"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var e,t=require("./dom.js"),i=require("./window.js"),n=require("../common/arrays.js"),a=require("../common/decorators.js"),s=require("../common/event.js"),o=require("../common/lifecycle.js"),r=require("../common/linkedList.js"),l=self&&self.__decorate||function(e,t,i,n){var a,s=arguments.length,o=s<3?t:null===n?n=Object.getOwnPropertyDescriptor(t,i):n;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)o=Reflect.decorate(e,t,i,n);else for(var r=e.length-1;r>=0;r--)(a=e[r])&&(o=(s<3?a(o):s>3?a(t,i,o):a(t,i))||o);return s>3&&o&&Object.defineProperty(t,i,o),o};exports.EventType=void 0,(e=exports.EventType||(exports.EventType={})).Tap="-monaco-gesturetap",e.Change="-monaco-gesturechange",e.Start="-monaco-gesturestart",e.End="-monaco-gesturesend",e.Contextmenu="-monaco-gesturecontextmenu";class h extends o.Disposable{static{this.SCROLL_FRICTION=-.005}static{this.HOLD_DELAY=700}static{this.CLEAR_TAP_COUNT_TIME=400}constructor(){super(),this.dispatched=!1,this.targets=new r.LinkedList,this.ignoreTargets=new r.LinkedList,this.activeTouches={},this.handle=null,this._lastSetTapCountTime=0,this._register(s.Event.runAndSubscribe(t.onDidRegisterWindow,(({window:e,disposables:i})=>{i.add(t.addDisposableListener(e.document,"touchstart",(e=>this.onTouchStart(e)),{passive:!1})),i.add(t.addDisposableListener(e.document,"touchend",(t=>this.onTouchEnd(e,t)))),i.add(t.addDisposableListener(e.document,"touchmove",(e=>this.onTouchMove(e)),{passive:!1}))}),{window:i.mainWindow,disposables:this._store}))}static addTarget(e){if(!h.isTouchDevice())return o.Disposable.None;h.INSTANCE||(h.INSTANCE=o.markAsSingleton(new h));const t=h.INSTANCE.targets.push(e);return o.toDisposable(t)}static ignoreTarget(e){if(!h.isTouchDevice())return o.Disposable.None;h.INSTANCE||(h.INSTANCE=o.markAsSingleton(new h));const t=h.INSTANCE.ignoreTargets.push(e);return o.toDisposable(t)}static isTouchDevice(){return"ontouchstart"in i.mainWindow||navigator.maxTouchPoints>0}dispose(){this.handle&&(this.handle.dispose(),this.handle=null),super.dispose()}onTouchStart(e){const t=Date.now();this.handle&&(this.handle.dispose(),this.handle=null);for(let i=0,n=e.targetTouches.length;i<n;i++){const n=e.targetTouches.item(i);this.activeTouches[n.identifier]={id:n.identifier,initialTarget:n.target,initialTimeStamp:t,initialPageX:n.pageX,initialPageY:n.pageY,rollingTimestamps:[t],rollingPageX:[n.pageX],rollingPageY:[n.pageY]};const a=this.newGestureEvent(exports.EventType.Start,n.target);a.pageX=n.pageX,a.pageY=n.pageY,this.dispatchEvent(a)}this.dispatched&&(e.preventDefault(),e.stopPropagation(),this.dispatched=!1)}onTouchEnd(e,t){const i=Date.now(),a=Object.keys(this.activeTouches).length;for(let s=0,o=t.changedTouches.length;s<o;s++){const o=t.changedTouches.item(s);if(!this.activeTouches.hasOwnProperty(String(o.identifier))){console.warn("move of an UNKNOWN touch",o);continue}const r=this.activeTouches[o.identifier],l=Date.now()-r.initialTimeStamp;if(l<h.HOLD_DELAY&&Math.abs(r.initialPageX-n.tail(r.rollingPageX))<30&&Math.abs(r.initialPageY-n.tail(r.rollingPageY))<30){const e=this.newGestureEvent(exports.EventType.Tap,r.initialTarget);e.pageX=n.tail(r.rollingPageX),e.pageY=n.tail(r.rollingPageY),this.dispatchEvent(e)}else if(l>=h.HOLD_DELAY&&Math.abs(r.initialPageX-n.tail(r.rollingPageX))<30&&Math.abs(r.initialPageY-n.tail(r.rollingPageY))<30){const e=this.newGestureEvent(exports.EventType.Contextmenu,r.initialTarget);e.pageX=n.tail(r.rollingPageX),e.pageY=n.tail(r.rollingPageY),this.dispatchEvent(e)}else if(1===a){const t=n.tail(r.rollingPageX),a=n.tail(r.rollingPageY),s=n.tail(r.rollingTimestamps)-r.rollingTimestamps[0],o=t-r.rollingPageX[0],l=a-r.rollingPageY[0],h=[...this.targets].filter((e=>r.initialTarget instanceof Node&&e.contains(r.initialTarget)));this.inertia(e,h,i,Math.abs(o)/s,o>0?1:-1,t,Math.abs(l)/s,l>0?1:-1,a)}this.dispatchEvent(this.newGestureEvent(exports.EventType.End,r.initialTarget)),delete this.activeTouches[o.identifier]}this.dispatched&&(t.preventDefault(),t.stopPropagation(),this.dispatched=!1)}newGestureEvent(e,t){const i=document.createEvent("CustomEvent");return i.initEvent(e,!1,!0),i.initialTarget=t,i.tapCount=0,i}dispatchEvent(e){if(e.type===exports.EventType.Tap){const t=(new Date).getTime();let i=0;i=t-this._lastSetTapCountTime>h.CLEAR_TAP_COUNT_TIME?1:2,this._lastSetTapCountTime=t,e.tapCount=i}else e.type!==exports.EventType.Change&&e.type!==exports.EventType.Contextmenu||(this._lastSetTapCountTime=0);if(e.initialTarget instanceof Node){for(const t of this.ignoreTargets)if(t.contains(e.initialTarget))return;const t=[];for(const i of this.targets)if(i.contains(e.initialTarget)){let n=0,a=e.initialTarget;for(;a&&a!==i;)n++,a=a.parentElement;t.push([n,i])}t.sort(((e,t)=>e[0]-t[0]));for(const[i,n]of t)n.dispatchEvent(e),this.dispatched=!0}}inertia(e,i,n,a,s,o,r,l,c){this.handle=t.scheduleAtNextAnimationFrame(e,(()=>{const t=Date.now(),g=t-n;let p=0,u=0,d=!0;a+=h.SCROLL_FRICTION*g,r+=h.SCROLL_FRICTION*g,a>0&&(d=!1,p=s*a*g),r>0&&(d=!1,u=l*r*g);const T=this.newGestureEvent(exports.EventType.Change);T.translationX=p,T.translationY=u,i.forEach((e=>e.dispatchEvent(T))),d||this.inertia(e,i,t,a,s,o+p,r,l,c+u)}))}onTouchMove(e){const t=Date.now();for(let i=0,a=e.changedTouches.length;i<a;i++){const a=e.changedTouches.item(i);if(!this.activeTouches.hasOwnProperty(String(a.identifier))){console.warn("end of an UNKNOWN touch",a);continue}const s=this.activeTouches[a.identifier],o=this.newGestureEvent(exports.EventType.Change,s.initialTarget);o.translationX=a.pageX-n.tail(s.rollingPageX),o.translationY=a.pageY-n.tail(s.rollingPageY),o.pageX=a.pageX,o.pageY=a.pageY,this.dispatchEvent(o),s.rollingPageX.length>3&&(s.rollingPageX.shift(),s.rollingPageY.shift(),s.rollingTimestamps.shift()),s.rollingPageX.push(a.pageX),s.rollingPageY.push(a.pageY),s.rollingTimestamps.push(t)}this.dispatched&&(e.preventDefault(),e.stopPropagation(),this.dispatched=!1)}}l([a.memoize],h,"isTouchDevice",null),exports.Gesture=h;
//# sourceMappingURL=touch.js.map
