"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var e=require("./tree.js"),t=require("../../../common/arrays.js"),i=require("../../../common/async.js"),l=require("../../../common/symbols.js"),r=require("../../../common/diff/diff.js"),n=require("../../../common/event.js"),o=require("../../../common/iterator.js");function s(e){return"object"==typeof e&&"visibility"in e&&"data"in e}function d(e){switch(e){case!0:return 1;case!1:return 0;default:return e}}function a(e){return"boolean"==typeof e.collapsible}exports.IndexTreeModel=class{constructor(e,t,r,o={}){this.user=e,this.list=t,this.rootRef=[],this.eventBufferer=new n.EventBufferer,this._onDidChangeCollapseState=new n.Emitter,this.onDidChangeCollapseState=this.eventBufferer.wrapEvent(this._onDidChangeCollapseState.event),this._onDidChangeRenderNodeCount=new n.Emitter,this.onDidChangeRenderNodeCount=this.eventBufferer.wrapEvent(this._onDidChangeRenderNodeCount.event),this._onDidSplice=new n.Emitter,this.onDidSplice=this._onDidSplice.event,this.refilterDelayer=new i.Delayer(l.MicrotaskDelay),this.collapseByDefault=void 0!==o.collapseByDefault&&o.collapseByDefault,this.allowNonCollapsibleParents=o.allowNonCollapsibleParents??!1,this.filter=o.filter,this.autoExpandSingleChildren=void 0!==o.autoExpandSingleChildren&&o.autoExpandSingleChildren,this.root={parent:void 0,element:r,children:[],depth:0,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:!1,collapsed:!1,renderNodeCount:0,visibility:1,visible:!0,filterData:void 0}}splice(t,i,l=o.Iterable.empty(),r={}){if(0===t.length)throw new e.TreeError(this.user,"Invalid tree location");r.diffIdentityProvider?this.spliceSmart(r.diffIdentityProvider,t,i,l,r):this.spliceSimple(t,i,l,r)}spliceSmart(e,t,i,l=o.Iterable.empty(),n,s=n.diffDepth??0){const{parentNode:d}=this.getParentNodeWithListIndex(t);if(!d.lastDiffIds)return this.spliceSimple(t,i,l,n);const a=[...l],h=t[t.length-1],c=new r.LcsDiff({getElements:()=>d.lastDiffIds},{getElements:()=>[...d.children.slice(0,h),...a,...d.children.slice(h+i)].map((t=>e.getId(t.element).toString()))}).ComputeDiff(!1);if(c.quitEarly)return d.lastDiffIds=void 0,this.spliceSimple(t,i,a,n);const p=t.slice(0,-1),f=(t,i,l)=>{if(s>0)for(let r=0;r<l;r++)t--,i--,this.spliceSmart(e,[...p,t,0],Number.MAX_SAFE_INTEGER,a[i].children,n,s-1)};let u=Math.min(d.children.length,h+i),C=a.length;for(const e of c.changes.sort(((e,t)=>t.originalStart-e.originalStart)))f(u,C,u-(e.originalStart+e.originalLength)),u=e.originalStart,C=e.modifiedStart-h,this.spliceSimple([...p,u],e.originalLength,o.Iterable.slice(a,C,C+e.modifiedLength),n);f(u,C,u)}spliceSimple(e,i,l=o.Iterable.empty(),{onDidCreateNode:r,onDidDeleteNode:n,diffIdentityProvider:s}){const{parentNode:d,listIndex:a,revealed:h,visible:c}=this.getParentNodeWithListIndex(e),p=[],f=o.Iterable.map(l,(e=>this.createTreeNode(e,d,d.visible?1:0,h,p,r))),u=e[e.length-1];let C=0;for(let e=u;e>=0&&e<d.children.length;e--){const t=d.children[e];if(t.visible){C=t.visibleChildIndex;break}}const v=[];let g=0,b=0;for(const e of f)v.push(e),b+=e.renderNodeCount,e.visible&&(e.visibleChildIndex=C+g++);const N=t.splice(d.children,u,i,v);s?d.lastDiffIds?t.splice(d.lastDiffIds,u,i,v.map((e=>s.getId(e.element).toString()))):d.lastDiffIds=d.children.map((e=>s.getId(e.element).toString())):d.lastDiffIds=void 0;let I=0;for(const e of N)e.visible&&I++;if(0!==I)for(let e=u+v.length;e<d.children.length;e++){const t=d.children[e];t.visible&&(t.visibleChildIndex-=I)}if(d.visibleChildrenCount+=g-I,h&&c){const e=N.reduce(((e,t)=>e+(t.visible?t.renderNodeCount:0)),0);this._updateAncestorsRenderNodeCount(d,b-e),this.list.splice(a,e,p)}if(N.length>0&&n){const e=t=>{n(t),t.children.forEach(e)};N.forEach(e)}this._onDidSplice.fire({insertedNodes:v,deletedNodes:N});let m=d;for(;m;){if(2===m.visibility){this.refilterDelayer.trigger((()=>this.refilter()));break}m=m.parent}}rerender(t){if(0===t.length)throw new e.TreeError(this.user,"Invalid tree location");const{node:i,listIndex:l,revealed:r}=this.getTreeNodeWithListIndex(t);i.visible&&r&&this.list.splice(l,1,[i])}has(e){return this.hasTreeNode(e)}getListIndex(e){const{listIndex:t,visible:i,revealed:l}=this.getTreeNodeWithListIndex(e);return i&&l?t:-1}getListRenderCount(e){return this.getTreeNode(e).renderNodeCount}isCollapsible(e){return this.getTreeNode(e).collapsible}setCollapsible(e,t){const i=this.getTreeNode(e);void 0===t&&(t=!i.collapsible);const l={collapsible:t};return this.eventBufferer.bufferEvents((()=>this._setCollapseState(e,l)))}isCollapsed(e){return this.getTreeNode(e).collapsed}setCollapsed(e,t,i){const l=this.getTreeNode(e);void 0===t&&(t=!l.collapsed);const r={collapsed:t,recursive:i||!1};return this.eventBufferer.bufferEvents((()=>this._setCollapseState(e,r)))}_setCollapseState(e,t){const{node:i,listIndex:l,revealed:r}=this.getTreeNodeWithListIndex(e),n=this._setListNodeCollapseState(i,l,r,t);if(i!==this.root&&this.autoExpandSingleChildren&&n&&!a(t)&&i.collapsible&&!i.collapsed&&!t.recursive){let l=-1;for(let e=0;e<i.children.length;e++){if(i.children[e].visible){if(l>-1){l=-1;break}l=e}}l>-1&&this._setCollapseState([...e,l],t)}return n}_setListNodeCollapseState(e,t,i,l){const r=this._setNodeCollapseState(e,l,!1);if(!i||!e.visible||!r)return r;const n=e.renderNodeCount,o=this.updateNodeAfterCollapseChange(e),s=n-(-1===t?0:1);return this.list.splice(t+1,s,o.slice(1)),r}_setNodeCollapseState(e,t,i){let l;if(e===this.root?l=!1:(a(t)?(l=e.collapsible!==t.collapsible,e.collapsible=t.collapsible):e.collapsible?(l=e.collapsed!==t.collapsed,e.collapsed=t.collapsed):l=!1,l&&this._onDidChangeCollapseState.fire({node:e,deep:i})),!a(t)&&t.recursive)for(const i of e.children)l=this._setNodeCollapseState(i,t,!0)||l;return l}expandTo(e){this.eventBufferer.bufferEvents((()=>{let t=this.getTreeNode(e);for(;t.parent;)t=t.parent,e=e.slice(0,e.length-1),t.collapsed&&this._setCollapseState(e,{collapsed:!1,recursive:!1})}))}refilter(){const e=this.root.renderNodeCount,t=this.updateNodeAfterFilterChange(this.root);this.list.splice(0,e,t),this.refilterDelayer.cancel()}createTreeNode(e,t,i,l,r,n){const s={parent:t,element:e.element,children:[],depth:t.depth+1,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:"boolean"==typeof e.collapsible?e.collapsible:void 0!==e.collapsed,collapsed:void 0===e.collapsed?this.collapseByDefault:e.collapsed,renderNodeCount:1,visibility:1,visible:!0,filterData:void 0},d=this._filterNode(s,i);s.visibility=d,l&&r.push(s);const a=e.children||o.Iterable.empty(),h=l&&0!==d&&!s.collapsed;let c=0,p=1;for(const e of a){const t=this.createTreeNode(e,s,d,h,r,n);s.children.push(t),p+=t.renderNodeCount,t.visible&&(t.visibleChildIndex=c++)}return this.allowNonCollapsibleParents||(s.collapsible=s.collapsible||s.children.length>0),s.visibleChildrenCount=c,s.visible=2===d?c>0:1===d,s.visible?s.collapsed||(s.renderNodeCount=p):(s.renderNodeCount=0,l&&r.pop()),n?.(s),s}updateNodeAfterCollapseChange(e){const t=e.renderNodeCount,i=[];return this._updateNodeAfterCollapseChange(e,i),this._updateAncestorsRenderNodeCount(e.parent,i.length-t),i}_updateNodeAfterCollapseChange(e,t){if(!1===e.visible)return 0;if(t.push(e),e.renderNodeCount=1,!e.collapsed)for(const i of e.children)e.renderNodeCount+=this._updateNodeAfterCollapseChange(i,t);return this._onDidChangeRenderNodeCount.fire(e),e.renderNodeCount}updateNodeAfterFilterChange(e){const t=e.renderNodeCount,i=[];return this._updateNodeAfterFilterChange(e,e.visible?1:0,i),this._updateAncestorsRenderNodeCount(e.parent,i.length-t),i}_updateNodeAfterFilterChange(e,t,i,l=!0){let r;if(e!==this.root){if(r=this._filterNode(e,t),0===r)return e.visible=!1,e.renderNodeCount=0,!1;l&&i.push(e)}const n=i.length;e.renderNodeCount=e===this.root?0:1;let o=!1;if(e.collapsed&&0===r)e.visibleChildrenCount=0;else{let t=0;for(const n of e.children)o=this._updateNodeAfterFilterChange(n,r,i,l&&!e.collapsed)||o,n.visible&&(n.visibleChildIndex=t++);e.visibleChildrenCount=t}return e!==this.root&&(e.visible=2===r?o:1===r,e.visibility=r),e.visible?e.collapsed||(e.renderNodeCount+=i.length-n):(e.renderNodeCount=0,l&&i.pop()),this._onDidChangeRenderNodeCount.fire(e),e.visible}_updateAncestorsRenderNodeCount(e,t){if(0!==t)for(;e;)e.renderNodeCount+=t,this._onDidChangeRenderNodeCount.fire(e),e=e.parent}_filterNode(e,t){const i=this.filter?this.filter.filter(e.element,t):1;return"boolean"==typeof i?(e.filterData=void 0,i?1:0):s(i)?(e.filterData=i.data,d(i.visibility)):(e.filterData=void 0,d(i))}hasTreeNode(e,t=this.root){if(!e||0===e.length)return!0;const[i,...l]=e;return!(i<0||i>t.children.length)&&this.hasTreeNode(l,t.children[i])}getTreeNode(t,i=this.root){if(!t||0===t.length)return i;const[l,...r]=t;if(l<0||l>i.children.length)throw new e.TreeError(this.user,"Invalid tree location");return this.getTreeNode(r,i.children[l])}getTreeNodeWithListIndex(t){if(0===t.length)return{node:this.root,listIndex:-1,revealed:!0,visible:!1};const{parentNode:i,listIndex:l,revealed:r,visible:n}=this.getParentNodeWithListIndex(t),o=t[t.length-1];if(o<0||o>i.children.length)throw new e.TreeError(this.user,"Invalid tree location");const s=i.children[o];return{node:s,listIndex:l,revealed:r,visible:n&&s.visible}}getParentNodeWithListIndex(t,i=this.root,l=0,r=!0,n=!0){const[o,...s]=t;if(o<0||o>i.children.length)throw new e.TreeError(this.user,"Invalid tree location");for(let e=0;e<o;e++)l+=i.children[e].renderNodeCount;return r=r&&!i.collapsed,n=n&&i.visible,0===s.length?{parentNode:i,listIndex:l,revealed:r,visible:n}:this.getParentNodeWithListIndex(s,i.children[o],l+1,r,n)}getNode(e=[]){return this.getTreeNode(e)}getNodeLocation(e){const t=[];let i=e;for(;i.parent;)t.push(i.parent.children.indexOf(i)),i=i.parent;return t.reverse()}getParentNodeLocation(e){return 0===e.length?void 0:1===e.length?[]:t.tail2(e)[0]}getFirstElementChild(e){const t=this.getTreeNode(e);if(0!==t.children.length)return t.children[0].element}},exports.getVisibleState=d,exports.isFilterResult=s;
//# sourceMappingURL=indexTreeModel.js.map
