"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var e=require("../../../base/browser/browser.js"),t=require("../../../base/common/arrays.js"),i=require("../../../base/common/event.js"),s=require("../../../base/common/lifecycle.js"),o=require("../../../base/common/objects.js"),n=require("../../../base/common/platform.js"),r=require("./elementSizeObserver.js"),a=require("./fontMeasurements.js"),c=require("./migrateOptions.js"),u=require("./tabFocus.js"),h=require("../../common/config/editorOptions.js"),p=require("../../common/config/editorZoom.js"),d=require("../../common/config/fontInfo.js"),l=require("../../../platform/accessibility/common/accessibility.js"),_=require("../../../base/browser/dom.js"),g=require("../../../base/browser/pixelRatio.js"),m=self&&self.__decorate||function(e,t,i,s){var o,n=arguments.length,r=n<3?t:null===s?s=Object.getOwnPropertyDescriptor(t,i):s;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,i,s);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(n<3?o(r):n>3?o(t,i,r):o(t,i))||r);return n>3&&r&&Object.defineProperty(t,i,r),r},f=self&&self.__param||function(e,t){return function(i,s){t(i,s,e)}};function b(){let t="";return e.isSafari||e.isWebkitWebView||(t+="no-user-select "),e.isSafari&&(t+="no-minimap-shadow ",t+="enable-user-select "),n.isMacintosh&&(t+="mac "),t}exports.EditorConfiguration=class extends s.Disposable{constructor(e,t,s,o,n){super(),this._accessibilityService=n,this._onDidChange=this._register(new i.Emitter),this.onDidChange=this._onDidChange.event,this._onDidChangeFast=this._register(new i.Emitter),this.onDidChangeFast=this._onDidChangeFast.event,this._isDominatedByLongLines=!1,this._viewLineCount=1,this._lineNumbersDigitCount=1,this._reservedHeight=0,this._glyphMarginDecorationLaneCount=1,this._computeOptionsMemory=new h.ComputeOptionsMemory,this.isSimpleWidget=e,this.contextMenuId=t,this._containerObserver=this._register(new r.ElementSizeObserver(o,s.dimension)),this._targetWindowId=_.getWindow(o).vscodeWindowId,this._rawOptions=C(s),this._validatedOptions=v.validateOptions(this._rawOptions),this.options=this._computeOptions(),this.options.get(13)&&this._containerObserver.startObserving(),this._register(p.EditorZoom.onDidChangeZoomLevel((()=>this._recomputeOptions()))),this._register(u.TabFocus.onDidChangeTabFocus((()=>this._recomputeOptions()))),this._register(this._containerObserver.onDidChange((()=>this._recomputeOptions()))),this._register(a.FontMeasurements.onDidChange((()=>this._recomputeOptions()))),this._register(g.PixelRatio.getInstance(_.getWindow(o)).onDidChange((()=>this._recomputeOptions()))),this._register(this._accessibilityService.onDidChangeScreenReaderOptimized((()=>this._recomputeOptions())))}_recomputeOptions(){const e=this._computeOptions(),t=v.checkEquals(this.options,e);null!==t&&(this.options=e,this._onDidChangeFast.fire(t),this._onDidChange.fire(t))}_computeOptions(){const e=this._readEnvConfiguration(),t=d.BareFontInfo.createFromValidatedSettings(this._validatedOptions,e.pixelRatio,this.isSimpleWidget),i=this._readFontInfo(t),s={memory:this._computeOptionsMemory,outerWidth:e.outerWidth,outerHeight:e.outerHeight-this._reservedHeight,fontInfo:i,extraEditorClassName:e.extraEditorClassName,isDominatedByLongLines:this._isDominatedByLongLines,viewLineCount:this._viewLineCount,lineNumbersDigitCount:this._lineNumbersDigitCount,emptySelectionClipboard:e.emptySelectionClipboard,pixelRatio:e.pixelRatio,tabFocusMode:u.TabFocus.getTabFocusMode(),accessibilitySupport:e.accessibilitySupport,glyphMarginDecorationLaneCount:this._glyphMarginDecorationLaneCount};return v.computeOptions(this._validatedOptions,s)}_readEnvConfiguration(){return{extraEditorClassName:b(),outerWidth:this._containerObserver.getWidth(),outerHeight:this._containerObserver.getHeight(),emptySelectionClipboard:e.isWebKit||e.isFirefox,pixelRatio:g.PixelRatio.getInstance(_.getWindowById(this._targetWindowId,!0).window).value,accessibilitySupport:this._accessibilityService.isScreenReaderOptimized()?2:this._accessibilityService.getAccessibilitySupport()}}_readFontInfo(e){return a.FontMeasurements.readFontInfo(_.getWindowById(this._targetWindowId,!0).window,e)}getRawOptions(){return this._rawOptions}updateOptions(e){const t=C(e);v.applyUpdate(this._rawOptions,t)&&(this._validatedOptions=v.validateOptions(this._rawOptions),this._recomputeOptions())}observeContainer(e){this._containerObserver.observe(e)}setIsDominatedByLongLines(e){this._isDominatedByLongLines!==e&&(this._isDominatedByLongLines=e,this._recomputeOptions())}setModelLineCount(e){const t=function(e){let t=0;for(;e;)e=Math.floor(e/10),t++;return t||1}(e);this._lineNumbersDigitCount!==t&&(this._lineNumbersDigitCount=t,this._recomputeOptions())}setViewLineCount(e){this._viewLineCount!==e&&(this._viewLineCount=e,this._recomputeOptions())}setReservedHeight(e){this._reservedHeight!==e&&(this._reservedHeight=e,this._recomputeOptions())}setGlyphMarginDecorationLaneCount(e){this._glyphMarginDecorationLaneCount!==e&&(this._glyphMarginDecorationLaneCount=e,this._recomputeOptions())}},exports.EditorConfiguration=m([f(4,l.IAccessibilityService)],exports.EditorConfiguration);class O{constructor(){this._values=[]}_read(e){return this._values[e]}get(e){return this._values[e]}_write(e,t){this._values[e]=t}}class y{constructor(){this._values=[]}_read(e){if(e>=this._values.length)throw new Error("Cannot read uninitialized value");return this._values[e]}get(e){return this._read(e)}_write(e,t){this._values[e]=t}}class v{static validateOptions(e){const t=new O;for(const i of h.editorOptionsRegistry){const s="_never_"===i.name?void 0:e[i.name];t._write(i.id,i.validate(s))}return t}static computeOptions(e,t){const i=new y;for(const s of h.editorOptionsRegistry)i._write(s.id,s.compute(t,i,e._read(s.id)));return i}static _deepEquals(e,i){if("object"!=typeof e||"object"!=typeof i||!e||!i)return e===i;if(Array.isArray(e)||Array.isArray(i))return!(!Array.isArray(e)||!Array.isArray(i))&&t.equals(e,i);if(Object.keys(e).length!==Object.keys(i).length)return!1;for(const t in e)if(!v._deepEquals(e[t],i[t]))return!1;return!0}static checkEquals(e,t){const i=[];let s=!1;for(const o of h.editorOptionsRegistry){const n=!v._deepEquals(e._read(o.id),t._read(o.id));i[o.id]=n,n&&(s=!0)}return s?new h.ConfigurationChangedEvent(i):null}static applyUpdate(e,t){let i=!1;for(const s of h.editorOptionsRegistry)if(t.hasOwnProperty(s.name)){const o=s.applyUpdate(e[s.name],t[s.name]);e[s.name]=o.newValue,i=i||o.didChange}return i}}function C(e){const t=o.deepClone(e);return c.migrateOptions(t),t}exports.ComputedEditorOptions=y;
//# sourceMappingURL=editorConfiguration.js.map
