"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var e=require("../../nls.js"),t=require("../../base/browser/browser.js"),o=require("../../base/common/types.js"),r=require("../../base/browser/ui/aria/aria.js"),i=require("./editorExtensions.js"),n=require("./services/codeEditorService.js"),s=require("../common/cursor/cursorColumnSelection.js"),d=require("../common/cursorCommon.js"),a=require("../common/cursor/cursorDeleteOperations.js"),c=require("../common/cursor/cursorMoveCommands.js"),u=require("../common/cursor/cursorTypeOperations.js"),l=require("../common/core/position.js"),m=require("../common/core/range.js"),p=require("../common/editorContextKeys.js"),C=require("../../platform/contextkey/common/contextkey.js"),g=require("../../platform/keybinding/common/keybindingsRegistry.js"),S=require("../../base/browser/dom.js"),E=require("../common/cursor/cursorTypeEditOperations.js");class x extends i.EditorCommand{runEditorCommand(e,t,o){const r=t._getViewModel();r&&this.runCoreEditorCommand(r,o||{})}}var v,w;exports.EditorScroll_=void 0,(v=exports.EditorScroll_||(exports.EditorScroll_={})).metadata={description:"Scroll editor in the given direction",args:[{name:"Editor scroll argument object",description:"Property-value pairs that can be passed through this argument:\n\t\t\t\t\t* 'to': A mandatory direction value.\n\t\t\t\t\t\t```\n\t\t\t\t\t\t'up', 'down'\n\t\t\t\t\t\t```\n\t\t\t\t\t* 'by': Unit to move. Default is computed based on 'to' value.\n\t\t\t\t\t\t```\n\t\t\t\t\t\t'line', 'wrappedLine', 'page', 'halfPage', 'editor'\n\t\t\t\t\t\t```\n\t\t\t\t\t* 'value': Number of units to move. Default is '1'.\n\t\t\t\t\t* 'revealCursor': If 'true' reveals the cursor if it is outside view port.\n\t\t\t\t",constraint:function(e){if(!o.isObject(e))return!1;const t=e;return!(!o.isString(t.to)||!o.isUndefined(t.by)&&!o.isString(t.by)||!o.isUndefined(t.value)&&!o.isNumber(t.value)||!o.isUndefined(t.revealCursor)&&!o.isBoolean(t.revealCursor))},schema:{type:"object",required:["to"],properties:{to:{type:"string",enum:["up","down"]},by:{type:"string",enum:["line","wrappedLine","page","halfPage","editor"]},value:{type:"number",default:1},revealCursor:{type:"boolean"}}}}]},v.RawDirection={Up:"up",Right:"right",Down:"down",Left:"left"},v.RawUnit={Line:"line",WrappedLine:"wrappedLine",Page:"page",HalfPage:"halfPage",Editor:"editor",Column:"column"},v.parse=function(e){let t,o;switch(e.to){case v.RawDirection.Up:t=1;break;case v.RawDirection.Right:t=2;break;case v.RawDirection.Down:t=3;break;case v.RawDirection.Left:t=4;break;default:return null}switch(e.by){case v.RawUnit.Line:o=1;break;case v.RawUnit.WrappedLine:o=2;break;case v.RawUnit.Page:o=3;break;case v.RawUnit.HalfPage:o=4;break;case v.RawUnit.Editor:o=5;break;case v.RawUnit.Column:o=6;break;default:o=2}return{direction:t,unit:o,value:Math.floor(e.value||1),revealCursor:!!e.revealCursor,select:!!e.select}},exports.RevealLine_=void 0,(w=exports.RevealLine_||(exports.RevealLine_={})).metadata={description:"Reveal the given line at the given logical position",args:[{name:"Reveal line argument object",description:"Property-value pairs that can be passed through this argument:\n\t\t\t\t\t* 'lineNumber': A mandatory line number value.\n\t\t\t\t\t* 'at': Logical position at which line has to be revealed.\n\t\t\t\t\t\t```\n\t\t\t\t\t\t'top', 'center', 'bottom'\n\t\t\t\t\t\t```\n\t\t\t\t",constraint:function(e){if(!o.isObject(e))return!1;const t=e;return!(!o.isNumber(t.lineNumber)&&!o.isString(t.lineNumber)||!o.isUndefined(t.at)&&!o.isString(t.at))},schema:{type:"object",required:["lineNumber"],properties:{lineNumber:{type:["number","string"]},at:{type:"string",enum:["top","center","bottom"]}}}}]},w.RawAtArgument={Top:"top",Center:"center",Bottom:"bottom"};class y{constructor(e){e.addImplementation(1e4,"code-editor",((e,t)=>{const o=e.get(n.ICodeEditorService).getFocusedCodeEditor();return!(!o||!o.hasTextFocus())&&this._runEditorCommand(e,o,t)})),e.addImplementation(1e3,"generic-dom-input-textarea",((e,t)=>{const o=S.getActiveElement();return!!(o&&["input","textarea"].indexOf(o.tagName.toLowerCase())>=0)&&(this.runDOMCommand(o),!0)})),e.addImplementation(0,"generic-dom",((e,t)=>{const o=e.get(n.ICodeEditorService).getActiveCodeEditor();return!!o&&(o.focus(),this._runEditorCommand(e,o,t))}))}_runEditorCommand(e,t,o){const r=this.runEditorCommand(e,t,o);return r||!0}}exports.CoreNavigationCommands=void 0,function(o){class n extends x{constructor(e){super(e),this._inSelectionMode=e.inSelectionMode}runCoreEditorCommand(e,t){if(!t.position)return;e.model.pushStackElement();e.setCursorStates(t.source,3,[c.CursorMoveCommands.moveTo(e,e.getPrimaryCursorState(),this._inSelectionMode,t.position,t.viewPosition)])&&2!==t.revealType&&e.revealAllCursors(t.source,!0,!0)}}o.MoveTo=i.registerEditorCommand(new n({id:"_moveTo",inSelectionMode:!1,precondition:void 0})),o.MoveToSelect=i.registerEditorCommand(new n({id:"_moveToSelect",inSelectionMode:!0,precondition:void 0}));class a extends x{runCoreEditorCommand(e,t){e.model.pushStackElement();const o=this._getColumnSelectResult(e,e.getPrimaryCursorState(),e.getCursorColumnSelectData(),t);null!==o&&(e.setCursorStates(t.source,3,o.viewStates.map((e=>d.CursorState.fromViewState(e)))),e.setCursorColumnSelectData({isReal:!0,fromViewLineNumber:o.fromLineNumber,fromViewVisualColumn:o.fromVisualColumn,toViewLineNumber:o.toLineNumber,toViewVisualColumn:o.toVisualColumn}),o.reversed?e.revealTopMostCursor(t.source):e.revealBottomMostCursor(t.source))}}o.ColumnSelect=i.registerEditorCommand(new class extends a{constructor(){super({id:"columnSelect",precondition:void 0})}_getColumnSelectResult(e,t,o,r){if(void 0===r.position||void 0===r.viewPosition||void 0===r.mouseColumn)return null;const i=e.model.validatePosition(r.position),n=e.coordinatesConverter.validateViewPosition(new l.Position(r.viewPosition.lineNumber,r.viewPosition.column),i),d=r.doColumnSelect?o.fromViewLineNumber:n.lineNumber,a=r.doColumnSelect?o.fromViewVisualColumn:r.mouseColumn-1;return s.ColumnSelection.columnSelect(e.cursorConfig,e,d,a,n.lineNumber,r.mouseColumn-1)}}),o.CursorColumnSelectLeft=i.registerEditorCommand(new class extends a{constructor(){super({id:"cursorColumnSelectLeft",precondition:void 0,kbOpts:{weight:0,kbExpr:p.EditorContextKeys.textInputFocus,primary:3599,linux:{primary:0}}})}_getColumnSelectResult(e,t,o,r){return s.ColumnSelection.columnSelectLeft(e.cursorConfig,e,o)}}),o.CursorColumnSelectRight=i.registerEditorCommand(new class extends a{constructor(){super({id:"cursorColumnSelectRight",precondition:void 0,kbOpts:{weight:0,kbExpr:p.EditorContextKeys.textInputFocus,primary:3601,linux:{primary:0}}})}_getColumnSelectResult(e,t,o,r){return s.ColumnSelection.columnSelectRight(e.cursorConfig,e,o)}});class u extends a{constructor(e){super(e),this._isPaged=e.isPaged}_getColumnSelectResult(e,t,o,r){return s.ColumnSelection.columnSelectUp(e.cursorConfig,e,o,this._isPaged)}}o.CursorColumnSelectUp=i.registerEditorCommand(new u({isPaged:!1,id:"cursorColumnSelectUp",precondition:void 0,kbOpts:{weight:0,kbExpr:p.EditorContextKeys.textInputFocus,primary:3600,linux:{primary:0}}})),o.CursorColumnSelectPageUp=i.registerEditorCommand(new u({isPaged:!0,id:"cursorColumnSelectPageUp",precondition:void 0,kbOpts:{weight:0,kbExpr:p.EditorContextKeys.textInputFocus,primary:3595,linux:{primary:0}}}));class C extends a{constructor(e){super(e),this._isPaged=e.isPaged}_getColumnSelectResult(e,t,o,r){return s.ColumnSelection.columnSelectDown(e.cursorConfig,e,o,this._isPaged)}}o.CursorColumnSelectDown=i.registerEditorCommand(new C({isPaged:!1,id:"cursorColumnSelectDown",precondition:void 0,kbOpts:{weight:0,kbExpr:p.EditorContextKeys.textInputFocus,primary:3602,linux:{primary:0}}})),o.CursorColumnSelectPageDown=i.registerEditorCommand(new C({isPaged:!0,id:"cursorColumnSelectPageDown",precondition:void 0,kbOpts:{weight:0,kbExpr:p.EditorContextKeys.textInputFocus,primary:3596,linux:{primary:0}}}));class g extends x{constructor(){super({id:"cursorMove",precondition:void 0,metadata:c.CursorMove.metadata})}runCoreEditorCommand(e,t){const o=c.CursorMove.parse(t);o&&this._runCursorMove(e,t.source,o)}_runCursorMove(e,t,o){e.model.pushStackElement(),e.setCursorStates(t,3,g._move(e,e.getCursorStates(),o)),e.revealAllCursors(t,!0)}static _move(e,t,o){const r=o.select,i=o.value;switch(o.direction){case 0:case 1:case 2:case 3:case 4:case 5:case 6:case 7:case 8:case 9:case 10:return c.CursorMoveCommands.simpleMove(e,t,o.direction,r,i,o.unit);case 11:case 13:case 12:case 14:return c.CursorMoveCommands.viewportMove(e,t,o.direction,r,i);default:return null}}}o.CursorMoveImpl=g,o.CursorMove=i.registerEditorCommand(new g);class S extends x{constructor(e){super(e),this._staticArgs=e.args}runCoreEditorCommand(e,t){let o=this._staticArgs;-1===this._staticArgs.value&&(o={direction:this._staticArgs.direction,unit:this._staticArgs.unit,select:this._staticArgs.select,value:t.pageSize||e.cursorConfig.pageSize}),e.model.pushStackElement(),e.setCursorStates(t.source,3,c.CursorMoveCommands.simpleMove(e,e.getCursorStates(),o.direction,o.select,o.value,o.unit)),e.revealAllCursors(t.source,!0)}}o.CursorLeft=i.registerEditorCommand(new S({args:{direction:0,unit:0,select:!1,value:1},id:"cursorLeft",precondition:void 0,kbOpts:{weight:0,kbExpr:p.EditorContextKeys.textInputFocus,primary:15,mac:{primary:15,secondary:[288]}}})),o.CursorLeftSelect=i.registerEditorCommand(new S({args:{direction:0,unit:0,select:!0,value:1},id:"cursorLeftSelect",precondition:void 0,kbOpts:{weight:0,kbExpr:p.EditorContextKeys.textInputFocus,primary:1039}})),o.CursorRight=i.registerEditorCommand(new S({args:{direction:1,unit:0,select:!1,value:1},id:"cursorRight",precondition:void 0,kbOpts:{weight:0,kbExpr:p.EditorContextKeys.textInputFocus,primary:17,mac:{primary:17,secondary:[292]}}})),o.CursorRightSelect=i.registerEditorCommand(new S({args:{direction:1,unit:0,select:!0,value:1},id:"cursorRightSelect",precondition:void 0,kbOpts:{weight:0,kbExpr:p.EditorContextKeys.textInputFocus,primary:1041}})),o.CursorUp=i.registerEditorCommand(new S({args:{direction:2,unit:2,select:!1,value:1},id:"cursorUp",precondition:void 0,kbOpts:{weight:0,kbExpr:p.EditorContextKeys.textInputFocus,primary:16,mac:{primary:16,secondary:[302]}}})),o.CursorUpSelect=i.registerEditorCommand(new S({args:{direction:2,unit:2,select:!0,value:1},id:"cursorUpSelect",precondition:void 0,kbOpts:{weight:0,kbExpr:p.EditorContextKeys.textInputFocus,primary:1040,secondary:[3088],mac:{primary:1040},linux:{primary:1040}}})),o.CursorPageUp=i.registerEditorCommand(new S({args:{direction:2,unit:2,select:!1,value:-1},id:"cursorPageUp",precondition:void 0,kbOpts:{weight:0,kbExpr:p.EditorContextKeys.textInputFocus,primary:11}})),o.CursorPageUpSelect=i.registerEditorCommand(new S({args:{direction:2,unit:2,select:!0,value:-1},id:"cursorPageUpSelect",precondition:void 0,kbOpts:{weight:0,kbExpr:p.EditorContextKeys.textInputFocus,primary:1035}})),o.CursorDown=i.registerEditorCommand(new S({args:{direction:3,unit:2,select:!1,value:1},id:"cursorDown",precondition:void 0,kbOpts:{weight:0,kbExpr:p.EditorContextKeys.textInputFocus,primary:18,mac:{primary:18,secondary:[300]}}})),o.CursorDownSelect=i.registerEditorCommand(new S({args:{direction:3,unit:2,select:!0,value:1},id:"cursorDownSelect",precondition:void 0,kbOpts:{weight:0,kbExpr:p.EditorContextKeys.textInputFocus,primary:1042,secondary:[3090],mac:{primary:1042},linux:{primary:1042}}})),o.CursorPageDown=i.registerEditorCommand(new S({args:{direction:3,unit:2,select:!1,value:-1},id:"cursorPageDown",precondition:void 0,kbOpts:{weight:0,kbExpr:p.EditorContextKeys.textInputFocus,primary:12}})),o.CursorPageDownSelect=i.registerEditorCommand(new S({args:{direction:3,unit:2,select:!0,value:-1},id:"cursorPageDownSelect",precondition:void 0,kbOpts:{weight:0,kbExpr:p.EditorContextKeys.textInputFocus,primary:1036}})),o.CreateCursor=i.registerEditorCommand(new class extends x{constructor(){super({id:"createCursor",precondition:void 0})}runCoreEditorCommand(e,t){if(!t.position)return;let o;o=t.wholeLine?c.CursorMoveCommands.line(e,e.getPrimaryCursorState(),!1,t.position,t.viewPosition):c.CursorMoveCommands.moveTo(e,e.getPrimaryCursorState(),!1,t.position,t.viewPosition);const r=e.getCursorStates();if(r.length>1){const i=o.modelState?o.modelState.position:null,n=o.viewState?o.viewState.position:null;for(let o=0,s=r.length;o<s;o++){const s=r[o];if((!i||s.modelState.selection.containsPosition(i))&&(!n||s.viewState.selection.containsPosition(n)))return r.splice(o,1),e.model.pushStackElement(),void e.setCursorStates(t.source,3,r)}}r.push(o),e.model.pushStackElement(),e.setCursorStates(t.source,3,r)}}),o.LastCursorMoveToSelect=i.registerEditorCommand(new class extends x{constructor(){super({id:"_lastCursorMoveToSelect",precondition:void 0})}runCoreEditorCommand(e,t){if(!t.position)return;const o=e.getLastAddedCursorIndex(),r=e.getCursorStates(),i=r.slice(0);i[o]=c.CursorMoveCommands.moveTo(e,r[o],!0,t.position,t.viewPosition),e.model.pushStackElement(),e.setCursorStates(t.source,3,i)}});class E extends x{constructor(e){super(e),this._inSelectionMode=e.inSelectionMode}runCoreEditorCommand(e,t){e.model.pushStackElement(),e.setCursorStates(t.source,3,c.CursorMoveCommands.moveToBeginningOfLine(e,e.getCursorStates(),this._inSelectionMode)),e.revealAllCursors(t.source,!0)}}o.CursorHome=i.registerEditorCommand(new E({inSelectionMode:!1,id:"cursorHome",precondition:void 0,kbOpts:{weight:0,kbExpr:p.EditorContextKeys.textInputFocus,primary:14,mac:{primary:14,secondary:[2063]}}})),o.CursorHomeSelect=i.registerEditorCommand(new E({inSelectionMode:!0,id:"cursorHomeSelect",precondition:void 0,kbOpts:{weight:0,kbExpr:p.EditorContextKeys.textInputFocus,primary:1038,mac:{primary:1038,secondary:[3087]}}}));class v extends x{constructor(e){super(e),this._inSelectionMode=e.inSelectionMode}runCoreEditorCommand(e,t){e.model.pushStackElement(),e.setCursorStates(t.source,3,this._exec(e.getCursorStates())),e.revealAllCursors(t.source,!0)}_exec(e){const t=[];for(let o=0,r=e.length;o<r;o++){const r=e[o],i=r.modelState.position.lineNumber;t[o]=d.CursorState.fromModelState(r.modelState.move(this._inSelectionMode,i,1,0))}return t}}o.CursorLineStart=i.registerEditorCommand(new v({inSelectionMode:!1,id:"cursorLineStart",precondition:void 0,kbOpts:{weight:0,kbExpr:p.EditorContextKeys.textInputFocus,primary:0,mac:{primary:287}}})),o.CursorLineStartSelect=i.registerEditorCommand(new v({inSelectionMode:!0,id:"cursorLineStartSelect",precondition:void 0,kbOpts:{weight:0,kbExpr:p.EditorContextKeys.textInputFocus,primary:0,mac:{primary:1311}}}));class w extends x{constructor(e){super(e),this._inSelectionMode=e.inSelectionMode}runCoreEditorCommand(e,t){e.model.pushStackElement(),e.setCursorStates(t.source,3,c.CursorMoveCommands.moveToEndOfLine(e,e.getCursorStates(),this._inSelectionMode,t.sticky||!1)),e.revealAllCursors(t.source,!0)}}o.CursorEnd=i.registerEditorCommand(new w({inSelectionMode:!1,id:"cursorEnd",precondition:void 0,kbOpts:{args:{sticky:!1},weight:0,kbExpr:p.EditorContextKeys.textInputFocus,primary:13,mac:{primary:13,secondary:[2065]}},metadata:{description:"Go to End",args:[{name:"args",schema:{type:"object",properties:{sticky:{description:e.localize("stickydesc","Stick to the end even when going to longer lines"),type:"boolean",default:!1}}}}]}})),o.CursorEndSelect=i.registerEditorCommand(new w({inSelectionMode:!0,id:"cursorEndSelect",precondition:void 0,kbOpts:{args:{sticky:!1},weight:0,kbExpr:p.EditorContextKeys.textInputFocus,primary:1037,mac:{primary:1037,secondary:[3089]}},metadata:{description:"Select to End",args:[{name:"args",schema:{type:"object",properties:{sticky:{description:e.localize("stickydesc","Stick to the end even when going to longer lines"),type:"boolean",default:!1}}}}]}}));class h extends x{constructor(e){super(e),this._inSelectionMode=e.inSelectionMode}runCoreEditorCommand(e,t){e.model.pushStackElement(),e.setCursorStates(t.source,3,this._exec(e,e.getCursorStates())),e.revealAllCursors(t.source,!0)}_exec(e,t){const o=[];for(let r=0,i=t.length;r<i;r++){const i=t[r],n=i.modelState.position.lineNumber,s=e.model.getLineMaxColumn(n);o[r]=d.CursorState.fromModelState(i.modelState.move(this._inSelectionMode,n,s,0))}return o}}o.CursorLineEnd=i.registerEditorCommand(new h({inSelectionMode:!1,id:"cursorLineEnd",precondition:void 0,kbOpts:{weight:0,kbExpr:p.EditorContextKeys.textInputFocus,primary:0,mac:{primary:291}}})),o.CursorLineEndSelect=i.registerEditorCommand(new h({inSelectionMode:!0,id:"cursorLineEndSelect",precondition:void 0,kbOpts:{weight:0,kbExpr:p.EditorContextKeys.textInputFocus,primary:0,mac:{primary:1315}}}));class b extends x{constructor(e){super(e),this._inSelectionMode=e.inSelectionMode}runCoreEditorCommand(e,t){e.model.pushStackElement(),e.setCursorStates(t.source,3,c.CursorMoveCommands.moveToBeginningOfBuffer(e,e.getCursorStates(),this._inSelectionMode)),e.revealAllCursors(t.source,!0)}}o.CursorTop=i.registerEditorCommand(new b({inSelectionMode:!1,id:"cursorTop",precondition:void 0,kbOpts:{weight:0,kbExpr:p.EditorContextKeys.textInputFocus,primary:2062,mac:{primary:2064}}})),o.CursorTopSelect=i.registerEditorCommand(new b({inSelectionMode:!0,id:"cursorTopSelect",precondition:void 0,kbOpts:{weight:0,kbExpr:p.EditorContextKeys.textInputFocus,primary:3086,mac:{primary:3088}}}));class k extends x{constructor(e){super(e),this._inSelectionMode=e.inSelectionMode}runCoreEditorCommand(e,t){e.model.pushStackElement(),e.setCursorStates(t.source,3,c.CursorMoveCommands.moveToEndOfBuffer(e,e.getCursorStates(),this._inSelectionMode)),e.revealAllCursors(t.source,!0)}}o.CursorBottom=i.registerEditorCommand(new k({inSelectionMode:!1,id:"cursorBottom",precondition:void 0,kbOpts:{weight:0,kbExpr:p.EditorContextKeys.textInputFocus,primary:2061,mac:{primary:2066}}})),o.CursorBottomSelect=i.registerEditorCommand(new k({inSelectionMode:!0,id:"cursorBottomSelect",precondition:void 0,kbOpts:{weight:0,kbExpr:p.EditorContextKeys.textInputFocus,primary:3085,mac:{primary:3090}}}));class f extends x{constructor(){super({id:"editorScroll",precondition:void 0,metadata:exports.EditorScroll_.metadata})}determineScrollMethod(e){return[6].includes(e.unit)&&[4,2].includes(e.direction)?this._runHorizontalEditorScroll.bind(this):[1,2,3,4,5,6].includes(e.unit)&&[1,3].includes(e.direction)?this._runVerticalEditorScroll.bind(this):null}runCoreEditorCommand(e,t){const o=exports.EditorScroll_.parse(t);if(!o)return;const r=this.determineScrollMethod(o);r&&r(e,t.source,o)}_runVerticalEditorScroll(e,t,o){const r=this._computeDesiredScrollTop(e,o);if(o.revealCursor){const i=e.getCompletelyVisibleViewRangeAtScrollTop(r);e.setCursorStates(t,3,[c.CursorMoveCommands.findPositionInViewportIfOutside(e,e.getPrimaryCursorState(),i,o.select)])}e.viewLayout.setScrollPosition({scrollTop:r},0)}_computeDesiredScrollTop(e,t){if(1===t.unit){const o=e.viewLayout.getFutureViewport(),r=e.getCompletelyVisibleViewRangeAtScrollTop(o.top),i=e.coordinatesConverter.convertViewRangeToModelRange(r);let n;n=1===t.direction?Math.max(1,i.startLineNumber-t.value):Math.min(e.model.getLineCount(),i.startLineNumber+t.value);const s=e.coordinatesConverter.convertModelPositionToViewPosition(new l.Position(n,1));return e.viewLayout.getVerticalOffsetForLineNumber(s.lineNumber)}if(5===t.unit){let o=0;return 3===t.direction&&(o=e.model.getLineCount()-e.cursorConfig.pageSize),e.viewLayout.getVerticalOffsetForLineNumber(o)}let o;o=3===t.unit?e.cursorConfig.pageSize*t.value:4===t.unit?Math.round(e.cursorConfig.pageSize/2)*t.value:t.value;const r=(1===t.direction?-1:1)*o;return e.viewLayout.getCurrentScrollTop()+r*e.cursorConfig.lineHeight}_runHorizontalEditorScroll(e,t,o){const r=this._computeDesiredScrollLeft(e,o);e.viewLayout.setScrollPosition({scrollLeft:r},0)}_computeDesiredScrollLeft(e,t){const o=(4===t.direction?-1:1)*t.value;return e.viewLayout.getCurrentScrollLeft()+o*e.cursorConfig.typicalHalfwidthCharacterWidth}}o.EditorScrollImpl=f,o.EditorScroll=i.registerEditorCommand(new f),o.ScrollLineUp=i.registerEditorCommand(new class extends x{constructor(){super({id:"scrollLineUp",precondition:void 0,kbOpts:{weight:0,kbExpr:p.EditorContextKeys.textInputFocus,primary:2064,mac:{primary:267}}})}runCoreEditorCommand(e,t){o.EditorScroll.runCoreEditorCommand(e,{to:exports.EditorScroll_.RawDirection.Up,by:exports.EditorScroll_.RawUnit.WrappedLine,value:1,revealCursor:!1,select:!1,source:t.source})}}),o.ScrollPageUp=i.registerEditorCommand(new class extends x{constructor(){super({id:"scrollPageUp",precondition:void 0,kbOpts:{weight:0,kbExpr:p.EditorContextKeys.textInputFocus,primary:2059,win:{primary:523},linux:{primary:523}}})}runCoreEditorCommand(e,t){o.EditorScroll.runCoreEditorCommand(e,{to:exports.EditorScroll_.RawDirection.Up,by:exports.EditorScroll_.RawUnit.Page,value:1,revealCursor:!1,select:!1,source:t.source})}}),o.ScrollEditorTop=i.registerEditorCommand(new class extends x{constructor(){super({id:"scrollEditorTop",precondition:void 0,kbOpts:{weight:0,kbExpr:p.EditorContextKeys.textInputFocus}})}runCoreEditorCommand(e,t){o.EditorScroll.runCoreEditorCommand(e,{to:exports.EditorScroll_.RawDirection.Up,by:exports.EditorScroll_.RawUnit.Editor,value:1,revealCursor:!1,select:!1,source:t.source})}}),o.ScrollLineDown=i.registerEditorCommand(new class extends x{constructor(){super({id:"scrollLineDown",precondition:void 0,kbOpts:{weight:0,kbExpr:p.EditorContextKeys.textInputFocus,primary:2066,mac:{primary:268}}})}runCoreEditorCommand(e,t){o.EditorScroll.runCoreEditorCommand(e,{to:exports.EditorScroll_.RawDirection.Down,by:exports.EditorScroll_.RawUnit.WrappedLine,value:1,revealCursor:!1,select:!1,source:t.source})}}),o.ScrollPageDown=i.registerEditorCommand(new class extends x{constructor(){super({id:"scrollPageDown",precondition:void 0,kbOpts:{weight:0,kbExpr:p.EditorContextKeys.textInputFocus,primary:2060,win:{primary:524},linux:{primary:524}}})}runCoreEditorCommand(e,t){o.EditorScroll.runCoreEditorCommand(e,{to:exports.EditorScroll_.RawDirection.Down,by:exports.EditorScroll_.RawUnit.Page,value:1,revealCursor:!1,select:!1,source:t.source})}}),o.ScrollEditorBottom=i.registerEditorCommand(new class extends x{constructor(){super({id:"scrollEditorBottom",precondition:void 0,kbOpts:{weight:0,kbExpr:p.EditorContextKeys.textInputFocus}})}runCoreEditorCommand(e,t){o.EditorScroll.runCoreEditorCommand(e,{to:exports.EditorScroll_.RawDirection.Down,by:exports.EditorScroll_.RawUnit.Editor,value:1,revealCursor:!1,select:!1,source:t.source})}}),o.ScrollLeft=i.registerEditorCommand(new class extends x{constructor(){super({id:"scrollLeft",precondition:void 0,kbOpts:{weight:0,kbExpr:p.EditorContextKeys.textInputFocus}})}runCoreEditorCommand(e,t){o.EditorScroll.runCoreEditorCommand(e,{to:exports.EditorScroll_.RawDirection.Left,by:exports.EditorScroll_.RawUnit.Column,value:2,revealCursor:!1,select:!1,source:t.source})}}),o.ScrollRight=i.registerEditorCommand(new class extends x{constructor(){super({id:"scrollRight",precondition:void 0,kbOpts:{weight:0,kbExpr:p.EditorContextKeys.textInputFocus}})}runCoreEditorCommand(e,t){o.EditorScroll.runCoreEditorCommand(e,{to:exports.EditorScroll_.RawDirection.Right,by:exports.EditorScroll_.RawUnit.Column,value:2,revealCursor:!1,select:!1,source:t.source})}});class M extends x{constructor(e){super(e),this._inSelectionMode=e.inSelectionMode}runCoreEditorCommand(e,t){t.position&&(e.model.pushStackElement(),e.setCursorStates(t.source,3,[c.CursorMoveCommands.word(e,e.getPrimaryCursorState(),this._inSelectionMode,t.position)]),2!==t.revealType&&e.revealAllCursors(t.source,!0,!0))}}o.WordSelect=i.registerEditorCommand(new M({inSelectionMode:!1,id:"_wordSelect",precondition:void 0})),o.WordSelectDrag=i.registerEditorCommand(new M({inSelectionMode:!0,id:"_wordSelectDrag",precondition:void 0})),o.LastCursorWordSelect=i.registerEditorCommand(new class extends x{constructor(){super({id:"lastCursorWordSelect",precondition:void 0})}runCoreEditorCommand(e,t){if(!t.position)return;const o=e.getLastAddedCursorIndex(),r=e.getCursorStates(),i=r.slice(0),n=r[o];i[o]=c.CursorMoveCommands.word(e,n,n.modelState.hasSelection(),t.position),e.model.pushStackElement(),e.setCursorStates(t.source,3,i)}});class _ extends x{constructor(e){super(e),this._inSelectionMode=e.inSelectionMode}runCoreEditorCommand(e,t){t.position&&(e.model.pushStackElement(),e.setCursorStates(t.source,3,[c.CursorMoveCommands.line(e,e.getPrimaryCursorState(),this._inSelectionMode,t.position,t.viewPosition)]),2!==t.revealType&&e.revealAllCursors(t.source,!1,!0))}}o.LineSelect=i.registerEditorCommand(new _({inSelectionMode:!1,id:"_lineSelect",precondition:void 0})),o.LineSelectDrag=i.registerEditorCommand(new _({inSelectionMode:!0,id:"_lineSelectDrag",precondition:void 0}));class L extends x{constructor(e){super(e),this._inSelectionMode=e.inSelectionMode}runCoreEditorCommand(e,t){if(!t.position)return;const o=e.getLastAddedCursorIndex(),r=e.getCursorStates(),i=r.slice(0);i[o]=c.CursorMoveCommands.line(e,r[o],this._inSelectionMode,t.position,t.viewPosition),e.model.pushStackElement(),e.setCursorStates(t.source,3,i)}}o.LastCursorLineSelect=i.registerEditorCommand(new L({inSelectionMode:!1,id:"lastCursorLineSelect",precondition:void 0})),o.LastCursorLineSelectDrag=i.registerEditorCommand(new L({inSelectionMode:!0,id:"lastCursorLineSelectDrag",precondition:void 0})),o.CancelSelection=i.registerEditorCommand(new class extends x{constructor(){super({id:"cancelSelection",precondition:p.EditorContextKeys.hasNonEmptySelection,kbOpts:{weight:0,kbExpr:p.EditorContextKeys.textInputFocus,primary:9,secondary:[1033]}})}runCoreEditorCommand(e,t){e.model.pushStackElement(),e.setCursorStates(t.source,3,[c.CursorMoveCommands.cancelSelection(e,e.getPrimaryCursorState())]),e.revealAllCursors(t.source,!0)}}),o.RemoveSecondaryCursors=i.registerEditorCommand(new class extends x{constructor(){super({id:"removeSecondaryCursors",precondition:p.EditorContextKeys.hasMultipleSelections,kbOpts:{weight:1,kbExpr:p.EditorContextKeys.textInputFocus,primary:9,secondary:[1033]}})}runCoreEditorCommand(t,o){t.model.pushStackElement(),t.setCursorStates(o.source,3,[t.getPrimaryCursorState()]),t.revealAllCursors(o.source,!0),r.status(e.localize("removedCursor","Removed secondary cursors"))}}),o.RevealLine=i.registerEditorCommand(new class extends x{constructor(){super({id:"revealLine",precondition:void 0,metadata:exports.RevealLine_.metadata})}runCoreEditorCommand(e,t){const o=t,r=o.lineNumber||0;let i="number"==typeof r?r+1:parseInt(r)+1;i<1&&(i=1);const n=e.model.getLineCount();i>n&&(i=n);const s=new m.Range(i,1,i,e.model.getLineMaxColumn(i));let d=0;if(o.at)switch(o.at){case exports.RevealLine_.RawAtArgument.Top:d=3;break;case exports.RevealLine_.RawAtArgument.Center:d=1;break;case exports.RevealLine_.RawAtArgument.Bottom:d=4}const a=e.coordinatesConverter.convertModelRangeToViewRange(s);e.revealRange(t.source,!1,a,d,0)}}),o.SelectAll=new class extends y{constructor(){super(i.SelectAllCommand)}runDOMCommand(e){t.isFirefox&&(e.focus(),e.select()),e.ownerDocument.execCommand("selectAll")}runEditorCommand(e,t,o){const r=t._getViewModel();r&&this.runCoreEditorCommand(r,o)}runCoreEditorCommand(e,t){e.model.pushStackElement(),e.setCursorStates("keyboard",3,[c.CursorMoveCommands.selectAll(e,e.getPrimaryCursorState())])}},o.SetSelection=i.registerEditorCommand(new class extends x{constructor(){super({id:"setSelection",precondition:void 0})}runCoreEditorCommand(e,t){t.selection&&(e.model.pushStackElement(),e.setCursorStates(t.source,3,[d.CursorState.fromModelSelection(t.selection)]))}})}(exports.CoreNavigationCommands||(exports.CoreNavigationCommands={}));const h=C.ContextKeyExpr.and(p.EditorContextKeys.textInputFocus,p.EditorContextKeys.columnSelection);function b(e,t){g.KeybindingsRegistry.registerKeybindingRule({id:e,primary:t,when:h,weight:1})}function k(e){return e.register(),e}b(exports.CoreNavigationCommands.CursorColumnSelectLeft.id,1039),b(exports.CoreNavigationCommands.CursorColumnSelectRight.id,1041),b(exports.CoreNavigationCommands.CursorColumnSelectUp.id,1040),b(exports.CoreNavigationCommands.CursorColumnSelectPageUp.id,1035),b(exports.CoreNavigationCommands.CursorColumnSelectDown.id,1042),b(exports.CoreNavigationCommands.CursorColumnSelectPageDown.id,1036),exports.CoreEditingCommands=void 0,function(e){class t extends i.EditorCommand{runEditorCommand(e,t,o){const r=t._getViewModel();r&&this.runCoreEditingCommand(t,r,o||{})}}e.CoreEditingCommand=t,e.LineBreakInsert=i.registerEditorCommand(new class extends t{constructor(){super({id:"lineBreakInsert",precondition:p.EditorContextKeys.writable,kbOpts:{weight:0,kbExpr:p.EditorContextKeys.textInputFocus,primary:0,mac:{primary:301}}})}runCoreEditingCommand(e,t,o){e.pushUndoStop(),e.executeCommands(this.id,E.EnterOperation.lineBreakInsert(t.cursorConfig,t.model,t.getCursorStates().map((e=>e.modelState.selection))))}}),e.Outdent=i.registerEditorCommand(new class extends t{constructor(){super({id:"outdent",precondition:p.EditorContextKeys.writable,kbOpts:{weight:0,kbExpr:C.ContextKeyExpr.and(p.EditorContextKeys.editorTextFocus,p.EditorContextKeys.tabDoesNotMoveFocus),primary:1026}})}runCoreEditingCommand(e,t,o){e.pushUndoStop(),e.executeCommands(this.id,u.TypeOperations.outdent(t.cursorConfig,t.model,t.getCursorStates().map((e=>e.modelState.selection)))),e.pushUndoStop()}}),e.Tab=i.registerEditorCommand(new class extends t{constructor(){super({id:"tab",precondition:p.EditorContextKeys.writable,kbOpts:{weight:0,kbExpr:C.ContextKeyExpr.and(p.EditorContextKeys.editorTextFocus,p.EditorContextKeys.tabDoesNotMoveFocus),primary:2}})}runCoreEditingCommand(e,t,o){e.pushUndoStop(),e.executeCommands(this.id,u.TypeOperations.tab(t.cursorConfig,t.model,t.getCursorStates().map((e=>e.modelState.selection)))),e.pushUndoStop()}}),e.DeleteLeft=i.registerEditorCommand(new class extends t{constructor(){super({id:"deleteLeft",precondition:void 0,kbOpts:{weight:0,kbExpr:p.EditorContextKeys.textInputFocus,primary:1,secondary:[1025],mac:{primary:1,secondary:[1025,294,257]}}})}runCoreEditingCommand(e,t,o){const[r,i]=a.DeleteOperations.deleteLeft(t.getPrevEditOperationType(),t.cursorConfig,t.model,t.getCursorStates().map((e=>e.modelState.selection)),t.getCursorAutoClosedCharacters());r&&e.pushUndoStop(),e.executeCommands(this.id,i),t.setPrevEditOperationType(2)}}),e.DeleteRight=i.registerEditorCommand(new class extends t{constructor(){super({id:"deleteRight",precondition:void 0,kbOpts:{weight:0,kbExpr:p.EditorContextKeys.textInputFocus,primary:20,mac:{primary:20,secondary:[290,276]}}})}runCoreEditingCommand(e,t,o){const[r,i]=a.DeleteOperations.deleteRight(t.getPrevEditOperationType(),t.cursorConfig,t.model,t.getCursorStates().map((e=>e.modelState.selection)));r&&e.pushUndoStop(),e.executeCommands(this.id,i),t.setPrevEditOperationType(3)}}),e.Undo=new class extends y{constructor(){super(i.UndoCommand)}runDOMCommand(e){e.ownerDocument.execCommand("undo")}runEditorCommand(e,t,o){if(t.hasModel()&&!0!==t.getOption(92))return t.getModel().undo()}},e.Redo=new class extends y{constructor(){super(i.RedoCommand)}runDOMCommand(e){e.ownerDocument.execCommand("redo")}runEditorCommand(e,t,o){if(t.hasModel()&&!0!==t.getOption(92))return t.getModel().redo()}}}(exports.CoreEditingCommands||(exports.CoreEditingCommands={}));class f extends i.Command{constructor(e,t,o){super({id:e,precondition:void 0,metadata:o}),this._handlerId=t}runCommand(e,t){const o=e.get(n.ICodeEditorService).getFocusedCodeEditor();o&&o.trigger("keyboard",this._handlerId,t)}}function M(e,t){k(new f("default:"+e,e)),k(new f(e,e,t))}M("type",{description:"Type",args:[{name:"args",schema:{type:"object",required:["text"],properties:{text:{type:"string"}}}}]}),M("replacePreviousChar"),M("compositionType"),M("compositionStart"),M("compositionEnd"),M("paste"),M("cut"),exports.CoreEditorCommand=x;
//# sourceMappingURL=coreCommands.js.map
