"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var t,e=require("../../nls.js"),i=require("../../base/common/uri.js"),o=require("./services/codeEditorService.js"),n=require("../common/core/position.js"),r=require("../common/services/model.js"),s=require("../common/services/resolverService.js"),d=require("../../platform/actions/common/actions.js"),m=require("../../platform/commands/common/commands.js"),c=require("../../platform/contextkey/common/contextkey.js"),a=require("../../platform/instantiation/common/instantiation.js"),u=require("../../platform/keybinding/common/keybindingsRegistry.js"),l=require("../../platform/registry/common/platform.js"),p=require("../../platform/telemetry/common/telemetry.js"),h=require("../../base/common/types.js"),g=require("../../platform/log/common/log.js"),C=require("../../base/browser/dom.js");class E{constructor(t){this.id=t.id,this.precondition=t.precondition,this._kbOpts=t.kbOpts,this._menuOpts=t.menuOpts,this.metadata=t.metadata}register(){if(Array.isArray(this._menuOpts)?this._menuOpts.forEach(this._registerMenuItem,this):this._menuOpts&&this._registerMenuItem(this._menuOpts),this._kbOpts){const t=Array.isArray(this._kbOpts)?this._kbOpts:[this._kbOpts];for(const e of t){let t=e.kbExpr;this.precondition&&(t=t?c.ContextKeyExpr.and(t,this.precondition):this.precondition);const i={id:this.id,weight:e.weight,args:e.args,when:t,primary:e.primary,secondary:e.secondary,win:e.win,linux:e.linux,mac:e.mac};u.KeybindingsRegistry.registerKeybindingRule(i)}}m.CommandsRegistry.registerCommand({id:this.id,handler:(t,e)=>this.runCommand(t,e),metadata:this.metadata})}_registerMenuItem(t){d.MenuRegistry.appendMenuItem(t.menuId,{group:t.group,command:{id:this.id,title:t.title,icon:t.icon,precondition:this.precondition},when:t.when,order:t.order})}}class f extends E{constructor(){super(...arguments),this._implementations=[]}addImplementation(t,e,i,o){return this._implementations.push({priority:t,name:e,implementation:i,when:o}),this._implementations.sort(((t,e)=>e.priority-t.priority)),{dispose:()=>{for(let t=0;t<this._implementations.length;t++)if(this._implementations[t].implementation===i)return void this._implementations.splice(t,1)}}}runCommand(t,e){const i=t.get(g.ILogService),o=t.get(c.IContextKeyService);i.trace(`Executing Command '${this.id}' which has ${this._implementations.length} bound.`);for(const n of this._implementations){if(n.when){const t=o.getContext(C.getActiveElement());if(!n.when.evaluate(t))continue}const r=n.implementation(t,e);if(r){if(i.trace(`Command '${this.id}' was handled by '${n.name}'.`),"boolean"==typeof r)return;return r}}i.trace(`The Command '${this.id}' was not handled by any implementation.`)}}class y extends E{constructor(t,e){super(e),this.command=t}runCommand(t,e){return this.command.runCommand(t,e)}}class b extends E{static bindToContribution(t){return class extends b{constructor(t){super(t),this._callback=t.handler}runEditorCommand(e,i,o){const n=t(i);n&&this._callback(n,o)}}}static runEditorCommand(t,e,i,n){const r=t.get(o.ICodeEditorService),s=r.getFocusedCodeEditor()||r.getActiveCodeEditor();if(s)return s.invokeWithinContext((t=>{if(t.get(c.IContextKeyService).contextMatchesRules(i??void 0))return n(t,s,e)}))}runCommand(t,e){return b.runEditorCommand(t,e,this.precondition,((t,e,i)=>this.runEditorCommand(t,e,i)))}}class x extends b{static convertOptions(t){let e;function i(e){return e.menuId||(e.menuId=d.MenuId.EditorContext),e.title||(e.title=t.label),e.when=c.ContextKeyExpr.and(t.precondition,e.when),e}return e=Array.isArray(t.menuOpts)?t.menuOpts:t.menuOpts?[t.menuOpts]:[],Array.isArray(t.contextMenuOpts)?e.push(...t.contextMenuOpts.map(i)):t.contextMenuOpts&&e.push(i(t.contextMenuOpts)),t.menuOpts=e,t}constructor(t){super(x.convertOptions(t)),this.label=t.label,this.alias=t.alias}runEditorCommand(t,e,i){return this.reportTelemetry(t,e),this.run(t,e,i||{})}reportTelemetry(t,e){t.get(p.ITelemetryService).publicLog2("editorActionInvoked",{name:this.label,id:this.id})}}class A extends d.Action2{run(t,...e){const i=t.get(o.ICodeEditorService),n=i.getFocusedCodeEditor()||i.getActiveCodeEditor();if(n)return n.invokeWithinContext((t=>{const i=t.get(c.IContextKeyService),o=t.get(g.ILogService);if(i.contextMatchesRules(this.desc.precondition??void 0))return this.runEditorCommand(t,n,...e);o.debug("[EditorAction2] NOT running command because its precondition is FALSE",this.desc.id,this.desc.precondition?.serialize())}))}}exports.EditorExtensionsRegistry=void 0,(t=exports.EditorExtensionsRegistry||(exports.EditorExtensionsRegistry={})).getEditorCommand=function(t){return I.INSTANCE.getEditorCommand(t)},t.getEditorActions=function(){return I.INSTANCE.getEditorActions()},t.getEditorContributions=function(){return I.INSTANCE.getEditorContributions()},t.getSomeEditorContributions=function(t){return I.INSTANCE.getEditorContributions().filter((e=>t.indexOf(e.id)>=0))},t.getDiffEditorContributions=function(){return I.INSTANCE.getDiffEditorContributions()};class I{static{this.INSTANCE=new I}constructor(){this.editorContributions=[],this.diffEditorContributions=[],this.editorActions=[],this.editorCommands=Object.create(null)}registerEditorContribution(t,e,i){this.editorContributions.push({id:t,ctor:e,instantiation:i})}getEditorContributions(){return this.editorContributions.slice(0)}getDiffEditorContributions(){return this.diffEditorContributions.slice(0)}registerEditorAction(t){t.register(),this.editorActions.push(t)}getEditorActions(){return this.editorActions}registerEditorCommand(t){t.register(),this.editorCommands[t.id]=t}getEditorCommand(t){return this.editorCommands[t]||null}}function v(t){return t.register(),t}l.Registry.add("editor.contributions",I.INSTANCE);const _=v(new f({id:"undo",precondition:void 0,kbOpts:{weight:0,primary:2104},menuOpts:[{menuId:d.MenuId.MenubarEditMenu,group:"1_do",title:e.localize({key:"miUndo",comment:["&& denotes a mnemonic"]},"&&Undo"),order:1},{menuId:d.MenuId.CommandPalette,group:"",title:e.localize("undo","Undo"),order:1}]}));v(new y(_,{id:"default:undo",precondition:void 0}));const M=v(new f({id:"redo",precondition:void 0,kbOpts:{weight:0,primary:2103,secondary:[3128],mac:{primary:3128}},menuOpts:[{menuId:d.MenuId.MenubarEditMenu,group:"1_do",title:e.localize({key:"miRedo",comment:["&& denotes a mnemonic"]},"&&Redo"),order:2},{menuId:d.MenuId.CommandPalette,group:"",title:e.localize("redo","Redo"),order:1}]}));v(new y(M,{id:"default:redo",precondition:void 0}));const O=v(new f({id:"editor.action.selectAll",precondition:void 0,kbOpts:{weight:0,kbExpr:null,primary:2079},menuOpts:[{menuId:d.MenuId.MenubarSelectionMenu,group:"1_basic",title:e.localize({key:"miSelectAll",comment:["&& denotes a mnemonic"]},"&&Select All"),order:1},{menuId:d.MenuId.CommandPalette,group:"",title:e.localize("selectAll","Select All"),order:1}]}));exports.Command=E,exports.EditorAction=x,exports.EditorAction2=A,exports.EditorCommand=b,exports.MultiCommand=f,exports.MultiEditorAction=class extends x{constructor(){super(...arguments),this._implementations=[]}addImplementation(t,e){return this._implementations.push([t,e]),this._implementations.sort(((t,e)=>e[0]-t[0])),{dispose:()=>{for(let t=0;t<this._implementations.length;t++)if(this._implementations[t][1]===e)return void this._implementations.splice(t,1)}}}run(t,e,i){for(const o of this._implementations){const n=o[1](t,e,i);if(n){if("boolean"==typeof n)return;return n}}}},exports.ProxyCommand=y,exports.RedoCommand=M,exports.SelectAllCommand=O,exports.UndoCommand=_,exports.registerEditorAction=function(t){const e=new t;return I.INSTANCE.registerEditorAction(e),e},exports.registerEditorCommand=function(t){return I.INSTANCE.registerEditorCommand(t),t},exports.registerEditorContribution=function(t,e,i){I.INSTANCE.registerEditorContribution(t,e,i)},exports.registerInstantiatedEditorAction=function(t){I.INSTANCE.registerEditorAction(t)},exports.registerModelAndPositionCommand=function(t,e){m.CommandsRegistry.registerCommand(t,(function(t,...o){const d=t.get(a.IInstantiationService),[m,c]=o;h.assertType(i.URI.isUri(m)),h.assertType(n.Position.isIPosition(c));const u=t.get(r.IModelService).getModel(m);if(u){const t=n.Position.lift(c);return d.invokeFunction(e,u,t,...o.slice(2))}return t.get(s.ITextModelService).createModelReference(m).then((t=>new Promise(((i,r)=>{try{i(d.invokeFunction(e,t.object.textEditorModel,n.Position.lift(c),o.slice(2)))}catch(t){r(t)}})).finally((()=>{t.dispose()}))))}))},exports.registerMultiEditorAction=function(t){return I.INSTANCE.registerEditorAction(t),t};
//# sourceMappingURL=editorExtensions.js.map
