"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var e=require("../../../base/common/async.js"),r=require("../../../base/common/lifecycle.js"),t=require("../../../base/common/worker/simpleWorker.js"),i=require("../../../base/browser/defaultWorkerFactory.js"),o=require("../../common/core/range.js"),s=require("../../common/languages/languageConfigurationRegistry.js"),n=require("../../common/services/editorSimpleWorker.js"),a=require("../../common/services/model.js"),c=require("../../common/services/textResourceConfiguration.js"),u=require("../../../base/common/arrays.js"),l=require("../../../platform/log/common/log.js"),g=require("../../../base/common/stopwatch.js"),d=require("../../../base/common/errors.js"),h=require("../../common/services/languageFeatures.js"),m=require("../../common/diff/linesDiffComputer.js"),_=require("../../common/diff/rangeMapping.js"),p=require("../../common/core/lineRange.js"),k=require("../../../base/browser/window.js"),w=require("../../../base/browser/dom.js"),f=require("../../common/services/textModelSync/textModelSync.impl.js"),S=require("../../common/services/editorWorkerHost.js"),W=self&&self.__decorate||function(e,r,t,i){var o,s=arguments.length,n=s<3?r:null===i?i=Object.getOwnPropertyDescriptor(r,t):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)n=Reflect.decorate(e,r,t,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(n=(s<3?o(n):s>3?o(r,t,n):o(r,t))||n);return s>3&&n&&Object.defineProperty(r,t,n),n},v=self&&self.__param||function(e,r){return function(t,i){r(t,i,e)}};const y=3e5;function C(e,r){const t=e.getModel(r);return!!t&&!t.isTooLargeForSyncing()}exports.EditorWorkerService=class extends r.Disposable{constructor(e,r,t,i,o,s){super(),this._languageConfigurationService=o,this._modelService=r,this._workerManager=this._register(new R(e,this._modelService)),this._logService=i,this._register(s.linkProvider.register({language:"*",hasAccessToAllModels:!0},{provideLinks:async(e,r)=>{if(!C(this._modelService,e.uri))return Promise.resolve({links:[]});const t=await this._workerWithResources([e.uri]),i=await t.$computeLinks(e.uri.toString());return i&&{links:i}}})),this._register(s.completionProvider.register("*",new M(this._workerManager,t,this._modelService,this._languageConfigurationService)))}dispose(){super.dispose()}canComputeUnicodeHighlights(e){return C(this._modelService,e)}async computedUnicodeHighlights(e,r,t){return(await this._workerWithResources([e])).$computeUnicodeHighlights(e.toString(),r,t)}async computeDiff(e,r,t,i){const s=await this._workerWithResources([e,r],!0),n=await s.$computeDiff(e.toString(),r.toString(),t,i);if(!n)return null;return{identical:n.identical,quitEarly:n.quitEarly,changes:a(n.changes),moves:n.moves.map((e=>new m.MovedText(new _.LineRangeMapping(new p.LineRange(e[0],e[1]),new p.LineRange(e[2],e[3])),a(e[4]))))};function a(e){return e.map((e=>new _.DetailedLineRangeMapping(new p.LineRange(e[0],e[1]),new p.LineRange(e[2],e[3]),e[4]?.map((e=>new _.RangeMapping(new o.Range(e[0],e[1],e[2],e[3]),new o.Range(e[4],e[5],e[6],e[7])))))))}}async computeMoreMinimalEdits(r,t,i=!1){if(u.isNonEmptyArray(t)){if(!C(this._modelService,r))return Promise.resolve(t);const o=g.StopWatch.create(),s=this._workerWithResources([r]).then((e=>e.$computeMoreMinimalEdits(r.toString(),t,i)));return s.finally((()=>this._logService.trace("FORMAT#computeMoreMinimalEdits",r.toString(!0),o.elapsed()))),Promise.race([s,e.timeout(1e3).then((()=>t))])}return Promise.resolve(void 0)}canNavigateValueSet(e){return C(this._modelService,e)}async navigateValueSet(e,r,t){const i=this._modelService.getModel(e);if(!i)return null;const o=this._languageConfigurationService.getLanguageConfiguration(i.getLanguageId()).getWordDefinition(),s=o.source,n=o.flags;return(await this._workerWithResources([e])).$navigateValueSet(e.toString(),r,t,s,n)}canComputeWordRanges(e){return C(this._modelService,e)}async computeWordRanges(e,r){const t=this._modelService.getModel(e);if(!t)return Promise.resolve(null);const i=this._languageConfigurationService.getLanguageConfiguration(t.getLanguageId()).getWordDefinition(),o=i.source,s=i.flags;return(await this._workerWithResources([e])).$computeWordRanges(e.toString(),r,o,s)}async findSectionHeaders(e,r){return(await this._workerWithResources([e])).$findSectionHeaders(e.toString(),r)}async computeDefaultDocumentColors(e){return(await this._workerWithResources([e])).$computeDefaultDocumentColors(e.toString())}async _workerWithResources(e,r=!1){const t=await this._workerManager.withWorker();return await t.workerWithSyncedResources(e,r)}},exports.EditorWorkerService=W([v(1,a.IModelService),v(2,c.ITextResourceConfigurationService),v(3,l.ILogService),v(4,s.ILanguageConfigurationService),v(5,h.ILanguageFeaturesService)],exports.EditorWorkerService);class M{constructor(e,r,t,i){this.languageConfigurationService=i,this._debugDisplayName="wordbasedCompletions",this._workerManager=e,this._configurationService=r,this._modelService=t}async provideCompletionItems(e,r){const t=this._configurationService.getValue(e.uri,r,"editor");if("off"===t.wordBasedSuggestions)return;const i=[];if("currentDocument"===t.wordBasedSuggestions)C(this._modelService,e.uri)&&i.push(e.uri);else for(const r of this._modelService.getModels())C(this._modelService,r.uri)&&(r===e?i.unshift(r.uri):"allDocuments"!==t.wordBasedSuggestions&&r.getLanguageId()!==e.getLanguageId()||i.push(r.uri));if(0===i.length)return;const s=this.languageConfigurationService.getLanguageConfiguration(e.getLanguageId()).getWordDefinition(),n=e.getWordAtPosition(r),a=n?new o.Range(r.lineNumber,n.startColumn,r.lineNumber,n.endColumn):o.Range.fromPositions(r),c=a.setEndPosition(r.lineNumber,r.column),u=await this._workerManager.withWorker(),l=await u.textualSuggest(i,n?.word,s);return l?{duration:l.duration,suggestions:l.words.map((e=>({kind:18,label:e,insertText:e,range:{insert:c,replace:a}})))}:void 0}}let R=class extends r.Disposable{constructor(e,r){super(),this._workerDescriptor=e,this._modelService=r,this._editorWorkerClient=null,this._lastWorkerUsedTime=(new Date).getTime();this._register(new w.WindowIntervalTimer).cancelAndSet((()=>this._checkStopIdleWorker()),Math.round(15e4),k.mainWindow),this._register(this._modelService.onModelRemoved((e=>this._checkStopEmptyWorker())))}dispose(){this._editorWorkerClient&&(this._editorWorkerClient.dispose(),this._editorWorkerClient=null),super.dispose()}_checkStopEmptyWorker(){if(!this._editorWorkerClient)return;0===this._modelService.getModels().length&&(this._editorWorkerClient.dispose(),this._editorWorkerClient=null)}_checkStopIdleWorker(){if(!this._editorWorkerClient)return;(new Date).getTime()-this._lastWorkerUsedTime>y&&(this._editorWorkerClient.dispose(),this._editorWorkerClient=null)}withWorker(){return this._lastWorkerUsedTime=(new Date).getTime(),this._editorWorkerClient||(this._editorWorkerClient=new exports.EditorWorkerClient(this._workerDescriptor,!1,this._modelService)),Promise.resolve(this._editorWorkerClient)}};R=W([v(1,a.IModelService)],R);class b{constructor(e){this._instance=e,this.proxy=this._instance}dispose(){this._instance.dispose()}setChannel(e,r){throw new Error("Not supported")}}exports.EditorWorkerClient=class extends r.Disposable{constructor(e,r,t){super(),this._workerDescriptor=e,this._disposed=!1,this._modelService=t,this._keepIdleModels=r,this._worker=null,this._modelManager=null}fhr(e,r){throw new Error("Not implemented!")}_getOrCreateWorker(){if(!this._worker)try{this._worker=this._register(i.createWebWorker(this._workerDescriptor)),S.EditorWorkerHost.setChannel(this._worker,this._createEditorWorkerHost())}catch(e){t.logOnceWebWorkerWarning(e),this._worker=this._createFallbackLocalWorker()}return this._worker}async _getProxy(){try{const e=this._getOrCreateWorker().proxy;return await e.$ping(),e}catch(e){return t.logOnceWebWorkerWarning(e),this._worker=this._createFallbackLocalWorker(),this._worker.proxy}}_createFallbackLocalWorker(){return new b(new n.EditorSimpleWorker(this._createEditorWorkerHost(),null))}_createEditorWorkerHost(){return{$fhr:(e,r)=>this.fhr(e,r)}}_getOrCreateModelManager(e){return this._modelManager||(this._modelManager=this._register(new f.WorkerTextModelSyncClient(e,this._modelService,this._keepIdleModels))),this._modelManager}async workerWithSyncedResources(e,r=!1){if(this._disposed)return Promise.reject(d.canceled());const t=await this._getProxy();return this._getOrCreateModelManager(t).ensureSyncedResources(e,r),t}async textualSuggest(e,r,t){const i=await this.workerWithSyncedResources(e),o=t.source,s=t.flags;return i.$textualSuggest(e.map((e=>e.toString())),r,o,s)}dispose(){super.dispose(),this._disposed=!0}},exports.EditorWorkerClient=W([v(2,a.IModelService)],exports.EditorWorkerClient);
//# sourceMappingURL=editorWorkerService.js.map
