"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var e=require("../../base/browser/dom.js"),t=require("../../base/browser/fastDomNode.js"),i=require("../../base/browser/performance.js"),n=require("../../base/common/errors.js"),r=require("./controller/mouseTarget.js"),s=require("./controller/pointerHandler.js"),o=require("./controller/textAreaHandler.js"),a=require("./view/renderingContext.js"),d=require("./view/viewController.js"),h=require("./view/viewOverlays.js"),l=require("./view/viewPart.js"),c=require("./view/viewUserInputEvents.js"),u=require("./viewParts/blockDecorations/blockDecorations.js"),_=require("./viewParts/contentWidgets/contentWidgets.js"),g=require("./viewParts/currentLineHighlight/currentLineHighlight.js"),w=require("./viewParts/decorations/decorations.js"),p=require("./viewParts/editorScrollbar/editorScrollbar.js"),v=require("./viewParts/glyphMargin/glyphMargin.js"),m=require("./viewParts/indentGuides/indentGuides.js"),f=require("./viewParts/lineNumbers/lineNumbers.js"),C=require("./viewParts/lines/viewLines.js"),y=require("./viewParts/linesDecorations/linesDecorations.js"),R=require("./viewParts/margin/margin.js"),x=require("./viewParts/marginDecorations/marginDecorations.js"),N=require("./viewParts/minimap/minimap.js"),D=require("./viewParts/overlayWidgets/overlayWidgets.js"),P=require("./viewParts/overviewRuler/decorationsOverviewRuler.js"),W=require("./viewParts/overviewRuler/overviewRuler.js"),L=require("./viewParts/rulers/rulers.js"),M=require("./viewParts/scrollDecoration/scrollDecoration.js"),A=require("./viewParts/selections/selections.js"),O=require("./viewParts/viewCursors/viewCursors.js"),j=require("./viewParts/viewZones/viewZones.js"),b=require("./viewParts/whitespace/whitespace.js"),q=require("../common/core/position.js"),H=require("../common/core/range.js"),G=require("../common/core/selection.js"),S=require("../common/model.js"),T=require("../common/viewEventHandler.js"),F=require("../common/viewLayout/viewLinesViewportData.js"),V=require("../common/viewModel/viewContext.js"),E=require("../../platform/instantiation/common/instantiation.js"),I=require("../../platform/theme/common/themeService.js"),Z=self&&self.__decorate||function(e,t,i,n){var r,s=arguments.length,o=s<3?t:null===n?n=Object.getOwnPropertyDescriptor(t,i):n;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)o=Reflect.decorate(e,t,i,n);else for(var a=e.length-1;a>=0;a--)(r=e[a])&&(o=(s<3?r(o):s>3?r(t,i,o):r(t,i))||o);return s>3&&o&&Object.defineProperty(t,i,o),o},B=self&&self.__param||function(e,t){return function(i,n){t(i,n,e)}};function k(e){try{return e()}catch(e){return n.onUnexpectedError(e),null}}exports.View=class extends T.ViewEventHandler{constructor(e,i,n,r,a,c,W){super(),this._instantiationService=W,this._shouldRecomputeGlyphMarginLanes=!1,this._selections=[new G.Selection(1,1,1,1)],this._renderAnimationFrame=null;const q=new d.ViewController(i,r,a,e);this._context=new V.ViewContext(i,n,r),this._context.addEventHandler(this),this._viewParts=[],this._textAreaHandler=this._instantiationService.createInstance(o.TextAreaHandler,this._context,q,this._createTextAreaHandlerHelper()),this._viewParts.push(this._textAreaHandler),this._linesContent=t.createFastDomNode(document.createElement("div")),this._linesContent.setClassName("lines-content monaco-editor-background"),this._linesContent.setPosition("absolute"),this.domNode=t.createFastDomNode(document.createElement("div")),this.domNode.setClassName(this._getEditorClassName()),this.domNode.setAttribute("role","code"),this._overflowGuardContainer=t.createFastDomNode(document.createElement("div")),l.PartFingerprints.write(this._overflowGuardContainer,3),this._overflowGuardContainer.setClassName("overflow-guard"),this._scrollbar=new p.EditorScrollbar(this._context,this._linesContent,this.domNode,this._overflowGuardContainer),this._viewParts.push(this._scrollbar),this._viewLines=new C.ViewLines(this._context,this._linesContent),this._viewZones=new j.ViewZones(this._context),this._viewParts.push(this._viewZones);const H=new P.DecorationsOverviewRuler(this._context);this._viewParts.push(H);const S=new M.ScrollDecorationViewPart(this._context);this._viewParts.push(S);const T=new h.ContentViewOverlays(this._context);this._viewParts.push(T),T.addDynamicOverlay(new g.CurrentLineHighlightOverlay(this._context)),T.addDynamicOverlay(new A.SelectionsOverlay(this._context)),T.addDynamicOverlay(new m.IndentGuidesOverlay(this._context)),T.addDynamicOverlay(new w.DecorationsOverlay(this._context)),T.addDynamicOverlay(new b.WhitespaceOverlay(this._context));const F=new h.MarginViewOverlays(this._context);this._viewParts.push(F),F.addDynamicOverlay(new g.CurrentLineMarginHighlightOverlay(this._context)),F.addDynamicOverlay(new x.MarginViewLineDecorationsOverlay(this._context)),F.addDynamicOverlay(new y.LinesDecorationsOverlay(this._context)),F.addDynamicOverlay(new f.LineNumbersOverlay(this._context)),this._glyphMarginWidgets=new v.GlyphMarginWidgets(this._context),this._viewParts.push(this._glyphMarginWidgets);const E=new R.Margin(this._context);E.getDomNode().appendChild(this._viewZones.marginDomNode),E.getDomNode().appendChild(F.getDomNode()),E.getDomNode().appendChild(this._glyphMarginWidgets.domNode),this._viewParts.push(E),this._contentWidgets=new _.ViewContentWidgets(this._context,this.domNode),this._viewParts.push(this._contentWidgets),this._viewCursors=new O.ViewCursors(this._context),this._viewParts.push(this._viewCursors),this._overlayWidgets=new D.ViewOverlayWidgets(this._context,this.domNode),this._viewParts.push(this._overlayWidgets);const I=new L.Rulers(this._context);this._viewParts.push(I);const Z=new u.BlockDecorations(this._context);this._viewParts.push(Z);const B=new N.Minimap(this._context);if(this._viewParts.push(B),H){const e=this._scrollbar.getOverviewRulerLayoutInfo();e.parent.insertBefore(H.getDomNode(),e.insertBefore)}this._linesContent.appendChild(T.getDomNode()),this._linesContent.appendChild(I.domNode),this._linesContent.appendChild(this._viewZones.domNode),this._linesContent.appendChild(this._viewLines.getDomNode()),this._linesContent.appendChild(this._contentWidgets.domNode),this._linesContent.appendChild(this._viewCursors.getDomNode()),this._overflowGuardContainer.appendChild(E.getDomNode()),this._overflowGuardContainer.appendChild(this._scrollbar.getDomNode()),this._overflowGuardContainer.appendChild(S.getDomNode()),this._overflowGuardContainer.appendChild(this._textAreaHandler.textArea),this._overflowGuardContainer.appendChild(this._textAreaHandler.textAreaCover),this._overflowGuardContainer.appendChild(this._overlayWidgets.getDomNode()),this._overflowGuardContainer.appendChild(B.getDomNode()),this._overflowGuardContainer.appendChild(Z.domNode),this.domNode.appendChild(this._overflowGuardContainer),c?(c.appendChild(this._contentWidgets.overflowingContentWidgetsDomNode.domNode),c.appendChild(this._overlayWidgets.overflowingOverlayWidgetsDomNode.domNode)):(this.domNode.appendChild(this._contentWidgets.overflowingContentWidgetsDomNode),this.domNode.appendChild(this._overlayWidgets.overflowingOverlayWidgetsDomNode)),this._applyLayout(),this._pointerHandler=this._register(new s.PointerHandler(this._context,q,this._createPointerHandlerHelper()))}_computeGlyphMarginLanes(){const e=this._context.viewModel.model,t=this._context.viewModel.glyphLanes;let i=[],n=0;i=i.concat(e.getAllMarginDecorations().map((e=>{const t=e.options.glyphMargin?.position??S.GlyphMarginLane.Center;return n=Math.max(n,e.range.endLineNumber),{range:e.range,lane:t,persist:e.options.glyphMargin?.persistLane}}))),i=i.concat(this._glyphMarginWidgets.getWidgets().map((t=>{const i=e.validateRange(t.preference.range);return n=Math.max(n,i.endLineNumber),{range:i,lane:t.preference.lane}}))),i.sort(((e,t)=>H.Range.compareRangesUsingStarts(e.range,t.range))),t.reset(n);for(const e of i)t.push(e.lane,e.range,e.persist);return t}_createPointerHandlerHelper(){return{viewDomNode:this.domNode.domNode,linesContentDomNode:this._linesContent.domNode,viewLinesDomNode:this._viewLines.getDomNode().domNode,focusTextArea:()=>{this.focus()},dispatchTextAreaEvent:e=>{this._textAreaHandler.textArea.domNode.dispatchEvent(e)},getLastRenderData:()=>{const e=this._viewCursors.getLastRenderData()||[],t=this._textAreaHandler.getLastRenderData();return new r.PointerHandlerLastRenderData(e,t)},renderNow:()=>{this.render(!0,!1)},shouldSuppressMouseDownOnViewZone:e=>this._viewZones.shouldSuppressMouseDownOnViewZone(e),shouldSuppressMouseDownOnWidget:e=>this._contentWidgets.shouldSuppressMouseDownOnWidget(e),getPositionFromDOMInfo:(e,t)=>(this._flushAccumulatedAndRenderNow(),this._viewLines.getPositionFromDOMInfo(e,t)),visibleRangeForPosition:(e,t)=>(this._flushAccumulatedAndRenderNow(),this._viewLines.visibleRangeForPosition(new q.Position(e,t))),getLineWidth:e=>(this._flushAccumulatedAndRenderNow(),this._viewLines.getLineWidth(e))}}_createTextAreaHandlerHelper(){return{visibleRangeForPosition:e=>(this._flushAccumulatedAndRenderNow(),this._viewLines.visibleRangeForPosition(e))}}_applyLayout(){const e=this._context.configuration.options.get(146);this.domNode.setWidth(e.width),this.domNode.setHeight(e.height),this._overflowGuardContainer.setWidth(e.width),this._overflowGuardContainer.setHeight(e.height),this._linesContent.setWidth(16777216),this._linesContent.setHeight(16777216)}_getEditorClassName(){const e=this._textAreaHandler.isFocused()?" focused":"";return this._context.configuration.options.get(143)+" "+I.getThemeTypeSelector(this._context.theme.type)+e}handleEvents(e){super.handleEvents(e),this._scheduleRender()}onConfigurationChanged(e){return this.domNode.setClassName(this._getEditorClassName()),this._applyLayout(),!1}onCursorStateChanged(e){return this._selections=e.selections,!1}onDecorationsChanged(e){return e.affectsGlyphMargin&&(this._shouldRecomputeGlyphMarginLanes=!0),!1}onFocusChanged(e){return this.domNode.setClassName(this._getEditorClassName()),!1}onThemeChanged(e){return this._context.theme.update(e.theme),this.domNode.setClassName(this._getEditorClassName()),!1}dispose(){null!==this._renderAnimationFrame&&(this._renderAnimationFrame.dispose(),this._renderAnimationFrame=null),this._contentWidgets.overflowingContentWidgetsDomNode.domNode.remove(),this._context.removeEventHandler(this),this._viewLines.dispose();for(const e of this._viewParts)e.dispose();super.dispose()}_scheduleRender(){if(this._store.isDisposed)throw new n.BugIndicatingError;if(null===this._renderAnimationFrame){const t=this._createCoordinatedRendering();this._renderAnimationFrame=U.INSTANCE.scheduleCoordinatedRendering({window:e.getWindow(this.domNode?.domNode),prepareRenderText:()=>{if(this._store.isDisposed)throw new n.BugIndicatingError;try{return t.prepareRenderText()}finally{this._renderAnimationFrame=null}},renderText:()=>{if(this._store.isDisposed)throw new n.BugIndicatingError;return t.renderText()},prepareRender:(e,i)=>{if(this._store.isDisposed)throw new n.BugIndicatingError;return t.prepareRender(e,i)},render:(e,i)=>{if(this._store.isDisposed)throw new n.BugIndicatingError;return t.render(e,i)}})}}_flushAccumulatedAndRenderNow(){const e=this._createCoordinatedRendering();k((()=>e.prepareRenderText()));const t=k((()=>e.renderText()));if(t){const[i,n]=t;k((()=>e.prepareRender(i,n))),k((()=>e.render(i,n)))}}_getViewPartsToRender(){const e=[];let t=0;for(const i of this._viewParts)i.shouldRender()&&(e[t++]=i);return e}_createCoordinatedRendering(){return{prepareRenderText:()=>{if(this._shouldRecomputeGlyphMarginLanes){this._shouldRecomputeGlyphMarginLanes=!1;const e=this._computeGlyphMarginLanes();this._context.configuration.setGlyphMarginDecorationLaneCount(e.requiredLanes)}i.inputLatency.onRenderStart()},renderText:()=>{if(!this.domNode.domNode.isConnected)return null;let e=this._getViewPartsToRender();if(!this._viewLines.shouldRender()&&0===e.length)return null;const t=this._context.viewLayout.getLinesViewportData();this._context.viewModel.setViewport(t.startLineNumber,t.endLineNumber,t.centeredLineNumber);const i=new F.ViewportData(this._selections,t,this._context.viewLayout.getWhitespaceViewportData(),this._context.viewModel);return this._contentWidgets.shouldRender()&&this._contentWidgets.onBeforeRender(i),this._viewLines.shouldRender()&&(this._viewLines.renderText(i),this._viewLines.onDidRender(),e=this._getViewPartsToRender()),[e,new a.RenderingContext(this._context.viewLayout,i,this._viewLines)]},prepareRender:(e,t)=>{for(const i of e)i.prepareRender(t)},render:(e,t)=>{for(const i of e)i.render(t),i.onDidRender()}}}delegateVerticalScrollbarPointerDown(e){this._scrollbar.delegateVerticalScrollbarPointerDown(e)}delegateScrollFromMouseWheelEvent(e){this._scrollbar.delegateScrollFromMouseWheelEvent(e)}restoreState(e){this._context.viewModel.viewLayout.setScrollPosition({scrollTop:e.scrollTop,scrollLeft:e.scrollLeft},1),this._context.viewModel.visibleLinesStabilized()}getOffsetForColumn(e,t){const i=this._context.viewModel.model.validatePosition({lineNumber:e,column:t}),n=this._context.viewModel.coordinatesConverter.convertModelPositionToViewPosition(i);this._flushAccumulatedAndRenderNow();const r=this._viewLines.visibleRangeForPosition(new q.Position(n.lineNumber,n.column));return r?r.left:-1}getTargetAtClientPoint(e,t){const i=this._pointerHandler.getTargetAtClientPoint(e,t);return i?c.ViewUserInputEvents.convertViewToModelMouseTarget(i,this._context.viewModel.coordinatesConverter):null}createOverviewRuler(e){return new W.OverviewRuler(this._context,e)}change(e){this._viewZones.changeViewZones(e),this._scheduleRender()}render(e,t){if(t){this._viewLines.forceShouldRender();for(const e of this._viewParts)e.forceShouldRender()}e?this._flushAccumulatedAndRenderNow():this._scheduleRender()}writeScreenReaderContent(e){this._textAreaHandler.writeScreenReaderContent(e)}focus(){this._textAreaHandler.focusTextArea()}isFocused(){return this._textAreaHandler.isFocused()}setAriaOptions(e){this._textAreaHandler.setAriaOptions(e)}addContentWidget(e){this._contentWidgets.addWidget(e.widget),this.layoutContentWidget(e),this._scheduleRender()}layoutContentWidget(e){this._contentWidgets.setWidgetPosition(e.widget,e.position?.position??null,e.position?.secondaryPosition??null,e.position?.preference??null,e.position?.positionAffinity??null),this._scheduleRender()}removeContentWidget(e){this._contentWidgets.removeWidget(e.widget),this._scheduleRender()}addOverlayWidget(e){this._overlayWidgets.addWidget(e.widget),this.layoutOverlayWidget(e),this._scheduleRender()}layoutOverlayWidget(e){this._overlayWidgets.setWidgetPosition(e.widget,e.position)&&this._scheduleRender()}removeOverlayWidget(e){this._overlayWidgets.removeWidget(e.widget),this._scheduleRender()}addGlyphMarginWidget(e){this._glyphMarginWidgets.addWidget(e.widget),this._shouldRecomputeGlyphMarginLanes=!0,this._scheduleRender()}layoutGlyphMarginWidget(e){const t=e.position;this._glyphMarginWidgets.setWidgetPosition(e.widget,t)&&(this._shouldRecomputeGlyphMarginLanes=!0,this._scheduleRender())}removeGlyphMarginWidget(e){this._glyphMarginWidgets.removeWidget(e.widget),this._shouldRecomputeGlyphMarginLanes=!0,this._scheduleRender()}},exports.View=Z([B(6,E.IInstantiationService)],exports.View);class U{static{this.INSTANCE=new U}constructor(){this._coordinatedRenderings=[],this._animationFrameRunners=new Map}scheduleCoordinatedRendering(e){return this._coordinatedRenderings.push(e),this._scheduleRender(e.window),{dispose:()=>{const t=this._coordinatedRenderings.indexOf(e);if(-1!==t&&(this._coordinatedRenderings.splice(t,1),0===this._coordinatedRenderings.length)){for(const[e,t]of this._animationFrameRunners)t.dispose();this._animationFrameRunners.clear()}}}}_scheduleRender(t){if(!this._animationFrameRunners.has(t)){const i=()=>{this._animationFrameRunners.delete(t),this._onRenderScheduled()};this._animationFrameRunners.set(t,e.runAtThisOrScheduleAtNextAnimationFrame(t,i,100))}}_onRenderScheduled(){const e=this._coordinatedRenderings.slice(0);this._coordinatedRenderings=[];for(const t of e)k((()=>t.prepareRenderText()));const t=[];for(let i=0,n=e.length;i<n;i++){const n=e[i];t[i]=k((()=>n.renderText()))}for(let i=0,n=e.length;i<n;i++){const n=e[i],r=t[i];if(!r)continue;const[s,o]=r;k((()=>n.prepareRender(s,o)))}for(let i=0,n=e.length;i<n;i++){const n=e[i],r=t[i];if(!r)continue;const[s,o]=r;k((()=>n.render(s,o)))}}}
//# sourceMappingURL=view.js.map
