"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var e=require("../../../../../base/browser/dom.js"),o=require("../../../../../base/browser/fastDomNode.js"),r=require("../../../../../base/browser/ui/scrollbar/scrollbarState.js"),t=require("../../../../../base/common/lifecycle.js");require("../../../../../base/common/arrays.js");var i=require("../../../../../base/common/observableInternal/derived.js"),s=require("../../../../../base/common/observableInternal/autorun.js"),n=require("../../../../../base/common/observableInternal/utils.js");require("../../../../../base/common/errors.js");var a=require("../utils.js"),d=require("../../../../common/core/position.js"),l=require("../../../../common/viewModel/overviewZoneManager.js");require("../../../../../platform/theme/common/colorUtils.js"),require("../../../../../platform/theme/common/colors/baseColors.js"),require("../../../../../platform/theme/common/colors/chartsColors.js");var m=require("../../../../../platform/theme/common/colors/editorColors.js");require("../../../../../platform/theme/common/colors/inputColors.js"),require("../../../../../platform/theme/common/colors/listColors.js"),require("../../../../../platform/theme/common/colors/menuColors.js"),require("../../../../../platform/theme/common/colors/minimapColors.js"),require("../../../../../platform/theme/common/colors/miscColors.js"),require("../../../../../platform/theme/common/colors/quickpickColors.js"),require("../../../../../platform/theme/common/colors/searchColors.js");var c,h=require("../../../../../platform/theme/common/themeService.js"),u=self&&self.__decorate||function(e,o,r,t){var i,s=arguments.length,n=s<3?o:null===t?t=Object.getOwnPropertyDescriptor(o,r):t;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)n=Reflect.decorate(e,o,r,t);else for(var a=e.length-1;a>=0;a--)(i=e[a])&&(n=(s<3?i(n):s>3?i(o,r,n):i(o,r))||n);return s>3&&n&&Object.defineProperty(o,r,n),n},v=self&&self.__param||function(e,o){return function(r,t){o(r,t,e)}};exports.OverviewRulerFeature=class extends t.Disposable{static{c=this}static{this.ONE_OVERVIEW_WIDTH=15}static{this.ENTIRE_DIFF_OVERVIEW_WIDTH=2*this.ONE_OVERVIEW_WIDTH}constructor(t,h,u,v,f,_,p){super(),this._editors=t,this._rootElement=h,this._diffModel=u,this._rootWidth=v,this._rootHeight=f,this._modifiedEditorLayoutInfo=_,this._themeService=p,this.width=c.ENTIRE_DIFF_OVERVIEW_WIDTH;const g=n.observableFromEvent(this._themeService.onDidColorThemeChange,(()=>this._themeService.getColorTheme())),E=i.derived((e=>{const o=g.read(e);return{insertColor:o.getColor(m.diffOverviewRulerInserted)||(o.getColor(m.diffInserted)||m.defaultInsertColor).transparent(2),removeColor:o.getColor(m.diffOverviewRulerRemoved)||(o.getColor(m.diffRemoved)||m.defaultRemoveColor).transparent(2)}})),b=o.createFastDomNode(document.createElement("div"));b.setClassName("diffViewport"),b.setPosition("absolute");const I=e.h("div.diffOverview",{style:{position:"absolute",top:"0px",width:c.ENTIRE_DIFF_OVERVIEW_WIDTH+"px"}}).root;this._register(a.appendRemoveOnDispose(I,b.domNode)),this._register(e.addStandardDisposableListener(I,e.EventType.POINTER_DOWN,(e=>{this._editors.modified.delegateVerticalScrollbarPointerDown(e)}))),this._register(e.addDisposableListener(I,e.EventType.MOUSE_WHEEL,(e=>{this._editors.modified.delegateScrollFromMouseWheelEvent(e)}),{passive:!1})),this._register(a.appendRemoveOnDispose(this._rootElement,I)),this._register(s.autorunWithStore(((e,o)=>{const t=this._diffModel.read(e),i=this._editors.original.createOverviewRuler("original diffOverviewRuler");i&&(o.add(i),o.add(a.appendRemoveOnDispose(I,i.getDomNode())));const m=this._editors.modified.createOverviewRuler("modified diffOverviewRuler");if(m&&(o.add(m),o.add(a.appendRemoveOnDispose(I,m.getDomNode()))),!i||!m)return;const h=n.observableSignalFromEvent("viewZoneChanged",this._editors.original.onDidChangeViewZones),u=n.observableSignalFromEvent("viewZoneChanged",this._editors.modified.onDidChangeViewZones),v=n.observableSignalFromEvent("hiddenRangesChanged",this._editors.original.onDidChangeHiddenAreas),f=n.observableSignalFromEvent("hiddenRangesChanged",this._editors.modified.onDidChangeHiddenAreas);o.add(s.autorun((e=>{h.read(e),u.read(e),v.read(e),f.read(e);const o=E.read(e),r=t?.diff.read(e)?.mappings;function s(e,o,r){const t=r._getViewModel();return t?e.filter((e=>e.length>0)).map((e=>{const r=t.coordinatesConverter.convertModelPositionToViewPosition(new d.Position(e.startLineNumber,1)),i=t.coordinatesConverter.convertModelPositionToViewPosition(new d.Position(e.endLineNumberExclusive,1)),s=i.lineNumber-r.lineNumber;return new l.OverviewRulerZone(r.lineNumber,i.lineNumber,s,o.toString())})):[]}const n=s((r||[]).map((e=>e.lineRangeMapping.original)),o.removeColor,this._editors.original),a=s((r||[]).map((e=>e.lineRangeMapping.modified)),o.insertColor,this._editors.modified);i?.setZones(n),m?.setZones(a)}))),o.add(s.autorun((e=>{const o=this._rootHeight.read(e),t=this._rootWidth.read(e),s=this._modifiedEditorLayoutInfo.read(e);if(s){const t=c.ENTIRE_DIFF_OVERVIEW_WIDTH-2*c.ONE_OVERVIEW_WIDTH;i.setLayout({top:0,height:o,right:t+c.ONE_OVERVIEW_WIDTH,width:c.ONE_OVERVIEW_WIDTH}),m.setLayout({top:0,height:o,right:0,width:c.ONE_OVERVIEW_WIDTH});const n=this._editors.modifiedScrollTop.read(e),a=this._editors.modifiedScrollHeight.read(e),d=this._editors.modified.getOption(104),l=new r.ScrollbarState(d.verticalHasArrows?d.arrowSize:0,d.verticalScrollbarSize,0,s.height,a,n);b.setTop(l.getSliderPosition()),b.setHeight(l.getSliderSize())}else b.setTop(0),b.setHeight(0);I.style.height=o+"px",I.style.left=t-c.ENTIRE_DIFF_OVERVIEW_WIDTH+"px",b.setWidth(c.ENTIRE_DIFF_OVERVIEW_WIDTH)})))})))}},exports.OverviewRulerFeature=c=u([v(6,h.IThemeService)],exports.OverviewRulerFeature);
//# sourceMappingURL=overviewRulerFeature.js.map
