"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var e=require("./diffEditor.js"),i=require("./editorOptions.js"),t=require("../core/textModelDefaults.js"),o=require("../../../nls.js"),n=require("../../../platform/configuration/common/configurationRegistry.js"),r=require("../../../platform/registry/common/platform.js");const a=Object.freeze({id:"editor",order:5,type:"object",title:o.localize("editorConfigurationTitle","Editor"),scope:5}),d={...a,properties:{"editor.tabSize":{type:"number",default:t.EDITOR_MODEL_DEFAULTS.tabSize,minimum:1,markdownDescription:o.localize("tabSize","The number of spaces a tab is equal to. This setting is overridden based on the file contents when {0} is on.","`#editor.detectIndentation#`")},"editor.indentSize":{anyOf:[{type:"string",enum:["tabSize"]},{type:"number",minimum:1}],default:"tabSize",markdownDescription:o.localize("indentSize",'The number of spaces used for indentation or `"tabSize"` to use the value from `#editor.tabSize#`. This setting is overridden based on the file contents when `#editor.detectIndentation#` is on.')},"editor.insertSpaces":{type:"boolean",default:t.EDITOR_MODEL_DEFAULTS.insertSpaces,markdownDescription:o.localize("insertSpaces","Insert spaces when pressing `Tab`. This setting is overridden based on the file contents when {0} is on.","`#editor.detectIndentation#`")},"editor.detectIndentation":{type:"boolean",default:t.EDITOR_MODEL_DEFAULTS.detectIndentation,markdownDescription:o.localize("detectIndentation","Controls whether {0} and {1} will be automatically detected when a file is opened based on the file contents.","`#editor.tabSize#`","`#editor.insertSpaces#`")},"editor.trimAutoWhitespace":{type:"boolean",default:t.EDITOR_MODEL_DEFAULTS.trimAutoWhitespace,description:o.localize("trimAutoWhitespace","Remove trailing auto inserted whitespace.")},"editor.largeFileOptimizations":{type:"boolean",default:t.EDITOR_MODEL_DEFAULTS.largeFileOptimizations,description:o.localize("largeFileOptimizations","Special handling for large files to disable certain memory intensive features.")},"editor.wordBasedSuggestions":{enum:["off","currentDocument","matchingDocuments","allDocuments"],default:"matchingDocuments",enumDescriptions:[o.localize("wordBasedSuggestions.off","Turn off Word Based Suggestions."),o.localize("wordBasedSuggestions.currentDocument","Only suggest words from the active document."),o.localize("wordBasedSuggestions.matchingDocuments","Suggest words from all open documents of the same language."),o.localize("wordBasedSuggestions.allDocuments","Suggest words from all open documents.")],description:o.localize("wordBasedSuggestions","Controls whether completions should be computed based on words in the document and from which documents they are computed.")},"editor.semanticHighlighting.enabled":{enum:[!0,!1,"configuredByTheme"],enumDescriptions:[o.localize("semanticHighlighting.true","Semantic highlighting enabled for all color themes."),o.localize("semanticHighlighting.false","Semantic highlighting disabled for all color themes."),o.localize("semanticHighlighting.configuredByTheme","Semantic highlighting is configured by the current color theme's `semanticHighlighting` setting.")],default:"configuredByTheme",description:o.localize("semanticHighlighting.enabled","Controls whether the semanticHighlighting is shown for the languages that support it.")},"editor.stablePeek":{type:"boolean",default:!1,markdownDescription:o.localize("stablePeek","Keep peek editors open even when double-clicking their content or when hitting `Escape`.")},"editor.maxTokenizationLineLength":{type:"integer",default:2e4,description:o.localize("maxTokenizationLineLength","Lines above this length will not be tokenized for performance reasons")},"editor.experimental.asyncTokenization":{type:"boolean",default:!0,description:o.localize("editor.experimental.asyncTokenization","Controls whether the tokenization should happen asynchronously on a web worker."),tags:["experimental"]},"editor.experimental.asyncTokenizationLogging":{type:"boolean",default:!1,description:o.localize("editor.experimental.asyncTokenizationLogging","Controls whether async tokenization should be logged. For debugging only.")},"editor.experimental.asyncTokenizationVerification":{type:"boolean",default:!1,description:o.localize("editor.experimental.asyncTokenizationVerification","Controls whether async tokenization should be verified against legacy background tokenization. Might slow down tokenization. For debugging only."),tags:["experimental"]},"editor.experimental.treeSitterTelemetry":{type:"boolean",default:!1,markdownDescription:o.localize("editor.experimental.treeSitterTelemetry","Controls whether tree sitter parsing should be turned on and telemetry collected. Setting `editor.experimental.preferTreeSitter` for specific languages will take precedence."),tags:["experimental"]},"editor.language.brackets":{type:["array","null"],default:null,description:o.localize("schema.brackets","Defines the bracket symbols that increase or decrease the indentation."),items:{type:"array",items:[{type:"string",description:o.localize("schema.openBracket","The opening bracket character or string sequence.")},{type:"string",description:o.localize("schema.closeBracket","The closing bracket character or string sequence.")}]}},"editor.language.colorizedBracketPairs":{type:["array","null"],default:null,description:o.localize("schema.colorizedBracketPairs","Defines the bracket pairs that are colorized by their nesting level if bracket pair colorization is enabled."),items:{type:"array",items:[{type:"string",description:o.localize("schema.openBracket","The opening bracket character or string sequence.")},{type:"string",description:o.localize("schema.closeBracket","The closing bracket character or string sequence.")}]}},"diffEditor.maxComputationTime":{type:"number",default:e.diffEditorDefaultOptions.maxComputationTime,description:o.localize("maxComputationTime","Timeout in milliseconds after which diff computation is cancelled. Use 0 for no timeout.")},"diffEditor.maxFileSize":{type:"number",default:e.diffEditorDefaultOptions.maxFileSize,description:o.localize("maxFileSize","Maximum file size in MB for which to compute diffs. Use 0 for no limit.")},"diffEditor.renderSideBySide":{type:"boolean",default:e.diffEditorDefaultOptions.renderSideBySide,description:o.localize("sideBySide","Controls whether the diff editor shows the diff side by side or inline.")},"diffEditor.renderSideBySideInlineBreakpoint":{type:"number",default:e.diffEditorDefaultOptions.renderSideBySideInlineBreakpoint,description:o.localize("renderSideBySideInlineBreakpoint","If the diff editor width is smaller than this value, the inline view is used.")},"diffEditor.useInlineViewWhenSpaceIsLimited":{type:"boolean",default:e.diffEditorDefaultOptions.useInlineViewWhenSpaceIsLimited,description:o.localize("useInlineViewWhenSpaceIsLimited","If enabled and the editor width is too small, the inline view is used.")},"diffEditor.renderMarginRevertIcon":{type:"boolean",default:e.diffEditorDefaultOptions.renderMarginRevertIcon,description:o.localize("renderMarginRevertIcon","When enabled, the diff editor shows arrows in its glyph margin to revert changes.")},"diffEditor.renderGutterMenu":{type:"boolean",default:e.diffEditorDefaultOptions.renderGutterMenu,description:o.localize("renderGutterMenu","When enabled, the diff editor shows a special gutter for revert and stage actions.")},"diffEditor.ignoreTrimWhitespace":{type:"boolean",default:e.diffEditorDefaultOptions.ignoreTrimWhitespace,description:o.localize("ignoreTrimWhitespace","When enabled, the diff editor ignores changes in leading or trailing whitespace.")},"diffEditor.renderIndicators":{type:"boolean",default:e.diffEditorDefaultOptions.renderIndicators,description:o.localize("renderIndicators","Controls whether the diff editor shows +/- indicators for added/removed changes.")},"diffEditor.codeLens":{type:"boolean",default:e.diffEditorDefaultOptions.diffCodeLens,description:o.localize("codeLens","Controls whether the editor shows CodeLens.")},"diffEditor.wordWrap":{type:"string",enum:["off","on","inherit"],default:e.diffEditorDefaultOptions.diffWordWrap,markdownEnumDescriptions:[o.localize("wordWrap.off","Lines will never wrap."),o.localize("wordWrap.on","Lines will wrap at the viewport width."),o.localize("wordWrap.inherit","Lines will wrap according to the {0} setting.","`#editor.wordWrap#`")]},"diffEditor.diffAlgorithm":{type:"string",enum:["legacy","advanced"],default:e.diffEditorDefaultOptions.diffAlgorithm,markdownEnumDescriptions:[o.localize("diffAlgorithm.legacy","Uses the legacy diffing algorithm."),o.localize("diffAlgorithm.advanced","Uses the advanced diffing algorithm.")],tags:["experimental"]},"diffEditor.hideUnchangedRegions.enabled":{type:"boolean",default:e.diffEditorDefaultOptions.hideUnchangedRegions.enabled,markdownDescription:o.localize("hideUnchangedRegions.enabled","Controls whether the diff editor shows unchanged regions.")},"diffEditor.hideUnchangedRegions.revealLineCount":{type:"integer",default:e.diffEditorDefaultOptions.hideUnchangedRegions.revealLineCount,markdownDescription:o.localize("hideUnchangedRegions.revealLineCount","Controls how many lines are used for unchanged regions."),minimum:1},"diffEditor.hideUnchangedRegions.minimumLineCount":{type:"integer",default:e.diffEditorDefaultOptions.hideUnchangedRegions.minimumLineCount,markdownDescription:o.localize("hideUnchangedRegions.minimumLineCount","Controls how many lines are used as a minimum for unchanged regions."),minimum:1},"diffEditor.hideUnchangedRegions.contextLineCount":{type:"integer",default:e.diffEditorDefaultOptions.hideUnchangedRegions.contextLineCount,markdownDescription:o.localize("hideUnchangedRegions.contextLineCount","Controls how many lines are used as context when comparing unchanged regions."),minimum:1},"diffEditor.experimental.showMoves":{type:"boolean",default:e.diffEditorDefaultOptions.experimental.showMoves,markdownDescription:o.localize("showMoves","Controls whether the diff editor should show detected code moves.")},"diffEditor.experimental.showEmptyDecorations":{type:"boolean",default:e.diffEditorDefaultOptions.experimental.showEmptyDecorations,description:o.localize("showEmptyDecorations","Controls whether the diff editor shows empty decorations to see where characters got inserted or deleted.")},"diffEditor.experimental.useTrueInlineView":{type:"boolean",default:e.diffEditorDefaultOptions.experimental.useTrueInlineView,description:o.localize("useTrueInlineView","If enabled and the editor uses the inline view, word changes are rendered inline.")}}};for(const e of i.editorOptionsRegistry){const i=e.schema;if(void 0!==i)if(void 0!==(s=i).type||void 0!==s.anyOf)d.properties[`editor.${e.name}`]=i;else for(const e in i)Object.hasOwnProperty.call(i,e)&&(d.properties[e]=i[e])}var s;let l=null;function c(){return null===l&&(l=Object.create(null),Object.keys(d.properties).forEach((e=>{l[e]=!0}))),l}r.Registry.as(n.Extensions.Configuration).registerConfiguration(d),exports.editorConfigurationBaseNode=a,exports.isDiffEditorConfigurationKey=function(e){return c()[`diffEditor.${e}`]||!1},exports.isEditorConfigurationKey=function(e){return c()[`editor.${e}`]||!1};
//# sourceMappingURL=editorConfigurationSchema.js.map
