"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var t=require("../../../base/common/errors.js"),e=require("../../../base/common/strings.js"),s=require("./cursorCollection.js"),o=require("../cursorCommon.js"),i=require("./cursorContext.js"),n=require("./cursorDeleteOperations.js"),r=require("./cursorTypeOperations.js"),l=require("./cursorTypeEditOperations.js"),a=require("../core/range.js"),c=require("../core/selection.js"),u=require("../textModelEvents.js"),h=require("../viewEvents.js"),d=require("../../../base/common/lifecycle.js"),m=require("../viewModelEventDispatcher.js");class g extends d.Disposable{constructor(t,e,o,n){super(),this._model=t,this._knownModelVersionId=this._model.getVersionId(),this._viewModel=e,this._coordinatesConverter=o,this.context=new i.CursorContext(this._model,this._viewModel,this._coordinatesConverter,n),this._cursors=new s.CursorCollection(this.context),this._hasFocus=!1,this._isHandling=!1,this._compositionState=null,this._columnSelectData=null,this._autoClosedActions=[],this._prevEditOperationType=0}dispose(){this._cursors.dispose(),this._autoClosedActions=d.dispose(this._autoClosedActions),super.dispose()}updateConfiguration(t){this.context=new i.CursorContext(this._model,this._viewModel,this._coordinatesConverter,t),this._cursors.updateContext(this.context)}onLineMappingChanged(t){this._knownModelVersionId===this._model.getVersionId()&&this.setStates(t,"viewModel",0,this.getCursorStates())}setHasFocus(t){this._hasFocus=t}_validateAutoClosedActions(){if(this._autoClosedActions.length>0){const t=this._cursors.getSelections();for(let e=0;e<this._autoClosedActions.length;e++){const s=this._autoClosedActions[e];s.isValid(t)||(s.dispose(),this._autoClosedActions.splice(e,1),e--)}}}getPrimaryCursorState(){return this._cursors.getPrimaryCursor()}getLastAddedCursorIndex(){return this._cursors.getLastAddedCursorIndex()}getCursorStates(){return this._cursors.getAll()}setStates(t,e,s,o){let i=!1;const n=this.context.cursorConfig.multiCursorLimit;null!==o&&o.length>n&&(o=o.slice(0,n),i=!0);const r=p.from(this._model,this);return this._cursors.setStates(o),this._cursors.normalize(),this._columnSelectData=null,this._validateAutoClosedActions(),this._emitStateChangedIfNecessary(t,e,s,r,i)}setCursorColumnSelectData(t){this._columnSelectData=t}revealAll(t,e,s,o,i,n){const r=this._cursors.getViewPositions();let l=null,c=null;r.length>1?c=this._cursors.getViewSelections():l=a.Range.fromPositions(r[0],r[0]),t.emitViewEvent(new h.ViewRevealRangeRequestEvent(e,s,l,c,o,i,n))}revealPrimary(t,e,s,o,i,n){const r=[this._cursors.getPrimaryCursor().viewState.selection];t.emitViewEvent(new h.ViewRevealRangeRequestEvent(e,s,null,r,o,i,n))}saveState(){const t=[],e=this._cursors.getSelections();for(let s=0,o=e.length;s<o;s++){const o=e[s];t.push({inSelectionMode:!o.isEmpty(),selectionStart:{lineNumber:o.selectionStartLineNumber,column:o.selectionStartColumn},position:{lineNumber:o.positionLineNumber,column:o.positionColumn}})}return t}restoreState(t,e){const s=[];for(let t=0,o=e.length;t<o;t++){const o=e[t];let i=1,n=1;o.position&&o.position.lineNumber&&(i=o.position.lineNumber),o.position&&o.position.column&&(n=o.position.column);let r=i,l=n;o.selectionStart&&o.selectionStart.lineNumber&&(r=o.selectionStart.lineNumber),o.selectionStart&&o.selectionStart.column&&(l=o.selectionStart.column),s.push({selectionStartLineNumber:r,selectionStartColumn:l,positionLineNumber:i,positionColumn:n})}this.setStates(t,"restoreState",0,o.CursorState.fromModelSelections(s)),this.revealAll(t,"restoreState",!1,0,!0,1)}onModelContentChanged(t,e){if(e instanceof u.ModelInjectedTextChangedEvent){if(this._isHandling)return;this._isHandling=!0;try{this.setStates(t,"modelChange",0,this.getCursorStates())}finally{this._isHandling=!1}}else{const i=e.rawContentChangedEvent;if(this._knownModelVersionId=i.versionId,this._isHandling)return;const n=i.containsEvent(1);if(this._prevEditOperationType=0,n)this._cursors.dispose(),this._cursors=new s.CursorCollection(this.context),this._validateAutoClosedActions(),this._emitStateChangedIfNecessary(t,"model",1,null,!1);else if(this._hasFocus&&i.resultingSelection&&i.resultingSelection.length>0){const e=o.CursorState.fromModelSelections(i.resultingSelection);this.setStates(t,"modelChange",i.isUndoing?5:i.isRedoing?6:2,e)&&this.revealAll(t,"modelChange",!1,0,!0,0)}else{const e=this._cursors.readSelectionFromMarkers();this.setStates(t,"modelChange",2,o.CursorState.fromModelSelections(e))}}}getSelection(){return this._cursors.getPrimaryCursor().modelState.selection}getTopMostViewPosition(){return this._cursors.getTopMostViewPosition()}getBottomMostViewPosition(){return this._cursors.getBottomMostViewPosition()}getCursorColumnSelectData(){if(this._columnSelectData)return this._columnSelectData;const t=this._cursors.getPrimaryCursor(),e=t.viewState.selectionStart.getStartPosition(),s=t.viewState.position;return{isReal:!1,fromViewLineNumber:e.lineNumber,fromViewVisualColumn:this.context.cursorConfig.visibleColumnFromColumn(this._viewModel,e),toViewLineNumber:s.lineNumber,toViewVisualColumn:this.context.cursorConfig.visibleColumnFromColumn(this._viewModel,s)}}getSelections(){return this._cursors.getSelections()}setSelections(t,e,s,i){this.setStates(t,e,i,o.CursorState.fromModelSelections(s))}getPrevEditOperationType(){return this._prevEditOperationType}setPrevEditOperationType(t){this._prevEditOperationType=t}_pushAutoClosedAction(t,e){const s=[],o=[];for(let i=0,n=t.length;i<n;i++)s.push({range:t[i],options:{description:"auto-closed-character",inlineClassName:"auto-closed-character",stickiness:1}}),o.push({range:e[i],options:{description:"auto-closed-enclosing",stickiness:1}});const i=this._model.deltaDecorations([],s),n=this._model.deltaDecorations([],o);this._autoClosedActions.push(new _(this._model,i,n))}_executeEditOperation(t){if(!t)return;t.shouldPushStackElementBefore&&this._model.pushStackElement();const e=C.executeCommands(this._model,this._cursors.getSelections(),t.commands);if(e){this._interpretCommandResult(e);const s=[],o=[];for(let e=0;e<t.commands.length;e++){const i=t.commands[e];i instanceof l.BaseTypeWithAutoClosingCommand&&i.enclosingRange&&i.closeCharacterRange&&(s.push(i.closeCharacterRange),o.push(i.enclosingRange))}s.length>0&&this._pushAutoClosedAction(s,o),this._prevEditOperationType=t.type}t.shouldPushStackElementAfter&&this._model.pushStackElement()}_interpretCommandResult(t){t&&0!==t.length||(t=this._cursors.readSelectionFromMarkers()),this._columnSelectData=null,this._cursors.setSelections(t),this._cursors.normalize()}_emitStateChangedIfNecessary(t,e,s,o,i){const n=p.from(this._model,this);if(n.equals(o))return!1;const r=this._cursors.getSelections(),l=this._cursors.getViewSelections();if(t.emitViewEvent(new h.ViewCursorStateChangedEvent(l,r,s)),!o||o.cursorState.length!==n.cursorState.length||n.cursorState.some(((t,e)=>!t.modelState.equals(o.cursorState[e].modelState)))){const l=o?o.cursorState.map((t=>t.modelState.selection)):null,a=o?o.modelVersionId:0;t.emitOutgoingEvent(new m.CursorStateChangedEvent(l,r,a,n.modelVersionId,e||"keyboard",s,i))}return!0}_findAutoClosingPairs(t){if(!t.length)return null;const e=[];for(let s=0,o=t.length;s<o;s++){const o=t[s];if(!o.text||o.text.indexOf("\n")>=0)return null;const i=o.text.match(/([)\]}>'"`])([^)\]}>'"`]*)$/);if(!i)return null;const n=i[1],r=this.context.cursorConfig.autoClosingPairs.autoClosingPairsCloseSingleChar.get(n);if(!r||1!==r.length)return null;const l=r[0].open,a=o.text.length-i[2].length-1,c=o.text.lastIndexOf(l,a-1);if(-1===c)return null;e.push([c,a])}return e}executeEdits(t,e,s,o){let i=null;"snippet"===e&&(i=this._findAutoClosingPairs(s)),i&&(s[0]._isTracked=!0);const n=[],r=[],l=this._model.pushEditOperations(this.getSelections(),s,(t=>{if(i)for(let e=0,s=i.length;e<s;e++){const[s,o]=i[e],l=t[e],c=l.range.startLineNumber,u=l.range.startColumn-1+s,h=l.range.startColumn-1+o;n.push(new a.Range(c,h+1,c,h+2)),r.push(new a.Range(c,u+1,c,h+2))}const e=o(t);return e&&(this._isHandling=!0),e}));l&&(this._isHandling=!1,this.setSelections(t,e,l,0)),n.length>0&&this._pushAutoClosedAction(n,r)}_executeEdit(e,s,o,i=0){if(this.context.cursorConfig.readOnly)return;const n=p.from(this._model,this);this._cursors.stopTrackingSelections(),this._isHandling=!0;try{this._cursors.ensureValidState(),e()}catch(e){t.onUnexpectedError(e)}this._isHandling=!1,this._cursors.startTrackingSelections(),this._validateAutoClosedActions(),this._emitStateChangedIfNecessary(s,o,i,n,!1)&&this.revealAll(s,o,!1,0,!0,0)}getAutoClosedCharacters(){return _.getAllAutoClosedCharacters(this._autoClosedActions)}startComposition(t){this._compositionState=new f(this._model,this.getSelections())}endComposition(t,e){const s=this._compositionState?this._compositionState.deduceOutcome(this._model,this.getSelections()):null;this._compositionState=null,this._executeEdit((()=>{"keyboard"===e&&this._executeEditOperation(r.TypeOperations.compositionEndWithInterceptors(this._prevEditOperationType,this.context.cursorConfig,this._model,s,this.getSelections(),this.getAutoClosedCharacters()))}),t,e)}type(t,s,o){this._executeEdit((()=>{if("keyboard"===o){const t=s.length;let o=0;for(;o<t;){const t=e.nextCharLength(s,o),i=s.substr(o,t);this._executeEditOperation(r.TypeOperations.typeWithInterceptors(!!this._compositionState,this._prevEditOperationType,this.context.cursorConfig,this._model,this.getSelections(),this.getAutoClosedCharacters(),i)),o+=t}}else this._executeEditOperation(r.TypeOperations.typeWithoutInterceptors(this._prevEditOperationType,this.context.cursorConfig,this._model,this.getSelections(),s))}),t,o)}compositionType(t,e,s,o,i,n){if(0!==e.length||0!==s||0!==o)this._executeEdit((()=>{this._executeEditOperation(r.TypeOperations.compositionType(this._prevEditOperationType,this.context.cursorConfig,this._model,this.getSelections(),e,s,o,i))}),t,n);else if(0!==i){const e=this.getSelections().map((t=>{const e=t.getPosition();return new c.Selection(e.lineNumber,e.column+i,e.lineNumber,e.column+i)}));this.setSelections(t,n,e,0)}}paste(t,e,s,o,i){this._executeEdit((()=>{this._executeEditOperation(r.TypeOperations.paste(this.context.cursorConfig,this._model,this.getSelections(),e,s,o||[]))}),t,i,4)}cut(t,e){this._executeEdit((()=>{this._executeEditOperation(n.DeleteOperations.cut(this.context.cursorConfig,this._model,this.getSelections()))}),t,e)}executeCommand(t,e,s){this._executeEdit((()=>{this._cursors.killSecondaryCursors(),this._executeEditOperation(new o.EditOperationResult(0,[e],{shouldPushStackElementBefore:!1,shouldPushStackElementAfter:!1}))}),t,s)}executeCommands(t,e,s){this._executeEdit((()=>{this._executeEditOperation(new o.EditOperationResult(0,e,{shouldPushStackElementBefore:!1,shouldPushStackElementAfter:!1}))}),t,s)}}class p{static from(t,e){return new p(t.getVersionId(),e.getCursorStates())}constructor(t,e){this.modelVersionId=t,this.cursorState=e}equals(t){if(!t)return!1;if(this.modelVersionId!==t.modelVersionId)return!1;if(this.cursorState.length!==t.cursorState.length)return!1;for(let e=0,s=this.cursorState.length;e<s;e++)if(!this.cursorState[e].equals(t.cursorState[e]))return!1;return!0}}class _{static getAllAutoClosedCharacters(t){let e=[];for(const s of t)e=e.concat(s.getAutoClosedCharactersRanges());return e}constructor(t,e,s){this._model=t,this._autoClosedCharactersDecorations=e,this._autoClosedEnclosingDecorations=s}dispose(){this._autoClosedCharactersDecorations=this._model.deltaDecorations(this._autoClosedCharactersDecorations,[]),this._autoClosedEnclosingDecorations=this._model.deltaDecorations(this._autoClosedEnclosingDecorations,[])}getAutoClosedCharactersRanges(){const t=[];for(let e=0;e<this._autoClosedCharactersDecorations.length;e++){const s=this._model.getDecorationRange(this._autoClosedCharactersDecorations[e]);s&&t.push(s)}return t}isValid(t){const e=[];for(let t=0;t<this._autoClosedEnclosingDecorations.length;t++){const s=this._model.getDecorationRange(this._autoClosedEnclosingDecorations[t]);if(s&&(e.push(s),s.startLineNumber!==s.endLineNumber))return!1}e.sort(a.Range.compareRangesUsingStarts),t.sort(a.Range.compareRangesUsingStarts);for(let s=0;s<t.length;s++){if(s>=e.length)return!1;if(!e[s].strictContainsRange(t[s]))return!1}return!0}}class C{static executeCommands(t,e,s){const o={model:t,selectionsBefore:e,trackedRanges:[],trackedRangesDirection:[]},i=this._innerExecuteCommands(o,s);for(let t=0,e=o.trackedRanges.length;t<e;t++)o.model._setTrackedRange(o.trackedRanges[t],null,0);return i}static _innerExecuteCommands(t,e){if(this._arrayIsEmpty(e))return null;const s=this._getEditOperations(t,e);if(0===s.operations.length)return null;const o=s.operations,i=this._getLoserCursorMap(o);if(i.hasOwnProperty("0"))return console.warn("Ignoring commands"),null;const n=[];for(let t=0,e=o.length;t<e;t++)i.hasOwnProperty(o[t].identifier.major.toString())||n.push(o[t]);s.hadTrackedEditOperation&&n.length>0&&(n[0]._isTracked=!0);let r=t.model.pushEditOperations(t.selectionsBefore,n,(s=>{const o=[];for(let e=0;e<t.selectionsBefore.length;e++)o[e]=[];for(const t of s)t.identifier&&o[t.identifier.major].push(t);const i=(t,e)=>t.identifier.minor-e.identifier.minor,n=[];for(let s=0;s<t.selectionsBefore.length;s++)o[s].length>0?(o[s].sort(i),n[s]=e[s].computeCursorState(t.model,{getInverseEditOperations:()=>o[s],getTrackedSelection:e=>{const s=parseInt(e,10),o=t.model._getTrackedRange(t.trackedRanges[s]);return 0===t.trackedRangesDirection[s]?new c.Selection(o.startLineNumber,o.startColumn,o.endLineNumber,o.endColumn):new c.Selection(o.endLineNumber,o.endColumn,o.startLineNumber,o.startColumn)}})):n[s]=t.selectionsBefore[s];return n}));r||(r=t.selectionsBefore);const l=[];for(const t in i)i.hasOwnProperty(t)&&l.push(parseInt(t,10));l.sort(((t,e)=>e-t));for(const t of l)r.splice(t,1);return r}static _arrayIsEmpty(t){for(let e=0,s=t.length;e<s;e++)if(t[e])return!1;return!0}static _getEditOperations(t,e){let s=[],o=!1;for(let i=0,n=e.length;i<n;i++){const n=e[i];if(n){const e=this._getEditOperationsFromCommand(t,i,n);s=s.concat(e.operations),o=o||e.hadTrackedEditOperation}}return{operations:s,hadTrackedEditOperation:o}}static _getEditOperationsFromCommand(e,s,o){const i=[];let n=0;const r=(t,e,r=!1)=>{a.Range.isEmpty(t)&&""===e||i.push({identifier:{major:s,minor:n++},range:t,text:e,forceMoveMarkers:r,isAutoWhitespaceEdit:o.insertsAutoWhitespace})};let l=!1;const u={addEditOperation:r,addTrackedEditOperation:(t,e,s)=>{l=!0,r(t,e,s)},trackSelection:(t,s)=>{const o=c.Selection.liftSelection(t);let i;if(o.isEmpty())if("boolean"==typeof s)i=s?2:3;else{const t=e.model.getLineMaxColumn(o.startLineNumber);i=o.startColumn===t?2:3}else i=1;const n=e.trackedRanges.length,r=e.model._setTrackedRange(null,o,i);return e.trackedRanges[n]=r,e.trackedRangesDirection[n]=o.getDirection(),n.toString()}};try{o.getEditOperations(e.model,u)}catch(e){return t.onUnexpectedError(e),{operations:[],hadTrackedEditOperation:!1}}return{operations:i,hadTrackedEditOperation:l}}static _getLoserCursorMap(t){(t=t.slice(0)).sort(((t,e)=>-a.Range.compareRangesUsingEnds(t.range,e.range)));const e={};for(let s=1;s<t.length;s++){const o=t[s-1],i=t[s];if(a.Range.getStartPosition(o.range).isBefore(a.Range.getEndPosition(i.range))){let n;n=o.identifier.major>i.identifier.major?o.identifier.major:i.identifier.major,e[n.toString()]=!0;for(let e=0;e<t.length;e++)t[e].identifier.major===n&&(t.splice(e,1),e<s&&s--,e--);s>0&&s--}}return e}}class S{constructor(t,e,s){this.text=t,this.startSelection=e,this.endSelection=s}}class f{static _capture(t,e){const s=[];for(const o of e){if(o.startLineNumber!==o.endLineNumber)return null;s.push(new S(t.getLineContent(o.startLineNumber),o.startColumn-1,o.endColumn-1))}return s}constructor(t,e){this._original=f._capture(t,e)}deduceOutcome(t,e){if(!this._original)return null;const s=f._capture(t,e);if(!s)return null;if(this._original.length!==s.length)return null;const o=[];for(let t=0,e=this._original.length;t<e;t++)o.push(f._deduceOutcome(this._original[t],s[t]));return o}static _deduceOutcome(t,s){const o=Math.min(t.startSelection,s.startSelection,e.commonPrefixLength(t.text,s.text)),i=Math.min(t.text.length-t.endSelection,s.text.length-s.endSelection,e.commonSuffixLength(t.text,s.text)),n=t.text.substring(o,t.text.length-i),l=s.text.substring(o,s.text.length-i);return new r.CompositionOutcome(n,t.startSelection-o,t.endSelection-o,l,s.startSelection-o,s.endSelection-o)}}exports.CommandExecutor=C,exports.CursorsController=g;
//# sourceMappingURL=cursor.js.map
