"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var e=require("../../../base/common/event.js"),t=require("../../../base/common/lifecycle.js"),r=require("../../../base/common/strings.js"),i=require("../core/wordHelper.js"),n=require("./languageConfiguration.js"),o=require("./supports/characterPair.js"),s=require("./supports/electricCharacter.js"),a=require("./supports/indentRules.js"),u=require("./supports/onEnter.js"),g=require("./supports/richEditBrackets.js"),c=require("../../../platform/instantiation/common/instantiation.js"),l=require("../../../platform/configuration/common/configuration.js"),h=require("./language.js"),d=require("../../../platform/instantiation/common/extensions.js"),f=require("./modesRegistry.js"),p=require("./supports/languageBracketsConfiguration.js"),C=self&&self.__decorate||function(e,t,r,i){var n,o=arguments.length,s=o<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,r):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)s=Reflect.decorate(e,t,r,i);else for(var a=e.length-1;a>=0;a--)(n=e[a])&&(s=(o<3?n(s):o>3?n(t,r,s):n(t,r))||s);return o>3&&s&&Object.defineProperty(t,r,s),s},_=self&&self.__param||function(e,t){return function(r,i){t(r,i,e)}};class m{constructor(e){this.languageId=e}affects(e){return!this.languageId||this.languageId===e}}const v=c.createDecorator("languageConfigurationService");exports.LanguageConfigurationService=class extends t.Disposable{constructor(t,r){super(),this.configurationService=t,this.languageService=r,this._registry=this._register(new R),this.onDidChangeEmitter=this._register(new e.Emitter),this.onDidChange=this.onDidChangeEmitter.event,this.configurations=new Map;const i=new Set(Object.values(k));this._register(this.configurationService.onDidChangeConfiguration((e=>{const t=e.change.keys.some((e=>i.has(e))),r=e.change.overrides.filter((([e,t])=>t.some((e=>i.has(e))))).map((([e])=>e));if(t)this.configurations.clear(),this.onDidChangeEmitter.fire(new m(void 0));else for(const e of r)this.languageService.isRegisteredLanguageId(e)&&(this.configurations.delete(e),this.onDidChangeEmitter.fire(new m(e)))}))),this._register(this._registry.onDidChange((e=>{this.configurations.delete(e.languageId),this.onDidChangeEmitter.fire(new m(e.languageId))})))}register(e,t,r){return this._registry.register(e,t,r)}getLanguageConfiguration(e){let t=this.configurations.get(e);return t||(t=function(e,t,r,i){let n=t.getLanguageConfiguration(e);if(!n){if(!i.isRegisteredLanguageId(e))return new E(e,{});n=new E(e,{})}const o=function(e,t){const r=t.getValue(k.brackets,{overrideIdentifier:e}),i=t.getValue(k.colorizedBracketPairs,{overrideIdentifier:e});return{brackets:P(r),colorizedBracketPairs:P(i)}}(n.languageId,r),s=b([n.underlyingConfig,o]);return new E(n.languageId,s)}(e,this._registry,this.configurationService,this.languageService),this.configurations.set(e,t)),t}},exports.LanguageConfigurationService=C([_(0,l.IConfigurationService),_(1,h.ILanguageService)],exports.LanguageConfigurationService);const k={brackets:"editor.language.brackets",colorizedBracketPairs:"editor.language.colorizedBracketPairs"};function P(e){if(Array.isArray(e))return e.map((e=>{if(Array.isArray(e)&&2===e.length)return[e[0],e[1]]})).filter((e=>!!e))}class y{constructor(e){this.languageId=e,this._resolved=null,this._entries=[],this._order=0,this._resolved=null}register(e,r){const i=new S(e,r,++this._order);return this._entries.push(i),this._resolved=null,t.toDisposable((()=>{for(let e=0;e<this._entries.length;e++)if(this._entries[e]===i){this._entries.splice(e,1),this._resolved=null;break}}))}getResolvedConfiguration(){if(!this._resolved){const e=this._resolve();e&&(this._resolved=new E(this.languageId,e))}return this._resolved}_resolve(){return 0===this._entries.length?null:(this._entries.sort(S.cmp),b(this._entries.map((e=>e.configuration))))}}function b(e){let t={comments:void 0,brackets:void 0,wordPattern:void 0,indentationRules:void 0,onEnterRules:void 0,autoClosingPairs:void 0,surroundingPairs:void 0,autoCloseBefore:void 0,folding:void 0,colorizedBracketPairs:void 0,__electricCharacterSupport:void 0};for(const r of e)t={comments:r.comments||t.comments,brackets:r.brackets||t.brackets,wordPattern:r.wordPattern||t.wordPattern,indentationRules:r.indentationRules||t.indentationRules,onEnterRules:r.onEnterRules||t.onEnterRules,autoClosingPairs:r.autoClosingPairs||t.autoClosingPairs,surroundingPairs:r.surroundingPairs||t.surroundingPairs,autoCloseBefore:r.autoCloseBefore||t.autoCloseBefore,folding:r.folding||t.folding,colorizedBracketPairs:r.colorizedBracketPairs||t.colorizedBracketPairs,__electricCharacterSupport:r.__electricCharacterSupport||t.__electricCharacterSupport};return t}class S{constructor(e,t,r){this.configuration=e,this.priority=t,this.order=r}static cmp(e,t){return e.priority===t.priority?e.order-t.order:e.priority-t.priority}}class w{constructor(e){this.languageId=e}}class R extends t.Disposable{constructor(){super(),this._entries=new Map,this._onDidChange=this._register(new e.Emitter),this.onDidChange=this._onDidChange.event,this._register(this.register(f.PLAINTEXT_LANGUAGE_ID,{brackets:[["(",")"],["[","]"],["{","}"]],surroundingPairs:[{open:"{",close:"}"},{open:"[",close:"]"},{open:"(",close:")"},{open:"<",close:">"},{open:'"',close:'"'},{open:"'",close:"'"},{open:"`",close:"`"}],colorizedBracketPairs:[],folding:{offSide:!0}},0))}register(e,r,i=0){let n=this._entries.get(e);n||(n=new y(e),this._entries.set(e,n));const o=n.register(r,i);return this._onDidChange.fire(new w(e)),t.toDisposable((()=>{o.dispose(),this._onDidChange.fire(new w(e))}))}getLanguageConfiguration(e){const t=this._entries.get(e);return t?.getResolvedConfiguration()||null}}class E{constructor(e,t){this.languageId=e,this.underlyingConfig=t,this._brackets=null,this._electricCharacter=null,this._onEnterSupport=this.underlyingConfig.brackets||this.underlyingConfig.indentationRules||this.underlyingConfig.onEnterRules?new u.OnEnterSupport(this.underlyingConfig):null,this.comments=E._handleComments(this.underlyingConfig),this.characterPair=new o.CharacterPairSupport(this.underlyingConfig),this.wordDefinition=this.underlyingConfig.wordPattern||i.DEFAULT_WORD_REGEXP,this.indentationRules=this.underlyingConfig.indentationRules,this.underlyingConfig.indentationRules?this.indentRulesSupport=new a.IndentRulesSupport(this.underlyingConfig.indentationRules):this.indentRulesSupport=null,this.foldingRules=this.underlyingConfig.folding||{},this.bracketsNew=new p.LanguageBracketsConfiguration(e,this.underlyingConfig)}getWordDefinition(){return i.ensureValidWordDefinition(this.wordDefinition)}get brackets(){return!this._brackets&&this.underlyingConfig.brackets&&(this._brackets=new g.RichEditBrackets(this.languageId,this.underlyingConfig.brackets)),this._brackets}get electricCharacter(){return this._electricCharacter||(this._electricCharacter=new s.BracketElectricCharacterSupport(this.brackets)),this._electricCharacter}onEnter(e,t,r,i){return this._onEnterSupport?this._onEnterSupport.onEnter(e,t,r,i):null}getAutoClosingPairs(){return new n.AutoClosingPairs(this.characterPair.getAutoClosingPairs())}getAutoCloseBeforeSet(e){return this.characterPair.getAutoCloseBeforeSet(e)}getSurroundingPairs(){return this.characterPair.getSurroundingPairs()}static _handleComments(e){const t=e.comments;if(!t)return null;const r={};if(t.lineComment&&(r.lineCommentToken=t.lineComment),t.blockComment){const[e,i]=t.blockComment;r.blockCommentStartToken=e,r.blockCommentEndToken=i}return r}}d.registerSingleton(v,exports.LanguageConfigurationService,1),exports.ILanguageConfigurationService=v,exports.LanguageConfigurationChangeEvent=w,exports.LanguageConfigurationRegistry=R,exports.LanguageConfigurationServiceChangeEvent=m,exports.ResolvedLanguageConfiguration=E,exports.getIndentationAtPosition=function(e,t,i){const n=e.getLineContent(t);let o=r.getLeadingWhitespace(n);return o.length>i-1&&(o=o.substring(0,i-1)),o};
//# sourceMappingURL=languageConfigurationRegistry.js.map
