"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var e=require("../../../../base/common/arrays.js"),t=require("../../../../base/common/event.js"),n=require("../../../../base/common/lifecycle.js"),a=require("../../core/range.js"),r=require("../../languages/supports.js"),i=require("../../languages/supports/richEditBrackets.js"),s=require("./bracketPairsTree/bracketPairsTree.js");class o extends n.Disposable{get canBuildAST(){return this.textModel.getValueLength()<=5e6}constructor(e,a){super(),this.textModel=e,this.languageConfigurationService=a,this.bracketPairsTree=this._register(new n.MutableDisposable),this.onDidChangeEmitter=new t.Emitter,this.onDidChange=this.onDidChangeEmitter.event,this.bracketsRequested=!1}handleLanguageConfigurationServiceChange(e){e.languageId&&!this.bracketPairsTree.value?.object.didLanguageChange(e.languageId)||(this.bracketPairsTree.clear(),this.updateBracketPairsTree())}handleDidChangeOptions(e){this.bracketPairsTree.clear(),this.updateBracketPairsTree()}handleDidChangeLanguage(e){this.bracketPairsTree.clear(),this.updateBracketPairsTree()}handleDidChangeContent(e){this.bracketPairsTree.value?.object.handleContentChanged(e)}handleDidChangeBackgroundTokenizationState(){this.bracketPairsTree.value?.object.handleDidChangeBackgroundTokenizationState()}handleDidChangeTokens(e){this.bracketPairsTree.value?.object.handleDidChangeTokens(e)}updateBracketPairsTree(){if(this.bracketsRequested&&this.canBuildAST){if(!this.bracketPairsTree.value){const a=new n.DisposableStore;this.bracketPairsTree.value=(e=a.add(new s.BracketPairsTree(this.textModel,(e=>this.languageConfigurationService.getLanguageConfiguration(e)))),t=a,{object:e,dispose:()=>t?.dispose()}),a.add(this.bracketPairsTree.value.object.onDidChange((e=>this.onDidChangeEmitter.fire(e)))),this.onDidChangeEmitter.fire()}}else this.bracketPairsTree.value&&(this.bracketPairsTree.clear(),this.onDidChangeEmitter.fire());var e,t}getBracketPairsInRange(t){return this.bracketsRequested=!0,this.updateBracketPairsTree(),this.bracketPairsTree.value?.object.getBracketPairsInRange(t,!1)||e.CallbackIterable.empty}getBracketPairsInRangeWithMinIndentation(t){return this.bracketsRequested=!0,this.updateBracketPairsTree(),this.bracketPairsTree.value?.object.getBracketPairsInRange(t,!0)||e.CallbackIterable.empty}getBracketsInRange(t,n=!1){return this.bracketsRequested=!0,this.updateBracketPairsTree(),this.bracketPairsTree.value?.object.getBracketsInRange(t,n)||e.CallbackIterable.empty}findMatchingBracketUp(e,t,n){const r=this.textModel.validatePosition(t),i=this.textModel.getLanguageIdAtPosition(r.lineNumber,r.column);if(this.canBuildAST){const n=this.languageConfigurationService.getLanguageConfiguration(i).bracketsNew.getClosingBracketInfo(e);if(!n)return null;const r=this.getBracketPairsInRange(a.Range.fromPositions(t,t)).findLast((e=>n.closes(e.openingBracketInfo)));return r?r.openingBracketRange:null}{const t=e.toLowerCase(),a=this.languageConfigurationService.getLanguageConfiguration(i).brackets;if(!a)return null;const s=a.textIsBracket[t];return s?u(this._findMatchingBracketUp(s,r,g(n))):null}}matchBracket(t,n){if(this.canBuildAST){const n=this.getBracketPairsInRange(a.Range.fromPositions(t,t)).filter((e=>void 0!==e.closingBracketRange&&(e.openingBracketRange.containsPosition(t)||e.closingBracketRange.containsPosition(t)))).findLastMaxBy(e.compareBy((e=>e.openingBracketRange.containsPosition(t)?e.openingBracketRange:e.closingBracketRange),a.Range.compareRangesUsingStarts));return n?[n.openingBracketRange,n.closingBracketRange]:null}{const e=g(n);return this._matchBracket(this.textModel.validatePosition(t),e)}}_establishBracketSearchOffsets(e,t,n,a){const i=t.getCount(),s=t.getLanguageId(a);let o=Math.max(0,e.column-1-n.maxBracketLength);for(let e=a-1;e>=0;e--){const n=t.getEndOffset(e);if(n<=o)break;if(r.ignoreBracketsInToken(t.getStandardTokenType(e))||t.getLanguageId(e)!==s){o=n;break}}let g=Math.min(t.getLineContent().length,e.column-1+n.maxBracketLength);for(let e=a+1;e<i;e++){const n=t.getStartOffset(e);if(n>=g)break;if(r.ignoreBracketsInToken(t.getStandardTokenType(e))||t.getLanguageId(e)!==s){g=n;break}}return{searchStartOffset:o,searchEndOffset:g}}_matchBracket(e,t){const n=e.lineNumber,a=this.textModel.tokenization.getLineTokens(n),s=this.textModel.getLineContent(n),o=a.findTokenIndexAtOffset(e.column-1);if(o<0)return null;const g=this.languageConfigurationService.getLanguageConfiguration(a.getLanguageId(o)).brackets;if(g&&!r.ignoreBracketsInToken(a.getStandardTokenType(o))){let{searchStartOffset:r,searchEndOffset:u}=this._establishBracketSearchOffsets(e,a,g,o),l=null;for(;;){const a=i.BracketsUtils.findNextBracketInRange(g.forwardRegex,n,s,r,u);if(!a)break;if(a.startColumn<=e.column&&e.column<=a.endColumn){const e=s.substring(a.startColumn-1,a.endColumn-1).toLowerCase(),n=this._matchFoundBracket(a,g.textIsBracket[e],g.textIsOpenBracket[e],t);if(n){if(n instanceof c)return null;l=n}}r=a.endColumn-1}if(l)return l}if(o>0&&a.getStartOffset(o)===e.column-1){const g=o-1,u=this.languageConfigurationService.getLanguageConfiguration(a.getLanguageId(g)).brackets;if(u&&!r.ignoreBracketsInToken(a.getStandardTokenType(g))){const{searchStartOffset:r,searchEndOffset:o}=this._establishBracketSearchOffsets(e,a,u,g),l=i.BracketsUtils.findPrevBracketInRange(u.reversedRegex,n,s,r,o);if(l&&l.startColumn<=e.column&&e.column<=l.endColumn){const e=s.substring(l.startColumn-1,l.endColumn-1).toLowerCase(),n=this._matchFoundBracket(l,u.textIsBracket[e],u.textIsOpenBracket[e],t);if(n)return n instanceof c?null:n}}}return null}_matchFoundBracket(e,t,n,a){if(!t)return null;const r=n?this._findMatchingBracketDown(t,e.getEndPosition(),a):this._findMatchingBracketUp(t,e.getStartPosition(),a);return r?r instanceof c?r:[e,r]:null}_findMatchingBracketUp(e,t,n){const a=e.languageId,s=e.reversedRegex;let o=-1,g=0;const u=(t,a,r,u)=>{for(;;){if(n&&++g%100==0&&!n())return c.INSTANCE;const l=i.BracketsUtils.findPrevBracketInRange(s,t,a,r,u);if(!l)break;const f=a.substring(l.startColumn-1,l.endColumn-1).toLowerCase();if(e.isOpen(f)?o++:e.isClose(f)&&o--,0===o)return l;u=l.startColumn-1}return null};for(let e=t.lineNumber;e>=1;e--){const n=this.textModel.tokenization.getLineTokens(e),i=n.getCount(),s=this.textModel.getLineContent(e);let o=i-1,g=s.length,c=s.length;e===t.lineNumber&&(o=n.findTokenIndexAtOffset(t.column-1),g=t.column-1,c=t.column-1);let l=!0;for(;o>=0;o--){const t=n.getLanguageId(o)===a&&!r.ignoreBracketsInToken(n.getStandardTokenType(o));if(t)l?g=n.getStartOffset(o):(g=n.getStartOffset(o),c=n.getEndOffset(o));else if(l&&g!==c){const t=u(e,s,g,c);if(t)return t}l=t}if(l&&g!==c){const t=u(e,s,g,c);if(t)return t}}return null}_findMatchingBracketDown(e,t,n){const a=e.languageId,s=e.forwardRegex;let o=1,g=0;const u=(t,a,r,u)=>{for(;;){if(n&&++g%100==0&&!n())return c.INSTANCE;const l=i.BracketsUtils.findNextBracketInRange(s,t,a,r,u);if(!l)break;const f=a.substring(l.startColumn-1,l.endColumn-1).toLowerCase();if(e.isOpen(f)?o++:e.isClose(f)&&o--,0===o)return l;r=l.endColumn-1}return null},l=this.textModel.getLineCount();for(let e=t.lineNumber;e<=l;e++){const n=this.textModel.tokenization.getLineTokens(e),i=n.getCount(),s=this.textModel.getLineContent(e);let o=0,g=0,c=0;e===t.lineNumber&&(o=n.findTokenIndexAtOffset(t.column-1),g=t.column-1,c=t.column-1);let l=!0;for(;o<i;o++){const t=n.getLanguageId(o)===a&&!r.ignoreBracketsInToken(n.getStandardTokenType(o));if(t)l||(g=n.getStartOffset(o)),c=n.getEndOffset(o);else if(l&&g!==c){const t=u(e,s,g,c);if(t)return t}l=t}if(l&&g!==c){const t=u(e,s,g,c);if(t)return t}}return null}findPrevBracket(e){const t=this.textModel.validatePosition(e);if(this.canBuildAST)return this.bracketsRequested=!0,this.updateBracketPairsTree(),this.bracketPairsTree.value?.object.getFirstBracketBefore(t)||null;let n=null,a=null,s=null;for(let e=t.lineNumber;e>=1;e--){const o=this.textModel.tokenization.getLineTokens(e),g=o.getCount(),c=this.textModel.getLineContent(e);let u=g-1,l=c.length,f=c.length;if(e===t.lineNumber){u=o.findTokenIndexAtOffset(t.column-1),l=t.column-1,f=t.column-1;const e=o.getLanguageId(u);n!==e&&(n=e,a=this.languageConfigurationService.getLanguageConfiguration(n).brackets,s=this.languageConfigurationService.getLanguageConfiguration(n).bracketsNew)}let d=!0;for(;u>=0;u--){const t=o.getLanguageId(u);if(n!==t){if(a&&s&&d&&l!==f){const t=i.BracketsUtils.findPrevBracketInRange(a.reversedRegex,e,c,l,f);if(t)return this._toFoundBracket(s,t);d=!1}n=t,a=this.languageConfigurationService.getLanguageConfiguration(n).brackets,s=this.languageConfigurationService.getLanguageConfiguration(n).bracketsNew}const g=!!a&&!r.ignoreBracketsInToken(o.getStandardTokenType(u));if(g)d?l=o.getStartOffset(u):(l=o.getStartOffset(u),f=o.getEndOffset(u));else if(s&&a&&d&&l!==f){const t=i.BracketsUtils.findPrevBracketInRange(a.reversedRegex,e,c,l,f);if(t)return this._toFoundBracket(s,t)}d=g}if(s&&a&&d&&l!==f){const t=i.BracketsUtils.findPrevBracketInRange(a.reversedRegex,e,c,l,f);if(t)return this._toFoundBracket(s,t)}}return null}findNextBracket(e){const t=this.textModel.validatePosition(e);if(this.canBuildAST)return this.bracketsRequested=!0,this.updateBracketPairsTree(),this.bracketPairsTree.value?.object.getFirstBracketAfter(t)||null;const n=this.textModel.getLineCount();let a=null,s=null,o=null;for(let e=t.lineNumber;e<=n;e++){const n=this.textModel.tokenization.getLineTokens(e),g=n.getCount(),c=this.textModel.getLineContent(e);let u=0,l=0,f=0;if(e===t.lineNumber){u=n.findTokenIndexAtOffset(t.column-1),l=t.column-1,f=t.column-1;const e=n.getLanguageId(u);a!==e&&(a=e,s=this.languageConfigurationService.getLanguageConfiguration(a).brackets,o=this.languageConfigurationService.getLanguageConfiguration(a).bracketsNew)}let d=!0;for(;u<g;u++){const t=n.getLanguageId(u);if(a!==t){if(o&&s&&d&&l!==f){const t=i.BracketsUtils.findNextBracketInRange(s.forwardRegex,e,c,l,f);if(t)return this._toFoundBracket(o,t);d=!1}a=t,s=this.languageConfigurationService.getLanguageConfiguration(a).brackets,o=this.languageConfigurationService.getLanguageConfiguration(a).bracketsNew}const g=!!s&&!r.ignoreBracketsInToken(n.getStandardTokenType(u));if(g)d||(l=n.getStartOffset(u)),f=n.getEndOffset(u);else if(o&&s&&d&&l!==f){const t=i.BracketsUtils.findNextBracketInRange(s.forwardRegex,e,c,l,f);if(t)return this._toFoundBracket(o,t)}d=g}if(o&&s&&d&&l!==f){const t=i.BracketsUtils.findNextBracketInRange(s.forwardRegex,e,c,l,f);if(t)return this._toFoundBracket(o,t)}}return null}findEnclosingBrackets(e,t){const n=this.textModel.validatePosition(e);if(this.canBuildAST){const e=a.Range.fromPositions(n),t=this.getBracketPairsInRange(a.Range.fromPositions(n,n)).findLast((t=>void 0!==t.closingBracketRange&&t.range.strictContainsRange(e)));return t?[t.openingBracketRange,t.closingBracketRange]:null}const s=g(t),o=this.textModel.getLineCount(),l=new Map;let f=[];const d=(e,t)=>{if(!l.has(e)){const n=[];for(let e=0,a=t?t.brackets.length:0;e<a;e++)n[e]=0;l.set(e,n)}f=l.get(e)};let k=0;const h=(e,t,n,a,r)=>{for(;;){if(s&&++k%100==0&&!s())return c.INSTANCE;const o=i.BracketsUtils.findNextBracketInRange(e.forwardRegex,t,n,a,r);if(!o)break;const g=n.substring(o.startColumn-1,o.endColumn-1).toLowerCase(),u=e.textIsBracket[g];if(u&&(u.isOpen(g)?f[u.index]++:u.isClose(g)&&f[u.index]--,-1===f[u.index]))return this._matchFoundBracket(o,u,!1,s);a=o.endColumn-1}return null};let B=null,C=null;for(let e=n.lineNumber;e<=o;e++){const t=this.textModel.tokenization.getLineTokens(e),a=t.getCount(),i=this.textModel.getLineContent(e);let s=0,o=0,g=0;if(e===n.lineNumber){s=t.findTokenIndexAtOffset(n.column-1),o=n.column-1,g=n.column-1;const e=t.getLanguageId(s);B!==e&&(B=e,C=this.languageConfigurationService.getLanguageConfiguration(B).brackets,d(B,C))}let c=!0;for(;s<a;s++){const n=t.getLanguageId(s);if(B!==n){if(C&&c&&o!==g){const t=h(C,e,i,o,g);if(t)return u(t);c=!1}B=n,C=this.languageConfigurationService.getLanguageConfiguration(B).brackets,d(B,C)}const a=!!C&&!r.ignoreBracketsInToken(t.getStandardTokenType(s));if(a)c||(o=t.getStartOffset(s)),g=t.getEndOffset(s);else if(C&&c&&o!==g){const t=h(C,e,i,o,g);if(t)return u(t)}c=a}if(C&&c&&o!==g){const t=h(C,e,i,o,g);if(t)return u(t)}}return null}_toFoundBracket(e,t){if(!t)return null;let n=this.textModel.getValueInRange(t);n=n.toLowerCase();const a=e.getBracketInfo(n);return a?{range:t,bracketInfo:a}:null}}function g(e){if(void 0===e)return()=>!0;{const t=Date.now();return()=>Date.now()-t<=e}}class c{static{this.INSTANCE=new c}constructor(){this._searchCanceledBrand=void 0}}function u(e){return e instanceof c?null:e}exports.BracketPairsTextModelPart=o;
//# sourceMappingURL=bracketPairsImpl.js.map
