"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var e=require("../../../nls.js"),t=require("../../../base/common/errors.js"),s=require("../core/selection.js"),i=require("../../../base/common/uri.js"),r=require("../core/textChange.js"),n=require("../../../base/common/buffer.js"),o=require("../../../base/common/resources.js");function a(e){return e.toString()}class d{static create(e,t){const s=e.getAlternativeVersionId(),i=l(e);return new d(s,s,i,i,t,t,[])}constructor(e,t,s,i,r,n,o){this.beforeVersionId=e,this.afterVersionId=t,this.beforeEOL=s,this.afterEOL=i,this.beforeCursorState=r,this.afterCursorState=n,this.changes=o}append(e,t,s,i,n){t.length>0&&(this.changes=r.compressConsecutiveTextChanges(this.changes,t)),this.afterEOL=s,this.afterVersionId=i,this.afterCursorState=n}static _writeSelectionsSize(e){return 4+16*(e?e.length:0)}static _writeSelections(e,t,s){if(n.writeUInt32BE(e,t?t.length:0,s),s+=4,t)for(const i of t)n.writeUInt32BE(e,i.selectionStartLineNumber,s),s+=4,n.writeUInt32BE(e,i.selectionStartColumn,s),s+=4,n.writeUInt32BE(e,i.positionLineNumber,s),s+=4,n.writeUInt32BE(e,i.positionColumn,s),s+=4;return s}static _readSelections(e,t,i){const r=n.readUInt32BE(e,t);t+=4;for(let o=0;o<r;o++){const r=n.readUInt32BE(e,t);t+=4;const o=n.readUInt32BE(e,t);t+=4;const a=n.readUInt32BE(e,t);t+=4;const d=n.readUInt32BE(e,t);t+=4,i.push(new s.Selection(r,o,a,d))}return t}serialize(){let e=10+d._writeSelectionsSize(this.beforeCursorState)+d._writeSelectionsSize(this.afterCursorState)+4;for(const t of this.changes)e+=t.writeSize();const t=new Uint8Array(e);let s=0;n.writeUInt32BE(t,this.beforeVersionId,s),s+=4,n.writeUInt32BE(t,this.afterVersionId,s),s+=4,n.writeUInt8(t,this.beforeEOL,s),s+=1,n.writeUInt8(t,this.afterEOL,s),s+=1,s=d._writeSelections(t,this.beforeCursorState,s),s=d._writeSelections(t,this.afterCursorState,s),n.writeUInt32BE(t,this.changes.length,s),s+=4;for(const e of this.changes)s=e.write(t,s);return t.buffer}static deserialize(e){const t=new Uint8Array(e);let s=0;const i=n.readUInt32BE(t,s);s+=4;const o=n.readUInt32BE(t,s);s+=4;const a=n.readUInt8(t,s);s+=1;const c=n.readUInt8(t,s);s+=1;const h=[];s=d._readSelections(t,s,h);const l=[];s=d._readSelections(t,s,l);const u=n.readUInt32BE(t,s);s+=4;const _=[];for(let e=0;e<u;e++)s=r.TextChange.read(t,s,_);return new d(i,o,a,c,h,l,_)}}class c{get type(){return 0}get resource(){return i.URI.isUri(this.model)?this.model:this.model.uri}constructor(e,t,s,i){this.label=e,this.code=t,this.model=s,this._data=d.create(s,i)}toString(){return(this._data instanceof d?this._data:d.deserialize(this._data)).changes.map((e=>e.toString())).join(", ")}matchesResource(e){return(i.URI.isUri(this.model)?this.model:this.model.uri).toString()===e.toString()}setModel(e){this.model=e}canAppend(e){return this.model===e&&this._data instanceof d}append(e,t,s,i,r){this._data instanceof d&&this._data.append(e,t,s,i,r)}close(){this._data instanceof d&&(this._data=this._data.serialize())}open(){this._data instanceof d||(this._data=d.deserialize(this._data))}undo(){if(i.URI.isUri(this.model))throw new Error("Invalid SingleModelEditStackElement");this._data instanceof d&&(this._data=this._data.serialize());const e=d.deserialize(this._data);this.model._applyUndo(e.changes,e.beforeEOL,e.beforeVersionId,e.beforeCursorState)}redo(){if(i.URI.isUri(this.model))throw new Error("Invalid SingleModelEditStackElement");this._data instanceof d&&(this._data=this._data.serialize());const e=d.deserialize(this._data);this.model._applyRedo(e.changes,e.afterEOL,e.afterVersionId,e.afterCursorState)}heapSize(){return this._data instanceof d&&(this._data=this._data.serialize()),this._data.byteLength+168}}class h{get resources(){return this._editStackElementsArr.map((e=>e.resource))}constructor(e,t,s){this.label=e,this.code=t,this.type=1,this._isOpen=!0,this._editStackElementsArr=s.slice(0),this._editStackElementsMap=new Map;for(const e of this._editStackElementsArr){const t=a(e.resource);this._editStackElementsMap.set(t,e)}this._delegate=null}prepareUndoRedo(){if(this._delegate)return this._delegate.prepareUndoRedo(this)}matchesResource(e){const t=a(e);return this._editStackElementsMap.has(t)}setModel(e){const t=a(i.URI.isUri(e)?e:e.uri);this._editStackElementsMap.has(t)&&this._editStackElementsMap.get(t).setModel(e)}canAppend(e){if(!this._isOpen)return!1;const t=a(e.uri);if(this._editStackElementsMap.has(t)){return this._editStackElementsMap.get(t).canAppend(e)}return!1}append(e,t,s,i,r){const n=a(e.uri);this._editStackElementsMap.get(n).append(e,t,s,i,r)}close(){this._isOpen=!1}open(){}undo(){this._isOpen=!1;for(const e of this._editStackElementsArr)e.undo()}redo(){for(const e of this._editStackElementsArr)e.redo()}heapSize(e){const t=a(e);if(this._editStackElementsMap.has(t)){return this._editStackElementsMap.get(t).heapSize()}return 0}split(){return this._editStackElementsArr}toString(){const e=[];for(const t of this._editStackElementsArr)e.push(`${o.basename(t.resource)}: ${t}`);return`{${e.join(", ")}}`}}function l(e){return"\n"===e.getEOL()?0:1}function u(e){return!!e&&(e instanceof c||e instanceof h)}class _{constructor(e,t){this._model=e,this._undoRedoService=t}pushStackElement(){const e=this._undoRedoService.getLastElement(this._model.uri);u(e)&&e.close()}popStackElement(){const e=this._undoRedoService.getLastElement(this._model.uri);u(e)&&e.open()}clear(){this._undoRedoService.removeElements(this._model.uri)}_getOrCreateEditStackElement(t,s){const i=this._undoRedoService.getLastElement(this._model.uri);if(u(i)&&i.canAppend(this._model))return i;const r=new c(e.localize("edit","Typing"),"undoredo.textBufferEdit",this._model,t);return this._undoRedoService.pushElement(r,s),r}pushEOL(e){const t=this._getOrCreateEditStackElement(null,void 0);this._model.setEOL(e),t.append(this._model,[],l(this._model),this._model.getAlternativeVersionId(),null)}pushEditOperation(e,t,s,i){const r=this._getOrCreateEditStackElement(e,i),n=this._model.applyEdits(t,!0),o=_._computeCursorState(s,n),a=n.map(((e,t)=>({index:t,textChange:e.textChange})));return a.sort(((e,t)=>e.textChange.oldPosition===t.textChange.oldPosition?e.index-t.index:e.textChange.oldPosition-t.textChange.oldPosition)),r.append(this._model,a.map((e=>e.textChange)),l(this._model),this._model.getAlternativeVersionId(),o),o}static _computeCursorState(e,s){try{return e?e(s):null}catch(e){return t.onUnexpectedError(e),null}}}exports.EditStack=_,exports.MultiModelEditStackElement=h,exports.SingleModelEditStackData=d,exports.SingleModelEditStackElement=c,exports.isEditStackElement=u;
//# sourceMappingURL=editStack.js.map
