"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var e,t=require("../../../base/common/arrays.js"),i=require("../../../base/common/color.js"),n=require("../../../base/common/errors.js"),s=require("../../../base/common/event.js"),r=require("../../../base/common/lifecycle.js"),o=require("../../../base/common/strings.js"),a=require("../../../base/common/uri.js"),h=require("../core/eolCounter.js"),l=require("../core/indentation.js"),d=require("../core/position.js"),c=require("../core/range.js"),u=require("../core/selection.js"),g=require("../core/textModelDefaults.js"),f=require("../languages/language.js"),_=require("../languages/languageConfigurationRegistry.js"),p=require("../model.js"),m=require("./bracketPairsTextModelPart/bracketPairsImpl.js"),C=require("./bracketPairsTextModelPart/colorizedBracketPairsDecorationProvider.js"),D=require("./editStack.js"),L=require("./guidesTextModelPart.js"),b=require("./indentationGuesser.js"),v=require("./intervalTree.js"),T=require("./pieceTreeTextBuffer/pieceTreeTextBuffer.js"),E=require("./pieceTreeTextBuffer/pieceTreeTextBufferBuilder.js"),N=require("./textModelSearch.js"),I=require("./tokenizationTextModelPart.js"),R=require("./tokens.js"),w=require("../textModelEvents.js"),O=require("../../../platform/instantiation/common/instantiation.js"),x=require("../../../platform/undoRedo/common/undoRedo.js"),M=self&&self.__decorate||function(e,t,i,n){var s,r=arguments.length,o=r<3?t:null===n?n=Object.getOwnPropertyDescriptor(t,i):n;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)o=Reflect.decorate(e,t,i,n);else for(var a=e.length-1;a>=0;a--)(s=e[a])&&(o=(r<3?s(o):r>3?s(t,i,o):s(t,i))||o);return r>3&&o&&Object.defineProperty(t,i,o),o},A=self&&self.__param||function(e,t){return function(i,n){t(i,n,e)}};function S(e){const t=new E.PieceTreeTextBufferBuilder;return t.acceptChunk(e),t.finish()}function y(e){const t=new E.PieceTreeTextBufferBuilder;let i;for(;"string"==typeof(i=e.read());)t.acceptChunk(i);return t.finish()}function P(e,t){let i;return i="string"==typeof e?S(e):p.isITextSnapshot(e)?y(e):e,i.create(t)}let k=0;class j{constructor(e){this._source=e,this._eos=!1}read(){if(this._eos)return null;const e=[];let t=0,i=0;for(;;){const n=this._source.read();if(null===n)return this._eos=!0,0===t?null:e.join("");if(n.length>0&&(e[t++]=n,i+=n.length),i>=65536)return e.join("")}}}const F=()=>{throw new Error("Invalid change accessor")};function z(e){let t=0;for(const i of e){if(" "!==i&&"\t"!==i)break;t++}return t}function V(e){return!(!e.options.overviewRuler||!e.options.overviewRuler.color)}function B(e){return!!e.options.after||!!e.options.before}exports.TextModel=class extends r.Disposable{static{e=this}static{this._MODEL_SYNC_LIMIT=52428800}static{this.LARGE_FILE_SIZE_THRESHOLD=20971520}static{this.LARGE_FILE_LINE_COUNT_THRESHOLD=3e5}static{this.LARGE_FILE_HEAP_OPERATION_THRESHOLD=268435456}static{this.DEFAULT_CREATION_OPTIONS={isForSimpleWidget:!1,tabSize:g.EDITOR_MODEL_DEFAULTS.tabSize,indentSize:g.EDITOR_MODEL_DEFAULTS.indentSize,insertSpaces:g.EDITOR_MODEL_DEFAULTS.insertSpaces,detectIndentation:!1,defaultEOL:1,trimAutoWhitespace:g.EDITOR_MODEL_DEFAULTS.trimAutoWhitespace,largeFileOptimizations:g.EDITOR_MODEL_DEFAULTS.largeFileOptimizations,bracketPairColorizationOptions:g.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions}}static resolveOptions(e,t){if(t.detectIndentation){const i=b.guessIndentation(e,t.tabSize,t.insertSpaces);return new p.TextModelResolvedOptions({tabSize:i.tabSize,indentSize:"tabSize",insertSpaces:i.insertSpaces,trimAutoWhitespace:t.trimAutoWhitespace,defaultEOL:t.defaultEOL,bracketPairColorizationOptions:t.bracketPairColorizationOptions})}return new p.TextModelResolvedOptions(t)}get onDidChangeLanguage(){return this._tokenizationTextModelPart.onDidChangeLanguage}get onDidChangeLanguageConfiguration(){return this._tokenizationTextModelPart.onDidChangeLanguageConfiguration}get onDidChangeTokens(){return this._tokenizationTextModelPart.onDidChangeTokens}onDidChangeContent(e){return this._eventEmitter.slowEvent((t=>e(t.contentChangedEvent)))}onDidChangeContentOrInjectedText(e){return r.combinedDisposable(this._eventEmitter.fastEvent((t=>e(t))),this._onDidChangeInjectedText.event((t=>e(t))))}_isDisposing(){return this.__isDisposing}get tokenization(){return this._tokenizationTextModelPart}get bracketPairs(){return this._bracketPairs}get guides(){return this._guidesTextModelPart}constructor(t,i,n,h=null,l,d,u,g){super(),this._undoRedoService=l,this._languageService=d,this._languageConfigurationService=u,this.instantiationService=g,this._onWillDispose=this._register(new s.Emitter),this.onWillDispose=this._onWillDispose.event,this._onDidChangeDecorations=this._register(new K((e=>this.handleBeforeFireDecorationsChangedEvent(e)))),this.onDidChangeDecorations=this._onDidChangeDecorations.event,this._onDidChangeOptions=this._register(new s.Emitter),this.onDidChangeOptions=this._onDidChangeOptions.event,this._onDidChangeAttached=this._register(new s.Emitter),this.onDidChangeAttached=this._onDidChangeAttached.event,this._onDidChangeInjectedText=this._register(new s.Emitter),this._eventEmitter=this._register(new X),this._languageSelectionListener=this._register(new r.MutableDisposable),this._deltaDecorationCallCnt=0,this._attachedViews=new R.AttachedViews,k++,this.id="$model"+k,this.isForSimpleWidget=n.isForSimpleWidget,this._associatedResource=null==h?a.URI.parse("inmemory://model/"+k):h,this._attachedEditorCount=0;const{textBuffer:f,disposable:_}=P(t,n.defaultEOL);this._buffer=f,this._bufferDisposable=_,this._options=e.resolveOptions(this._buffer,n);const p="string"==typeof i?i:i.languageId;"string"!=typeof i&&(this._languageSelectionListener.value=i.onDidChange((()=>this._setLanguage(i.languageId)))),this._bracketPairs=this._register(new m.BracketPairsTextModelPart(this,this._languageConfigurationService)),this._guidesTextModelPart=this._register(new L.GuidesTextModelPart(this,this._languageConfigurationService)),this._decorationProvider=this._register(new C.ColorizedBracketPairsDecorationProvider(this)),this._tokenizationTextModelPart=this.instantiationService.createInstance(I.TokenizationTextModelPart,this,this._bracketPairs,p,this._attachedViews);const b=this._buffer.getLineCount(),v=this._buffer.getValueLengthInRange(new c.Range(1,1,b,this._buffer.getLineLength(b)+1),0);n.largeFileOptimizations?(this._isTooLargeForTokenization=v>e.LARGE_FILE_SIZE_THRESHOLD||b>e.LARGE_FILE_LINE_COUNT_THRESHOLD,this._isTooLargeForHeapOperation=v>e.LARGE_FILE_HEAP_OPERATION_THRESHOLD):(this._isTooLargeForTokenization=!1,this._isTooLargeForHeapOperation=!1),this._isTooLargeForSyncing=v>e._MODEL_SYNC_LIMIT,this._versionId=1,this._alternativeVersionId=1,this._initialUndoRedoSnapshot=null,this._isDisposed=!1,this.__isDisposing=!1,this._instanceId=o.singleLetterHash(k),this._lastDecorationId=0,this._decorations=Object.create(null),this._decorationsTree=new U,this._commandManager=new D.EditStack(this,this._undoRedoService),this._isUndoing=!1,this._isRedoing=!1,this._trimAutoWhitespaceLines=null,this._register(this._decorationProvider.onDidChange((()=>{this._onDidChangeDecorations.beginDeferredEmit(),this._onDidChangeDecorations.fire(),this._onDidChangeDecorations.endDeferredEmit()}))),this._languageService.requestRichLanguageFeatures(p),this._register(this._languageConfigurationService.onDidChange((e=>{this._bracketPairs.handleLanguageConfigurationServiceChange(e),this._tokenizationTextModelPart.handleLanguageConfigurationServiceChange(e)})))}dispose(){this.__isDisposing=!0,this._onWillDispose.fire(),this._tokenizationTextModelPart.dispose(),this._isDisposed=!0,super.dispose(),this._bufferDisposable.dispose(),this.__isDisposing=!1;const e=new T.PieceTreeTextBuffer([],"","\n",!1,!1,!0,!0);e.dispose(),this._buffer=e,this._bufferDisposable=r.Disposable.None}_assertNotDisposed(){if(this._isDisposed)throw new n.BugIndicatingError("Model is disposed!")}_emitContentChangedEvent(e,t){this.__isDisposing||(this._tokenizationTextModelPart.handleDidChangeContent(t),this._bracketPairs.handleDidChangeContent(t),this._eventEmitter.fire(new w.InternalModelContentChangeEvent(e,t)))}setValue(e){if(this._assertNotDisposed(),null==e)throw n.illegalArgument();const{textBuffer:t,disposable:i}=P(e,this._options.defaultEOL);this._setValueFromTextBuffer(t,i)}_createContentChanged2(e,t,i,n,s,r,o,a){return{changes:[{range:e,rangeOffset:t,rangeLength:i,text:n}],eol:this._buffer.getEOL(),isEolChange:a,versionId:this.getVersionId(),isUndoing:s,isRedoing:r,isFlush:o}}_setValueFromTextBuffer(e,t){this._assertNotDisposed();const i=this.getFullModelRange(),n=this.getValueLengthInRange(i),s=this.getLineCount(),r=this.getLineMaxColumn(s);this._buffer=e,this._bufferDisposable.dispose(),this._bufferDisposable=t,this._increaseVersionId(),this._decorations=Object.create(null),this._decorationsTree=new U,this._commandManager.clear(),this._trimAutoWhitespaceLines=null,this._emitContentChangedEvent(new w.ModelRawContentChangedEvent([new w.ModelRawFlush],this._versionId,!1,!1),this._createContentChanged2(new c.Range(1,1,s,r),0,n,this.getValue(),!1,!1,!0,!1))}setEOL(e){this._assertNotDisposed();const t=1===e?"\r\n":"\n";if(this._buffer.getEOL()===t)return;const i=this.getFullModelRange(),n=this.getValueLengthInRange(i),s=this.getLineCount(),r=this.getLineMaxColumn(s);this._onBeforeEOLChange(),this._buffer.setEOL(t),this._increaseVersionId(),this._onAfterEOLChange(),this._emitContentChangedEvent(new w.ModelRawContentChangedEvent([new w.ModelRawEOLChanged],this._versionId,!1,!1),this._createContentChanged2(new c.Range(1,1,s,r),0,n,this.getValue(),!1,!1,!1,!0))}_onBeforeEOLChange(){this._decorationsTree.ensureAllNodesHaveRanges(this)}_onAfterEOLChange(){const e=this.getVersionId(),t=this._decorationsTree.collectNodesPostOrder();for(let i=0,n=t.length;i<n;i++){const n=t[i],s=n.range,r=n.cachedAbsoluteStart-n.start,o=this._buffer.getOffsetAt(s.startLineNumber,s.startColumn),a=this._buffer.getOffsetAt(s.endLineNumber,s.endColumn);n.cachedAbsoluteStart=o,n.cachedAbsoluteEnd=a,n.cachedVersionId=e,n.start=o-r,n.end=a-r,v.recomputeMaxEnd(n)}}onBeforeAttached(){return this._attachedEditorCount++,1===this._attachedEditorCount&&(this._tokenizationTextModelPart.handleDidChangeAttached(),this._onDidChangeAttached.fire(void 0)),this._attachedViews.attachView()}onBeforeDetached(e){this._attachedEditorCount--,0===this._attachedEditorCount&&(this._tokenizationTextModelPart.handleDidChangeAttached(),this._onDidChangeAttached.fire(void 0)),this._attachedViews.detachView(e)}isAttachedToEditor(){return this._attachedEditorCount>0}getAttachedEditorCount(){return this._attachedEditorCount}isTooLargeForSyncing(){return this._isTooLargeForSyncing}isTooLargeForTokenization(){return this._isTooLargeForTokenization}isTooLargeForHeapOperation(){return this._isTooLargeForHeapOperation}isDisposed(){return this._isDisposed}isDominatedByLongLines(){if(this._assertNotDisposed(),this.isTooLargeForTokenization())return!1;let e=0,t=0;const i=this._buffer.getLineCount();for(let n=1;n<=i;n++){const i=this._buffer.getLineLength(n);i>=1e4?t+=i:e+=i}return t>e}get uri(){return this._associatedResource}getOptions(){return this._assertNotDisposed(),this._options}getFormattingOptions(){return{tabSize:this._options.indentSize,insertSpaces:this._options.insertSpaces}}updateOptions(e){this._assertNotDisposed();const t=void 0!==e.tabSize?e.tabSize:this._options.tabSize,i=void 0!==e.indentSize?e.indentSize:this._options.originalIndentSize,n=void 0!==e.insertSpaces?e.insertSpaces:this._options.insertSpaces,s=void 0!==e.trimAutoWhitespace?e.trimAutoWhitespace:this._options.trimAutoWhitespace,r=void 0!==e.bracketColorizationOptions?e.bracketColorizationOptions:this._options.bracketPairColorizationOptions,o=new p.TextModelResolvedOptions({tabSize:t,indentSize:i,insertSpaces:n,defaultEOL:this._options.defaultEOL,trimAutoWhitespace:s,bracketPairColorizationOptions:r});if(this._options.equals(o))return;const a=this._options.createChangeEvent(o);this._options=o,this._bracketPairs.handleDidChangeOptions(a),this._decorationProvider.handleDidChangeOptions(a),this._onDidChangeOptions.fire(a)}detectIndentation(e,t){this._assertNotDisposed();const i=b.guessIndentation(this._buffer,t,e);this.updateOptions({insertSpaces:i.insertSpaces,tabSize:i.tabSize,indentSize:i.tabSize})}normalizeIndentation(e){return this._assertNotDisposed(),l.normalizeIndentation(e,this._options.indentSize,this._options.insertSpaces)}getVersionId(){return this._assertNotDisposed(),this._versionId}mightContainRTL(){return this._buffer.mightContainRTL()}mightContainUnusualLineTerminators(){return this._buffer.mightContainUnusualLineTerminators()}removeUnusualLineTerminators(e=null){const t=this.findMatches(o.UNUSUAL_LINE_TERMINATORS.source,!1,!0,!1,null,!1,1073741824);this._buffer.resetMightContainUnusualLineTerminators(),this.pushEditOperations(e,t.map((e=>({range:e.range,text:null}))),(()=>null))}mightContainNonBasicASCII(){return this._buffer.mightContainNonBasicASCII()}getAlternativeVersionId(){return this._assertNotDisposed(),this._alternativeVersionId}getInitialUndoRedoSnapshot(){return this._assertNotDisposed(),this._initialUndoRedoSnapshot}getOffsetAt(e){this._assertNotDisposed();const t=this._validatePosition(e.lineNumber,e.column,0);return this._buffer.getOffsetAt(t.lineNumber,t.column)}getPositionAt(e){this._assertNotDisposed();const t=Math.min(this._buffer.getLength(),Math.max(0,e));return this._buffer.getPositionAt(t)}_increaseVersionId(){this._versionId=this._versionId+1,this._alternativeVersionId=this._versionId}_overwriteVersionId(e){this._versionId=e}_overwriteAlternativeVersionId(e){this._alternativeVersionId=e}_overwriteInitialUndoRedoSnapshot(e){this._initialUndoRedoSnapshot=e}getValue(e,t=!1){if(this._assertNotDisposed(),this.isTooLargeForHeapOperation())throw new n.BugIndicatingError("Operation would exceed heap memory limits");const i=this.getFullModelRange(),s=this.getValueInRange(i,e);return t?this._buffer.getBOM()+s:s}createSnapshot(e=!1){return new j(this._buffer.createSnapshot(e))}getValueLength(e,t=!1){this._assertNotDisposed();const i=this.getFullModelRange(),n=this.getValueLengthInRange(i,e);return t?this._buffer.getBOM().length+n:n}getValueInRange(e,t=0){return this._assertNotDisposed(),this._buffer.getValueInRange(this.validateRange(e),t)}getValueLengthInRange(e,t=0){return this._assertNotDisposed(),this._buffer.getValueLengthInRange(this.validateRange(e),t)}getCharacterCountInRange(e,t=0){return this._assertNotDisposed(),this._buffer.getCharacterCountInRange(this.validateRange(e),t)}getLineCount(){return this._assertNotDisposed(),this._buffer.getLineCount()}getLineContent(e){if(this._assertNotDisposed(),e<1||e>this.getLineCount())throw new n.BugIndicatingError("Illegal value for lineNumber");return this._buffer.getLineContent(e)}getLineLength(e){if(this._assertNotDisposed(),e<1||e>this.getLineCount())throw new n.BugIndicatingError("Illegal value for lineNumber");return this._buffer.getLineLength(e)}getLinesContent(){if(this._assertNotDisposed(),this.isTooLargeForHeapOperation())throw new n.BugIndicatingError("Operation would exceed heap memory limits");return this._buffer.getLinesContent()}getEOL(){return this._assertNotDisposed(),this._buffer.getEOL()}getEndOfLineSequence(){return this._assertNotDisposed(),"\n"===this._buffer.getEOL()?0:1}getLineMinColumn(e){return this._assertNotDisposed(),1}getLineMaxColumn(e){if(this._assertNotDisposed(),e<1||e>this.getLineCount())throw new n.BugIndicatingError("Illegal value for lineNumber");return this._buffer.getLineLength(e)+1}getLineFirstNonWhitespaceColumn(e){if(this._assertNotDisposed(),e<1||e>this.getLineCount())throw new n.BugIndicatingError("Illegal value for lineNumber");return this._buffer.getLineFirstNonWhitespaceColumn(e)}getLineLastNonWhitespaceColumn(e){if(this._assertNotDisposed(),e<1||e>this.getLineCount())throw new n.BugIndicatingError("Illegal value for lineNumber");return this._buffer.getLineLastNonWhitespaceColumn(e)}_validateRangeRelaxedNoAllocations(e){const t=this._buffer.getLineCount(),i=e.startLineNumber,n=e.startColumn;let s=Math.floor("number"!=typeof i||isNaN(i)?1:i),r=Math.floor("number"!=typeof n||isNaN(n)?1:n);if(s<1)s=1,r=1;else if(s>t)s=t,r=this.getLineMaxColumn(s);else if(r<=1)r=1;else{const e=this.getLineMaxColumn(s);r>=e&&(r=e)}const o=e.endLineNumber,a=e.endColumn;let h=Math.floor("number"!=typeof o||isNaN(o)?1:o),l=Math.floor("number"!=typeof a||isNaN(a)?1:a);if(h<1)h=1,l=1;else if(h>t)h=t,l=this.getLineMaxColumn(h);else if(l<=1)l=1;else{const e=this.getLineMaxColumn(h);l>=e&&(l=e)}return i===s&&n===r&&o===h&&a===l&&e instanceof c.Range&&!(e instanceof u.Selection)?e:new c.Range(s,r,h,l)}_isValidPosition(e,t,i){if("number"!=typeof e||"number"!=typeof t)return!1;if(isNaN(e)||isNaN(t))return!1;if(e<1||t<1)return!1;if((0|e)!==e||(0|t)!==t)return!1;if(e>this._buffer.getLineCount())return!1;if(1===t)return!0;if(t>this.getLineMaxColumn(e))return!1;if(1===i){const i=this._buffer.getLineCharCode(e,t-2);if(o.isHighSurrogate(i))return!1}return!0}_validatePosition(e,t,i){const n=Math.floor("number"!=typeof e||isNaN(e)?1:e),s=Math.floor("number"!=typeof t||isNaN(t)?1:t),r=this._buffer.getLineCount();if(n<1)return new d.Position(1,1);if(n>r)return new d.Position(r,this.getLineMaxColumn(r));if(s<=1)return new d.Position(n,1);const a=this.getLineMaxColumn(n);if(s>=a)return new d.Position(n,a);if(1===i){const e=this._buffer.getLineCharCode(n,s-2);if(o.isHighSurrogate(e))return new d.Position(n,s-1)}return new d.Position(n,s)}validatePosition(e){return this._assertNotDisposed(),e instanceof d.Position&&this._isValidPosition(e.lineNumber,e.column,1)?e:this._validatePosition(e.lineNumber,e.column,1)}_isValidRange(e,t){const i=e.startLineNumber,n=e.startColumn,s=e.endLineNumber,r=e.endColumn;if(!this._isValidPosition(i,n,0))return!1;if(!this._isValidPosition(s,r,0))return!1;if(1===t){const e=n>1?this._buffer.getLineCharCode(i,n-2):0,t=r>1&&r<=this._buffer.getLineLength(s)?this._buffer.getLineCharCode(s,r-2):0,a=o.isHighSurrogate(e),h=o.isHighSurrogate(t);return!a&&!h}return!0}validateRange(e){if(this._assertNotDisposed(),e instanceof c.Range&&!(e instanceof u.Selection)&&this._isValidRange(e,1))return e;const t=this._validatePosition(e.startLineNumber,e.startColumn,0),i=this._validatePosition(e.endLineNumber,e.endColumn,0),n=t.lineNumber,s=t.column,r=i.lineNumber,a=i.column;{const e=s>1?this._buffer.getLineCharCode(n,s-2):0,t=a>1&&a<=this._buffer.getLineLength(r)?this._buffer.getLineCharCode(r,a-2):0,i=o.isHighSurrogate(e),h=o.isHighSurrogate(t);return i||h?n===r&&s===a?new c.Range(n,s-1,r,a-1):i&&h?new c.Range(n,s-1,r,a+1):i?new c.Range(n,s-1,r,a):new c.Range(n,s,r,a+1):new c.Range(n,s,r,a)}}modifyPosition(e,t){this._assertNotDisposed();const i=this.getOffsetAt(e)+t;return this.getPositionAt(Math.min(this._buffer.getLength(),Math.max(0,i)))}getFullModelRange(){this._assertNotDisposed();const e=this.getLineCount();return new c.Range(1,1,e,this.getLineMaxColumn(e))}findMatchesLineByLine(e,t,i,n){return this._buffer.findMatchesLineByLine(e,t,i,n)}findMatches(e,t,i,n,s,r,o=999){this._assertNotDisposed();let a=null;null!==t&&(Array.isArray(t)||(t=[t]),t.every((e=>c.Range.isIRange(e)))&&(a=t.map((e=>this.validateRange(e))))),null===a&&(a=[this.getFullModelRange()]),a=a.sort(((e,t)=>e.startLineNumber-t.startLineNumber||e.startColumn-t.startColumn));const h=[];let l;if(h.push(a.reduce(((e,t)=>c.Range.areIntersecting(e,t)?e.plusRange(t):(h.push(e),t)))),!i&&e.indexOf("\n")<0){const t=new N.SearchParams(e,i,n,s).parseSearchRequest();if(!t)return[];l=e=>this.findMatchesLineByLine(e,t,r,o)}else l=t=>N.TextModelSearch.findMatches(this,new N.SearchParams(e,i,n,s),t,r,o);return h.map(l).reduce(((e,t)=>e.concat(t)),[])}findNextMatch(e,t,i,n,s,r){this._assertNotDisposed();const o=this.validatePosition(t);if(!i&&e.indexOf("\n")<0){const t=new N.SearchParams(e,i,n,s).parseSearchRequest();if(!t)return null;const a=this.getLineCount();let h=new c.Range(o.lineNumber,o.column,a,this.getLineMaxColumn(a)),l=this.findMatchesLineByLine(h,t,r,1);return N.TextModelSearch.findNextMatch(this,new N.SearchParams(e,i,n,s),o,r),l.length>0?l[0]:(h=new c.Range(1,1,o.lineNumber,this.getLineMaxColumn(o.lineNumber)),l=this.findMatchesLineByLine(h,t,r,1),l.length>0?l[0]:null)}return N.TextModelSearch.findNextMatch(this,new N.SearchParams(e,i,n,s),o,r)}findPreviousMatch(e,t,i,n,s,r){this._assertNotDisposed();const o=this.validatePosition(t);return N.TextModelSearch.findPreviousMatch(this,new N.SearchParams(e,i,n,s),o,r)}pushStackElement(){this._commandManager.pushStackElement()}popStackElement(){this._commandManager.popStackElement()}pushEOL(e){if(("\n"===this.getEOL()?0:1)!==e)try{this._onDidChangeDecorations.beginDeferredEmit(),this._eventEmitter.beginDeferredEmit(),null===this._initialUndoRedoSnapshot&&(this._initialUndoRedoSnapshot=this._undoRedoService.createSnapshot(this.uri)),this._commandManager.pushEOL(e)}finally{this._eventEmitter.endDeferredEmit(),this._onDidChangeDecorations.endDeferredEmit()}}_validateEditOperation(e){return e instanceof p.ValidAnnotatedEditOperation?e:new p.ValidAnnotatedEditOperation(e.identifier||null,this.validateRange(e.range),e.text,e.forceMoveMarkers||!1,e.isAutoWhitespaceEdit||!1,e._isTracked||!1)}_validateEditOperations(e){const t=[];for(let i=0,n=e.length;i<n;i++)t[i]=this._validateEditOperation(e[i]);return t}pushEditOperations(e,t,i,n){try{return this._onDidChangeDecorations.beginDeferredEmit(),this._eventEmitter.beginDeferredEmit(),this._pushEditOperations(e,this._validateEditOperations(t),i,n)}finally{this._eventEmitter.endDeferredEmit(),this._onDidChangeDecorations.endDeferredEmit()}}_pushEditOperations(e,t,i,n){if(this._options.trimAutoWhitespace&&this._trimAutoWhitespaceLines){const i=t.map((e=>({range:this.validateRange(e.range),text:e.text})));let n=!0;if(e)for(let t=0,s=e.length;t<s;t++){const s=e[t];let r=!1;for(let e=0,t=i.length;e<t;e++){const t=i[e].range,n=t.startLineNumber>s.endLineNumber,o=s.startLineNumber>t.endLineNumber;if(!n&&!o){r=!0;break}}if(!r){n=!1;break}}if(n)for(let e=0,n=this._trimAutoWhitespaceLines.length;e<n;e++){const n=this._trimAutoWhitespaceLines[e],s=this.getLineMaxColumn(n);let r=!0;for(let e=0,t=i.length;e<t;e++){const t=i[e].range,o=i[e].text;if(!(n<t.startLineNumber||n>t.endLineNumber)&&!(n===t.startLineNumber&&t.startColumn===s&&t.isEmpty()&&o&&o.length>0&&"\n"===o.charAt(0)||n===t.startLineNumber&&1===t.startColumn&&t.isEmpty()&&o&&o.length>0&&"\n"===o.charAt(o.length-1))){r=!1;break}}if(r){const e=new c.Range(n,1,n,s);t.push(new p.ValidAnnotatedEditOperation(null,e,null,!1,!1,!1))}}this._trimAutoWhitespaceLines=null}return null===this._initialUndoRedoSnapshot&&(this._initialUndoRedoSnapshot=this._undoRedoService.createSnapshot(this.uri)),this._commandManager.pushEditOperation(e,t,i,n)}_applyUndo(e,t,i,n){const s=e.map((e=>{const t=this.getPositionAt(e.newPosition),i=this.getPositionAt(e.newEnd);return{range:new c.Range(t.lineNumber,t.column,i.lineNumber,i.column),text:e.oldText}}));this._applyUndoRedoEdits(s,t,!0,!1,i,n)}_applyRedo(e,t,i,n){const s=e.map((e=>{const t=this.getPositionAt(e.oldPosition),i=this.getPositionAt(e.oldEnd);return{range:new c.Range(t.lineNumber,t.column,i.lineNumber,i.column),text:e.newText}}));this._applyUndoRedoEdits(s,t,!1,!0,i,n)}_applyUndoRedoEdits(e,t,i,n,s,r){try{this._onDidChangeDecorations.beginDeferredEmit(),this._eventEmitter.beginDeferredEmit(),this._isUndoing=i,this._isRedoing=n,this.applyEdits(e,!1),this.setEOL(t),this._overwriteAlternativeVersionId(s)}finally{this._isUndoing=!1,this._isRedoing=!1,this._eventEmitter.endDeferredEmit(r),this._onDidChangeDecorations.endDeferredEmit()}}applyEdits(e,t=!1){try{this._onDidChangeDecorations.beginDeferredEmit(),this._eventEmitter.beginDeferredEmit();const i=this._validateEditOperations(e);return this._doApplyEdits(i,t)}finally{this._eventEmitter.endDeferredEmit(),this._onDidChangeDecorations.endDeferredEmit()}}_doApplyEdits(e,i){const n=this._buffer.getLineCount(),s=this._buffer.applyEdits(e,this._options.trimAutoWhitespace,i),r=this._buffer.getLineCount(),o=s.changes;if(this._trimAutoWhitespaceLines=s.trimAutoWhitespaceLineNumbers,0!==o.length){for(let e=0,t=o.length;e<t;e++){const t=o[e];this._decorationsTree.acceptReplace(t.rangeOffset,t.rangeLength,t.text.length,t.forceMoveMarkers)}const e=[];this._increaseVersionId();let i=n;for(let n=0,s=o.length;n<s;n++){const s=o[n],[a]=h.countEOL(s.text);this._onDidChangeDecorations.fire();const l=s.range.startLineNumber,c=s.range.endLineNumber,u=c-l,g=a,f=Math.min(u,g),_=g-u,p=r-i-_+l,m=p,C=p+g,D=this._decorationsTree.getInjectedTextInInterval(this,this.getOffsetAt(new d.Position(m,1)),this.getOffsetAt(new d.Position(C,this.getLineMaxColumn(C))),0),L=w.LineInjectedText.fromDecorations(D),b=new t.ArrayQueue(L);for(let t=f;t>=0;t--){const i=l+t,n=p+t;b.takeFromEndWhile((e=>e.lineNumber>n));const s=b.takeFromEndWhile((e=>e.lineNumber===n));e.push(new w.ModelRawLineChanged(i,this.getLineContent(n),s))}if(f<u){const t=l+f;e.push(new w.ModelRawLinesDeleted(t+1,c))}if(f<g){const n=new t.ArrayQueue(L),s=l+f,o=g-f,a=r-i-o+s+1,h=[],d=[];for(let e=0;e<o;e++){const t=a+e;d[e]=this.getLineContent(t),n.takeWhile((e=>e.lineNumber<t)),h[e]=n.takeWhile((e=>e.lineNumber===t))}e.push(new w.ModelRawLinesInserted(s+1,l+g,d,h))}i+=_}this._emitContentChangedEvent(new w.ModelRawContentChangedEvent(e,this.getVersionId(),this._isUndoing,this._isRedoing),{changes:o,eol:this._buffer.getEOL(),isEolChange:!1,versionId:this.getVersionId(),isUndoing:this._isUndoing,isRedoing:this._isRedoing,isFlush:!1})}return null===s.reverseEdits?void 0:s.reverseEdits}undo(){return this._undoRedoService.undo(this.uri)}canUndo(){return this._undoRedoService.canUndo(this.uri)}redo(){return this._undoRedoService.redo(this.uri)}canRedo(){return this._undoRedoService.canRedo(this.uri)}handleBeforeFireDecorationsChangedEvent(e){if(null===e||0===e.size)return;const t=Array.from(e).map((e=>new w.ModelRawLineChanged(e,this.getLineContent(e),this._getInjectedTextInLine(e))));this._onDidChangeInjectedText.fire(new w.ModelInjectedTextChangedEvent(t))}changeDecorations(e,t=0){this._assertNotDisposed();try{return this._onDidChangeDecorations.beginDeferredEmit(),this._changeDecorations(t,e)}finally{this._onDidChangeDecorations.endDeferredEmit()}}_changeDecorations(e,t){const i={addDecoration:(t,i)=>this._deltaDecorationsImpl(e,[],[{range:t,options:i}])[0],changeDecoration:(e,t)=>{this._changeDecorationImpl(e,t)},changeDecorationOptions:(e,t)=>{this._changeDecorationOptionsImpl(e,J(t))},removeDecoration:t=>{this._deltaDecorationsImpl(e,[t],[])},deltaDecorations:(t,i)=>0===t.length&&0===i.length?[]:this._deltaDecorationsImpl(e,t,i)};let s=null;try{s=t(i)}catch(e){n.onUnexpectedError(e)}return i.addDecoration=F,i.changeDecoration=F,i.changeDecorationOptions=F,i.removeDecoration=F,i.deltaDecorations=F,s}deltaDecorations(e,t,i=0){if(this._assertNotDisposed(),e||(e=[]),0===e.length&&0===t.length)return[];try{return this._deltaDecorationCallCnt++,this._deltaDecorationCallCnt>1&&(console.warn("Invoking deltaDecorations recursively could lead to leaking decorations."),n.onUnexpectedError(new Error("Invoking deltaDecorations recursively could lead to leaking decorations."))),this._onDidChangeDecorations.beginDeferredEmit(),this._deltaDecorationsImpl(i,e,t)}finally{this._onDidChangeDecorations.endDeferredEmit(),this._deltaDecorationCallCnt--}}_getTrackedRange(e){return this.getDecorationRange(e)}_setTrackedRange(e,t,i){const n=e?this._decorations[e]:null;if(!n)return t?this._deltaDecorationsImpl(0,[],[{range:t,options:Z[i]}],!0)[0]:null;if(!t)return this._decorationsTree.delete(n),delete this._decorations[n.id],null;const s=this._validateRangeRelaxedNoAllocations(t),r=this._buffer.getOffsetAt(s.startLineNumber,s.startColumn),o=this._buffer.getOffsetAt(s.endLineNumber,s.endColumn);return this._decorationsTree.delete(n),n.reset(this.getVersionId(),r,o,s),n.setOptions(Z[i]),this._decorationsTree.insert(n),n.id}removeAllDecorationsWithOwnerId(e){if(this._isDisposed)return;const t=this._decorationsTree.collectNodesFromOwner(e);for(let e=0,i=t.length;e<i;e++){const i=t[e];this._decorationsTree.delete(i),delete this._decorations[i.id]}}getDecorationOptions(e){const t=this._decorations[e];return t?t.options:null}getDecorationRange(e){const t=this._decorations[e];return t?this._decorationsTree.getNodeRange(this,t):null}getLineDecorations(e,t=0,i=!1){return e<1||e>this.getLineCount()?[]:this.getLinesDecorations(e,e,t,i)}getLinesDecorations(e,i,n=0,s=!1,r=!1){const o=this.getLineCount(),a=Math.min(o,Math.max(1,e)),h=Math.min(o,Math.max(1,i)),l=this.getLineMaxColumn(h),d=new c.Range(a,1,h,l),u=this._getDecorationsInRange(d,n,s,r);return t.pushMany(u,this._decorationProvider.getDecorationsInRange(d,n,s)),u}getDecorationsInRange(e,i=0,n=!1,s=!1,r=!1){const o=this.validateRange(e),a=this._getDecorationsInRange(o,i,n,r);return t.pushMany(a,this._decorationProvider.getDecorationsInRange(o,i,n,s)),a}getOverviewRulerDecorations(e=0,t=!1){return this._decorationsTree.getAll(this,e,t,!0,!1)}getInjectedTextDecorations(e=0){return this._decorationsTree.getAllInjectedText(this,e)}_getInjectedTextInLine(e){const t=this._buffer.getOffsetAt(e,1),i=t+this._buffer.getLineLength(e),n=this._decorationsTree.getInjectedTextInInterval(this,t,i,0);return w.LineInjectedText.fromDecorations(n).filter((t=>t.lineNumber===e))}getAllDecorations(e=0,t=!1){let i=this._decorationsTree.getAll(this,e,t,!1,!1);return i=i.concat(this._decorationProvider.getAllDecorations(e,t)),i}getAllMarginDecorations(e=0){return this._decorationsTree.getAll(this,e,!1,!1,!0)}_getDecorationsInRange(e,t,i,n){const s=this._buffer.getOffsetAt(e.startLineNumber,e.startColumn),r=this._buffer.getOffsetAt(e.endLineNumber,e.endColumn);return this._decorationsTree.getAllInInterval(this,s,r,t,i,n)}getRangeAt(e,t){return this._buffer.getRangeAt(e,t-e)}_changeDecorationImpl(e,t){const i=this._decorations[e];if(!i)return;if(i.options.after){const t=this.getDecorationRange(e);this._onDidChangeDecorations.recordLineAffectedByInjectedText(t.endLineNumber)}if(i.options.before){const t=this.getDecorationRange(e);this._onDidChangeDecorations.recordLineAffectedByInjectedText(t.startLineNumber)}const n=this._validateRangeRelaxedNoAllocations(t),s=this._buffer.getOffsetAt(n.startLineNumber,n.startColumn),r=this._buffer.getOffsetAt(n.endLineNumber,n.endColumn);this._decorationsTree.delete(i),i.reset(this.getVersionId(),s,r,n),this._decorationsTree.insert(i),this._onDidChangeDecorations.checkAffectedAndFire(i.options),i.options.after&&this._onDidChangeDecorations.recordLineAffectedByInjectedText(n.endLineNumber),i.options.before&&this._onDidChangeDecorations.recordLineAffectedByInjectedText(n.startLineNumber)}_changeDecorationOptionsImpl(e,t){const i=this._decorations[e];if(!i)return;const n=!(!i.options.overviewRuler||!i.options.overviewRuler.color),s=!(!t.overviewRuler||!t.overviewRuler.color);if(this._onDidChangeDecorations.checkAffectedAndFire(i.options),this._onDidChangeDecorations.checkAffectedAndFire(t),i.options.after||t.after){const e=this._decorationsTree.getNodeRange(this,i);this._onDidChangeDecorations.recordLineAffectedByInjectedText(e.endLineNumber)}if(i.options.before||t.before){const e=this._decorationsTree.getNodeRange(this,i);this._onDidChangeDecorations.recordLineAffectedByInjectedText(e.startLineNumber)}const r=n!==s,o=function(e){return!!e.after||!!e.before}(t)!==B(i);r||o?(this._decorationsTree.delete(i),i.setOptions(t),this._decorationsTree.insert(i)):i.setOptions(t)}_deltaDecorationsImpl(e,t,i,n=!1){const s=this.getVersionId(),r=t.length;let o=0;const a=i.length;let h=0;this._onDidChangeDecorations.beginDeferredEmit();try{const l=new Array(a);for(;o<r||h<a;){let d=null;if(o<r){do{d=this._decorations[t[o++]]}while(!d&&o<r);if(d){if(d.options.after){const e=this._decorationsTree.getNodeRange(this,d);this._onDidChangeDecorations.recordLineAffectedByInjectedText(e.endLineNumber)}if(d.options.before){const e=this._decorationsTree.getNodeRange(this,d);this._onDidChangeDecorations.recordLineAffectedByInjectedText(e.startLineNumber)}this._decorationsTree.delete(d),n||this._onDidChangeDecorations.checkAffectedAndFire(d.options)}}if(h<a){if(!d){const e=++this._lastDecorationId,t=`${this._instanceId};${e}`;d=new v.IntervalNode(t,0,0),this._decorations[t]=d}const t=i[h],r=this._validateRangeRelaxedNoAllocations(t.range),o=J(t.options),a=this._buffer.getOffsetAt(r.startLineNumber,r.startColumn),c=this._buffer.getOffsetAt(r.endLineNumber,r.endColumn);d.ownerId=e,d.reset(s,a,c,r),d.setOptions(o),d.options.after&&this._onDidChangeDecorations.recordLineAffectedByInjectedText(r.endLineNumber),d.options.before&&this._onDidChangeDecorations.recordLineAffectedByInjectedText(r.startLineNumber),n||this._onDidChangeDecorations.checkAffectedAndFire(o),this._decorationsTree.insert(d),l[h]=d.id,h++}else d&&delete this._decorations[d.id]}return l}finally{this._onDidChangeDecorations.endDeferredEmit()}}getLanguageId(){return this.tokenization.getLanguageId()}setLanguage(e,t){"string"==typeof e?(this._languageSelectionListener.clear(),this._setLanguage(e,t)):(this._languageSelectionListener.value=e.onDidChange((()=>this._setLanguage(e.languageId,t))),this._setLanguage(e.languageId,t))}_setLanguage(e,t){this.tokenization.setLanguageId(e,t),this._languageService.requestRichLanguageFeatures(e)}getLanguageIdAtPosition(e,t){return this.tokenization.getLanguageIdAtPosition(e,t)}getWordAtPosition(e){return this._tokenizationTextModelPart.getWordAtPosition(e)}getWordUntilPosition(e){return this._tokenizationTextModelPart.getWordUntilPosition(e)}normalizePosition(e,t){return e}getLineIndentColumn(e){return z(this.getLineContent(e))+1}},exports.TextModel=e=M([A(4,x.IUndoRedoService),A(5,f.ILanguageService),A(6,_.ILanguageConfigurationService),A(7,O.IInstantiationService)],exports.TextModel);class U{constructor(){this._decorationsTree0=new v.IntervalTree,this._decorationsTree1=new v.IntervalTree,this._injectedTextDecorationsTree=new v.IntervalTree}ensureAllNodesHaveRanges(e){this.getAll(e,0,!1,!1,!1)}_ensureNodesHaveRanges(e,t){for(const i of t)null===i.range&&(i.range=e.getRangeAt(i.cachedAbsoluteStart,i.cachedAbsoluteEnd));return t}getAllInInterval(e,t,i,n,s,r){const o=e.getVersionId(),a=this._intervalSearch(t,i,n,s,o,r);return this._ensureNodesHaveRanges(e,a)}_intervalSearch(e,t,i,n,s,r){const o=this._decorationsTree0.intervalSearch(e,t,i,n,s,r),a=this._decorationsTree1.intervalSearch(e,t,i,n,s,r),h=this._injectedTextDecorationsTree.intervalSearch(e,t,i,n,s,r);return o.concat(a).concat(h)}getInjectedTextInInterval(e,t,i,n){const s=e.getVersionId(),r=this._injectedTextDecorationsTree.intervalSearch(t,i,n,!1,s,!1);return this._ensureNodesHaveRanges(e,r).filter((e=>e.options.showIfCollapsed||!e.range.isEmpty()))}getAllInjectedText(e,t){const i=e.getVersionId(),n=this._injectedTextDecorationsTree.search(t,!1,i,!1);return this._ensureNodesHaveRanges(e,n).filter((e=>e.options.showIfCollapsed||!e.range.isEmpty()))}getAll(e,t,i,n,s){const r=e.getVersionId(),o=this._search(t,i,n,r,s);return this._ensureNodesHaveRanges(e,o)}_search(e,t,i,n,s){if(i)return this._decorationsTree1.search(e,t,n,s);{const i=this._decorationsTree0.search(e,t,n,s),r=this._decorationsTree1.search(e,t,n,s),o=this._injectedTextDecorationsTree.search(e,t,n,s);return i.concat(r).concat(o)}}collectNodesFromOwner(e){const t=this._decorationsTree0.collectNodesFromOwner(e),i=this._decorationsTree1.collectNodesFromOwner(e),n=this._injectedTextDecorationsTree.collectNodesFromOwner(e);return t.concat(i).concat(n)}collectNodesPostOrder(){const e=this._decorationsTree0.collectNodesPostOrder(),t=this._decorationsTree1.collectNodesPostOrder(),i=this._injectedTextDecorationsTree.collectNodesPostOrder();return e.concat(t).concat(i)}insert(e){B(e)?this._injectedTextDecorationsTree.insert(e):V(e)?this._decorationsTree1.insert(e):this._decorationsTree0.insert(e)}delete(e){B(e)?this._injectedTextDecorationsTree.delete(e):V(e)?this._decorationsTree1.delete(e):this._decorationsTree0.delete(e)}getNodeRange(e,t){const i=e.getVersionId();return t.cachedVersionId!==i&&this._resolveNode(t,i),null===t.range&&(t.range=e.getRangeAt(t.cachedAbsoluteStart,t.cachedAbsoluteEnd)),t.range}_resolveNode(e,t){B(e)?this._injectedTextDecorationsTree.resolveNode(e,t):V(e)?this._decorationsTree1.resolveNode(e,t):this._decorationsTree0.resolveNode(e,t)}acceptReplace(e,t,i,n){this._decorationsTree0.acceptReplace(e,t,i,n),this._decorationsTree1.acceptReplace(e,t,i,n),this._injectedTextDecorationsTree.acceptReplace(e,t,i,n)}}function H(e){return e.replace(/[^a-z0-9\-_]/gi," ")}class W{constructor(e){this.color=e.color||"",this.darkColor=e.darkColor||""}}class q extends W{constructor(e){super(e),this._resolvedColor=null,this.position="number"==typeof e.position?e.position:p.OverviewRulerLane.Center}getColor(e){return this._resolvedColor||("light"!==e.type&&this.darkColor?this._resolvedColor=this._resolveColor(this.darkColor,e):this._resolvedColor=this._resolveColor(this.color,e)),this._resolvedColor}invalidateCachedColor(){this._resolvedColor=null}_resolveColor(e,t){if("string"==typeof e)return e;const i=e?t.getColor(e.id):null;return i?i.toString():""}}class G{constructor(e){this.position=e?.position??p.GlyphMarginLane.Center,this.persistLane=e?.persistLane}}class Y extends W{constructor(e){super(e),this.position=e.position,this.sectionHeaderStyle=e.sectionHeaderStyle??null,this.sectionHeaderText=e.sectionHeaderText??null}getColor(e){return this._resolvedColor||("light"!==e.type&&this.darkColor?this._resolvedColor=this._resolveColor(this.darkColor,e):this._resolvedColor=this._resolveColor(this.color,e)),this._resolvedColor}invalidateCachedColor(){this._resolvedColor=void 0}_resolveColor(e,t){return"string"==typeof e?i.Color.fromHex(e):t.getColor(e.id)}}class ${static from(e){return e instanceof $?e:new $(e)}constructor(e){this.content=e.content||"",this.inlineClassName=e.inlineClassName||null,this.inlineClassNameAffectsLetterSpacing=e.inlineClassNameAffectsLetterSpacing||!1,this.attachedData=e.attachedData||null,this.cursorStops=e.cursorStops||null}}class Q{static register(e){return new Q(e)}static createDynamic(e){return new Q(e)}constructor(e){this.description=e.description,this.blockClassName=e.blockClassName?H(e.blockClassName):null,this.blockDoesNotCollapse=e.blockDoesNotCollapse??null,this.blockIsAfterEnd=e.blockIsAfterEnd??null,this.blockPadding=e.blockPadding??null,this.stickiness=e.stickiness||0,this.zIndex=e.zIndex||0,this.className=e.className?H(e.className):null,this.shouldFillLineOnLineBreak=e.shouldFillLineOnLineBreak??null,this.hoverMessage=e.hoverMessage||null,this.glyphMarginHoverMessage=e.glyphMarginHoverMessage||null,this.lineNumberHoverMessage=e.lineNumberHoverMessage||null,this.isWholeLine=e.isWholeLine||!1,this.showIfCollapsed=e.showIfCollapsed||!1,this.collapseOnReplaceEdit=e.collapseOnReplaceEdit||!1,this.overviewRuler=e.overviewRuler?new q(e.overviewRuler):null,this.minimap=e.minimap?new Y(e.minimap):null,this.glyphMargin=e.glyphMarginClassName?new G(e.glyphMargin):null,this.glyphMarginClassName=e.glyphMarginClassName?H(e.glyphMarginClassName):null,this.linesDecorationsClassName=e.linesDecorationsClassName?H(e.linesDecorationsClassName):null,this.lineNumberClassName=e.lineNumberClassName?H(e.lineNumberClassName):null,this.linesDecorationsTooltip=e.linesDecorationsTooltip?o.htmlAttributeEncodeValue(e.linesDecorationsTooltip):null,this.firstLineDecorationClassName=e.firstLineDecorationClassName?H(e.firstLineDecorationClassName):null,this.marginClassName=e.marginClassName?H(e.marginClassName):null,this.inlineClassName=e.inlineClassName?H(e.inlineClassName):null,this.inlineClassNameAffectsLetterSpacing=e.inlineClassNameAffectsLetterSpacing||!1,this.beforeContentClassName=e.beforeContentClassName?H(e.beforeContentClassName):null,this.afterContentClassName=e.afterContentClassName?H(e.afterContentClassName):null,this.after=e.after?$.from(e.after):null,this.before=e.before?$.from(e.before):null,this.hideInCommentTokens=e.hideInCommentTokens??!1,this.hideInStringTokens=e.hideInStringTokens??!1}}Q.EMPTY=Q.register({description:"empty"});const Z=[Q.register({description:"tracked-range-always-grows-when-typing-at-edges",stickiness:0}),Q.register({description:"tracked-range-never-grows-when-typing-at-edges",stickiness:1}),Q.register({description:"tracked-range-grows-only-when-typing-before",stickiness:2}),Q.register({description:"tracked-range-grows-only-when-typing-after",stickiness:3})];function J(e){return e instanceof Q?e:Q.createDynamic(e)}class K extends r.Disposable{constructor(e){super(),this.handleBeforeFire=e,this._actual=this._register(new s.Emitter),this.event=this._actual.event,this._affectedInjectedTextLines=null,this._deferredCnt=0,this._shouldFireDeferred=!1,this._affectsMinimap=!1,this._affectsOverviewRuler=!1,this._affectsGlyphMargin=!1,this._affectsLineNumber=!1}beginDeferredEmit(){this._deferredCnt++}endDeferredEmit(){this._deferredCnt--,0===this._deferredCnt&&(this._shouldFireDeferred&&this.doFire(),this._affectedInjectedTextLines?.clear(),this._affectedInjectedTextLines=null)}recordLineAffectedByInjectedText(e){this._affectedInjectedTextLines||(this._affectedInjectedTextLines=new Set),this._affectedInjectedTextLines.add(e)}checkAffectedAndFire(e){this._affectsMinimap||=!!e.minimap?.position,this._affectsOverviewRuler||=!!e.overviewRuler?.color,this._affectsGlyphMargin||=!!e.glyphMarginClassName,this._affectsLineNumber||=!!e.lineNumberClassName,this.tryFire()}fire(){this._affectsMinimap=!0,this._affectsOverviewRuler=!0,this._affectsGlyphMargin=!0,this.tryFire()}tryFire(){0===this._deferredCnt?this.doFire():this._shouldFireDeferred=!0}doFire(){this.handleBeforeFire(this._affectedInjectedTextLines);const e={affectsMinimap:this._affectsMinimap,affectsOverviewRuler:this._affectsOverviewRuler,affectsGlyphMargin:this._affectsGlyphMargin,affectsLineNumber:this._affectsLineNumber};this._shouldFireDeferred=!1,this._affectsMinimap=!1,this._affectsOverviewRuler=!1,this._affectsGlyphMargin=!1,this._actual.fire(e)}}class X extends r.Disposable{constructor(){super(),this._fastEmitter=this._register(new s.Emitter),this.fastEvent=this._fastEmitter.event,this._slowEmitter=this._register(new s.Emitter),this.slowEvent=this._slowEmitter.event,this._deferredCnt=0,this._deferredEvent=null}beginDeferredEmit(){this._deferredCnt++}endDeferredEmit(e=null){if(this._deferredCnt--,0===this._deferredCnt&&null!==this._deferredEvent){this._deferredEvent.rawContentChangedEvent.resultingSelection=e;const t=this._deferredEvent;this._deferredEvent=null,this._fastEmitter.fire(t),this._slowEmitter.fire(t)}}fire(e){this._deferredCnt>0?this._deferredEvent?this._deferredEvent=this._deferredEvent.merge(e):this._deferredEvent=e:(this._fastEmitter.fire(e),this._slowEmitter.fire(e))}}exports.ModelDecorationGlyphMarginOptions=G,exports.ModelDecorationInjectedTextOptions=$,exports.ModelDecorationMinimapOptions=Y,exports.ModelDecorationOptions=Q,exports.ModelDecorationOverviewRulerOptions=q,exports.createTextBuffer=P,exports.createTextBufferFactory=S,exports.createTextBufferFactoryFromSnapshot=y,exports.indentOfLine=z;
//# sourceMappingURL=textModel.js.map
