"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var e=require("../../../base/common/async.js"),t=require("../../../base/common/errors.js"),n=require("../../../base/common/platform.js"),i=require("../../../base/common/stopwatch.js"),s=require("../core/eolCounter.js"),r=require("../core/lineRange.js"),a=require("../core/offsetRange.js"),o=require("../languages/nullTokenize.js"),d=require("./fixedArray.js"),l=require("../tokens/contiguousMultilineTokensBuilder.js"),u=require("../tokens/lineTokens.js");class h{constructor(e,t){this.tokenizationSupport=t,this.initialState=this.tokenizationSupport.getInitialState(),this.store=new g(e)}getStartState(e){return this.store.getStartState(e,this.initialState)}getFirstInvalidLine(){return this.store.getFirstInvalidLine(this.initialState)}}class g{constructor(e){this.lineCount=e,this._tokenizationStateStore=new c,this._invalidEndStatesLineNumbers=new S,this._invalidEndStatesLineNumbers.addRange(new a.OffsetRange(1,e+1))}getEndState(e){return this._tokenizationStateStore.getEndState(e)}setEndState(e,n){if(!n)throw new t.BugIndicatingError("Cannot set null/undefined state");this._invalidEndStatesLineNumbers.delete(e);const i=this._tokenizationStateStore.setEndState(e,n);return i&&e<this.lineCount&&this._invalidEndStatesLineNumbers.addRange(new a.OffsetRange(e+1,e+2)),i}acceptChange(e,t){this.lineCount+=t-e.length,this._tokenizationStateStore.acceptChange(e,t),this._invalidEndStatesLineNumbers.addRangeAndResize(new a.OffsetRange(e.startLineNumber,e.endLineNumberExclusive),t)}acceptChanges(e){for(const t of e){const[e]=s.countEOL(t.text);this.acceptChange(new r.LineRange(t.range.startLineNumber,t.range.endLineNumber+1),e+1)}}invalidateEndStateRange(e){this._invalidEndStatesLineNumbers.addRange(new a.OffsetRange(e.startLineNumber,e.endLineNumberExclusive))}getFirstInvalidEndStateLineNumber(){return this._invalidEndStatesLineNumbers.min}getFirstInvalidEndStateLineNumberOrMax(){return this.getFirstInvalidEndStateLineNumber()||Number.MAX_SAFE_INTEGER}allStatesValid(){return null===this._invalidEndStatesLineNumbers.min}getStartState(e,t){return 1===e?t:this.getEndState(e-1)}getFirstInvalidLine(e){const n=this.getFirstInvalidEndStateLineNumber();if(null===n)return null;const i=this.getStartState(n,e);if(!i)throw new t.BugIndicatingError("Start state must be defined");return{lineNumber:n,startState:i}}}class c{constructor(){this._lineEndStates=new d.FixedArray(null)}getEndState(e){return this._lineEndStates.get(e)}setEndState(e,t){const n=this._lineEndStates.get(e);return(!n||!n.equals(t))&&(this._lineEndStates.set(e,t),!0)}acceptChange(e,t){let n=e.length;t>0&&n>0&&(n--,t--),this._lineEndStates.replace(e.startLineNumber,n,t)}}class S{constructor(){this._ranges=[]}get min(){return 0===this._ranges.length?null:this._ranges[0].start}delete(e){const t=this._ranges.findIndex((t=>t.contains(e)));if(-1!==t){const n=this._ranges[t];n.start===e?n.endExclusive===e+1?this._ranges.splice(t,1):this._ranges[t]=new a.OffsetRange(e+1,n.endExclusive):n.endExclusive===e+1?this._ranges[t]=new a.OffsetRange(n.start,e):this._ranges.splice(t,1,new a.OffsetRange(n.start,e),new a.OffsetRange(e+1,n.endExclusive))}}addRange(e){a.OffsetRange.addRange(e,this._ranges)}addRangeAndResize(e,t){let n=0;for(;!(n>=this._ranges.length||e.start<=this._ranges[n].endExclusive);)n++;let i=n;for(;!(i>=this._ranges.length||e.endExclusive<this._ranges[i].start);)i++;const s=t-e.length;for(let e=i;e<this._ranges.length;e++)this._ranges[e]=this._ranges[e].delta(s);if(n===i){const i=new a.OffsetRange(e.start,e.start+t);i.isEmpty||this._ranges.splice(n,0,i)}else{const t=Math.min(e.start,this._ranges[n].start),r=Math.max(e.endExclusive,this._ranges[i-1].endExclusive),o=new a.OffsetRange(t,r+s);o.isEmpty?this._ranges.splice(n,i-n):this._ranges.splice(n,i-n,o)}}toString(){return this._ranges.map((e=>e.toString())).join(" + ")}}function _(e,n,i,s,r,a){let d=null;if(i)try{d=i.tokenizeEncoded(s,r,a.clone())}catch(e){t.onUnexpectedError(e)}return d||(d=o.nullTokenizeEncoded(e.encodeLanguageId(n),a)),u.LineTokens.convertToEndOffset(d.tokens,s.length),d}exports.DefaultBackgroundTokenizer=class{constructor(e,t){this._tokenizerWithStateStore=e,this._backgroundTokenStore=t,this._isDisposed=!1,this._isScheduled=!1}dispose(){this._isDisposed=!0}handleChanges(){this._beginBackgroundTokenization()}_beginBackgroundTokenization(){!this._isScheduled&&this._tokenizerWithStateStore._textModel.isAttachedToEditor()&&this._hasLinesToTokenize()&&(this._isScheduled=!0,e.runWhenGlobalIdle((e=>{this._isScheduled=!1,this._backgroundTokenizeWithDeadline(e)})))}_backgroundTokenizeWithDeadline(e){const t=Date.now()+e.timeRemaining(),i=()=>{!this._isDisposed&&this._tokenizerWithStateStore._textModel.isAttachedToEditor()&&this._hasLinesToTokenize()&&(this._backgroundTokenizeForAtLeast1ms(),Date.now()<t?n.setTimeout0(i):this._beginBackgroundTokenization())};i()}_backgroundTokenizeForAtLeast1ms(){const e=this._tokenizerWithStateStore._textModel.getLineCount(),t=new l.ContiguousMultilineTokensBuilder,n=i.StopWatch.create(!1);do{if(n.elapsed()>1)break;if(this._tokenizeOneInvalidLine(t)>=e)break}while(this._hasLinesToTokenize());this._backgroundTokenStore.setTokens(t.finalize()),this.checkFinished()}_hasLinesToTokenize(){return!!this._tokenizerWithStateStore&&!this._tokenizerWithStateStore.store.allStatesValid()}_tokenizeOneInvalidLine(e){const t=this._tokenizerWithStateStore?.getFirstInvalidLine();return t?(this._tokenizerWithStateStore.updateTokensUntilLine(e,t.lineNumber),t.lineNumber):this._tokenizerWithStateStore._textModel.getLineCount()+1}checkFinished(){this._isDisposed||this._tokenizerWithStateStore.store.allStatesValid()&&this._backgroundTokenStore.backgroundTokenizationFinished()}requestTokens(e,t){this._tokenizerWithStateStore.store.invalidateEndStateRange(new r.LineRange(e,t))}},exports.RangePriorityQueueImpl=S,exports.TokenizationStateStore=c,exports.TokenizerWithStateStore=h,exports.TokenizerWithStateStoreAndTextModel=class extends h{constructor(e,t,n,i){super(e,t),this._textModel=n,this._languageIdCodec=i}updateTokensUntilLine(e,t){const n=this._textModel.getLanguageId();for(;;){const i=this.getFirstInvalidLine();if(!i||i.lineNumber>t)break;const s=this._textModel.getLineContent(i.lineNumber),r=_(this._languageIdCodec,n,this.tokenizationSupport,s,!0,i.startState);e.add(i.lineNumber,r.tokens),this.store.setEndState(i.lineNumber,r.endState)}}getTokenTypeIfInsertingCharacter(e,t){const n=this.getStartState(e.lineNumber);if(!n)return 0;const i=this._textModel.getLanguageId(),s=this._textModel.getLineContent(e.lineNumber),r=s.substring(0,e.column-1)+t+s.substring(e.column-1),a=_(this._languageIdCodec,i,this.tokenizationSupport,r,!0,n),o=new u.LineTokens(a.tokens,r,this._languageIdCodec);if(0===o.getCount())return 0;const d=o.findTokenIndexAtOffset(e.column-1);return o.getStandardTokenType(d)}tokenizeLineWithEdit(e,t,n){const i=e.lineNumber,s=e.column,r=this.getStartState(i);if(!r)return null;const a=this._textModel.getLineContent(i),o=a.substring(0,s-1)+n+a.substring(s-1+t),d=this._textModel.getLanguageIdAtPosition(i,0),l=_(this._languageIdCodec,d,this.tokenizationSupport,o,!0,r);return new u.LineTokens(l.tokens,o,this._languageIdCodec)}hasAccurateTokensForLine(e){return e<this.store.getFirstInvalidEndStateLineNumberOrMax()}isCheapToTokenize(e){const t=this.store.getFirstInvalidEndStateLineNumberOrMax();return e<t||e===t&&this._textModel.getLineLength(e)<2048}tokenizeHeuristically(e,t,n){if(n<=this.store.getFirstInvalidEndStateLineNumberOrMax())return{heuristicTokens:!1};if(t<=this.store.getFirstInvalidEndStateLineNumberOrMax())return this.updateTokensUntilLine(e,n),{heuristicTokens:!1};let i=this.guessStartState(t);const s=this._textModel.getLanguageId();for(let r=t;r<=n;r++){const t=this._textModel.getLineContent(r),n=_(this._languageIdCodec,s,this.tokenizationSupport,t,!0,i);e.add(r,n.tokens),i=n.endState}return{heuristicTokens:!0}}guessStartState(e){let t=this._textModel.getLineFirstNonWhitespaceColumn(e);const n=[];let i=null;for(let s=e-1;t>1&&s>=1;s--){const e=this._textModel.getLineFirstNonWhitespaceColumn(s);if(0!==e&&(e<t&&(n.push(this._textModel.getLineContent(s)),t=e,i=this.getStartState(s),i)))break}i||(i=this.tokenizationSupport.getInitialState()),n.reverse();const s=this._textModel.getLanguageId();let r=i;for(const e of n){r=_(this._languageIdCodec,s,this.tokenizationSupport,e,!1,r).endState}return r}},exports.TrackingTokenizationStateStore=g;
//# sourceMappingURL=textModelTokens.js.map
