"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var e,t=require("../../../base/common/event.js"),o=require("../../../base/common/lifecycle.js"),i=require("../../../base/common/platform.js"),s=require("../model/textModel.js"),n=require("../core/textModelDefaults.js"),r=require("../languages/modesRegistry.js"),d=require("./textResourceConfiguration.js"),a=require("../../../platform/configuration/common/configuration.js"),l=require("../../../platform/undoRedo/common/undoRedo.js"),c=require("../../../base/common/hash.js"),u=require("../model/editStack.js"),h=require("../../../base/common/network.js"),p=require("../../../base/common/objects.js"),S=require("../../../platform/instantiation/common/instantiation.js"),m=self&&self.__decorate||function(e,t,o,i){var s,n=arguments.length,r=n<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,o):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,o,i);else for(var d=e.length-1;d>=0;d--)(s=e[d])&&(r=(n<3?s(r):n>3?s(t,o,r):s(t,o))||r);return n>3&&r&&Object.defineProperty(t,o,r),r},_=self&&self.__param||function(e,t){return function(o,i){t(o,i,e)}};function g(e){return e.toString()}class f{constructor(e,t,i){this.model=e,this._modelEventListeners=new o.DisposableStore,this.model=e,this._modelEventListeners.add(e.onWillDispose((()=>t(e)))),this._modelEventListeners.add(e.onDidChangeLanguage((t=>i(e,t))))}dispose(){this._modelEventListeners.dispose()}}const M=i.isLinux||i.isMacintosh?1:2;class O{constructor(e,t,o,i,s,n,r,d){this.uri=e,this.initialUndoRedoSnapshot=t,this.time=o,this.sharesUndoRedoStack=i,this.heapSize=s,this.sha1=n,this.versionId=r,this.alternativeVersionId=d}}exports.ModelService=class extends o.Disposable{static{e=this}static{this.MAX_MEMORY_FOR_CLOSED_FILES_UNDO_STACK=20971520}constructor(e,o,i,s){super(),this._configurationService=e,this._resourcePropertiesService=o,this._undoRedoService=i,this._instantiationService=s,this._onModelAdded=this._register(new t.Emitter),this.onModelAdded=this._onModelAdded.event,this._onModelRemoved=this._register(new t.Emitter),this.onModelRemoved=this._onModelRemoved.event,this._onModelModeChanged=this._register(new t.Emitter),this.onModelLanguageChanged=this._onModelModeChanged.event,this._modelCreationOptionsByLanguageAndResource=Object.create(null),this._models={},this._disposedModels=new Map,this._disposedModelsHeapSize=0,this._register(this._configurationService.onDidChangeConfiguration((e=>this._updateModelOptions(e)))),this._updateModelOptions(void 0)}static _readModelOptions(e,t){let o=n.EDITOR_MODEL_DEFAULTS.tabSize;if(e.editor&&void 0!==e.editor.tabSize){const t=parseInt(e.editor.tabSize,10);isNaN(t)||(o=t),o<1&&(o=1)}let i="tabSize";if(e.editor&&void 0!==e.editor.indentSize&&"tabSize"!==e.editor.indentSize){const t=parseInt(e.editor.indentSize,10);isNaN(t)||(i=Math.max(t,1))}let s=n.EDITOR_MODEL_DEFAULTS.insertSpaces;e.editor&&void 0!==e.editor.insertSpaces&&(s="false"!==e.editor.insertSpaces&&Boolean(e.editor.insertSpaces));let r=M;const d=e.eol;"\r\n"===d?r=2:"\n"===d&&(r=1);let a=n.EDITOR_MODEL_DEFAULTS.trimAutoWhitespace;e.editor&&void 0!==e.editor.trimAutoWhitespace&&(a="false"!==e.editor.trimAutoWhitespace&&Boolean(e.editor.trimAutoWhitespace));let l=n.EDITOR_MODEL_DEFAULTS.detectIndentation;e.editor&&void 0!==e.editor.detectIndentation&&(l="false"!==e.editor.detectIndentation&&Boolean(e.editor.detectIndentation));let c=n.EDITOR_MODEL_DEFAULTS.largeFileOptimizations;e.editor&&void 0!==e.editor.largeFileOptimizations&&(c="false"!==e.editor.largeFileOptimizations&&Boolean(e.editor.largeFileOptimizations));let u=n.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions;return e.editor?.bracketPairColorization&&"object"==typeof e.editor.bracketPairColorization&&(u={enabled:!!e.editor.bracketPairColorization.enabled,independentColorPoolPerBracketType:!!e.editor.bracketPairColorization.independentColorPoolPerBracketType}),{isForSimpleWidget:t,tabSize:o,indentSize:i,insertSpaces:s,detectIndentation:l,defaultEOL:r,trimAutoWhitespace:a,largeFileOptimizations:c,bracketPairColorizationOptions:u}}_getEOL(e,t){if(e)return this._resourcePropertiesService.getEOL(e,t);const o=this._configurationService.getValue("files.eol",{overrideIdentifier:t});return o&&"string"==typeof o&&"auto"!==o?o:3===i.OS||2===i.OS?"\n":"\r\n"}_shouldRestoreUndoStack(){const e=this._configurationService.getValue("files.restoreUndoStack");return"boolean"!=typeof e||e}getCreationOptions(t,o,i){const s="string"==typeof t?t:t.languageId;let n=this._modelCreationOptionsByLanguageAndResource[s+o];if(!n){const t=this._configurationService.getValue("editor",{overrideIdentifier:s,resource:o}),r=this._getEOL(o,s);n=e._readModelOptions({editor:t,eol:r},i),this._modelCreationOptionsByLanguageAndResource[s+o]=n}return n}_updateModelOptions(t){const o=this._modelCreationOptionsByLanguageAndResource;this._modelCreationOptionsByLanguageAndResource=Object.create(null);const i=Object.keys(this._models);for(let s=0,n=i.length;s<n;s++){const n=i[s],r=this._models[n],d=r.model.getLanguageId(),a=r.model.uri;if(t&&!t.affectsConfiguration("editor",{overrideIdentifier:d,resource:a})&&!t.affectsConfiguration("files.eol",{overrideIdentifier:d,resource:a}))continue;const l=o[d+a],c=this.getCreationOptions(d,a,r.model.isForSimpleWidget);e._setModelOptionsForModel(r.model,c,l)}}static _setModelOptionsForModel(e,t,o){o&&o.defaultEOL!==t.defaultEOL&&1===e.getLineCount()&&e.setEOL(1===t.defaultEOL?0:1),o&&o.detectIndentation===t.detectIndentation&&o.insertSpaces===t.insertSpaces&&o.tabSize===t.tabSize&&o.indentSize===t.indentSize&&o.trimAutoWhitespace===t.trimAutoWhitespace&&p.equals(o.bracketPairColorizationOptions,t.bracketPairColorizationOptions)||(t.detectIndentation?(e.detectIndentation(t.insertSpaces,t.tabSize),e.updateOptions({trimAutoWhitespace:t.trimAutoWhitespace,bracketColorizationOptions:t.bracketPairColorizationOptions})):e.updateOptions({insertSpaces:t.insertSpaces,tabSize:t.tabSize,indentSize:t.indentSize,trimAutoWhitespace:t.trimAutoWhitespace,bracketColorizationOptions:t.bracketPairColorizationOptions}))}_insertDisposedModel(e){this._disposedModels.set(g(e.uri),e),this._disposedModelsHeapSize+=e.heapSize}_removeDisposedModel(e){const t=this._disposedModels.get(g(e));return t&&(this._disposedModelsHeapSize-=t.heapSize),this._disposedModels.delete(g(e)),t}_ensureDisposedModelsHeapSize(e){if(this._disposedModelsHeapSize>e){const t=[];for(this._disposedModels.forEach((e=>{e.sharesUndoRedoStack||t.push(e)})),t.sort(((e,t)=>e.time-t.time));t.length>0&&this._disposedModelsHeapSize>e;){const e=t.shift();this._removeDisposedModel(e.uri),null!==e.initialUndoRedoSnapshot&&this._undoRedoService.restoreSnapshot(e.initialUndoRedoSnapshot)}}}_createModelData(e,t,o,i){const n=this.getCreationOptions(t,o,i),r=this._instantiationService.createInstance(s.TextModel,e,t,n,o);if(o&&this._disposedModels.has(g(o))){const e=this._removeDisposedModel(o),t=this._undoRedoService.getElements(o),i=this._getSHA1Computer(),s=!!i.canComputeSHA1(r)&&i.computeSHA1(r)===e.sha1;if(s||e.sharesUndoRedoStack){for(const e of t.past)u.isEditStackElement(e)&&e.matchesResource(o)&&e.setModel(r);for(const e of t.future)u.isEditStackElement(e)&&e.matchesResource(o)&&e.setModel(r);this._undoRedoService.setElementsValidFlag(o,!0,(e=>u.isEditStackElement(e)&&e.matchesResource(o))),s&&(r._overwriteVersionId(e.versionId),r._overwriteAlternativeVersionId(e.alternativeVersionId),r._overwriteInitialUndoRedoSnapshot(e.initialUndoRedoSnapshot))}else null!==e.initialUndoRedoSnapshot&&this._undoRedoService.restoreSnapshot(e.initialUndoRedoSnapshot)}const d=g(r.uri);if(this._models[d])throw new Error("ModelService: Cannot add model because it already exists!");const a=new f(r,(e=>this._onWillDispose(e)),((e,t)=>this._onDidChangeLanguage(e,t)));return this._models[d]=a,a}createModel(e,t,o,i=!1){let s;return s=t?this._createModelData(e,t,o,i):this._createModelData(e,r.PLAINTEXT_LANGUAGE_ID,o,i),this._onModelAdded.fire(s.model),s.model}getModels(){const e=[],t=Object.keys(this._models);for(let o=0,i=t.length;o<i;o++){const i=t[o];e.push(this._models[i].model)}return e}getModel(e){const t=g(e),o=this._models[t];return o?o.model:null}_schemaShouldMaintainUndoRedoElements(e){return e.scheme===h.Schemas.file||e.scheme===h.Schemas.vscodeRemote||e.scheme===h.Schemas.vscodeUserData||e.scheme===h.Schemas.vscodeNotebookCell||"fake-fs"===e.scheme}_onWillDispose(t){const o=g(t.uri),i=this._models[o],s=this._undoRedoService.getUriComparisonKey(t.uri)!==t.uri.toString();let n=!1,r=0;if(s||this._shouldRestoreUndoStack()&&this._schemaShouldMaintainUndoRedoElements(t.uri)){const e=this._undoRedoService.getElements(t.uri);if(e.past.length>0||e.future.length>0){for(const o of e.past)u.isEditStackElement(o)&&o.matchesResource(t.uri)&&(n=!0,r+=o.heapSize(t.uri),o.setModel(t.uri));for(const o of e.future)u.isEditStackElement(o)&&o.matchesResource(t.uri)&&(n=!0,r+=o.heapSize(t.uri),o.setModel(t.uri))}}const d=e.MAX_MEMORY_FOR_CLOSED_FILES_UNDO_STACK,a=this._getSHA1Computer();if(n)if(s||!(r>d)&&a.canComputeSHA1(t))this._ensureDisposedModelsHeapSize(d-r),this._undoRedoService.setElementsValidFlag(t.uri,!1,(e=>u.isEditStackElement(e)&&e.matchesResource(t.uri))),this._insertDisposedModel(new O(t.uri,i.model.getInitialUndoRedoSnapshot(),Date.now(),s,r,a.computeSHA1(t),t.getVersionId(),t.getAlternativeVersionId()));else{const e=i.model.getInitialUndoRedoSnapshot();null!==e&&this._undoRedoService.restoreSnapshot(e)}else if(!s){const e=i.model.getInitialUndoRedoSnapshot();null!==e&&this._undoRedoService.restoreSnapshot(e)}delete this._models[o],i.dispose(),delete this._modelCreationOptionsByLanguageAndResource[t.getLanguageId()+t.uri],this._onModelRemoved.fire(t)}_onDidChangeLanguage(t,o){const i=o.oldLanguage,s=t.getLanguageId(),n=this.getCreationOptions(i,t.uri,t.isForSimpleWidget),r=this.getCreationOptions(s,t.uri,t.isForSimpleWidget);e._setModelOptionsForModel(t,r,n),this._onModelModeChanged.fire({model:t,oldLanguageId:i})}_getSHA1Computer(){return new v}},exports.ModelService=e=m([_(0,a.IConfigurationService),_(1,d.ITextResourcePropertiesService),_(2,l.IUndoRedoService),_(3,S.IInstantiationService)],exports.ModelService);class v{static{this.MAX_MODEL_SIZE=10485760}canComputeSHA1(e){return e.getValueLength()<=v.MAX_MODEL_SIZE}computeSHA1(e){const t=new c.StringSHA1,o=e.createSnapshot();let i;for(;i=o.read();)t.update(i);return t.digest()}}exports.DefaultModelSHA1Computer=v;
//# sourceMappingURL=modelService.js.map
