"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var e=require("../../../platform/theme/common/themeService.js"),t=require("../../../platform/log/common/log.js"),n=require("../tokens/sparseMultilineTokens.js"),i=require("../languages/language.js"),s=self&&self.__decorate||function(e,t,n,i){var s,r=arguments.length,a=r<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)a=Reflect.decorate(e,t,n,i);else for(var o=e.length-1;o>=0;o--)(s=e[o])&&(a=(r<3?s(a):r>3?s(t,n,a):s(t,n))||a);return r>3&&a&&Object.defineProperty(t,n,a),a},r=self&&self.__param||function(e,t){return function(n,i){t(n,i,e)}};exports.SemanticTokensProviderStyling=class{constructor(e,t,n,i){this._legend=e,this._themeService=t,this._languageService=n,this._logService=i,this._hasWarnedOverlappingTokens=!1,this._hasWarnedInvalidLengthTokens=!1,this._hasWarnedInvalidEditStart=!1,this._hashTable=new o}getMetadata(e,t,n){const i=this._languageService.languageIdCodec.encodeLanguageId(n),s=this._hashTable.get(e,t,i);let r;if(s)r=s.metadata;else{let s=this._legend.tokenTypes[e];const a=[];if(s){let e=t;for(let t=0;e>0&&t<this._legend.tokenModifiers.length;t++)1&e&&a.push(this._legend.tokenModifiers[t]),e>>=1;const i=this._themeService.getColorTheme().getTokenStyleMetadata(s,a,n);if(void 0===i)r=2147483647;else{if(r=0,void 0!==i.italic){r|=1|(i.italic?1:0)<<11}if(void 0!==i.bold){r|=2|(i.bold?2:0)<<11}if(void 0!==i.underline){r|=4|(i.underline?4:0)<<11}if(void 0!==i.strikethrough){r|=8|(i.strikethrough?8:0)<<11}if(i.foreground){r|=16|i.foreground<<15}0===r&&(r=2147483647)}}else r=2147483647,s="not-in-legend";this._hashTable.add(e,t,i,r)}return r}warnOverlappingSemanticTokens(e,t){this._hasWarnedOverlappingTokens||(this._hasWarnedOverlappingTokens=!0,this._logService.warn(`Overlapping semantic tokens detected at lineNumber ${e}, column ${t}`))}warnInvalidLengthSemanticTokens(e,t){this._hasWarnedInvalidLengthTokens||(this._hasWarnedInvalidLengthTokens=!0,this._logService.warn(`Semantic token with invalid length detected at lineNumber ${e}, column ${t}`))}warnInvalidEditStart(e,t,n,i,s){this._hasWarnedInvalidEditStart||(this._hasWarnedInvalidEditStart=!0,this._logService.warn(`Invalid semantic tokens edit detected (previousResultId: ${e}, resultId: ${t}) at edit #${n}: The provided start offset ${i} is outside the previous data (length ${s}).`))}},exports.SemanticTokensProviderStyling=s([r(1,e.IThemeService),r(2,i.ILanguageService),r(3,t.ILogService)],exports.SemanticTokensProviderStyling);class a{constructor(e,t,n,i){this.tokenTypeIndex=e,this.tokenModifierSet=t,this.languageId=n,this.metadata=i,this.next=null}}class o{static{this._SIZES=[3,7,13,31,61,127,251,509,1021,2039,4093,8191,16381,32749,65521,131071,262139,524287,1048573,2097143]}constructor(){this._elementsCount=0,this._currentLengthIndex=0,this._currentLength=o._SIZES[this._currentLengthIndex],this._growCount=Math.round(this._currentLengthIndex+1<o._SIZES.length?2/3*this._currentLength:0),this._elements=[],o._nullOutEntries(this._elements,this._currentLength)}static _nullOutEntries(e,t){for(let n=0;n<t;n++)e[n]=null}_hash2(e,t){return(e<<5)-e+t|0}_hashFunc(e,t,n){return this._hash2(this._hash2(e,t),n)%this._currentLength}get(e,t,n){const i=this._hashFunc(e,t,n);let s=this._elements[i];for(;s;){if(s.tokenTypeIndex===e&&s.tokenModifierSet===t&&s.languageId===n)return s;s=s.next}return null}add(e,t,n,i){if(this._elementsCount++,0!==this._growCount&&this._elementsCount>=this._growCount){const e=this._elements;this._currentLengthIndex++,this._currentLength=o._SIZES[this._currentLengthIndex],this._growCount=Math.round(this._currentLengthIndex+1<o._SIZES.length?2/3*this._currentLength:0),this._elements=[],o._nullOutEntries(this._elements,this._currentLength);for(const t of e){let e=t;for(;e;){const t=e.next;e.next=null,this._add(e),e=t}}}this._add(new a(e,t,n,i))}_add(e){const t=this._hashFunc(e.tokenTypeIndex,e.tokenModifierSet,e.languageId);e.next=this._elements[t],this._elements[t]=e}}exports.toMultilineTokens2=function(e,t,i){const s=e.data,r=e.data.length/5|0,a=Math.max(Math.ceil(r/1024),400),o=[];let h=0,l=1,d=0;for(;h<r;){const e=h;let c=Math.min(e+a,r);if(c<r){let t=c;for(;t-1>e&&0===s[5*t];)t--;if(t-1===e){let e=c;for(;e+1<r&&0===s[5*e];)e++;c=e}else c=t}let u=new Uint32Array(4*(c-e)),g=0,_=0,f=0,v=0;for(;h<c;){const e=5*h,n=s[e],r=s[e+1],a=l+n|0,o=0===n?d+r|0:r,c=o+s[e+2]|0,m=s[e+3],S=s[e+4];if(c<=o)t.warnInvalidLengthSemanticTokens(a,o+1);else if(f===a&&v>o)t.warnOverlappingSemanticTokens(a,o+1);else{const e=t.getMetadata(m,S,i);2147483647!==e&&(0===_&&(_=a),u[g]=a-_,u[g+1]=o,u[g+2]=c,u[g+3]=e,g+=4,f=a,v=c)}l=a,d=o,h++}g!==u.length&&(u=u.subarray(0,g));const m=n.SparseMultilineTokens.create(_,u);o.push(m)}return o};
//# sourceMappingURL=semanticTokensProviderStyling.js.map
