"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var e=require("../../../base/common/arrays.js"),i=require("../core/position.js"),n=require("../core/range.js"),t=require("../textModelGuides.js"),o=require("../model/textModel.js"),s=require("../textModelEvents.js"),r=require("../viewEvents.js"),l=require("./modelLineProjection.js"),d=require("../model/prefixSumComputer.js"),u=require("../viewModel.js");class m{constructor(e,i){this.modelLineNumber=e,this.modelLineWrappedLineIdx=i}}class a{constructor(e,i){this.modelRange=e,this.viewLines=i}}class L{constructor(e){this._lines=e}convertViewPositionToModelPosition(e){return this._lines.convertViewPositionToModelPosition(e.lineNumber,e.column)}convertViewRangeToModelRange(e){return this._lines.convertViewRangeToModelRange(e)}validateViewPosition(e,i){return this._lines.validateViewPosition(e.lineNumber,e.column,i)}validateViewRange(e,i){return this._lines.validateViewRange(e,i)}convertModelPositionToViewPosition(e,i,n,t){return this._lines.convertModelPositionToViewPosition(e.lineNumber,e.column,i,n,t)}convertModelRangeToViewRange(e,i){return this._lines.convertModelRangeToViewRange(e,i)}modelPositionIsVisible(e){return this._lines.modelPositionIsVisible(e.lineNumber,e.column)}getModelLineViewLineCount(e){return this._lines.getModelLineViewLineCount(e)}getViewLineNumberOfModelPosition(e,i){return this._lines.getViewLineNumberOfModelPosition(e,i)}}class c{constructor(e){this._lines=e}_validPosition(e){return this._lines.model.validatePosition(e)}_validRange(e){return this._lines.model.validateRange(e)}convertViewPositionToModelPosition(e){return this._validPosition(e)}convertViewRangeToModelRange(e){return this._validRange(e)}validateViewPosition(e,i){return this._validPosition(i)}validateViewRange(e,i){return this._validRange(i)}convertModelPositionToViewPosition(e){return this._validPosition(e)}convertModelRangeToViewRange(e){return this._validRange(e)}modelPositionIsVisible(e){const i=this._lines.model.getLineCount();return!(e.lineNumber<1||e.lineNumber>i)}getModelLineViewLineCount(e){return 1}getViewLineNumberOfModelPosition(e,i){return e}}exports.ViewModelLinesFromModelAsIs=class{constructor(e){this.model=e}dispose(){}createCoordinatesConverter(){return new c(this)}getHiddenAreas(){return[]}setHiddenAreas(e){return!1}setTabSize(e){return!1}setWrappingSettings(e,i,n,t){return!1}createLineBreaksComputer(){const e=[];return{addRequest:(i,n,t)=>{e.push(null)},finalize:()=>e}}onModelFlushed(){}onModelLinesDeleted(e,i,n){return new r.ViewLinesDeletedEvent(i,n)}onModelLinesInserted(e,i,n,t){return new r.ViewLinesInsertedEvent(i,n)}onModelLineChanged(e,i,n){return[!1,new r.ViewLinesChangedEvent(i,1),null,null]}acceptVersionId(e){}getViewLineCount(){return this.model.getLineCount()}getActiveIndentGuide(e,i,n){return{startLineNumber:e,endLineNumber:e,indent:0}}getViewLinesBracketGuides(e,i,n){return new Array(i-e+1).fill([])}getViewLinesIndentGuides(e,i){const n=i-e+1,t=new Array(n);for(let e=0;e<n;e++)t[e]=0;return t}getViewLineContent(e){return this.model.getLineContent(e)}getViewLineLength(e){return this.model.getLineLength(e)}getViewLineMinColumn(e){return this.model.getLineMinColumn(e)}getViewLineMaxColumn(e){return this.model.getLineMaxColumn(e)}getViewLineData(e){const i=this.model.tokenization.getLineTokens(e),n=i.getLineContent();return new u.ViewLineData(n,!1,1,n.length+1,0,i.inflate(),null)}getViewLinesData(e,i,n){const t=this.model.getLineCount();e=Math.min(Math.max(1,e),t),i=Math.min(Math.max(1,i),t);const o=[];for(let t=e;t<=i;t++){const i=t-e;o[i]=n[i]?this.getViewLineData(t):null}return o}getDecorationsInRange(e,i,n,t,o){return this.model.getDecorationsInRange(e,i,n,t,o)}normalizePosition(e,i){return this.model.normalizePosition(e,i)}getLineIndentColumn(e){return this.model.getLineIndentColumn(e)}getInjectedTextAt(e){return null}},exports.ViewModelLinesFromProjectedModel=class{constructor(e,i,n,t,o,s,r,l,d,u){this._editorId=e,this.model=i,this._validModelVersionId=-1,this._domLineBreaksComputerFactory=n,this._monospaceLineBreaksComputerFactory=t,this.fontInfo=o,this.tabSize=s,this.wrappingStrategy=r,this.wrappingColumn=l,this.wrappingIndent=d,this.wordBreak=u,this._constructLines(!0,null)}dispose(){this.hiddenAreasDecorationIds=this.model.deltaDecorations(this.hiddenAreasDecorationIds,[])}createCoordinatesConverter(){return new L(this)}_constructLines(i,t){this.modelLineProjections=[],i&&(this.hiddenAreasDecorationIds=this.model.deltaDecorations(this.hiddenAreasDecorationIds,[]));const o=this.model.getLinesContent(),r=this.model.getInjectedTextDecorations(this._editorId),u=o.length,m=this.createLineBreaksComputer(),a=new e.ArrayQueue(s.LineInjectedText.fromDecorations(r));for(let e=0;e<u;e++){const i=a.takeWhile((i=>i.lineNumber===e+1));m.addRequest(o[e],i,t?t[e]:null)}const L=m.finalize(),c=[],h=this.hiddenAreasDecorationIds.map((e=>this.model.getDecorationRange(e))).sort(n.Range.compareRangesUsingStarts);let g=1,w=0,V=-1,P=V+1<h.length?w+1:u+2;for(let e=0;e<u;e++){const i=e+1;i===P&&(V++,g=h[V].startLineNumber,w=h[V].endLineNumber,P=V+1<h.length?w+1:u+2);const n=i>=g&&i<=w,t=l.createModelLineProjection(L[e],!n);c[e]=t.getViewLineCount(),this.modelLineProjections[e]=t}this._validModelVersionId=this.model.getVersionId(),this.projectedModelLineLineCounts=new d.ConstantTimePrefixSumComputer(c)}getHiddenAreas(){return this.hiddenAreasDecorationIds.map((e=>this.model.getDecorationRange(e)))}setHiddenAreas(e){const i=function(e){if(0===e.length)return[];const i=e.slice();i.sort(n.Range.compareRangesUsingStarts);const t=[];let o=i[0].startLineNumber,s=i[0].endLineNumber;for(let e=1,r=i.length;e<r;e++){const r=i[e];r.startLineNumber>s+1?(t.push(new n.Range(o,1,s,1)),o=r.startLineNumber,s=r.endLineNumber):r.endLineNumber>s&&(s=r.endLineNumber)}return t.push(new n.Range(o,1,s,1)),t}(e.map((e=>this.model.validateRange(e)))),t=this.hiddenAreasDecorationIds.map((e=>this.model.getDecorationRange(e))).sort(n.Range.compareRangesUsingStarts);if(i.length===t.length){let e=!1;for(let n=0;n<i.length;n++)if(!i[n].equalsRange(t[n])){e=!0;break}if(!e)return!1}const s=i.map((e=>({range:e,options:o.ModelDecorationOptions.EMPTY})));this.hiddenAreasDecorationIds=this.model.deltaDecorations(this.hiddenAreasDecorationIds,s);const r=i;let l=1,d=0,u=-1,m=u+1<r.length?d+1:this.modelLineProjections.length+2,a=!1;for(let e=0;e<this.modelLineProjections.length;e++){const i=e+1;i===m&&(u++,l=r[u].startLineNumber,d=r[u].endLineNumber,m=u+1<r.length?d+1:this.modelLineProjections.length+2);let n=!1;if(i>=l&&i<=d?this.modelLineProjections[e].isVisible()&&(this.modelLineProjections[e]=this.modelLineProjections[e].setVisible(!1),n=!0):(a=!0,this.modelLineProjections[e].isVisible()||(this.modelLineProjections[e]=this.modelLineProjections[e].setVisible(!0),n=!0)),n){const i=this.modelLineProjections[e].getViewLineCount();this.projectedModelLineLineCounts.setValue(e,i)}}return a||this.setHiddenAreas([]),!0}modelPositionIsVisible(e,i){return!(e<1||e>this.modelLineProjections.length)&&this.modelLineProjections[e-1].isVisible()}getModelLineViewLineCount(e){return e<1||e>this.modelLineProjections.length?1:this.modelLineProjections[e-1].getViewLineCount()}setTabSize(e){return this.tabSize!==e&&(this.tabSize=e,this._constructLines(!1,null),!0)}setWrappingSettings(e,i,n,t,o){const s=this.fontInfo.equals(e),r=this.wrappingStrategy===i,l=this.wrappingColumn===n,d=this.wrappingIndent===t,u=this.wordBreak===o;if(s&&r&&l&&d&&u)return!1;const m=s&&r&&!l&&d&&u;this.fontInfo=e,this.wrappingStrategy=i,this.wrappingColumn=n,this.wrappingIndent=t,this.wordBreak=o;let a=null;if(m){a=[];for(let e=0,i=this.modelLineProjections.length;e<i;e++)a[e]=this.modelLineProjections[e].getProjectionData()}return this._constructLines(!1,a),!0}createLineBreaksComputer(){return("advanced"===this.wrappingStrategy?this._domLineBreaksComputerFactory:this._monospaceLineBreaksComputerFactory).createLineBreaksComputer(this.fontInfo,this.tabSize,this.wrappingColumn,this.wrappingIndent,this.wordBreak)}onModelFlushed(){this._constructLines(!0,null)}onModelLinesDeleted(e,i,n){if(!e||e<=this._validModelVersionId)return null;const t=1===i?1:this.projectedModelLineLineCounts.getPrefixSum(i-1)+1,o=this.projectedModelLineLineCounts.getPrefixSum(n);return this.modelLineProjections.splice(i-1,n-i+1),this.projectedModelLineLineCounts.removeValues(i-1,n-i+1),new r.ViewLinesDeletedEvent(t,o)}onModelLinesInserted(e,i,n,t){if(!e||e<=this._validModelVersionId)return null;const o=i>2&&!this.modelLineProjections[i-2].isVisible(),s=1===i?1:this.projectedModelLineLineCounts.getPrefixSum(i-1)+1;let d=0;const u=[],m=[];for(let e=0,i=t.length;e<i;e++){const i=l.createModelLineProjection(t[e],!o);u.push(i);const n=i.getViewLineCount();d+=n,m[e]=n}return this.modelLineProjections=this.modelLineProjections.slice(0,i-1).concat(u).concat(this.modelLineProjections.slice(i-1)),this.projectedModelLineLineCounts.insertValues(i-1,m),new r.ViewLinesInsertedEvent(s,s+d-1)}onModelLineChanged(e,i,n){if(null!==e&&e<=this._validModelVersionId)return[!1,null,null,null];const t=i-1,o=this.modelLineProjections[t].getViewLineCount(),s=this.modelLineProjections[t].isVisible(),d=l.createModelLineProjection(n,s);this.modelLineProjections[t]=d;const u=this.modelLineProjections[t].getViewLineCount();let m=!1,a=0,L=-1,c=0,h=-1,g=0,w=-1;o>u?(a=this.projectedModelLineLineCounts.getPrefixSum(i-1)+1,L=a+u-1,g=L+1,w=g+(o-u)-1,m=!0):o<u?(a=this.projectedModelLineLineCounts.getPrefixSum(i-1)+1,L=a+o-1,c=L+1,h=c+(u-o)-1,m=!0):(a=this.projectedModelLineLineCounts.getPrefixSum(i-1)+1,L=a+u-1),this.projectedModelLineLineCounts.setValue(t,u);return[m,a<=L?new r.ViewLinesChangedEvent(a,L-a+1):null,c<=h?new r.ViewLinesInsertedEvent(c,h):null,g<=w?new r.ViewLinesDeletedEvent(g,w):null]}acceptVersionId(e){this._validModelVersionId=e,1!==this.modelLineProjections.length||this.modelLineProjections[0].isVisible()||this.setHiddenAreas([])}getViewLineCount(){return this.projectedModelLineLineCounts.getTotalSum()}_toValidViewLineNumber(e){if(e<1)return 1;const i=this.getViewLineCount();return e>i?i:0|e}getActiveIndentGuide(e,i,n){e=this._toValidViewLineNumber(e),i=this._toValidViewLineNumber(i),n=this._toValidViewLineNumber(n);const t=this.convertViewPositionToModelPosition(e,this.getViewLineMinColumn(e)),o=this.convertViewPositionToModelPosition(i,this.getViewLineMinColumn(i)),s=this.convertViewPositionToModelPosition(n,this.getViewLineMinColumn(n)),r=this.model.guides.getActiveIndentGuide(t.lineNumber,o.lineNumber,s.lineNumber),l=this.convertModelPositionToViewPosition(r.startLineNumber,1),d=this.convertModelPositionToViewPosition(r.endLineNumber,this.model.getLineMaxColumn(r.endLineNumber));return{startLineNumber:l.lineNumber,endLineNumber:d.lineNumber,indent:r.indent}}getViewLineInfo(e){e=this._toValidViewLineNumber(e);const i=this.projectedModelLineLineCounts.getIndexOf(e-1),n=i.index,t=i.remainder;return new m(n+1,t)}getMinColumnOfViewLine(e){return this.modelLineProjections[e.modelLineNumber-1].getViewLineMinColumn(this.model,e.modelLineNumber,e.modelLineWrappedLineIdx)}getMaxColumnOfViewLine(e){return this.modelLineProjections[e.modelLineNumber-1].getViewLineMaxColumn(this.model,e.modelLineNumber,e.modelLineWrappedLineIdx)}getModelStartPositionOfViewLine(e){const n=this.modelLineProjections[e.modelLineNumber-1],t=n.getViewLineMinColumn(this.model,e.modelLineNumber,e.modelLineWrappedLineIdx),o=n.getModelColumnOfViewPosition(e.modelLineWrappedLineIdx,t);return new i.Position(e.modelLineNumber,o)}getModelEndPositionOfViewLine(e){const n=this.modelLineProjections[e.modelLineNumber-1],t=n.getViewLineMaxColumn(this.model,e.modelLineNumber,e.modelLineWrappedLineIdx),o=n.getModelColumnOfViewPosition(e.modelLineWrappedLineIdx,t);return new i.Position(e.modelLineNumber,o)}getViewLineInfosGroupedByModelRanges(e,t){const o=this.getViewLineInfo(e),s=this.getViewLineInfo(t),r=new Array;let l=this.getModelStartPositionOfViewLine(o),d=new Array;for(let e=o.modelLineNumber;e<=s.modelLineNumber;e++){const t=this.modelLineProjections[e-1];if(t.isVisible()){const i=e===o.modelLineNumber?o.modelLineWrappedLineIdx:0,n=e===s.modelLineNumber?s.modelLineWrappedLineIdx+1:t.getViewLineCount();for(let t=i;t<n;t++)d.push(new m(e,t))}if(!t.isVisible()&&l){const t=new i.Position(e-1,this.model.getLineMaxColumn(e-1)+1),o=n.Range.fromPositions(l,t);r.push(new a(o,d)),d=[],l=null}else t.isVisible()&&!l&&(l=new i.Position(e,1))}if(l){const e=n.Range.fromPositions(l,this.getModelEndPositionOfViewLine(s));r.push(new a(e,d))}return r}getViewLinesBracketGuides(e,i,n,o){const s=n?this.convertViewPositionToModelPosition(n.lineNumber,n.column):null,r=[];for(const n of this.getViewLineInfosGroupedByModelRanges(e,i)){const e=n.modelRange.startLineNumber,i=this.model.guides.getLinesBracketGuides(e,n.modelRange.endLineNumber,s,o);for(const o of n.viewLines){const n=i[o.modelLineNumber-e].map((e=>{if(-1!==e.forWrappedLinesAfterColumn){if(this.modelLineProjections[o.modelLineNumber-1].getViewPositionOfModelPosition(0,e.forWrappedLinesAfterColumn).lineNumber>=o.modelLineWrappedLineIdx)return}if(-1!==e.forWrappedLinesBeforeOrAtColumn){if(this.modelLineProjections[o.modelLineNumber-1].getViewPositionOfModelPosition(0,e.forWrappedLinesBeforeOrAtColumn).lineNumber<o.modelLineWrappedLineIdx)return}if(!e.horizontalLine)return e;let i=-1;if(-1!==e.column){const n=this.modelLineProjections[o.modelLineNumber-1].getViewPositionOfModelPosition(0,e.column);if(n.lineNumber===o.modelLineWrappedLineIdx)i=n.column;else if(n.lineNumber<o.modelLineWrappedLineIdx)i=this.getMinColumnOfViewLine(o);else if(n.lineNumber>o.modelLineWrappedLineIdx)return}const n=this.convertModelPositionToViewPosition(o.modelLineNumber,e.horizontalLine.endColumn),s=this.modelLineProjections[o.modelLineNumber-1].getViewPositionOfModelPosition(0,e.horizontalLine.endColumn);return s.lineNumber===o.modelLineWrappedLineIdx?new t.IndentGuide(e.visibleColumn,i,e.className,new t.IndentGuideHorizontalLine(e.horizontalLine.top,n.column),-1,-1):s.lineNumber<o.modelLineWrappedLineIdx||-1!==e.visibleColumn?void 0:new t.IndentGuide(e.visibleColumn,i,e.className,new t.IndentGuideHorizontalLine(e.horizontalLine.top,this.getMaxColumnOfViewLine(o)),-1,-1)}));r.push(n.filter((e=>!!e)))}}return r}getViewLinesIndentGuides(e,n){e=this._toValidViewLineNumber(e),n=this._toValidViewLineNumber(n);const t=this.convertViewPositionToModelPosition(e,this.getViewLineMinColumn(e)),o=this.convertViewPositionToModelPosition(n,this.getViewLineMaxColumn(n));let s=[];const r=[],l=[],d=t.lineNumber-1,u=o.lineNumber-1;let m=null;for(let e=d;e<=u;e++){const n=this.modelLineProjections[e];if(n.isVisible()){const o=n.getViewLineNumberOfModelPosition(0,e===d?t.column:1),s=n.getViewLineNumberOfModelPosition(0,this.model.getLineMaxColumn(e+1)),u=s-o+1;let a=0;u>1&&1===n.getViewLineMinColumn(this.model,e+1,s)&&(a=0===o?1:2),r.push(u),l.push(a),null===m&&(m=new i.Position(e+1,0))}else null!==m&&(s=s.concat(this.model.guides.getLinesIndentGuides(m.lineNumber,e)),m=null)}null!==m&&(s=s.concat(this.model.guides.getLinesIndentGuides(m.lineNumber,o.lineNumber)),m=null);const a=n-e+1,L=new Array(a);let c=0;for(let e=0,i=s.length;e<i;e++){let i=s[e];const n=Math.min(a-c,r[e]),t=l[e];let o;o=2===t?0:1===t?1:n;for(let e=0;e<n;e++)e===o&&(i=0),L[c++]=i}return L}getViewLineContent(e){const i=this.getViewLineInfo(e);return this.modelLineProjections[i.modelLineNumber-1].getViewLineContent(this.model,i.modelLineNumber,i.modelLineWrappedLineIdx)}getViewLineLength(e){const i=this.getViewLineInfo(e);return this.modelLineProjections[i.modelLineNumber-1].getViewLineLength(this.model,i.modelLineNumber,i.modelLineWrappedLineIdx)}getViewLineMinColumn(e){const i=this.getViewLineInfo(e);return this.modelLineProjections[i.modelLineNumber-1].getViewLineMinColumn(this.model,i.modelLineNumber,i.modelLineWrappedLineIdx)}getViewLineMaxColumn(e){const i=this.getViewLineInfo(e);return this.modelLineProjections[i.modelLineNumber-1].getViewLineMaxColumn(this.model,i.modelLineNumber,i.modelLineWrappedLineIdx)}getViewLineData(e){const i=this.getViewLineInfo(e);return this.modelLineProjections[i.modelLineNumber-1].getViewLineData(this.model,i.modelLineNumber,i.modelLineWrappedLineIdx)}getViewLinesData(e,i,n){e=this._toValidViewLineNumber(e),i=this._toValidViewLineNumber(i);const t=this.projectedModelLineLineCounts.getIndexOf(e-1);let o=e;const s=t.index,r=t.remainder,l=[];for(let t=s,d=this.model.getLineCount();t<d;t++){const d=this.modelLineProjections[t];if(!d.isVisible())continue;const u=t===s?r:0;let m=d.getViewLineCount()-u,a=!1;if(o+m>i&&(a=!0,m=i-o+1),d.getViewLinesData(this.model,t+1,u,m,o-e,n,l),o+=m,a)break}return l}validateViewPosition(e,n,t){e=this._toValidViewLineNumber(e);const o=this.projectedModelLineLineCounts.getIndexOf(e-1),s=o.index,r=o.remainder,l=this.modelLineProjections[s],d=l.getViewLineMinColumn(this.model,s+1,r),u=l.getViewLineMaxColumn(this.model,s+1,r);n<d&&(n=d),n>u&&(n=u);const m=l.getModelColumnOfViewPosition(r,n);return this.model.validatePosition(new i.Position(s+1,m)).equals(t)?new i.Position(e,n):this.convertModelPositionToViewPosition(t.lineNumber,t.column)}validateViewRange(e,i){const t=this.validateViewPosition(e.startLineNumber,e.startColumn,i.getStartPosition()),o=this.validateViewPosition(e.endLineNumber,e.endColumn,i.getEndPosition());return new n.Range(t.lineNumber,t.column,o.lineNumber,o.column)}convertViewPositionToModelPosition(e,n){const t=this.getViewLineInfo(e),o=this.modelLineProjections[t.modelLineNumber-1].getModelColumnOfViewPosition(t.modelLineWrappedLineIdx,n);return this.model.validatePosition(new i.Position(t.modelLineNumber,o))}convertViewRangeToModelRange(e){const i=this.convertViewPositionToModelPosition(e.startLineNumber,e.startColumn),t=this.convertViewPositionToModelPosition(e.endLineNumber,e.endColumn);return new n.Range(i.lineNumber,i.column,t.lineNumber,t.column)}convertModelPositionToViewPosition(e,n,t=2,o=!1,s=!1){const r=this.model.validatePosition(new i.Position(e,n)),l=r.lineNumber,d=r.column;let u=l-1,m=!1;if(s)for(;u<this.modelLineProjections.length&&!this.modelLineProjections[u].isVisible();)u++,m=!0;else for(;u>0&&!this.modelLineProjections[u].isVisible();)u--,m=!0;if(0===u&&!this.modelLineProjections[u].isVisible())return new i.Position(o?0:1,1);const a=1+this.projectedModelLineLineCounts.getPrefixSum(u);let L;return L=m?s?this.modelLineProjections[u].getViewPositionOfModelPosition(a,1,t):this.modelLineProjections[u].getViewPositionOfModelPosition(a,this.model.getLineMaxColumn(u+1),t):this.modelLineProjections[l-1].getViewPositionOfModelPosition(a,d,t),L}convertModelRangeToViewRange(e,i=0){if(e.isEmpty()){const t=this.convertModelPositionToViewPosition(e.startLineNumber,e.startColumn,i);return n.Range.fromPositions(t)}{const i=this.convertModelPositionToViewPosition(e.startLineNumber,e.startColumn,1),t=this.convertModelPositionToViewPosition(e.endLineNumber,e.endColumn,0);return new n.Range(i.lineNumber,i.column,t.lineNumber,t.column)}}getViewLineNumberOfModelPosition(e,i){let n=e-1;if(this.modelLineProjections[n].isVisible()){const e=1+this.projectedModelLineLineCounts.getPrefixSum(n);return this.modelLineProjections[n].getViewLineNumberOfModelPosition(e,i)}for(;n>0&&!this.modelLineProjections[n].isVisible();)n--;if(0===n&&!this.modelLineProjections[n].isVisible())return 1;const t=1+this.projectedModelLineLineCounts.getPrefixSum(n);return this.modelLineProjections[n].getViewLineNumberOfModelPosition(t,this.model.getLineMaxColumn(n+1))}getDecorationsInRange(e,t,o,s,r){const l=this.convertViewPositionToModelPosition(e.startLineNumber,e.startColumn),d=this.convertViewPositionToModelPosition(e.endLineNumber,e.endColumn);if(d.lineNumber-l.lineNumber<=e.endLineNumber-e.startLineNumber)return this.model.getDecorationsInRange(new n.Range(l.lineNumber,1,d.lineNumber,d.column),t,o,s,r);let u=[];const m=l.lineNumber-1,a=d.lineNumber-1;let L=null;for(let e=m;e<=a;e++){if(this.modelLineProjections[e].isVisible())null===L&&(L=new i.Position(e+1,e===m?l.column:1));else if(null!==L){const i=this.model.getLineMaxColumn(e);u=u.concat(this.model.getDecorationsInRange(new n.Range(L.lineNumber,L.column,e,i),t,o,s)),L=null}}null!==L&&(u=u.concat(this.model.getDecorationsInRange(new n.Range(L.lineNumber,L.column,d.lineNumber,d.column),t,o,s)),L=null),u.sort(((e,i)=>{const t=n.Range.compareRangesUsingStarts(e.range,i.range);return 0===t?e.id<i.id?-1:e.id>i.id?1:0:t}));const c=[];let h=0,g=null;for(const e of u){const i=e.id;g!==i&&(g=i,c[h++]=e)}return c}getInjectedTextAt(e){const i=this.getViewLineInfo(e.lineNumber);return this.modelLineProjections[i.modelLineNumber-1].getInjectedTextAt(i.modelLineWrappedLineIdx,e.column)}normalizePosition(e,i){const n=this.getViewLineInfo(e.lineNumber);return this.modelLineProjections[n.modelLineNumber-1].normalizePosition(n.modelLineWrappedLineIdx,e,i)}getLineIndentColumn(e){const i=this.getViewLineInfo(e);return 0===i.modelLineWrappedLineIdx?this.model.getLineIndentColumn(i.modelLineNumber):0}};
//# sourceMappingURL=viewModelLines.js.map
