"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var e=require("../../../../base/common/async.js"),t=require("../../../../base/common/lifecycle.js");require("./bracketMatching.css.js");var o=require("../../../browser/editorExtensions.js"),r=require("../../../common/core/position.js"),s=require("../../../common/core/range.js"),i=require("../../../common/core/selection.js"),a=require("../../../common/editorContextKeys.js"),c=require("../../../common/model.js"),n=require("../../../common/model/textModel.js"),l=require("../../../../nls.js"),d=require("../../../../platform/actions/common/actions.js"),h=require("../../../../platform/theme/common/colorUtils.js");require("../../../../platform/theme/common/colors/baseColors.js"),require("../../../../platform/theme/common/colors/chartsColors.js"),require("../../../../platform/theme/common/colors/editorColors.js"),require("../../../../platform/theme/common/colors/inputColors.js"),require("../../../../platform/theme/common/colors/listColors.js"),require("../../../../platform/theme/common/colors/menuColors.js"),require("../../../../platform/theme/common/colors/minimapColors.js"),require("../../../../platform/theme/common/colors/miscColors.js"),require("../../../../platform/theme/common/colors/quickpickColors.js"),require("../../../../platform/theme/common/colors/searchColors.js");var m=require("../../../../platform/theme/common/themeService.js");const u=h.registerColor("editorOverviewRuler.bracketMatchForeground","#A0A0A0",l.localize("overviewRulerBracketMatchForeground","Overview ruler marker color for matching brackets."));class k extends o.EditorAction{constructor(){super({id:"editor.action.jumpToBracket",label:l.localize("smartSelect.jumpBracket","Go to Bracket"),alias:"Go to Bracket",precondition:void 0,kbOpts:{kbExpr:a.EditorContextKeys.editorTextFocus,primary:3165,weight:100}})}run(e,t){B.get(t)?.jumpToBracket()}}class g extends o.EditorAction{constructor(){super({id:"editor.action.selectToBracket",label:l.localize("smartSelect.selectToBracket","Select to Bracket"),alias:"Select to Bracket",precondition:void 0,metadata:{description:l.localize2("smartSelect.selectToBracketDescription","Select the text inside and including the brackets or curly braces"),args:[{name:"args",schema:{type:"object",properties:{selectBrackets:{type:"boolean",default:!0}}}}]}})}run(e,t,o){let r=!0;o&&!1===o.selectBrackets&&(r=!1),B.get(t)?.selectToBracket(r)}}class _ extends o.EditorAction{constructor(){super({id:"editor.action.removeBrackets",label:l.localize("smartSelect.removeBrackets","Remove Brackets"),alias:"Remove Brackets",precondition:void 0,kbOpts:{kbExpr:a.EditorContextKeys.editorTextFocus,primary:2561,weight:100}})}run(e,t){B.get(t)?.removeBrackets(this.id)}}class p{constructor(e,t,o){this.position=e,this.brackets=t,this.options=o}}class B extends t.Disposable{static{this.ID="editor.contrib.bracketMatchingController"}static get(e){return e.getContribution(B.ID)}constructor(t){super(),this._editor=t,this._lastBracketsData=[],this._lastVersionId=0,this._decorations=this._editor.createDecorationsCollection(),this._updateBracketsSoon=this._register(new e.RunOnceScheduler((()=>this._updateBrackets()),50)),this._matchBrackets=this._editor.getOption(72),this._updateBracketsSoon.schedule(),this._register(t.onDidChangeCursorPosition((e=>{"never"!==this._matchBrackets&&this._updateBracketsSoon.schedule()}))),this._register(t.onDidChangeModelContent((e=>{this._updateBracketsSoon.schedule()}))),this._register(t.onDidChangeModel((e=>{this._lastBracketsData=[],this._updateBracketsSoon.schedule()}))),this._register(t.onDidChangeModelLanguageConfiguration((e=>{this._lastBracketsData=[],this._updateBracketsSoon.schedule()}))),this._register(t.onDidChangeConfiguration((e=>{e.hasChanged(72)&&(this._matchBrackets=this._editor.getOption(72),this._decorations.clear(),this._lastBracketsData=[],this._lastVersionId=0,this._updateBracketsSoon.schedule())}))),this._register(t.onDidBlurEditorWidget((()=>{this._updateBracketsSoon.schedule()}))),this._register(t.onDidFocusEditorWidget((()=>{this._updateBracketsSoon.schedule()})))}jumpToBracket(){if(!this._editor.hasModel())return;const e=this._editor.getModel(),t=this._editor.getSelections().map((t=>{const o=t.getStartPosition(),r=e.bracketPairs.matchBracket(o);let s=null;if(r)r[0].containsPosition(o)&&!r[1].containsPosition(o)?s=r[1].getStartPosition():r[1].containsPosition(o)&&(s=r[0].getStartPosition());else{const t=e.bracketPairs.findEnclosingBrackets(o);if(t)s=t[1].getStartPosition();else{const t=e.bracketPairs.findNextBracket(o);t&&t.range&&(s=t.range.getStartPosition())}}return s?new i.Selection(s.lineNumber,s.column,s.lineNumber,s.column):new i.Selection(o.lineNumber,o.column,o.lineNumber,o.column)}));this._editor.setSelections(t),this._editor.revealRange(t[0])}selectToBracket(e){if(!this._editor.hasModel())return;const t=this._editor.getModel(),o=[];this._editor.getSelections().forEach((r=>{const a=r.getStartPosition();let c=t.bracketPairs.matchBracket(a);if(!c&&(c=t.bracketPairs.findEnclosingBrackets(a),!c)){const e=t.bracketPairs.findNextBracket(a);e&&e.range&&(c=t.bracketPairs.matchBracket(e.range.getStartPosition()))}let n=null,l=null;if(c){c.sort(s.Range.compareRangesUsingStarts);const[t,o]=c;if(n=e?t.getStartPosition():t.getEndPosition(),l=e?o.getEndPosition():o.getStartPosition(),o.containsPosition(a)){const e=n;n=l,l=e}}n&&l&&o.push(new i.Selection(n.lineNumber,n.column,l.lineNumber,l.column))})),o.length>0&&(this._editor.setSelections(o),this._editor.revealRange(o[0]))}removeBrackets(e){if(!this._editor.hasModel())return;const t=this._editor.getModel();this._editor.getSelections().forEach((o=>{const r=o.getPosition();let s=t.bracketPairs.matchBracket(r);s||(s=t.bracketPairs.findEnclosingBrackets(r)),s&&(this._editor.pushUndoStop(),this._editor.executeEdits(e,[{range:s[0],text:""},{range:s[1],text:""}]),this._editor.pushUndoStop())}))}static{this._DECORATION_OPTIONS_WITH_OVERVIEW_RULER=n.ModelDecorationOptions.register({description:"bracket-match-overview",stickiness:1,className:"bracket-match",overviewRuler:{color:m.themeColorFromId(u),position:c.OverviewRulerLane.Center}})}static{this._DECORATION_OPTIONS_WITHOUT_OVERVIEW_RULER=n.ModelDecorationOptions.register({description:"bracket-match-no-overview",stickiness:1,className:"bracket-match"})}_updateBrackets(){if("never"===this._matchBrackets)return;this._recomputeBrackets();const e=[];let t=0;for(const o of this._lastBracketsData){const r=o.brackets;r&&(e[t++]={range:r[0],options:o.options},e[t++]={range:r[1],options:o.options})}this._decorations.set(e)}_recomputeBrackets(){if(!this._editor.hasModel()||!this._editor.hasWidgetFocus())return this._lastBracketsData=[],void(this._lastVersionId=0);const e=this._editor.getSelections();if(e.length>100)return this._lastBracketsData=[],void(this._lastVersionId=0);const t=this._editor.getModel(),o=t.getVersionId();let s=[];this._lastVersionId===o&&(s=this._lastBracketsData);const i=[];let a=0;for(let t=0,o=e.length;t<o;t++){const o=e[t];o.isEmpty()&&(i[a++]=o.getStartPosition())}i.length>1&&i.sort(r.Position.compare);const c=[];let n=0,l=0;const d=s.length;for(let e=0,o=i.length;e<o;e++){const o=i[e];for(;l<d&&s[l].position.isBefore(o);)l++;if(l<d&&s[l].position.equals(o))c[n++]=s[l];else{let e=t.bracketPairs.matchBracket(o,20),r=B._DECORATION_OPTIONS_WITH_OVERVIEW_RULER;e||"always"!==this._matchBrackets||(e=t.bracketPairs.findEnclosingBrackets(o,20),r=B._DECORATION_OPTIONS_WITHOUT_OVERVIEW_RULER),c[n++]=new p(o,e,r)}}this._lastBracketsData=c,this._lastVersionId=o}}o.registerEditorContribution(B.ID,B,1),o.registerEditorAction(g),o.registerEditorAction(k),o.registerEditorAction(_),d.MenuRegistry.appendMenuItem(d.MenuId.MenubarGoMenu,{group:"5_infile_nav",command:{id:"editor.action.jumpToBracket",title:l.localize({key:"miGoToBracket",comment:["&& denotes a mnemonic"]},"Go to &&Bracket")},order:2}),exports.BracketMatchingController=B;
//# sourceMappingURL=bracketMatching.js.map
