"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var e=require("../../../../base/common/arrays.js"),o=require("../../../../base/common/cancellation.js"),i=require("../../../../base/common/errors.js"),t=require("../../../../base/common/lifecycle.js"),n=require("../../../../base/common/uri.js"),r=require("../../../browser/services/bulkEditService.js"),c=require("../../../common/core/range.js"),a=require("../../../common/core/selection.js"),s=require("../../../common/services/languageFeatures.js"),d=require("../../../common/services/model.js"),l=require("../../editorState/browser/editorState.js"),m=require("../../../../nls.js"),u=require("../../../../platform/commands/common/commands.js"),p=require("../../../../platform/notification/common/notification.js"),f=require("../../../../platform/progress/common/progress.js"),A=require("../../../../platform/telemetry/common/telemetry.js"),g=require("../common/types.js"),y=require("../../../../base/common/hierarchicalKind.js");class C extends t.Disposable{static codeActionsPreferredComparator(e,o){return e.isPreferred&&!o.isPreferred?-1:!e.isPreferred&&o.isPreferred?1:0}static codeActionsComparator({action:o},{action:i}){return o.isAI&&!i.isAI?1:!o.isAI&&i.isAI?-1:e.isNonEmptyArray(o.diagnostics)?e.isNonEmptyArray(i.diagnostics)?C.codeActionsPreferredComparator(o,i):-1:e.isNonEmptyArray(i.diagnostics)?1:C.codeActionsPreferredComparator(o,i)}constructor(e,o,i){super(),this.documentation=o,this._register(i),this.allActions=[...e].sort(C.codeActionsComparator),this.validActions=this.allActions.filter((({action:e})=>!e.disabled))}get hasAutoFix(){return this.validActions.some((({action:e})=>!!e.kind&&g.CodeActionKind.QuickFix.contains(new y.HierarchicalKind(e.kind))&&!!e.isPreferred))}get hasAIFix(){return this.validActions.some((({action:e})=>!!e.isAI))}get allAIFixes(){return this.validActions.every((({action:e})=>!!e.isAI))}}const v={actions:[],documentation:void 0};async function h(o,n,r,c,a,s){const d=c.filter||{},m={...d,excludes:[...d.excludes||[],g.CodeActionKind.Notebook]},u={only:d.include?.value,trigger:c.type},p=new l.TextModelCancellationTokenSource(n,s),f=2===c.type,A=function(e,o,i){return e.all(o).filter((e=>!e.providedCodeActionKinds||e.providedCodeActionKinds.some((e=>g.mayIncludeActionsOfKind(i,new y.HierarchicalKind(e))))))}(o,n,f?m:d),h=new t.DisposableStore,x=A.map((async e=>{try{a.report(e);const o=await e.provideCodeActions(n,r,u,p.token);if(o&&h.add(o),p.token.isCancellationRequested)return v;const i=(o?.actions||[]).filter((e=>e&&g.filtersAction(d,e))),t=function(e,o,i){if(!e.documentation)return;const t=e.documentation.map((e=>({kind:new y.HierarchicalKind(e.kind),command:e.command})));if(i){let e;for(const o of t)o.kind.contains(i)&&(e?e.kind.contains(o.kind)&&(e=o):e=o);if(e)return e?.command}for(const e of o)if(e.kind)for(const o of t)if(o.kind.contains(new y.HierarchicalKind(e.kind)))return o.command;return}(e,i,d.include);return{actions:i.map((o=>new g.CodeActionItem(o,e))),documentation:t}}catch(e){if(i.isCancellationError(e))throw e;return i.onUnexpectedExternalError(e),v}})),w=o.onDidChange((()=>{const i=o.all(n);e.equals(i,A)||p.cancel()}));try{const i=await Promise.all(x),t=i.map((e=>e.actions)).flat(),r=[...e.coalesce(i.map((e=>e.documentation))),...I(o,n,c,t)];return new C(t,r,h)}finally{w.dispose(),p.dispose()}}function*I(e,o,i,t){if(o&&t.length)for(const n of e.all(o))n._getAdditionalMenuItems&&(yield*n._getAdditionalMenuItems?.({trigger:i.type,only:i.filter?.include?.value},t.map((e=>e.action))))}var x;exports.ApplyCodeActionReason=void 0,(x=exports.ApplyCodeActionReason||(exports.ApplyCodeActionReason={})).OnSave="onSave",x.FromProblemsView="fromProblemsView",x.FromCodeActions="fromCodeActions",x.FromAILightbulb="fromAILightbulb",u.CommandsRegistry.registerCommand("_executeCodeActionProvider",(async function(e,t,r,l,m){if(!(t instanceof n.URI))throw i.illegalArgument();const{codeActionProvider:u}=e.get(s.ILanguageFeaturesService),p=e.get(d.IModelService).getModel(t);if(!p)throw i.illegalArgument();const A=a.Selection.isISelection(r)?a.Selection.liftSelection(r):c.Range.isIRange(r)?p.validateRange(r):void 0;if(!A)throw i.illegalArgument();const C="string"==typeof l?new y.HierarchicalKind(l):void 0,v=await h(u,p,A,{type:1,triggerAction:g.CodeActionTriggerSource.Default,filter:{includeSourceActions:!0,include:C}},f.Progress.None,o.CancellationToken.None),I=[],x=Math.min(v.validActions.length,"number"==typeof m?m:0);for(let e=0;e<x;e++)I.push(v.validActions[e].resolve(o.CancellationToken.None));try{return await Promise.all(I),v.validActions.map((e=>e.action))}finally{setTimeout((()=>v.dispose()),100)}})),exports.applyCodeAction=async function(e,i,t,n,c=o.CancellationToken.None){const a=e.get(r.IBulkEditService),s=e.get(u.ICommandService),d=e.get(A.ITelemetryService),l=e.get(p.INotificationService);if(d.publicLog2("codeAction.applyCodeAction",{codeActionTitle:i.action.title,codeActionKind:i.action.kind,codeActionIsPreferred:!!i.action.isPreferred,reason:t}),await i.resolve(c),!c.isCancellationRequested){if(i.action.edit?.edits.length){if(!(await a.apply(i.action.edit,{editor:n?.editor,label:i.action.title,quotableLabel:i.action.title,code:"undoredo.codeAction",respectAutoSaveConfig:t!==exports.ApplyCodeActionReason.OnSave,showPreview:n?.preview})).isApplied)return}if(i.action.command)try{await s.executeCommand(i.action.command.id,...i.action.command.arguments||[])}catch(e){const o=function(e){return"string"==typeof e?e:e instanceof Error&&"string"==typeof e.message?e.message:void 0}(e);l.error("string"==typeof o?o:m.localize("applyCodeActionFailed","An unknown error occurred while applying the code action"))}}},exports.autoFixCommandId="editor.action.autoFix",exports.codeActionCommandId="editor.action.codeAction",exports.fixAllCommandId="editor.action.fixAll",exports.getCodeActions=h,exports.organizeImportsCommandId="editor.action.organizeImports",exports.quickFixCommandId="editor.action.quickFix",exports.refactorCommandId="editor.action.refactor",exports.sourceActionCommandId="editor.action.sourceAction";
//# sourceMappingURL=codeAction.js.map
