"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var e=require("../../../../base/common/hierarchicalKind.js"),o=require("../../../../base/common/strings.js"),r=require("../../../browser/editorExtensions.js"),i=require("../../../common/editorContextKeys.js"),t=require("./codeAction.js"),n=require("../../../../nls.js"),a=require("../../../../platform/contextkey/common/contextkey.js"),c=require("../common/types.js"),d=require("./codeActionController.js"),s=require("./codeActionModel.js");function l(e){return a.ContextKeyExpr.regex(s.SUPPORTED_CODE_ACTIONS.keys()[0],new RegExp("(\\s|^)"+o.escapeRegExpCharacters(e.value)+"\\b"))}const p={type:"object",defaultSnippets:[{body:{kind:""}}],properties:{kind:{type:"string",description:n.localize("args.schema.kind","Kind of the code action to run.")},apply:{type:"string",description:n.localize("args.schema.apply","Controls when the returned actions are applied."),default:"ifSingle",enum:["first","ifSingle","never"],enumDescriptions:[n.localize("args.schema.apply.first","Always apply the first returned code action."),n.localize("args.schema.apply.ifSingle","Apply the first returned code action if it is the only one."),n.localize("args.schema.apply.never","Do not apply the returned code actions.")]},preferred:{type:"boolean",default:!1,description:n.localize("args.schema.preferred","Controls if only preferred code actions should be returned.")}}};function u(e,o,r,i,t=c.CodeActionTriggerSource.Default){if(e.hasModel()){const n=d.CodeActionController.get(e);n?.manualTriggerAtCurrentPosition(o,t,r,i)}}class x extends r.EditorAction{constructor(){super({id:t.quickFixCommandId,label:n.localize("quickfix.trigger.label","Quick Fix..."),alias:"Quick Fix...",precondition:a.ContextKeyExpr.and(i.EditorContextKeys.writable,i.EditorContextKeys.hasCodeActionsProvider),kbOpts:{kbExpr:i.EditorContextKeys.textInputFocus,primary:2137,weight:100}})}run(e,o){return u(o,n.localize("editor.action.quickFix.noneMessage","No code actions available"),void 0,void 0,c.CodeActionTriggerSource.QuickFix)}}class f extends r.EditorCommand{constructor(){super({id:t.codeActionCommandId,precondition:a.ContextKeyExpr.and(i.EditorContextKeys.writable,i.EditorContextKeys.hasCodeActionsProvider),metadata:{description:"Trigger a code action",args:[{name:"args",schema:p}]}})}runEditorCommand(o,r,i){const t=c.CodeActionCommandArgs.fromUser(i,{kind:e.HierarchicalKind.Empty,apply:"ifSingle"});return u(r,"string"==typeof i?.kind?t.preferred?n.localize("editor.action.codeAction.noneMessage.preferred.kind","No preferred code actions for '{0}' available",i.kind):n.localize("editor.action.codeAction.noneMessage.kind","No code actions for '{0}' available",i.kind):t.preferred?n.localize("editor.action.codeAction.noneMessage.preferred","No preferred code actions available"):n.localize("editor.action.codeAction.noneMessage","No code actions available"),{include:t.kind,includeSourceActions:!0,onlyIncludePreferredActions:t.preferred},t.apply)}}class g extends r.EditorAction{constructor(){super({id:t.refactorCommandId,label:n.localize("refactor.label","Refactor..."),alias:"Refactor...",precondition:a.ContextKeyExpr.and(i.EditorContextKeys.writable,i.EditorContextKeys.hasCodeActionsProvider),kbOpts:{kbExpr:i.EditorContextKeys.textInputFocus,primary:3120,mac:{primary:1328},weight:100},contextMenuOpts:{group:"1_modification",order:2,when:a.ContextKeyExpr.and(i.EditorContextKeys.writable,l(c.CodeActionKind.Refactor))},metadata:{description:"Refactor...",args:[{name:"args",schema:p}]}})}run(o,r,i){const t=c.CodeActionCommandArgs.fromUser(i,{kind:c.CodeActionKind.Refactor,apply:"never"});return u(r,"string"==typeof i?.kind?t.preferred?n.localize("editor.action.refactor.noneMessage.preferred.kind","No preferred refactorings for '{0}' available",i.kind):n.localize("editor.action.refactor.noneMessage.kind","No refactorings for '{0}' available",i.kind):t.preferred?n.localize("editor.action.refactor.noneMessage.preferred","No preferred refactorings available"):n.localize("editor.action.refactor.noneMessage","No refactorings available"),{include:c.CodeActionKind.Refactor.contains(t.kind)?t.kind:e.HierarchicalKind.None,onlyIncludePreferredActions:t.preferred},t.apply,c.CodeActionTriggerSource.Refactor)}}class A extends r.EditorAction{constructor(){super({id:t.sourceActionCommandId,label:n.localize("source.label","Source Action..."),alias:"Source Action...",precondition:a.ContextKeyExpr.and(i.EditorContextKeys.writable,i.EditorContextKeys.hasCodeActionsProvider),contextMenuOpts:{group:"1_modification",order:2.1,when:a.ContextKeyExpr.and(i.EditorContextKeys.writable,l(c.CodeActionKind.Source))},metadata:{description:"Source Action...",args:[{name:"args",schema:p}]}})}run(o,r,i){const t=c.CodeActionCommandArgs.fromUser(i,{kind:c.CodeActionKind.Source,apply:"never"});return u(r,"string"==typeof i?.kind?t.preferred?n.localize("editor.action.source.noneMessage.preferred.kind","No preferred source actions for '{0}' available",i.kind):n.localize("editor.action.source.noneMessage.kind","No source actions for '{0}' available",i.kind):t.preferred?n.localize("editor.action.source.noneMessage.preferred","No preferred source actions available"):n.localize("editor.action.source.noneMessage","No source actions available"),{include:c.CodeActionKind.Source.contains(t.kind)?t.kind:e.HierarchicalKind.None,includeSourceActions:!0,onlyIncludePreferredActions:t.preferred},t.apply,c.CodeActionTriggerSource.SourceAction)}}class m extends r.EditorAction{constructor(){super({id:t.organizeImportsCommandId,label:n.localize("organizeImports.label","Organize Imports"),alias:"Organize Imports",precondition:a.ContextKeyExpr.and(i.EditorContextKeys.writable,l(c.CodeActionKind.SourceOrganizeImports)),kbOpts:{kbExpr:i.EditorContextKeys.textInputFocus,primary:1581,weight:100}})}run(e,o){return u(o,n.localize("editor.action.organize.noneMessage","No organize imports action available"),{include:c.CodeActionKind.SourceOrganizeImports,includeSourceActions:!0},"ifSingle",c.CodeActionTriggerSource.OrganizeImports)}}class C extends r.EditorAction{constructor(){super({id:t.fixAllCommandId,label:n.localize("fixAll.label","Fix All"),alias:"Fix All",precondition:a.ContextKeyExpr.and(i.EditorContextKeys.writable,l(c.CodeActionKind.SourceFixAll))})}run(e,o){return u(o,n.localize("fixAll.noneMessage","No fix all action available"),{include:c.CodeActionKind.SourceFixAll,includeSourceActions:!0},"ifSingle",c.CodeActionTriggerSource.FixAll)}}class y extends r.EditorAction{constructor(){super({id:t.autoFixCommandId,label:n.localize("autoFix.label","Auto Fix..."),alias:"Auto Fix...",precondition:a.ContextKeyExpr.and(i.EditorContextKeys.writable,l(c.CodeActionKind.QuickFix)),kbOpts:{kbExpr:i.EditorContextKeys.textInputFocus,primary:1625,mac:{primary:2649},weight:100}})}run(e,o){return u(o,n.localize("editor.action.autoFix.noneMessage","No auto fixes available"),{include:c.CodeActionKind.QuickFix,onlyIncludePreferredActions:!0},"ifSingle",c.CodeActionTriggerSource.AutoFix)}}exports.AutoFixAction=y,exports.CodeActionCommand=f,exports.FixAllAction=C,exports.OrganizeImportsAction=m,exports.QuickFixAction=x,exports.RefactorAction=g,exports.SourceAction=A;
//# sourceMappingURL=codeActionCommands.js.map
