"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var e=require("../../../../base/browser/dom.js"),t=require("../../../../base/browser/ui/aria/aria.js"),i=require("../../../../base/common/errors.js"),o=require("../../../../base/common/lazy.js"),r=require("../../../../base/common/lifecycle.js"),s=require("../../../common/core/position.js"),n=require("../../../common/model/textModel.js"),c=require("../../../common/services/languageFeatures.js"),l=require("./codeAction.js"),a=require("./codeActionKeybindingResolver.js"),d=require("./codeActionMenu.js"),h=require("./lightBulbWidget.js"),g=require("../../message/browser/messageController.js"),u=require("../../../../nls.js"),m=require("../../../../platform/actionWidget/browser/actionWidget.js"),p=require("../../../../platform/commands/common/commands.js"),A=require("../../../../platform/configuration/common/configuration.js"),f=require("../../../../platform/contextkey/common/contextkey.js"),b=require("../../../../platform/instantiation/common/instantiation.js"),v=require("../../../../platform/markers/common/markers.js"),C=require("../../../../platform/progress/common/progress.js");require("../../../../platform/theme/common/colorUtils.js"),require("../../../../platform/theme/common/colors/baseColors.js"),require("../../../../platform/theme/common/colors/chartsColors.js");var _=require("../../../../platform/theme/common/colors/editorColors.js");require("../../../../platform/theme/common/colors/inputColors.js"),require("../../../../platform/theme/common/colors/listColors.js"),require("../../../../platform/theme/common/colors/menuColors.js"),require("../../../../platform/theme/common/colors/minimapColors.js"),require("../../../../platform/theme/common/colors/miscColors.js"),require("../../../../platform/theme/common/colors/quickpickColors.js"),require("../../../../platform/theme/common/colors/searchColors.js");var y,q=require("../../../../platform/theme/common/theme.js"),w=require("../../../../platform/theme/common/themeService.js"),j=require("../common/types.js"),S=require("./codeActionModel.js"),x=require("../../../../base/common/hierarchicalKind.js"),D=require("../../../../platform/telemetry/common/telemetry.js"),I=self&&self.__decorate||function(e,t,i,o){var r,s=arguments.length,n=s<3?t:null===o?o=Object.getOwnPropertyDescriptor(t,i):o;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)n=Reflect.decorate(e,t,i,o);else for(var c=e.length-1;c>=0;c--)(r=e[c])&&(n=(s<3?r(n):s>3?r(t,i,n):r(t,i))||n);return s>3&&n&&Object.defineProperty(t,i,n),n},M=self&&self.__param||function(e,t){return function(i,o){t(i,o,e)}};exports.CodeActionController=class extends r.Disposable{static{y=this}static{this.ID="editor.contrib.codeActionController"}static get(e){return e.getContribution(y.ID)}constructor(e,t,i,s,n,c,l,d,g,u,m){super(),this._commandService=l,this._configurationService=d,this._actionWidgetService=g,this._instantiationService=u,this._telemetryService=m,this._activeCodeActions=this._register(new r.MutableDisposable),this._showDisabled=!1,this._disposed=!1,this._editor=e,this._model=this._register(new S.CodeActionModel(this._editor,n.codeActionProvider,t,i,c,d,this._telemetryService)),this._register(this._model.onDidChangeState((e=>this.update(e)))),this._lightBulbWidget=new o.Lazy((()=>{const e=this._editor.getContribution(h.LightBulbWidget.ID);return e&&this._register(e.onClick((e=>this.showCodeActionsFromLightbulb(e.actions,e)))),e})),this._resolver=s.createInstance(a.CodeActionKeybindingResolver),this._register(this._editor.onDidLayoutChange((()=>this._actionWidgetService.hide())))}dispose(){this._disposed=!0,super.dispose()}async showCodeActionsFromLightbulb(e,t){if(e.allAIFixes&&1===e.validActions.length){const t=e.validActions[0],i=t.action.command;return i&&"inlineChat.start"===i.id&&i.arguments&&i.arguments.length>=1&&(i.arguments[0]={...i.arguments[0],autoSend:!1}),void await this._applyCodeAction(t,!1,!1,l.ApplyCodeActionReason.FromAILightbulb)}await this.showCodeActionList(e,t,{includeDisabledActions:!1,fromLightbulb:!0})}showCodeActions(e,t,i){return this.showCodeActionList(t,i,{includeDisabledActions:!1,fromLightbulb:!1})}manualTriggerAtCurrentPosition(e,t,i,o){if(!this._editor.hasModel())return;g.MessageController.get(this._editor)?.closeMessage();const r=this._editor.getPosition();this._trigger({type:1,triggerAction:t,filter:i,autoApply:o,context:{notAvailableMessage:e,position:r}})}_trigger(e){return this._model.trigger(e)}async _applyCodeAction(e,t,i,o){try{await this._instantiationService.invokeFunction(l.applyCodeAction,e,o,{preview:i,editor:this._editor})}finally{t&&this._trigger({type:2,triggerAction:j.CodeActionTriggerSource.QuickFix,filter:{}})}}hideLightBulbWidget(){this._lightBulbWidget.rawValue?.hide(),this._lightBulbWidget.rawValue?.gutterHide()}async update(e){if(1!==e.type)return void this.hideLightBulbWidget();let t;try{t=await e.actions}catch(e){return void i.onUnexpectedError(e)}if(this._disposed)return;const o=this._editor.getSelection();if(o?.startLineNumber===e.position.lineNumber)if(this._lightBulbWidget.value?.update(t,e.trigger,e.position),1===e.trigger.type){if(e.trigger.filter?.include){const i=this.tryGetValidActionToApply(e.trigger,t);if(i){try{this.hideLightBulbWidget(),await this._applyCodeAction(i,!1,!1,l.ApplyCodeActionReason.FromCodeActions)}finally{t.dispose()}return}if(e.trigger.context){const i=this.getInvalidActionThatWouldHaveBeenApplied(e.trigger,t);if(i&&i.action.disabled)return g.MessageController.get(this._editor)?.showMessage(i.action.disabled,e.trigger.context.position),void t.dispose()}}const i=!!e.trigger.filter?.include;if(e.trigger.context&&(!t.allActions.length||!i&&!t.validActions.length))return g.MessageController.get(this._editor)?.showMessage(e.trigger.context.notAvailableMessage,e.trigger.context.position),this._activeCodeActions.value=t,void t.dispose();this._activeCodeActions.value=t,this.showCodeActionList(t,this.toCoords(e.position),{includeDisabledActions:i,fromLightbulb:!1})}else this._actionWidgetService.isVisible?t.dispose():this._activeCodeActions.value=t}getInvalidActionThatWouldHaveBeenApplied(e,t){if(t.allActions.length)return"first"===e.autoApply&&0===t.validActions.length||"ifSingle"===e.autoApply&&1===t.allActions.length?t.allActions.find((({action:e})=>e.disabled)):void 0}tryGetValidActionToApply(e,t){if(t.validActions.length)return"first"===e.autoApply&&t.validActions.length>0||"ifSingle"===e.autoApply&&1===t.validActions.length?t.validActions[0]:void 0}static{this.DECORATION=n.ModelDecorationOptions.register({description:"quickfix-highlight",className:"quickfix-edit-highlight"})}async showCodeActionList(e,i,o){const r=this._editor.createDecorationsCollection(),n=this._editor.getDomNode();if(!n)return;const c=o.includeDisabledActions&&(this._showDisabled||0===e.validActions.length)?e.allActions:e.validActions;if(!c.length)return;const a=s.Position.isIPosition(i)?this.toCoords(i):i,h={onSelect:async(e,t)=>{this._applyCodeAction(e,!0,!!t,o.fromLightbulb?l.ApplyCodeActionReason.FromAILightbulb:l.ApplyCodeActionReason.FromCodeActions),this._actionWidgetService.hide(!1),r.clear()},onHide:e=>{this._editor?.focus(),r.clear()},onHover:async(e,t)=>{if(t.isCancellationRequested)return;let i=!1;const o=e.action.kind;if(o){const e=new x.HierarchicalKind(o);i=[j.CodeActionKind.RefactorExtract,j.CodeActionKind.RefactorInline,j.CodeActionKind.RefactorRewrite,j.CodeActionKind.RefactorMove,j.CodeActionKind.Source].some((t=>t.contains(e)))}return{canPreview:i||!!e.action.edit?.edits.length}},onFocus:e=>{if(e&&e.action){const i=e.action.ranges,o=e.action.diagnostics;if(r.clear(),i&&i.length>0){const e=o&&o?.length>1?o.map((e=>({range:e,options:y.DECORATION}))):i.map((e=>({range:e,options:y.DECORATION})));r.set(e)}else if(o&&o.length>0){const e=o.map((e=>({range:e,options:y.DECORATION})));r.set(e);const i=o[0];if(i.startLineNumber&&i.startColumn){const e=this._editor.getModel()?.getWordAtPosition({lineNumber:i.startLineNumber,column:i.startColumn})?.word;t.status(u.localize("editingNewSelection","Context: {0} at line {1} and column {2}.",e,i.startLineNumber,i.startColumn))}}}else r.clear()}};this._actionWidgetService.show("codeActionWidget",!0,d.toMenuItems(c,this._shouldShowHeaders(),this._resolver.getResolver()),h,a,n,this._getActionBarActions(e,i,o))}toCoords(t){if(!this._editor.hasModel())return{x:0,y:0};this._editor.revealPosition(t,1),this._editor.render();const i=this._editor.getScrolledVisiblePosition(t),o=e.getDomNodePagePosition(this._editor.getDomNode());return{x:o.left+i.left,y:o.top+i.top+i.height}}_shouldShowHeaders(){const e=this._editor?.getModel();return this._configurationService.getValue("editor.codeActionWidget.showHeaders",{resource:e?.uri})}_getActionBarActions(e,t,i){if(i.fromLightbulb)return[];const o=e.documentation.map((e=>({id:e.id,label:e.title,tooltip:e.tooltip??"",class:void 0,enabled:!0,run:()=>this._commandService.executeCommand(e.id,...e.arguments??[])})));return i.includeDisabledActions&&e.validActions.length>0&&e.allActions.length!==e.validActions.length&&o.push(this._showDisabled?{id:"hideMoreActions",label:u.localize("hideMoreActions","Hide Disabled"),enabled:!0,tooltip:"",class:void 0,run:()=>(this._showDisabled=!1,this.showCodeActionList(e,t,i))}:{id:"showMoreActions",label:u.localize("showMoreActions","Show Disabled"),enabled:!0,tooltip:"",class:void 0,run:()=>(this._showDisabled=!0,this.showCodeActionList(e,t,i))}),o}},exports.CodeActionController=y=I([M(1,v.IMarkerService),M(2,f.IContextKeyService),M(3,b.IInstantiationService),M(4,c.ILanguageFeaturesService),M(5,C.IEditorProgressService),M(6,p.ICommandService),M(7,A.IConfigurationService),M(8,m.IActionWidgetService),M(9,b.IInstantiationService),M(10,D.ITelemetryService)],exports.CodeActionController),w.registerThemingParticipant(((e,t)=>{var i,o;i=".quickfix-edit-highlight",(o=e.getColor(_.editorFindMatchHighlight))&&t.addRule(`.monaco-editor ${i} { background-color: ${o}; }`);const r=e.getColor(_.editorFindMatchHighlightBorder);r&&t.addRule(`.monaco-editor .quickfix-edit-highlight { border: 1px ${q.isHighContrast(e.type)?"dotted":"solid"} ${r}; box-sizing: border-box; }`)}));
//# sourceMappingURL=codeActionController.js.map
