"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var e=require("../../../../base/common/async.js"),t=require("../../../../base/common/errors.js"),i=require("../../../../base/common/event.js"),s=require("../../../../base/common/lifecycle.js"),o=require("../../../../base/common/resources.js"),r=require("../../../common/config/editorOptions.js"),n=require("../../../common/core/position.js"),c=require("../../../common/core/selection.js"),a=require("../../../../platform/contextkey/common/contextkey.js"),d=require("../../../../platform/progress/common/progress.js"),l=require("../common/types.js"),g=require("./codeAction.js"),h=require("../../../../base/common/hierarchicalKind.js"),u=require("../../../../base/common/stopwatch.js");const _=new a.RawContextKey("supportedCodeAction",""),p="_typescript.applyFixAllCodeAction";class A extends s.Disposable{constructor(t,i,s,o=250){super(),this._editor=t,this._markerService=i,this._signalChange=s,this._delay=o,this._autoTriggerTimer=this._register(new e.TimeoutTimer),this._register(this._markerService.onMarkerChanged((e=>this._onMarkerChanges(e)))),this._register(this._editor.onDidChangeCursorPosition((()=>this._tryAutoTrigger())))}trigger(e){const t=this._getRangeOfSelectionUnlessWhitespaceEnclosed(e);this._signalChange(t?{trigger:e,selection:t}:void 0)}_onMarkerChanges(e){const t=this._editor.getModel();t&&e.some((e=>o.isEqual(e,t.uri)))&&this._tryAutoTrigger()}_tryAutoTrigger(){this._autoTriggerTimer.cancelAndSet((()=>{this.trigger({type:2,triggerAction:l.CodeActionTriggerSource.Default})}),this._delay)}_getRangeOfSelectionUnlessWhitespaceEnclosed(e){if(!this._editor.hasModel())return;const t=this._editor.getSelection();if(1===e.type)return t;const i=this._editor.getOption(65).enabled;if(i!==r.ShowLightbulbIconMode.Off){if(i===r.ShowLightbulbIconMode.On)return t;if(i===r.ShowLightbulbIconMode.OnCode){if(!t.isEmpty())return t;const e=this._editor.getModel(),{lineNumber:i,column:s}=t.getPosition(),o=e.getLineContent(i);if(0===o.length)return;if(1===s){if(/\s/.test(o[0]))return}else if(s===e.getLineMaxColumn(i)){if(/\s/.test(o[o.length-1]))return}else if(/\s/.test(o[s-2])&&/\s/.test(o[s-1]))return}return t}}}exports.CodeActionsState=void 0,function(e){e.Empty={type:0};e.Triggered=class{constructor(e,i,s){this.trigger=e,this.position=i,this._cancellablePromise=s,this.type=1,this.actions=s.catch((e=>{if(t.isCancellationError(e))return m;throw e}))}cancel(){this._cancellablePromise.cancel()}}}(exports.CodeActionsState||(exports.CodeActionsState={}));const m=Object.freeze({allActions:[],validActions:[],dispose:()=>{},documentation:[],hasAutoFix:!1,hasAIFix:!1,allAIFixes:!1});class f extends s.Disposable{constructor(e,t,o,r,n,c,a){super(),this._editor=e,this._registry=t,this._markerService=o,this._progressService=n,this._configurationService=c,this._telemetryService=a,this._codeActionOracle=this._register(new s.MutableDisposable),this._state=exports.CodeActionsState.Empty,this._onDidChangeState=this._register(new i.Emitter),this.onDidChangeState=this._onDidChangeState.event,this._disposed=!1,this._supportedCodeActions=_.bindTo(r),this._register(this._editor.onDidChangeModel((()=>this._update()))),this._register(this._editor.onDidChangeModelLanguage((()=>this._update()))),this._register(this._registry.onDidChange((()=>this._update()))),this._register(this._editor.onDidChangeConfiguration((e=>{e.hasChanged(65)&&this._update()}))),this._update()}dispose(){this._disposed||(this._disposed=!0,super.dispose(),this.setState(exports.CodeActionsState.Empty,!0))}_settingEnabledNearbyQuickfixes(){const e=this._editor?.getModel();return!!this._configurationService&&this._configurationService.getValue("editor.codeActionWidget.includeNearbyQuickFixes",{resource:e?.uri})}_update(){if(this._disposed)return;this._codeActionOracle.value=void 0,this.setState(exports.CodeActionsState.Empty);const t=this._editor.getModel();if(t&&this._registry.has(t)&&!this._editor.getOption(92)){const i=this._registry.all(t).flatMap((e=>e.providedCodeActionKinds??[]));this._supportedCodeActions.set(i.join(" ")),this._codeActionOracle.value=new A(this._editor,this._markerService,(i=>{if(!i)return void this.setState(exports.CodeActionsState.Empty);const s=i.selection.getStartPosition(),o=e.createCancelablePromise((async e=>{if(this._settingEnabledNearbyQuickfixes()&&1===i.trigger.type&&(i.trigger.triggerAction===l.CodeActionTriggerSource.QuickFix||i.trigger.filter?.include?.contains(l.CodeActionKind.QuickFix))){const s=await g.getCodeActions(this._registry,t,i.selection,i.trigger,d.Progress.None,e),o=[...s.allActions];if(e.isCancellationRequested)return m;const r=s.validActions?.some((e=>!!e.action.kind&&l.CodeActionKind.QuickFix.contains(new h.HierarchicalKind(e.action.kind)))),a=this._markerService.read({resource:t.uri});if(r){for(const e of s.validActions)e.action.command?.arguments?.some((e=>"string"==typeof e&&e.includes(p)))&&(e.action.diagnostics=[...a.filter((e=>e.relatedInformation))]);return{validActions:s.validActions,allActions:o,documentation:s.documentation,hasAutoFix:s.hasAutoFix,hasAIFix:s.hasAIFix,allAIFixes:s.allAIFixes,dispose:()=>{s.dispose()}}}if(!r&&a.length>0){const r=i.selection.getPosition();let h=r,u=Number.MAX_VALUE;const _=[...s.validActions];for(const A of a){const m=A.endColumn,f=A.endLineNumber,y=A.startLineNumber;if(f===r.lineNumber||y===r.lineNumber){h=new n.Position(f,m);const A={type:i.trigger.type,triggerAction:i.trigger.triggerAction,filter:{include:i.trigger.filter?.include?i.trigger.filter?.include:l.CodeActionKind.QuickFix},autoApply:i.trigger.autoApply,context:{notAvailableMessage:i.trigger.context?.notAvailableMessage||"",position:h}},y=new c.Selection(h.lineNumber,h.column,h.lineNumber,h.column),C=await g.getCodeActions(this._registry,t,y,A,d.Progress.None,e);if(0!==C.validActions.length){for(const e of C.validActions)e.action.command?.arguments?.some((e=>"string"==typeof e&&e.includes(p)))&&(e.action.diagnostics=[...a.filter((e=>e.relatedInformation))]);0===s.allActions.length&&o.push(...C.allActions),Math.abs(r.column-m)<u?_.unshift(...C.validActions):_.push(...C.validActions)}u=Math.abs(r.column-m)}}const A=_.filter(((e,t,i)=>i.findIndex((t=>t.action.title===e.action.title))===t));return A.sort(((e,t)=>e.action.isPreferred&&!t.action.isPreferred?-1:!e.action.isPreferred&&t.action.isPreferred||e.action.isAI&&!t.action.isAI?1:!e.action.isAI&&t.action.isAI?-1:0)),{validActions:A,allActions:o,documentation:s.documentation,hasAutoFix:s.hasAutoFix,hasAIFix:s.hasAIFix,allAIFixes:s.allAIFixes,dispose:()=>{s.dispose()}}}}if(1===i.trigger.type){const s=new u.StopWatch,o=await g.getCodeActions(this._registry,t,i.selection,i.trigger,d.Progress.None,e);return this._telemetryService&&this._telemetryService.publicLog2("codeAction.invokedDurations",{codeActions:o.validActions.length,duration:s.elapsed()}),o}return g.getCodeActions(this._registry,t,i.selection,i.trigger,d.Progress.None,e)}));1===i.trigger.type&&this._progressService?.showWhile(o,250);const r=new exports.CodeActionsState.Triggered(i.trigger,s,o);let a=!1;1===this._state.type&&(a=1===this._state.trigger.type&&1===r.type&&2===r.trigger.type&&this._state.position!==r.position),a?setTimeout((()=>{this.setState(r)}),500):this.setState(r)}),void 0),this._codeActionOracle.value.trigger({type:2,triggerAction:l.CodeActionTriggerSource.Default})}else this._supportedCodeActions.reset()}trigger(e){this._codeActionOracle.value?.trigger(e)}setState(e,t){e!==this._state&&(1===this._state.type&&this._state.cancel(),this._state=e,t||this._disposed||this._onDidChangeState.fire(e))}}exports.APPLY_FIX_ALL_COMMAND_ID=p,exports.CodeActionModel=f,exports.SUPPORTED_CODE_ACTIONS=_;
//# sourceMappingURL=codeActionModel.js.map
