"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var t=require("../../../../base/browser/dom.js"),e=require("../../../../base/browser/touch.js"),i=require("../../../../base/common/codicons.js"),o=require("../../../../base/common/event.js"),s=require("../../../../base/common/lifecycle.js"),n=require("../../../../base/common/themables.js");require("./lightBulbWidget.css.js");var r,a=require("../../../common/model.js"),h=require("../../../common/model/textModel.js"),c=require("../../../common/model/utils.js"),d=require("./codeAction.js"),l=require("../../../../nls.js"),u=require("../../../../platform/keybinding/common/keybinding.js"),g=require("../../../../platform/theme/common/iconRegistry.js"),b=require("../../../common/core/range.js"),p=self&&self.__decorate||function(t,e,i,o){var s,n=arguments.length,r=n<3?e:null===o?o=Object.getOwnPropertyDescriptor(e,i):o;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(t,e,i,o);else for(var a=t.length-1;a>=0;a--)(s=t[a])&&(r=(n<3?s(r):n>3?s(e,i,r):s(e,i))||r);return n>3&&r&&Object.defineProperty(e,i,r),r},_=self&&self.__param||function(t,e){return function(i,o){e(i,o,t)}};const m=g.registerIcon("gutter-lightbulb",i.Codicon.lightBulb,l.localize("gutterLightbulbWidget","Icon which spawns code actions menu from the gutter when there is no space in the editor.")),f=g.registerIcon("gutter-lightbulb-auto-fix",i.Codicon.lightbulbAutofix,l.localize("gutterLightbulbAutoFixWidget","Icon which spawns code actions menu from the gutter when there is no space in the editor and a quick fix is available.")),D=g.registerIcon("gutter-lightbulb-sparkle",i.Codicon.lightbulbSparkle,l.localize("gutterLightbulbAIFixWidget","Icon which spawns code actions menu from the gutter when there is no space in the editor and an AI fix is available.")),C=g.registerIcon("gutter-lightbulb-aifix-auto-fix",i.Codicon.lightbulbSparkleAutofix,l.localize("gutterLightbulbAIFixAutoFixWidget","Icon which spawns code actions menu from the gutter when there is no space in the editor and an AI fix and a quick fix is available.")),L=g.registerIcon("gutter-lightbulb-sparkle-filled",i.Codicon.sparkleFilled,l.localize("gutterLightbulbSparkleFilledWidget","Icon which spawns code actions menu from the gutter when there is no space in the editor and an AI fix and a quick fix is available."));var I;!function(t){t.Hidden={type:0};t.Showing=class{constructor(t,e,i,o){this.actions=t,this.trigger=e,this.editorPosition=i,this.widgetPosition=o,this.type=1}}}(I||(I={})),exports.LightBulbWidget=class extends s.Disposable{static{r=this}static{this.GUTTER_DECORATION=h.ModelDecorationOptions.register({description:"codicon-gutter-lightbulb-decoration",glyphMarginClassName:n.ThemeIcon.asClassName(i.Codicon.lightBulb),glyphMargin:{position:a.GlyphMarginLane.Left},stickiness:1})}static{this.ID="editor.contrib.lightbulbWidget"}static{this._posPref=[0]}constructor(i,s){super(),this._editor=i,this._keybindingService=s,this._onClick=this._register(new o.Emitter),this.onClick=this._onClick.event,this._state=I.Hidden,this._gutterState=I.Hidden,this._iconClasses=[],this.lightbulbClasses=["codicon-"+m.id,"codicon-"+C.id,"codicon-"+f.id,"codicon-"+D.id,"codicon-"+L.id],this.gutterDecoration=r.GUTTER_DECORATION,this._domNode=t.$("div.lightBulbWidget"),this._domNode.role="listbox",this._register(e.Gesture.ignoreTarget(this._domNode)),this._editor.addContentWidget(this),this._register(this._editor.onDidChangeModelContent((t=>{const e=this._editor.getModel();(1!==this.state.type||!e||this.state.editorPosition.lineNumber>=e.getLineCount())&&this.hide(),(1!==this.gutterState.type||!e||this.gutterState.editorPosition.lineNumber>=e.getLineCount())&&this.gutterHide()}))),this._register(t.addStandardDisposableGenericMouseDownListener(this._domNode,(e=>{if(1!==this.state.type)return;this._editor.focus(),e.preventDefault();const{top:i,height:o}=t.getDomNodePagePosition(this._domNode),s=this._editor.getOption(67);let n=Math.floor(s/3);null!==this.state.widgetPosition.position&&this.state.widgetPosition.position.lineNumber<this.state.editorPosition.lineNumber&&(n+=s),this._onClick.fire({x:e.posx,y:i+o+n,actions:this.state.actions,trigger:this.state.trigger})}))),this._register(t.addDisposableListener(this._domNode,"mouseenter",(t=>{1&~t.buttons||this.hide()}))),this._register(o.Event.runAndSubscribe(this._keybindingService.onDidUpdateKeybindings,(()=>{this._preferredKbLabel=this._keybindingService.lookupKeybinding(d.autoFixCommandId)?.getLabel()??void 0,this._quickFixKbLabel=this._keybindingService.lookupKeybinding(d.quickFixCommandId)?.getLabel()??void 0,this._updateLightBulbTitleAndIcon()}))),this._register(this._editor.onMouseDown((async e=>{if(!e.target.element||!this.lightbulbClasses.some((t=>e.target.element&&e.target.element.classList.contains(t))))return;if(1!==this.gutterState.type)return;this._editor.focus();const{top:i,height:o}=t.getDomNodePagePosition(e.target.element),s=this._editor.getOption(67);let n=Math.floor(s/3);null!==this.gutterState.widgetPosition.position&&this.gutterState.widgetPosition.position.lineNumber<this.gutterState.editorPosition.lineNumber&&(n+=s),this._onClick.fire({x:e.event.posx,y:i+o+n,actions:this.gutterState.actions,trigger:this.gutterState.trigger})})))}dispose(){super.dispose(),this._editor.removeContentWidget(this),this._gutterDecorationID&&this._removeGutterDecoration(this._gutterDecorationID)}getId(){return"LightBulbWidget"}getDomNode(){return this._domNode}getPosition(){return 1===this._state.type?this._state.widgetPosition:null}update(t,e,i){if(t.validActions.length<=0)return this.gutterHide(),this.hide();if(!this._editor.hasTextFocus())return this.gutterHide(),this.hide();if(!this._editor.getOptions().get(65).enabled)return this.gutterHide(),this.hide();const o=this._editor.getModel();if(!o)return this.gutterHide(),this.hide();const{lineNumber:s,column:n}=o.validatePosition(i),a=o.getOptions().tabSize,h=this._editor.getOptions().get(50),d=o.getLineContent(s),l=c.computeIndentLevel(d,a),u=h.spaceWidth*l>22,g=t=>t>2&&this._editor.getTopForLineNumber(t)===this._editor.getTopForLineNumber(t-1),b=this._editor.getLineDecorations(s);let p=!1;if(b)for(const t of b){const e=t.options.glyphMarginClassName;if(e&&!this.lightbulbClasses.some((t=>e.includes(t)))){p=!0;break}}let _=s,m=1;if(!u){const a=t=>{const e=o.getLineContent(t);return/^\s*$|^\s+/.test(e)||e.length<=m};if(s>1&&!g(s-1)){const n=s===o.getLineCount(),h=s>1&&a(s-1),c=!n&&a(s+1),d=a(s),l=!c&&!h;if(!(c||h||p))return this.gutterState=new I.Showing(t,e,i,{position:{lineNumber:_,column:m},preference:r._posPref}),this.renderGutterLightbub(),this.hide();h||n||h&&!d?_-=1:(c||l&&d)&&(_+=1)}else if(1!==s||s!==o.getLineCount()&&(a(s+1)||a(s))){if(s<o.getLineCount()&&!g(s+1))_+=1;else if(n*h.spaceWidth<22)return this.hide()}else{if(this.gutterState=new I.Showing(t,e,i,{position:{lineNumber:_,column:m},preference:r._posPref}),!p)return this.renderGutterLightbub(),this.hide();this.gutterHide()}m=/^\S\s*$/.test(o.getLineContent(_))?2:1}this.state=new I.Showing(t,e,i,{position:{lineNumber:_,column:m},preference:r._posPref}),this._gutterDecorationID&&(this._removeGutterDecoration(this._gutterDecorationID),this.gutterHide());const f=t.validActions,D=t.validActions[0].action.kind;f.length,this._editor.layoutContentWidget(this)}hide(){this.state!==I.Hidden&&(this.state=I.Hidden,this._editor.layoutContentWidget(this))}gutterHide(){this.gutterState!==I.Hidden&&(this._gutterDecorationID&&this._removeGutterDecoration(this._gutterDecorationID),this.gutterState=I.Hidden)}get state(){return this._state}set state(t){this._state=t,this._updateLightBulbTitleAndIcon()}get gutterState(){return this._gutterState}set gutterState(t){this._gutterState=t,this._updateGutterLightBulbTitleAndIcon()}_updateLightBulbTitleAndIcon(){if(this._domNode.classList.remove(...this._iconClasses),this._iconClasses=[],1!==this.state.type)return;let t,e=!1;this.state.actions.allAIFixes?(t=i.Codicon.sparkleFilled,1===this.state.actions.validActions.length&&(e=!0)):t=this.state.actions.hasAutoFix?this.state.actions.hasAIFix?i.Codicon.lightbulbSparkleAutofix:i.Codicon.lightbulbAutofix:this.state.actions.hasAIFix?i.Codicon.lightbulbSparkle:i.Codicon.lightBulb,this._updateLightbulbTitle(this.state.actions.hasAutoFix,e),this._iconClasses=n.ThemeIcon.asClassNameArray(t),this._domNode.classList.add(...this._iconClasses)}_updateGutterLightBulbTitleAndIcon(){if(1!==this.gutterState.type)return;let t,e=!1;this.gutterState.actions.allAIFixes?(t=L,1===this.gutterState.actions.validActions.length&&(e=!0)):t=this.gutterState.actions.hasAutoFix?this.gutterState.actions.hasAIFix?C:f:this.gutterState.actions.hasAIFix?D:m,this._updateLightbulbTitle(this.gutterState.actions.hasAutoFix,e);const i=h.ModelDecorationOptions.register({description:"codicon-gutter-lightbulb-decoration",glyphMarginClassName:n.ThemeIcon.asClassName(t),glyphMargin:{position:a.GlyphMarginLane.Left},stickiness:1});this.gutterDecoration=i}renderGutterLightbub(){const t=this._editor.getSelection();t&&(void 0===this._gutterDecorationID?this._addGutterDecoration(t.startLineNumber):this._updateGutterDecoration(this._gutterDecorationID,t.startLineNumber))}_addGutterDecoration(t){this._editor.changeDecorations((e=>{this._gutterDecorationID=e.addDecoration(new b.Range(t,0,t,0),this.gutterDecoration)}))}_removeGutterDecoration(t){this._editor.changeDecorations((e=>{e.removeDecoration(t),this._gutterDecorationID=void 0}))}_updateGutterDecoration(t,e){this._editor.changeDecorations((i=>{i.changeDecoration(t,new b.Range(e,0,e,0)),i.changeDecorationOptions(t,this.gutterDecoration)}))}_updateLightbulbTitle(t,e){1===this.state.type&&(e?this.title=l.localize("codeActionAutoRun","Run: {0}",this.state.actions.validActions[0].action.title):t&&this._preferredKbLabel?this.title=l.localize("preferredcodeActionWithKb","Show Code Actions. Preferred Quick Fix Available ({0})",this._preferredKbLabel):!t&&this._quickFixKbLabel?this.title=l.localize("codeActionWithKb","Show Code Actions ({0})",this._quickFixKbLabel):t||(this.title=l.localize("codeAction","Show Code Actions")))}set title(t){this._domNode.title=t}},exports.LightBulbWidget=r=p([_(1,u.IKeybindingService)],exports.LightBulbWidget);
//# sourceMappingURL=lightBulbWidget.js.map
