"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var e=require("../../../../base/common/async.js"),s=require("../../../../base/common/errors.js"),o=require("../../../../base/common/lifecycle.js"),t=require("../../../browser/stableEditorScroll.js"),i=require("../../../browser/editorExtensions.js"),n=require("../../../common/config/editorOptions.js"),r=require("../../../common/editorContextKeys.js"),d=require("./codelens.js"),l=require("./codeLensCache.js"),a=require("./codelensWidget.js"),c=require("../../../../nls.js"),h=require("../../../../platform/commands/common/commands.js"),_=require("../../../../platform/notification/common/notification.js"),u=require("../../../../platform/quickinput/common/quickInput.js"),m=require("../../../common/services/languageFeatureDebounce.js"),C=require("../../../common/services/languageFeatures.js"),p=self&&self.__decorate||function(e,s,o,t){var i,n=arguments.length,r=n<3?s:null===t?t=Object.getOwnPropertyDescriptor(s,o):t;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,s,o,t);else for(var d=e.length-1;d>=0;d--)(i=e[d])&&(r=(n<3?i(r):n>3?i(s,o,r):i(s,o))||r);return n>3&&r&&Object.defineProperty(s,o,r),r},L=self&&self.__param||function(e,s){return function(o,t){s(o,t,e)}};exports.CodeLensContribution=class{static{this.ID="css.editor.codeLens"}constructor(s,t,i,n,r,d){this._editor=s,this._languageFeaturesService=t,this._commandService=n,this._notificationService=r,this._codeLensCache=d,this._disposables=new o.DisposableStore,this._localToDispose=new o.DisposableStore,this._lenses=[],this._oldCodeLensModels=new o.DisposableStore,this._provideCodeLensDebounce=i.for(t.codeLensProvider,"CodeLensProvide",{min:250}),this._resolveCodeLensesDebounce=i.for(t.codeLensProvider,"CodeLensResolve",{min:250,salt:"resolve"}),this._resolveCodeLensesScheduler=new e.RunOnceScheduler((()=>this._resolveCodeLensesInViewport()),this._resolveCodeLensesDebounce.default()),this._disposables.add(this._editor.onDidChangeModel((()=>this._onModelChange()))),this._disposables.add(this._editor.onDidChangeModelLanguage((()=>this._onModelChange()))),this._disposables.add(this._editor.onDidChangeConfiguration((e=>{(e.hasChanged(50)||e.hasChanged(19)||e.hasChanged(18))&&this._updateLensStyle(),e.hasChanged(17)&&this._onModelChange()}))),this._disposables.add(t.codeLensProvider.onDidChange(this._onModelChange,this)),this._onModelChange(),this._updateLensStyle()}dispose(){this._localDispose(),this._disposables.dispose(),this._oldCodeLensModels.dispose(),this._currentCodeLensModel?.dispose()}_getLayoutInfo(){const e=Math.max(1.3,this._editor.getOption(67)/this._editor.getOption(52));let s=this._editor.getOption(19);return(!s||s<5)&&(s=.9*this._editor.getOption(52)|0),{fontSize:s,codeLensHeight:s*e|0}}_updateLensStyle(){const{codeLensHeight:e,fontSize:s}=this._getLayoutInfo(),o=this._editor.getOption(18),t=this._editor.getOption(50),{style:i}=this._editor.getContainerDomNode();i.setProperty("--vscode-editorCodeLens-lineHeight",`${e}px`),i.setProperty("--vscode-editorCodeLens-fontSize",`${s}px`),i.setProperty("--vscode-editorCodeLens-fontFeatureSettings",t.fontFeatureSettings),o&&(i.setProperty("--vscode-editorCodeLens-fontFamily",o),i.setProperty("--vscode-editorCodeLens-fontFamilyDefault",n.EDITOR_FONT_DEFAULTS.fontFamily)),this._editor.changeViewZones((s=>{for(const o of this._lenses)o.updateHeight(e,s)}))}_localDispose(){this._getCodeLensModelPromise?.cancel(),this._getCodeLensModelPromise=void 0,this._resolveCodeLensesPromise?.cancel(),this._resolveCodeLensesPromise=void 0,this._localToDispose.clear(),this._oldCodeLensModels.clear(),this._currentCodeLensModel?.dispose()}_onModelChange(){this._localDispose();const i=this._editor.getModel();if(!i)return;if(!this._editor.getOption(17)||i.isTooLargeForTokenization())return;const n=this._codeLensCache.get(i);if(n&&this._renderCodeLensSymbols(n),!this._languageFeaturesService.codeLensProvider.has(i))return void(n&&e.disposableTimeout((()=>{const e=this._codeLensCache.get(i);n===e&&(this._codeLensCache.delete(i),this._onModelChange())}),3e4,this._localToDispose));for(const e of this._languageFeaturesService.codeLensProvider.all(i))if("function"==typeof e.onDidChange){const s=e.onDidChange((()=>r.schedule()));this._localToDispose.add(s)}const r=new e.RunOnceScheduler((()=>{const o=Date.now();this._getCodeLensModelPromise?.cancel(),this._getCodeLensModelPromise=e.createCancelablePromise((e=>d.getCodeLensModel(this._languageFeaturesService.codeLensProvider,i,e))),this._getCodeLensModelPromise.then((e=>{this._currentCodeLensModel&&this._oldCodeLensModels.add(this._currentCodeLensModel),this._currentCodeLensModel=e,this._codeLensCache.put(i,e);const s=this._provideCodeLensDebounce.update(i,Date.now()-o);r.delay=s,this._renderCodeLensSymbols(e),this._resolveCodeLensesInViewportSoon()}),s.onUnexpectedError)}),this._provideCodeLensDebounce.get(i));this._localToDispose.add(r),this._localToDispose.add(o.toDisposable((()=>this._resolveCodeLensesScheduler.cancel()))),this._localToDispose.add(this._editor.onDidChangeModelContent((()=>{this._editor.changeDecorations((e=>{this._editor.changeViewZones((s=>{const o=[];let t=-1;this._lenses.forEach((e=>{e.isValid()&&t!==e.getLineNumber()?(e.update(s),t=e.getLineNumber()):o.push(e)}));const i=new a.CodeLensHelper;o.forEach((e=>{e.dispose(i,s),this._lenses.splice(this._lenses.indexOf(e),1)})),i.commit(e)}))})),r.schedule(),this._resolveCodeLensesScheduler.cancel(),this._resolveCodeLensesPromise?.cancel(),this._resolveCodeLensesPromise=void 0}))),this._localToDispose.add(this._editor.onDidFocusEditorText((()=>{r.schedule()}))),this._localToDispose.add(this._editor.onDidBlurEditorText((()=>{r.cancel()}))),this._localToDispose.add(this._editor.onDidScrollChange((e=>{e.scrollTopChanged&&this._lenses.length>0&&this._resolveCodeLensesInViewportSoon()}))),this._localToDispose.add(this._editor.onDidLayoutChange((()=>{this._resolveCodeLensesInViewportSoon()}))),this._localToDispose.add(o.toDisposable((()=>{if(this._editor.getModel()){const e=t.StableEditorScrollState.capture(this._editor);this._editor.changeDecorations((e=>{this._editor.changeViewZones((s=>{this._disposeAllLenses(e,s)}))})),e.restore(this._editor)}else this._disposeAllLenses(void 0,void 0)}))),this._localToDispose.add(this._editor.onMouseDown((e=>{if(9!==e.target.type)return;let s=e.target.element;if("SPAN"===s?.tagName&&(s=s.parentElement),"A"===s?.tagName)for(const e of this._lenses){const o=e.getCommand(s);if(o){this._commandService.executeCommand(o.id,...o.arguments||[]).catch((e=>this._notificationService.error(e)));break}}}))),r.schedule()}_disposeAllLenses(e,s){const o=new a.CodeLensHelper;for(const e of this._lenses)e.dispose(o,s);e&&o.commit(e),this._lenses.length=0}_renderCodeLensSymbols(e){if(!this._editor.hasModel())return;const s=this._editor.getModel().getLineCount(),o=[];let i;for(const t of e.lenses){const e=t.symbol.range.startLineNumber;e<1||e>s||(i&&i[i.length-1].symbol.range.startLineNumber===e?i.push(t):(i=[t],o.push(i)))}if(!o.length&&!this._lenses.length)return;const n=t.StableEditorScrollState.capture(this._editor),r=this._getLayoutInfo();this._editor.changeDecorations((e=>{this._editor.changeViewZones((s=>{const t=new a.CodeLensHelper;let i=0,n=0;for(;n<o.length&&i<this._lenses.length;){const e=o[n][0].symbol.range.startLineNumber,d=this._lenses[i].getLineNumber();d<e?(this._lenses[i].dispose(t,s),this._lenses.splice(i,1)):d===e?(this._lenses[i].updateCodeLensSymbols(o[n],t),n++,i++):(this._lenses.splice(i,0,new a.CodeLensWidget(o[n],this._editor,t,s,r.codeLensHeight,(()=>this._resolveCodeLensesInViewportSoon()))),i++,n++)}for(;i<this._lenses.length;)this._lenses[i].dispose(t,s),this._lenses.splice(i,1);for(;n<o.length;)this._lenses.push(new a.CodeLensWidget(o[n],this._editor,t,s,r.codeLensHeight,(()=>this._resolveCodeLensesInViewportSoon()))),n++;t.commit(e)}))})),n.restore(this._editor)}_resolveCodeLensesInViewportSoon(){this._editor.getModel()&&this._resolveCodeLensesScheduler.schedule()}_resolveCodeLensesInViewport(){this._resolveCodeLensesPromise?.cancel(),this._resolveCodeLensesPromise=void 0;const o=this._editor.getModel();if(!o)return;const t=[],i=[];if(this._lenses.forEach((e=>{const s=e.computeIfNecessary(o);s&&(t.push(s),i.push(e))})),0===t.length)return;const n=Date.now(),r=e.createCancelablePromise((e=>{const n=t.map(((t,n)=>{const r=new Array(t.length),d=t.map(((t,i)=>t.symbol.command||"function"!=typeof t.provider.resolveCodeLens?(r[i]=t.symbol,Promise.resolve(void 0)):Promise.resolve(t.provider.resolveCodeLens(o,t.symbol,e)).then((e=>{r[i]=e}),s.onUnexpectedExternalError)));return Promise.all(d).then((()=>{e.isCancellationRequested||i[n].isDisposed()||i[n].updateCommands(r)}))}));return Promise.all(n)}));this._resolveCodeLensesPromise=r,this._resolveCodeLensesPromise.then((()=>{const e=this._resolveCodeLensesDebounce.update(o,Date.now()-n);this._resolveCodeLensesScheduler.delay=e,this._currentCodeLensModel&&this._codeLensCache.put(o,this._currentCodeLensModel),this._oldCodeLensModels.clear(),r===this._resolveCodeLensesPromise&&(this._resolveCodeLensesPromise=void 0)}),(e=>{s.onUnexpectedError(e),r===this._resolveCodeLensesPromise&&(this._resolveCodeLensesPromise=void 0)}))}async getModel(){return await this._getCodeLensModelPromise,await this._resolveCodeLensesPromise,this._currentCodeLensModel?.isDisposed?void 0:this._currentCodeLensModel}},exports.CodeLensContribution=p([L(1,C.ILanguageFeaturesService),L(2,m.ILanguageFeatureDebounceService),L(3,h.ICommandService),L(4,_.INotificationService),L(5,l.ICodeLensCache)],exports.CodeLensContribution),i.registerEditorContribution(exports.CodeLensContribution.ID,exports.CodeLensContribution,1),i.registerEditorAction(class extends i.EditorAction{constructor(){super({id:"codelens.showLensesInCurrentLine",precondition:r.EditorContextKeys.hasCodeLensProvider,label:c.localize("showLensOnLine","Show CodeLens Commands For Current Line"),alias:"Show CodeLens Commands For Current Line"})}async run(e,s){if(!s.hasModel())return;const o=e.get(u.IQuickInputService),t=e.get(h.ICommandService),i=e.get(_.INotificationService),n=s.getSelection().positionLineNumber,r=s.getContribution(exports.CodeLensContribution.ID);if(!r)return;const d=await r.getModel();if(!d)return;const l=[];for(const e of d.lenses)e.symbol.command&&e.symbol.range.startLineNumber===n&&l.push({label:e.symbol.command.title,command:e.symbol.command});if(0===l.length)return;const a=await o.pick(l,{canPickMany:!1,placeHolder:c.localize("placeHolder","Select a command")});if(!a)return;let m=a.command;if(d.isDisposed){const e=await r.getModel(),s=e?.lenses.find((e=>e.symbol.range.startLineNumber===n&&e.symbol.command?.title===m.title));if(!s||!s.symbol.command)return;m=s.symbol.command}try{await t.executeCommand(m.id,...m.arguments||[])}catch(e){i.error(e)}}});
//# sourceMappingURL=codelensController.js.map
