"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var e,o=require("../../../../base/common/async.js"),t=require("../../../../base/common/color.js"),r=require("../../../../base/common/errors.js"),s=require("../../../../base/common/event.js"),i=require("../../../../base/common/lifecycle.js"),n=require("../../../../base/common/stopwatch.js"),a=require("../../../../base/common/strings.js"),c=require("../../../browser/editorDom.js"),l=require("../../../browser/editorExtensions.js"),u=require("../../../common/core/range.js"),h=require("../../../common/model/textModel.js"),d=require("../../../common/services/languageFeatureDebounce.js"),m=require("../../../common/services/languageFeatures.js"),_=require("./color.js"),g=require("../../../../platform/configuration/common/configuration.js"),p=self&&self.__decorate||function(e,o,t,r){var s,i=arguments.length,n=i<3?o:null===r?r=Object.getOwnPropertyDescriptor(o,t):r;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)n=Reflect.decorate(e,o,t,r);else for(var a=e.length-1;a>=0;a--)(s=e[a])&&(n=(i<3?s(n):i>3?s(o,t,n):s(o,t))||n);return i>3&&n&&Object.defineProperty(o,t,n),n},D=self&&self.__param||function(e,o){return function(t,r){o(t,r,e)}};const C=Object.create({});exports.ColorDetector=class extends i.Disposable{static{e=this}static{this.ID="editor.contrib.colorDetector"}static{this.RECOMPUTE_TIME=1e3}constructor(o,t,r,s){super(),this._editor=o,this._configurationService=t,this._languageFeaturesService=r,this._localToDispose=this._register(new i.DisposableStore),this._decorationsIds=[],this._colorDatas=new Map,this._colorDecoratorIds=this._editor.createDecorationsCollection(),this._ruleFactory=new c.DynamicCssRules(this._editor),this._decoratorLimitReporter=new f,this._colorDecorationClassRefs=this._register(new i.DisposableStore),this._debounceInformation=s.for(r.colorProvider,"Document Colors",{min:e.RECOMPUTE_TIME}),this._register(o.onDidChangeModel((()=>{this._isColorDecoratorsEnabled=this.isEnabled(),this.updateColors()}))),this._register(o.onDidChangeModelLanguage((()=>this.updateColors()))),this._register(r.colorProvider.onDidChange((()=>this.updateColors()))),this._register(o.onDidChangeConfiguration((e=>{const o=this._isColorDecoratorsEnabled;this._isColorDecoratorsEnabled=this.isEnabled(),this._isDefaultColorDecoratorsEnabled=this._editor.getOption(148);const t=o!==this._isColorDecoratorsEnabled||e.hasChanged(21),r=e.hasChanged(148);(t||r)&&(this._isColorDecoratorsEnabled?this.updateColors():this.removeAllDecorations())}))),this._timeoutTimer=null,this._computePromise=null,this._isColorDecoratorsEnabled=this.isEnabled(),this._isDefaultColorDecoratorsEnabled=this._editor.getOption(148),this.updateColors()}isEnabled(){const e=this._editor.getModel();if(!e)return!1;const o=e.getLanguageId(),t=this._configurationService.getValue(o);if(t&&"object"==typeof t){const e=t.colorDecorators;if(e&&void 0!==e.enable&&!e.enable)return e.enable}return this._editor.getOption(20)}static get(e){return e.getContribution(this.ID)}dispose(){this.stop(),this.removeAllDecorations(),super.dispose()}updateColors(){if(this.stop(),!this._isColorDecoratorsEnabled)return;const e=this._editor.getModel();e&&this._languageFeaturesService.colorProvider.has(e)&&(this._localToDispose.add(this._editor.onDidChangeModelContent((()=>{this._timeoutTimer||(this._timeoutTimer=new o.TimeoutTimer,this._timeoutTimer.cancelAndSet((()=>{this._timeoutTimer=null,this.beginCompute()}),this._debounceInformation.get(e)))}))),this.beginCompute())}async beginCompute(){this._computePromise=o.createCancelablePromise((async e=>{const o=this._editor.getModel();if(!o)return[];const t=new n.StopWatch(!1),r=await _.getColors(this._languageFeaturesService.colorProvider,o,e,this._isDefaultColorDecoratorsEnabled);return this._debounceInformation.update(o,t.elapsed()),r}));try{const e=await this._computePromise;this.updateDecorations(e),this.updateColorDecorators(e),this._computePromise=null}catch(e){r.onUnexpectedError(e)}}stop(){this._timeoutTimer&&(this._timeoutTimer.cancel(),this._timeoutTimer=null),this._computePromise&&(this._computePromise.cancel(),this._computePromise=null),this._localToDispose.clear()}updateDecorations(e){const o=e.map((e=>({range:{startLineNumber:e.colorInfo.range.startLineNumber,startColumn:e.colorInfo.range.startColumn,endLineNumber:e.colorInfo.range.endLineNumber,endColumn:e.colorInfo.range.endColumn},options:h.ModelDecorationOptions.EMPTY})));this._editor.changeDecorations((t=>{this._decorationsIds=t.deltaDecorations(this._decorationsIds,o),this._colorDatas=new Map,this._decorationsIds.forEach(((o,t)=>this._colorDatas.set(o,e[t])))}))}updateColorDecorators(e){this._colorDecorationClassRefs.clear();const o=[],r=this._editor.getOption(21);for(let s=0;s<e.length&&o.length<r;s++){const{red:r,green:i,blue:n,alpha:c}=e[s].colorInfo.color,l=new t.RGBA(Math.round(255*r),Math.round(255*i),Math.round(255*n),c),u=`rgba(${l.r}, ${l.g}, ${l.b}, ${l.a})`,h=this._colorDecorationClassRefs.add(this._ruleFactory.createClassNameRef({backgroundColor:u}));o.push({range:{startLineNumber:e[s].colorInfo.range.startLineNumber,startColumn:e[s].colorInfo.range.startColumn,endLineNumber:e[s].colorInfo.range.endLineNumber,endColumn:e[s].colorInfo.range.endColumn},options:{description:"colorDetector",before:{content:a.noBreakWhitespace,inlineClassName:`${h.className} colorpicker-color-decoration`,inlineClassNameAffectsLetterSpacing:!0,attachedData:C}}})}const s=r<e.length&&r;this._decoratorLimitReporter.update(e.length,s),this._colorDecoratorIds.set(o)}removeAllDecorations(){this._editor.removeDecorations(this._decorationsIds),this._decorationsIds=[],this._colorDecoratorIds.clear(),this._colorDecorationClassRefs.clear()}getColorData(e){const o=this._editor.getModel();if(!o)return null;const t=o.getDecorationsInRange(u.Range.fromPositions(e,e)).filter((e=>this._colorDatas.has(e.id)));return 0===t.length?null:this._colorDatas.get(t[0].id)}isColorDecoration(e){return this._colorDecoratorIds.has(e)}},exports.ColorDetector=e=p([D(1,g.IConfigurationService),D(2,m.ILanguageFeaturesService),D(3,d.ILanguageFeatureDebounceService)],exports.ColorDetector);class f{constructor(){this._onDidChange=new s.Emitter,this._computed=0,this._limited=!1}update(e,o){e===this._computed&&o===this._limited||(this._computed=e,this._limited=o,this._onDidChange.fire())}}l.registerEditorContribution(exports.ColorDetector.ID,exports.ColorDetector,1),exports.ColorDecorationInjectedTextMarker=C,exports.DecoratorLimitReporter=f;
//# sourceMappingURL=colorDetector.js.map
