"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var e,t=require("../../../../base/browser/dom.js"),o=require("../../../../base/browser/ui/actionbar/actionViewItems.js"),i=require("../../../../base/common/actions.js"),n=require("../../../../base/common/lifecycle.js"),r=require("../../../../base/common/platform.js"),s=require("../../../browser/editorExtensions.js"),c=require("../../../common/editorContextKeys.js"),a=require("../../../../nls.js"),l=require("../../../../platform/actions/common/actions.js"),u=require("../../../../platform/contextkey/common/contextkey.js"),d=require("../../../../platform/contextview/browser/contextView.js"),h=require("../../../../platform/keybinding/common/keybinding.js"),p=require("../../../../platform/configuration/common/configuration.js"),g=require("../../../../platform/workspace/common/workspace.js"),m=self&&self.__decorate||function(e,t,o,i){var n,r=arguments.length,s=r<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,o):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)s=Reflect.decorate(e,t,o,i);else for(var c=e.length-1;c>=0;c--)(n=e[c])&&(s=(r<3?n(s):r>3?n(t,o,s):n(t,o))||s);return r>3&&s&&Object.defineProperty(t,o,s),s},_=self&&self.__param||function(e,t){return function(o,i){t(o,i,e)}};exports.ContextMenuController=class{static{e=this}static{this.ID="editor.contrib.contextmenu"}static get(t){return t.getContribution(e.ID)}constructor(e,o,i,r,s,c,a,l){this._contextMenuService=o,this._contextViewService=i,this._contextKeyService=r,this._keybindingService=s,this._menuService=c,this._configurationService=a,this._workspaceContextService=l,this._toDispose=new n.DisposableStore,this._contextMenuIsBeingShownCount=0,this._editor=e,this._toDispose.add(this._editor.onContextMenu((e=>this._onContextMenu(e)))),this._toDispose.add(this._editor.onMouseWheel((e=>{if(this._contextMenuIsBeingShownCount>0){const o=this._contextViewService.getContextViewElement(),i=e.srcElement;i.shadowRoot&&t.getShadowRoot(o)===i.shadowRoot||this._contextViewService.hideContextView()}}))),this._toDispose.add(this._editor.onKeyDown((e=>{this._editor.getOption(24)&&58===e.keyCode&&(e.preventDefault(),e.stopPropagation(),this.showContextMenu())})))}_onContextMenu(e){if(!this._editor.hasModel())return;if(!this._editor.getOption(24))return this._editor.focus(),void(e.target.position&&!this._editor.getSelection().containsPosition(e.target.position)&&this._editor.setPosition(e.target.position));if(12===e.target.type)return;if(6===e.target.type&&e.target.detail.injectedText)return;if(e.event.preventDefault(),e.event.stopPropagation(),11===e.target.type)return this._showScrollbarContextMenu(e.event);if(6!==e.target.type&&7!==e.target.type&&1!==e.target.type)return;if(this._editor.focus(),e.target.position){let t=!1;for(const o of this._editor.getSelections())if(o.containsPosition(e.target.position)){t=!0;break}t||this._editor.setPosition(e.target.position)}let t=null;1!==e.target.type&&(t=e.event),this.showContextMenu(t)}showContextMenu(e){if(!this._editor.getOption(24))return;if(!this._editor.hasModel())return;const t=this._getMenuActions(this._editor.getModel(),this._editor.contextMenuId);t.length>0&&this._doShowContextMenu(t,e)}_getMenuActions(e,t){const o=[],n=this._menuService.getMenuActions(t,this._contextKeyService,{arg:e.uri});for(const t of n){const[,n]=t;let r=0;for(const t of n)if(t instanceof l.SubmenuItemAction){const n=this._getMenuActions(e,t.item.submenu);n.length>0&&(o.push(new i.SubmenuAction(t.id,t.label,n)),r++)}else o.push(t),r++;r&&o.push(new i.Separator)}return o.length&&o.pop(),o}_doShowContextMenu(e,i=null){if(!this._editor.hasModel())return;const n=this._editor.getOption(60);this._editor.updateOptions({hover:{enabled:!1}});let s=i;if(!s){this._editor.revealPosition(this._editor.getPosition(),1),this._editor.render();const e=this._editor.getScrolledVisiblePosition(this._editor.getPosition()),o=t.getDomNodePagePosition(this._editor.getDomNode()),i=o.left+e.left,n=o.top+e.top+e.height;s={x:i,y:n}}const c=this._editor.getOption(128)&&!r.isIOS;this._contextMenuIsBeingShownCount++,this._contextMenuService.showContextMenu({domForShadowRoot:c?this._editor.getOverflowWidgetsDomNode()??this._editor.getDomNode():void 0,getAnchor:()=>s,getActions:()=>e,getActionViewItem:e=>{const t=this._keybindingFor(e);if(t)return new o.ActionViewItem(e,e,{label:!0,keybinding:t.getLabel(),isMenu:!0});const i=e;return"function"==typeof i.getActionViewItem?i.getActionViewItem():new o.ActionViewItem(e,e,{icon:!0,label:!0,isMenu:!0})},getKeyBinding:e=>this._keybindingFor(e),onHide:e=>{this._contextMenuIsBeingShownCount--,this._editor.updateOptions({hover:n})}})}_showScrollbarContextMenu(e){if(!this._editor.hasModel())return;if(g.isStandaloneEditorWorkspace(this._workspaceContextService.getWorkspace()))return;const t=this._editor.getOption(73);let o=0;const n=e=>({id:"menu-action-"+ ++o,label:e.label,tooltip:"",class:void 0,enabled:void 0===e.enabled||e.enabled,checked:e.checked,run:e.run}),s=(e,t,r,s,c)=>{if(!t)return n({label:e,enabled:t,run:()=>{}});const a=e=>()=>{this._configurationService.updateValue(r,e)},l=[];for(const e of c)l.push(n({label:e.label,checked:s===e.value,run:a(e.value)}));return((e,t)=>new i.SubmenuAction("menu-action-"+ ++o,e,t,void 0))(e,l)},c=[];c.push(n({label:a.localize("context.minimap.minimap","Minimap"),checked:t.enabled,run:()=>{this._configurationService.updateValue("editor.minimap.enabled",!t.enabled)}})),c.push(new i.Separator),c.push(n({label:a.localize("context.minimap.renderCharacters","Render Characters"),enabled:t.enabled,checked:t.renderCharacters,run:()=>{this._configurationService.updateValue("editor.minimap.renderCharacters",!t.renderCharacters)}})),c.push(s(a.localize("context.minimap.size","Vertical size"),t.enabled,"editor.minimap.size",t.size,[{label:a.localize("context.minimap.size.proportional","Proportional"),value:"proportional"},{label:a.localize("context.minimap.size.fill","Fill"),value:"fill"},{label:a.localize("context.minimap.size.fit","Fit"),value:"fit"}])),c.push(s(a.localize("context.minimap.slider","Slider"),t.enabled,"editor.minimap.showSlider",t.showSlider,[{label:a.localize("context.minimap.slider.mouseover","Mouse Over"),value:"mouseover"},{label:a.localize("context.minimap.slider.always","Always"),value:"always"}]));const l=this._editor.getOption(128)&&!r.isIOS;this._contextMenuIsBeingShownCount++,this._contextMenuService.showContextMenu({domForShadowRoot:l?this._editor.getDomNode():void 0,getAnchor:()=>e,getActions:()=>c,onHide:e=>{this._contextMenuIsBeingShownCount--,this._editor.focus()}})}_keybindingFor(e){return this._keybindingService.lookupKeybinding(e.id)}dispose(){this._contextMenuIsBeingShownCount>0&&this._contextViewService.hideContextView(),this._toDispose.dispose()}},exports.ContextMenuController=e=m([_(1,d.IContextMenuService),_(2,d.IContextViewService),_(3,u.IContextKeyService),_(4,h.IKeybindingService),_(5,l.IMenuService),_(6,p.IConfigurationService),_(7,g.IWorkspaceContextService)],exports.ContextMenuController);class x extends s.EditorAction{constructor(){super({id:"editor.action.showContextMenu",label:a.localize("action.showContextMenu.label","Show Editor Context Menu"),alias:"Show Editor Context Menu",precondition:void 0,kbOpts:{kbExpr:c.EditorContextKeys.textInputFocus,primary:1092,weight:100}})}run(e,t){exports.ContextMenuController.get(t)?.showContextMenu()}}s.registerEditorContribution(exports.ContextMenuController.ID,exports.ContextMenuController,2),s.registerEditorAction(x);
//# sourceMappingURL=contextmenu.js.map
