"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var e,t=require("../../../../base/browser/dom.js"),r=require("../../../../base/common/arrays.js"),i=require("../../../../base/common/async.js"),s=require("../../../../base/common/cancellation.js"),a=require("../../../../base/common/dataTransfer.js"),o=require("../../../../base/common/hierarchicalKind.js"),n=require("../../../../base/common/lifecycle.js"),c=require("../../../../base/common/mime.js"),d=require("../../../../base/common/platform.js"),l=require("../../../../base/common/uuid.js"),p=require("../../../browser/controller/textAreaInput.js"),u=require("../../../browser/dnd.js"),h=require("../../../browser/services/bulkEditService.js"),g=require("../../../common/core/range.js"),f=require("../../../common/languages.js"),m=require("../../../common/services/languageFeatures.js"),P=require("./defaultProviders.js"),y=require("./edit.js"),v=require("../../editorState/browser/editorState.js"),b=require("../../inlineProgress/browser/inlineProgress.js"),_=require("../../message/browser/messageController.js"),C=require("../../../../nls.js"),w=require("../../../../platform/clipboard/common/clipboardService.js"),S=require("../../../../platform/contextkey/common/contextkey.js"),D=require("../../../../platform/instantiation/common/instantiation.js"),E=require("../../../../platform/progress/common/progress.js"),M=require("../../../../platform/quickinput/common/quickInput.js"),q=require("./postEditWidget.js"),x=require("../../../../base/common/errors.js"),A=self&&self.__decorate||function(e,t,r,i){var s,a=arguments.length,o=a<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,r):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)o=Reflect.decorate(e,t,r,i);else for(var n=e.length-1;n>=0;n--)(s=e[n])&&(o=(a<3?s(o):a>3?s(t,r,o):s(t,r))||o);return a>3&&o&&Object.defineProperty(t,r,o),o},T=self&&self.__param||function(e,t){return function(r,i){t(r,i,e)}};const j="editor.changePasteType",k=new S.RawContextKey("pasteWidgetVisible",!1,C.localize("pasteWidgetVisible","Whether the paste widget is showing")),I="application/vnd.code.copyMetadata";exports.CopyPasteController=class extends n.Disposable{static{e=this}static{this.ID="editor.contrib.copyPasteActionController"}static get(t){return t.getContribution(e.ID)}constructor(e,r,i,s,a,o,n){super(),this._bulkEditService=i,this._clipboardService=s,this._languageFeaturesService=a,this._quickInputService=o,this._progressService=n,this._editor=e;const c=e.getContainerDomNode();this._register(t.addDisposableListener(c,"copy",(e=>this.handleCopy(e)))),this._register(t.addDisposableListener(c,"cut",(e=>this.handleCopy(e)))),this._register(t.addDisposableListener(c,"paste",(e=>this.handlePaste(e)),!0)),this._pasteProgressManager=this._register(new b.InlineProgressManager("pasteIntoEditor",e,r)),this._postPasteWidgetManager=this._register(r.createInstance(q.PostEditWidgetManager,"pasteIntoEditor",e,k,{id:j,label:C.localize("postPasteWidgetTitle","Show paste options...")}))}changePasteType(){this._postPasteWidgetManager.tryShowSelector()}pasteAs(e){this._editor.focus();try{this._pasteAsActionContext={preferred:e},t.getActiveDocument().execCommand("paste")}finally{this._pasteAsActionContext=void 0}}clearWidgets(){this._postPasteWidgetManager.clear()}isPasteAsEnabled(){return this._editor.getOption(85).enabled}async finishedPaste(){await this._currentPasteOperation}handleCopy(t){if(!this._editor.hasTextFocus())return;if(this._clipboardService.clearInternalState?.(),!t.clipboardData||!this.isPasteAsEnabled())return;const s=this._editor.getModel(),a=this._editor.getSelections();if(!s||!a?.length)return;const o=this._editor.getOption(37);let n=a;const c=1===a.length&&a[0].isEmpty();if(c){if(!o)return;n=[new g.Range(n[0].startLineNumber,1,n[0].startLineNumber,1+s.getLineLength(n[0].startLineNumber))]}const p=this._editor._getViewModel()?.getPlainTextToCopy(a,o,d.isWindows),h={multicursorText:Array.isArray(p)?p:null,pasteOnNewLine:c,mode:null},f=this._languageFeaturesService.documentPasteEditProvider.ordered(s).filter((e=>!!e.prepareDocumentPaste));if(!f.length)return void this.setCopyMetadata(t.clipboardData,{defaultPastePayload:h});const m=u.toVSDataTransfer(t.clipboardData),P=f.flatMap((e=>e.copyMimeTypes??[])),y=l.generateUuid();this.setCopyMetadata(t.clipboardData,{id:y,providerCopyMimeTypes:P,defaultPastePayload:h});const v=i.createCancelablePromise((async e=>{const t=r.coalesce(await Promise.all(f.map((async t=>{try{return await t.prepareDocumentPaste(s,n,m,e)}catch(e){return void console.error(e)}}))));t.reverse();for(const e of t)for(const[t,r]of e)m.replace(t,r);return m}));e._currentCopyOperation?.dataTransferPromise.cancel(),e._currentCopyOperation={handle:y,dataTransferPromise:v}}async handlePaste(e){if(!e.clipboardData||!this._editor.hasTextFocus())return;_.MessageController.get(this._editor)?.closeMessage(),this._currentPasteOperation?.cancel(),this._currentPasteOperation=void 0;const t=this._editor.getModel(),r=this._editor.getSelections();if(!r?.length||!t)return;if(this._editor.getOption(92)||!this.isPasteAsEnabled()&&!this._pasteAsActionContext)return;const i=this.fetchCopyMetadata(e),s=u.toExternalVSDataTransfer(e.clipboardData);s.delete(I);const o=[...e.clipboardData.types,...i?.providerCopyMimeTypes??[],c.Mimes.uriList],n=this._languageFeaturesService.documentPasteEditProvider.ordered(t).filter((e=>{const t=this._pasteAsActionContext?.preferred;return!(t&&e.providedPasteEditKinds&&!this.providerMatchesPreference(e,t))&&e.pasteMimeTypes?.some((e=>a.matchesMimeType(e,o)))}));n.length?(e.preventDefault(),e.stopImmediatePropagation(),this._pasteAsActionContext?this.showPasteAsPick(this._pasteAsActionContext.preferred,n,r,s,i):this.doPasteInline(n,r,s,i,e)):this._pasteAsActionContext?.preferred&&this.showPasteAsNoEditMessage(r,this._pasteAsActionContext.preferred)}showPasteAsNoEditMessage(e,t){_.MessageController.get(this._editor)?.showMessage(C.localize("pasteAsError","No paste edits for '{0}' found",t instanceof o.HierarchicalKind?t.value:t.providerId),e[0].getStartPosition())}doPasteInline(e,t,r,a,o){const c=this._editor;if(!c.hasModel())return;const d=new v.EditorStateCancellationTokenSource(c,3,void 0),l=i.createCancelablePromise((async c=>{const p=this._editor;if(!p.hasModel())return;const u=p.getModel(),h=new n.DisposableStore,g=h.add(new s.CancellationTokenSource(c));h.add(d.token.onCancellationRequested((()=>g.cancel())));const m=g.token;try{if(await this.mergeInDataFromCopy(r,a,m),m.isCancellationRequested)return;const s=e.filter((e=>this.isSupportedPasteProvider(e,r)));if(!s.length||1===s.length&&s[0]instanceof P.DefaultTextPasteOrDropEditProvider)return this.applyDefaultPasteHandler(r,a,m,o);const n={triggerKind:f.DocumentPasteTriggerKind.Automatic},c=await this.getPasteEdits(s,r,u,t,n,m);if(h.add(c),m.isCancellationRequested)return;if(1===c.edits.length&&c.edits[0].provider instanceof P.DefaultTextPasteOrDropEditProvider)return this.applyDefaultPasteHandler(r,a,m,o);if(c.edits.length){const e="afterPaste"===p.getOption(85).showPasteSelector;return this._postPasteWidgetManager.applyEditAndShowIfNeeded(t,{activeEditIndex:0,allEdits:c.edits},e,((e,r)=>new Promise(((s,a)=>{(async()=>{try{const o=e.provider.resolveDocumentPasteEdit?.(e,r),n=new i.DeferredPromise,c=o&&await this._pasteProgressManager.showWhile(t[0].getEndPosition(),C.localize("resolveProcess","Resolving paste edit. Click to cancel"),Promise.race([n.p,o]),{cancel:()=>(n.cancel(),a(new x.CancellationError))},0);return c&&(e.additionalEdit=c.additionalEdit),s(e)}catch(e){return a(e)}})()}))),m)}await this.applyDefaultPasteHandler(r,a,m,o)}finally{h.dispose(),this._currentPasteOperation===l&&(this._currentPasteOperation=void 0)}}));this._pasteProgressManager.showWhile(t[0].getEndPosition(),C.localize("pasteIntoEditorProgress","Running paste handlers. Click to cancel and do basic paste"),l,{cancel:async()=>{try{if(l.cancel(),d.token.isCancellationRequested)return;await this.applyDefaultPasteHandler(r,a,d.token,o)}finally{d.dispose()}}}).then((()=>{d.dispose()})),this._currentPasteOperation=l}showPasteAsPick(e,t,r,s,a){const c=i.createCancelablePromise((async i=>{const d=this._editor;if(!d.hasModel())return;const l=d.getModel(),p=new n.DisposableStore,u=p.add(new v.EditorStateCancellationTokenSource(d,3,void 0,i));try{if(await this.mergeInDataFromCopy(s,a,u.token),u.token.isCancellationRequested)return;let i=t.filter((t=>this.isSupportedPasteProvider(t,s,e)));e&&(i=i.filter((t=>this.providerMatchesPreference(t,e))));const n={triggerKind:f.DocumentPasteTriggerKind.PasteAs,only:e&&e instanceof o.HierarchicalKind?e:void 0};let c,d=p.add(await this.getPasteEdits(i,s,l,r,n,u.token));if(u.token.isCancellationRequested)return;if(e&&(d={edits:d.edits.filter((t=>e instanceof o.HierarchicalKind?e.contains(t.kind):e.providerId===t.provider.id)),dispose:d.dispose}),!d.edits.length)return void(n.only&&this.showPasteAsNoEditMessage(r,n.only));if(e)c=d.edits.at(0);else{const e=await this._quickInputService.pick(d.edits.map((e=>({label:e.title,description:e.kind?.value,edit:e}))),{placeHolder:C.localize("pasteAsPickerPlaceholder","Select Paste Action")});c=e?.edit}if(!c)return;const h=y.createCombinedWorkspaceEdit(l.uri,r,c);await this._bulkEditService.apply(h,{editor:this._editor})}finally{p.dispose(),this._currentPasteOperation===c&&(this._currentPasteOperation=void 0)}}));this._progressService.withProgress({location:10,title:C.localize("pasteAsProgress","Running paste handlers")},(()=>c))}setCopyMetadata(e,t){e.setData(I,JSON.stringify(t))}fetchCopyMetadata(e){if(!e.clipboardData)return;const t=e.clipboardData.getData(I);if(t)try{return JSON.parse(t)}catch{return}const[r,i]=p.ClipboardEventUtils.getTextData(e.clipboardData);return i?{defaultPastePayload:{mode:i.mode,multicursorText:i.multicursorText??null,pasteOnNewLine:!!i.isFromEmptySelection}}:void 0}async mergeInDataFromCopy(t,r,i){if(r?.id&&e._currentCopyOperation?.handle===r.id){const r=await e._currentCopyOperation.dataTransferPromise;if(i.isCancellationRequested)return;for(const[e,i]of r)t.replace(e,i)}if(!t.has(c.Mimes.uriList)){const e=await this._clipboardService.readResources();if(i.isCancellationRequested)return;e.length&&t.append(c.Mimes.uriList,a.createStringDataTransferItem(a.UriList.create(e)))}}async getPasteEdits(e,t,s,a,o,c){const d=new n.DisposableStore,l=await i.raceCancellation(Promise.all(e.map((async e=>{try{const r=await(e.provideDocumentPasteEdits?.(s,a,t,o,c));return r&&d.add(r),r?.edits?.map((t=>({...t,provider:e})))}catch(e){return void(x.isCancellationError(e)||console.error(e))}}))),c),p=r.coalesce(l??[]).flat().filter((e=>!o.only||o.only.contains(e.kind)));return{edits:y.sortEditsByYieldTo(p),dispose:()=>d.dispose()}}async applyDefaultPasteHandler(e,t,r,i){const s=e.get(c.Mimes.text)??e.get("text"),a=await(s?.asString())??"";if(r.isCancellationRequested)return;const o={clipboardEvent:i,text:a,pasteOnNewLine:t?.defaultPastePayload.pasteOnNewLine??!1,multicursorText:t?.defaultPastePayload.multicursorText??null,mode:null};this._editor.trigger("keyboard","paste",o)}isSupportedPasteProvider(e,t,r){return!!e.pasteMimeTypes?.some((e=>t.matches(e)))&&(!r||this.providerMatchesPreference(e,r))}providerMatchesPreference(e,t){return t instanceof o.HierarchicalKind?!e.providedPasteEditKinds||e.providedPasteEditKinds.some((e=>t.contains(e))):e.id===t.providerId}},exports.CopyPasteController=e=A([T(1,D.IInstantiationService),T(2,h.IBulkEditService),T(3,w.IClipboardService),T(4,m.ILanguageFeaturesService),T(5,M.IQuickInputService),T(6,E.IProgressService)],exports.CopyPasteController),exports.changePasteTypeCommandId=j,exports.pasteWidgetVisibleCtx=k;
//# sourceMappingURL=copyPasteController.js.map
