"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var e=require("../../../../base/browser/dom.js"),t=require("../../../../base/browser/ui/aria/aria.js"),i=require("../../../../base/browser/ui/toggle/toggle.js"),s=require("../../../../base/browser/ui/sash/sash.js"),o=require("../../../../base/browser/ui/widget.js"),n=require("../../../../base/common/async.js"),r=require("../../../../base/common/codicons.js"),a=require("../../../../base/common/errors.js"),d=require("../../../../base/common/lifecycle.js"),h=require("../../../../base/common/platform.js"),l=require("../../../../base/common/strings.js");require("./findWidget.css.js");var c=require("../../../common/core/range.js"),_=require("./findModel.js"),u=require("../../../../nls.js"),p=require("../../../../platform/history/browser/contextScopedHistoryWidget.js"),g=require("../../../../platform/history/browser/historyWidgetKeybindingHint.js"),m=require("../../../../platform/theme/common/colorUtils.js"),f=require("../../../../platform/theme/common/colors/baseColors.js");require("../../../../platform/theme/common/colors/chartsColors.js");var b=require("../../../../platform/theme/common/colors/editorColors.js"),v=require("../../../../platform/theme/common/colors/inputColors.js");require("../../../../platform/theme/common/colors/listColors.js"),require("../../../../platform/theme/common/colors/menuColors.js"),require("../../../../platform/theme/common/colors/minimapColors.js"),require("../../../../platform/theme/common/colors/miscColors.js"),require("../../../../platform/theme/common/colors/quickpickColors.js"),require("../../../../platform/theme/common/colors/searchColors.js");var I=require("../../../../platform/theme/common/iconRegistry.js"),S=require("../../../../platform/theme/common/themeService.js"),C=require("../../../../base/common/themables.js"),N=require("../../../../platform/theme/common/theme.js"),w=require("../../../../base/common/types.js"),y=require("../../../../platform/theme/browser/defaultStyles.js"),x=require("../../../../base/browser/ui/hover/hoverDelegateFactory.js");const E=I.registerIcon("find-collapsed",r.Codicon.chevronRight,u.localize("findCollapsedIcon","Icon to indicate that the editor find widget is collapsed.")),F=I.registerIcon("find-expanded",r.Codicon.chevronDown,u.localize("findExpandedIcon","Icon to indicate that the editor find widget is expanded.")),D=I.registerIcon("find-selection",r.Codicon.selection,u.localize("findSelectionIcon","Icon for 'Find in Selection' in the editor find widget.")),R=I.registerIcon("find-replace",r.Codicon.replace,u.localize("findReplaceIcon","Icon for 'Replace' in the editor find widget.")),B=I.registerIcon("find-replace-all",r.Codicon.replaceAll,u.localize("findReplaceAllIcon","Icon for 'Replace All' in the editor find widget.")),T=I.registerIcon("find-previous-match",r.Codicon.arrowUp,u.localize("findPreviousMatchIcon","Icon for 'Find Previous' in the editor find widget.")),L=I.registerIcon("find-next-match",r.Codicon.arrowDown,u.localize("findNextMatchIcon","Icon for 'Find Next' in the editor find widget.")),V=u.localize("label.findDialog","Find / Replace"),W=u.localize("label.find","Find"),q=u.localize("placeholder.find","Find"),A=u.localize("label.previousMatchButton","Previous Match"),H=u.localize("label.nextMatchButton","Next Match"),k=u.localize("label.toggleSelectionFind","Find in Selection"),M=u.localize("label.closeButton","Close"),P=u.localize("label.replace","Replace"),O=u.localize("placeholder.replace","Replace"),Z=u.localize("label.replaceButton","Replace"),z=u.localize("label.replaceAllButton","Replace All"),j=u.localize("label.toggleReplaceButton","Toggle Replace"),U=u.localize("title.matchesCountLimit","Only the first {0} results are highlighted, but all find operations work on the entire text.",_.MATCHES_LIMIT),K=u.localize("label.matchesLocation","{0} of {1}"),$=u.localize("label.noResults","No results"),X=419;let G=69;const Y="ctrlEnterReplaceAll.windows.donotask",J=h.isMacintosh?256:2048;class Q{constructor(e){this.afterLineNumber=e,this.heightInPx=33,this.suppressMouseDown=!1,this.domNode=document.createElement("div"),this.domNode.className="dock-find-viewzone"}}function ee(e,t,i){const s=!!t.match(/\n/);i&&s&&i.selectionStart>0&&e.stopPropagation()}function te(e,t,i){const s=!!t.match(/\n/);i&&s&&i.selectionEnd<i.value.length&&e.stopPropagation()}class ie extends o.Widget{static{this.ID="editor.contrib.findWidget"}constructor(t,i,s,o,r,a,h,l,c,u){super(),this._hoverService=u,this._cachedHeight=null,this._revealTimeouts=[],this._codeEditor=t,this._controller=i,this._state=s,this._contextViewProvider=o,this._keybindingService=r,this._contextKeyService=a,this._storageService=l,this._notificationService=c,this._ctrlEnterReplaceAllWarningPrompted=!!l.getBoolean(Y,0),this._isVisible=!1,this._isReplaceVisible=!1,this._ignoreChangeEvent=!1,this._updateHistoryDelayer=new n.Delayer(500),this._register(d.toDisposable((()=>this._updateHistoryDelayer.cancel()))),this._register(this._state.onFindReplaceStateChange((e=>this._onStateChanged(e)))),this._buildDomNode(),this._updateButtons(),this._tryUpdateWidgetWidth(),this._findInput.inputBox.layout(),this._register(this._codeEditor.onDidChangeConfiguration((e=>{if(e.hasChanged(92)&&(this._codeEditor.getOption(92)&&this._state.change({isReplaceRevealed:!1},!1),this._updateButtons()),e.hasChanged(146)&&this._tryUpdateWidgetWidth(),e.hasChanged(2)&&this.updateAccessibilitySupport(),e.hasChanged(41)){const e=this._codeEditor.getOption(41).loop;this._state.change({loop:e},!1);const t=this._codeEditor.getOption(41).addExtraSpaceOnTop;t&&!this._viewZone&&(this._viewZone=new Q(0),this._showViewZone()),!t&&this._viewZone&&this._removeViewZone()}}))),this.updateAccessibilitySupport(),this._register(this._codeEditor.onDidChangeCursorSelection((()=>{this._isVisible&&this._updateToggleSelectionFindButton()}))),this._register(this._codeEditor.onDidFocusEditorWidget((async()=>{if(this._isVisible){const e=await this._controller.getGlobalBufferTerm();e&&e!==this._state.searchString&&(this._state.change({searchString:e},!1),this._findInput.select())}}))),this._findInputFocused=_.CONTEXT_FIND_INPUT_FOCUSED.bindTo(a),this._findFocusTracker=this._register(e.trackFocus(this._findInput.inputBox.inputElement)),this._register(this._findFocusTracker.onDidFocus((()=>{this._findInputFocused.set(!0),this._updateSearchScope()}))),this._register(this._findFocusTracker.onDidBlur((()=>{this._findInputFocused.set(!1)}))),this._replaceInputFocused=_.CONTEXT_REPLACE_INPUT_FOCUSED.bindTo(a),this._replaceFocusTracker=this._register(e.trackFocus(this._replaceInput.inputBox.inputElement)),this._register(this._replaceFocusTracker.onDidFocus((()=>{this._replaceInputFocused.set(!0),this._updateSearchScope()}))),this._register(this._replaceFocusTracker.onDidBlur((()=>{this._replaceInputFocused.set(!1)}))),this._codeEditor.addOverlayWidget(this),this._codeEditor.getOption(41).addExtraSpaceOnTop&&(this._viewZone=new Q(0)),this._register(this._codeEditor.onDidChangeModel((()=>{this._isVisible&&(this._viewZoneId=void 0)}))),this._register(this._codeEditor.onDidScrollChange((e=>{e.scrollTopChanged?this._layoutViewZone():setTimeout((()=>{this._layoutViewZone()}),0)})))}getId(){return ie.ID}getDomNode(){return this._domNode}getPosition(){return this._isVisible?{preference:0}:null}_onStateChanged(t){if(t.searchString){try{this._ignoreChangeEvent=!0,this._findInput.setValue(this._state.searchString)}finally{this._ignoreChangeEvent=!1}this._updateButtons()}if(t.replaceString&&(this._replaceInput.inputBox.value=this._state.replaceString),t.isRevealed&&(this._state.isRevealed?this._reveal():this._hide(!0)),t.isReplaceRevealed&&(this._state.isReplaceRevealed?this._codeEditor.getOption(92)||this._isReplaceVisible||(this._isReplaceVisible=!0,this._replaceInput.width=e.getTotalWidth(this._findInput.domNode),this._updateButtons(),this._replaceInput.inputBox.layout()):this._isReplaceVisible&&(this._isReplaceVisible=!1,this._updateButtons())),(t.isRevealed||t.isReplaceRevealed)&&(this._state.isRevealed||this._state.isReplaceRevealed)&&this._tryUpdateHeight()&&this._showViewZone(),t.isRegex&&this._findInput.setRegex(this._state.isRegex),t.wholeWord&&this._findInput.setWholeWords(this._state.wholeWord),t.matchCase&&this._findInput.setCaseSensitive(this._state.matchCase),t.preserveCase&&this._replaceInput.setPreserveCase(this._state.preserveCase),t.searchScope&&(this._state.searchScope?this._toggleSelectionFind.checked=!0:this._toggleSelectionFind.checked=!1,this._updateToggleSelectionFindButton()),t.searchString||t.matchesCount||t.matchesPosition){const e=this._state.searchString.length>0&&0===this._state.matchesCount;this._domNode.classList.toggle("no-results",e),this._updateMatchesCount(),this._updateButtons()}(t.searchString||t.currentMatch)&&this._layoutViewZone(),t.updateHistory&&this._delayedUpdateHistory(),t.loop&&this._updateButtons()}_delayedUpdateHistory(){this._updateHistoryDelayer.trigger(this._updateHistory.bind(this)).then(void 0,a.onUnexpectedError)}_updateHistory(){this._state.searchString&&this._findInput.inputBox.addToHistory(),this._state.replaceString&&this._replaceInput.inputBox.addToHistory()}_updateMatchesCount(){let e;if(this._matchesCount.style.minWidth=G+"px",this._state.matchesCount>=_.MATCHES_LIMIT?this._matchesCount.title=U:this._matchesCount.title="",this._matchesCount.firstChild?.remove(),this._state.matchesCount>0){let t=String(this._state.matchesCount);this._state.matchesCount>=_.MATCHES_LIMIT&&(t+="+");let i=String(this._state.matchesPosition);"0"===i&&(i="?"),e=l.format(K,i,t)}else e=$;this._matchesCount.appendChild(document.createTextNode(e)),t.alert(this._getAriaLabel(e,this._state.currentMatch,this._state.searchString)),G=Math.max(G,this._matchesCount.clientWidth)}_getAriaLabel(e,t,i){if(e===$)return""===i?u.localize("ariaSearchNoResultEmpty","{0} found",e):u.localize("ariaSearchNoResult","{0} found for '{1}'",e,i);if(t){const s=u.localize("ariaSearchNoResultWithLineNum","{0} found for '{1}', at {2}",e,i,t.startLineNumber+":"+t.startColumn),o=this._codeEditor.getModel();if(o&&t.startLineNumber<=o.getLineCount()&&t.startLineNumber>=1){return`${o.getLineContent(t.startLineNumber)}, ${s}`}return s}return u.localize("ariaSearchNoResultWithLineNumNoCurrentMatch","{0} found for '{1}'",e,i)}_updateToggleSelectionFindButton(){const e=this._codeEditor.getSelection(),t=!!e&&(e.startLineNumber!==e.endLineNumber||e.startColumn!==e.endColumn),i=this._toggleSelectionFind.checked;this._isVisible&&(i||t)?this._toggleSelectionFind.enable():this._toggleSelectionFind.disable()}_updateButtons(){this._findInput.setEnabled(this._isVisible),this._replaceInput.setEnabled(this._isVisible&&this._isReplaceVisible),this._updateToggleSelectionFindButton(),this._closeBtn.setEnabled(this._isVisible);const e=this._state.searchString.length>0,t=!!this._state.matchesCount;this._prevBtn.setEnabled(this._isVisible&&e&&t&&this._state.canNavigateBack()),this._nextBtn.setEnabled(this._isVisible&&e&&t&&this._state.canNavigateForward()),this._replaceBtn.setEnabled(this._isVisible&&this._isReplaceVisible&&e),this._replaceAllBtn.setEnabled(this._isVisible&&this._isReplaceVisible&&e),this._domNode.classList.toggle("replaceToggled",this._isReplaceVisible),this._toggleReplaceBtn.setExpanded(this._isReplaceVisible);const i=!this._codeEditor.getOption(92);this._toggleReplaceBtn.setEnabled(this._isVisible&&i)}_reveal(){if(this._revealTimeouts.forEach((e=>{clearTimeout(e)})),this._revealTimeouts=[],!this._isVisible){this._isVisible=!0;const t=this._codeEditor.getSelection();switch(this._codeEditor.getOption(41).autoFindInSelection){case"always":this._toggleSelectionFind.checked=!0;break;case"never":this._toggleSelectionFind.checked=!1;break;case"multiline":{const e=!!t&&t.startLineNumber!==t.endLineNumber;this._toggleSelectionFind.checked=e;break}}this._tryUpdateWidgetWidth(),this._updateButtons(),this._revealTimeouts.push(setTimeout((()=>{this._domNode.classList.add("visible"),this._domNode.setAttribute("aria-hidden","false")}),0)),this._revealTimeouts.push(setTimeout((()=>{this._findInput.validate()}),200)),this._codeEditor.layoutOverlayWidget(this);let i=!0;if(this._codeEditor.getOption(41).seedSearchStringFromSelection&&t){const s=this._codeEditor.getDomNode();if(s){const o=e.getDomNodePagePosition(s),n=this._codeEditor.getScrolledVisiblePosition(t.getStartPosition()),r=o.left+(n?n.left:0),a=n?n.top:0;if(this._viewZone&&a<this._viewZone.heightInPx){t.endLineNumber>t.startLineNumber&&(i=!1);const s=e.getTopLeftOffset(this._domNode).left;r>s&&(i=!1);const n=this._codeEditor.getScrolledVisiblePosition(t.getEndPosition());o.left+(n?n.left:0)>s&&(i=!1)}}}this._showViewZone(i)}}_hide(e){this._revealTimeouts.forEach((e=>{clearTimeout(e)})),this._revealTimeouts=[],this._isVisible&&(this._isVisible=!1,this._updateButtons(),this._domNode.classList.remove("visible"),this._domNode.setAttribute("aria-hidden","true"),this._findInput.clearMessage(),e&&this._codeEditor.focus(),this._codeEditor.layoutOverlayWidget(this),this._removeViewZone())}_layoutViewZone(e){if(!this._codeEditor.getOption(41).addExtraSpaceOnTop)return void this._removeViewZone();if(!this._isVisible)return;const t=this._viewZone;void 0===this._viewZoneId&&t&&this._codeEditor.changeViewZones((i=>{t.heightInPx=this._getHeight(),this._viewZoneId=i.addZone(t),this._codeEditor.setScrollTop(e||this._codeEditor.getScrollTop()+t.heightInPx)}))}_showViewZone(e=!0){if(!this._isVisible)return;if(!this._codeEditor.getOption(41).addExtraSpaceOnTop)return;void 0===this._viewZone&&(this._viewZone=new Q(0));const t=this._viewZone;this._codeEditor.changeViewZones((i=>{if(void 0!==this._viewZoneId){const s=this._getHeight();if(s===t.heightInPx)return;const o=s-t.heightInPx;return t.heightInPx=s,i.layoutZone(this._viewZoneId),void(e&&this._codeEditor.setScrollTop(this._codeEditor.getScrollTop()+o))}{let s=this._getHeight();if(s-=this._codeEditor.getOption(84).top,s<=0)return;t.heightInPx=s,this._viewZoneId=i.addZone(t),e&&this._codeEditor.setScrollTop(this._codeEditor.getScrollTop()+s)}}))}_removeViewZone(){this._codeEditor.changeViewZones((e=>{void 0!==this._viewZoneId&&(e.removeZone(this._viewZoneId),this._viewZoneId=void 0,this._viewZone&&(this._codeEditor.setScrollTop(this._codeEditor.getScrollTop()-this._viewZone.heightInPx),this._viewZone=void 0))}))}_tryUpdateWidgetWidth(){if(!this._isVisible)return;if(!this._domNode.isConnected)return;const t=this._codeEditor.getLayoutInfo();if(t.contentWidth<=0)return void this._domNode.classList.add("hiddenEditor");this._domNode.classList.contains("hiddenEditor")&&this._domNode.classList.remove("hiddenEditor");const i=t.width,s=t.minimap.minimapWidth;let o=!1,n=!1,r=!1;if(this._resized){if(e.getTotalWidth(this._domNode)>X)return this._domNode.style.maxWidth=i-28-s-15+"px",void(this._replaceInput.width=e.getTotalWidth(this._findInput.domNode))}if(447+s>=i&&(n=!0),447+s-G>=i&&(r=!0),447+s-G>=i+50&&(o=!0),this._domNode.classList.toggle("collapsed-find-widget",o),this._domNode.classList.toggle("narrow-find-widget",r),this._domNode.classList.toggle("reduced-find-widget",n),r||o||(this._domNode.style.maxWidth=i-28-s-15+"px"),this._findInput.layout({collapsedFindWidget:o,narrowFindWidget:r,reducedFindWidget:n}),this._resized){const e=this._findInput.inputBox.element.clientWidth;e>0&&(this._replaceInput.width=e)}else this._isReplaceVisible&&(this._replaceInput.width=e.getTotalWidth(this._findInput.domNode))}_getHeight(){let e=0;return e+=4,e+=this._findInput.inputBox.height+2,this._isReplaceVisible&&(e+=4,e+=this._replaceInput.inputBox.height+2),e+=4,e}_tryUpdateHeight(){const e=this._getHeight();return(null===this._cachedHeight||this._cachedHeight!==e)&&(this._cachedHeight=e,this._domNode.style.height=`${e}px`,!0)}focusFindInput(){this._findInput.select(),this._findInput.focus()}focusReplaceInput(){this._replaceInput.select(),this._replaceInput.focus()}highlightFindOptions(){this._findInput.highlightFindOptions()}_updateSearchScope(){if(this._codeEditor.hasModel()&&this._toggleSelectionFind.checked){const e=this._codeEditor.getSelections();e.map((e=>{1===e.endColumn&&e.endLineNumber>e.startLineNumber&&(e=e.setEndPosition(e.endLineNumber-1,this._codeEditor.getModel().getLineMaxColumn(e.endLineNumber-1)));const t=this._state.currentMatch;return e.startLineNumber===e.endLineNumber||c.Range.equalsRange(e,t)?null:e})).filter((e=>!!e)),e.length&&this._state.change({searchScope:e},!0)}}_onFindInputMouseDown(e){e.middleButton&&e.stopPropagation()}_onFindInputKeyDown(e){return e.equals(3|J)?(this._keybindingService.dispatchEvent(e,e.target)||this._findInput.inputBox.insertAtCursor("\n"),void e.preventDefault()):e.equals(2)?(this._isReplaceVisible?this._replaceInput.focus():this._findInput.focusOnCaseSensitive(),void e.preventDefault()):e.equals(2066)?(this._codeEditor.focus(),void e.preventDefault()):e.equals(16)?ee(e,this._findInput.getValue(),this._findInput.domNode.querySelector("textarea")):e.equals(18)?te(e,this._findInput.getValue(),this._findInput.domNode.querySelector("textarea")):void 0}_onReplaceInputKeyDown(e){return e.equals(3|J)?(this._keybindingService.dispatchEvent(e,e.target)||(h.isWindows&&h.isNative&&!this._ctrlEnterReplaceAllWarningPrompted&&(this._notificationService.info(u.localize("ctrlEnter.keybindingChanged","Ctrl+Enter now inserts line break instead of replacing all. You can modify the keybinding for editor.action.replaceAll to override this behavior.")),this._ctrlEnterReplaceAllWarningPrompted=!0,this._storageService.store(Y,!0,0,0)),this._replaceInput.inputBox.insertAtCursor("\n")),void e.preventDefault()):e.equals(2)?(this._findInput.focusOnCaseSensitive(),void e.preventDefault()):e.equals(1026)?(this._findInput.focus(),void e.preventDefault()):e.equals(2066)?(this._codeEditor.focus(),void e.preventDefault()):e.equals(16)?ee(e,this._replaceInput.inputBox.value,this._replaceInput.inputBox.element.querySelector("textarea")):e.equals(18)?te(e,this._replaceInput.inputBox.value,this._replaceInput.inputBox.element.querySelector("textarea")):void 0}getVerticalSashLeft(e){return 0}_keybindingLabelFor(e){const t=this._keybindingService.lookupKeybinding(e);return t?` (${t.getLabel()})`:""}_buildDomNode(){const t=!0,o=!0;this._findInput=this._register(new p.ContextScopedFindInput(null,this._contextViewProvider,{width:221,label:W,placeholder:q,appendCaseSensitiveLabel:this._keybindingLabelFor(_.FIND_IDS.ToggleCaseSensitiveCommand),appendWholeWordsLabel:this._keybindingLabelFor(_.FIND_IDS.ToggleWholeWordCommand),appendRegexLabel:this._keybindingLabelFor(_.FIND_IDS.ToggleRegexCommand),validation:e=>{if(0===e.length||!this._findInput.getRegex())return null;try{return new RegExp(e,"gu"),null}catch(e){return{content:e.message}}},flexibleHeight:t,flexibleWidth:o,flexibleMaxHeight:118,showCommonFindToggles:!0,showHistoryHint:()=>g.showHistoryKeybindingHint(this._keybindingService),inputBoxStyles:y.defaultInputBoxStyles,toggleStyles:y.defaultToggleStyles},this._contextKeyService)),this._findInput.setRegex(!!this._state.isRegex),this._findInput.setCaseSensitive(!!this._state.matchCase),this._findInput.setWholeWords(!!this._state.wholeWord),this._register(this._findInput.onKeyDown((e=>this._onFindInputKeyDown(e)))),this._register(this._findInput.inputBox.onDidChange((()=>{this._ignoreChangeEvent||this._state.change({searchString:this._findInput.getValue()},!0)}))),this._register(this._findInput.onDidOptionChange((()=>{this._state.change({isRegex:this._findInput.getRegex(),wholeWord:this._findInput.getWholeWords(),matchCase:this._findInput.getCaseSensitive()},!0)}))),this._register(this._findInput.onCaseSensitiveKeyDown((e=>{e.equals(1026)&&this._isReplaceVisible&&(this._replaceInput.focus(),e.preventDefault())}))),this._register(this._findInput.onRegexKeyDown((e=>{e.equals(2)&&this._isReplaceVisible&&(this._replaceInput.focusOnPreserve(),e.preventDefault())}))),this._register(this._findInput.inputBox.onDidHeightChange((e=>{this._tryUpdateHeight()&&this._showViewZone()}))),h.isLinux&&this._register(this._findInput.onMouseDown((e=>this._onFindInputMouseDown(e)))),this._matchesCount=document.createElement("div"),this._matchesCount.className="matchesCount",this._updateMatchesCount();const n=this._register(x.createInstantHoverDelegate());this._prevBtn=this._register(new se({label:A+this._keybindingLabelFor(_.FIND_IDS.PreviousMatchFindAction),icon:T,hoverDelegate:n,onTrigger:()=>{w.assertIsDefined(this._codeEditor.getAction(_.FIND_IDS.PreviousMatchFindAction)).run().then(void 0,a.onUnexpectedError)}},this._hoverService)),this._nextBtn=this._register(new se({label:H+this._keybindingLabelFor(_.FIND_IDS.NextMatchFindAction),icon:L,hoverDelegate:n,onTrigger:()=>{w.assertIsDefined(this._codeEditor.getAction(_.FIND_IDS.NextMatchFindAction)).run().then(void 0,a.onUnexpectedError)}},this._hoverService));const r=document.createElement("div");r.className="find-part",r.appendChild(this._findInput.domNode);const d=document.createElement("div");d.className="find-actions",r.appendChild(d),d.appendChild(this._matchesCount),d.appendChild(this._prevBtn.domNode),d.appendChild(this._nextBtn.domNode),this._toggleSelectionFind=this._register(new i.Toggle({icon:D,title:k+this._keybindingLabelFor(_.FIND_IDS.ToggleSearchScopeCommand),isChecked:!1,hoverDelegate:n,inputActiveOptionBackground:m.asCssVariable(v.inputActiveOptionBackground),inputActiveOptionBorder:m.asCssVariable(v.inputActiveOptionBorder),inputActiveOptionForeground:m.asCssVariable(v.inputActiveOptionForeground)})),this._register(this._toggleSelectionFind.onChange((()=>{if(this._toggleSelectionFind.checked){if(this._codeEditor.hasModel()){let e=this._codeEditor.getSelections();e=e.map((e=>(1===e.endColumn&&e.endLineNumber>e.startLineNumber&&(e=e.setEndPosition(e.endLineNumber-1,this._codeEditor.getModel().getLineMaxColumn(e.endLineNumber-1))),e.isEmpty()?null:e))).filter((e=>!!e)),e.length&&this._state.change({searchScope:e},!0)}}else this._state.change({searchScope:null},!0)}))),d.appendChild(this._toggleSelectionFind.domNode),this._closeBtn=this._register(new se({label:M+this._keybindingLabelFor(_.FIND_IDS.CloseFindWidgetCommand),icon:I.widgetClose,hoverDelegate:n,onTrigger:()=>{this._state.change({isRevealed:!1,searchScope:null},!1)},onKeyDown:e=>{e.equals(2)&&this._isReplaceVisible&&(this._replaceBtn.isEnabled()?this._replaceBtn.focus():this._codeEditor.focus(),e.preventDefault())}},this._hoverService)),this._replaceInput=this._register(new p.ContextScopedReplaceInput(null,void 0,{label:P,placeholder:O,appendPreserveCaseLabel:this._keybindingLabelFor(_.FIND_IDS.TogglePreserveCaseCommand),history:[],flexibleHeight:t,flexibleWidth:o,flexibleMaxHeight:118,showHistoryHint:()=>g.showHistoryKeybindingHint(this._keybindingService),inputBoxStyles:y.defaultInputBoxStyles,toggleStyles:y.defaultToggleStyles},this._contextKeyService,!0)),this._replaceInput.setPreserveCase(!!this._state.preserveCase),this._register(this._replaceInput.onKeyDown((e=>this._onReplaceInputKeyDown(e)))),this._register(this._replaceInput.inputBox.onDidChange((()=>{this._state.change({replaceString:this._replaceInput.inputBox.value},!1)}))),this._register(this._replaceInput.inputBox.onDidHeightChange((e=>{this._isReplaceVisible&&this._tryUpdateHeight()&&this._showViewZone()}))),this._register(this._replaceInput.onDidOptionChange((()=>{this._state.change({preserveCase:this._replaceInput.getPreserveCase()},!0)}))),this._register(this._replaceInput.onPreserveCaseKeyDown((e=>{e.equals(2)&&(this._prevBtn.isEnabled()?this._prevBtn.focus():this._nextBtn.isEnabled()?this._nextBtn.focus():this._toggleSelectionFind.enabled?this._toggleSelectionFind.focus():this._closeBtn.isEnabled()&&this._closeBtn.focus(),e.preventDefault())})));const l=this._register(x.createInstantHoverDelegate());this._replaceBtn=this._register(new se({label:Z+this._keybindingLabelFor(_.FIND_IDS.ReplaceOneAction),icon:R,hoverDelegate:l,onTrigger:()=>{this._controller.replace()},onKeyDown:e=>{e.equals(1026)&&(this._closeBtn.focus(),e.preventDefault())}},this._hoverService)),this._replaceAllBtn=this._register(new se({label:z+this._keybindingLabelFor(_.FIND_IDS.ReplaceAllAction),icon:B,hoverDelegate:l,onTrigger:()=>{this._controller.replaceAll()}},this._hoverService));const c=document.createElement("div");c.className="replace-part",c.appendChild(this._replaceInput.domNode);const u=document.createElement("div");u.className="replace-actions",c.appendChild(u),u.appendChild(this._replaceBtn.domNode),u.appendChild(this._replaceAllBtn.domNode),this._toggleReplaceBtn=this._register(new se({label:j,className:"codicon toggle left",onTrigger:()=>{this._state.change({isReplaceRevealed:!this._isReplaceVisible},!1),this._isReplaceVisible&&(this._replaceInput.width=e.getTotalWidth(this._findInput.domNode),this._replaceInput.inputBox.layout()),this._showViewZone()}},this._hoverService)),this._toggleReplaceBtn.setExpanded(this._isReplaceVisible),this._domNode=document.createElement("div"),this._domNode.className="editor-widget find-widget",this._domNode.setAttribute("aria-hidden","true"),this._domNode.ariaLabel=V,this._domNode.role="dialog",this._domNode.style.width="419px",this._domNode.appendChild(this._toggleReplaceBtn.domNode),this._domNode.appendChild(r),this._domNode.appendChild(this._closeBtn.domNode),this._domNode.appendChild(c),this._resizeSash=this._register(new s.Sash(this._domNode,this,{orientation:0,size:2})),this._resized=!1;let f=X;this._register(this._resizeSash.onDidStart((()=>{f=e.getTotalWidth(this._domNode)}))),this._register(this._resizeSash.onDidChange((t=>{this._resized=!0;const i=f+t.startX-t.currentX;if(i<X)return;i>(parseFloat(e.getComputedStyle(this._domNode).maxWidth)||0)||(this._domNode.style.width=`${i}px`,this._isReplaceVisible&&(this._replaceInput.width=e.getTotalWidth(this._findInput.domNode)),this._findInput.inputBox.layout(),this._tryUpdateHeight())}))),this._register(this._resizeSash.onDidReset((()=>{const t=e.getTotalWidth(this._domNode);if(t<X)return;let i=X;if(!this._resized||t===X){const e=this._codeEditor.getLayoutInfo();i=e.width-28-e.minimap.minimapWidth-15,this._resized=!0}this._domNode.style.width=`${i}px`,this._isReplaceVisible&&(this._replaceInput.width=e.getTotalWidth(this._findInput.domNode)),this._findInput.inputBox.layout()})))}updateAccessibilitySupport(){const e=this._codeEditor.getOption(2);this._findInput.setFocusInputOnOptionClick(2!==e)}}class se extends o.Widget{constructor(e,t){super(),this._opts=e;let i="button";this._opts.className&&(i=i+" "+this._opts.className),this._opts.icon&&(i=i+" "+C.ThemeIcon.asClassName(this._opts.icon)),this._domNode=document.createElement("div"),this._domNode.tabIndex=0,this._domNode.className=i,this._domNode.setAttribute("role","button"),this._domNode.setAttribute("aria-label",this._opts.label),this._register(t.setupManagedHover(e.hoverDelegate??x.getDefaultHoverDelegate("element"),this._domNode,this._opts.label)),this.onclick(this._domNode,(e=>{this._opts.onTrigger(),e.preventDefault()})),this.onkeydown(this._domNode,(e=>{if(e.equals(10)||e.equals(3))return this._opts.onTrigger(),void e.preventDefault();this._opts.onKeyDown?.(e)}))}get domNode(){return this._domNode}isEnabled(){return this._domNode.tabIndex>=0}focus(){this._domNode.focus()}setEnabled(e){this._domNode.classList.toggle("disabled",!e),this._domNode.setAttribute("aria-disabled",String(!e)),this._domNode.tabIndex=e?0:-1}setExpanded(e){this._domNode.setAttribute("aria-expanded",String(!!e)),e?(this._domNode.classList.remove(...C.ThemeIcon.asClassNameArray(E)),this._domNode.classList.add(...C.ThemeIcon.asClassNameArray(F))):(this._domNode.classList.remove(...C.ThemeIcon.asClassNameArray(F)),this._domNode.classList.add(...C.ThemeIcon.asClassNameArray(E)))}}S.registerThemingParticipant(((e,t)=>{const i=e.getColor(b.editorFindMatchHighlightBorder);i&&t.addRule(`.monaco-editor .findMatch { border: 1px ${N.isHighContrast(e.type)?"dotted":"solid"} ${i}; box-sizing: border-box; }`);const s=e.getColor(b.editorFindRangeHighlightBorder);s&&t.addRule(`.monaco-editor .findScope { border: 1px ${N.isHighContrast(e.type)?"dashed":"solid"} ${s}; }`);const o=e.getColor(f.contrastBorder);o&&t.addRule(`.monaco-editor .find-widget { border: 1px solid ${o}; }`);const n=e.getColor(b.editorFindMatchForeground);n&&t.addRule(`.monaco-editor .findMatchInline { color: ${n}; }`);const r=e.getColor(b.editorFindMatchHighlightForeground);r&&t.addRule(`.monaco-editor .currentFindMatchInline { color: ${r}; }`)})),exports.FindWidget=ie,exports.FindWidgetViewZone=Q,exports.NLS_MATCHES_LOCATION=K,exports.NLS_NO_RESULTS=$,exports.SimpleButton=se,exports.findNextMatchIcon=L,exports.findPreviousMatchIcon=T,exports.findReplaceAllIcon=B,exports.findReplaceIcon=R,exports.findSelectionIcon=D;
//# sourceMappingURL=findWidget.js.map
