"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var e=require("../../../../base/common/async.js"),t=require("../../../../base/common/cancellation.js"),o=require("../../../../base/common/errors.js"),i=require("../../../../base/common/keyCodes.js"),n=require("../../../../base/common/lifecycle.js"),s=require("../../../../base/common/strings.js"),r=require("../../../../base/common/types.js");require("./folding.css.js");var l,d=require("../../../browser/stableEditorScroll.js"),a=require("../../../browser/editorExtensions.js"),g=require("../../../common/editorContextKeys.js"),c=require("../../../common/languages.js"),u=require("../../../common/languages/languageConfigurationRegistry.js"),h=require("./foldingModel.js"),p=require("./hiddenRangeModel.js"),f=require("./indentRangeProvider.js"),m=require("../../../../nls.js"),b=require("../../../../platform/contextkey/common/contextkey.js"),C=require("./foldingDecorations.js"),v=require("./foldingRanges.js"),y=require("./syntaxRangeProvider.js"),F=require("../../../../platform/notification/common/notification.js"),R=require("../../../common/services/languageFeatureDebounce.js"),x=require("../../../../base/common/stopwatch.js"),L=require("../../../common/services/languageFeatures.js"),S=require("../../../../base/common/event.js"),M=require("../../../../platform/commands/common/commands.js"),E=require("../../../../base/common/uri.js"),k=require("../../../common/services/model.js"),w=require("../../../../platform/configuration/common/configuration.js"),A=self&&self.__decorate||function(e,t,o,i){var n,s=arguments.length,r=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,o):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,o,i);else for(var l=e.length-1;l>=0;l--)(n=e[l])&&(r=(s<3?n(r):s>3?n(t,o,r):n(t,o))||r);return s>3&&r&&Object.defineProperty(t,o,r),r},P=self&&self.__param||function(e,t){return function(o,i){t(o,i,e)}};const D=new b.RawContextKey("foldingEnabled",!1);exports.FoldingController=class extends n.Disposable{static{l=this}static{this.ID="editor.contrib.folding"}static get(e){return e.getContribution(l.ID)}static getFoldingRangeProviders(e,t){const o=e.foldingRangeProvider.ordered(t);return l._foldingRangeSelector?.(o,t)??o}constructor(e,t,o,i,s,r){super(),this.contextKeyService=t,this.languageConfigurationService=o,this.languageFeaturesService=r,this.localToDispose=this._register(new n.DisposableStore),this.editor=e,this._foldingLimitReporter=new I(e);const l=this.editor.getOptions();this._isEnabled=l.get(43),this._useFoldingProviders="indentation"!==l.get(44),this._unfoldOnClickAfterEndOfLine=l.get(48),this._restoringViewState=!1,this._currentModelHasFoldedImports=!1,this._foldingImportsByDefault=l.get(46),this.updateDebounceInfo=s.for(r.foldingRangeProvider,"Folding",{min:200}),this.foldingModel=null,this.hiddenRangeModel=null,this.rangeProvider=null,this.foldingRegionPromise=null,this.foldingModelPromise=null,this.updateScheduler=null,this.cursorChangedScheduler=null,this.mouseDownInfo=null,this.foldingDecorationProvider=new C.FoldingDecorationProvider(e),this.foldingDecorationProvider.showFoldingControls=l.get(111),this.foldingDecorationProvider.showFoldingHighlights=l.get(45),this.foldingEnabled=D.bindTo(this.contextKeyService),this.foldingEnabled.set(this._isEnabled),this._register(this.editor.onDidChangeModel((()=>this.onModelChanged()))),this._register(this.editor.onDidChangeConfiguration((e=>{if(e.hasChanged(43)&&(this._isEnabled=this.editor.getOptions().get(43),this.foldingEnabled.set(this._isEnabled),this.onModelChanged()),e.hasChanged(47)&&this.onModelChanged(),e.hasChanged(111)||e.hasChanged(45)){const e=this.editor.getOptions();this.foldingDecorationProvider.showFoldingControls=e.get(111),this.foldingDecorationProvider.showFoldingHighlights=e.get(45),this.triggerFoldingModelChanged()}e.hasChanged(44)&&(this._useFoldingProviders="indentation"!==this.editor.getOptions().get(44),this.onFoldingStrategyChanged()),e.hasChanged(48)&&(this._unfoldOnClickAfterEndOfLine=this.editor.getOptions().get(48)),e.hasChanged(46)&&(this._foldingImportsByDefault=this.editor.getOptions().get(46))}))),this.onModelChanged()}saveViewState(){const e=this.editor.getModel();if(!e||!this._isEnabled||e.isTooLargeForTokenization())return{};if(this.foldingModel){const t=this.foldingModel.getMemento(),o=this.rangeProvider?this.rangeProvider.id:void 0;return{collapsedRegions:t,lineCount:e.getLineCount(),provider:o,foldedImports:this._currentModelHasFoldedImports}}}restoreViewState(e){const t=this.editor.getModel();if(t&&this._isEnabled&&!t.isTooLargeForTokenization()&&this.hiddenRangeModel&&e&&(this._currentModelHasFoldedImports=!!e.foldedImports,e.collapsedRegions&&e.collapsedRegions.length>0&&this.foldingModel)){this._restoringViewState=!0;try{this.foldingModel.applyMemento(e.collapsedRegions)}finally{this._restoringViewState=!1}}}onModelChanged(){this.localToDispose.clear();const t=this.editor.getModel();this._isEnabled&&t&&!t.isTooLargeForTokenization()&&(this._currentModelHasFoldedImports=!1,this.foldingModel=new h.FoldingModel(t,this.foldingDecorationProvider),this.localToDispose.add(this.foldingModel),this.hiddenRangeModel=new p.HiddenRangeModel(this.foldingModel),this.localToDispose.add(this.hiddenRangeModel),this.localToDispose.add(this.hiddenRangeModel.onDidChange((e=>this.onHiddenRangesChanges(e)))),this.updateScheduler=new e.Delayer(this.updateDebounceInfo.get(t)),this.cursorChangedScheduler=new e.RunOnceScheduler((()=>this.revealCursor()),200),this.localToDispose.add(this.cursorChangedScheduler),this.localToDispose.add(this.languageFeaturesService.foldingRangeProvider.onDidChange((()=>this.onFoldingStrategyChanged()))),this.localToDispose.add(this.editor.onDidChangeModelLanguageConfiguration((()=>this.onFoldingStrategyChanged()))),this.localToDispose.add(this.editor.onDidChangeModelContent((e=>this.onDidChangeModelContent(e)))),this.localToDispose.add(this.editor.onDidChangeCursorPosition((()=>this.onCursorPositionChanged()))),this.localToDispose.add(this.editor.onMouseDown((e=>this.onEditorMouseDown(e)))),this.localToDispose.add(this.editor.onMouseUp((e=>this.onEditorMouseUp(e)))),this.localToDispose.add({dispose:()=>{this.foldingRegionPromise&&(this.foldingRegionPromise.cancel(),this.foldingRegionPromise=null),this.updateScheduler?.cancel(),this.updateScheduler=null,this.foldingModel=null,this.foldingModelPromise=null,this.hiddenRangeModel=null,this.cursorChangedScheduler=null,this.rangeProvider?.dispose(),this.rangeProvider=null}}),this.triggerFoldingModelChanged())}onFoldingStrategyChanged(){this.rangeProvider?.dispose(),this.rangeProvider=null,this.triggerFoldingModelChanged()}getRangeProvider(e){if(this.rangeProvider)return this.rangeProvider;const t=new f.IndentRangeProvider(e,this.languageConfigurationService,this._foldingLimitReporter);if(this.rangeProvider=t,this._useFoldingProviders&&this.foldingModel){const o=l.getFoldingRangeProviders(this.languageFeaturesService,e);o.length>0&&(this.rangeProvider=new y.SyntaxRangeProvider(e,o,(()=>this.triggerFoldingModelChanged()),this._foldingLimitReporter,t))}return this.rangeProvider}getFoldingModel(){return this.foldingModelPromise}onDidChangeModelContent(e){this.hiddenRangeModel?.notifyChangeModelContent(e),this.triggerFoldingModelChanged()}triggerFoldingModelChanged(){this.updateScheduler&&(this.foldingRegionPromise&&(this.foldingRegionPromise.cancel(),this.foldingRegionPromise=null),this.foldingModelPromise=this.updateScheduler.trigger((()=>{const t=this.foldingModel;if(!t)return null;const o=new x.StopWatch,i=this.getRangeProvider(t.textModel),n=this.foldingRegionPromise=e.createCancelablePromise((e=>i.compute(e)));return n.then((e=>{if(e&&n===this.foldingRegionPromise){let i;if(this._foldingImportsByDefault&&!this._currentModelHasFoldedImports){const t=e.setCollapsedAllOfType(c.FoldingRangeKind.Imports.value,!0);t&&(i=d.StableEditorScrollState.capture(this.editor),this._currentModelHasFoldedImports=t)}const n=this.editor.getSelections();t.update(e,_(n)),i?.restore(this.editor);const s=this.updateDebounceInfo.update(t.textModel,o.elapsed());this.updateScheduler&&(this.updateScheduler.defaultDelay=s)}return t}))})).then(void 0,(e=>(o.onUnexpectedError(e),null))))}onHiddenRangesChanges(e){if(this.hiddenRangeModel&&e.length&&!this._restoringViewState){const e=this.editor.getSelections();e&&this.hiddenRangeModel.adjustSelections(e)&&this.editor.setSelections(e)}this.editor.setHiddenAreas(e,this)}onCursorPositionChanged(){this.hiddenRangeModel&&this.hiddenRangeModel.hasRanges()&&this.cursorChangedScheduler.schedule()}revealCursor(){const e=this.getFoldingModel();e&&e.then((e=>{if(e){const t=this.editor.getSelections();if(t&&t.length>0){const o=[];for(const i of t){const t=i.selectionStartLineNumber;this.hiddenRangeModel&&this.hiddenRangeModel.isHidden(t)&&o.push(...e.getAllRegionsAtLine(t,(e=>e.isCollapsed&&t>e.startLineNumber)))}o.length&&(e.toggleCollapseState(o),this.reveal(t[0].getPosition()))}}})).then(void 0,o.onUnexpectedError)}onEditorMouseDown(e){if(this.mouseDownInfo=null,!this.hiddenRangeModel||!e.target||!e.target.range)return;if(!e.event.leftButton&&!e.event.middleButton)return;const t=e.target.range;let o=!1;switch(e.target.type){case 4:{const t=e.target.detail,i=e.target.element.offsetLeft;if(t.offsetX-i<4)return;o=!0;break}case 7:if(this._unfoldOnClickAfterEndOfLine&&this.hiddenRangeModel.hasRanges()){if(!e.target.detail.isAfterLines)break}return;case 6:if(this.hiddenRangeModel.hasRanges()){const e=this.editor.getModel();if(e&&t.startColumn===e.getLineMaxColumn(t.startLineNumber))break}return;default:return}this.mouseDownInfo={lineNumber:t.startLineNumber,iconClicked:o}}onEditorMouseUp(e){const t=this.foldingModel;if(!t||!this.mouseDownInfo||!e.target)return;const o=this.mouseDownInfo.lineNumber,i=this.mouseDownInfo.iconClicked,n=e.target.range;if(!n||n.startLineNumber!==o)return;if(i){if(4!==e.target.type)return}else{const e=this.editor.getModel();if(!e||n.startColumn!==e.getLineMaxColumn(o))return}const s=t.getRegionAtLine(o);if(s&&s.startLineNumber===o){const n=s.isCollapsed;if(i||n){let i=[];if(e.event.altKey){const e=e=>!e.containedBy(s)&&!s.containedBy(e),o=t.getRegionsInside(null,e);for(const e of o)e.isCollapsed&&i.push(e);0===i.length&&(i=o)}else{const o=e.event.middleButton||e.event.shiftKey;if(o)for(const e of t.getRegionsInside(s))e.isCollapsed===n&&i.push(e);!n&&o&&0!==i.length||i.push(s)}t.toggleCollapseState(i),this.reveal({lineNumber:o,column:1})}}}reveal(e){this.editor.revealPositionInCenterIfOutsideViewport(e,0)}},exports.FoldingController=l=A([P(1,b.IContextKeyService),P(2,u.ILanguageConfigurationService),P(3,F.INotificationService),P(4,R.ILanguageFeatureDebounceService),P(5,L.ILanguageFeaturesService)],exports.FoldingController);class I{constructor(e){this.editor=e,this._onDidChange=new S.Emitter,this._computed=0,this._limited=!1}get limit(){return this.editor.getOptions().get(47)}update(e,t){e===this._computed&&t===this._limited||(this._computed=e,this._limited=t,this._onDidChange.fire())}}class T extends a.EditorAction{runEditorCommand(e,t,o){const i=e.get(u.ILanguageConfigurationService),n=exports.FoldingController.get(t);if(!n)return;const s=n.getFoldingModel();return s?(this.reportTelemetry(e,t),s.then((e=>{if(e){this.invoke(n,e,t,o,i);const s=t.getSelection();s&&n.reveal(s.getStartPosition())}}))):void 0}getSelectedLines(e){const t=e.getSelections();return t?t.map((e=>e.startLineNumber)):[]}getLineNumbers(e,t){return e&&e.selectionLines?e.selectionLines.map((e=>e+1)):this.getSelectedLines(t)}run(e,t){}}function _(e){return e&&0!==e.length?{startsInside(t,o){for(const i of e){const e=i.startLineNumber;if(e>=t&&e<=o)return!0}return!1}}:{startsInside:()=>!1}}function N(e){if(!r.isUndefined(e)){if(!r.isObject(e))return!1;const t=e;if(!r.isUndefined(t.levels)&&!r.isNumber(t.levels))return!1;if(!r.isUndefined(t.direction)&&!r.isString(t.direction))return!1;if(!(r.isUndefined(t.selectionLines)||Array.isArray(t.selectionLines)&&t.selectionLines.every(r.isNumber)))return!1}return!0}class K extends T{static{this.ID_PREFIX="editor.foldLevel"}static{this.ID=e=>K.ID_PREFIX+e}getFoldingLevel(){return parseInt(this.id.substr(K.ID_PREFIX.length))}invoke(e,t,o){h.setCollapseStateAtLevel(t,this.getFoldingLevel(),!0,this.getSelectedLines(o))}}a.registerEditorContribution(exports.FoldingController.ID,exports.FoldingController,0),a.registerEditorAction(class extends T{constructor(){super({id:"editor.unfold",label:m.localize("unfoldAction.label","Unfold"),alias:"Unfold",precondition:D,kbOpts:{kbExpr:g.EditorContextKeys.editorTextFocus,primary:3166,mac:{primary:2654},weight:100},metadata:{description:"Unfold the content in the editor",args:[{name:"Unfold editor argument",description:"Property-value pairs that can be passed through this argument:\n\t\t\t\t\t\t* 'levels': Number of levels to unfold. If not set, defaults to 1.\n\t\t\t\t\t\t* 'direction': If 'up', unfold given number of levels up otherwise unfolds down.\n\t\t\t\t\t\t* 'selectionLines': Array of the start lines (0-based) of the editor selections to apply the unfold action to. If not set, the active selection(s) will be used.\n\t\t\t\t\t\t",constraint:N,schema:{type:"object",properties:{levels:{type:"number",default:1},direction:{type:"string",enum:["up","down"],default:"down"},selectionLines:{type:"array",items:{type:"number"}}}}}]}})}invoke(e,t,o,i){const n=i&&i.levels||1,s=this.getLineNumbers(i,o);i&&"up"===i.direction?h.setCollapseStateLevelsUp(t,!1,n,s):h.setCollapseStateLevelsDown(t,!1,n,s)}}),a.registerEditorAction(class extends T{constructor(){super({id:"editor.unfoldRecursively",label:m.localize("unFoldRecursivelyAction.label","Unfold Recursively"),alias:"Unfold Recursively",precondition:D,kbOpts:{kbExpr:g.EditorContextKeys.editorTextFocus,primary:i.KeyChord(2089,2142),weight:100}})}invoke(e,t,o,i){h.setCollapseStateLevelsDown(t,!1,Number.MAX_VALUE,this.getSelectedLines(o))}}),a.registerEditorAction(class extends T{constructor(){super({id:"editor.fold",label:m.localize("foldAction.label","Fold"),alias:"Fold",precondition:D,kbOpts:{kbExpr:g.EditorContextKeys.editorTextFocus,primary:3164,mac:{primary:2652},weight:100},metadata:{description:"Fold the content in the editor",args:[{name:"Fold editor argument",description:"Property-value pairs that can be passed through this argument:\n\t\t\t\t\t\t\t* 'levels': Number of levels to fold.\n\t\t\t\t\t\t\t* 'direction': If 'up', folds given number of levels up otherwise folds down.\n\t\t\t\t\t\t\t* 'selectionLines': Array of the start lines (0-based) of the editor selections to apply the fold action to. If not set, the active selection(s) will be used.\n\t\t\t\t\t\t\tIf no levels or direction is set, folds the region at the locations or if already collapsed, the first uncollapsed parent instead.\n\t\t\t\t\t\t",constraint:N,schema:{type:"object",properties:{levels:{type:"number"},direction:{type:"string",enum:["up","down"]},selectionLines:{type:"array",items:{type:"number"}}}}}]}})}invoke(e,t,o,i){const n=this.getLineNumbers(i,o),s=i&&i.levels,r=i&&i.direction;"number"!=typeof s&&"string"!=typeof r?h.setCollapseStateUp(t,!0,n):"up"===r?h.setCollapseStateLevelsUp(t,!0,s||1,n):h.setCollapseStateLevelsDown(t,!0,s||1,n)}}),a.registerEditorAction(class extends T{constructor(){super({id:"editor.foldRecursively",label:m.localize("foldRecursivelyAction.label","Fold Recursively"),alias:"Fold Recursively",precondition:D,kbOpts:{kbExpr:g.EditorContextKeys.editorTextFocus,primary:i.KeyChord(2089,2140),weight:100}})}invoke(e,t,o){const i=this.getSelectedLines(o);h.setCollapseStateLevelsDown(t,!0,Number.MAX_VALUE,i)}}),a.registerEditorAction(class extends T{constructor(){super({id:"editor.toggleFoldRecursively",label:m.localize("toggleFoldRecursivelyAction.label","Toggle Fold Recursively"),alias:"Toggle Fold Recursively",precondition:D,kbOpts:{kbExpr:g.EditorContextKeys.editorTextFocus,primary:i.KeyChord(2089,3114),weight:100}})}invoke(e,t,o){const i=this.getSelectedLines(o);h.toggleCollapseState(t,Number.MAX_VALUE,i)}}),a.registerEditorAction(class extends T{constructor(){super({id:"editor.foldAll",label:m.localize("foldAllAction.label","Fold All"),alias:"Fold All",precondition:D,kbOpts:{kbExpr:g.EditorContextKeys.editorTextFocus,primary:i.KeyChord(2089,2069),weight:100}})}invoke(e,t,o){h.setCollapseStateLevelsDown(t,!0)}}),a.registerEditorAction(class extends T{constructor(){super({id:"editor.unfoldAll",label:m.localize("unfoldAllAction.label","Unfold All"),alias:"Unfold All",precondition:D,kbOpts:{kbExpr:g.EditorContextKeys.editorTextFocus,primary:i.KeyChord(2089,2088),weight:100}})}invoke(e,t,o){h.setCollapseStateLevelsDown(t,!1)}}),a.registerEditorAction(class extends T{constructor(){super({id:"editor.foldAllBlockComments",label:m.localize("foldAllBlockComments.label","Fold All Block Comments"),alias:"Fold All Block Comments",precondition:D,kbOpts:{kbExpr:g.EditorContextKeys.editorTextFocus,primary:i.KeyChord(2089,2138),weight:100}})}invoke(e,t,o,i,n){if(t.regions.hasTypes())h.setCollapseStateForType(t,c.FoldingRangeKind.Comment.value,!0);else{const e=o.getModel();if(!e)return;const i=n.getLanguageConfiguration(e.getLanguageId()).comments;if(i&&i.blockCommentStartToken){const e=new RegExp("^\\s*"+s.escapeRegExpCharacters(i.blockCommentStartToken));h.setCollapseStateForMatchingLines(t,e,!0)}}}}),a.registerEditorAction(class extends T{constructor(){super({id:"editor.foldAllMarkerRegions",label:m.localize("foldAllMarkerRegions.label","Fold All Regions"),alias:"Fold All Regions",precondition:D,kbOpts:{kbExpr:g.EditorContextKeys.editorTextFocus,primary:i.KeyChord(2089,2077),weight:100}})}invoke(e,t,o,i,n){if(t.regions.hasTypes())h.setCollapseStateForType(t,c.FoldingRangeKind.Region.value,!0);else{const e=o.getModel();if(!e)return;const i=n.getLanguageConfiguration(e.getLanguageId()).foldingRules;if(i&&i.markers&&i.markers.start){const e=new RegExp(i.markers.start);h.setCollapseStateForMatchingLines(t,e,!0)}}}}),a.registerEditorAction(class extends T{constructor(){super({id:"editor.unfoldAllMarkerRegions",label:m.localize("unfoldAllMarkerRegions.label","Unfold All Regions"),alias:"Unfold All Regions",precondition:D,kbOpts:{kbExpr:g.EditorContextKeys.editorTextFocus,primary:i.KeyChord(2089,2078),weight:100}})}invoke(e,t,o,i,n){if(t.regions.hasTypes())h.setCollapseStateForType(t,c.FoldingRangeKind.Region.value,!1);else{const e=o.getModel();if(!e)return;const i=n.getLanguageConfiguration(e.getLanguageId()).foldingRules;if(i&&i.markers&&i.markers.start){const e=new RegExp(i.markers.start);h.setCollapseStateForMatchingLines(t,e,!1)}}}}),a.registerEditorAction(class extends T{constructor(){super({id:"editor.foldAllExcept",label:m.localize("foldAllExcept.label","Fold All Except Selected"),alias:"Fold All Except Selected",precondition:D,kbOpts:{kbExpr:g.EditorContextKeys.editorTextFocus,primary:i.KeyChord(2089,2136),weight:100}})}invoke(e,t,o){const i=this.getSelectedLines(o);h.setCollapseStateForRest(t,!0,i)}}),a.registerEditorAction(class extends T{constructor(){super({id:"editor.unfoldAllExcept",label:m.localize("unfoldAllExcept.label","Unfold All Except Selected"),alias:"Unfold All Except Selected",precondition:D,kbOpts:{kbExpr:g.EditorContextKeys.editorTextFocus,primary:i.KeyChord(2089,2134),weight:100}})}invoke(e,t,o){const i=this.getSelectedLines(o);h.setCollapseStateForRest(t,!1,i)}}),a.registerEditorAction(class extends T{constructor(){super({id:"editor.toggleFold",label:m.localize("toggleFoldAction.label","Toggle Fold"),alias:"Toggle Fold",precondition:D,kbOpts:{kbExpr:g.EditorContextKeys.editorTextFocus,primary:i.KeyChord(2089,2090),weight:100}})}invoke(e,t,o){const i=this.getSelectedLines(o);h.toggleCollapseState(t,1,i)}}),a.registerEditorAction(class extends T{constructor(){super({id:"editor.gotoParentFold",label:m.localize("gotoParentFold.label","Go to Parent Fold"),alias:"Go to Parent Fold",precondition:D,kbOpts:{kbExpr:g.EditorContextKeys.editorTextFocus,weight:100}})}invoke(e,t,o){const i=this.getSelectedLines(o);if(i.length>0){const e=h.getParentFoldLine(i[0],t);null!==e&&o.setSelection({startLineNumber:e,startColumn:1,endLineNumber:e,endColumn:1})}}}),a.registerEditorAction(class extends T{constructor(){super({id:"editor.gotoPreviousFold",label:m.localize("gotoPreviousFold.label","Go to Previous Folding Range"),alias:"Go to Previous Folding Range",precondition:D,kbOpts:{kbExpr:g.EditorContextKeys.editorTextFocus,weight:100}})}invoke(e,t,o){const i=this.getSelectedLines(o);if(i.length>0){const e=h.getPreviousFoldLine(i[0],t);null!==e&&o.setSelection({startLineNumber:e,startColumn:1,endLineNumber:e,endColumn:1})}}}),a.registerEditorAction(class extends T{constructor(){super({id:"editor.gotoNextFold",label:m.localize("gotoNextFold.label","Go to Next Folding Range"),alias:"Go to Next Folding Range",precondition:D,kbOpts:{kbExpr:g.EditorContextKeys.editorTextFocus,weight:100}})}invoke(e,t,o){const i=this.getSelectedLines(o);if(i.length>0){const e=h.getNextFoldLine(i[0],t);null!==e&&o.setSelection({startLineNumber:e,startColumn:1,endLineNumber:e,endColumn:1})}}}),a.registerEditorAction(class extends T{constructor(){super({id:"editor.createFoldingRangeFromSelection",label:m.localize("createManualFoldRange.label","Create Folding Range from Selection"),alias:"Create Folding Range from Selection",precondition:D,kbOpts:{kbExpr:g.EditorContextKeys.editorTextFocus,primary:i.KeyChord(2089,2135),weight:100}})}invoke(e,t,o){const i=[],n=o.getSelections();if(n){for(const e of n){let t=e.endLineNumber;1===e.endColumn&&--t,t>e.startLineNumber&&(i.push({startLineNumber:e.startLineNumber,endLineNumber:t,type:void 0,isCollapsed:!0,source:1}),o.setSelection({startLineNumber:e.startLineNumber,startColumn:1,endLineNumber:e.startLineNumber,endColumn:1}))}if(i.length>0){i.sort(((e,t)=>e.startLineNumber-t.startLineNumber));const e=v.FoldingRegions.sanitizeAndMerge(t.regions,i,o.getModel()?.getLineCount());t.updatePost(v.FoldingRegions.fromFoldRanges(e))}}}}),a.registerEditorAction(class extends T{constructor(){super({id:"editor.removeManualFoldingRanges",label:m.localize("removeManualFoldingRanges.label","Remove Manual Folding Ranges"),alias:"Remove Manual Folding Ranges",precondition:D,kbOpts:{kbExpr:g.EditorContextKeys.editorTextFocus,primary:i.KeyChord(2089,2137),weight:100}})}invoke(e,t,o){const i=o.getSelections();if(i){const o=[];for(const e of i){const{startLineNumber:t,endLineNumber:i}=e;o.push(i>=t?{startLineNumber:t,endLineNumber:i}:{endLineNumber:i,startLineNumber:t})}t.removeManualRanges(o),e.triggerFoldingModelChanged()}}});for(let e=1;e<=7;e++)a.registerInstantiatedEditorAction(new K({id:K.ID(e),label:m.localize("foldLevelAction.label","Fold Level {0}",e),alias:`Fold Level ${e}`,precondition:D,kbOpts:{kbExpr:g.EditorContextKeys.editorTextFocus,primary:i.KeyChord(2089,2048|21+e),weight:100}}));M.CommandsRegistry.registerCommand("_executeFoldingRangeProvider",(async function(e,...i){const[n]=i;if(!(n instanceof E.URI))throw o.illegalArgument();const s=e.get(L.ILanguageFeaturesService),r=e.get(k.IModelService).getModel(n);if(!r)throw o.illegalArgument();const l=e.get(w.IConfigurationService);if(!l.getValue("editor.folding",{resource:n}))return[];const d=e.get(u.ILanguageConfigurationService),a=l.getValue("editor.foldingStrategy",{resource:n}),g={get limit(){return l.getValue("editor.foldingMaximumRegions",{resource:n})},update:(e,t)=>{}},h=new f.IndentRangeProvider(r,d,g);let p=h;if("indentation"!==a){const e=exports.FoldingController.getFoldingRangeProviders(s,r);e.length&&(p=new y.SyntaxRangeProvider(r,e,(()=>{}),g,h))}const m=await p.compute(t.CancellationToken.None),b=[];try{if(m)for(let e=0;e<m.length;e++){const t=m.getType(e);b.push({start:m.getStartLineNumber(e),end:m.getEndLineNumber(e),kind:t?c.FoldingRangeKind.fromValue(t):void 0})}return b}finally{p.dispose()}})),exports.RangesLimitReporter=I,exports.toSelectedLines=_;
//# sourceMappingURL=folding.js.map
