"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var o=require("../../../../base/common/codicons.js"),e=require("../../../common/model/textModel.js"),i=require("../../../../nls.js"),s=require("../../../../platform/theme/common/colorUtils.js"),n=require("../../../../platform/theme/common/colors/baseColors.js");require("../../../../platform/theme/common/colors/chartsColors.js");var t=require("../../../../platform/theme/common/colors/editorColors.js");require("../../../../platform/theme/common/colors/inputColors.js"),require("../../../../platform/theme/common/colors/listColors.js"),require("../../../../platform/theme/common/colors/menuColors.js"),require("../../../../platform/theme/common/colors/minimapColors.js"),require("../../../../platform/theme/common/colors/miscColors.js"),require("../../../../platform/theme/common/colors/quickpickColors.js"),require("../../../../platform/theme/common/colors/searchColors.js");var r=require("../../../../platform/theme/common/iconRegistry.js"),l=require("../../../../platform/theme/common/themeService.js"),a=require("../../../../base/common/themables.js");const c=s.registerColor("editor.foldBackground",{light:s.transparent(t.editorSelectionBackground,.3),dark:s.transparent(t.editorSelectionBackground,.3),hcDark:null,hcLight:null},i.localize("foldBackgroundBackground","Background color behind folded ranges. The color must not be opaque so as not to hide underlying decorations."),!0);s.registerColor("editor.foldPlaceholderForeground",{light:"#808080",dark:"#808080",hcDark:null,hcLight:null},i.localize("collapsedTextColor","Color of the collapsed text after the first line of a folded range.")),s.registerColor("editorGutter.foldingControlForeground",n.iconForeground,i.localize("editorGutter.foldingControlForeground","Color of the folding control in the editor gutter."));const d=r.registerIcon("folding-expanded",o.Codicon.chevronDown,i.localize("foldingExpandedIcon","Icon for expanded ranges in the editor glyph margin.")),m=r.registerIcon("folding-collapsed",o.Codicon.chevronRight,i.localize("foldingCollapsedIcon","Icon for collapsed ranges in the editor glyph margin.")),h=r.registerIcon("folding-manual-collapsed",m,i.localize("foldingManualCollapedIcon","Icon for manually collapsed ranges in the editor glyph margin.")),g=r.registerIcon("folding-manual-expanded",d,i.localize("foldingManualExpandedIcon","Icon for manually expanded ranges in the editor glyph margin.")),D={color:l.themeColorFromId(c),position:1},C=i.localize("linesCollapsed","Click to expand the range."),p=i.localize("linesExpanded","Click to collapse the range.");class O{static{this.COLLAPSED_VISUAL_DECORATION=e.ModelDecorationOptions.register({description:"folding-collapsed-visual-decoration",stickiness:0,afterContentClassName:"inline-folded",isWholeLine:!0,linesDecorationsTooltip:C,firstLineDecorationClassName:a.ThemeIcon.asClassName(m)})}static{this.COLLAPSED_HIGHLIGHTED_VISUAL_DECORATION=e.ModelDecorationOptions.register({description:"folding-collapsed-highlighted-visual-decoration",stickiness:0,afterContentClassName:"inline-folded",className:"folded-background",minimap:D,isWholeLine:!0,linesDecorationsTooltip:C,firstLineDecorationClassName:a.ThemeIcon.asClassName(m)})}static{this.MANUALLY_COLLAPSED_VISUAL_DECORATION=e.ModelDecorationOptions.register({description:"folding-manually-collapsed-visual-decoration",stickiness:0,afterContentClassName:"inline-folded",isWholeLine:!0,linesDecorationsTooltip:C,firstLineDecorationClassName:a.ThemeIcon.asClassName(h)})}static{this.MANUALLY_COLLAPSED_HIGHLIGHTED_VISUAL_DECORATION=e.ModelDecorationOptions.register({description:"folding-manually-collapsed-highlighted-visual-decoration",stickiness:0,afterContentClassName:"inline-folded",className:"folded-background",minimap:D,isWholeLine:!0,linesDecorationsTooltip:C,firstLineDecorationClassName:a.ThemeIcon.asClassName(h)})}static{this.NO_CONTROLS_COLLAPSED_RANGE_DECORATION=e.ModelDecorationOptions.register({description:"folding-no-controls-range-decoration",stickiness:0,afterContentClassName:"inline-folded",isWholeLine:!0,linesDecorationsTooltip:C})}static{this.NO_CONTROLS_COLLAPSED_HIGHLIGHTED_RANGE_DECORATION=e.ModelDecorationOptions.register({description:"folding-no-controls-range-decoration",stickiness:0,afterContentClassName:"inline-folded",className:"folded-background",minimap:D,isWholeLine:!0,linesDecorationsTooltip:C})}static{this.EXPANDED_VISUAL_DECORATION=e.ModelDecorationOptions.register({description:"folding-expanded-visual-decoration",stickiness:1,isWholeLine:!0,firstLineDecorationClassName:"alwaysShowFoldIcons "+a.ThemeIcon.asClassName(d),linesDecorationsTooltip:p})}static{this.EXPANDED_AUTO_HIDE_VISUAL_DECORATION=e.ModelDecorationOptions.register({description:"folding-expanded-auto-hide-visual-decoration",stickiness:1,isWholeLine:!0,firstLineDecorationClassName:a.ThemeIcon.asClassName(d),linesDecorationsTooltip:p})}static{this.MANUALLY_EXPANDED_VISUAL_DECORATION=e.ModelDecorationOptions.register({description:"folding-manually-expanded-visual-decoration",stickiness:0,isWholeLine:!0,firstLineDecorationClassName:"alwaysShowFoldIcons "+a.ThemeIcon.asClassName(g),linesDecorationsTooltip:p})}static{this.MANUALLY_EXPANDED_AUTO_HIDE_VISUAL_DECORATION=e.ModelDecorationOptions.register({description:"folding-manually-expanded-auto-hide-visual-decoration",stickiness:0,isWholeLine:!0,firstLineDecorationClassName:a.ThemeIcon.asClassName(g),linesDecorationsTooltip:p})}static{this.NO_CONTROLS_EXPANDED_RANGE_DECORATION=e.ModelDecorationOptions.register({description:"folding-no-controls-range-decoration",stickiness:0,isWholeLine:!0})}static{this.HIDDEN_RANGE_DECORATION=e.ModelDecorationOptions.register({description:"folding-hidden-range-decoration",stickiness:1})}constructor(o){this.editor=o,this.showFoldingControls="mouseover",this.showFoldingHighlights=!0}getDecorationOption(o,e,i){return e?O.HIDDEN_RANGE_DECORATION:"never"===this.showFoldingControls?o?this.showFoldingHighlights?O.NO_CONTROLS_COLLAPSED_HIGHLIGHTED_RANGE_DECORATION:O.NO_CONTROLS_COLLAPSED_RANGE_DECORATION:O.NO_CONTROLS_EXPANDED_RANGE_DECORATION:o?i?this.showFoldingHighlights?O.MANUALLY_COLLAPSED_HIGHLIGHTED_VISUAL_DECORATION:O.MANUALLY_COLLAPSED_VISUAL_DECORATION:this.showFoldingHighlights?O.COLLAPSED_HIGHLIGHTED_VISUAL_DECORATION:O.COLLAPSED_VISUAL_DECORATION:"mouseover"===this.showFoldingControls?i?O.MANUALLY_EXPANDED_AUTO_HIDE_VISUAL_DECORATION:O.EXPANDED_AUTO_HIDE_VISUAL_DECORATION:i?O.MANUALLY_EXPANDED_VISUAL_DECORATION:O.EXPANDED_VISUAL_DECORATION}changeDecorations(o){return this.editor.changeDecorations(o)}removeDecorations(o){this.editor.removeDecorations(o)}}exports.FoldingDecorationProvider=O,exports.foldingCollapsedIcon=m,exports.foldingExpandedIcon=d,exports.foldingManualCollapsedIcon=h,exports.foldingManualExpandedIcon=g;
//# sourceMappingURL=foldingDecorations.js.map
