"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var e=require("../../../../base/common/arrays.js"),t=require("../../../../base/common/cancellation.js"),r=require("../../../../base/common/errors.js"),n=require("../../../../base/common/iterator.js"),o=require("../../../../base/common/linkedList.js"),i=require("../../../../base/common/types.js"),s=require("../../../../base/common/uri.js"),a=require("../../editorState/browser/editorState.js"),c=require("../../../browser/editorBrowser.js"),d=require("../../../common/core/position.js"),u=require("../../../common/core/range.js"),m=require("../../../common/core/selection.js"),g=require("../../../common/services/editorWorker.js"),l=require("../../../common/services/resolverService.js"),f=require("./formattingEdit.js"),p=require("../../../../platform/commands/common/commands.js"),v=require("../../../../platform/extensions/common/extensions.js"),E=require("../../../../platform/instantiation/common/instantiation.js"),y=require("../../../common/services/languageFeatures.js"),R=require("../../../../platform/log/common/log.js"),x=require("../../../../platform/accessibilitySignal/browser/accessibilitySignalService.js");function S(e,t,r){const n=[],o=new v.ExtensionIdentifierSet,i=e.ordered(r);for(const e of i)n.push(e),e.extensionId&&o.add(e.extensionId);const s=t.ordered(r);for(const e of s){if(e.extensionId){if(o.has(e.extensionId))continue;o.add(e.extensionId)}n.push({displayName:e.displayName,extensionId:e.extensionId,provideDocumentFormattingEdits:(t,r,n)=>e.provideDocumentRangeFormattingEdits(t,t.getFullModelRange(),r,n)})}return n}class I{static{this._selectors=new o.LinkedList}static setFormatterSelector(e){return{dispose:I._selectors.unshift(e)}}static async select(e,t,r,o){if(0===e.length)return;const i=n.Iterable.first(I._selectors);return i?await i(e,t,r,o):void 0}}async function F(t,r,n,o,i,s){const d=t.get(g.IEditorWorkerService),l=t.get(R.ILogService),p=t.get(x.IAccessibilitySignalService);let v,E;c.isCodeEditor(n)?(v=n.getModel(),E=new a.EditorStateCancellationTokenSource(n,5,void 0,i)):(v=n,E=new a.TextModelCancellationTokenSource(n,i));const y=[];let S=0;for(const t of e.asArray(o).sort(u.Range.compareRangesUsingStarts))S>0&&u.Range.areIntersectingOrTouching(y[S-1],t)?y[S-1]=u.Range.fromPositions(y[S-1].getStartPosition(),t.getEndPosition()):S=y.push(t);const I=async e=>{l.trace("[format][provideDocumentRangeFormattingEdits] (request)",r.extensionId?.value,e);const t=await r.provideDocumentRangeFormattingEdits(v,e,v.getFormattingOptions(),E.token)||[];return l.trace("[format][provideDocumentRangeFormattingEdits] (response)",r.extensionId?.value,t),t},F=(e,t)=>{if(!e.length||!t.length)return!1;const r=e.reduce(((e,t)=>u.Range.plusRange(e,t.range)),e[0].range);if(!t.some((e=>u.Range.intersectRanges(r,e.range))))return!1;for(const r of e)for(const e of t)if(u.Range.intersectRanges(r.range,e.range))return!0;return!1},w=[],C=[];try{if("function"==typeof r.provideDocumentRangesFormattingEdits){l.trace("[format][provideDocumentRangeFormattingEdits] (request)",r.extensionId?.value,y);const e=await r.provideDocumentRangesFormattingEdits(v,y,v.getFormattingOptions(),E.token)||[];l.trace("[format][provideDocumentRangeFormattingEdits] (response)",r.extensionId?.value,e),C.push(e)}else{for(const e of y){if(E.token.isCancellationRequested)return!0;C.push(await I(e))}for(let e=0;e<y.length;++e)for(let t=e+1;t<y.length;++t){if(E.token.isCancellationRequested)return!0;if(F(C[e],C[t])){const r=u.Range.plusRange(y[e],y[t]),n=await I(r);y.splice(t,1),y.splice(e,1),y.push(r),C.splice(t,1),C.splice(e,1),C.push(n),e=0,t=0}}}for(const e of C){if(E.token.isCancellationRequested)return!0;const t=await d.computeMoreMinimalEdits(v.uri,e);t&&w.push(...t)}}finally{E.dispose()}if(0===w.length)return!1;if(c.isCodeEditor(n))f.FormattingEdit.execute(n,w,!0),n.revealPositionInCenterIfOutsideViewport(n.getPosition(),1);else{const[{range:e}]=w,t=new m.Selection(e.startLineNumber,e.startColumn,e.endLineNumber,e.endColumn);v.pushEditOperations([t],w.map((e=>({text:e.text,range:u.Range.lift(e.range),forceMoveMarkers:!0}))),(e=>{for(const{range:r}of e)if(u.Range.areIntersectingOrTouching(r,t))return[new m.Selection(r.startLineNumber,r.startColumn,r.endLineNumber,r.endColumn)];return null}))}return p.playSignal(x.AccessibilitySignal.format,{userGesture:s}),!0}async function w(e,t,r,n,o,i){const s=e.get(g.IEditorWorkerService),d=e.get(x.IAccessibilitySignalService);let l,p,v;c.isCodeEditor(r)?(l=r.getModel(),p=new a.EditorStateCancellationTokenSource(r,5,void 0,o)):(l=r,p=new a.TextModelCancellationTokenSource(r,o));try{const e=await t.provideDocumentFormattingEdits(l,l.getFormattingOptions(),p.token);if(v=await s.computeMoreMinimalEdits(l.uri,e),p.token.isCancellationRequested)return!0}finally{p.dispose()}if(!v||0===v.length)return!1;if(c.isCodeEditor(r))f.FormattingEdit.execute(r,v,2!==n),2!==n&&r.revealPositionInCenterIfOutsideViewport(r.getPosition(),1);else{const[{range:e}]=v,t=new m.Selection(e.startLineNumber,e.startColumn,e.endLineNumber,e.endColumn);l.pushEditOperations([t],v.map((e=>({text:e.text,range:u.Range.lift(e.range),forceMoveMarkers:!0}))),(e=>{for(const{range:r}of e)if(u.Range.areIntersectingOrTouching(r,t))return[new m.Selection(r.startLineNumber,r.startColumn,r.endLineNumber,r.endColumn)];return null}))}return d.playSignal(x.AccessibilitySignal.format,{userGesture:i}),!0}async function C(t,n,o,i,s,a){const c=n.documentRangeFormattingEditProvider.ordered(o);for(const n of c){const c=await Promise.resolve(n.provideDocumentRangeFormattingEdits(o,i,s,a)).catch(r.onUnexpectedExternalError);if(e.isNonEmptyArray(c))return await t.computeMoreMinimalEdits(o.uri,c)}}async function h(t,n,o,i,s){const a=S(n.documentFormattingEditProvider,n.documentRangeFormattingEditProvider,o);for(const n of a){const a=await Promise.resolve(n.provideDocumentFormattingEdits(o,i,s)).catch(r.onUnexpectedExternalError);if(e.isNonEmptyArray(a))return await t.computeMoreMinimalEdits(o.uri,a)}}function M(e,t,n,o,i,s,a){const c=t.onTypeFormattingEditProvider.ordered(n);return 0===c.length||c[0].autoFormatTriggerCharacters.indexOf(i)<0?Promise.resolve(void 0):Promise.resolve(c[0].provideOnTypeFormattingEdits(n,o,i,s,a)).catch(r.onUnexpectedExternalError).then((t=>e.computeMoreMinimalEdits(n.uri,t)))}p.CommandsRegistry.registerCommand("_executeFormatRangeProvider",(async function(e,...r){const[n,o,a]=r;i.assertType(s.URI.isUri(n)),i.assertType(u.Range.isIRange(o));const c=e.get(l.ITextModelService),d=e.get(g.IEditorWorkerService),m=e.get(y.ILanguageFeaturesService),f=await c.createModelReference(n);try{return C(d,m,f.object.textEditorModel,u.Range.lift(o),a,t.CancellationToken.None)}finally{f.dispose()}})),p.CommandsRegistry.registerCommand("_executeFormatDocumentProvider",(async function(e,...r){const[n,o]=r;i.assertType(s.URI.isUri(n));const a=e.get(l.ITextModelService),c=e.get(g.IEditorWorkerService),d=e.get(y.ILanguageFeaturesService),u=await a.createModelReference(n);try{return h(c,d,u.object.textEditorModel,o,t.CancellationToken.None)}finally{u.dispose()}})),p.CommandsRegistry.registerCommand("_executeFormatOnTypeProvider",(async function(e,...r){const[n,o,a,c]=r;i.assertType(s.URI.isUri(n)),i.assertType(d.Position.isIPosition(o)),i.assertType("string"==typeof a);const u=e.get(l.ITextModelService),m=e.get(g.IEditorWorkerService),f=e.get(y.ILanguageFeaturesService),p=await u.createModelReference(n);try{return M(m,f,p.object.textEditorModel,d.Position.lift(o),a,c,t.CancellationToken.None)}finally{p.dispose()}})),exports.FormattingConflicts=I,exports.formatDocumentRangesWithProvider=F,exports.formatDocumentRangesWithSelectedProvider=async function(e,t,r,n,o,i,s){const a=e.get(E.IInstantiationService),{documentRangeFormattingEditProvider:d}=e.get(y.ILanguageFeaturesService),u=c.isCodeEditor(t)?t.getModel():t,m=d.ordered(u),g=await I.select(m,u,n,2);g&&(o.report(g),await a.invokeFunction(F,g,t,r,i,s))},exports.formatDocumentWithProvider=w,exports.formatDocumentWithSelectedProvider=async function(e,t,r,n,o,i){const s=e.get(E.IInstantiationService),a=e.get(y.ILanguageFeaturesService),d=c.isCodeEditor(t)?t.getModel():t,u=S(a.documentFormattingEditProvider,a.documentRangeFormattingEditProvider,d),m=await I.select(u,d,r,1);m&&(n.report(m),await s.invokeFunction(w,m,t,r,o,i))},exports.getDocumentFormattingEditsUntilResult=h,exports.getDocumentRangeFormattingEditsUntilResult=C,exports.getOnTypeFormattingEdits=M,exports.getRealAndSyntheticDocumentFormattersOrdered=S;
//# sourceMappingURL=format.js.map
