"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var e=require("../../../../base/common/arrays.js"),t=require("../../../../base/common/cancellation.js"),i=require("../../../../base/common/errors.js"),o=require("../../../../base/common/keyCodes.js"),r=require("../../../../base/common/lifecycle.js"),s=require("../../../browser/editorExtensions.js"),n=require("../../../browser/services/codeEditorService.js"),a=require("../../../common/core/characterClassifier.js"),c=require("../../../common/core/range.js"),d=require("../../../common/editorContextKeys.js"),l=require("../../../common/services/editorWorker.js"),u=require("../../../common/services/languageFeatures.js"),g=require("./format.js"),h=require("./formattingEdit.js"),m=require("../../../../nls.js"),p=require("../../../../platform/accessibilitySignal/browser/accessibilitySignalService.js"),_=require("../../../../platform/commands/common/commands.js"),f=require("../../../../platform/contextkey/common/contextkey.js"),S=require("../../../../platform/instantiation/common/instantiation.js"),y=require("../../../../platform/progress/common/progress.js"),b=self&&self.__decorate||function(e,t,i,o){var r,s=arguments.length,n=s<3?t:null===o?o=Object.getOwnPropertyDescriptor(t,i):o;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)n=Reflect.decorate(e,t,i,o);else for(var a=e.length-1;a>=0;a--)(r=e[a])&&(n=(s<3?r(n):s>3?r(t,i,n):r(t,i))||n);return s>3&&n&&Object.defineProperty(t,i,n),n},C=self&&self.__param||function(e,t){return function(i,o){t(i,o,e)}};exports.FormatOnType=class{static{this.ID="editor.contrib.autoFormat"}constructor(e,t,i,o){this._editor=e,this._languageFeaturesService=t,this._workerService=i,this._accessibilitySignalService=o,this._disposables=new r.DisposableStore,this._sessionDisposables=new r.DisposableStore,this._disposables.add(t.onTypeFormattingEditProvider.onDidChange(this._update,this)),this._disposables.add(e.onDidChangeModel((()=>this._update()))),this._disposables.add(e.onDidChangeModelLanguage((()=>this._update()))),this._disposables.add(e.onDidChangeConfiguration((e=>{e.hasChanged(56)&&this._update()}))),this._update()}dispose(){this._disposables.dispose(),this._sessionDisposables.dispose()}_update(){if(this._sessionDisposables.clear(),!this._editor.getOption(56))return;if(!this._editor.hasModel())return;const e=this._editor.getModel(),[t]=this._languageFeaturesService.onTypeFormattingEditProvider.ordered(e);if(!t||!t.autoFormatTriggerCharacters)return;const i=new a.CharacterSet;for(const e of t.autoFormatTriggerCharacters)i.add(e.charCodeAt(0));this._sessionDisposables.add(this._editor.onDidType((e=>{const t=e.charCodeAt(e.length-1);i.has(t)&&this._trigger(String.fromCharCode(t))})))}_trigger(i){if(!this._editor.hasModel())return;if(this._editor.getSelections().length>1||!this._editor.getSelection().isEmpty())return;const o=this._editor.getModel(),r=this._editor.getPosition(),s=new t.CancellationTokenSource,n=this._editor.onDidChangeModelContent((e=>{if(e.isFlush)return s.cancel(),void n.dispose();for(let t=0,i=e.changes.length;t<i;t++){if(e.changes[t].range.endLineNumber<=r.lineNumber)return s.cancel(),void n.dispose()}}));g.getOnTypeFormattingEdits(this._workerService,this._languageFeaturesService,o,r,i,o.getFormattingOptions(),s.token).then((t=>{s.token.isCancellationRequested||e.isNonEmptyArray(t)&&(this._accessibilitySignalService.playSignal(p.AccessibilitySignal.format,{userGesture:!1}),h.FormattingEdit.execute(this._editor,t,!0))})).finally((()=>{n.dispose()}))}},exports.FormatOnType=b([C(1,u.ILanguageFeaturesService),C(2,l.IEditorWorkerService),C(3,p.IAccessibilitySignalService)],exports.FormatOnType);let v=class{static{this.ID="editor.contrib.formatOnPaste"}constructor(e,t,i){this.editor=e,this._languageFeaturesService=t,this._instantiationService=i,this._callOnDispose=new r.DisposableStore,this._callOnModel=new r.DisposableStore,this._callOnDispose.add(e.onDidChangeConfiguration((()=>this._update()))),this._callOnDispose.add(e.onDidChangeModel((()=>this._update()))),this._callOnDispose.add(e.onDidChangeModelLanguage((()=>this._update()))),this._callOnDispose.add(t.documentRangeFormattingEditProvider.onDidChange(this._update,this))}dispose(){this._callOnDispose.dispose(),this._callOnModel.dispose()}_update(){this._callOnModel.clear(),this.editor.getOption(55)&&this.editor.hasModel()&&this._languageFeaturesService.documentRangeFormattingEditProvider.has(this.editor.getModel())&&this._callOnModel.add(this.editor.onDidPaste((({range:e})=>this._trigger(e))))}_trigger(e){this.editor.hasModel()&&(this.editor.getSelections().length>1||this._instantiationService.invokeFunction(g.formatDocumentRangesWithSelectedProvider,this.editor,e,2,y.Progress.None,t.CancellationToken.None,!1).catch(i.onUnexpectedError))}};v=b([C(1,u.ILanguageFeaturesService),C(2,S.IInstantiationService)],v);class D extends s.EditorAction{constructor(){super({id:"editor.action.formatDocument",label:m.localize("formatDocument.label","Format Document"),alias:"Format Document",precondition:f.ContextKeyExpr.and(d.EditorContextKeys.notInCompositeEditor,d.EditorContextKeys.writable,d.EditorContextKeys.hasDocumentFormattingProvider),kbOpts:{kbExpr:d.EditorContextKeys.editorTextFocus,primary:1572,linux:{primary:3111},weight:100},contextMenuOpts:{group:"1_modification",order:1.3}})}async run(e,i){if(i.hasModel()){const o=e.get(S.IInstantiationService),r=e.get(y.IEditorProgressService);await r.showWhile(o.invokeFunction(g.formatDocumentWithSelectedProvider,i,1,y.Progress.None,t.CancellationToken.None,!0),250)}}}class E extends s.EditorAction{constructor(){super({id:"editor.action.formatSelection",label:m.localize("formatSelection.label","Format Selection"),alias:"Format Selection",precondition:f.ContextKeyExpr.and(d.EditorContextKeys.writable,d.EditorContextKeys.hasDocumentSelectionFormattingProvider),kbOpts:{kbExpr:d.EditorContextKeys.editorTextFocus,primary:o.KeyChord(2089,2084),weight:100},contextMenuOpts:{when:d.EditorContextKeys.hasNonEmptySelection,group:"1_modification",order:1.31}})}async run(e,i){if(!i.hasModel())return;const o=e.get(S.IInstantiationService),r=i.getModel(),s=i.getSelections().map((e=>e.isEmpty()?new c.Range(e.startLineNumber,1,e.startLineNumber,r.getLineMaxColumn(e.startLineNumber)):e)),n=e.get(y.IEditorProgressService);await n.showWhile(o.invokeFunction(g.formatDocumentRangesWithSelectedProvider,i,s,1,y.Progress.None,t.CancellationToken.None,!0),250)}}s.registerEditorContribution(exports.FormatOnType.ID,exports.FormatOnType,2),s.registerEditorContribution(v.ID,v,2),s.registerEditorAction(D),s.registerEditorAction(E),_.CommandsRegistry.registerCommand("editor.action.format",(async e=>{const t=e.get(n.ICodeEditorService).getFocusedCodeEditor();if(!t||!t.hasModel())return;const i=e.get(_.ICommandService);t.getSelection().isEmpty()?await i.executeCommand("editor.action.formatDocument"):await i.executeCommand("editor.action.formatSelection")}));
//# sourceMappingURL=formatActions.js.map
