"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var e,t=require("../../../../base/common/codicons.js"),i=require("../../../../base/common/lifecycle.js"),o=require("../../../browser/editorExtensions.js"),r=require("../../../browser/services/codeEditorService.js"),s=require("../../../common/core/position.js"),n=require("../../../common/core/range.js"),a=require("../../../common/editorContextKeys.js"),l=require("./markerNavigationService.js"),d=require("../../../../nls.js"),c=require("../../../../platform/actions/common/actions.js"),m=require("../../../../platform/contextkey/common/contextkey.js"),h=require("../../../../platform/instantiation/common/instantiation.js"),p=require("../../../../platform/theme/common/iconRegistry.js"),u=require("./gotoErrorWidget.js"),g=self&&self.__decorate||function(e,t,i,o){var r,s=arguments.length,n=s<3?t:null===o?o=Object.getOwnPropertyDescriptor(t,i):o;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)n=Reflect.decorate(e,t,i,o);else for(var a=e.length-1;a>=0;a--)(r=e[a])&&(n=(s<3?r(n):s>3?r(t,i,n):r(t,i))||n);return s>3&&n&&Object.defineProperty(t,i,n),n},_=self&&self.__param||function(e,t){return function(i,o){t(i,o,e)}};exports.MarkerController=class{static{e=this}static{this.ID="editor.contrib.markerController"}static get(t){return t.getContribution(e.ID)}constructor(e,t,o,r,s){this._markerNavigationService=t,this._contextKeyService=o,this._editorService=r,this._instantiationService=s,this._sessionDispoables=new i.DisposableStore,this._editor=e,this._widgetVisible=x.bindTo(this._contextKeyService)}dispose(){this._cleanUp(),this._sessionDispoables.dispose()}_cleanUp(){this._widgetVisible.reset(),this._sessionDispoables.clear(),this._widget=void 0,this._model=void 0}_getOrCreateModel(e){if(this._model&&this._model.matches(e))return this._model;let t=!1;return this._model&&(t=!0,this._cleanUp()),this._model=this._markerNavigationService.getMarkerList(e),t&&this._model.move(!0,this._editor.getModel(),this._editor.getPosition()),this._widget=this._instantiationService.createInstance(u.MarkerNavigationWidget,this._editor),this._widget.onDidClose((()=>this.close()),this,this._sessionDispoables),this._widgetVisible.set(!0),this._sessionDispoables.add(this._model),this._sessionDispoables.add(this._widget),this._sessionDispoables.add(this._editor.onDidChangeCursorPosition((e=>{this._model?.selected&&n.Range.containsPosition(this._model?.selected.marker,e.position)||this._model?.resetIndex()}))),this._sessionDispoables.add(this._model.onDidChange((()=>{if(!this._widget||!this._widget.position||!this._model)return;const e=this._model.find(this._editor.getModel().uri,this._widget.position);e?this._widget.updateMarker(e.marker):this._widget.showStale()}))),this._sessionDispoables.add(this._widget.onDidSelectRelatedInformation((e=>{this._editorService.openCodeEditor({resource:e.resource,options:{pinned:!0,revealIfOpened:!0,selection:n.Range.lift(e).collapseToStart()}},this._editor),this.close(!1)}))),this._sessionDispoables.add(this._editor.onDidChangeModel((()=>this._cleanUp()))),this._model}close(e=!0){this._cleanUp(),e&&this._editor.focus()}showAtMarker(e){if(this._editor.hasModel()){const t=this._getOrCreateModel(this._editor.getModel().uri);t.resetIndex(),t.move(!0,this._editor.getModel(),new s.Position(e.startLineNumber,e.startColumn)),t.selected&&this._widget.showAtMarker(t.selected.marker,t.selected.index,t.selected.total)}}async nagivate(t,i){if(this._editor.hasModel()){const o=this._getOrCreateModel(i?void 0:this._editor.getModel().uri);if(o.move(t,this._editor.getModel(),this._editor.getPosition()),!o.selected)return;if(o.selected.marker.resource.toString()!==this._editor.getModel().uri.toString()){this._cleanUp();const r=await this._editorService.openCodeEditor({resource:o.selected.marker.resource,options:{pinned:!1,revealIfOpened:!0,selectionRevealType:2,selection:o.selected.marker}},this._editor);r&&(e.get(r)?.close(),e.get(r)?.nagivate(t,i))}else this._widget.showAtMarker(o.selected.marker,o.selected.index,o.selected.total)}}},exports.MarkerController=e=g([_(1,l.IMarkerNavigationService),_(2,m.IContextKeyService),_(3,r.ICodeEditorService),_(4,h.IInstantiationService)],exports.MarkerController);class b extends o.EditorAction{constructor(e,t,i){super(i),this._next=e,this._multiFile=t}async run(e,t){t.hasModel()&&exports.MarkerController.get(t)?.nagivate(this._next,this._multiFile)}}class v extends b{static{this.ID="editor.action.marker.next"}static{this.LABEL=d.localize("markerAction.next.label","Go to Next Problem (Error, Warning, Info)")}constructor(){super(!0,!1,{id:v.ID,label:v.LABEL,alias:"Go to Next Problem (Error, Warning, Info)",precondition:void 0,kbOpts:{kbExpr:a.EditorContextKeys.focus,primary:578,weight:100},menuOpts:{menuId:u.MarkerNavigationWidget.TitleMenu,title:v.LABEL,icon:p.registerIcon("marker-navigation-next",t.Codicon.arrowDown,d.localize("nextMarkerIcon","Icon for goto next marker.")),group:"navigation",order:1}})}}class k extends b{static{this.ID="editor.action.marker.prev"}static{this.LABEL=d.localize("markerAction.previous.label","Go to Previous Problem (Error, Warning, Info)")}constructor(){super(!1,!1,{id:k.ID,label:k.LABEL,alias:"Go to Previous Problem (Error, Warning, Info)",precondition:void 0,kbOpts:{kbExpr:a.EditorContextKeys.focus,primary:1602,weight:100},menuOpts:{menuId:u.MarkerNavigationWidget.TitleMenu,title:k.LABEL,icon:p.registerIcon("marker-navigation-previous",t.Codicon.arrowUp,d.localize("previousMarkerIcon","Icon for goto previous marker.")),group:"navigation",order:2}})}}o.registerEditorContribution(exports.MarkerController.ID,exports.MarkerController,4),o.registerEditorAction(v),o.registerEditorAction(k),o.registerEditorAction(class extends b{constructor(){super(!0,!0,{id:"editor.action.marker.nextInFiles",label:d.localize("markerAction.nextInFiles.label","Go to Next Problem in Files (Error, Warning, Info)"),alias:"Go to Next Problem in Files (Error, Warning, Info)",precondition:void 0,kbOpts:{kbExpr:a.EditorContextKeys.focus,primary:66,weight:100},menuOpts:{menuId:c.MenuId.MenubarGoMenu,title:d.localize({key:"miGotoNextProblem",comment:["&& denotes a mnemonic"]},"Next &&Problem"),group:"6_problem_nav",order:1}})}}),o.registerEditorAction(class extends b{constructor(){super(!1,!0,{id:"editor.action.marker.prevInFiles",label:d.localize("markerAction.previousInFiles.label","Go to Previous Problem in Files (Error, Warning, Info)"),alias:"Go to Previous Problem in Files (Error, Warning, Info)",precondition:void 0,kbOpts:{kbExpr:a.EditorContextKeys.focus,primary:1090,weight:100},menuOpts:{menuId:c.MenuId.MenubarGoMenu,title:d.localize({key:"miGotoPreviousProblem",comment:["&& denotes a mnemonic"]},"Previous &&Problem"),group:"6_problem_nav",order:2}})}});const x=new m.RawContextKey("markersNavigationVisible",!1),f=o.EditorCommand.bindToContribution(exports.MarkerController.get);o.registerEditorCommand(new f({id:"closeMarkersNavigation",precondition:x,handler:e=>e.close(),kbOpts:{weight:150,kbExpr:a.EditorContextKeys.focus,primary:9,secondary:[1033]}})),exports.NextMarkerAction=v;
//# sourceMappingURL=gotoError.js.map
