"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var e=require("../../../../base/browser/ui/aria/aria.js"),o=require("../../../../base/common/async.js"),t=require("../../../../base/common/keyCodes.js"),i=require("../../../../base/common/types.js"),n=require("../../../../base/common/uri.js"),r=require("../../editorState/browser/editorState.js"),s=require("../../../browser/editorBrowser.js"),a=require("../../../browser/editorExtensions.js"),d=require("../../../browser/services/codeEditorService.js"),c=require("../../../browser/widget/codeEditor/embeddedCodeEditorWidget.js"),l=require("../../../common/core/position.js"),m=require("../../../common/core/range.js"),u=require("../../../common/editorContextKeys.js"),g=require("../../../common/languages.js"),p=require("./peek/referencesController.js"),f=require("./referencesModel.js"),y=require("./symbolNavigation.js"),C=require("../../message/browser/messageController.js"),h=require("../../peekView/browser/peekView.js"),x=require("../../../../nls.js"),I=require("../../../../platform/actions/common/actions.js"),P=require("../../../../platform/commands/common/commands.js"),E=require("../../../../platform/contextkey/common/contextkey.js"),v=require("../../../../platform/instantiation/common/instantiation.js"),k=require("../../../../platform/notification/common/notification.js"),M=require("../../../../platform/progress/common/progress.js"),T=require("./goToSymbol.js"),w=require("../../../common/services/languageFeatures.js"),b=require("../../../../base/common/iterator.js"),R=require("../../../../platform/contextkey/common/contextkeys.js");I.MenuRegistry.appendMenuItem(I.MenuId.EditorContext,{submenu:I.MenuId.EditorContextPeek,title:x.localize("peek.submenu","Peek"),group:"navigation",order:100});class _{static is(e){return!(!e||"object"!=typeof e)&&(e instanceof _||!(!l.Position.isIPosition(e.position)||!e.model))}constructor(e,o){this.model=e,this.position=o}}class D extends a.EditorAction2{static{this._allSymbolNavigationCommands=new Map}static{this._activeAlternativeCommands=new Set}static all(){return D._allSymbolNavigationCommands.values()}static _patchConfig(e){const o={...e,f1:!0};if(o.menu)for(const t of b.Iterable.wrap(o.menu))t.id!==I.MenuId.EditorContext&&t.id!==I.MenuId.EditorContextPeek||(t.when=E.ContextKeyExpr.and(e.precondition,t.when));return o}constructor(e,o){super(D._patchConfig(o)),this.configuration=e,D._allSymbolNavigationCommands.set(o.id,this)}runEditorCommand(t,i,n,s){if(!i.hasModel())return Promise.resolve(void 0);const a=t.get(k.INotificationService),c=t.get(d.ICodeEditorService),l=t.get(M.IEditorProgressService),m=t.get(y.ISymbolNavigationService),u=t.get(w.ILanguageFeaturesService),g=t.get(v.IInstantiationService),p=i.getModel(),f=i.getPosition(),h=_.is(n)?n:new _(p,f),x=new r.EditorStateCancellationTokenSource(i,5),I=o.raceCancellation(this._getLocationModel(u,h.model,h.position,x.token),x.token).then((async o=>{if(!o||x.token.isCancellationRequested)return;let t;if(e.alert(o.ariaMessage),o.referenceAt(p.uri,f)){const e=this._getAlternativeCommand(i);!D._activeAlternativeCommands.has(e)&&D._allSymbolNavigationCommands.has(e)&&(t=D._allSymbolNavigationCommands.get(e))}const r=o.references.length;if(0===r){if(!this.configuration.muteMessage){const e=p.getWordAtPosition(f);C.MessageController.get(i)?.showMessage(this._getNoResultFoundMessage(e),f)}}else{if(1!==r||!t)return this._onResult(c,m,i,o,s);D._activeAlternativeCommands.add(this.desc.id),g.invokeFunction((e=>t.runEditorCommand(e,i,n,s).finally((()=>{D._activeAlternativeCommands.delete(this.desc.id)}))))}}),(e=>{a.error(e)})).finally((()=>{x.dispose()}));return l.showWhile(I,250),I}async _onResult(e,o,t,i,n){const r=this._getGoToPreference(t);if(t instanceof c.EmbeddedCodeEditorWidget||!(this.configuration.openInPeek||"peek"===r&&i.references.length>1)){const s=i.firstReference(),a=i.references.length>1&&"gotoAndPeek"===r,d=await this._openReference(t,e,s,this.configuration.openToSide,!a);a&&d?this._openInPeek(d,i,n):i.dispose(),"goto"===r&&o.put(s)}else this._openInPeek(t,i,n)}async _openReference(e,o,t,i,n){let r;if(g.isLocationLink(t)&&(r=t.targetSelectionRange),r||(r=t.range),!r)return;const s=await o.openCodeEditor({resource:t.uri,options:{selection:m.Range.collapseToStart(r),selectionRevealType:3,selectionSource:"code.jump"}},e,i);if(s){if(n){const e=s.getModel(),o=s.createDecorationsCollection([{range:r,options:{description:"symbol-navigate-action-highlight",className:"symbolHighlight"}}]);setTimeout((()=>{s.getModel()===e&&o.clear()}),350)}return s}}_openInPeek(e,t,i){const n=p.ReferencesController.get(e);n&&e.hasModel()?n.toggleWidget(i??e.getSelection(),o.createCancelablePromise((e=>Promise.resolve(t))),this.configuration.openInPeek):t.dispose()}}class A extends D{async _getLocationModel(e,o,t,i){return new f.ReferencesModel(await T.getDefinitionsAtPosition(e.definitionProvider,o,t,!1,i),x.localize("def.title","Definitions"))}_getNoResultFoundMessage(e){return e&&e.word?x.localize("noResultWord","No definition found for '{0}'",e.word):x.localize("generic.noResults","No definition found")}_getAlternativeCommand(e){return e.getOption(58).alternativeDefinitionCommand}_getGoToPreference(e){return e.getOption(58).multipleDefinitions}}I.registerAction2(class e extends A{static{this.id="editor.action.revealDefinition"}constructor(){super({openToSide:!1,openInPeek:!1,muteMessage:!1},{id:e.id,title:{...x.localize2("actions.goToDecl.label","Go to Definition"),mnemonicTitle:x.localize({key:"miGotoDefinition",comment:["&& denotes a mnemonic"]},"Go to &&Definition")},precondition:u.EditorContextKeys.hasDefinitionProvider,keybinding:[{when:u.EditorContextKeys.editorTextFocus,primary:70,weight:100},{when:E.ContextKeyExpr.and(u.EditorContextKeys.editorTextFocus,R.IsWebContext),primary:2118,weight:100}],menu:[{id:I.MenuId.EditorContext,group:"navigation",order:1.1},{id:I.MenuId.MenubarGoMenu,precondition:null,group:"4_symbol_nav",order:2}]}),P.CommandsRegistry.registerCommandAlias("editor.action.goToDeclaration",e.id)}}),I.registerAction2(class e extends A{static{this.id="editor.action.revealDefinitionAside"}constructor(){super({openToSide:!0,openInPeek:!1,muteMessage:!1},{id:e.id,title:x.localize2("actions.goToDeclToSide.label","Open Definition to the Side"),precondition:E.ContextKeyExpr.and(u.EditorContextKeys.hasDefinitionProvider,u.EditorContextKeys.isInEmbeddedEditor.toNegated()),keybinding:[{when:u.EditorContextKeys.editorTextFocus,primary:t.KeyChord(2089,70),weight:100},{when:E.ContextKeyExpr.and(u.EditorContextKeys.editorTextFocus,R.IsWebContext),primary:t.KeyChord(2089,2118),weight:100}]}),P.CommandsRegistry.registerCommandAlias("editor.action.openDeclarationToTheSide",e.id)}}),I.registerAction2(class e extends A{static{this.id="editor.action.peekDefinition"}constructor(){super({openToSide:!1,openInPeek:!0,muteMessage:!1},{id:e.id,title:x.localize2("actions.previewDecl.label","Peek Definition"),precondition:E.ContextKeyExpr.and(u.EditorContextKeys.hasDefinitionProvider,h.PeekContext.notInPeekEditor,u.EditorContextKeys.isInEmbeddedEditor.toNegated()),keybinding:{when:u.EditorContextKeys.editorTextFocus,primary:582,linux:{primary:3140},weight:100},menu:{id:I.MenuId.EditorContextPeek,group:"peek",order:2}}),P.CommandsRegistry.registerCommandAlias("editor.action.previewDeclaration",e.id)}});class S extends D{async _getLocationModel(e,o,t,i){return new f.ReferencesModel(await T.getDeclarationsAtPosition(e.declarationProvider,o,t,!1,i),x.localize("decl.title","Declarations"))}_getNoResultFoundMessage(e){return e&&e.word?x.localize("decl.noResultWord","No declaration found for '{0}'",e.word):x.localize("decl.generic.noResults","No declaration found")}_getAlternativeCommand(e){return e.getOption(58).alternativeDeclarationCommand}_getGoToPreference(e){return e.getOption(58).multipleDeclarations}}I.registerAction2(class e extends S{static{this.id="editor.action.revealDeclaration"}constructor(){super({openToSide:!1,openInPeek:!1,muteMessage:!1},{id:e.id,title:{...x.localize2("actions.goToDeclaration.label","Go to Declaration"),mnemonicTitle:x.localize({key:"miGotoDeclaration",comment:["&& denotes a mnemonic"]},"Go to &&Declaration")},precondition:E.ContextKeyExpr.and(u.EditorContextKeys.hasDeclarationProvider,u.EditorContextKeys.isInEmbeddedEditor.toNegated()),menu:[{id:I.MenuId.EditorContext,group:"navigation",order:1.3},{id:I.MenuId.MenubarGoMenu,precondition:null,group:"4_symbol_nav",order:3}]})}_getNoResultFoundMessage(e){return e&&e.word?x.localize("decl.noResultWord","No declaration found for '{0}'",e.word):x.localize("decl.generic.noResults","No declaration found")}}),I.registerAction2(class extends S{constructor(){super({openToSide:!1,openInPeek:!0,muteMessage:!1},{id:"editor.action.peekDeclaration",title:x.localize2("actions.peekDecl.label","Peek Declaration"),precondition:E.ContextKeyExpr.and(u.EditorContextKeys.hasDeclarationProvider,h.PeekContext.notInPeekEditor,u.EditorContextKeys.isInEmbeddedEditor.toNegated()),menu:{id:I.MenuId.EditorContextPeek,group:"peek",order:3}})}});class N extends D{async _getLocationModel(e,o,t,i){return new f.ReferencesModel(await T.getTypeDefinitionsAtPosition(e.typeDefinitionProvider,o,t,!1,i),x.localize("typedef.title","Type Definitions"))}_getNoResultFoundMessage(e){return e&&e.word?x.localize("goToTypeDefinition.noResultWord","No type definition found for '{0}'",e.word):x.localize("goToTypeDefinition.generic.noResults","No type definition found")}_getAlternativeCommand(e){return e.getOption(58).alternativeTypeDefinitionCommand}_getGoToPreference(e){return e.getOption(58).multipleTypeDefinitions}}I.registerAction2(class e extends N{static{this.ID="editor.action.goToTypeDefinition"}constructor(){super({openToSide:!1,openInPeek:!1,muteMessage:!1},{id:e.ID,title:{...x.localize2("actions.goToTypeDefinition.label","Go to Type Definition"),mnemonicTitle:x.localize({key:"miGotoTypeDefinition",comment:["&& denotes a mnemonic"]},"Go to &&Type Definition")},precondition:u.EditorContextKeys.hasTypeDefinitionProvider,keybinding:{when:u.EditorContextKeys.editorTextFocus,primary:0,weight:100},menu:[{id:I.MenuId.EditorContext,group:"navigation",order:1.4},{id:I.MenuId.MenubarGoMenu,precondition:null,group:"4_symbol_nav",order:3}]})}}),I.registerAction2(class e extends N{static{this.ID="editor.action.peekTypeDefinition"}constructor(){super({openToSide:!1,openInPeek:!0,muteMessage:!1},{id:e.ID,title:x.localize2("actions.peekTypeDefinition.label","Peek Type Definition"),precondition:E.ContextKeyExpr.and(u.EditorContextKeys.hasTypeDefinitionProvider,h.PeekContext.notInPeekEditor,u.EditorContextKeys.isInEmbeddedEditor.toNegated()),menu:{id:I.MenuId.EditorContextPeek,group:"peek",order:4}})}});class K extends D{async _getLocationModel(e,o,t,i){return new f.ReferencesModel(await T.getImplementationsAtPosition(e.implementationProvider,o,t,!1,i),x.localize("impl.title","Implementations"))}_getNoResultFoundMessage(e){return e&&e.word?x.localize("goToImplementation.noResultWord","No implementation found for '{0}'",e.word):x.localize("goToImplementation.generic.noResults","No implementation found")}_getAlternativeCommand(e){return e.getOption(58).alternativeImplementationCommand}_getGoToPreference(e){return e.getOption(58).multipleImplementations}}I.registerAction2(class e extends K{static{this.ID="editor.action.goToImplementation"}constructor(){super({openToSide:!1,openInPeek:!1,muteMessage:!1},{id:e.ID,title:{...x.localize2("actions.goToImplementation.label","Go to Implementations"),mnemonicTitle:x.localize({key:"miGotoImplementation",comment:["&& denotes a mnemonic"]},"Go to &&Implementations")},precondition:u.EditorContextKeys.hasImplementationProvider,keybinding:{when:u.EditorContextKeys.editorTextFocus,primary:2118,weight:100},menu:[{id:I.MenuId.EditorContext,group:"navigation",order:1.45},{id:I.MenuId.MenubarGoMenu,precondition:null,group:"4_symbol_nav",order:4}]})}}),I.registerAction2(class e extends K{static{this.ID="editor.action.peekImplementation"}constructor(){super({openToSide:!1,openInPeek:!0,muteMessage:!1},{id:e.ID,title:x.localize2("actions.peekImplementation.label","Peek Implementations"),precondition:E.ContextKeyExpr.and(u.EditorContextKeys.hasImplementationProvider,h.PeekContext.notInPeekEditor,u.EditorContextKeys.isInEmbeddedEditor.toNegated()),keybinding:{when:u.EditorContextKeys.editorTextFocus,primary:3142,weight:100},menu:{id:I.MenuId.EditorContextPeek,group:"peek",order:5}})}});class z extends D{_getNoResultFoundMessage(e){return e?x.localize("references.no","No references found for '{0}'",e.word):x.localize("references.noGeneric","No references found")}_getAlternativeCommand(e){return e.getOption(58).alternativeReferenceCommand}_getGoToPreference(e){return e.getOption(58).multipleReferences}}I.registerAction2(class extends z{constructor(){super({openToSide:!1,openInPeek:!1,muteMessage:!1},{id:"editor.action.goToReferences",title:{...x.localize2("goToReferences.label","Go to References"),mnemonicTitle:x.localize({key:"miGotoReference",comment:["&& denotes a mnemonic"]},"Go to &&References")},precondition:E.ContextKeyExpr.and(u.EditorContextKeys.hasReferenceProvider,h.PeekContext.notInPeekEditor,u.EditorContextKeys.isInEmbeddedEditor.toNegated()),keybinding:{when:u.EditorContextKeys.editorTextFocus,primary:1094,weight:100},menu:[{id:I.MenuId.EditorContext,group:"navigation",order:1.45},{id:I.MenuId.MenubarGoMenu,precondition:null,group:"4_symbol_nav",order:5}]})}async _getLocationModel(e,o,t,i){return new f.ReferencesModel(await T.getReferencesAtPosition(e.referenceProvider,o,t,!0,!1,i),x.localize("ref.title","References"))}}),I.registerAction2(class extends z{constructor(){super({openToSide:!1,openInPeek:!0,muteMessage:!1},{id:"editor.action.referenceSearch.trigger",title:x.localize2("references.action.label","Peek References"),precondition:E.ContextKeyExpr.and(u.EditorContextKeys.hasReferenceProvider,h.PeekContext.notInPeekEditor,u.EditorContextKeys.isInEmbeddedEditor.toNegated()),menu:{id:I.MenuId.EditorContextPeek,group:"peek",order:6}})}async _getLocationModel(e,o,t,i){return new f.ReferencesModel(await T.getReferencesAtPosition(e.referenceProvider,o,t,!1,!1,i),x.localize("ref.title","References"))}});class j extends D{constructor(e,o,t){super(e,{id:"editor.action.goToLocation",title:x.localize2("label.generic","Go to Any Symbol"),precondition:E.ContextKeyExpr.and(h.PeekContext.notInPeekEditor,u.EditorContextKeys.isInEmbeddedEditor.toNegated())}),this._references=o,this._gotoMultipleBehaviour=t}async _getLocationModel(e,o,t,i){return new f.ReferencesModel(this._references,x.localize("generic.title","Locations"))}_getNoResultFoundMessage(e){return e&&x.localize("generic.noResult","No results for '{0}'",e.word)||""}_getGoToPreference(e){return this._gotoMultipleBehaviour??e.getOption(58).multipleReferences}_getAlternativeCommand(){return""}}P.CommandsRegistry.registerCommand({id:"editor.action.goToLocations",metadata:{description:"Go to locations from a position in a file",args:[{name:"uri",description:"The text document in which to start",constraint:n.URI},{name:"position",description:"The position at which to start",constraint:l.Position.isIPosition},{name:"locations",description:"An array of locations.",constraint:Array},{name:"multiple",description:"Define what to do when having multiple results, either `peek`, `gotoAndPeek`, or `goto`"},{name:"noResultsMessage",description:"Human readable message that shows when locations is empty."}]},handler:async(e,o,t,r,a,c,m)=>{i.assertType(n.URI.isUri(o)),i.assertType(l.Position.isIPosition(t)),i.assertType(Array.isArray(r)),i.assertType(void 0===a||"string"==typeof a),i.assertType(void 0===m||"boolean"==typeof m);const u=e.get(d.ICodeEditorService),g=await u.openCodeEditor({resource:o},u.getFocusedCodeEditor());if(s.isCodeEditor(g))return g.setPosition(t),g.revealPositionInCenterIfOutsideViewport(t,0),g.invokeWithinContext((e=>{const o=new class extends j{_getNoResultFoundMessage(e){return c||super._getNoResultFoundMessage(e)}}({muteMessage:!Boolean(c),openInPeek:Boolean(m),openToSide:!1},r,a);e.get(v.IInstantiationService).invokeFunction(o.run.bind(o),g)}))}}),P.CommandsRegistry.registerCommand({id:"editor.action.peekLocations",metadata:{description:"Peek locations from a position in a file",args:[{name:"uri",description:"The text document in which to start",constraint:n.URI},{name:"position",description:"The position at which to start",constraint:l.Position.isIPosition},{name:"locations",description:"An array of locations.",constraint:Array},{name:"multiple",description:"Define what to do when having multiple results, either `peek`, `gotoAndPeek`, or `goto`"}]},handler:async(e,o,t,i,n)=>{e.get(P.ICommandService).executeCommand("editor.action.goToLocations",o,t,i,n,void 0,!0)}}),P.CommandsRegistry.registerCommand({id:"editor.action.findReferences",handler:(e,t,r)=>{i.assertType(n.URI.isUri(t)),i.assertType(l.Position.isIPosition(r));const a=e.get(w.ILanguageFeaturesService),c=e.get(d.ICodeEditorService);return c.openCodeEditor({resource:t},c.getFocusedCodeEditor()).then((e=>{if(!s.isCodeEditor(e)||!e.hasModel())return;const t=p.ReferencesController.get(e);if(!t)return;const i=o.createCancelablePromise((o=>T.getReferencesAtPosition(a.referenceProvider,e.getModel(),l.Position.lift(r),!1,!1,o).then((e=>new f.ReferencesModel(e,x.localize("ref.title","References")))))),n=new m.Range(r.lineNumber,r.column,r.lineNumber,r.column);return Promise.resolve(t.toggleWidget(n,i,!1))}))}}),P.CommandsRegistry.registerCommandAlias("editor.action.showReferences","editor.action.peekLocations"),exports.DefinitionAction=A,exports.SymbolNavigationAction=D,exports.SymbolNavigationAnchor=_;
//# sourceMappingURL=goToCommands.js.map
