"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var e,t=require("../../../../../base/common/async.js"),i=require("../../../../../base/common/errors.js"),o=require("../../../../../base/common/keyCodes.js"),r=require("../../../../../base/common/lifecycle.js"),s=require("../../../../browser/services/codeEditorService.js"),n=require("../../../../common/core/position.js"),d=require("../../../../common/core/range.js"),c=require("../../../peekView/browser/peekView.js"),a=require("../../../../../nls.js"),h=require("../../../../../platform/commands/common/commands.js"),g=require("../../../../../platform/configuration/common/configuration.js"),l=require("../../../../../platform/contextkey/common/contextkey.js"),f=require("../../../../../platform/instantiation/common/instantiation.js"),m=require("../../../../../platform/keybinding/common/keybindingsRegistry.js"),_=require("../../../../../platform/list/browser/listService.js"),u=require("../../../../../platform/notification/common/notification.js"),p=require("../../../../../platform/storage/common/storage.js"),y=require("../referencesModel.js"),w=require("./referencesWidget.js"),R=require("../../../../common/editorContextKeys.js"),C=require("../../../../../platform/contextkey/common/contextkeys.js"),b=self&&self.__decorate||function(e,t,i,o){var r,s=arguments.length,n=s<3?t:null===o?o=Object.getOwnPropertyDescriptor(t,i):o;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)n=Reflect.decorate(e,t,i,o);else for(var d=e.length-1;d>=0;d--)(r=e[d])&&(n=(s<3?r(n):s>3?r(t,i,n):r(t,i))||n);return s>3&&n&&Object.defineProperty(t,i,n),n},v=self&&self.__param||function(e,t){return function(i,o){t(i,o,e)}};const x=new l.RawContextKey("referenceSearchVisible",!1,a.localize("referenceSearchVisible","Whether reference peek is visible, like 'Peek References' or 'Peek Definition'"));function S(e,t){const i=c.getOuterEditor(e);if(!i)return;const o=exports.ReferencesController.get(i);o&&t(o)}exports.ReferencesController=class{static{e=this}static{this.ID="editor.contrib.referencesController"}static get(t){return t.getContribution(e.ID)}constructor(e,t,i,o,s,n,d,c){this._defaultTreeKeyboardSupport=e,this._editor=t,this._editorService=o,this._notificationService=s,this._instantiationService=n,this._storageService=d,this._configurationService=c,this._disposables=new r.DisposableStore,this._requestIdPool=0,this._ignoreModelChangeEvent=!1,this._referenceSearchVisible=x.bindTo(i)}dispose(){this._referenceSearchVisible.reset(),this._disposables.dispose(),this._widget?.dispose(),this._model?.dispose(),this._widget=void 0,this._model=void 0}toggleWidget(e,t,i){let o;if(this._widget&&(o=this._widget.position),this.closeWidget(),o&&e.containsPosition(o))return;this._peekMode=i,this._referenceSearchVisible.set(!0),this._disposables.add(this._editor.onDidChangeModelLanguage((()=>{this.closeWidget()}))),this._disposables.add(this._editor.onDidChangeModel((()=>{this._ignoreModelChangeEvent||this.closeWidget()})));const r="peekViewLayout",s=w.LayoutData.fromJSON(this._storageService.get(r,0,"{}"));this._widget=this._instantiationService.createInstance(w.ReferenceWidget,this._editor,this._defaultTreeKeyboardSupport,s),this._widget.setTitle(a.localize("labelLoading","Loading...")),this._widget.show(e),this._disposables.add(this._widget.onDidClose((()=>{t.cancel(),this._widget?(this._storageService.store(r,JSON.stringify(this._widget.layoutData),0,1),this._widget.isClosing||this.closeWidget(),this._widget=void 0):this.closeWidget()}))),this._disposables.add(this._widget.onDidSelectReference((e=>{const{element:t,kind:o}=e;if(t)switch(o){case"open":"editor"===e.source&&this._configurationService.getValue("editor.stablePeek")||this.openReference(t,!1,!1);break;case"side":this.openReference(t,!0,!1);break;case"goto":i?this._gotoReference(t,!0):this.openReference(t,!1,!0)}})));const d=++this._requestIdPool;t.then((t=>{if(d===this._requestIdPool&&this._widget)return this._model?.dispose(),this._model=t,this._widget.setModel(this._model).then((()=>{if(this._widget&&this._model&&this._editor.hasModel()){this._model.isEmpty?this._widget.setMetaTitle(""):this._widget.setMetaTitle(a.localize("metaTitle.N","{0} ({1})",this._model.title,this._model.references.length));const t=this._editor.getModel().uri,i=new n.Position(e.startLineNumber,e.startColumn),o=this._model.nearestReference(t,i);if(o)return this._widget.setSelection(o).then((()=>{this._widget&&"editor"===this._editor.getOption(87)&&this._widget.focusOnPreviewEditor()}))}}));t.dispose()}),(e=>{this._notificationService.error(e)}))}changeFocusBetweenPreviewAndReferences(){this._widget&&(this._widget.isPreviewEditorFocused()?this._widget.focusOnReferenceTree():this._widget.focusOnPreviewEditor())}async goToNextOrPreviousReference(e){if(!this._editor.hasModel()||!this._model||!this._widget)return;const t=this._widget.position;if(!t)return;const i=this._model.nearestReference(this._editor.getModel().uri,t);if(!i)return;const o=this._model.nextOrPreviousReference(i,e),r=this._editor.hasTextFocus(),s=this._widget.isPreviewEditorFocused();await this._widget.setSelection(o),await this._gotoReference(o,!1),r?this._editor.focus():this._widget&&s&&this._widget.focusOnPreviewEditor()}async revealReference(e){this._editor.hasModel()&&this._model&&this._widget&&await this._widget.revealReference(e)}closeWidget(e=!0){this._widget?.dispose(),this._model?.dispose(),this._referenceSearchVisible.reset(),this._disposables.clear(),this._widget=void 0,this._model=void 0,e&&this._editor.focus(),this._requestIdPool+=1}_gotoReference(o,r){this._widget?.hide(),this._ignoreModelChangeEvent=!0;const s=d.Range.lift(o.range).collapseToStart();return this._editorService.openCodeEditor({resource:o.uri,options:{selection:s,selectionSource:"code.jump",pinned:r}},this._editor).then((i=>{if(this._ignoreModelChangeEvent=!1,i&&this._widget)if(this._editor===i)this._widget.show(s),this._widget.focusOnReferenceTree();else{const o=e.get(i),r=this._model.clone();this.closeWidget(),i.focus(),o?.toggleWidget(s,t.createCancelablePromise((e=>Promise.resolve(r))),this._peekMode??!1)}else this.closeWidget()}),(e=>{this._ignoreModelChangeEvent=!1,i.onUnexpectedError(e)}))}openReference(e,t,i){t||this.closeWidget();const{uri:o,range:r}=e;this._editorService.openCodeEditor({resource:o,options:{selection:r,selectionSource:"code.jump",pinned:i}},this._editor,t)}},exports.ReferencesController=e=b([v(2,l.IContextKeyService),v(3,s.ICodeEditorService),v(4,u.INotificationService),v(5,f.IInstantiationService),v(6,p.IStorageService),v(7,g.IConfigurationService)],exports.ReferencesController),m.KeybindingsRegistry.registerCommandAndKeybindingRule({id:"togglePeekWidgetFocus",weight:100,primary:o.KeyChord(2089,60),when:l.ContextKeyExpr.or(x,c.PeekContext.inPeekEditor),handler(e){S(e,(e=>{e.changeFocusBetweenPreviewAndReferences()}))}}),m.KeybindingsRegistry.registerCommandAndKeybindingRule({id:"goToNextReference",weight:90,primary:62,secondary:[70],when:l.ContextKeyExpr.or(x,c.PeekContext.inPeekEditor),handler(e){S(e,(e=>{e.goToNextOrPreviousReference(!0)}))}}),m.KeybindingsRegistry.registerCommandAndKeybindingRule({id:"goToPreviousReference",weight:90,primary:1086,secondary:[1094],when:l.ContextKeyExpr.or(x,c.PeekContext.inPeekEditor),handler(e){S(e,(e=>{e.goToNextOrPreviousReference(!1)}))}}),h.CommandsRegistry.registerCommandAlias("goToNextReferenceFromEmbeddedEditor","goToNextReference"),h.CommandsRegistry.registerCommandAlias("goToPreviousReferenceFromEmbeddedEditor","goToPreviousReference"),h.CommandsRegistry.registerCommandAlias("closeReferenceSearchEditor","closeReferenceSearch"),h.CommandsRegistry.registerCommand("closeReferenceSearch",(e=>S(e,(e=>e.closeWidget())))),m.KeybindingsRegistry.registerKeybindingRule({id:"closeReferenceSearch",weight:-1,primary:9,secondary:[1033],when:l.ContextKeyExpr.and(c.PeekContext.inPeekEditor,l.ContextKeyExpr.not("config.editor.stablePeek"))}),m.KeybindingsRegistry.registerKeybindingRule({id:"closeReferenceSearch",weight:250,primary:9,secondary:[1033],when:l.ContextKeyExpr.and(x,l.ContextKeyExpr.not("config.editor.stablePeek"),l.ContextKeyExpr.or(R.EditorContextKeys.editorTextFocus,C.InputFocusedContext.negate()))}),m.KeybindingsRegistry.registerCommandAndKeybindingRule({id:"revealReference",weight:200,primary:3,mac:{primary:3,secondary:[2066]},when:l.ContextKeyExpr.and(x,_.WorkbenchListFocusContextKey,_.WorkbenchTreeElementCanCollapse.negate(),_.WorkbenchTreeElementCanExpand.negate()),handler(e){const t=e.get(_.IListService),i=t.lastFocusedList?.getFocus();Array.isArray(i)&&i[0]instanceof y.OneReference&&S(e,(e=>e.revealReference(i[0])))}}),m.KeybindingsRegistry.registerCommandAndKeybindingRule({id:"openReferenceToSide",weight:100,primary:2051,mac:{primary:259},when:l.ContextKeyExpr.and(x,_.WorkbenchListFocusContextKey,_.WorkbenchTreeElementCanCollapse.negate(),_.WorkbenchTreeElementCanExpand.negate()),handler(e){const t=e.get(_.IListService),i=t.lastFocusedList?.getFocus();Array.isArray(i)&&i[0]instanceof y.OneReference&&S(e,(e=>e.openReference(i[0],!0,!0)))}}),h.CommandsRegistry.registerCommand("openReference",(e=>{const t=e.get(_.IListService),i=t.lastFocusedList?.getFocus();Array.isArray(i)&&i[0]instanceof y.OneReference&&S(e,(e=>e.openReference(i[0],!1,!0)))})),exports.ctxReferenceSearchVisible=x;
//# sourceMappingURL=referencesController.js.map
