"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var e=require("../../../../base/common/event.js"),t=require("../../../../base/common/lifecycle.js"),i=require("../../../../base/common/resources.js"),r=require("../../../browser/editorExtensions.js"),o=require("../../../browser/services/codeEditorService.js"),s=require("../../../common/core/range.js"),n=require("../../../../nls.js"),d=require("../../../../platform/contextkey/common/contextkey.js"),c=require("../../../../platform/instantiation/common/extensions.js"),a=require("../../../../platform/instantiation/common/instantiation.js"),l=require("../../../../platform/keybinding/common/keybinding.js"),h=require("../../../../platform/keybinding/common/keybindingsRegistry.js"),u=require("../../../../platform/notification/common/notification.js"),g=self&&self.__decorate||function(e,t,i,r){var o,s=arguments.length,n=s<3?t:null===r?r=Object.getOwnPropertyDescriptor(t,i):r;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)n=Reflect.decorate(e,t,i,r);else for(var d=e.length-1;d>=0;d--)(o=e[d])&&(n=(s<3?o(n):s>3?o(t,i,n):o(t,i))||n);return s>3&&n&&Object.defineProperty(t,i,n),n},_=self&&self.__param||function(e,t){return function(i,r){t(i,r,e)}};const m=new d.RawContextKey("hasSymbols",!1,n.localize("hasSymbols","Whether there are symbol locations that can be navigated via keyboard-only.")),f=a.createDecorator("ISymbolNavigationService");let b=class{constructor(e,t,i,r){this._editorService=t,this._notificationService=i,this._keybindingService=r,this._currentModel=void 0,this._currentIdx=-1,this._ignoreEditorChange=!1,this._ctxHasSymbols=m.bindTo(e)}reset(){this._ctxHasSymbols.reset(),this._currentState?.dispose(),this._currentMessage?.dispose(),this._currentModel=void 0,this._currentIdx=-1}put(e){const r=e.parent.parent;if(r.references.length<=1)return void this.reset();this._currentModel=r,this._currentIdx=r.references.indexOf(e),this._ctxHasSymbols.set(!0),this._showMessage();const o=new p(this._editorService),n=o.onDidChange((e=>{if(this._ignoreEditorChange)return;const t=this._editorService.getActiveCodeEditor();if(!t)return;const o=t.getModel(),n=t.getPosition();if(!o||!n)return;let d=!1,c=!1;for(const e of r.references)if(i.isEqual(e.uri,o.uri))d=!0,c=c||s.Range.containsPosition(e.range,n);else if(d)break;d&&c||this.reset()}));this._currentState=t.combinedDisposable(o,n)}revealNext(e){if(!this._currentModel)return Promise.resolve();this._currentIdx+=1,this._currentIdx%=this._currentModel.references.length;const t=this._currentModel.references[this._currentIdx];return this._showMessage(),this._ignoreEditorChange=!0,this._editorService.openCodeEditor({resource:t.uri,options:{selection:s.Range.collapseToStart(t.range),selectionRevealType:3}},e).finally((()=>{this._ignoreEditorChange=!1}))}_showMessage(){this._currentMessage?.dispose();const e=this._keybindingService.lookupKeybinding("editor.gotoNextSymbolFromResult"),t=e?n.localize("location.kb","Symbol {0} of {1}, {2} for next",this._currentIdx+1,this._currentModel.references.length,e.getLabel()):n.localize("location","Symbol {0} of {1}",this._currentIdx+1,this._currentModel.references.length);this._currentMessage=this._notificationService.status(t)}};b=g([_(0,d.IContextKeyService),_(1,o.ICodeEditorService),_(2,u.INotificationService),_(3,l.IKeybindingService)],b),c.registerSingleton(f,b,1),r.registerEditorCommand(new class extends r.EditorCommand{constructor(){super({id:"editor.gotoNextSymbolFromResult",precondition:m,kbOpts:{weight:100,primary:70}})}runEditorCommand(e,t){return e.get(f).revealNext(t)}}),h.KeybindingsRegistry.registerCommandAndKeybindingRule({id:"editor.gotoNextSymbolFromResult.cancel",weight:100,when:m,primary:9,handler(e){e.get(f).reset()}});let p=class{constructor(i){this._listener=new Map,this._disposables=new t.DisposableStore,this._onDidChange=new e.Emitter,this.onDidChange=this._onDidChange.event,this._disposables.add(i.onCodeEditorRemove(this._onDidRemoveEditor,this)),this._disposables.add(i.onCodeEditorAdd(this._onDidAddEditor,this)),i.listCodeEditors().forEach(this._onDidAddEditor,this)}dispose(){this._disposables.dispose(),this._onDidChange.dispose(),t.dispose(this._listener.values())}_onDidAddEditor(e){this._listener.set(e,t.combinedDisposable(e.onDidChangeCursorPosition((t=>this._onDidChange.fire({editor:e}))),e.onDidChangeModelContent((t=>this._onDidChange.fire({editor:e})))))}_onDidRemoveEditor(e){this._listener.get(e)?.dispose(),this._listener.delete(e)}};p=g([_(0,o.ICodeEditorService)],p),exports.ISymbolNavigationService=f,exports.ctxHasSymbols=m;
//# sourceMappingURL=symbolNavigation.js.map
