"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var o,e=require("./hoverActionIds.js"),t=require("../../../../base/common/keyCodes.js"),r=require("../../../browser/editorExtensions.js"),i=require("../../../common/core/range.js"),s=require("../../../common/editorContextKeys.js"),n=require("../../gotoSymbol/browser/link/goToDefinitionAtPosition.js"),c=require("./contentHoverController2.js"),l=require("../../../common/languages.js"),a=require("../../../../nls.js");require("./hover.css.js"),function(o){o.NoAutoFocus="noAutoFocus",o.FocusIfVisible="focusIfVisible",o.AutoFocusImmediately="autoFocusImmediately"}(o||(o={}));class d extends r.EditorAction{constructor(){super({id:e.SHOW_OR_FOCUS_HOVER_ACTION_ID,label:a.localize({key:"showOrFocusHover",comment:["Label for action that will trigger the showing/focusing of a hover in the editor.","If the hover is not visible, it will show the hover.","This allows for users to show the hover without using the mouse."]},"Show or Focus Hover"),metadata:{description:a.localize2("showOrFocusHoverDescription","Show or focus the editor hover which shows documentation, references, and other content for a symbol at the current cursor position."),args:[{name:"args",schema:{type:"object",properties:{focus:{description:"Controls if and when the hover should take focus upon being triggered by this action.",enum:[o.NoAutoFocus,o.FocusIfVisible,o.AutoFocusImmediately],enumDescriptions:[a.localize("showOrFocusHover.focus.noAutoFocus","The hover will not automatically take focus."),a.localize("showOrFocusHover.focus.focusIfVisible","The hover will take focus only if it is already visible."),a.localize("showOrFocusHover.focus.autoFocusImmediately","The hover will automatically take focus when it appears.")],default:o.FocusIfVisible}}}}]},alias:"Show or Focus Hover",precondition:void 0,kbOpts:{kbExpr:s.EditorContextKeys.editorTextFocus,primary:t.KeyChord(2089,2087),weight:100}})}run(e,t,r){if(!t.hasModel())return;const s=c.ContentHoverController.get(t);if(!s)return;const n=r?.focus;let l=o.FocusIfVisible;Object.values(o).includes(n)?l=n:"boolean"==typeof n&&n&&(l=o.AutoFocusImmediately);const a=o=>{const e=t.getPosition(),r=new i.Range(e.lineNumber,e.column,e.lineNumber,e.column);s.showContentHover(r,1,1,o)},d=2===t.getOption(2);s.isHoverVisible?l!==o.NoAutoFocus?s.focus():a(d):a(d||l===o.AutoFocusImmediately)}}class h extends r.EditorAction{constructor(){super({id:e.SHOW_DEFINITION_PREVIEW_HOVER_ACTION_ID,label:a.localize({key:"showDefinitionPreviewHover",comment:["Label for action that will trigger the showing of definition preview hover in the editor.","This allows for users to show the definition preview hover without using the mouse."]},"Show Definition Preview Hover"),alias:"Show Definition Preview Hover",precondition:void 0,metadata:{description:a.localize2("showDefinitionPreviewHoverDescription","Show the definition preview hover in the editor.")}})}run(o,e){const t=c.ContentHoverController.get(e);if(!t)return;const r=e.getPosition();if(!r)return;const s=new i.Range(r.lineNumber,r.column,r.lineNumber,r.column),l=n.GotoDefinitionAtPositionEditorContribution.get(e);if(!l)return;l.startFindDefinitionFromCursor(r).then((()=>{t.showContentHover(s,1,1,!0)}))}}class u extends r.EditorAction{constructor(){super({id:e.SCROLL_UP_HOVER_ACTION_ID,label:a.localize({key:"scrollUpHover",comment:["Action that allows to scroll up in the hover widget with the up arrow when the hover widget is focused."]},"Scroll Up Hover"),alias:"Scroll Up Hover",precondition:s.EditorContextKeys.hoverFocused,kbOpts:{kbExpr:s.EditorContextKeys.hoverFocused,primary:16,weight:100},metadata:{description:a.localize2("scrollUpHoverDescription","Scroll up the editor hover.")}})}run(o,e){const t=c.ContentHoverController.get(e);t&&t.scrollUp()}}class v extends r.EditorAction{constructor(){super({id:e.SCROLL_DOWN_HOVER_ACTION_ID,label:a.localize({key:"scrollDownHover",comment:["Action that allows to scroll down in the hover widget with the up arrow when the hover widget is focused."]},"Scroll Down Hover"),alias:"Scroll Down Hover",precondition:s.EditorContextKeys.hoverFocused,kbOpts:{kbExpr:s.EditorContextKeys.hoverFocused,primary:18,weight:100},metadata:{description:a.localize2("scrollDownHoverDescription","Scroll down the editor hover.")}})}run(o,e){const t=c.ContentHoverController.get(e);t&&t.scrollDown()}}class p extends r.EditorAction{constructor(){super({id:e.SCROLL_LEFT_HOVER_ACTION_ID,label:a.localize({key:"scrollLeftHover",comment:["Action that allows to scroll left in the hover widget with the left arrow when the hover widget is focused."]},"Scroll Left Hover"),alias:"Scroll Left Hover",precondition:s.EditorContextKeys.hoverFocused,kbOpts:{kbExpr:s.EditorContextKeys.hoverFocused,primary:15,weight:100},metadata:{description:a.localize2("scrollLeftHoverDescription","Scroll left the editor hover.")}})}run(o,e){const t=c.ContentHoverController.get(e);t&&t.scrollLeft()}}class w extends r.EditorAction{constructor(){super({id:e.SCROLL_RIGHT_HOVER_ACTION_ID,label:a.localize({key:"scrollRightHover",comment:["Action that allows to scroll right in the hover widget with the right arrow when the hover widget is focused."]},"Scroll Right Hover"),alias:"Scroll Right Hover",precondition:s.EditorContextKeys.hoverFocused,kbOpts:{kbExpr:s.EditorContextKeys.hoverFocused,primary:17,weight:100},metadata:{description:a.localize2("scrollRightHoverDescription","Scroll right the editor hover.")}})}run(o,e){const t=c.ContentHoverController.get(e);t&&t.scrollRight()}}class g extends r.EditorAction{constructor(){super({id:e.PAGE_UP_HOVER_ACTION_ID,label:a.localize({key:"pageUpHover",comment:["Action that allows to page up in the hover widget with the page up command when the hover widget is focused."]},"Page Up Hover"),alias:"Page Up Hover",precondition:s.EditorContextKeys.hoverFocused,kbOpts:{kbExpr:s.EditorContextKeys.hoverFocused,primary:11,secondary:[528],weight:100},metadata:{description:a.localize2("pageUpHoverDescription","Page up the editor hover.")}})}run(o,e){const t=c.ContentHoverController.get(e);t&&t.pageUp()}}class m extends r.EditorAction{constructor(){super({id:e.PAGE_DOWN_HOVER_ACTION_ID,label:a.localize({key:"pageDownHover",comment:["Action that allows to page down in the hover widget with the page down command when the hover widget is focused."]},"Page Down Hover"),alias:"Page Down Hover",precondition:s.EditorContextKeys.hoverFocused,kbOpts:{kbExpr:s.EditorContextKeys.hoverFocused,primary:12,secondary:[530],weight:100},metadata:{description:a.localize2("pageDownHoverDescription","Page down the editor hover.")}})}run(o,e){const t=c.ContentHoverController.get(e);t&&t.pageDown()}}class H extends r.EditorAction{constructor(){super({id:e.GO_TO_TOP_HOVER_ACTION_ID,label:a.localize({key:"goToTopHover",comment:["Action that allows to go to the top of the hover widget with the home command when the hover widget is focused."]},"Go To Top Hover"),alias:"Go To Bottom Hover",precondition:s.EditorContextKeys.hoverFocused,kbOpts:{kbExpr:s.EditorContextKeys.hoverFocused,primary:14,secondary:[2064],weight:100},metadata:{description:a.localize2("goToTopHoverDescription","Go to the top of the editor hover.")}})}run(o,e){const t=c.ContentHoverController.get(e);t&&t.goToTop()}}class E extends r.EditorAction{constructor(){super({id:e.GO_TO_BOTTOM_HOVER_ACTION_ID,label:a.localize({key:"goToBottomHover",comment:["Action that allows to go to the bottom in the hover widget with the end command when the hover widget is focused."]},"Go To Bottom Hover"),alias:"Go To Bottom Hover",precondition:s.EditorContextKeys.hoverFocused,kbOpts:{kbExpr:s.EditorContextKeys.hoverFocused,primary:13,secondary:[2066],weight:100},metadata:{description:a.localize2("goToBottomHoverDescription","Go to the bottom of the editor hover.")}})}run(o,e){const t=c.ContentHoverController.get(e);t&&t.goToBottom()}}class f extends r.EditorAction{constructor(){super({id:e.INCREASE_HOVER_VERBOSITY_ACTION_ID,label:e.INCREASE_HOVER_VERBOSITY_ACTION_LABEL,alias:"Increase Hover Verbosity Level",precondition:s.EditorContextKeys.hoverVisible})}run(o,e,t){const r=c.ContentHoverController.get(e);if(!r)return;const i=void 0!==t?.index?t.index:r.focusedHoverPartIndex();r.updateHoverVerbosityLevel(l.HoverVerbosityAction.Increase,i,t?.focus)}}class C extends r.EditorAction{constructor(){super({id:e.DECREASE_HOVER_VERBOSITY_ACTION_ID,label:e.DECREASE_HOVER_VERBOSITY_ACTION_LABEL,alias:"Decrease Hover Verbosity Level",precondition:s.EditorContextKeys.hoverVisible})}run(o,e,t){const r=c.ContentHoverController.get(e);if(!r)return;const i=void 0!==t?.index?t.index:r.focusedHoverPartIndex();c.ContentHoverController.get(e)?.updateHoverVerbosityLevel(l.HoverVerbosityAction.Decrease,i,t?.focus)}}exports.DecreaseHoverVerbosityLevel=C,exports.GoToBottomHoverAction=E,exports.GoToTopHoverAction=H,exports.IncreaseHoverVerbosityLevel=f,exports.PageDownHoverAction=m,exports.PageUpHoverAction=g,exports.ScrollDownHoverAction=v,exports.ScrollLeftHoverAction=p,exports.ScrollRightHoverAction=w,exports.ScrollUpHoverAction=u,exports.ShowDefinitionPreviewHoverAction=h,exports.ShowOrFocusHoverAction=d;
//# sourceMappingURL=hoverActions.js.map
