"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var e=require("../../../../base/browser/dom.js"),r=require("../../../../base/common/arrays.js"),t=require("../../../../base/common/async.js"),o=require("../../../../base/common/errors.js"),n=require("../../../../base/common/lifecycle.js"),s=require("../../../../base/common/resources.js"),i=require("../../../common/core/range.js"),a=require("../../../common/services/languageFeatures.js"),c=require("../../../common/services/markerDecorations.js"),d=require("../../codeAction/browser/codeAction.js"),p=require("../../codeAction/browser/codeActionController.js"),l=require("../../codeAction/common/types.js"),u=require("../../gotoError/browser/gotoError.js"),m=require("./hoverTypes.js"),h=require("../../../../nls.js"),g=require("../../../../platform/markers/common/markers.js"),f=require("../../../../platform/opener/common/opener.js"),k=require("../../../../platform/progress/common/progress.js"),v=self&&self.__decorate||function(e,r,t,o){var n,s=arguments.length,i=s<3?r:null===o?o=Object.getOwnPropertyDescriptor(r,t):o;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)i=Reflect.decorate(e,r,t,o);else for(var a=e.length-1;a>=0;a--)(n=e[a])&&(i=(s<3?n(i):s>3?n(r,t,i):n(r,t))||i);return s>3&&i&&Object.defineProperty(r,t,i),i},C=self&&self.__param||function(e,r){return function(t,o){r(t,o,e)}};const b=e.$;class y{constructor(e,r,t){this.owner=e,this.range=r,this.marker=t}isValidForHoverAnchor(e){return 1===e.type&&this.range.startColumn<=e.range.startColumn&&this.range.endColumn>=e.range.endColumn}}const x={type:1,filter:{include:l.CodeActionKind.QuickFix},triggerAction:l.CodeActionTriggerSource.QuickFixHover};exports.MarkerHoverParticipant=class{constructor(e,r,t,o){this._editor=e,this._markerDecorationsService=r,this._openerService=t,this._languageFeaturesService=o,this.hoverOrdinal=1,this.recentMarkerCodeActionsInfo=void 0}computeSync(e,r){if(!this._editor.hasModel()||1!==e.type&&!e.supportsMarkerHover)return[];const t=this._editor.getModel(),o=e.range.startLineNumber,n=t.getLineMaxColumn(o),s=[];for(const a of r){const r=a.range.startLineNumber===o?a.range.startColumn:1,c=a.range.endLineNumber===o?a.range.endColumn:n,d=this._markerDecorationsService.getMarker(t.uri,a);if(!d)continue;const p=new i.Range(e.range.startLineNumber,r,e.range.startLineNumber,c);s.push(new y(this,p,d))}return s}renderHoverParts(e,r){if(!r.length)return new m.RenderedHoverParts([]);const t=new n.DisposableStore,o=[];r.forEach((r=>{const t=this._renderMarkerHover(r);e.fragment.appendChild(t.hoverElement),o.push(t)}));const s=1===r.length?r[0]:r.sort(((e,r)=>g.MarkerSeverity.compare(e.marker.severity,r.marker.severity)))[0];return this.renderMarkerStatusbar(e,s,t),new m.RenderedHoverParts(o)}_renderMarkerHover(t){const i=new n.DisposableStore,a=b("div.hover-row"),c=e.append(a,b("div.marker.hover-contents")),{source:d,message:p,code:l,relatedInformation:u}=t.marker;this._editor.applyFontInfo(c);const m=e.append(c,b("span"));if(m.style.whiteSpace="pre-wrap",m.innerText=p,d||l)if(l&&"string"!=typeof l){const r=b("span");if(d){e.append(r,b("span")).innerText=d}const t=e.append(r,b("a.code-link"));t.setAttribute("href",l.target.toString()),i.add(e.addDisposableListener(t,"click",(e=>{this._openerService.open(l.target,{allowCommands:!0}),e.preventDefault(),e.stopPropagation()})));e.append(t,b("span")).innerText=l.value;const o=e.append(c,r);o.style.opacity="0.6",o.style.paddingLeft="6px"}else{const r=e.append(c,b("span"));r.style.opacity="0.6",r.style.paddingLeft="6px",r.innerText=d&&l?`${d}(${l})`:d||`(${l})`}if(r.isNonEmptyArray(u))for(const{message:r,resource:t,startLineNumber:n,startColumn:a}of u){const d=e.append(c,b("div"));d.style.marginTop="8px";const p=e.append(d,b("a"));p.innerText=`${s.basename(t)}(${n}, ${a}): `,p.style.cursor="pointer",i.add(e.addDisposableListener(p,"click",(e=>{if(e.stopPropagation(),e.preventDefault(),this._openerService){const e={selection:{startLineNumber:n,startColumn:a}};this._openerService.open(t,{fromUserGesture:!0,editorOptions:e}).catch(o.onUnexpectedError)}})));const l=e.append(d,b("span"));l.innerText=r,this._editor.applyFontInfo(l)}return{hoverPart:t,hoverElement:a,dispose:()=>i.dispose()}}renderMarkerStatusbar(r,s,i){if(s.marker.severity===g.MarkerSeverity.Error||s.marker.severity===g.MarkerSeverity.Warning||s.marker.severity===g.MarkerSeverity.Info){const e=u.MarkerController.get(this._editor);e&&r.statusBar.addAction({label:h.localize("view problem","View Problem"),commandId:u.NextMarkerAction.ID,run:()=>{r.hide(),e.showAtMarker(s.marker),this._editor.focus()}})}if(!this._editor.getOption(92)){const a=r.statusBar.append(b("div"));this.recentMarkerCodeActionsInfo&&(g.IMarkerData.makeKey(this.recentMarkerCodeActionsInfo.marker)===g.IMarkerData.makeKey(s.marker)?this.recentMarkerCodeActionsInfo.hasCodeActions||(a.textContent=h.localize("noQuickFixes","No quick fixes available")):this.recentMarkerCodeActionsInfo=void 0);const c=this.recentMarkerCodeActionsInfo&&!this.recentMarkerCodeActionsInfo.hasCodeActions?n.Disposable.None:t.disposableTimeout((()=>a.textContent=h.localize("checkingForQuickFixes","Checking for quick fixes...")),200,i);a.textContent||(a.textContent=String.fromCharCode(160));const l=this.getCodeActions(s.marker);i.add(n.toDisposable((()=>l.cancel()))),l.then((t=>{if(c.dispose(),this.recentMarkerCodeActionsInfo={marker:s.marker,hasCodeActions:t.validActions.length>0},!this.recentMarkerCodeActionsInfo.hasCodeActions)return t.dispose(),void(a.textContent=h.localize("noQuickFixes","No quick fixes available"));a.style.display="none";let o=!1;i.add(n.toDisposable((()=>{o||t.dispose()}))),r.statusBar.addAction({label:h.localize("quick fixes","Quick Fix..."),commandId:d.quickFixCommandId,run:n=>{o=!0;const s=p.CodeActionController.get(this._editor),i=e.getDomNodePagePosition(n);r.hide(),s?.showCodeActions(x,t,{x:i.left,y:i.top,width:i.width,height:i.height})}})}),o.onUnexpectedError)}}getCodeActions(e){return t.createCancelablePromise((r=>d.getCodeActions(this._languageFeaturesService.codeActionProvider,this._editor.getModel(),new i.Range(e.startLineNumber,e.startColumn,e.endLineNumber,e.endColumn),x,k.Progress.None,r)))}},exports.MarkerHoverParticipant=v([C(1,c.IMarkerDecorationsService),C(2,f.IOpenerService),C(3,a.ILanguageFeaturesService)],exports.MarkerHoverParticipant),exports.MarkerHover=y;
//# sourceMappingURL=markerHoverParticipant.js.map
