"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var e=require("../../../../base/common/lifecycle.js"),t=require("../../../../base/common/strings.js"),n=require("../../../browser/editorExtensions.js"),i=require("../../../common/commands/shiftCommand.js"),o=require("../../../common/core/range.js"),s=require("../../../common/editorContextKeys.js"),a=require("../../../common/languages/languageConfigurationRegistry.js"),r=require("../../../common/services/model.js"),c=require("../common/indentUtils.js"),d=require("../../../../nls.js"),l=require("../../../../platform/quickinput/common/quickInput.js"),u=require("../../../common/languages/autoIndent.js"),g=require("../common/indentation.js"),p=require("../../../common/tokens/lineTokens.js"),h=self&&self.__decorate||function(e,t,n,i){var o,s=arguments.length,a=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)a=Reflect.decorate(e,t,n,i);else for(var r=e.length-1;r>=0;r--)(o=e[r])&&(a=(s<3?o(a):s>3?o(t,n,a):o(t,n))||a);return s>3&&a&&Object.defineProperty(t,n,a),a},S=self&&self.__param||function(e,t){return function(n,i){t(n,i,e)}};class m extends n.EditorAction{static{this.ID="editor.action.indentationToSpaces"}constructor(){super({id:m.ID,label:d.localize("indentationToSpaces","Convert Indentation to Spaces"),alias:"Convert Indentation to Spaces",precondition:s.EditorContextKeys.writable,metadata:{description:d.localize2("indentationToSpacesDescription","Convert the tab indentation to spaces.")}})}run(e,t){const n=t.getModel();if(!n)return;const i=n.getOptions(),o=t.getSelection();if(!o)return;const s=new _(o,i.tabSize);t.pushUndoStop(),t.executeCommands(this.id,[s]),t.pushUndoStop(),n.updateOptions({insertSpaces:!0})}}class f extends n.EditorAction{static{this.ID="editor.action.indentationToTabs"}constructor(){super({id:f.ID,label:d.localize("indentationToTabs","Convert Indentation to Tabs"),alias:"Convert Indentation to Tabs",precondition:s.EditorContextKeys.writable,metadata:{description:d.localize2("indentationToTabsDescription","Convert the spaces indentation to tabs.")}})}run(e,t){const n=t.getModel();if(!n)return;const i=n.getOptions(),o=t.getSelection();if(!o)return;const s=new y(o,i.tabSize);t.pushUndoStop(),t.executeCommands(this.id,[s]),t.pushUndoStop(),n.updateOptions({insertSpaces:!1})}}class b extends n.EditorAction{constructor(e,t,n){super(n),this.insertSpaces=e,this.displaySizeOnly=t}run(e,t){const n=e.get(l.IQuickInputService),i=e.get(r.IModelService),o=t.getModel();if(!o)return;const s=i.getCreationOptions(o.getLanguageId(),o.uri,o.isForSimpleWidget),a=o.getOptions(),c=[1,2,3,4,5,6,7,8].map((e=>({id:e.toString(),label:e.toString(),description:e===s.tabSize&&e===a.tabSize?d.localize("configuredTabSize","Configured Tab Size"):e===s.tabSize?d.localize("defaultTabSize","Default Tab Size"):e===a.tabSize?d.localize("currentTabSize","Current Tab Size"):void 0}))),u=Math.min(o.getOptions().tabSize-1,7);setTimeout((()=>{n.pick(c,{placeHolder:d.localize({key:"selectTabWidth",comment:["Tab corresponds to the tab key"]},"Select Tab Size for Current File"),activeItem:c[u]}).then((e=>{if(e&&o&&!o.isDisposed()){const t=parseInt(e.label,10);this.displaySizeOnly?o.updateOptions({tabSize:t}):o.updateOptions({tabSize:t,indentSize:t,insertSpaces:this.insertSpaces})}}))}),50)}}class I extends b{static{this.ID="editor.action.indentUsingTabs"}constructor(){super(!1,!1,{id:I.ID,label:d.localize("indentUsingTabs","Indent Using Tabs"),alias:"Indent Using Tabs",precondition:void 0,metadata:{description:d.localize2("indentUsingTabsDescription","Use indentation with tabs.")}})}}class C extends b{static{this.ID="editor.action.indentUsingSpaces"}constructor(){super(!0,!1,{id:C.ID,label:d.localize("indentUsingSpaces","Indent Using Spaces"),alias:"Indent Using Spaces",precondition:void 0,metadata:{description:d.localize2("indentUsingSpacesDescription","Use indentation with spaces.")}})}}class L extends b{static{this.ID="editor.action.changeTabDisplaySize"}constructor(){super(!0,!0,{id:L.ID,label:d.localize("changeTabDisplaySize","Change Tab Display Size"),alias:"Change Tab Display Size",precondition:void 0,metadata:{description:d.localize2("changeTabDisplaySizeDescription","Change the space size equivalent of the tab.")}})}}class z extends n.EditorAction{static{this.ID="editor.action.detectIndentation"}constructor(){super({id:z.ID,label:d.localize("detectIndentation","Detect Indentation from Content"),alias:"Detect Indentation from Content",precondition:void 0,metadata:{description:d.localize2("detectIndentationDescription","Detect the indentation from content.")}})}run(e,t){const n=e.get(r.IModelService),i=t.getModel();if(!i)return;const o=n.getCreationOptions(i.getLanguageId(),i.uri,i.isForSimpleWidget);i.detectIndentation(o.insertSpaces,o.tabSize)}}class T extends n.EditorAction{constructor(){super({id:"editor.action.reindentlines",label:d.localize("editor.reindentlines","Reindent Lines"),alias:"Reindent Lines",precondition:s.EditorContextKeys.writable,metadata:{description:d.localize2("editor.reindentlinesDescription","Reindent the lines of the editor.")}})}run(e,t){const n=e.get(a.ILanguageConfigurationService),i=t.getModel();if(!i)return;const o=g.getReindentEditOperations(i,n,1,i.getLineCount());o.length>0&&(t.pushUndoStop(),t.executeEdits(this.id,o),t.pushUndoStop())}}class O extends n.EditorAction{constructor(){super({id:"editor.action.reindentselectedlines",label:d.localize("editor.reindentselectedlines","Reindent Selected Lines"),alias:"Reindent Selected Lines",precondition:s.EditorContextKeys.writable,metadata:{description:d.localize2("editor.reindentselectedlinesDescription","Reindent the selected lines of the editor.")}})}run(e,t){const n=e.get(a.ILanguageConfigurationService),i=t.getModel();if(!i)return;const o=t.getSelections();if(null===o)return;const s=[];for(const e of o){let t=e.startLineNumber,o=e.endLineNumber;if(t!==o&&1===e.endColumn&&o--,1===t){if(t===o)continue}else t--;const a=g.getReindentEditOperations(i,n,t,o);s.push(...a)}s.length>0&&(t.pushUndoStop(),t.executeEdits(this.id,s),t.pushUndoStop())}}class x{constructor(e,t){this._initialSelection=t,this._edits=[],this._selectionId=null;for(const t of e)t.range&&"string"==typeof t.text&&this._edits.push(t)}getEditOperations(e,t){for(const e of this._edits)t.addEditOperation(o.Range.lift(e.range),e.text);let n=!1;Array.isArray(this._edits)&&1===this._edits.length&&this._initialSelection.isEmpty()&&(this._edits[0].range.startColumn===this._initialSelection.endColumn&&this._edits[0].range.startLineNumber===this._initialSelection.endLineNumber?(n=!0,this._selectionId=t.trackSelection(this._initialSelection,!0)):this._edits[0].range.endColumn===this._initialSelection.startColumn&&this._edits[0].range.endLineNumber===this._initialSelection.startLineNumber&&(n=!0,this._selectionId=t.trackSelection(this._initialSelection,!1))),n||(this._selectionId=t.trackSelection(this._initialSelection))}computeCursorState(e,t){return t.getTrackedSelection(this._selectionId)}}function D(e,t,n,i){if(1===e.getLineCount()&&1===e.getLineMaxColumn(1))return;let s="";for(let e=0;e<n;e++)s+=" ";const a=new RegExp(s,"gi");for(let n=1,r=e.getLineCount();n<=r;n++){let r=e.getLineFirstNonWhitespaceColumn(n);if(0===r&&(r=e.getLineMaxColumn(n)),1===r)continue;const c=new o.Range(n,1,n,r),d=e.getValueInRange(c),l=i?d.replace(/\t/gi,s):d.replace(a,"\t");t.addEditOperation(c,l)}}exports.AutoIndentOnPaste=class{static{this.ID="editor.contrib.autoIndentOnPaste"}constructor(t,n){this.editor=t,this._languageConfigurationService=n,this.callOnDispose=new e.DisposableStore,this.callOnModel=new e.DisposableStore,this.callOnDispose.add(t.onDidChangeConfiguration((()=>this.update()))),this.callOnDispose.add(t.onDidChangeModel((()=>this.update()))),this.callOnDispose.add(t.onDidChangeModelLanguage((()=>this.update())))}update(){this.callOnModel.clear(),this.editor.getOption(12)<4||this.editor.getOption(55)||this.editor.hasModel()&&this.callOnModel.add(this.editor.onDidPaste((({range:e})=>{this.trigger(e)})))}trigger(e){const n=this.editor.getSelections();if(null===n||n.length>1)return;const s=this.editor.getModel();if(!s)return;if(this.rangeContainsOnlyWhitespaceCharacters(s,e))return;if(function(e,t){const n=t=>2===p.getStandardTokenTypeAtPosition(e,t);return n(t.getStartPosition())||n(t.getEndPosition())}(s,e))return;if(!s.tokenization.isCheapToTokenize(e.getStartPosition().lineNumber))return;const a=this.editor.getOption(12),{tabSize:r,indentSize:d,insertSpaces:l}=s.getOptions(),g=[],h={shiftIndent:e=>i.ShiftCommand.shiftIndent(e,e.length+1,r,d,l),unshiftIndent:e=>i.ShiftCommand.unshiftIndent(e,e.length+1,r,d,l)};let S=e.startLineNumber;for(;S<=e.endLineNumber&&this.shouldIgnoreLine(s,S);)S++;if(S>e.endLineNumber)return;let m=s.getLineContent(S);if(!/\S/.test(m.substring(0,e.startColumn-1))){const e=u.getGoodIndentForLine(a,s,s.getLanguageId(),S,h,this._languageConfigurationService);if(null!==e){const n=t.getLeadingWhitespace(m),i=c.getSpaceCnt(e,r);if(i!==c.getSpaceCnt(n,r)){const e=c.generateIndent(i,r,l);g.push({range:new o.Range(S,1,S,n.length+1),text:e}),m=e+m.substring(n.length)}else{const e=u.getIndentMetadata(s,S,this._languageConfigurationService);if(0===e||8===e)return}}}const f=S;for(;S<e.endLineNumber&&!/\S/.test(s.getLineContent(S+1));)S++;if(S!==e.endLineNumber){const n={tokenization:{getLineTokens:e=>s.tokenization.getLineTokens(e),getLanguageId:()=>s.getLanguageId(),getLanguageIdAtPosition:(e,t)=>s.getLanguageIdAtPosition(e,t)},getLineContent:e=>e===f?m:s.getLineContent(e)},i=u.getGoodIndentForLine(a,n,s.getLanguageId(),S+1,h,this._languageConfigurationService);if(null!==i){const n=c.getSpaceCnt(i,r),a=c.getSpaceCnt(t.getLeadingWhitespace(s.getLineContent(S+1)),r);if(n!==a){const i=n-a;for(let n=S+1;n<=e.endLineNumber;n++){const e=s.getLineContent(n),a=t.getLeadingWhitespace(e),d=c.getSpaceCnt(a,r)+i,u=c.generateIndent(d,r,l);u!==a&&g.push({range:new o.Range(n,1,n,a.length+1),text:u})}}}}if(g.length>0){this.editor.pushUndoStop();const e=new x(g,this.editor.getSelection());this.editor.executeCommand("autoIndentOnPaste",e),this.editor.pushUndoStop()}}rangeContainsOnlyWhitespaceCharacters(e,t){const n=e=>0===e.trim().length;let i=!0;if(t.startLineNumber===t.endLineNumber){i=n(e.getLineContent(t.startLineNumber).substring(t.startColumn-1,t.endColumn-1))}else for(let o=t.startLineNumber;o<=t.endLineNumber;o++){const s=e.getLineContent(o);if(o===t.startLineNumber){i=n(s.substring(t.startColumn-1))}else if(o===t.endLineNumber){i=n(s.substring(0,t.endColumn-1))}else i=0===e.getLineFirstNonWhitespaceColumn(o);if(!i)break}return i}shouldIgnoreLine(e,t){e.tokenization.forceTokenization(t);const n=e.getLineFirstNonWhitespaceColumn(t);if(0===n)return!0;const i=e.tokenization.getLineTokens(t);if(i.getCount()>0){const e=i.findTokenIndexAtOffset(n);if(e>=0&&1===i.getStandardTokenType(e))return!0}return!1}dispose(){this.callOnDispose.dispose(),this.callOnModel.dispose()}},exports.AutoIndentOnPaste=h([S(1,a.ILanguageConfigurationService)],exports.AutoIndentOnPaste);class _{constructor(e,t){this.selection=e,this.tabSize=t,this.selectionId=null}getEditOperations(e,t){this.selectionId=t.trackSelection(this.selection),D(e,t,this.tabSize,!0)}computeCursorState(e,t){return t.getTrackedSelection(this.selectionId)}}class y{constructor(e,t){this.selection=e,this.tabSize=t,this.selectionId=null}getEditOperations(e,t){this.selectionId=t.trackSelection(this.selection),D(e,t,this.tabSize,!1)}computeCursorState(e,t){return t.getTrackedSelection(this.selectionId)}}n.registerEditorContribution(exports.AutoIndentOnPaste.ID,exports.AutoIndentOnPaste,2),n.registerEditorAction(m),n.registerEditorAction(f),n.registerEditorAction(I),n.registerEditorAction(C),n.registerEditorAction(L),n.registerEditorAction(z),n.registerEditorAction(T),n.registerEditorAction(O),exports.AutoIndentOnPasteCommand=x,exports.ChangeIndentationSizeAction=b,exports.ChangeTabDisplaySize=L,exports.DetectIndentation=z,exports.IndentUsingSpaces=C,exports.IndentUsingTabs=I,exports.IndentationToSpacesAction=m,exports.IndentationToSpacesCommand=_,exports.IndentationToTabsAction=f,exports.IndentationToTabsCommand=y,exports.ReindentLinesAction=T,exports.ReindentSelectedLinesAction=O;
//# sourceMappingURL=indentation.js.map
