"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var e=require("../../../../base/browser/dom.js"),t=require("../../../../base/common/arrays.js"),o=require("../../../../base/common/async.js"),i=require("../../../../base/common/cancellation.js"),s=require("../../../../base/common/errors.js"),n=require("../../../../base/common/lifecycle.js"),r=require("../../../../base/common/map.js"),a=require("../../../../base/common/types.js"),l=require("../../../../base/common/uri.js"),c=require("../../../browser/editorDom.js"),d=require("../../../browser/stableEditorScroll.js"),h=require("../../../common/config/editorOptions.js"),m=require("../../../common/core/editOperation.js"),u=require("../../../common/core/range.js"),p=require("../../../common/languages.js"),g=require("../../../common/model.js"),_=require("../../../common/model/textModel.js"),f=require("../../../common/services/languageFeatureDebounce.js"),y=require("../../../common/services/languageFeatures.js"),b=require("../../../common/services/resolverService.js"),v=require("../../gotoSymbol/browser/link/clickLinkGesture.js"),C=require("./inlayHints.js"),I=require("./inlayHintsLocations.js"),D=require("../../../../platform/commands/common/commands.js"),R=require("../../../../platform/instantiation/common/extensions.js"),H=require("../../../../platform/instantiation/common/instantiation.js"),M=require("../../../../platform/notification/common/notification.js");require("../../../../platform/theme/common/colorUtils.js"),require("../../../../platform/theme/common/colors/baseColors.js"),require("../../../../platform/theme/common/colors/chartsColors.js");var x=require("../../../../platform/theme/common/colors/editorColors.js");require("../../../../platform/theme/common/colors/inputColors.js"),require("../../../../platform/theme/common/colors/listColors.js"),require("../../../../platform/theme/common/colors/menuColors.js"),require("../../../../platform/theme/common/colors/minimapColors.js"),require("../../../../platform/theme/common/colors/miscColors.js"),require("../../../../platform/theme/common/colors/quickpickColors.js"),require("../../../../platform/theme/common/colors/searchColors.js");var S,j=require("../../../../platform/theme/common/themeService.js"),F=self&&self.__decorate||function(e,t,o,i){var s,n=arguments.length,r=n<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,o):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,o,i);else for(var a=e.length-1;a>=0;a--)(s=e[a])&&(r=(n<3?s(r):n>3?s(t,o,r):s(t,o))||r);return n>3&&r&&Object.defineProperty(t,o,r),r},L=self&&self.__param||function(e,t){return function(o,i){t(o,i,e)}};class q{constructor(){this._entries=new r.LRUCache(50)}get(e){const t=q._key(e);return this._entries.get(t)}set(e,t){const o=q._key(e);this._entries.set(o,t)}static _key(e){return`${e.uri.toString()}/${e.getVersionId()}`}}const w=H.createDecorator("IInlayHintsCache");R.registerSingleton(w,q,1);class k{constructor(e,t){this.item=e,this.index=t}get part(){const e=this.item.hint.label;return"string"==typeof e?{label:e}:e[this.index]}}class T{constructor(e,t){this.part=e,this.hasTriggerModifier=t}}function E(e){return e.replace(/[ \t]/g," ")}exports.InlayHintsController=class{static{S=this}static{this.ID="editor.contrib.InlayHints"}static{this._MAX_DECORATORS=1500}static{this._MAX_LABEL_LEN=43}static get(e){return e.getContribution(S.ID)??void 0}constructor(e,t,o,i,s,r,a){this._editor=e,this._languageFeaturesService=t,this._inlayHintsCache=i,this._commandService=s,this._notificationService=r,this._instaService=a,this._disposables=new n.DisposableStore,this._sessionDisposables=new n.DisposableStore,this._decorationsMetadata=new Map,this._ruleFactory=new c.DynamicCssRules(this._editor),this._activeRenderMode=0,this._debounceInfo=o.for(t.inlayHintsProvider,"InlayHint",{min:25}),this._disposables.add(t.inlayHintsProvider.onDidChange((()=>this._update()))),this._disposables.add(e.onDidChangeModel((()=>this._update()))),this._disposables.add(e.onDidChangeModelLanguage((()=>this._update()))),this._disposables.add(e.onDidChangeConfiguration((e=>{e.hasChanged(142)&&this._update()}))),this._update()}dispose(){this._sessionDisposables.dispose(),this._removeAllDecorations(),this._disposables.dispose()}_update(){this._sessionDisposables.clear(),this._removeAllDecorations();const t=this._editor.getOption(142);if("off"===t.enabled)return;const r=this._editor.getModel();if(!r||!this._languageFeaturesService.inlayHintsProvider.has(r))return;if("on"===t.enabled)this._activeRenderMode=0;else{let o,i;"onUnlessPressed"===t.enabled?(o=0,i=1):(o=1,i=0),this._activeRenderMode=o,this._sessionDisposables.add(e.ModifierKeyEmitter.getInstance().event((e=>{if(!this._editor.hasModel())return;const t=e.altKey&&e.ctrlKey&&!e.shiftKey&&!e.metaKey?i:o;if(t!==this._activeRenderMode){this._activeRenderMode=t;const e=this._editor.getModel(),o=this._copyInlayHintsWithCurrentAnchor(e);this._updateHintsDecorators([e.getFullModelRange()],o),d.schedule(0)}})))}const a=this._inlayHintsCache.get(r);let l;a&&this._updateHintsDecorators([r.getFullModelRange()],a),this._sessionDisposables.add(n.toDisposable((()=>{r.isDisposed()||this._cacheHintsForFastRestore(r)})));const c=new Set,d=new o.RunOnceScheduler((async()=>{const e=Date.now();l?.dispose(!0),l=new i.CancellationTokenSource;const t=r.onWillDispose((()=>l?.cancel()));try{const t=l.token,o=await C.InlayHintsFragments.create(this._languageFeaturesService.inlayHintsProvider,r,this._getHintsRanges(),t);if(d.delay=this._debounceInfo.update(r,Date.now()-e),t.isCancellationRequested)return void o.dispose();for(const e of o.provider)"function"!=typeof e.onDidChangeInlayHints||c.has(e)||(c.add(e),this._sessionDisposables.add(e.onDidChangeInlayHints((()=>{d.isScheduled()||d.schedule()}))));this._sessionDisposables.add(o),this._updateHintsDecorators(o.ranges,o.items),this._cacheHintsForFastRestore(r)}catch(e){s.onUnexpectedError(e)}finally{l.dispose(),t.dispose()}}),this._debounceInfo.get(r));this._sessionDisposables.add(d),this._sessionDisposables.add(n.toDisposable((()=>l?.dispose(!0)))),d.schedule(0),this._sessionDisposables.add(this._editor.onDidScrollChange((e=>{!e.scrollTopChanged&&d.isScheduled()||d.schedule()}))),this._sessionDisposables.add(this._editor.onDidChangeModelContent((e=>{l?.cancel();const t=Math.max(d.delay,1250);d.schedule(t)}))),this._sessionDisposables.add(this._installDblClickGesture((()=>d.schedule(0)))),this._sessionDisposables.add(this._installLinkGesture()),this._sessionDisposables.add(this._installContextMenu())}_installLinkGesture(){const e=new n.DisposableStore,t=e.add(new v.ClickLinkGesture(this._editor)),o=new n.DisposableStore;return e.add(o),e.add(t.onMouseMoveOrRelevantKeyDown((e=>{const[t]=e,s=this._getInlayHintLabelPart(t),r=this._editor.getModel();if(!s||!r)return void o.clear();const a=new i.CancellationTokenSource;o.add(n.toDisposable((()=>a.dispose(!0)))),s.item.resolve(a.token),this._activeInlayHintPart=s.part.command||s.part.location?new T(s,t.hasTriggerModifier):void 0;const l=r.validatePosition(s.item.hint.position).lineNumber,c=new u.Range(l,1,l,r.getLineMaxColumn(l)),d=this._getInlineHintsForRange(c);this._updateHintsDecorators([c],d),o.add(n.toDisposable((()=>{this._activeInlayHintPart=void 0,this._updateHintsDecorators([c],d)})))}))),e.add(t.onCancel((()=>o.clear()))),e.add(t.onExecute((async e=>{const t=this._getInlayHintLabelPart(e);if(t){const o=t.part;o.location?this._instaService.invokeFunction(I.goToDefinitionWithLocation,e,this._editor,o.location):p.Command.is(o.command)&&await this._invokeCommand(o.command,t.item)}}))),e}_getInlineHintsForRange(e){const t=new Set;for(const o of this._decorationsMetadata.values())e.containsRange(o.item.anchor.range)&&t.add(o.item);return Array.from(t)}_installDblClickGesture(e){return this._editor.onMouseUp((async o=>{if(2!==o.event.detail)return;const s=this._getInlayHintLabelPart(o);if(s&&(o.event.preventDefault(),await s.item.resolve(i.CancellationToken.None),t.isNonEmptyArray(s.item.hint.textEdits))){const t=s.item.hint.textEdits.map((e=>m.EditOperation.replace(u.Range.lift(e.range),e.text)));this._editor.executeEdits("inlayHint.default",t),e()}}))}_installContextMenu(){return this._editor.onContextMenu((async t=>{if(!e.isHTMLElement(t.event.target))return;const o=this._getInlayHintLabelPart(t);o&&await this._instaService.invokeFunction(I.showGoToContextMenu,this._editor,t.event.target,o)}))}_getInlayHintLabelPart(e){if(6!==e.target.type)return;const t=e.target.detail.injectedText?.options;return t instanceof _.ModelDecorationInjectedTextOptions&&t?.attachedData instanceof k?t.attachedData:void 0}async _invokeCommand(e,t){try{await this._commandService.executeCommand(e.id,...e.arguments??[])}catch(e){this._notificationService.notify({severity:M.Severity.Error,source:t.provider.displayName,message:e})}}_cacheHintsForFastRestore(e){const t=this._copyInlayHintsWithCurrentAnchor(e);this._inlayHintsCache.set(e,t)}_copyInlayHintsWithCurrentAnchor(e){const t=new Map;for(const[o,i]of this._decorationsMetadata){if(t.has(i.item))continue;const s=e.getDecorationRange(o);if(s){const e=new C.InlayHintAnchor(s,i.item.anchor.direction),o=i.item.with({anchor:e});t.set(i.item,o)}}return Array.from(t.values())}_getHintsRanges(){const e=this._editor.getModel(),t=this._editor.getVisibleRangesPlusViewportAboveBelow(),o=[];for(const i of t.sort(u.Range.compareRangesUsingStarts)){const t=e.validateRange(new u.Range(i.startLineNumber-30,i.startColumn,i.endLineNumber+30,i.endColumn));0!==o.length&&u.Range.areIntersectingOrTouching(o[o.length-1],t)?o[o.length-1]=u.Range.plusRange(o[o.length-1],t):o.push(t)}return o}_updateHintsDecorators(e,o){const i=[],s=(e,t,o,s,n)=>{const r={content:o,inlineClassNameAffectsLetterSpacing:!0,inlineClassName:t.className,cursorStops:s,attachedData:n};i.push({item:e,classNameRef:t,decoration:{range:e.anchor.range,options:{description:"InlayHint",showIfCollapsed:e.anchor.range.isEmpty(),collapseOnReplaceEdit:!e.anchor.range.isEmpty(),stickiness:0,[e.anchor.direction]:0===this._activeRenderMode?r:void 0}}})},n=(e,t)=>{const o=this._ruleFactory.createClassNameRef({width:(r/3|0)+"px",display:"inline-block"});s(e,o," ",t?g.InjectedTextCursorStops.Right:g.InjectedTextCursorStops.None)},{fontSize:r,fontFamily:a,padding:l,isUniform:c}=this._getLayoutInfo(),m="--code-editorInlayHintsFontFamily";this._editor.getContainerDomNode().style.setProperty(m,a);let u={line:0,totalLen:0};for(const e of o){if(u.line!==e.anchor.range.startLineNumber&&(u={line:e.anchor.range.startLineNumber,totalLen:0}),u.totalLen>S._MAX_LABEL_LEN)continue;e.hint.paddingLeft&&n(e,!1);const o="string"==typeof e.hint.label?[{label:e.hint.label}]:e.hint.label;for(let i=0;i<o.length;i++){const n=o[i],a=0===i,d=i===o.length-1,p={fontSize:`${r}px`,fontFamily:`var(${m}), ${h.EDITOR_FONT_DEFAULTS.fontFamily}`,verticalAlign:c?"baseline":"middle",unicodeBidi:"isolate"};t.isNonEmptyArray(e.hint.textEdits)&&(p.cursor="default"),this._fillInColors(p,e.hint),(n.command||n.location)&&this._activeInlayHintPart?.part.item===e&&this._activeInlayHintPart.part.index===i&&(p.textDecoration="underline",this._activeInlayHintPart.hasTriggerModifier&&(p.color=j.themeColorFromId(x.editorActiveLinkForeground),p.cursor="pointer")),l&&(a&&d?(p.padding=`1px ${0|Math.max(1,r/4)}px`,p.borderRadius=(r/4|0)+"px"):a?(p.padding=`1px 0 1px ${0|Math.max(1,r/4)}px`,p.borderRadius=`${r/4|0}px 0 0 ${r/4|0}px`):d?(p.padding=`1px ${0|Math.max(1,r/4)}px 1px 0`,p.borderRadius=`0 ${r/4|0}px ${r/4|0}px 0`):p.padding="1px 0 1px 0");let _=n.label;u.totalLen+=_.length;let f=!1;const y=u.totalLen-S._MAX_LABEL_LEN;if(y>0&&(_=_.slice(0,-y)+"…",f=!0),s(e,this._ruleFactory.createClassNameRef(p),E(_),d&&!e.hint.paddingRight?g.InjectedTextCursorStops.Right:g.InjectedTextCursorStops.None,new k(e,i)),f)break}if(e.hint.paddingRight&&n(e,!0),i.length>S._MAX_DECORATORS)break}const p=[];for(const[t,o]of this._decorationsMetadata){const i=this._editor.getModel()?.getDecorationRange(t);i&&e.some((e=>e.containsRange(i)))&&(p.push(t),o.classNameRef.dispose(),this._decorationsMetadata.delete(t))}const _=d.StableEditorScrollState.capture(this._editor);this._editor.changeDecorations((e=>{const t=e.deltaDecorations(p,i.map((e=>e.decoration)));for(let e=0;e<t.length;e++){const o=i[e];this._decorationsMetadata.set(t[e],o)}})),_.restore(this._editor)}_fillInColors(e,t){t.kind===p.InlayHintKind.Parameter?(e.backgroundColor=j.themeColorFromId(x.editorInlayHintParameterBackground),e.color=j.themeColorFromId(x.editorInlayHintParameterForeground)):t.kind===p.InlayHintKind.Type?(e.backgroundColor=j.themeColorFromId(x.editorInlayHintTypeBackground),e.color=j.themeColorFromId(x.editorInlayHintTypeForeground)):(e.backgroundColor=j.themeColorFromId(x.editorInlayHintBackground),e.color=j.themeColorFromId(x.editorInlayHintForeground))}_getLayoutInfo(){const e=this._editor.getOption(142),t=e.padding,o=this._editor.getOption(52),i=this._editor.getOption(49);let s=e.fontSize;(!s||s<5||s>o)&&(s=o);const n=e.fontFamily||i;return{fontSize:s,fontFamily:n,padding:t,isUniform:!t&&n===i&&s===o}}_removeAllDecorations(){this._editor.removeDecorations(Array.from(this._decorationsMetadata.keys()));for(const e of this._decorationsMetadata.values())e.classNameRef.dispose();this._decorationsMetadata.clear()}},exports.InlayHintsController=S=F([L(1,y.ILanguageFeaturesService),L(2,f.ILanguageFeatureDebounceService),L(3,w),L(4,D.ICommandService),L(5,M.INotificationService),L(6,H.IInstantiationService)],exports.InlayHintsController),D.CommandsRegistry.registerCommand("_executeInlayHintProvider",(async(e,...t)=>{const[o,s]=t;a.assertType(l.URI.isUri(o)),a.assertType(u.Range.isIRange(s));const{inlayHintsProvider:n}=e.get(y.ILanguageFeaturesService),r=await e.get(b.ITextModelService).createModelReference(o);try{const e=await C.InlayHintsFragments.create(n,r.object.textEditorModel,[u.Range.lift(s)],i.CancellationToken.None),t=e.items.map((e=>e.hint));return setTimeout((()=>e.dispose()),0),t}finally{r.dispose()}})),exports.RenderedInlayHintLabelPart=k;
//# sourceMappingURL=inlayHintsController.js.map
