"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var e=require("../../../../../base/browser/domObservable.js"),t=require("../../../../../base/browser/ui/aria/aria.js"),i=require("../../../../../base/common/async.js"),s=require("../../../../../base/common/cancellation.js"),o=require("../../../../../base/common/lifecycle.js"),r=require("../../../../../base/common/observableInternal/base.js"),n=require("../../../../../base/common/observableInternal/derived.js"),a=require("../../../../../base/common/observableInternal/autorun.js"),d=require("../../../../../base/common/observableInternal/utils.js"),l=require("../../../../../base/common/observableInternal/promise.js");require("../../../../../base/common/arrays.js");var c,g=require("../../../../../base/common/types.js"),h=require("../../../../browser/coreCommands.js"),m=require("../../../../browser/observableCodeEditor.js"),u=require("../../../../common/core/position.js"),b=require("../../../../common/services/languageFeatureDebounce.js"),p=require("../../../../common/services/languageFeatures.js"),v=require("./commandIds.js"),_=require("../view/ghostTextView.js"),S=require("./inlineCompletionContextKeys.js"),C=require("../hintsWidget/inlineCompletionsHintsWidget.js"),y=require("../model/inlineCompletionsModel.js"),f=require("../model/suggestWidgetAdaptor.js"),I=require("../../../../../nls.js"),x=require("../../../../../platform/accessibility/common/accessibility.js"),O=require("../../../../../platform/accessibilitySignal/browser/accessibilitySignalService.js"),w=require("../../../../../platform/commands/common/commands.js"),j=require("../../../../../platform/configuration/common/configuration.js"),q=require("../../../../../platform/contextkey/common/contextkey.js"),D=require("../../../../../platform/instantiation/common/instantiation.js"),A=require("../../../../../platform/keybinding/common/keybinding.js"),F=self&&self.__decorate||function(e,t,i,s){var o,r=arguments.length,n=r<3?t:null===s?s=Object.getOwnPropertyDescriptor(t,i):s;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)n=Reflect.decorate(e,t,i,s);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(n=(r<3?o(n):r>3?o(t,i,n):o(t,i))||n);return r>3&&n&&Object.defineProperty(t,i,n),n},T=self&&self.__param||function(e,t){return function(i,s){t(i,s,e)}};exports.InlineCompletionsController=class extends o.Disposable{static{c=this}static{this.ID="editor.contrib.inlineCompletionsController"}static get(e){return e.getContribution(c.ID)}constructor(t,c,b,p,I,x,w,j,q,D){super(),this.editor=t,this._instantiationService=c,this._contextKeyService=b,this._configurationService=p,this._commandService=I,this._debounceService=x,this._languageFeaturesService=w,this._accessibilitySignalService=j,this._keybindingService=q,this._accessibilityService=D,this._editorObs=m.observableCodeEditor(this.editor),this._positions=n.derived(this,(e=>this._editorObs.selections.read(e)?.map((e=>e.getEndPosition()))??[new u.Position(1,1)])),this._suggestWidgetAdaptor=this._register(new f.SuggestWidgetAdaptor(this.editor,(()=>(this._editorObs.forceUpdate(),this.model.get()?.selectedInlineCompletion.get()?.toSingleTextEdit(void 0))),(e=>this._editorObs.forceUpdate((t=>{this.model.get()?.handleSuggestAccepted(e)}))))),this._suggestWidgetSelectedItem=d.observableFromEvent(this,(e=>this._suggestWidgetAdaptor.onDidSelectedItemChange((()=>{this._editorObs.forceUpdate((t=>e(void 0)))}))),(()=>this._suggestWidgetAdaptor.selectedItem)),this._enabledInConfig=d.observableFromEvent(this,this.editor.onDidChangeConfiguration,(()=>this.editor.getOption(62).enabled)),this._isScreenReaderEnabled=d.observableFromEvent(this,this._accessibilityService.onDidChangeScreenReaderOptimized,(()=>this._accessibilityService.isScreenReaderOptimized())),this._editorDictationInProgress=d.observableFromEvent(this,this._contextKeyService.onDidChangeContext,(()=>!0===this._contextKeyService.getContext(this.editor.getDomNode()).getValue("editorDictation.inProgress"))),this._enabled=n.derived(this,(e=>this._enabledInConfig.read(e)&&(!this._isScreenReaderEnabled.read(e)||!this._editorDictationInProgress.read(e)))),this._debounceValue=this._debounceService.for(this._languageFeaturesService.inlineCompletionsProvider,"InlineCompletionsDebounce",{min:50,max:50}),this.model=n.derivedDisposable(this,(e=>{if(this._editorObs.isReadonly.read(e))return;const t=this._editorObs.model.read(e);if(!t)return;return this._instantiationService.createInstance(y.InlineCompletionsModel,t,this._suggestWidgetSelectedItem,this._editorObs.versionId,this._positions,this._debounceValue,d.observableFromEvent(this.editor.onDidChangeConfiguration,(()=>this.editor.getOption(119).preview)),d.observableFromEvent(this.editor.onDidChangeConfiguration,(()=>this.editor.getOption(119).previewMode)),d.observableFromEvent(this.editor.onDidChangeConfiguration,(()=>this.editor.getOption(62).mode)),this._enabled)})).recomputeInitiallyAndOnChange(this._store),this._ghostTexts=n.derived(this,(e=>{const t=this.model.read(e);return t?.ghostTexts.read(e)??[]})),this._stablizedGhostTexts=function(e,t){const i=r.observableValue("result",[]),s=[];return t.add(a.autorun((t=>{const o=e.read(t);r.transaction((e=>{if(o.length!==s.length){s.length=o.length;for(let e=0;e<s.length;e++)s[e]||(s[e]=r.observableValue("item",o[e]));i.set([...s],e)}s.forEach(((t,i)=>t.set(o[i],e)))}))}))),i}(this._ghostTexts,this._store),this._ghostTextWidgets=d.mapObservableArrayCached(this,this._stablizedGhostTexts,((e,t)=>t.add(this._instantiationService.createInstance(_.GhostTextView,this.editor,{ghostText:e,minReservedLineCount:d.constObservable(0),targetTextModel:this.model.map((e=>e?.textModel))})))).recomputeInitiallyAndOnChange(this._store),this._playAccessibilitySignal=d.observableSignal(this),this._fontFamily=d.observableFromEvent(this,this.editor.onDidChangeConfiguration,(()=>this.editor.getOption(62).fontFamily)),this._register(new S.InlineCompletionContextKeys(this._contextKeyService,this.model)),this._register(m.reactToChange(this._editorObs.onDidType,((e,t)=>{this._enabled.get()&&this.model.get()?.trigger()}))),this._register(this._commandService.onDidExecuteCommand((e=>{new Set([h.CoreEditingCommands.Tab.id,h.CoreEditingCommands.DeleteLeft.id,h.CoreEditingCommands.DeleteRight.id,v.inlineSuggestCommitId,"acceptSelectedSuggestion"]).has(e.commandId)&&t.hasTextFocus()&&this._enabled.get()&&this._editorObs.forceUpdate((e=>{this.model.get()?.trigger(e)}))}))),this._register(m.reactToChange(this._editorObs.selections,((e,t)=>{t.some((e=>3===e.reason||"api"===e.source))&&this.model.get()?.stop()}))),this._register(this.editor.onDidBlurEditorWidget((()=>{this._contextKeyService.getContextKeyValue("accessibleViewIsShown")||this._configurationService.getValue("editor.inlineSuggest.keepOnBlur")||t.getOption(62).keepOnBlur||C.InlineSuggestionHintsContentWidget.dropDownVisible||r.transaction((e=>{this.model.get()?.stop(e)}))}))),this._register(a.autorun((e=>{const t=this.model.read(e)?.state.read(e);t?.suggestItem?t.primaryGhostText.lineCount>=2&&this._suggestWidgetAdaptor.forceRenderingAbove():this._suggestWidgetAdaptor.stopForceRenderingAbove()}))),this._register(o.toDisposable((()=>{this._suggestWidgetAdaptor.stopForceRenderingAbove()})));const A=d.derivedObservableWithCache(this,((e,t)=>{const i=this.model.read(e),s=i?.state.read(e);return this._suggestWidgetSelectedItem.get()?t:s?.inlineCompletion?.semanticId}));this._register(m.reactToChangeWithStore(n.derived((e=>(this._playAccessibilitySignal.read(e),A.read(e),{}))),(async(e,t,o)=>{const r=this.model.get(),n=r?.state.get();if(!n||!r)return;const a=r.textModel.getLineContent(n.primaryGhostText.lineNumber);await i.timeout(50,s.cancelOnDispose(o)),await l.waitForState(this._suggestWidgetSelectedItem,g.isUndefined,(()=>!1),s.cancelOnDispose(o)),await this._accessibilitySignalService.playSignal(O.AccessibilitySignal.inlineSuggestion),this.editor.getOption(8)&&this._provideScreenReaderUpdate(n.primaryGhostText.renderForScreenReader(a))}))),this._register(new C.InlineCompletionsHintsWidget(this.editor,this.model,this._instantiationService)),this._register(e.createStyleSheetFromObservable(n.derived((e=>{const t=this._fontFamily.read(e);return""===t||"default"===t?"":`\n.monaco-editor .ghost-text-decoration,\n.monaco-editor .ghost-text-decoration-preview,\n.monaco-editor .ghost-text {\n\tfont-family: ${t};\n}`})))),this._register(this._configurationService.onDidChangeConfiguration((e=>{e.affectsConfiguration("accessibility.verbosity.inlineCompletions")&&this.editor.updateOptions({inlineCompletionsAccessibilityVerbose:this._configurationService.getValue("accessibility.verbosity.inlineCompletions")})}))),this.editor.updateOptions({inlineCompletionsAccessibilityVerbose:this._configurationService.getValue("accessibility.verbosity.inlineCompletions")})}playAccessibilitySignal(e){this._playAccessibilitySignal.trigger(e)}_provideScreenReaderUpdate(e){const i=this._contextKeyService.getContextKeyValue("accessibleViewIsShown"),s=this._keybindingService.lookupKeybinding("editor.action.accessibleView");let o;!i&&s&&this.editor.getOption(150)&&(o=I.localize("showAccessibleViewHint","Inspect this in the accessible view ({0})",s.getAriaLabel())),t.alert(o?e+", "+o:e)}shouldShowHoverAt(e){const t=this.model.get()?.primaryGhostText.get();return!!t&&t.parts.some((i=>e.containsPosition(new u.Position(t.lineNumber,i.column))))}shouldShowHoverAtViewZone(e){return this._ghostTextWidgets.get()[0]?.ownsViewZone(e)??!1}},exports.InlineCompletionsController=c=F([T(1,D.IInstantiationService),T(2,q.IContextKeyService),T(3,j.IConfigurationService),T(4,w.ICommandService),T(5,b.ILanguageFeatureDebounceService),T(6,p.ILanguageFeaturesService),T(7,O.IAccessibilitySignalService),T(8,A.IKeybindingService),T(9,x.IAccessibilityService)],exports.InlineCompletionsController);
//# sourceMappingURL=inlineCompletionsController.js.map
