"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var e=require("../../../../../base/common/cancellation.js"),t=require("../../../../../base/common/equals.js"),i=require("../../../../../base/common/filters.js"),n=require("../../../../../base/common/lifecycle.js"),o=require("../../../../../base/common/observableInternal/base.js"),s=require("../../../../../base/common/observableInternal/derived.js");require("../../../../../base/common/observableInternal/autorun.js"),require("../../../../../base/common/observableInternal/utils.js"),require("../../../../../base/common/errors.js");var r=require("../../../../common/core/range.js"),a=require("../../../../common/core/textEdit.js"),l=require("../../../../common/core/textLength.js"),u=require("../../../../common/languages.js"),d=require("../../../../common/languages/languageConfigurationRegistry.js"),c=require("../../../../common/services/languageFeatures.js"),p=require("./provideInlineCompletions.js"),g=require("./singleTextEdit.js"),h=self&&self.__decorate||function(e,t,i,n){var o,s=arguments.length,r=s<3?t:null===n?n=Object.getOwnPropertyDescriptor(t,i):n;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,i,n);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,i,r):o(t,i))||r);return s>3&&r&&Object.defineProperty(t,i,r),r},m=self&&self.__param||function(e,t){return function(i,n){t(i,n,e)}};exports.InlineCompletionsSource=class extends n.Disposable{constructor(e,t,i,s,r){super(),this.textModel=e,this.versionId=t,this._debounceValue=i,this.languageFeaturesService=s,this.languageConfigurationService=r,this._updateOperation=this._register(new n.MutableDisposable),this.inlineCompletions=o.disposableObservableValue("inlineCompletions",void 0),this.suggestWidgetInlineCompletions=o.disposableObservableValue("suggestWidgetInlineCompletions",void 0),this._register(this.textModel.onDidChangeContent((()=>{this._updateOperation.clear()})))}fetch(t,i,n){const s=new C(t,i,this.textModel.getVersionId()),r=i.selectedSuggestionInfo?this.suggestWidgetInlineCompletions:this.inlineCompletions;if(this._updateOperation.value?.request.satisfies(s))return this._updateOperation.value.promise;if(r.get()?.request.satisfies(s))return Promise.resolve(!0);const a=!!this._updateOperation.value;this._updateOperation.clear();const l=new e.CancellationTokenSource,d=(async()=>{var e,d;if((a||i.triggerKind===u.InlineCompletionTriggerKind.Automatic)&&await(e=this._debounceValue.get(this.textModel),d=l.token,new Promise((t=>{let i;const n=setTimeout((()=>{i&&i.dispose(),t()}),e);d&&(i=d.onCancellationRequested((()=>{clearTimeout(n),i&&i.dispose(),t()})))}))),l.token.isCancellationRequested||this._store.isDisposed||this.textModel.getVersionId()!==s.versionId)return!1;const c=new Date,g=await p.provideInlineCompletions(this.languageFeaturesService.inlineCompletionsProvider,t,this.textModel,i,l.token,this.languageConfigurationService);if(l.token.isCancellationRequested||this._store.isDisposed||this.textModel.getVersionId()!==s.versionId)return!1;const h=new Date;this._debounceValue.update(this.textModel,h.getTime()-c.getTime());const m=new f(g,s,this.textModel,this.versionId);if(n){const e=n.toInlineCompletion(void 0);n.canBeReused(this.textModel,t)&&!g.has(e)&&m.prepend(n.inlineCompletion,e.range,!0)}return this._updateOperation.clear(),o.transaction((e=>{r.set(m,e)})),!0})(),c=new _(s,l,d);return this._updateOperation.value=c,d}clear(e){this._updateOperation.clear(),this.inlineCompletions.set(void 0,e),this.suggestWidgetInlineCompletions.set(void 0,e)}clearSuggestWidgetInlineCompletions(e){this._updateOperation.value?.request.context.selectedSuggestionInfo&&this._updateOperation.clear(),this.suggestWidgetInlineCompletions.set(void 0,e)}cancelUpdate(){this._updateOperation.clear()}},exports.InlineCompletionsSource=h([m(3,c.ILanguageFeaturesService),m(4,d.ILanguageConfigurationService)],exports.InlineCompletionsSource);class C{constructor(e,t,i){this.position=e,this.context=t,this.versionId=i}satisfies(e){return this.position.equals(e.position)&&t.equalsIfDefined(this.context.selectedSuggestionInfo,e.context.selectedSuggestionInfo,t.itemEquals())&&(e.context.triggerKind===u.InlineCompletionTriggerKind.Automatic||this.context.triggerKind===u.InlineCompletionTriggerKind.Explicit)&&this.versionId===e.versionId}}class _{constructor(e,t,i){this.request=e,this.cancellationTokenSource=t,this.promise=i}dispose(){this.cancellationTokenSource.cancel()}}class f{get inlineCompletions(){return this._inlineCompletions}constructor(e,t,i,n){this.inlineCompletionProviderResult=e,this.request=t,this._textModel=i,this._versionId=n,this._refCount=1,this._prependedInlineCompletionItems=[];const o=i.deltaDecorations([],e.completions.map((e=>({range:e.range,options:{description:"inline-completion-tracking-range"}}))));this._inlineCompletions=e.completions.map(((e,t)=>new I(e,o[t],this._textModel,this._versionId)))}clone(){return this._refCount++,this}dispose(){if(this._refCount--,0===this._refCount){setTimeout((()=>{this._textModel.isDisposed()||this._textModel.deltaDecorations(this._inlineCompletions.map((e=>e.decorationId)),[])}),0),this.inlineCompletionProviderResult.dispose();for(const e of this._prependedInlineCompletionItems)e.source.removeRef()}}prepend(e,t,i){i&&e.source.addRef();const n=this._textModel.deltaDecorations([],[{range:t,options:{description:"inline-completion-tracking-range"}}])[0];this._inlineCompletions.unshift(new I(e,n,this._textModel,this._versionId)),this._prependedInlineCompletionItems.push(e)}}class I{get forwardStable(){return this.inlineCompletion.source.inlineCompletions.enableForwardStability??!1}constructor(e,t,i,n){this.inlineCompletion=e,this.decorationId=t,this._textModel=i,this._modelVersion=n,this.semanticId=JSON.stringify([this.inlineCompletion.filterText,this.inlineCompletion.insertText,this.inlineCompletion.range.getStartPosition().toString()]),this._updatedRange=s.derivedOpts({owner:this,equalsFn:r.Range.equalsRange},(e=>(this._modelVersion.read(e),this._textModel.getDecorationRange(this.decorationId))))}toInlineCompletion(e){return this.inlineCompletion.withRange(this._updatedRange.read(e)??v)}toSingleTextEdit(e){return new a.SingleTextEdit(this._updatedRange.read(e)??v,this.inlineCompletion.insertText)}isVisible(e,t,n){const o=g.singleTextRemoveCommonPrefix(this._toFilterTextReplacement(n),e),s=this._updatedRange.read(n);if(!s||!this.inlineCompletion.range.getStartPosition().equals(s.getStartPosition())||t.lineNumber!==o.range.startLineNumber)return!1;const r=e.getValueInRange(o.range,1),a=o.text,l=Math.max(0,t.column-o.range.startColumn);let u=a.substring(0,l),d=a.substring(l),c=r.substring(0,l),p=r.substring(l);const h=e.getLineIndentColumn(o.range.startLineNumber);return o.range.startColumn<=h&&(c=c.trimStart(),0===c.length&&(p=p.trimStart()),u=u.trimStart(),0===u.length&&(d=d.trimStart())),u.startsWith(c)&&!!i.matchesSubString(p,d)}canBeReused(e,t){const i=this._updatedRange.read(void 0);return!!i&&i.containsPosition(t)&&this.isVisible(e,t,void 0)&&l.TextLength.ofRange(i).isGreaterThanOrEqualTo(l.TextLength.ofRange(this.inlineCompletion.range))}_toFilterTextReplacement(e){return new a.SingleTextEdit(this._updatedRange.read(e)??v,this.inlineCompletion.filterText)}}const v=new r.Range(1,1,1,1);exports.InlineCompletionWithUpdatedRange=I,exports.UpToDateInlineCompletions=f;
//# sourceMappingURL=inlineCompletionsSource.js.map
