"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var e=require("../../../../../base/browser/trustedTypes.js"),t=require("../../../../../base/common/event.js"),i=require("../../../../../base/common/lifecycle.js"),n=require("../../../../../base/common/observableInternal/base.js"),o=require("../../../../../base/common/observableInternal/derived.js"),s=require("../../../../../base/common/observableInternal/autorun.js"),r=require("../../../../../base/common/observableInternal/utils.js");require("../../../../../base/common/errors.js"),require("../../../../../base/common/arrays.js");var a=require("../../../../../base/common/strings.js");require("./ghostTextView.css.js");var d=require("../../../../browser/config/domFontInfo.js"),l=require("../../../../common/config/editorOptions.js"),c=require("../../../../common/core/position.js"),h=require("../../../../common/core/range.js"),u=require("../../../../common/core/stringBuilder.js"),g=require("../../../../common/languages/language.js"),p=require("../../../../common/model.js"),m=require("../../../../common/tokens/lineTokens.js"),v=require("../../../../common/viewLayout/lineDecorations.js"),b=require("../../../../common/viewLayout/viewLineRenderer.js"),f=require("../model/ghostText.js"),w=require("../utils.js"),x=self&&self.__decorate||function(e,t,i,n){var o,s=arguments.length,r=s<3?t:null===n?n=Object.getOwnPropertyDescriptor(t,i):n;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,i,n);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(r=(s<3?o(r):s>3?o(t,i,r):o(t,i))||r);return s>3&&r&&Object.defineProperty(t,i,r),r},L=self&&self.__param||function(e,t){return function(i,n){t(i,n,e)}};const C="ghost-text";exports.GhostTextView=class extends i.Disposable{constructor(e,t,s){super(),this.editor=e,this.model=t,this.languageService=s,this.isDisposed=n.observableValue(this,!1),this.currentTextModel=r.observableFromEvent(this,this.editor.onDidChangeModel,(()=>this.editor.getModel())),this.uiState=o.derived(this,(e=>{if(this.isDisposed.read(e))return;const t=this.currentTextModel.read(e);if(t!==this.model.targetTextModel.read(e))return;const i=this.model.ghostText.read(e);if(!i)return;const n=i instanceof f.GhostTextReplacement?i.columnRange:void 0,o=[],s=[];function r(e,t){if(s.length>0){const i=s[s.length-1];t&&i.decorations.push(new v.LineDecoration(i.content.length+1,i.content.length+1+e[0].length,t,0)),i.content+=e[0],e=e.slice(1)}for(const i of e)s.push({content:i,decorations:t?[new v.LineDecoration(1,i.length+1,t,0)]:[]})}const a=t.getLineContent(i.lineNumber);let d,l=0;for(const e of i.parts){let t=e.lines;void 0===d?(o.push({column:e.column,text:t[0],preview:e.preview}),t=t.slice(1)):r([a.substring(l,e.column-1)],void 0),t.length>0&&(r(t,C),void 0===d&&e.column<=a.length&&(d=e.column)),l=e.column-1}void 0!==d&&r([a.substring(l)],void 0);const c=void 0!==d?new w.ColumnRange(d,a.length+1):void 0;return{replacedRange:n,inlineTexts:o,additionalLines:s,hiddenRange:c,lineNumber:i.lineNumber,additionalReservedLineCount:this.model.minReservedLineCount.read(e),targetTextModel:t}})),this.decorations=o.derived(this,(e=>{const t=this.uiState.read(e);if(!t)return[];const i=[];t.replacedRange&&i.push({range:t.replacedRange.toRange(t.lineNumber),options:{inlineClassName:"inline-completion-text-to-replace",description:"GhostTextReplacement"}}),t.hiddenRange&&i.push({range:t.hiddenRange.toRange(t.lineNumber),options:{inlineClassName:"ghost-text-hidden",description:"ghost-text-hidden"}});for(const e of t.inlineTexts)i.push({range:h.Range.fromPositions(new c.Position(t.lineNumber,e.column)),options:{description:C,after:{content:e.text,inlineClassName:e.preview?"ghost-text-decoration-preview":"ghost-text-decoration",cursorStops:p.InjectedTextCursorStops.Left},showIfCollapsed:!0}});return i})),this.additionalLinesWidget=this._register(new T(this.editor,this.languageService.languageIdCodec,o.derived((e=>{const t=this.uiState.read(e);return t?{lineNumber:t.lineNumber,additionalLines:t.additionalLines,minReservedLineCount:t.additionalReservedLineCount,targetTextModel:t.targetTextModel}:void 0})))),this._register(i.toDisposable((()=>{this.isDisposed.set(!0,void 0)}))),this._register(w.applyObservableDecorations(this.editor,this.decorations))}ownsViewZone(e){return this.additionalLinesWidget.viewZoneId===e}},exports.GhostTextView=x([L(2,g.ILanguageService)],exports.GhostTextView);class T extends i.Disposable{get viewZoneId(){return this._viewZoneId}constructor(e,i,n){super(),this.editor=e,this.languageIdCodec=i,this.lines=n,this._viewZoneId=void 0,this.editorOptionsChanged=r.observableSignalFromEvent("editorOptionChanged",t.Event.filter(this.editor.onDidChangeConfiguration,(e=>e.hasChanged(33)||e.hasChanged(118)||e.hasChanged(100)||e.hasChanged(95)||e.hasChanged(51)||e.hasChanged(50)||e.hasChanged(67)))),this._register(s.autorun((e=>{const t=this.lines.read(e);this.editorOptionsChanged.read(e),t?this.updateLines(t.lineNumber,t.additionalLines,t.minReservedLineCount):this.clear()})))}dispose(){super.dispose(),this.clear()}clear(){this.editor.changeViewZones((e=>{this._viewZoneId&&(e.removeZone(this._viewZoneId),this._viewZoneId=void 0)}))}updateLines(e,t,i){const n=this.editor.getModel();if(!n)return;const{tabSize:o}=n.getOptions();this.editor.changeViewZones((n=>{this._viewZoneId&&(n.removeZone(this._viewZoneId),this._viewZoneId=void 0);const s=Math.max(t.length,i);if(s>0){const i=document.createElement("div");!function(e,t,i,n,o){const s=n.get(33),r=n.get(118),c="none",h=n.get(95),g=n.get(51),p=n.get(50),v=n.get(67),f=new u.StringBuilder(1e4);f.appendString('<div class="suggest-preview-text">');for(let e=0,n=i.length;e<n;e++){const n=i[e],d=n.content;f.appendString('<div class="view-line'),f.appendString('" style="top:'),f.appendString(String(e*v)),f.appendString('px;width:1000000px;">');const u=a.isBasicASCII(d),w=a.containsRTL(d),x=m.LineTokens.createEmpty(d,o);b.renderViewLine(new b.RenderLineInput(p.isMonospace&&!s,p.canUseHalfwidthRightwardsArrow,d,!1,u,w,0,x,n.decorations,t,0,p.spaceWidth,p.middotWidth,p.wsmiddotWidth,r,c,h,g!==l.EditorFontLigatures.OFF,null),f),f.appendString("</div>")}f.appendString("</div>"),d.applyFontInfo(e,p);const w=f.build(),x=I?I.createHTML(w):w;e.innerHTML=x}(i,o,t,this.editor.getOptions(),this.languageIdCodec),this._viewZoneId=n.addZone({afterLineNumber:e,heightInLines:s,domNode:i,afterColumnAffinity:1})}}))}}const I=e.createTrustedTypesPolicy("editorGhostText",{createHTML:e=>e});exports.AdditionalLinesWidget=T,exports.GHOST_TEXT_DESCRIPTION=C,exports.ttPolicy=I;
//# sourceMappingURL=ghostTextView.js.map
