"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var e=require("../../../../base/common/lifecycle.js"),t=require("../../../../base/common/observableInternal/base.js"),i=require("../../../../base/common/observableInternal/derived.js"),n=require("../../../../base/common/observableInternal/autorun.js"),r=require("../../../../base/common/observableInternal/utils.js"),s=require("../../../../base/common/errors.js");require("../../../../base/common/arrays.js");var o,a=require("../../../common/core/editOperation.js"),d=require("../../../common/core/position.js"),c=require("../../../common/core/range.js"),l=require("./ghostTextWidget.js"),u=require("../../../../platform/contextkey/common/contextkey.js"),h=require("../../../../platform/instantiation/common/instantiation.js"),g=require("../../../common/languages.js"),m=require("../../../common/services/languageFeatures.js"),v=require("../../../../base/common/cancellation.js"),b=require("../../inlineCompletions/browser/model/ghostText.js"),E=require("../../../../platform/commands/common/commands.js"),C=require("./inlineEditHintsWidget.js"),f=require("../../../../base/browser/dom.js"),_=require("../../../../platform/configuration/common/configuration.js"),p=require("./inlineEditSideBySideWidget.js"),I=require("../../../browser/widget/diffEditor/diffProviderFactoryService.js"),x=require("../../../common/services/model.js"),S=self&&self.__decorate||function(e,t,i,n){var r,s=arguments.length,o=s<3?t:null===n?n=Object.getOwnPropertyDescriptor(t,i):n;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)o=Reflect.decorate(e,t,i,n);else for(var a=e.length-1;a>=0;a--)(r=e[a])&&(o=(s<3?r(o):s>3?r(t,i,o):r(t,i))||o);return s>3&&o&&Object.defineProperty(t,i,o),o},y=self&&self.__param||function(e,t){return function(i,n){t(i,n,e)}};exports.InlineEditController=class extends e.Disposable{static{o=this}static{this.ID="editor.contrib.inlineEditController"}static{this.inlineEditVisibleKey="inlineEditVisible"}static{this.inlineEditVisibleContext=new u.RawContextKey(this.inlineEditVisibleKey,!1)}static{this.cursorAtInlineEditKey="cursorAtInlineEdit"}static{this.cursorAtInlineEditContext=new u.RawContextKey(this.cursorAtInlineEditKey,!1)}static get(e){return e.getContribution(o.ID)}constructor(e,s,a,d,c,u,h,g){super(),this.editor=e,this.instantiationService=s,this.contextKeyService=a,this.languageFeaturesService=d,this._commandService=c,this._configurationService=u,this._diffProviderFactoryService=h,this._modelService=g,this._isVisibleContext=o.inlineEditVisibleContext.bindTo(this.contextKeyService),this._isCursorAtInlineEditContext=o.cursorAtInlineEditContext.bindTo(this.contextKeyService),this._currentEdit=t.observableValue(this,void 0),this._currentWidget=i.derivedDisposable(this._currentEdit,(e=>{const t=this._currentEdit.read(e);if(!t)return;const i=t.range.endLineNumber,n=t.range.endColumn,s=!t.text.endsWith("\n")||t.range.startLineNumber===t.range.endLineNumber&&t.range.startColumn===t.range.endColumn?t.text:t.text.slice(0,-1),o=new b.GhostText(i,[new b.GhostTextPart(n,s,!1)]),a=t.range.startLineNumber===t.range.endLineNumber&&1===o.parts.length&&1===o.parts[0].lines.length,d=""===t.text;if(!a&&!d)return;return this.instantiationService.createInstance(l.GhostTextWidget,this.editor,{ghostText:r.constObservable(o),minReservedLineCount:r.constObservable(0),targetTextModel:r.constObservable(this.editor.getModel()??void 0),range:r.constObservable(t.range)})})),this._isAccepting=t.observableValue(this,!1),this._enabled=r.observableFromEvent(this,this.editor.onDidChangeConfiguration,(()=>this.editor.getOption(63).enabled)),this._fontFamily=r.observableFromEvent(this,this.editor.onDidChangeConfiguration,(()=>this.editor.getOption(63).fontFamily));const m=r.observableSignalFromEvent("InlineEditController.modelContentChangedSignal",e.onDidChangeModelContent);this._register(n.autorun((t=>{this._enabled.read(t)&&(m.read(t),this._isAccepting.read(t)||this.getInlineEdit(e,!0))})));const v=r.observableFromEvent(this,e.onDidChangeCursorPosition,(()=>e.getPosition()));this._register(n.autorun((e=>{if(!this._enabled.read(e))return;const t=v.read(e);t&&this.checkCursorPosition(t)}))),this._register(n.autorun((t=>{const i=this._currentEdit.read(t);if(this._isCursorAtInlineEditContext.set(!1),!i)return void this._isVisibleContext.set(!1);this._isVisibleContext.set(!0);const n=e.getPosition();n&&this.checkCursorPosition(n)})));const E=r.observableSignalFromEvent("InlineEditController.editorBlurSignal",e.onDidBlurEditorWidget);this._register(n.autorun((async t=>{this._enabled.read(t)&&(E.read(t),this._configurationService.getValue("editor.experimentalInlineEdit.keepOnBlur")||e.getOption(63).keepOnBlur||(this._currentRequestCts?.dispose(!0),this._currentRequestCts=void 0,await this.clear(!1)))})));const _=r.observableSignalFromEvent("InlineEditController.editorFocusSignal",e.onDidFocusEditorText);this._register(n.autorun((t=>{this._enabled.read(t)&&(_.read(t),this.getInlineEdit(e,!0))})));const I=this._register(f.createStyleSheet2());this._register(n.autorun((e=>{const t=this._fontFamily.read(e);I.setStyle(""===t||"default"===t?"":`\n.monaco-editor .inline-edit-decoration,\n.monaco-editor .inline-edit-decoration-preview,\n.monaco-editor .inline-edit {\n\tfont-family: ${t};\n}`)}))),this._register(new C.InlineEditHintsWidget(this.editor,this._currentWidget,this.instantiationService)),this._register(new p.InlineEditSideBySideWidget(this.editor,this._currentEdit,this.instantiationService,this._diffProviderFactoryService,this._modelService))}checkCursorPosition(e){if(!this._currentEdit)return void this._isCursorAtInlineEditContext.set(!1);const t=this._currentEdit.get();t?this._isCursorAtInlineEditContext.set(c.Range.containsPosition(t.range,e)):this._isCursorAtInlineEditContext.set(!1)}validateInlineEdit(e,t){if(t.text.includes("\n")&&t.range.startLineNumber!==t.range.endLineNumber&&t.range.startColumn!==t.range.endColumn){if(1!==t.range.startColumn)return!1;const i=t.range.endLineNumber;if(t.range.endColumn!==(e.getModel()?.getLineLength(i)??0)+1)return!1}return!0}async fetchInlineEdit(e,t){this._currentRequestCts&&this._currentRequestCts.dispose(!0);const i=e.getModel();if(!i)return;const n=i.getVersionId(),r=this.languageFeaturesService.inlineEditProvider.all(i);if(0===r.length)return;const s=r[0];this._currentRequestCts=new v.CancellationTokenSource;const o=this._currentRequestCts.token,a=t?g.InlineEditTriggerKind.Automatic:g.InlineEditTriggerKind.Invoke;var d,c;if(t&&await(d=50,c=o,new Promise((e=>{let t;const i=setTimeout((()=>{t&&t.dispose(),e()}),d);c&&(t=c.onCancellationRequested((()=>{clearTimeout(i),t&&t.dispose(),e()})))}))),o.isCancellationRequested||i.isDisposed()||i.getVersionId()!==n)return;const l=await s.provideInlineEdit(i,{triggerKind:a},o);return l&&!o.isCancellationRequested&&!i.isDisposed()&&i.getVersionId()===n&&this.validateInlineEdit(e,l)?l:void 0}async getInlineEdit(e,t){this._isCursorAtInlineEditContext.set(!1),await this.clear();const i=await this.fetchInlineEdit(e,t);i&&this._currentEdit.set(i,void 0)}async trigger(){await this.getInlineEdit(this.editor,!1)}async jumpBack(){this._jumpBackPosition&&(this.editor.setPosition(this._jumpBackPosition),this.editor.revealPositionInCenterIfOutsideViewport(this._jumpBackPosition))}async accept(){this._isAccepting.set(!0,void 0);const e=this._currentEdit.get();if(!e)return;let i=e.text;e.text.startsWith("\n")&&(i=e.text.substring(1)),this.editor.pushUndoStop(),this.editor.executeEdits("acceptCurrent",[a.EditOperation.replace(c.Range.lift(e.range),i)]),e.accepted&&await this._commandService.executeCommand(e.accepted.id,...e.accepted.arguments||[]).then(void 0,s.onUnexpectedExternalError),this.freeEdit(e),t.transaction((e=>{this._currentEdit.set(void 0,e),this._isAccepting.set(!1,e)}))}jumpToCurrent(){this._jumpBackPosition=this.editor.getSelection()?.getStartPosition();const e=this._currentEdit.get();if(!e)return;const t=d.Position.lift({lineNumber:e.range.startLineNumber,column:e.range.startColumn});this.editor.setPosition(t),this.editor.revealPositionInCenterIfOutsideViewport(t)}async clear(e=!0){const t=this._currentEdit.get();t&&t?.rejected&&e&&await this._commandService.executeCommand(t.rejected.id,...t.rejected.arguments||[]).then(void 0,s.onUnexpectedExternalError),t&&this.freeEdit(t),this._currentEdit.set(void 0,void 0)}freeEdit(e){const t=this.editor.getModel();if(!t)return;const i=this.languageFeaturesService.inlineEditProvider.all(t);0!==i.length&&i[0].freeInlineEdit(e)}},exports.InlineEditController=o=S([y(1,h.IInstantiationService),y(2,u.IContextKeyService),y(3,m.ILanguageFeaturesService),y(4,E.ICommandService),y(5,_.IConfigurationService),y(6,I.IDiffProviderFactoryService),y(7,x.IModelService)],exports.InlineEditController);
//# sourceMappingURL=inlineEditController.js.map
