"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var e=require("../../../../base/common/async.js"),i=require("../../../../base/common/cancellation.js"),t=require("../../../../base/common/equals.js"),s=require("../../../../base/common/errors.js"),n=require("../../../../base/common/lifecycle.js"),o=require("../../../../base/common/observableInternal/base.js"),r=require("../../../../base/common/observableInternal/derived.js");require("../../../../base/common/observableInternal/autorun.js");var l,d=require("../../../../base/common/observableInternal/utils.js"),a=require("../../../../base/common/observableInternal/promise.js"),c=require("../../../../base/common/uri.js"),h=require("../../../browser/widget/diffEditor/diffProviderFactoryService.js"),m=require("../../../common/core/lineRange.js"),u=require("../../../common/languages.js"),p=require("../../../common/services/languageFeatures.js"),g=require("../../../common/services/model.js"),_=require("../../inlineCompletions/browser/model/provideInlineCompletions.js"),v=require("./inlineEditsWidget.js"),I=self&&self.__decorate||function(e,i,t,s){var n,o=arguments.length,r=o<3?i:null===s?s=Object.getOwnPropertyDescriptor(i,t):s;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,i,t,s);else for(var l=e.length-1;l>=0;l--)(n=e[l])&&(r=(o<3?n(r):o>3?n(i,t,r):n(i,t))||r);return o>3&&r&&Object.defineProperty(i,t,r),r},f=self&&self.__param||function(e,i){return function(t,s){i(t,s,e)}};exports.InlineEditsModel=class extends n.Disposable{static{l=this}static{this._modelId=0}static _createUniqueUri(){return c.URI.from({scheme:"inline-edits",path:(new Date).toString()+String(l._modelId++)})}constructor(s,c,h,p,g,I,f){super(),this.textModel=s,this._textModelVersionId=c,this._selection=h,this._debounceValue=p,this.languageFeaturesService=g,this._diffProviderFactoryService=I,this._modelService=f,this._forceUpdateExplicitlySignal=d.observableSignal(this),this._selectedInlineCompletionId=o.observableValue(this,void 0),this._isActive=o.observableValue(this,!1),this._originalModel=r.derivedDisposable((()=>this._modelService.createModel("",null,l._createUniqueUri()))).keepObserved(this._store),this._modifiedModel=r.derivedDisposable((()=>this._modelService.createModel("",null,l._createUniqueUri()))).keepObserved(this._store),this._pinnedRange=new E(this.textModel,this._textModelVersionId),this.isPinned=this._pinnedRange.range.map((e=>!!e)),this.userPrompt=o.observableValue(this,void 0),this.inlineEdit=r.derived(this,(e=>this._inlineEdit.read(e)?.promiseResult.read(e)?.data)),this._inlineEdit=r.derived(this,(e=>{const t=this.selectedInlineEdit.read(e);if(!t)return;const s=t.inlineCompletion.range;if(""===t.inlineCompletion.insertText.trim())return;let n=t.inlineCompletion.insertText.split(/\r\n|\r|\n/);function o(e){const i=e[0].match(/^\s*/)?.[0]??"";return e.map((e=>e.replace(new RegExp("^"+i),"")))}n=o(n);let r=this.textModel.getValueInRange(s).split(/\r\n|\r|\n/);r=o(r),this._originalModel.get().setValue(r.join("\n")),this._modifiedModel.get().setValue(n.join("\n"));const l=this._diffProviderFactoryService.createDiffProvider({diffAlgorithm:"advanced"});return a.ObservablePromise.fromFn((async()=>{const e=await l.computeDiff(this._originalModel.get(),this._modifiedModel.get(),{computeMoves:!1,ignoreTrimWhitespace:!1,maxComputationTimeMs:1e3},i.CancellationToken.None);if(!e.identical)return new v.InlineEdit(m.LineRange.fromRangeInclusive(s),o(n),e.changes)}))})),this._fetchStore=this._register(new n.DisposableStore),this._inlineEditsFetchResult=o.disposableObservableValue(this,void 0),this._inlineEdits=r.derivedOpts({owner:this,equalsFn:t.structuralEquals},(e=>this._inlineEditsFetchResult.read(e)?.completions.map((e=>new b(e)))??[])),this._fetchInlineEditsPromise=r.derivedHandleChanges({owner:this,createEmptyChangeSummary:()=>({inlineCompletionTriggerKind:u.InlineCompletionTriggerKind.Automatic}),handleChange:(e,i)=>(e.didChange(this._forceUpdateExplicitlySignal)&&(i.inlineCompletionTriggerKind=u.InlineCompletionTriggerKind.Explicit),!0)},(async(t,s)=>{this._fetchStore.clear(),this._forceUpdateExplicitlySignal.read(t),this._textModelVersionId.read(t);const n=this._pinnedRange.range.read(t)??(o=this._selection.read(t),(e=>e.isEmpty()?void 0:e)(o));var o;if(!n)return this._inlineEditsFetchResult.set(void 0,void 0),void this.userPrompt.set(void 0,void 0);const r={triggerKind:s.inlineCompletionTriggerKind,selectedSuggestionInfo:void 0,userPrompt:this.userPrompt.read(t)},l=i.cancelOnDispose(this._fetchStore);await e.timeout(200,l);const d=await _.provideInlineCompletions(this.languageFeaturesService.inlineCompletionsProvider,n,this.textModel,r,l);l.isCancellationRequested||this._inlineEditsFetchResult.set(d,void 0)})),this._filteredInlineEditItems=r.derivedOpts({owner:this,equalsFn:t.itemsEquals()},(e=>this._inlineEdits.read(e))),this.selectedInlineCompletionIndex=r.derived(this,(e=>{const i=this._selectedInlineCompletionId.read(e),t=this._filteredInlineEditItems.read(e),s=void 0===this._selectedInlineCompletionId?-1:t.findIndex((e=>e.semanticId===i));return-1===s?(this._selectedInlineCompletionId.set(void 0,void 0),0):s})),this.selectedInlineEdit=r.derived(this,(e=>this._filteredInlineEditItems.read(e)[this.selectedInlineCompletionIndex.read(e)])),this._register(d.recomputeInitiallyAndOnChange(this._fetchInlineEditsPromise))}async triggerExplicitly(e){o.subtransaction(e,(e=>{this._isActive.set(!0,e),this._forceUpdateExplicitlySignal.trigger(e)})),await this._fetchInlineEditsPromise.get()}stop(e){o.subtransaction(e,(e=>{this.userPrompt.set(void 0,e),this._isActive.set(!1,e),this._inlineEditsFetchResult.set(void 0,e),this._pinnedRange.setRange(void 0,e)}))}async _deltaSelectedInlineCompletionIndex(e){await this.triggerExplicitly();const i=this._filteredInlineEditItems.get()||[];if(i.length>0){const t=(this.selectedInlineCompletionIndex.get()+e+i.length)%i.length;this._selectedInlineCompletionId.set(i[t].semanticId,void 0)}else this._selectedInlineCompletionId.set(void 0,void 0)}async next(){await this._deltaSelectedInlineCompletionIndex(1)}async previous(){await this._deltaSelectedInlineCompletionIndex(-1)}async accept(e){if(e.getModel()!==this.textModel)throw new s.BugIndicatingError;const i=this.selectedInlineEdit.get();i&&(e.pushUndoStop(),e.executeEdits("inlineSuggestion.accept",[i.inlineCompletion.toSingleTextEdit().toSingleEditOperation()]),this.stop())}},exports.InlineEditsModel=l=I([f(4,p.ILanguageFeaturesService),f(5,h.IDiffProviderFactoryService),f(6,g.IModelService)],exports.InlineEditsModel);class b{constructor(e){this.inlineCompletion=e,this.semanticId=this.inlineCompletion.hash()}}class E extends n.Disposable{constructor(e,i){super(),this._textModel=e,this._versionId=i,this._decorations=o.observableValue(this,[]),this.range=r.derived(this,(e=>{this._versionId.read(e);const i=this._decorations.read(e)[0];return i?this._textModel.getDecorationRange(i)??null:null})),this._register(n.toDisposable((()=>{this._textModel.deltaDecorations(this._decorations.get(),[])})))}setRange(e,i){this._decorations.set(this._textModel.deltaDecorations(this._decorations.get(),e?[{range:e,options:{description:"trackedRange"}}]:[]),i)}}
//# sourceMappingURL=inlineEditsModel.js.map
