"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var e=require("../../../../base/browser/dom.js"),t=require("../../../../base/browser/fonts.js"),i=require("../../../../base/common/lifecycle.js");require("../../../../base/common/arrays.js");var o=require("../../../../base/common/observableInternal/derived.js"),r=require("../../../../base/common/observableInternal/autorun.js"),s=require("../../../../base/common/observableInternal/utils.js");require("../../../../base/common/errors.js"),require("./inlineEditsWidget.css.js");var n=require("../../../browser/editorExtensions.js"),d=require("../../../browser/observableCodeEditor.js"),a=require("../../../browser/widget/codeEditor/embeddedCodeEditorWidget.js"),l=require("../../../browser/widget/diffEditor/registrations.contribution.js"),h=require("../../../browser/widget/diffEditor/utils.js"),u=require("../../../common/languages/modesRegistry.js"),c=require("../../../common/model/textModel.js"),p=require("../../contextmenu/browser/contextmenu.js"),g=require("../../placeholderText/browser/placeholderTextContribution.js"),m=require("../../suggest/browser/suggestController.js"),_=require("../../../../platform/instantiation/common/instantiation.js"),b=self&&self.__decorate||function(e,t,i,o){var r,s=arguments.length,n=s<3?t:null===o?o=Object.getOwnPropertyDescriptor(t,i):o;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)n=Reflect.decorate(e,t,i,o);else for(var d=e.length-1;d>=0;d--)(r=e[d])&&(n=(s<3?r(n):s>3?r(t,i,n):r(t,i))||n);return s>3&&n&&Object.defineProperty(t,i,n),n},f=self&&self.__param||function(e,t){return function(i,o){t(i,o,e)}};exports.InlineEditsWidget=class extends i.Disposable{constructor(_,b,f,x){super(),this._editor=_,this._edit=b,this._userPrompt=f,this._instantiationService=x,this._editorObs=d.observableCodeEditor(this._editor),this._elements=e.h("div.inline-edits-widget",{style:{position:"absolute",overflow:"visible",top:"0px",left:"0px"}},[e.h("div@editorContainer",{style:{position:"absolute",top:"0px",left:"0px",width:"500px",height:"500px"}},[e.h("div.toolbar@toolbar",{style:{position:"absolute",top:"-25px",left:"0px"}}),e.h("div.promptEditor@promptEditor",{style:{position:"absolute",top:"-25px",left:"80px",width:"300px",height:"22px"}}),e.h("div.preview@editor",{style:{position:"absolute",top:"0px",left:"0px"}})]),e.svgElem("svg",{style:{overflow:"visible",pointerEvents:"none"}},[e.svgElem("defs",[e.svgElem("linearGradient",{id:"Gradient2",x1:"0",y1:"0",x2:"1",y2:"0"},[e.svgElem("stop",{offset:"0%",class:"gradient-stop"}),e.svgElem("stop",{offset:"100%",class:"gradient-stop"})])]),e.svgElem("path@path",{d:"",fill:"url(#Gradient2)"})])]),this._previewTextModel=this._register(this._instantiationService.createInstance(c.TextModel,"",u.PLAINTEXT_LANGUAGE_ID,c.TextModel.DEFAULT_CREATION_OPTIONS,null)),this._setText=o.derived((e=>{const t=this._edit.read(e);t&&this._previewTextModel.setValue(t.newLines.join("\n"))})).recomputeInitiallyAndOnChange(this._store),this._promptTextModel=this._register(this._instantiationService.createInstance(c.TextModel,"",u.PLAINTEXT_LANGUAGE_ID,c.TextModel.DEFAULT_CREATION_OPTIONS,null)),this._promptEditor=this._register(this._instantiationService.createInstance(a.EmbeddedCodeEditorWidget,this._elements.promptEditor,{glyphMargin:!1,lineNumbers:"off",minimap:{enabled:!1},guides:{indentation:!1,bracketPairs:!1,bracketPairsHorizontal:!1,highlightActiveIndentation:!1},folding:!1,selectOnLineNumbers:!1,selectionHighlight:!1,columnSelection:!1,overviewRulerBorder:!1,overviewRulerLanes:0,lineDecorationsWidth:0,lineNumbersMinChars:0,placeholder:"Describe the change you want...",fontFamily:t.DEFAULT_FONT_FAMILY},{contributions:n.EditorExtensionsRegistry.getSomeEditorContributions([m.SuggestController.ID,g.PlaceholderTextContribution.ID,p.ContextMenuController.ID]),isSimpleWidget:!0},this._editor)),this._previewEditor=this._register(this._instantiationService.createInstance(a.EmbeddedCodeEditorWidget,this._elements.editor,{glyphMargin:!1,lineNumbers:"off",minimap:{enabled:!1},guides:{indentation:!1,bracketPairs:!1,bracketPairsHorizontal:!1,highlightActiveIndentation:!1},folding:!1,selectOnLineNumbers:!1,selectionHighlight:!1,columnSelection:!1,overviewRulerBorder:!1,overviewRulerLanes:0,lineDecorationsWidth:0,lineNumbersMinChars:0},{contributions:[]},this._editor)),this._previewEditorObs=d.observableCodeEditor(this._previewEditor),this._decorations=o.derived(this,(e=>{this._setText.read(e);const t=this._edit.read(e)?.changes;if(!t)return[];const i=[],o=[];if(1===t.length&&t[0].innerChanges[0].modifiedRange.equalsRange(this._previewTextModel.getFullModelRange()))return[];for(const e of t)if(e.original.isEmpty||i.push({range:e.original.toInclusiveRange(),options:l.diffLineDeleteDecorationBackgroundWithIndicator}),e.modified.isEmpty||o.push({range:e.modified.toInclusiveRange(),options:l.diffLineAddDecorationBackgroundWithIndicator}),e.modified.isEmpty||e.original.isEmpty)e.original.isEmpty||i.push({range:e.original.toInclusiveRange(),options:l.diffWholeLineDeleteDecoration}),e.modified.isEmpty||o.push({range:e.modified.toInclusiveRange(),options:l.diffWholeLineAddDecoration});else for(const t of e.innerChanges||[])e.original.contains(t.originalRange.startLineNumber)&&i.push({range:t.originalRange,options:t.originalRange.isEmpty()?l.diffDeleteDecorationEmpty:l.diffDeleteDecoration}),e.modified.contains(t.modifiedRange.startLineNumber)&&o.push({range:t.modifiedRange,options:t.modifiedRange.isEmpty()?l.diffAddDecorationEmpty:l.diffAddDecoration});return o})),this._layout1=o.derived(this,(e=>{const t=this._editor.getModel(),i=this._edit.read(e);if(!i)return null;const o=i.range;let r=0;for(let e=o.startLineNumber;e<o.endLineNumberExclusive;e++){const i=t.getLineMaxColumn(e),o=this._editor.getOffsetForColumn(e,i);r=Math.max(r,o)}return{left:this._editor.getLayoutInfo().contentLeft+r}})),this._layout=o.derived(this,(e=>{const t=this._edit.read(e);if(!t)return null;const i=t.range,o=this._editorObs.scrollLeft.read(e),r=this._layout1.read(e).left+20-o,s=this._editor.getTopForLineNumber(i.startLineNumber)-this._editorObs.scrollTop.read(e),n=this._editor.getTopForLineNumber(i.endLineNumberExclusive)-this._editorObs.scrollTop.read(e),d=new v(r,s),a=new v(r,n),l=n-s,h=this._editor.getOption(67)*t.newLines.length,u=l-h;return{topCode:d,bottomCode:a,codeHeight:l,topEdit:new v(r+50,s+u/2),bottomEdit:new v(r+50,n-u/2),editHeight:h}}));const y=o.derived(this,(e=>void 0!==this._edit.read(e)||void 0!==this._userPrompt.read(e)));var w,T,I;this._register(h.applyStyle(this._elements.root,{display:o.derived(this,(e=>y.read(e)?"block":"none"))})),this._register(h.appendRemoveOnDispose(this._editor.getDomNode(),this._elements.root)),this._register(d.observableCodeEditor(_).createOverlayWidget({domNode:this._elements.root,position:s.constObservable(null),allowEditorOverflow:!1,minContentWidthInPx:o.derived((e=>{const t=this._layout1.read(e)?.left;if(void 0===t)return 0;return t+this._previewEditorObs.contentWidth.read(e)}))})),this._previewEditor.setModel(this._previewTextModel),this._register(this._previewEditorObs.setDecorations(this._decorations)),this._register(r.autorun((e=>{const t=this._layout.read(e);if(!t)return;const{topCode:i,bottomCode:o,topEdit:r,bottomEdit:s,editHeight:n}=t,d=(new E).moveTo(i).lineTo(i.deltaX(10)).curveTo(i.deltaX(50),r.deltaX(-40),r.deltaX(-0)).lineTo(r).lineTo(s).lineTo(s.deltaX(-0)).curveTo(s.deltaX(-40),o.deltaX(50),o.deltaX(10)).lineTo(o).build();this._elements.path.setAttribute("d",d),this._elements.editorContainer.style.top=`${r.y}px`,this._elements.editorContainer.style.left=`${r.x}px`,this._elements.editorContainer.style.height=`${n}px`;const a=this._previewEditorObs.contentWidth.read(e);this._previewEditor.layout({height:n,width:a})}))),this._promptEditor.setModel(this._promptTextModel),this._promptEditor.layout(),this._register(function(e,t){const o=new i.DisposableStore;return o.add(r.autorun((i=>{const o=e.read(i);t.set(o,void 0)}))),o.add(r.autorun((i=>{const o=t.read(i);e.set(o,void 0)}))),o}((w=this._userPrompt,T=e=>e??"",I=e=>e,o.derivedWithSetter(void 0,(e=>T(w.read(e))),((e,t)=>w.set(I(e),t)))),d.observableCodeEditor(this._promptEditor).value)),this._register(r.autorun((e=>{const t=d.observableCodeEditor(this._promptEditor).isFocused.read(e);this._elements.root.classList.toggle("focused",t)})))}},exports.InlineEditsWidget=b([f(3,_.IInstantiationService)],exports.InlineEditsWidget);class v{constructor(e,t){this.x=e,this.y=t}deltaX(e){return new v(this.x+e,this.y)}}class E{constructor(){this._data=""}moveTo(e){return this._data+=`M ${e.x} ${e.y} `,this}lineTo(e){return this._data+=`L ${e.x} ${e.y} `,this}curveTo(e,t,i){return this._data+=`C ${e.x} ${e.y} ${t.x} ${t.y} ${i.x} ${i.y} `,this}build(){return this._data}}exports.InlineEdit=class{constructor(e,t,i){this.range=e,this.newLines=t,this.changes=i}};
//# sourceMappingURL=inlineEditsWidget.js.map
