"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var e=require("../../../../base/common/arrays.js"),t=require("../../../../base/common/async.js"),i=require("../../../../base/common/cancellation.js"),r=require("../../../../base/common/color.js"),n=require("../../../../base/common/errors.js"),o=require("../../../../base/common/event.js"),s=require("../../../../base/common/lifecycle.js"),a=require("../../../../base/common/strings.js"),c=require("../../../../base/common/uri.js"),d=require("../../../browser/editorExtensions.js"),u=require("../../../browser/services/codeEditorService.js"),l=require("../../../common/core/position.js"),g=require("../../../common/core/range.js"),h=require("../../../common/editorContextKeys.js"),m=require("../../../common/model/textModel.js"),_=require("../../../common/languages/languageConfigurationRegistry.js"),p=require("../../../../nls.js"),C=require("../../../../platform/contextkey/common/contextkey.js"),f=require("../../../common/services/languageFeatures.js"),b=require("../../../../platform/theme/common/colorUtils.js");require("../../../../platform/theme/common/colors/baseColors.js"),require("../../../../platform/theme/common/colors/chartsColors.js"),require("../../../../platform/theme/common/colors/editorColors.js"),require("../../../../platform/theme/common/colors/inputColors.js"),require("../../../../platform/theme/common/colors/listColors.js"),require("../../../../platform/theme/common/colors/menuColors.js"),require("../../../../platform/theme/common/colors/minimapColors.js"),require("../../../../platform/theme/common/colors/miscColors.js"),require("../../../../platform/theme/common/colors/quickpickColors.js"),require("../../../../platform/theme/common/colors/searchColors.js");var E=require("../../../common/services/languageFeatureDebounce.js"),R=require("../../../../base/common/stopwatch.js");require("./linkedEditing.css.js");var q,v=self&&self.__decorate||function(e,t,i,r){var n,o=arguments.length,s=o<3?t:null===r?r=Object.getOwnPropertyDescriptor(t,i):r;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)s=Reflect.decorate(e,t,i,r);else for(var a=e.length-1;a>=0;a--)(n=e[a])&&(s=(o<3?n(s):o>3?n(t,i,s):n(t,i))||s);return o>3&&s&&Object.defineProperty(t,i,s),s},y=self&&self.__param||function(e,t){return function(i,r){t(i,r,e)}};const k=new C.RawContextKey("LinkedEditingInputVisible",!1);exports.LinkedEditingContribution=class extends s.Disposable{static{q=this}static{this.ID="editor.contrib.linkedEditing"}static{this.DECORATION=m.ModelDecorationOptions.register({description:"linked-editing",stickiness:0,className:"linked-editing-decoration"})}static get(e){return e.getContribution(q.ID)}constructor(e,t,i,r,n){super(),this.languageConfigurationService=r,this._syncRangesToken=0,this._localToDispose=this._register(new s.DisposableStore),this._editor=e,this._providers=i.linkedEditingRangeProvider,this._enabled=!1,this._visibleContextKey=k.bindTo(t),this._debounceInformation=n.for(this._providers,"Linked Editing",{max:200}),this._currentDecorations=this._editor.createDecorationsCollection(),this._languageWordPattern=null,this._currentWordPattern=null,this._ignoreChangeEvent=!1,this._localToDispose=this._register(new s.DisposableStore),this._rangeUpdateTriggerPromise=null,this._rangeSyncTriggerPromise=null,this._currentRequestCts=null,this._currentRequestPosition=null,this._currentRequestModelVersion=null,this._register(this._editor.onDidChangeModel((()=>this.reinitialize(!0)))),this._register(this._editor.onDidChangeConfiguration((e=>{(e.hasChanged(70)||e.hasChanged(94))&&this.reinitialize(!1)}))),this._register(this._providers.onDidChange((()=>this.reinitialize(!1)))),this._register(this._editor.onDidChangeModelLanguage((()=>this.reinitialize(!0)))),this.reinitialize(!0)}reinitialize(e){const i=this._editor.getModel(),r=null!==i&&(this._editor.getOption(70)||this._editor.getOption(94))&&this._providers.has(i);if(r===this._enabled&&!e)return;if(this._enabled=r,this.clearRanges(),this._localToDispose.clear(),!r||null===i)return;this._localToDispose.add(o.Event.runAndSubscribe(i.onDidChangeLanguageConfiguration,(()=>{this._languageWordPattern=this.languageConfigurationService.getLanguageConfiguration(i.getLanguageId()).getWordDefinition()})));const n=new t.Delayer(this._debounceInformation.get(i)),s=()=>{this._rangeUpdateTriggerPromise=n.trigger((()=>this.updateRanges()),this._debounceDuration??this._debounceInformation.get(i))},a=new t.Delayer(0),c=e=>{this._rangeSyncTriggerPromise=a.trigger((()=>this._syncRanges(e)))};this._localToDispose.add(this._editor.onDidChangeCursorPosition((()=>{s()}))),this._localToDispose.add(this._editor.onDidChangeModelContent((e=>{if(!this._ignoreChangeEvent&&this._currentDecorations.length>0){const t=this._currentDecorations.getRange(0);if(t&&e.changes.every((e=>t.intersectRanges(e.range))))return void c(this._syncRangesToken)}s()}))),this._localToDispose.add({dispose:()=>{n.dispose(),a.dispose()}}),this.updateRanges()}_syncRanges(e){if(!this._editor.hasModel()||e!==this._syncRangesToken||0===this._currentDecorations.length)return;const t=this._editor.getModel(),i=this._currentDecorations.getRange(0);if(!i||i.startLineNumber!==i.endLineNumber)return this.clearRanges();const r=t.getValueInRange(i);if(this._currentWordPattern){const e=r.match(this._currentWordPattern);if((e?e[0].length:0)!==r.length)return this.clearRanges()}const n=[];for(let e=1,i=this._currentDecorations.length;e<i;e++){const i=this._currentDecorations.getRange(e);if(i)if(i.startLineNumber!==i.endLineNumber)n.push({range:i,text:r});else{let e=t.getValueInRange(i),o=r,s=i.startColumn,c=i.endColumn;const d=a.commonPrefixLength(e,o);s+=d,e=e.substr(d),o=o.substr(d);const u=a.commonSuffixLength(e,o);c-=u,e=e.substr(0,e.length-u),o=o.substr(0,o.length-u),s===c&&0===o.length||n.push({range:new g.Range(i.startLineNumber,s,i.endLineNumber,c),text:o})}}if(0!==n.length)try{this._editor.popUndoStop(),this._ignoreChangeEvent=!0;const e=this._editor._getViewModel().getPrevEditOperationType();this._editor.executeEdits("linkedEditing",n),this._editor._getViewModel().setPrevEditOperationType(e)}finally{this._ignoreChangeEvent=!1}}dispose(){this.clearRanges(),super.dispose()}clearRanges(){this._visibleContextKey.set(!1),this._currentDecorations.clear(),this._currentRequestCts&&(this._currentRequestCts.cancel(),this._currentRequestCts=null,this._currentRequestPosition=null)}async updateRanges(e=!1){if(!this._editor.hasModel())return void this.clearRanges();const t=this._editor.getPosition();if(!this._enabled&&!e||this._editor.getSelections().length>1)return void this.clearRanges();const r=this._editor.getModel(),o=r.getVersionId();if(this._currentRequestPosition&&this._currentRequestModelVersion===o){if(t.equals(this._currentRequestPosition))return;if(this._currentDecorations.length>0){const e=this._currentDecorations.getRange(0);if(e&&e.containsPosition(t))return}}this.clearRanges(),this._currentRequestPosition=t,this._currentRequestModelVersion=o;const s=this._currentRequestCts=new i.CancellationTokenSource;try{const e=new R.StopWatch(!1),i=await P(this._providers,r,t,s.token);if(this._debounceInformation.update(r,e.elapsed()),s!==this._currentRequestCts)return;if(this._currentRequestCts=null,o!==r.getVersionId())return;let n=[];i?.ranges&&(n=i.ranges),this._currentWordPattern=i?.wordPattern||this._languageWordPattern;let a=!1;for(let e=0,i=n.length;e<i;e++)if(g.Range.containsPosition(n[e],t)){if(a=!0,0!==e){const t=n[e];n.splice(e,1),n.unshift(t)}break}if(!a)return void this.clearRanges();const c=n.map((e=>({range:e,options:q.DECORATION})));this._visibleContextKey.set(!0),this._currentDecorations.set(c),this._syncRangesToken++}catch(e){n.isCancellationError(e)||n.onUnexpectedError(e),this._currentRequestCts!==s&&this._currentRequestCts||this.clearRanges()}}},exports.LinkedEditingContribution=q=v([y(1,C.IContextKeyService),y(2,f.ILanguageFeaturesService),y(3,_.ILanguageConfigurationService),y(4,E.ILanguageFeatureDebounceService)],exports.LinkedEditingContribution);class x extends d.EditorAction{constructor(){super({id:"editor.action.linkedEditing",label:p.localize("linkedEditing.label","Start Linked Editing"),alias:"Start Linked Editing",precondition:C.ContextKeyExpr.and(h.EditorContextKeys.writable,h.EditorContextKeys.hasRenameProvider),kbOpts:{kbExpr:h.EditorContextKeys.editorTextFocus,primary:3132,weight:100}})}runCommand(e,t){const i=e.get(u.ICodeEditorService),[r,o]=Array.isArray(t)&&t||[void 0,void 0];return c.URI.isUri(r)&&l.Position.isIPosition(o)?i.openCodeEditor({resource:r},i.getActiveCodeEditor()).then((e=>{e&&(e.setPosition(o),e.invokeWithinContext((t=>(this.reportTelemetry(t,e),this.run(t,e)))))}),n.onUnexpectedError):super.runCommand(e,t)}run(e,t){const i=exports.LinkedEditingContribution.get(t);return i?Promise.resolve(i.updateRanges(!0)):Promise.resolve()}}const D=d.EditorCommand.bindToContribution(exports.LinkedEditingContribution.get);function P(i,r,o,s){const a=i.ordered(r);return t.first(a.map((e=>async()=>{try{return await e.provideLinkedEditingRanges(r,o,s)}catch(e){return void n.onUnexpectedExternalError(e)}})),(t=>!!t&&e.isNonEmptyArray(t?.ranges)))}d.registerEditorCommand(new D({id:"cancelLinkedEditingInput",precondition:k,handler:e=>e.clearRanges(),kbOpts:{kbExpr:h.EditorContextKeys.editorTextFocus,weight:199,primary:9,secondary:[1033]}})),b.registerColor("editor.linkedEditingBackground",{dark:r.Color.fromHex("#f00").transparent(.3),light:r.Color.fromHex("#f00").transparent(.3),hcDark:r.Color.fromHex("#f00").transparent(.3),hcLight:r.Color.white},p.localize("editorLinkedEditingBackground","Background color when the editor auto renames on type.")),d.registerModelAndPositionCommand("_executeLinkedEditingProvider",((e,t,r)=>{const{linkedEditingRangeProvider:n}=e.get(f.ILanguageFeaturesService);return P(n,t,r,i.CancellationToken.None)})),d.registerEditorContribution(exports.LinkedEditingContribution.ID,exports.LinkedEditingContribution,1),d.registerEditorAction(x),exports.CONTEXT_ONTYPE_RENAME_INPUT_VISIBLE=k,exports.LinkedEditingAction=x;
//# sourceMappingURL=linkedEditing.js.map
