"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var e=require("../../../../base/common/async.js"),t=require("../../../../base/common/cancellation.js"),i=require("../../../../base/common/errors.js"),o=require("../../../../base/common/htmlContent.js"),n=require("../../../../base/common/lifecycle.js"),s=require("../../../../base/common/network.js"),r=require("../../../../base/common/platform.js"),c=require("../../../../base/common/resources.js"),a=require("../../../../base/common/stopwatch.js"),l=require("../../../../base/common/uri.js");require("./links.css.js");var u,h=require("../../../browser/editorExtensions.js"),d=require("../../../common/model/textModel.js"),p=require("../../../common/services/languageFeatureDebounce.js"),m=require("../../../common/services/languageFeatures.js"),g=require("../../gotoSymbol/browser/link/clickLinkGesture.js"),k=require("./getLinks.js"),f=require("../../../../nls.js"),L=require("../../../../platform/notification/common/notification.js"),v=require("../../../../platform/opener/common/opener.js"),b=self&&self.__decorate||function(e,t,i,o){var n,s=arguments.length,r=s<3?t:null===o?o=Object.getOwnPropertyDescriptor(t,i):o;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,i,o);else for(var c=e.length-1;c>=0;c--)(n=e[c])&&(r=(s<3?n(r):s>3?n(t,i,r):n(t,i))||r);return s>3&&r&&Object.defineProperty(t,i,r),r},D=self&&self.__param||function(e,t){return function(i,o){t(i,o,e)}};exports.LinkDetector=class extends n.Disposable{static{u=this}static{this.ID="editor.linkDetector"}static get(e){return e.getContribution(u.ID)}constructor(t,i,o,n,s){super(),this.editor=t,this.openerService=i,this.notificationService=o,this.languageFeaturesService=n,this.providers=this.languageFeaturesService.linkProvider,this.debounceInformation=s.for(this.providers,"Links",{min:1e3,max:4e3}),this.computeLinks=this._register(new e.RunOnceScheduler((()=>this.computeLinksNow()),1e3)),this.computePromise=null,this.activeLinksList=null,this.currentOccurrences={},this.activeLinkDecorationId=null;const r=this._register(new g.ClickLinkGesture(t));this._register(r.onMouseMoveOrRelevantKeyDown((([e,t])=>{this._onEditorMouseMove(e,t)}))),this._register(r.onExecute((e=>{this.onEditorMouseUp(e)}))),this._register(r.onCancel((e=>{this.cleanUpActiveLinkDecoration()}))),this._register(t.onDidChangeConfiguration((e=>{e.hasChanged(71)&&(this.updateDecorations([]),this.stop(),this.computeLinks.schedule(0))}))),this._register(t.onDidChangeModelContent((e=>{this.editor.hasModel()&&this.computeLinks.schedule(this.debounceInformation.get(this.editor.getModel()))}))),this._register(t.onDidChangeModel((e=>{this.currentOccurrences={},this.activeLinkDecorationId=null,this.stop(),this.computeLinks.schedule(0)}))),this._register(t.onDidChangeModelLanguage((e=>{this.stop(),this.computeLinks.schedule(0)}))),this._register(this.providers.onDidChange((e=>{this.stop(),this.computeLinks.schedule(0)}))),this.computeLinks.schedule(0)}async computeLinksNow(){if(!this.editor.hasModel()||!this.editor.getOption(71))return;const t=this.editor.getModel();if(!t.isTooLargeForSyncing()&&this.providers.has(t)){this.activeLinksList&&(this.activeLinksList.dispose(),this.activeLinksList=null),this.computePromise=e.createCancelablePromise((e=>k.getLinks(this.providers,t,e)));try{const e=new a.StopWatch(!1);if(this.activeLinksList=await this.computePromise,this.debounceInformation.update(t,e.elapsed()),t.isDisposed())return;this.updateDecorations(this.activeLinksList.links)}catch(e){i.onUnexpectedError(e)}finally{this.computePromise=null}}}updateDecorations(e){const t="altKey"===this.editor.getOption(78),i=[],o=Object.keys(this.currentOccurrences);for(const e of o){const t=this.currentOccurrences[e];i.push(t.decorationId)}const n=[];if(e)for(const i of e)n.push(S.decoration(i,t));this.editor.changeDecorations((t=>{const o=t.deltaDecorations(i,n);this.currentOccurrences={},this.activeLinkDecorationId=null;for(let t=0,i=o.length;t<i;t++){const i=new S(e[t],o[t]);this.currentOccurrences[i.decorationId]=i}}))}_onEditorMouseMove(e,t){const i="altKey"===this.editor.getOption(78);if(this.isEnabled(e,t)){this.cleanUpActiveLinkDecoration();const t=this.getLinkOccurrence(e.target.position);t&&this.editor.changeDecorations((e=>{t.activate(e,i),this.activeLinkDecorationId=t.decorationId}))}else this.cleanUpActiveLinkDecoration()}cleanUpActiveLinkDecoration(){const e="altKey"===this.editor.getOption(78);if(this.activeLinkDecorationId){const t=this.currentOccurrences[this.activeLinkDecorationId];t&&this.editor.changeDecorations((i=>{t.deactivate(i,e)})),this.activeLinkDecorationId=null}}onEditorMouseUp(e){if(!this.isEnabled(e))return;const t=this.getLinkOccurrence(e.target.position);t&&this.openLinkOccurrence(t,e.hasSideBySideModifier,!0)}openLinkOccurrence(e,o,n=!1){if(!this.openerService)return;const{link:r}=e;r.resolve(t.CancellationToken.None).then((e=>{if("string"==typeof e&&this.editor.hasModel()){const t=this.editor.getModel().uri;if(t.scheme===s.Schemas.file&&e.startsWith(`${s.Schemas.file}:`)){const i=l.URI.parse(e);if(i.scheme===s.Schemas.file){const o=c.originalFSPath(i);let n=null;o.startsWith("/./")||o.startsWith("\\.\\")?n=`.${o.substr(1)}`:(o.startsWith("//./")||o.startsWith("\\\\.\\"))&&(n=`.${o.substr(2)}`),n&&(e=c.joinPath(t,n))}}}return this.openerService.open(e,{openToSide:o,fromUserGesture:n,allowContributedOpeners:!0,allowCommands:!0,fromWorkspace:!0})}),(e=>{const t=e instanceof Error?e.message:e;"invalid"===t?this.notificationService.warn(f.localize("invalid.url","Failed to open this link because it is not well-formed: {0}",r.url.toString())):"missing"===t?this.notificationService.warn(f.localize("missing.url","Failed to open this link because its target is missing.")):i.onUnexpectedError(e)}))}getLinkOccurrence(e){if(!this.editor.hasModel()||!e)return null;const t=this.editor.getModel().getDecorationsInRange({startLineNumber:e.lineNumber,startColumn:e.column,endLineNumber:e.lineNumber,endColumn:e.column},0,!0);for(const e of t){const t=this.currentOccurrences[e.id];if(t)return t}return null}isEnabled(e,t){return Boolean(6===e.target.type&&(e.hasTriggerModifier||t&&t.keyCodeIsTriggerKey))}stop(){this.computeLinks.cancel(),this.activeLinksList&&(this.activeLinksList?.dispose(),this.activeLinksList=null),this.computePromise&&(this.computePromise.cancel(),this.computePromise=null)}dispose(){super.dispose(),this.stop()}},exports.LinkDetector=u=b([D(1,v.IOpenerService),D(2,L.INotificationService),D(3,m.ILanguageFeaturesService),D(4,p.ILanguageFeatureDebounceService)],exports.LinkDetector);const O=d.ModelDecorationOptions.register({description:"detected-link",stickiness:1,collapseOnReplaceEdit:!0,inlineClassName:"detected-link"}),M=d.ModelDecorationOptions.register({description:"detected-link-active",stickiness:1,collapseOnReplaceEdit:!0,inlineClassName:"detected-link-active"});class S{static decoration(e,t){return{range:e.range,options:S._getOptions(e,t,!1)}}static _getOptions(e,t,i){const n={...i?M:O};return n.hoverMessage=function(e,t){const i=e.url&&/^command:/i.test(e.url.toString()),n=e.tooltip?e.tooltip:i?f.localize("links.navigate.executeCmd","Execute command"):f.localize("links.navigate.follow","Follow link"),s=t?r.isMacintosh?f.localize("links.navigate.kb.meta.mac","cmd + click"):f.localize("links.navigate.kb.meta","ctrl + click"):r.isMacintosh?f.localize("links.navigate.kb.alt.mac","option + click"):f.localize("links.navigate.kb.alt","alt + click");if(e.url){let t="";if(/^command:/i.test(e.url.toString())){const i=e.url.toString().match(/^command:([^?#]+)/);if(i){const e=i[1];t=f.localize("tooltip.explanation","Execute command {0}",e)}}return new o.MarkdownString("",!0).appendLink(e.url.toString(!0).replace(/ /g,"%20"),n,t).appendMarkdown(` (${s})`)}return(new o.MarkdownString).appendText(`${n} (${s})`)}(e,t),n}constructor(e,t){this.link=e,this.decorationId=t}activate(e,t){e.changeDecorationOptions(this.decorationId,S._getOptions(this.link,t,!0))}deactivate(e,t){e.changeDecorationOptions(this.decorationId,S._getOptions(this.link,t,!1))}}class j extends h.EditorAction{constructor(){super({id:"editor.action.openLink",label:f.localize("label","Open Link"),alias:"Open Link",precondition:void 0})}run(e,t){const i=exports.LinkDetector.get(t);if(!i)return;if(!t.hasModel())return;const o=t.getSelections();for(const e of o){const t=i.getLinkOccurrence(e.getEndPosition());t&&i.openLinkOccurrence(t,!1)}}}h.registerEditorContribution(exports.LinkDetector.ID,exports.LinkDetector,1),h.registerEditorAction(j);
//# sourceMappingURL=links.js.map
