"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var e,o=require("../../../../base/common/async.js"),t=require("../../../../base/common/cancellation.js"),i=require("../../../../base/common/codicons.js"),r=require("../../../../base/common/themables.js"),s=require("../../../../base/common/fuzzyScorer.js"),n=require("../../../../base/common/lifecycle.js"),a=require("../../../../base/common/strings.js"),c=require("../../../common/core/range.js"),l=require("../../../common/languages.js"),d=require("../../documentSymbols/browser/outlineModel.js"),u=require("./editorNavigationQuickAccess.js"),m=require("../../../../nls.js"),b=require("../../../common/services/languageFeatures.js"),p=require("../../../../base/common/arraysFind.js"),y=self&&self.__decorate||function(e,o,t,i){var r,s=arguments.length,n=s<3?o:null===i?i=Object.getOwnPropertyDescriptor(o,t):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)n=Reflect.decorate(e,o,t,i);else for(var a=e.length-1;a>=0;a--)(r=e[a])&&(n=(s<3?r(n):s>3?r(o,t,n):r(o,t))||n);return s>3&&n&&Object.defineProperty(o,t,n),n},g=self&&self.__param||function(e,o){return function(t,i){o(t,i,e)}};exports.AbstractGotoSymbolQuickAccessProvider=class extends u.AbstractEditorNavigationQuickAccessProvider{static{e=this}static{this.PREFIX="@"}static{this.SCOPE_PREFIX=":"}static{this.PREFIX_BY_CATEGORY=`${this.PREFIX}${this.SCOPE_PREFIX}`}constructor(e,o,t=Object.create(null)){super(t),this._languageFeaturesService=e,this._outlineModelService=o,this.options=t,this.options.canAcceptInBackground=!0}provideWithoutTextEditor(e){return this.provideLabelPick(e,m.localize("cannotRunGotoSymbolWithoutEditor","To go to a symbol, first open a text editor with symbol information.")),n.Disposable.None}provideWithTextEditor(e,o,t,i){const r=e.editor,s=this.getModel(r);return s?this._languageFeaturesService.documentSymbolProvider.has(s)?this.doProvideWithEditorSymbols(e,s,o,t,i):this.doProvideWithoutEditorSymbols(e,s,o,t):n.Disposable.None}doProvideWithoutEditorSymbols(e,o,t,i){const r=new n.DisposableStore;return this.provideLabelPick(t,m.localize("cannotRunGotoSymbolWithoutSymbolProvider","The active text editor does not provide symbol information.")),(async()=>{await this.waitForLanguageSymbolRegistry(o,r)&&!i.isCancellationRequested&&r.add(this.doProvideWithEditorSymbols(e,o,t,i))})(),r}provideLabelPick(e,o){e.items=[{label:o,index:0,kind:14}],e.ariaLabel=o}async waitForLanguageSymbolRegistry(e,t){if(this._languageFeaturesService.documentSymbolProvider.has(e))return!0;const i=new o.DeferredPromise,r=t.add(this._languageFeaturesService.documentSymbolProvider.onDidChange((()=>{this._languageFeaturesService.documentSymbolProvider.has(e)&&(r.dispose(),i.complete(!0))})));return t.add(n.toDisposable((()=>i.complete(!1)))),i.p}doProvideWithEditorSymbols(o,i,r,a,l){const d=o.editor,u=new n.DisposableStore;u.add(r.onDidAccept((e=>{const[t]=r.selectedItems;t&&t.range&&(this.gotoLocation(o,{range:t.range.selection,keyMods:r.keyMods,preserveFocus:e.inBackground}),l?.handleAccept?.(t),e.inBackground||r.hide())}))),u.add(r.onDidTriggerItemButton((({item:e})=>{e&&e.range&&(this.gotoLocation(o,{range:e.range.selection,keyMods:r.keyMods,forceSideBySide:!0}),r.hide())})));const b=this.getDocumentSymbols(i,a);let y;const g=async o=>{y?.dispose(!0),r.busy=!1,y=new t.CancellationTokenSource(a),r.busy=!0;try{const t=s.prepareQuery(r.value.substr(e.PREFIX.length).trim()),n=await this.doGetSymbolPicks(b,t,void 0,y.token,i);if(a.isCancellationRequested)return;if(n.length>0){if(r.items=n,o&&0===t.original.length){const e=p.findLast(n,(e=>Boolean("separator"!==e.type&&e.range&&c.Range.containsPosition(e.range.decoration,o))));e&&(r.activeItems=[e])}}else t.original.length>0?this.provideLabelPick(r,m.localize("noMatchingSymbolResults","No matching editor symbols")):this.provideLabelPick(r,m.localize("noSymbolResults","No editor symbols"))}finally{a.isCancellationRequested||(r.busy=!1)}};return u.add(r.onDidChangeValue((()=>g(void 0)))),g(d.getSelection()?.getPosition()),u.add(r.onDidChangeActive((()=>{const[e]=r.activeItems;e&&e.range&&(d.revealRangeInCenter(e.range.selection,0),this.addDecorations(d,e.range.decoration))}))),u}async doGetSymbolPicks(o,t,n,d,u){const b=await o;if(d.isCancellationRequested)return[];const p=0===t.original.indexOf(e.SCOPE_PREFIX),y=p?1:0;let g,v,S;t.values&&t.values.length>1?(g=s.pieceToQuery(t.values[0]),v=s.pieceToQuery(t.values.slice(1))):g=t;const z=this.options?.openSideBySideDirection?.();z&&(S=[{iconClass:"right"===z?r.ThemeIcon.asClassName(i.Codicon.splitHorizontal):r.ThemeIcon.asClassName(i.Codicon.splitVertical),tooltip:"right"===z?m.localize("openToSide","Open to the Side"):m.localize("openToBottom","Open to the Bottom")}]);const P=[];for(let C=0;C<b.length;C++){const F=b[C],j=a.trim(F.name),x=`$(${l.SymbolKinds.toIcon(F.kind).id}) ${j}`,E=x.length-j.length;let q,_,I,L,A=F.containerName;if(n?.extraContainerLabel&&(A=A?`${n.extraContainerLabel} • ${A}`:n.extraContainerLabel),t.original.length>y){let O=!1;if(g!==t&&([q,_]=s.scoreFuzzy2(x,{...t,values:void 0},y,E),"number"==typeof q&&(O=!0)),"number"!=typeof q&&([q,_]=s.scoreFuzzy2(x,g,y,E),"number"!=typeof q))continue;if(!O&&v){if(A&&v.original.length>0&&([I,L]=s.scoreFuzzy2(A,v)),"number"!=typeof I)continue;"number"==typeof q&&(q+=I)}}const D=F.tags&&F.tags.indexOf(1)>=0;P.push({index:C,kind:F.kind,score:q,label:x,ariaLabel:l.getAriaLabelForSymbol(F.name,F.kind),description:A,highlights:D?void 0:{label:_,description:L},range:{selection:c.Range.collapseToStart(F.selectionRange),decoration:F.range},uri:u.uri,symbolName:j,strikethrough:D,buttons:S})}const k=P.sort(((e,o)=>p?this.compareByKindAndScore(e,o):this.compareByScore(e,o)));let R=[];if(p){let B,T,w=0;function M(){T&&"number"==typeof B&&w>0&&(T.label=a.format(f[B]||h,w))}for(const N of k)B!==N.kind?(M(),B=N.kind,w=1,T={type:"separator"},R.push(T)):w++,R.push(N);M()}else k.length>0&&(R=[{label:m.localize("symbols","symbols ({0})",P.length),type:"separator"},...k]);return R}compareByScore(e,o){if("number"!=typeof e.score&&"number"==typeof o.score)return 1;if("number"==typeof e.score&&"number"!=typeof o.score)return-1;if("number"==typeof e.score&&"number"==typeof o.score){if(e.score>o.score)return-1;if(e.score<o.score)return 1}return e.index<o.index?-1:e.index>o.index?1:0}compareByKindAndScore(e,o){const t=f[e.kind]||h,i=f[o.kind]||h,r=t.localeCompare(i);return 0===r?this.compareByScore(e,o):r}async getDocumentSymbols(e,o){const t=await this._outlineModelService.getOrCreate(e,o);return o.isCancellationRequested?[]:t.asListOfDocumentSymbols()}},exports.AbstractGotoSymbolQuickAccessProvider=e=y([g(0,b.ILanguageFeaturesService),g(1,d.IOutlineModelService)],exports.AbstractGotoSymbolQuickAccessProvider);const h=m.localize("property","properties ({0})"),f={5:m.localize("method","methods ({0})"),11:m.localize("function","functions ({0})"),8:m.localize("_constructor","constructors ({0})"),12:m.localize("variable","variables ({0})"),4:m.localize("class","classes ({0})"),22:m.localize("struct","structs ({0})"),23:m.localize("event","events ({0})"),24:m.localize("operator","operators ({0})"),10:m.localize("interface","interfaces ({0})"),2:m.localize("namespace","namespaces ({0})"),3:m.localize("package","packages ({0})"),25:m.localize("typeParameter","type parameters ({0})"),1:m.localize("modules","modules ({0})"),6:m.localize("property","properties ({0})"),9:m.localize("enum","enumerations ({0})"),21:m.localize("enumMember","enumeration members ({0})"),14:m.localize("string","strings ({0})"),0:m.localize("file","files ({0})"),17:m.localize("array","arrays ({0})"),15:m.localize("number","numbers ({0})"),16:m.localize("boolean","booleans ({0})"),18:m.localize("object","objects ({0})"),19:m.localize("key","keys ({0})"),7:m.localize("field","fields ({0})"),13:m.localize("constant","constants ({0})")};
//# sourceMappingURL=gotoSymbolQuickAccess.js.map
