"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var e,t=require("../../../../base/browser/ui/aria/aria.js"),i=require("../../../../base/common/async.js"),r=require("../../../../base/common/cancellation.js"),o=require("../../../../base/common/errors.js"),n=require("../../../../base/common/htmlContent.js"),s=require("../../../../base/common/lifecycle.js"),a=require("../../../../base/common/types.js"),c=require("../../../../base/common/uri.js"),d=require("../../../browser/editorExtensions.js"),l=require("../../../browser/services/bulkEditService.js"),u=require("../../../browser/services/codeEditorService.js"),m=require("../../../common/core/position.js"),g=require("../../../common/core/range.js"),p=require("../../../common/editorContextKeys.js"),h=require("../../../common/languages.js"),v=require("../../../common/services/languageFeatures.js"),f=require("../../../common/services/textResourceConfiguration.js"),R=require("../../editorState/browser/editorState.js"),S=require("../../message/browser/messageController.js"),y=require("../../../../nls.js"),_=require("../../../../platform/actions/common/actions.js"),E=require("../../../../platform/configuration/common/configurationRegistry.js"),w=require("../../../../platform/contextkey/common/contextkey.js"),b=require("../../../../platform/instantiation/common/instantiation.js"),I=require("../../../../platform/log/common/log.js"),x=require("../../../../platform/notification/common/notification.js"),C=require("../../../../platform/progress/common/progress.js"),j=require("../../../../platform/registry/common/platform.js"),P=require("../../../../platform/telemetry/common/telemetry.js"),N=require("./renameWidget.js"),k=self&&self.__decorate||function(e,t,i,r){var o,n=arguments.length,s=n<3?t:null===r?r=Object.getOwnPropertyDescriptor(t,i):r;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)s=Reflect.decorate(e,t,i,r);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(s=(n<3?o(s):n>3?o(t,i,s):o(t,i))||s);return n>3&&s&&Object.defineProperty(t,i,s),s},q=self&&self.__param||function(e,t){return function(i,r){t(i,r,e)}};class T{constructor(e,t,i){this.model=e,this.position=t,this._providerRenameIdx=0,this._providers=i.ordered(e)}hasProvider(){return this._providers.length>0}async resolveRenameLocation(e){const t=[];for(this._providerRenameIdx=0;this._providerRenameIdx<this._providers.length;this._providerRenameIdx++){const i=this._providers[this._providerRenameIdx];if(!i.resolveRenameLocation)break;const r=await i.resolveRenameLocation(this.model,this.position,e);if(r){if(!r.rejectReason)return r;t.push(r.rejectReason)}}this._providerRenameIdx=0;const i=this.model.getWordAtPosition(this.position);return i?{range:new g.Range(this.position.lineNumber,i.startColumn,this.position.lineNumber,i.endColumn),text:i.word,rejectReason:t.length>0?t.join("\n"):void 0}:{range:g.Range.fromPositions(this.position),text:"",rejectReason:t.length>0?t.join("\n"):void 0}}async provideRenameEdits(e,t){return this._provideRenameEdits(e,this._providerRenameIdx,[],t)}async _provideRenameEdits(e,t,i,r){const o=this._providers[t];if(!o)return{edits:[],rejectReason:i.join("\n")};const n=await o.provideRenameEdits(this.model,this.position,e,r);return n?n.rejectReason?this._provideRenameEdits(e,t+1,i.concat(n.rejectReason),r):n:this._provideRenameEdits(e,t+1,i.concat(y.localize("no result","No result.")),r)}}async function A(e,t,i,o){const n=new T(t,i,e),s=await n.resolveRenameLocation(r.CancellationToken.None);return s?.rejectReason?{edits:[],rejectReason:s.rejectReason}:n.provideRenameEdits(o,r.CancellationToken.None)}let L=class{static{e=this}static{this.ID="editor.contrib.renameController"}static get(t){return t.getContribution(e.ID)}constructor(e,t,i,o,n,a,c,d,l){this.editor=e,this._instaService=t,this._notificationService=i,this._bulkEditService=o,this._progressService=n,this._logService=a,this._configService=c,this._languageFeaturesService=d,this._telemetryService=l,this._disposableStore=new s.DisposableStore,this._cts=new r.CancellationTokenSource,this._renameWidget=this._disposableStore.add(this._instaService.createInstance(N.RenameWidget,this.editor,["acceptRenameInput","acceptRenameInputWithPreview"]))}dispose(){this._disposableStore.dispose(),this._cts.dispose(!0)}async run(){const e=this._logService.trace.bind(this._logService,"[rename]");if(this._cts.dispose(!0),this._cts=new r.CancellationTokenSource,!this.editor.hasModel())return void e("editor has no model");const s=this.editor.getPosition(),a=new T(this.editor.getModel(),s,this._languageFeaturesService.renameProvider);if(!a.hasProvider())return void e("skeleton has no provider");const c=new R.EditorStateCancellationTokenSource(this.editor,5,void 0,this._cts.token);let d;try{e("resolving rename location");const t=a.resolveRenameLocation(c.token);this._progressService.showWhile(t,250),d=await t,e("resolved rename location")}catch(t){return void(t instanceof o.CancellationError?e("resolve rename location cancelled",JSON.stringify(t,null,"\t")):(e("resolve rename location failed",t instanceof Error?t:JSON.stringify(t,null,"\t")),("string"==typeof t||n.isMarkdownString(t))&&S.MessageController.get(this.editor)?.showMessage(t||y.localize("resolveRenameLocationFailed","An unknown error occurred while resolving rename location"),s)))}finally{c.dispose()}if(!d)return void e("returning early - no loc");if(d.rejectReason)return e(`returning early - rejected with reason: ${d.rejectReason}`,d.rejectReason),void S.MessageController.get(this.editor)?.showMessage(d.rejectReason,s);if(c.token.isCancellationRequested)return void e("returning early - cts1 cancelled");const l=new R.EditorStateCancellationTokenSource(this.editor,5,d.range,this._cts.token),u=this.editor.getModel(),m=this._languageFeaturesService.newSymbolNamesProvider.all(u),p=await Promise.all(m.map((async e=>[e,await e.supportsAutomaticNewSymbolNamesTriggerKind??!1])));e("creating rename input field and awaiting its result");const v=this._bulkEditService.hasPreviewHandler()&&this._configService.getValue(this.editor.getModel().uri,"editor.rename.enablePreview"),f=await this._renameWidget.getInput(d.range,d.text,v,m.length>0?(e,t)=>{let i=p.slice();return e===h.NewSymbolNameTriggerKind.Automatic&&(i=i.filter((([e,t])=>t))),i.map((([i])=>i.provideNewSymbolNames(u,d.range,e,t)))}:void 0,l);if(e("received response from rename input field"),m.length>0&&this._reportTelemetry(m.length,u.getLanguageId(),f),"boolean"==typeof f)return e(`returning early - rename input field response - ${f}`),f&&this.editor.focus(),void l.dispose();this.editor.focus(),e("requesting rename edits");const _=i.raceCancellation(a.provideRenameEdits(f.newName,l.token),l.token).then((async i=>{if(i)if(this.editor.hasModel()){if(i.rejectReason)return e(`returning early - rejected with reason: ${i.rejectReason}`),void this._notificationService.info(i.rejectReason);this.editor.setSelection(g.Range.fromPositions(this.editor.getSelection().getPosition())),e("applying edits"),this._bulkEditService.apply(i,{editor:this.editor,showPreview:f.wantsPreview,label:y.localize("label","Renaming '{0}' to '{1}'",d?.text,f.newName),code:"undoredo.rename",quotableLabel:y.localize("quotableLabel","Renaming {0} to {1}",d?.text,f.newName),respectAutoSaveConfig:!0}).then((i=>{e("edits applied"),i.ariaSummary&&t.alert(y.localize("aria","Successfully renamed '{0}' to '{1}'. Summary: {2}",d.text,f.newName,i.ariaSummary))})).catch((t=>{e(`error when applying edits ${JSON.stringify(t,null,"\t")}`),this._notificationService.error(y.localize("rename.failedApply","Rename failed to apply edits")),this._logService.error(t)}))}else e("returning early - no model after rename edits are provided");else e("returning early - no rename edits result")}),(t=>{e("error when providing rename edits",JSON.stringify(t,null,"\t")),this._notificationService.error(y.localize("rename.failed","Rename failed to compute edits")),this._logService.error(t)})).finally((()=>{l.dispose()}));return e("returning rename operation"),this._progressService.showWhile(_,250),_}acceptRenameInput(e){this._renameWidget.acceptInput(e)}cancelRenameInput(){this._renameWidget.cancelInput(!0,"cancelRenameInput command")}focusNextRenameSuggestion(){this._renameWidget.focusNextRenameSuggestion()}focusPreviousRenameSuggestion(){this._renameWidget.focusPreviousRenameSuggestion()}_reportTelemetry(e,t,i){const r="boolean"==typeof i?{kind:"cancelled",languageId:t,nRenameSuggestionProviders:e}:{kind:"accepted",languageId:t,nRenameSuggestionProviders:e,source:i.stats.source.k,nRenameSuggestions:i.stats.nRenameSuggestions,timeBeforeFirstInputFieldEdit:i.stats.timeBeforeFirstInputFieldEdit,wantsPreview:i.wantsPreview,nRenameSuggestionsInvocations:i.stats.nRenameSuggestionsInvocations,hadAutomaticRenameSuggestionsInvocation:i.stats.hadAutomaticRenameSuggestionsInvocation};this._telemetryService.publicLog2("renameInvokedEvent",r)}};L=e=k([q(1,b.IInstantiationService),q(2,x.INotificationService),q(3,l.IBulkEditService),q(4,C.IEditorProgressService),q(5,I.ILogService),q(6,f.ITextResourceConfigurationService),q(7,v.ILanguageFeaturesService),q(8,P.ITelemetryService)],L);class M extends d.EditorAction{constructor(){super({id:"editor.action.rename",label:y.localize("rename.label","Rename Symbol"),alias:"Rename Symbol",precondition:w.ContextKeyExpr.and(p.EditorContextKeys.writable,p.EditorContextKeys.hasRenameProvider),kbOpts:{kbExpr:p.EditorContextKeys.editorTextFocus,primary:60,weight:100},contextMenuOpts:{group:"1_modification",order:1.1}})}runCommand(e,t){const i=e.get(u.ICodeEditorService),[r,n]=Array.isArray(t)&&t||[void 0,void 0];return c.URI.isUri(r)&&m.Position.isIPosition(n)?i.openCodeEditor({resource:r},i.getActiveCodeEditor()).then((e=>{e&&(e.setPosition(n),e.invokeWithinContext((t=>(this.reportTelemetry(t,e),this.run(t,e)))))}),o.onUnexpectedError):super.runCommand(e,t)}run(e,t){const i=e.get(I.ILogService),r=L.get(t);return r?(i.trace("[RenameAction] got controller, running..."),r.run()):(i.trace("[RenameAction] returning early - controller missing"),Promise.resolve())}}d.registerEditorContribution(L.ID,L,4),d.registerEditorAction(M);const O=d.EditorCommand.bindToContribution(L.get);d.registerEditorCommand(new O({id:"acceptRenameInput",precondition:N.CONTEXT_RENAME_INPUT_VISIBLE,handler:e=>e.acceptRenameInput(!1),kbOpts:{weight:199,kbExpr:w.ContextKeyExpr.and(p.EditorContextKeys.focus,w.ContextKeyExpr.not("isComposing")),primary:3}})),d.registerEditorCommand(new O({id:"acceptRenameInputWithPreview",precondition:w.ContextKeyExpr.and(N.CONTEXT_RENAME_INPUT_VISIBLE,w.ContextKeyExpr.has("config.editor.rename.enablePreview")),handler:e=>e.acceptRenameInput(!0),kbOpts:{weight:199,kbExpr:w.ContextKeyExpr.and(p.EditorContextKeys.focus,w.ContextKeyExpr.not("isComposing")),primary:2051}})),d.registerEditorCommand(new O({id:"cancelRenameInput",precondition:N.CONTEXT_RENAME_INPUT_VISIBLE,handler:e=>e.cancelRenameInput(),kbOpts:{weight:199,kbExpr:p.EditorContextKeys.focus,primary:9,secondary:[1033]}})),_.registerAction2(class extends _.Action2{constructor(){super({id:"focusNextRenameSuggestion",title:{...y.localize2("focusNextRenameSuggestion","Focus Next Rename Suggestion")},precondition:N.CONTEXT_RENAME_INPUT_VISIBLE,keybinding:[{primary:18,weight:199}]})}run(e){const t=e.get(u.ICodeEditorService).getFocusedCodeEditor();if(!t)return;const i=L.get(t);i&&i.focusNextRenameSuggestion()}}),_.registerAction2(class extends _.Action2{constructor(){super({id:"focusPreviousRenameSuggestion",title:{...y.localize2("focusPreviousRenameSuggestion","Focus Previous Rename Suggestion")},precondition:N.CONTEXT_RENAME_INPUT_VISIBLE,keybinding:[{primary:16,weight:199}]})}run(e){const t=e.get(u.ICodeEditorService).getFocusedCodeEditor();if(!t)return;const i=L.get(t);i&&i.focusPreviousRenameSuggestion()}}),d.registerModelAndPositionCommand("_executeDocumentRenameProvider",(function(e,t,i,...r){const[o]=r;a.assertType("string"==typeof o);const{renameProvider:n}=e.get(v.ILanguageFeaturesService);return A(n,t,i,o)})),d.registerModelAndPositionCommand("_executePrepareRename",(async function(e,t,i){const{renameProvider:o}=e.get(v.ILanguageFeaturesService),n=new T(t,i,o),s=await n.resolveRenameLocation(r.CancellationToken.None);if(s?.rejectReason)throw new Error(s.rejectReason);return s})),j.Registry.as(E.Extensions.Configuration).registerConfiguration({id:"editor",properties:{"editor.rename.enablePreview":{scope:5,description:y.localize("enablePreview","Enable/disable the ability to preview changes before renaming"),default:!0,type:"boolean"}}}),exports.RenameAction=M,exports.rename=A;
//# sourceMappingURL=rename.js.map
