"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var e,t=require("../../../../base/common/lifecycle.js"),n=require("../../../../base/common/errors.js"),s=require("../../../common/services/model.js"),o=require("../../../../platform/configuration/common/configuration.js"),i=require("../../../../base/common/async.js"),r=require("../../../../base/common/cancellation.js"),c=require("../../../../platform/theme/common/themeService.js"),u=require("../../../common/services/semanticTokensProviderStyling.js"),a=require("../common/getSemanticTokens.js"),l=require("../../../common/services/languageFeatureDebounce.js"),h=require("../../../../base/common/stopwatch.js"),m=require("../../../common/services/languageFeatures.js"),d=require("../../../common/services/semanticTokensStyling.js"),_=require("../../../common/editorFeatures.js"),g=require("../common/semanticTokensConfig.js"),S=self&&self.__decorate||function(e,t,n,s){var o,i=arguments.length,r=i<3?t:null===s?s=Object.getOwnPropertyDescriptor(t,n):s;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,s);else for(var c=e.length-1;c>=0;c--)(o=e[c])&&(r=(i<3?o(r):i>3?o(t,n,r):o(t,n))||r);return i>3&&r&&Object.defineProperty(t,n,r),r},D=self&&self.__param||function(e,t){return function(n,s){t(n,s,e)}};exports.DocumentSemanticTokensFeature=class extends t.Disposable{constructor(e,t,n,s,o,i){super(),this._watchers=Object.create(null);const r=t=>{this._watchers[t.uri.toString()]=new f(t,e,n,o,i)},c=(e,t)=>{t.dispose(),delete this._watchers[e.uri.toString()]},u=()=>{for(const e of t.getModels()){const t=this._watchers[e.uri.toString()];g.isSemanticColoringEnabled(e,n,s)?t||r(e):t&&c(e,t)}};t.getModels().forEach((e=>{g.isSemanticColoringEnabled(e,n,s)&&r(e)})),this._register(t.onModelAdded((e=>{g.isSemanticColoringEnabled(e,n,s)&&r(e)}))),this._register(t.onModelRemoved((e=>{const t=this._watchers[e.uri.toString()];t&&c(e,t)}))),this._register(s.onDidChangeConfiguration((e=>{e.affectsConfiguration(g.SEMANTIC_HIGHLIGHTING_SETTING_ID)&&u()}))),this._register(n.onDidColorThemeChange(u))}dispose(){for(const e of Object.values(this._watchers))e.dispose();super.dispose()}},exports.DocumentSemanticTokensFeature=S([D(0,d.ISemanticTokensStylingService),D(1,s.IModelService),D(2,c.IThemeService),D(3,o.IConfigurationService),D(4,l.ILanguageFeatureDebounceService),D(5,m.ILanguageFeaturesService)],exports.DocumentSemanticTokensFeature);let f=class extends t.Disposable{static{e=this}static{this.REQUEST_MIN_DELAY=300}static{this.REQUEST_MAX_DELAY=2e3}constructor(n,s,o,r,c){super(),this._semanticTokensStylingService=s,this._isDisposed=!1,this._model=n,this._provider=c.documentSemanticTokensProvider,this._debounceInformation=r.for(this._provider,"DocumentSemanticTokens",{min:e.REQUEST_MIN_DELAY,max:e.REQUEST_MAX_DELAY}),this._fetchDocumentSemanticTokens=this._register(new i.RunOnceScheduler((()=>this._fetchDocumentSemanticTokensNow()),e.REQUEST_MIN_DELAY)),this._currentDocumentResponse=null,this._currentDocumentRequestCancellationTokenSource=null,this._documentProvidersChangeListeners=[],this._providersChangedDuringRequest=!1,this._register(this._model.onDidChangeContent((()=>{this._fetchDocumentSemanticTokens.isScheduled()||this._fetchDocumentSemanticTokens.schedule(this._debounceInformation.get(this._model))}))),this._register(this._model.onDidChangeAttached((()=>{this._fetchDocumentSemanticTokens.isScheduled()||this._fetchDocumentSemanticTokens.schedule(this._debounceInformation.get(this._model))}))),this._register(this._model.onDidChangeLanguage((()=>{this._currentDocumentResponse&&(this._currentDocumentResponse.dispose(),this._currentDocumentResponse=null),this._currentDocumentRequestCancellationTokenSource&&(this._currentDocumentRequestCancellationTokenSource.cancel(),this._currentDocumentRequestCancellationTokenSource=null),this._setDocumentSemanticTokens(null,null,null,[]),this._fetchDocumentSemanticTokens.schedule(0)})));const u=()=>{t.dispose(this._documentProvidersChangeListeners),this._documentProvidersChangeListeners=[];for(const e of this._provider.all(n))"function"==typeof e.onDidChange&&this._documentProvidersChangeListeners.push(e.onDidChange((()=>{this._currentDocumentRequestCancellationTokenSource?this._providersChangedDuringRequest=!0:this._fetchDocumentSemanticTokens.schedule(0)})))};u(),this._register(this._provider.onDidChange((()=>{u(),this._fetchDocumentSemanticTokens.schedule(this._debounceInformation.get(this._model))}))),this._register(o.onDidColorThemeChange((e=>{this._setDocumentSemanticTokens(null,null,null,[]),this._fetchDocumentSemanticTokens.schedule(this._debounceInformation.get(this._model))}))),this._fetchDocumentSemanticTokens.schedule(0)}dispose(){this._currentDocumentResponse&&(this._currentDocumentResponse.dispose(),this._currentDocumentResponse=null),this._currentDocumentRequestCancellationTokenSource&&(this._currentDocumentRequestCancellationTokenSource.cancel(),this._currentDocumentRequestCancellationTokenSource=null),t.dispose(this._documentProvidersChangeListeners),this._documentProvidersChangeListeners=[],this._setDocumentSemanticTokens(null,null,null,[]),this._isDisposed=!0,super.dispose()}_fetchDocumentSemanticTokensNow(){if(this._currentDocumentRequestCancellationTokenSource)return;if(!a.hasDocumentSemanticTokensProvider(this._provider,this._model))return void(this._currentDocumentResponse&&this._model.tokenization.setSemanticTokens(null,!1));if(!this._model.isAttachedToEditor())return;const e=new r.CancellationTokenSource,t=this._currentDocumentResponse?this._currentDocumentResponse.provider:null,s=this._currentDocumentResponse&&this._currentDocumentResponse.resultId||null,o=a.getDocumentSemanticTokens(this._provider,this._model,t,s,e.token);this._currentDocumentRequestCancellationTokenSource=e,this._providersChangedDuringRequest=!1;const i=[],c=this._model.onDidChangeContent((e=>{i.push(e)})),u=new h.StopWatch(!1);o.then((e=>{if(this._debounceInformation.update(this._model,u.elapsed()),this._currentDocumentRequestCancellationTokenSource=null,c.dispose(),e){const{provider:t,tokens:n}=e,s=this._semanticTokensStylingService.getStyling(t);this._setDocumentSemanticTokens(t,n||null,s,i)}else this._setDocumentSemanticTokens(null,null,null,i)}),(e=>{e&&(n.isCancellationError(e)||"string"==typeof e.message&&-1!==e.message.indexOf("busy"))||n.onUnexpectedError(e),this._currentDocumentRequestCancellationTokenSource=null,c.dispose(),(i.length>0||this._providersChangedDuringRequest)&&(this._fetchDocumentSemanticTokens.isScheduled()||this._fetchDocumentSemanticTokens.schedule(this._debounceInformation.get(this._model)))}))}static _copy(e,t,n,s,o){o=Math.min(o,n.length-s,e.length-t);for(let i=0;i<o;i++)n[s+i]=e[t+i]}_setDocumentSemanticTokens(t,n,s,o){const i=this._currentDocumentResponse,r=()=>{(o.length>0||this._providersChangedDuringRequest)&&!this._fetchDocumentSemanticTokens.isScheduled()&&this._fetchDocumentSemanticTokens.schedule(this._debounceInformation.get(this._model))};if(this._currentDocumentResponse&&(this._currentDocumentResponse.dispose(),this._currentDocumentResponse=null),this._isDisposed)t&&n&&t.releaseDocumentSemanticTokens(n.resultId);else if(t&&s){if(!n)return this._model.tokenization.setSemanticTokens(null,!0),void r();if(a.isSemanticTokensEdits(n)){if(!i)return void this._model.tokenization.setSemanticTokens(null,!0);if(0===n.edits.length)n={resultId:n.resultId,data:i.data};else{let t=0;for(const e of n.edits)t+=(e.data?e.data.length:0)-e.deleteCount;const o=i.data,r=new Uint32Array(o.length+t);let c=o.length,u=r.length;for(let t=n.edits.length-1;t>=0;t--){const a=n.edits[t];if(a.start>o.length)return s.warnInvalidEditStart(i.resultId,n.resultId,t,a.start,o.length),void this._model.tokenization.setSemanticTokens(null,!0);const l=c-(a.start+a.deleteCount);l>0&&(e._copy(o,c-l,r,u-l,l),u-=l),a.data&&(e._copy(a.data,0,r,u-a.data.length,a.data.length),u-=a.data.length),c=a.start}c>0&&e._copy(o,0,r,0,c),n={resultId:n.resultId,data:r}}}if(a.isSemanticTokens(n)){this._currentDocumentResponse=new p(t,n.resultId,n.data);const e=u.toMultilineTokens2(n,s,this._model.getLanguageId());if(o.length>0)for(const t of o)for(const n of e)for(const e of t.changes)n.applyEdit(e.range,e.text);this._model.tokenization.setSemanticTokens(e,!0)}else this._model.tokenization.setSemanticTokens(null,!0);r()}else this._model.tokenization.setSemanticTokens(null,!1)}};f=e=S([D(1,d.ISemanticTokensStylingService),D(2,c.IThemeService),D(3,l.ILanguageFeatureDebounceService),D(4,m.ILanguageFeaturesService)],f);class p{constructor(e,t,n){this.provider=e,this.resultId=t,this.data=n}dispose(){this.provider.releaseDocumentSemanticTokens(this.resultId)}}_.registerEditorFeature(exports.DocumentSemanticTokensFeature);
//# sourceMappingURL=documentSemanticTokens.js.map
