"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var e,t=require("../../../../base/common/arrays.js"),n=require("../../../../base/common/cancellation.js"),o=require("../../../../base/common/errors.js"),i=require("../../../browser/editorExtensions.js"),r=require("../../../common/core/position.js"),s=require("../../../common/core/range.js"),a=require("../../../common/core/selection.js"),c=require("../../../common/editorContextKeys.js"),l=require("./bracketSelections.js"),u=require("./wordSelections.js"),d=require("../../../../nls.js"),g=require("../../../../platform/actions/common/actions.js"),m=require("../../../../platform/commands/common/commands.js"),h=require("../../../common/services/languageFeatures.js"),p=require("../../../common/services/resolverService.js"),S=require("../../../../base/common/types.js"),f=require("../../../../base/common/uri.js"),b=self&&self.__decorate||function(e,t,n,o){var i,r=arguments.length,s=r<3?t:null===o?o=Object.getOwnPropertyDescriptor(t,n):o;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)s=Reflect.decorate(e,t,n,o);else for(var a=e.length-1;a>=0;a--)(i=e[a])&&(s=(r<3?i(s):r>3?i(t,n,s):i(t,n))||s);return r>3&&s&&Object.defineProperty(t,n,s),s},_=self&&self.__param||function(e,t){return function(n,o){t(n,o,e)}};class x{constructor(e,t){this.index=e,this.ranges=t}mov(e){const t=this.index+(e?1:-1);if(t<0||t>=this.ranges.length)return this;const n=new x(t,this.ranges);return n.ranges[t].equalsRange(this.ranges[this.index])?n.mov(e):n}}exports.SmartSelectController=class{static{e=this}static{this.ID="editor.contrib.smartSelectController"}static get(t){return t.getContribution(e.ID)}constructor(e,t){this._editor=e,this._languageFeaturesService=t,this._ignoreSelection=!1}dispose(){this._selectionListener?.dispose()}async run(e){if(!this._editor.hasModel())return;const o=this._editor.getSelections(),i=this._editor.getModel();if(this._state||await R(this._languageFeaturesService.selectionRangeProvider,i,o.map((e=>e.getPosition())),this._editor.getOption(114),n.CancellationToken.None).then((e=>{if(t.isNonEmptyArray(e)&&e.length===o.length&&this._editor.hasModel()&&t.equals(this._editor.getSelections(),o,((e,t)=>e.equalsSelection(t)))){for(let t=0;t<e.length;t++)e[t]=e[t].filter((e=>e.containsPosition(o[t].getStartPosition())&&e.containsPosition(o[t].getEndPosition()))),e[t].unshift(o[t]);this._state=e.map((e=>new x(0,e))),this._selectionListener?.dispose(),this._selectionListener=this._editor.onDidChangeCursorPosition((()=>{this._ignoreSelection||(this._selectionListener?.dispose(),this._state=void 0)}))}})),!this._state)return;this._state=this._state.map((t=>t.mov(e)));const r=this._state.map((e=>a.Selection.fromPositions(e.ranges[e.index].getStartPosition(),e.ranges[e.index].getEndPosition())));this._ignoreSelection=!0;try{this._editor.setSelections(r)}finally{this._ignoreSelection=!1}}},exports.SmartSelectController=e=b([_(1,h.ILanguageFeaturesService)],exports.SmartSelectController);class y extends i.EditorAction{constructor(e,t){super(t),this._forward=e}async run(e,t){const n=exports.SmartSelectController.get(t);n&&await n.run(this._forward)}}m.CommandsRegistry.registerCommandAlias("editor.action.smartSelect.grow","editor.action.smartSelect.expand");async function R(e,n,i,a,c){const d=e.all(n).concat(new u.WordSelectionRangeProvider(a.selectSubwords));1===d.length&&d.unshift(new l.BracketSelectionRangeProvider);const g=[],m=[];for(const e of d)g.push(Promise.resolve(e.provideSelectionRanges(n,i,c)).then((e=>{if(t.isNonEmptyArray(e)&&e.length===i.length)for(let t=0;t<i.length;t++){m[t]||(m[t]=[]);for(const n of e[t])s.Range.isIRange(n.range)&&s.Range.containsPosition(n.range,i[t])&&m[t].push(s.Range.lift(n.range))}}),o.onUnexpectedExternalError));return await Promise.all(g),m.map((e=>{if(0===e.length)return[];e.sort(((e,t)=>r.Position.isBefore(e.getStartPosition(),t.getStartPosition())?1:r.Position.isBefore(t.getStartPosition(),e.getStartPosition())||r.Position.isBefore(e.getEndPosition(),t.getEndPosition())?-1:r.Position.isBefore(t.getEndPosition(),e.getEndPosition())?1:0));const t=[];let o;for(const n of e)(!o||s.Range.containsRange(n,o)&&!s.Range.equalsRange(n,o))&&(t.push(n),o=n);if(!a.selectLeadingAndTrailingWhitespace)return t;const i=[t[0]];for(let e=1;e<t.length;e++){const o=t[e-1],r=t[e];if(r.startLineNumber!==o.startLineNumber||r.endLineNumber!==o.endLineNumber){const e=new s.Range(o.startLineNumber,n.getLineFirstNonWhitespaceColumn(o.startLineNumber),o.endLineNumber,n.getLineLastNonWhitespaceColumn(o.endLineNumber));e.containsRange(o)&&!e.equalsRange(o)&&r.containsRange(e)&&!r.equalsRange(e)&&i.push(e);const t=new s.Range(o.startLineNumber,1,o.endLineNumber,n.getLineMaxColumn(o.endLineNumber));t.containsRange(o)&&!t.equalsRange(e)&&r.containsRange(t)&&!r.equalsRange(t)&&i.push(t)}i.push(r)}return i}))}i.registerEditorContribution(exports.SmartSelectController.ID,exports.SmartSelectController,4),i.registerEditorAction(class extends y{constructor(){super(!0,{id:"editor.action.smartSelect.expand",label:d.localize("smartSelect.expand","Expand Selection"),alias:"Expand Selection",precondition:void 0,kbOpts:{kbExpr:c.EditorContextKeys.editorTextFocus,primary:1553,mac:{primary:3345,secondary:[1297]},weight:100},menuOpts:{menuId:g.MenuId.MenubarSelectionMenu,group:"1_basic",title:d.localize({key:"miSmartSelectGrow",comment:["&& denotes a mnemonic"]},"&&Expand Selection"),order:2}})}}),i.registerEditorAction(class extends y{constructor(){super(!1,{id:"editor.action.smartSelect.shrink",label:d.localize("smartSelect.shrink","Shrink Selection"),alias:"Shrink Selection",precondition:void 0,kbOpts:{kbExpr:c.EditorContextKeys.editorTextFocus,primary:1551,mac:{primary:3343,secondary:[1295]},weight:100},menuOpts:{menuId:g.MenuId.MenubarSelectionMenu,group:"1_basic",title:d.localize({key:"miSmartSelectShrink",comment:["&& denotes a mnemonic"]},"&&Shrink Selection"),order:3}})}}),m.CommandsRegistry.registerCommand("_executeSelectionRangeProvider",(async function(e,...t){const[o,i]=t;S.assertType(f.URI.isUri(o));const r=e.get(h.ILanguageFeaturesService).selectionRangeProvider,s=await e.get(p.ITextModelService).createModelReference(o);try{return R(r,s.object.textEditorModel,i,{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},n.CancellationToken.None)}finally{s.dispose()}})),exports.provideSelectionRanges=R;
//# sourceMappingURL=smartSelect.js.map
