"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var e,t=require("../../../../base/common/lifecycle.js"),i=require("../../../../base/common/types.js"),s=require("../../../browser/editorExtensions.js"),o=require("../../../common/core/position.js"),n=require("../../../common/editorContextKeys.js"),r=require("../../../common/languages/languageConfigurationRegistry.js"),p=require("../../../common/services/languageFeatures.js"),a=require("../../suggest/browser/suggest.js"),h=require("../../../../nls.js"),l=require("../../../../platform/contextkey/common/contextkey.js"),c=require("../../../../platform/log/common/log.js"),d=require("./snippetSession.js"),_=self&&self.__decorate||function(e,t,i,s){var o,n=arguments.length,r=n<3?t:null===s?s=Object.getOwnPropertyDescriptor(t,i):s;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,i,s);else for(var p=e.length-1;p>=0;p--)(o=e[p])&&(r=(n<3?o(r):n>3?o(t,i,r):o(t,i))||r);return n>3&&r&&Object.defineProperty(t,i,r),r},u=self&&self.__param||function(e,t){return function(i,s){t(i,s,e)}};const g={overwriteBefore:0,overwriteAfter:0,undoStopBefore:!0,undoStopAfter:!0,adjustWhitespace:!0,clipboardText:void 0,overtypingCapturer:void 0};exports.SnippetController2=class{static{e=this}static{this.ID="snippetController2"}static get(t){return t.getContribution(e.ID)}static{this.InSnippetMode=new l.RawContextKey("inSnippetMode",!1,h.localize("inSnippetMode","Whether the editor in current in snippet mode"))}static{this.HasNextTabstop=new l.RawContextKey("hasNextTabstop",!1,h.localize("hasNextTabstop","Whether there is a next tab stop when in snippet mode"))}static{this.HasPrevTabstop=new l.RawContextKey("hasPrevTabstop",!1,h.localize("hasPrevTabstop","Whether there is a previous tab stop when in snippet mode"))}constructor(i,s,o,n,r){this._editor=i,this._logService=s,this._languageFeaturesService=o,this._languageConfigurationService=r,this._snippetListener=new t.DisposableStore,this._modelVersionId=-1,this._inSnippet=e.InSnippetMode.bindTo(n),this._hasNextTabstop=e.HasNextTabstop.bindTo(n),this._hasPrevTabstop=e.HasPrevTabstop.bindTo(n)}dispose(){this._inSnippet.reset(),this._hasPrevTabstop.reset(),this._hasNextTabstop.reset(),this._session?.dispose(),this._snippetListener.dispose()}insert(e,t){try{this._doInsert(e,void 0===t?g:{...g,...t})}catch(t){this.cancel(),this._logService.error(t),this._logService.error("snippet_error"),this._logService.error("insert_template=",e),this._logService.error("existing_template=",this._session?this._session._logInfo():"<no_session>")}}_doInsert(e,t){if(this._editor.hasModel()){if(this._snippetListener.clear(),t.undoStopBefore&&this._editor.getModel().pushStackElement(),this._session&&"string"!=typeof e&&this.cancel(),this._session?(i.assertType("string"==typeof e),this._session.merge(e,t)):(this._modelVersionId=this._editor.getModel().getAlternativeVersionId(),this._session=new d.SnippetSession(this._editor,e,t,this._languageConfigurationService),this._session.insert()),t.undoStopAfter&&this._editor.getModel().pushStackElement(),this._session?.hasChoice){const e={_debugDisplayName:"snippetChoiceCompletions",provideCompletionItems:(e,t)=>{if(!this._session||e!==this._editor.getModel()||!o.Position.equals(this._editor.getPosition(),t))return;const{activeChoice:i}=this._session;if(!i||0===i.choice.options.length)return;const s=e.getValueInRange(i.range),n=Boolean(i.choice.options.find((e=>e.value===s))),r=[];for(let e=0;e<i.choice.options.length;e++){const t=i.choice.options[e];r.push({kind:13,label:t.value,insertText:t.value,sortText:"a".repeat(e+1),range:i.range,filterText:n?`${s}_${t.value}`:void 0,command:{id:"jumpToNextSnippetPlaceholder",title:h.localize("next","Go to next placeholder...")}})}return{suggestions:r}}},t=this._editor.getModel();let i,s=!1;const n=()=>{i?.dispose(),s=!1},r=()=>{s||(i=this._languageFeaturesService.completionProvider.register({language:t.getLanguageId(),pattern:t.uri.fsPath,scheme:t.uri.scheme,exclusive:!0},e),this._snippetListener.add(i),s=!0)};this._choiceCompletions={provider:e,enable:r,disable:n}}this._updateState(),this._snippetListener.add(this._editor.onDidChangeModelContent((e=>e.isFlush&&this.cancel()))),this._snippetListener.add(this._editor.onDidChangeModel((()=>this.cancel()))),this._snippetListener.add(this._editor.onDidChangeCursorSelection((()=>this._updateState())))}}_updateState(){if(this._session&&this._editor.hasModel()){if(this._modelVersionId===this._editor.getModel().getAlternativeVersionId())return this.cancel();if(!this._session.hasPlaceholder)return this.cancel();if(this._session.isAtLastPlaceholder||!this._session.isSelectionWithinPlaceholders())return this._editor.getModel().pushStackElement(),this.cancel();this._inSnippet.set(!0),this._hasPrevTabstop.set(!this._session.isAtFirstPlaceholder),this._hasNextTabstop.set(!this._session.isAtLastPlaceholder),this._handleChoice()}}_handleChoice(){if(!this._session||!this._editor.hasModel())return void(this._currentChoice=void 0);const{activeChoice:e}=this._session;if(!e||!this._choiceCompletions)return this._choiceCompletions?.disable(),void(this._currentChoice=void 0);this._currentChoice!==e.choice&&(this._currentChoice=e.choice,this._choiceCompletions.enable(),queueMicrotask((()=>{a.showSimpleSuggestions(this._editor,this._choiceCompletions.provider)})))}finish(){for(;this._inSnippet.get();)this.next()}cancel(e=!1){this._inSnippet.reset(),this._hasPrevTabstop.reset(),this._hasNextTabstop.reset(),this._snippetListener.clear(),this._currentChoice=void 0,this._session?.dispose(),this._session=void 0,this._modelVersionId=-1,e&&this._editor.setSelections([this._editor.getSelection()])}prev(){this._session?.prev(),this._updateState()}next(){this._session?.next(),this._updateState()}isInSnippet(){return Boolean(this._inSnippet.get())}},exports.SnippetController2=e=_([u(1,c.ILogService),u(2,p.ILanguageFeaturesService),u(3,l.IContextKeyService),u(4,r.ILanguageConfigurationService)],exports.SnippetController2),s.registerEditorContribution(exports.SnippetController2.ID,exports.SnippetController2,4);const S=s.EditorCommand.bindToContribution(exports.SnippetController2.get);s.registerEditorCommand(new S({id:"jumpToNextSnippetPlaceholder",precondition:l.ContextKeyExpr.and(exports.SnippetController2.InSnippetMode,exports.SnippetController2.HasNextTabstop),handler:e=>e.next(),kbOpts:{weight:130,kbExpr:n.EditorContextKeys.textInputFocus,primary:2}})),s.registerEditorCommand(new S({id:"jumpToPrevSnippetPlaceholder",precondition:l.ContextKeyExpr.and(exports.SnippetController2.InSnippetMode,exports.SnippetController2.HasPrevTabstop),handler:e=>e.prev(),kbOpts:{weight:130,kbExpr:n.EditorContextKeys.textInputFocus,primary:1026}})),s.registerEditorCommand(new S({id:"leaveSnippet",precondition:exports.SnippetController2.InSnippetMode,handler:e=>e.cancel(!0),kbOpts:{weight:130,kbExpr:n.EditorContextKeys.textInputFocus,primary:9,secondary:[1033]}})),s.registerEditorCommand(new S({id:"acceptSnippet",precondition:exports.SnippetController2.InSnippetMode,handler:e=>e.finish()}));
//# sourceMappingURL=snippetController2.js.map
