"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var e,t,r=require("../../../../base/common/lifecycle.js"),i=require("../../../common/services/languageFeatures.js"),o=require("../../documentSymbols/browser/outlineModel.js"),s=require("../../../../base/common/async.js"),n=require("../../folding/browser/folding.js"),l=require("../../folding/browser/syntaxRangeProvider.js"),d=require("../../folding/browser/indentRangeProvider.js"),a=require("../../../common/languages/languageConfigurationRegistry.js"),c=require("../../../../base/common/errors.js"),u=require("./stickyScrollElement.js"),m=require("../../../../base/common/iterator.js"),h=require("../../../../platform/instantiation/common/instantiation.js"),g=self&&self.__decorate||function(e,t,r,i){var o,s=arguments.length,n=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,r):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)n=Reflect.decorate(e,t,r,i);else for(var l=e.length-1;l>=0;l--)(o=e[l])&&(n=(s<3?o(n):s>3?o(t,r,n):o(t,r))||n);return s>3&&n&&Object.defineProperty(t,r,n),n},_=self&&self.__param||function(e,t){return function(r,i){t(r,i,e)}};!function(e){e.OUTLINE_MODEL="outlineModel",e.FOLDING_PROVIDER_MODEL="foldingProviderModel",e.INDENTATION_MODEL="indentationModel"}(e||(e={})),function(e){e[e.VALID=0]="VALID",e[e.INVALID=1]="INVALID",e[e.CANCELED=2]="CANCELED"}(t||(t={})),exports.StickyModelProvider=class extends r.Disposable{constructor(t,i,o,n){switch(super(),this._editor=t,this._modelProviders=[],this._modelPromise=null,this._updateScheduler=this._register(new s.Delayer(300)),this._updateOperation=this._register(new r.DisposableStore),this._editor.getOption(116).defaultModel){case e.OUTLINE_MODEL:this._modelProviders.push(new f(this._editor,n));case e.FOLDING_PROVIDER_MODEL:this._modelProviders.push(new b(this._editor,i,n));case e.INDENTATION_MODEL:this._modelProviders.push(new v(this._editor,o))}}dispose(){this._modelProviders.forEach((e=>e.dispose())),this._updateOperation.clear(),this._cancelModelPromise(),super.dispose()}_cancelModelPromise(){this._modelPromise&&(this._modelPromise.cancel(),this._modelPromise=null)}async update(e){return this._updateOperation.clear(),this._updateOperation.add({dispose:()=>{this._cancelModelPromise(),this._updateScheduler.cancel()}}),this._cancelModelPromise(),await this._updateScheduler.trigger((async()=>{for(const r of this._modelProviders){const{statusPromise:i,modelPromise:o}=r.computeStickyModel(e);this._modelPromise=o;const s=await i;if(this._modelPromise!==o)return null;switch(s){case t.CANCELED:return this._updateOperation.clear(),null;case t.VALID:return r.stickyModel}}return null})).catch((e=>(c.onUnexpectedError(e),null)))}},exports.StickyModelProvider=g([_(2,h.IInstantiationService),_(3,i.ILanguageFeaturesService)],exports.StickyModelProvider);class p extends r.Disposable{constructor(e){super(),this._editor=e,this._stickyModel=null}get stickyModel(){return this._stickyModel}_invalid(){return this._stickyModel=null,t.INVALID}computeStickyModel(e){if(e.isCancellationRequested||!this.isProviderValid())return{statusPromise:this._invalid(),modelPromise:null};const r=s.createCancelablePromise((e=>this.createModelFromProvider(e)));return{statusPromise:r.then((r=>this.isModelValid(r)?e.isCancellationRequested?t.CANCELED:(this._stickyModel=this.createStickyModel(e,r),t.VALID):this._invalid())).then(void 0,(e=>(c.onUnexpectedError(e),t.CANCELED))),modelPromise:r}}isModelValid(e){return!0}isProviderValid(){return!0}}let f=class extends p{constructor(e,t){super(e),this._languageFeaturesService=t}createModelFromProvider(e){return o.OutlineModel.create(this._languageFeaturesService.documentSymbolProvider,this._editor.getModel(),e)}createStickyModel(e,t){const{stickyOutlineElement:r,providerID:i}=this._stickyModelFromOutlineModel(t,this._stickyModel?.outlineProviderId),o=this._editor.getModel();return new u.StickyModel(o.uri,o.getVersionId(),r,i)}isModelValid(e){return e&&e.children.size>0}_stickyModelFromOutlineModel(e,t){let r;if(m.Iterable.first(e.children.values())instanceof o.OutlineGroup){const i=m.Iterable.find(e.children.values(),(e=>e.id===t));if(i)r=i.children;else{let i,o="",s=-1;for(const[t,r]of e.children.entries()){const e=this._findSumOfRangesOfGroup(r);e>s&&(i=r,s=e,o=r.id)}t=o,r=i.children}}else r=e.children;const i=[],s=Array.from(r.values()).sort(((e,t)=>{const r=new u.StickyRange(e.symbol.range.startLineNumber,e.symbol.range.endLineNumber),i=new u.StickyRange(t.symbol.range.startLineNumber,t.symbol.range.endLineNumber);return this._comparator(r,i)}));for(const e of s)i.push(this._stickyModelFromOutlineElement(e,e.symbol.selectionRange.startLineNumber));return{stickyOutlineElement:new u.StickyElement(void 0,i,void 0),providerID:t}}_stickyModelFromOutlineElement(e,t){const r=[];for(const i of e.children.values())if(i.symbol.selectionRange.startLineNumber!==i.symbol.range.endLineNumber)if(i.symbol.selectionRange.startLineNumber!==t)r.push(this._stickyModelFromOutlineElement(i,i.symbol.selectionRange.startLineNumber));else for(const e of i.children.values())r.push(this._stickyModelFromOutlineElement(e,i.symbol.selectionRange.startLineNumber));r.sort(((e,t)=>this._comparator(e.range,t.range)));const i=new u.StickyRange(e.symbol.selectionRange.startLineNumber,e.symbol.range.endLineNumber);return new u.StickyElement(i,r,void 0)}_comparator(e,t){return e.startLineNumber!==t.startLineNumber?e.startLineNumber-t.startLineNumber:t.endLineNumber-e.endLineNumber}_findSumOfRangesOfGroup(e){let t=0;for(const r of e.children.values())t+=this._findSumOfRangesOfGroup(r);return e instanceof o.OutlineElement?t+e.symbol.range.endLineNumber-e.symbol.selectionRange.startLineNumber:t}};f=g([_(1,i.ILanguageFeaturesService)],f);class y extends p{constructor(e){super(e),this._foldingLimitReporter=new n.RangesLimitReporter(e)}createStickyModel(e,t){const r=this._fromFoldingRegions(t),i=this._editor.getModel();return new u.StickyModel(i.uri,i.getVersionId(),r,void 0)}isModelValid(e){return null!==e}_fromFoldingRegions(e){const t=e.length,r=[],i=new u.StickyElement(void 0,[],void 0);for(let o=0;o<t;o++){const t=e.getParentIndex(o);let s;s=-1!==t?r[t]:i;const n=new u.StickyElement(new u.StickyRange(e.getStartLineNumber(o),e.getEndLineNumber(o)+1),[],s);s.children.push(n),r.push(n)}return i}}let v=class extends y{constructor(e,t){super(e),this._languageConfigurationService=t,this.provider=this._register(new d.IndentRangeProvider(e.getModel(),this._languageConfigurationService,this._foldingLimitReporter))}async createModelFromProvider(e){return this.provider.compute(e)}};v=g([_(1,a.ILanguageConfigurationService)],v);let b=class extends y{constructor(e,t,r){super(e),this._languageFeaturesService=r;const i=n.FoldingController.getFoldingRangeProviders(this._languageFeaturesService,e.getModel());i.length>0&&(this.provider=this._register(new l.SyntaxRangeProvider(e.getModel(),i,t,this._foldingLimitReporter,void 0)))}isProviderValid(){return void 0!==this.provider}async createModelFromProvider(e){return this.provider?.compute(e)??null}};b=g([_(2,i.ILanguageFeaturesService)],b);
//# sourceMappingURL=stickyScrollModelProvider.js.map
