"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var e=require("../../../../base/common/cancellation.js"),t=require("../../../../base/common/errors.js"),s=require("../../../../base/common/filters.js"),i=require("../../../../base/common/lifecycle.js"),n=require("../../../../base/common/stopwatch.js"),o=require("../../../../base/common/types.js"),r=require("../../../../base/common/uri.js"),a=require("../../../common/core/position.js"),l=require("../../../common/core/range.js"),u=require("../../../common/services/resolverService.js"),c=require("../../snippet/browser/snippetParser.js"),g=require("../../../../nls.js"),d=require("../../../../platform/actions/common/actions.js"),p=require("../../../../platform/commands/common/commands.js"),m=require("../../../../platform/contextkey/common/contextkey.js"),h=require("../../../common/services/languageFeatures.js");const v={Visible:require("../../../../platform/history/browser/contextScopedHistoryWidget.js").historyNavigationVisible,HasFocusedSuggestion:new m.RawContextKey("suggestWidgetHasFocusedSuggestion",!1,g.localize("suggestWidgetHasSelection","Whether any suggestion is focused")),DetailsVisible:new m.RawContextKey("suggestWidgetDetailsVisible",!1,g.localize("suggestWidgetDetailsVisible","Whether suggestion details are visible")),MultipleSuggestions:new m.RawContextKey("suggestWidgetMultipleSuggestions",!1,g.localize("suggestWidgetMultipleSuggestions","Whether there are multiple suggestions to pick from")),MakesTextEdit:new m.RawContextKey("suggestionMakesTextEdit",!0,g.localize("suggestionMakesTextEdit","Whether inserting the current suggestion yields in a change or has everything already been typed")),AcceptSuggestionsOnEnter:new m.RawContextKey("acceptSuggestionOnEnter",!0,g.localize("acceptSuggestionOnEnter","Whether suggestions are inserted when pressing Enter")),HasInsertAndReplaceRange:new m.RawContextKey("suggestionHasInsertAndReplaceRange",!1,g.localize("suggestionHasInsertAndReplaceRange","Whether the current suggestion has insert and replace behaviour")),InsertMode:new m.RawContextKey("suggestionInsertMode",void 0,{type:"string",description:g.localize("suggestionInsertMode","Whether the default behaviour is to insert or replace")}),CanResolve:new m.RawContextKey("suggestionCanResolve",!1,g.localize("suggestionCanResolve","Whether the current suggestion supports to resolve further details"))},f=new d.MenuId("suggestWidgetStatusBar");class b{constructor(e,t,i,n){this.position=e,this.completion=t,this.container=i,this.provider=n,this.isInvalid=!1,this.score=s.FuzzyScore.Default,this.distance=0,this.textLabel="string"==typeof t.label?t.label:t.label?.label,this.labelLow=this.textLabel.toLowerCase(),this.isInvalid=!this.textLabel,this.sortTextLow=t.sortText&&t.sortText.toLowerCase(),this.filterTextLow=t.filterText&&t.filterText.toLowerCase(),this.extensionId=t.extensionId,l.Range.isIRange(t.range)?(this.editStart=new a.Position(t.range.startLineNumber,t.range.startColumn),this.editInsertEnd=new a.Position(t.range.endLineNumber,t.range.endColumn),this.editReplaceEnd=new a.Position(t.range.endLineNumber,t.range.endColumn),this.isInvalid=this.isInvalid||l.Range.spansMultipleLines(t.range)||t.range.startLineNumber!==e.lineNumber):(this.editStart=new a.Position(t.range.insert.startLineNumber,t.range.insert.startColumn),this.editInsertEnd=new a.Position(t.range.insert.endLineNumber,t.range.insert.endColumn),this.editReplaceEnd=new a.Position(t.range.replace.endLineNumber,t.range.replace.endColumn),this.isInvalid=this.isInvalid||l.Range.spansMultipleLines(t.range.insert)||l.Range.spansMultipleLines(t.range.replace)||t.range.insert.startLineNumber!==e.lineNumber||t.range.replace.startLineNumber!==e.lineNumber||t.range.insert.startColumn!==t.range.replace.startColumn),"function"!=typeof n.resolveCompletionItem&&(this._resolveCache=Promise.resolve(),this._resolveDuration=0)}get isResolved(){return void 0!==this._resolveDuration}get resolveDuration(){return void 0!==this._resolveDuration?this._resolveDuration:-1}async resolve(e){if(!this._resolveCache){const s=e.onCancellationRequested((()=>{this._resolveCache=void 0,this._resolveDuration=void 0})),i=new n.StopWatch(!0);this._resolveCache=Promise.resolve(this.provider.resolveCompletionItem(this.completion,e)).then((e=>{Object.assign(this.completion,e),this._resolveDuration=i.elapsed()}),(e=>{t.isCancellationError(e)&&(this._resolveCache=void 0,this._resolveDuration=void 0)})).finally((()=>{s.dispose()}))}return this._resolveCache}}class w{static{this.default=new w}constructor(e=2,t=new Set,s=new Set,i=new Map,n=!0){this.snippetSortOrder=e,this.kindFilter=t,this.providerFilter=s,this.providerItemsToReuse=i,this.showDeprecated=n}}class x{constructor(e,t,s,i){this.items=e,this.needsClipboard=t,this.durations=s,this.disposable=i}}async function C(s,o,r,a=w.default,u={triggerKind:0},g=e.CancellationToken.None){const d=new n.StopWatch;r=r.clone();const p=o.getWordAtPosition(r),m=p?new l.Range(r.lineNumber,p.startColumn,r.lineNumber,p.endColumn):l.Range.fromPositions(r),h={replace:m,insert:m.setEndPosition(r.lineNumber,r.column)},v=[],f=new i.DisposableStore,C=[];let y=!1;const R=(e,t,s)=>{let n=!1;if(!t)return n;for(const s of t.suggestions)if(!a.kindFilter.has(s.kind)){if(!a.showDeprecated&&s?.tags?.includes(1))continue;s.range||(s.range=h),s.sortText||(s.sortText="string"==typeof s.label?s.label:s.label.label),!y&&s.insertTextRules&&4&s.insertTextRules&&(y=c.SnippetParser.guessNeedsClipboard(s.insertText)),v.push(new b(r,s,t,e)),n=!0}return i.isDisposable(t)&&f.add(t),C.push({providerName:e._debugDisplayName??"unknown_provider",elapsedProvider:t.duration??-1,elapsedOverall:s.elapsed()}),n},I=(async()=>{})();for(const e of s.orderedGroups(o)){let s=!1;if(await Promise.all(e.map((async e=>{if(a.providerItemsToReuse.has(e)){const t=a.providerItemsToReuse.get(e);return t.forEach((e=>v.push(e))),void(s=s||t.length>0)}if(!(a.providerFilter.size>0)||a.providerFilter.has(e))try{const t=new n.StopWatch,i=await e.provideCompletionItems(o,r,u,g);s=R(e,i,t)||s}catch(e){t.onUnexpectedExternalError(e)}}))),s||g.isCancellationRequested)break}return await I,g.isCancellationRequested?(f.dispose(),Promise.reject(new t.CancellationError)):new x(v.sort(S(a.snippetSortOrder)),y,{entries:C,elapsed:d.elapsed()},f)}function y(e,t){if(e.sortTextLow&&t.sortTextLow){if(e.sortTextLow<t.sortTextLow)return-1;if(e.sortTextLow>t.sortTextLow)return 1}return e.textLabel<t.textLabel?-1:e.textLabel>t.textLabel?1:e.completion.kind-t.completion.kind}const R=new Map;function S(e){return R.get(e)}R.set(0,(function(e,t){if(e.completion.kind!==t.completion.kind){if(27===e.completion.kind)return-1;if(27===t.completion.kind)return 1}return y(e,t)})),R.set(2,(function(e,t){if(e.completion.kind!==t.completion.kind){if(27===e.completion.kind)return 1;if(27===t.completion.kind)return-1}return y(e,t)})),R.set(1,y),p.CommandsRegistry.registerCommand("_executeCompletionItemProvider",(async(t,...s)=>{const[i,n,l,c]=s;o.assertType(r.URI.isUri(i)),o.assertType(a.Position.isIPosition(n)),o.assertType("string"==typeof l||!l),o.assertType("number"==typeof c||!c);const{completionProvider:g}=t.get(h.ILanguageFeaturesService),d=await t.get(u.ITextModelService).createModelReference(i);try{const t={incomplete:!1,suggestions:[]},s=[],i=d.object.textEditorModel.validatePosition(n),o=await C(g,d.object.textEditorModel,i,void 0,{triggerCharacter:l??void 0,triggerKind:l?1:0});for(const i of o.items)s.length<(c??0)&&s.push(i.resolve(e.CancellationToken.None)),t.incomplete=t.incomplete||i.container.incomplete,t.suggestions.push(i.completion);try{return await Promise.all(s),t}finally{setTimeout((()=>o.disposable.dispose()),100)}}finally{d.dispose()}}));exports.CompletionItem=b,exports.CompletionItemModel=x,exports.CompletionOptions=w,exports.Context=v,exports.QuickSuggestionsOptions=class{static isAllOff(e){return"off"===e.other&&"off"===e.comments&&"off"===e.strings}static isAllOn(e){return"on"===e.other&&"on"===e.comments&&"on"===e.strings}static valueFor(e,t){switch(t){case 1:return e.comments;case 2:return e.strings;default:return e.other}}},exports.getSuggestionComparator=S,exports.provideSuggestionItems=C,exports.showSimpleSuggestions=function(e,t){e.getContribution("editor.contrib.suggestController")?.triggerSuggest((new Set).add(t),void 0,!0)},exports.suggestWidgetStatusbarMenu=f;
//# sourceMappingURL=suggest.js.map
