"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var e,t=require("../../../../base/browser/ui/aria/aria.js"),i=require("../../../../base/common/arrays.js"),o=require("../../../../base/common/cancellation.js"),s=require("../../../../base/common/errors.js"),n=require("../../../../base/common/event.js"),r=require("../../../../base/common/keybindings.js"),d=require("../../../../base/common/lifecycle.js"),a=require("../../../../base/common/platform.js"),l=require("../../../../base/common/stopwatch.js"),g=require("../../../../base/common/types.js"),c=require("../../../browser/stableEditorScroll.js"),u=require("../../../browser/editorExtensions.js"),p=require("../../../common/core/editOperation.js"),m=require("../../../common/core/position.js"),h=require("../../../common/core/range.js"),x=require("../../../common/editorContextKeys.js"),C=require("../../snippet/browser/snippetController2.js"),S=require("../../snippet/browser/snippetParser.js"),y=require("./suggestMemory.js"),b=require("./wordContextKey.js"),v=require("../../../../nls.js"),E=require("../../../../platform/commands/common/commands.js"),f=require("../../../../platform/contextkey/common/contextkey.js"),w=require("../../../../platform/instantiation/common/instantiation.js"),_=require("../../../../platform/log/common/log.js"),I=require("./suggest.js"),K=require("./suggestAlternatives.js"),D=require("./suggestCommitCharacters.js"),M=require("./suggestModel.js"),O=require("./suggestOvertypingCapturer.js"),k=require("./suggestWidget.js"),P=require("../../../../platform/telemetry/common/telemetry.js"),A=require("../../../../base/common/resources.js"),T=require("../../../../base/common/hash.js"),q=require("../../../../base/browser/dom.js"),R=require("../../../common/model/textModel.js"),F=self&&self.__decorate||function(e,t,i,o){var s,n=arguments.length,r=n<3?t:null===o?o=Object.getOwnPropertyDescriptor(t,i):o;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,i,o);else for(var d=e.length-1;d>=0;d--)(s=e[d])&&(r=(n<3?s(r):n>3?s(t,i,r):s(t,i))||r);return n>3&&r&&Object.defineProperty(t,i,r),r},j=self&&self.__param||function(e,t){return function(i,o){t(i,o,e)}};class N{constructor(e,t){this._model=e,this._position=t,this._decorationOptions=R.ModelDecorationOptions.register({description:"suggest-line-suffix",stickiness:1});if(e.getLineMaxColumn(t.lineNumber)!==t.column){const i=e.getOffsetAt(t),o=e.getPositionAt(i+1);e.changeDecorations((e=>{this._marker&&e.removeDecoration(this._marker),this._marker=e.addDecoration(h.Range.fromPositions(t,o),this._decorationOptions)}))}}dispose(){this._marker&&!this._model.isDisposed()&&this._model.changeDecorations((e=>{e.removeDecoration(this._marker),this._marker=void 0}))}delta(e){if(this._model.isDisposed()||this._position.lineNumber!==e.lineNumber)return 0;if(this._marker){const t=this._model.getDecorationRange(this._marker);return this._model.getOffsetAt(t.getStartPosition())-this._model.getOffsetAt(e)}return this._model.getLineMaxColumn(e.lineNumber)-e.column}}exports.SuggestController=class{static{e=this}static{this.ID="editor.contrib.suggestController"}static get(t){return t.getContribution(e.ID)}constructor(e,t,i,o,s,l,g){this._memoryService=t,this._commandService=i,this._contextKeyService=o,this._instantiationService=s,this._logService=l,this._telemetryService=g,this._lineSuffix=new d.MutableDisposable,this._toDispose=new d.DisposableStore,this._selectors=new W((e=>e.priority)),this._onWillInsertSuggestItem=new n.Emitter,this.onWillInsertSuggestItem=this._onWillInsertSuggestItem.event,this.editor=e,this.model=s.createInstance(M.SuggestModel,this.editor),this._selectors.register({priority:0,select:(e,t,i)=>this._memoryService.select(e,t,i)});const c=I.Context.InsertMode.bindTo(o);c.set(e.getOption(119).insertMode),this._toDispose.add(this.model.onDidTrigger((()=>c.set(e.getOption(119).insertMode)))),this.widget=this._toDispose.add(new q.WindowIdleValue(q.getWindow(e.getDomNode()),(()=>{const e=this._instantiationService.createInstance(k.SuggestWidget,this.editor);this._toDispose.add(e),this._toDispose.add(e.onDidSelect((e=>this._insertSuggestion(e,0)),this));const t=new D.CommitCharacterController(this.editor,e,this.model,(e=>this._insertSuggestion(e,2)));this._toDispose.add(t);const i=I.Context.MakesTextEdit.bindTo(this._contextKeyService),o=I.Context.HasInsertAndReplaceRange.bindTo(this._contextKeyService),s=I.Context.CanResolve.bindTo(this._contextKeyService);return this._toDispose.add(d.toDisposable((()=>{i.reset(),o.reset(),s.reset()}))),this._toDispose.add(e.onDidFocus((({item:e})=>{const t=this.editor.getPosition(),n=e.editStart.column,r=t.column;let d=!0;if(!("smart"!==this.editor.getOption(1)||2!==this.model.state||e.completion.additionalTextEdits||4&e.completion.insertTextRules||r-n!==e.completion.insertText.length)){d=this.editor.getModel().getValueInRange({startLineNumber:t.lineNumber,startColumn:n,endLineNumber:t.lineNumber,endColumn:r})!==e.completion.insertText}i.set(d),o.set(!m.Position.equals(e.editInsertEnd,e.editReplaceEnd)),s.set(Boolean(e.provider.resolveCompletionItem)||Boolean(e.completion.documentation)||e.completion.detail!==e.completion.label)}))),this._toDispose.add(e.onDetailsKeyDown((e=>{e.toKeyCodeChord().equals(new r.KeyCodeChord(!0,!1,!1,!1,33))||a.isMacintosh&&e.toKeyCodeChord().equals(new r.KeyCodeChord(!1,!1,!1,!0,33))?e.stopPropagation():e.toKeyCodeChord().isModifierKey()||this.editor.focus()}))),e}))),this._overtypingCapturer=this._toDispose.add(new q.WindowIdleValue(q.getWindow(e.getDomNode()),(()=>this._toDispose.add(new O.OvertypingCapturer(this.editor,this.model))))),this._alternatives=this._toDispose.add(new q.WindowIdleValue(q.getWindow(e.getDomNode()),(()=>this._toDispose.add(new K.SuggestAlternatives(this.editor,this._contextKeyService))))),this._toDispose.add(s.createInstance(b.WordContextKey,e)),this._toDispose.add(this.model.onDidTrigger((e=>{this.widget.value.showTriggered(e.auto,e.shy?250:50),this._lineSuffix.value=new N(this.editor.getModel(),e.position)}))),this._toDispose.add(this.model.onDidSuggest((e=>{if(e.triggerOptions.shy)return;let t=-1;for(const i of this._selectors.itemsOrderedByPriorityDesc)if(t=i.select(this.editor.getModel(),this.editor.getPosition(),e.completionModel.items),-1!==t)break;if(-1===t&&(t=0),0===this.model.state)return;let i=!1;if(e.triggerOptions.auto){const t=this.editor.getOption(119);"never"===t.selectionMode||"always"===t.selectionMode?i="never"===t.selectionMode:"whenTriggerCharacter"===t.selectionMode?i=1!==e.triggerOptions.triggerKind:"whenQuickSuggestion"===t.selectionMode&&(i=1===e.triggerOptions.triggerKind&&!e.triggerOptions.refilter)}this.widget.value.showSuggestions(e.completionModel,t,e.isFrozen,e.triggerOptions.auto,i)}))),this._toDispose.add(this.model.onDidCancel((e=>{e.retrigger||this.widget.value.hideWidget()}))),this._toDispose.add(this.editor.onDidBlurEditorWidget((()=>{this.model.cancel(),this.model.clear()})));const u=I.Context.AcceptSuggestionsOnEnter.bindTo(o),p=()=>{const e=this.editor.getOption(1);u.set("on"===e||"smart"===e)};this._toDispose.add(this.editor.onDidChangeConfiguration((()=>p()))),p()}dispose(){this._alternatives.dispose(),this._toDispose.dispose(),this.widget.dispose(),this.model.dispose(),this._lineSuffix.dispose(),this._onWillInsertSuggestItem.dispose()}_insertSuggestion(e,t){if(!e||!e.item)return this._alternatives.value.reset(),this.model.cancel(),void this.model.clear();if(!this.editor.hasModel())return;const i=C.SnippetController2.get(this.editor);if(!i)return;this._onWillInsertSuggestItem.fire({item:e.item});const n=this.editor.getModel(),r=n.getAlternativeVersionId(),{item:d}=e,a=[],g=new o.CancellationTokenSource;1&t||this.editor.pushUndoStop();const u=this.getOverwriteInfo(d,Boolean(8&t));this._memoryService.memorize(n,this.editor.getPosition(),d);const x=d.isResolved;let y=-1,b=-1;if(Array.isArray(d.completion.additionalTextEdits)){this.model.cancel();const e=c.StableEditorScrollState.capture(this.editor);this.editor.executeEdits("suggestController.additionalTextEdits.sync",d.completion.additionalTextEdits.map((e=>{let t=h.Range.lift(e.range);if(t.startLineNumber===d.position.lineNumber&&t.startColumn>d.position.column){const e=this.editor.getPosition().column-d.position.column,i=e,o=h.Range.spansMultipleLines(t)?0:e;t=new h.Range(t.startLineNumber,t.startColumn+i,t.endLineNumber,t.endColumn+o)}return p.EditOperation.replaceMove(t,e.text)}))),e.restoreRelativeVerticalPositionOfCursor(this.editor)}else if(!x){const e=new l.StopWatch;let i;const o=n.onDidChangeContent((e=>{if(e.isFlush)return g.cancel(),void o.dispose();for(const t of e.changes){const e=h.Range.getEndPosition(t.range);i&&!m.Position.isBefore(e,i)||(i=e)}})),s=t;t|=2;let r=!1;const u=this.editor.onWillType((()=>{u.dispose(),r=!0,2&s||this.editor.pushUndoStop()}));a.push(d.resolve(g.token).then((()=>{if(!d.completion.additionalTextEdits||g.token.isCancellationRequested)return;if(i&&d.completion.additionalTextEdits.some((e=>m.Position.isBefore(i,h.Range.getStartPosition(e.range)))))return!1;r&&this.editor.pushUndoStop();const e=c.StableEditorScrollState.capture(this.editor);return this.editor.executeEdits("suggestController.additionalTextEdits.async",d.completion.additionalTextEdits.map((e=>p.EditOperation.replaceMove(h.Range.lift(e.range),e.text)))),e.restoreRelativeVerticalPositionOfCursor(this.editor),!r&&2&s||this.editor.pushUndoStop(),!0})).then((t=>{this._logService.trace("[suggest] async resolving of edits DONE (ms, applied?)",e.elapsed(),t),b=!0===t?1:!1===t?0:-2})).finally((()=>{o.dispose(),u.dispose()})))}let{insertText:v}=d.completion;if(4&d.completion.insertTextRules||(v=S.SnippetParser.escape(v)),this.model.cancel(),i.insert(v,{overwriteBefore:u.overwriteBefore,overwriteAfter:u.overwriteAfter,undoStopBefore:!1,undoStopAfter:!1,adjustWhitespace:!(1&d.completion.insertTextRules),clipboardText:e.model.clipboardText,overtypingCapturer:this._overtypingCapturer.value}),2&t||this.editor.pushUndoStop(),d.completion.command)if(d.completion.command.id===V.id)this.model.trigger({auto:!0,retrigger:!0});else{const e=new l.StopWatch;a.push(this._commandService.executeCommand(d.completion.command.id,...d.completion.command.arguments?[...d.completion.command.arguments]:[]).catch((e=>{d.completion.extensionId?s.onUnexpectedExternalError(e):s.onUnexpectedError(e)})).finally((()=>{y=e.elapsed()})))}4&t&&this._alternatives.value.set(e,(e=>{for(g.cancel();n.canUndo();){r!==n.getAlternativeVersionId()&&n.undo(),this._insertSuggestion(e,3|(8&t?8:0));break}})),this._alertCompletionItem(d),Promise.all(a).finally((()=>{this._reportSuggestionAcceptedTelemetry(d,n,x,y,b,e.index,e.model.items),this.model.clear(),g.dispose()}))}_reportSuggestionAcceptedTelemetry(e,t,i,o,s,n,r){if(0===Math.floor(100*Math.random()))return;const d=new Map;for(let e=0;e<Math.min(30,r.length);e++){const t=r[e].textLabel;d.has(t)?d.get(t).push(e):d.set(t,[e])}const a=d.get(e.textLabel),l=a&&a.length>1?a[0]:-1;this._telemetryService.publicLog2("suggest.acceptedSuggestion",{extensionId:e.extensionId?.value??"unknown",providerId:e.provider._debugDisplayName??"unknown",kind:e.completion.kind,basenameHash:T.hash(A.basename(t.uri)).toString(16),languageId:t.getLanguageId(),fileExtension:A.extname(t.uri),resolveInfo:e.provider.resolveCompletionItem?i?1:0:-1,resolveDuration:e.resolveDuration,commandDuration:o,additionalEditsAsync:s,index:n,firstIndex:l})}getOverwriteInfo(e,t){g.assertType(this.editor.hasModel());let i="replace"===this.editor.getOption(119).insertMode;t&&(i=!i);const o=e.position.column-e.editStart.column,s=(i?e.editReplaceEnd.column:e.editInsertEnd.column)-e.position.column;return{overwriteBefore:o+(this.editor.getPosition().column-e.position.column),overwriteAfter:s+(this._lineSuffix.value?this._lineSuffix.value.delta(this.editor.getPosition()):0)}}_alertCompletionItem(e){if(i.isNonEmptyArray(e.completion.additionalTextEdits)){const i=v.localize("aria.alert.snippet","Accepting '{0}' made {1} additional edits",e.textLabel,e.completion.additionalTextEdits.length);t.alert(i)}}triggerSuggest(e,t,i){this.editor.hasModel()&&(this.model.trigger({auto:t??!1,completionOptions:{providerFilter:e,kindFilter:i?new Set:void 0}}),this.editor.revealPosition(this.editor.getPosition(),0),this.editor.focus())}triggerSuggestAndAcceptBest(e){if(!this.editor.hasModel())return;const t=this.editor.getPosition(),i=()=>{t.equals(this.editor.getPosition())&&this._commandService.executeCommand(e.fallback)},o=e=>{if(4&e.completion.insertTextRules||e.completion.additionalTextEdits)return!0;const t=this.editor.getPosition(),i=e.editStart.column,o=t.column;if(o-i!==e.completion.insertText.length)return!0;return this.editor.getModel().getValueInRange({startLineNumber:t.lineNumber,startColumn:i,endLineNumber:t.lineNumber,endColumn:o})!==e.completion.insertText};n.Event.once(this.model.onDidTrigger)((e=>{const t=[];n.Event.any(this.model.onDidTrigger,this.model.onDidCancel)((()=>{d.dispose(t),i()}),void 0,t),this.model.onDidSuggest((({completionModel:e})=>{if(d.dispose(t),0===e.items.length)return void i();const s=this._memoryService.select(this.editor.getModel(),this.editor.getPosition(),e.items),n=e.items[s];o(n)?(this.editor.pushUndoStop(),this._insertSuggestion({index:s,item:n,model:e},7)):i()}),void 0,t)})),this.model.trigger({auto:!1,shy:!0}),this.editor.revealPosition(t,0),this.editor.focus()}acceptSelectedSuggestion(e,t){const i=this.widget.value.getFocusedItem();let o=0;e&&(o|=4),t&&(o|=8),this._insertSuggestion(i,o)}acceptNextSuggestion(){this._alternatives.value.next()}acceptPrevSuggestion(){this._alternatives.value.prev()}cancelSuggestWidget(){this.model.cancel(),this.model.clear(),this.widget.value.hideWidget()}focusSuggestion(){this.widget.value.focusSelected()}selectNextSuggestion(){this.widget.value.selectNext()}selectNextPageSuggestion(){this.widget.value.selectNextPage()}selectLastSuggestion(){this.widget.value.selectLast()}selectPrevSuggestion(){this.widget.value.selectPrevious()}selectPrevPageSuggestion(){this.widget.value.selectPreviousPage()}selectFirstSuggestion(){this.widget.value.selectFirst()}toggleSuggestionDetails(){this.widget.value.toggleDetails()}toggleExplainMode(){this.widget.value.toggleExplainMode()}toggleSuggestionFocus(){this.widget.value.toggleDetailsFocus()}resetWidgetSize(){this.widget.value.resetPersistedSize()}forceRenderingAbove(){this.widget.value.forceRenderingAbove()}stopForceRenderingAbove(){this.widget.isInitialized&&this.widget.value.stopForceRenderingAbove()}registerSelector(e){return this._selectors.register(e)}},exports.SuggestController=e=F([j(1,y.ISuggestMemoryService),j(2,E.ICommandService),j(3,f.IContextKeyService),j(4,w.IInstantiationService),j(5,_.ILogService),j(6,P.ITelemetryService)],exports.SuggestController);class W{constructor(e){this.prioritySelector=e,this._items=new Array}register(e){if(-1!==this._items.indexOf(e))throw new Error("Value is already registered");return this._items.push(e),this._items.sort(((e,t)=>this.prioritySelector(t)-this.prioritySelector(e))),{dispose:()=>{const t=this._items.indexOf(e);t>=0&&this._items.splice(t,1)}}}get itemsOrderedByPriorityDesc(){return this._items}}class V extends u.EditorAction{static{this.id="editor.action.triggerSuggest"}constructor(){super({id:V.id,label:v.localize("suggest.trigger.label","Trigger Suggest"),alias:"Trigger Suggest",precondition:f.ContextKeyExpr.and(x.EditorContextKeys.writable,x.EditorContextKeys.hasCompletionItemProvider,I.Context.Visible.toNegated()),kbOpts:{kbExpr:x.EditorContextKeys.textInputFocus,primary:2058,secondary:[2087],mac:{primary:266,secondary:[521,2087]},weight:100}})}run(e,t,i){const o=exports.SuggestController.get(t);if(!o)return;let s;i&&"object"==typeof i&&!0===i.auto&&(s=!0),o.triggerSuggest(void 0,s,void 0)}}u.registerEditorContribution(exports.SuggestController.ID,exports.SuggestController,2),u.registerEditorAction(V);const L=190,z=u.EditorCommand.bindToContribution(exports.SuggestController.get);u.registerEditorCommand(new z({id:"acceptSelectedSuggestion",precondition:f.ContextKeyExpr.and(I.Context.Visible,I.Context.HasFocusedSuggestion),handler(e){e.acceptSelectedSuggestion(!0,!1)},kbOpts:[{primary:2,kbExpr:f.ContextKeyExpr.and(I.Context.Visible,x.EditorContextKeys.textInputFocus),weight:L},{primary:3,kbExpr:f.ContextKeyExpr.and(I.Context.Visible,x.EditorContextKeys.textInputFocus,I.Context.AcceptSuggestionsOnEnter,I.Context.MakesTextEdit),weight:L}],menuOpts:[{menuId:I.suggestWidgetStatusbarMenu,title:v.localize("accept.insert","Insert"),group:"left",order:1,when:I.Context.HasInsertAndReplaceRange.toNegated()},{menuId:I.suggestWidgetStatusbarMenu,title:v.localize("accept.insert","Insert"),group:"left",order:1,when:f.ContextKeyExpr.and(I.Context.HasInsertAndReplaceRange,I.Context.InsertMode.isEqualTo("insert"))},{menuId:I.suggestWidgetStatusbarMenu,title:v.localize("accept.replace","Replace"),group:"left",order:1,when:f.ContextKeyExpr.and(I.Context.HasInsertAndReplaceRange,I.Context.InsertMode.isEqualTo("replace"))}]})),u.registerEditorCommand(new z({id:"acceptAlternativeSelectedSuggestion",precondition:f.ContextKeyExpr.and(I.Context.Visible,x.EditorContextKeys.textInputFocus,I.Context.HasFocusedSuggestion),kbOpts:{weight:L,kbExpr:x.EditorContextKeys.textInputFocus,primary:1027,secondary:[1026]},handler(e){e.acceptSelectedSuggestion(!1,!0)},menuOpts:[{menuId:I.suggestWidgetStatusbarMenu,group:"left",order:2,when:f.ContextKeyExpr.and(I.Context.HasInsertAndReplaceRange,I.Context.InsertMode.isEqualTo("insert")),title:v.localize("accept.replace","Replace")},{menuId:I.suggestWidgetStatusbarMenu,group:"left",order:2,when:f.ContextKeyExpr.and(I.Context.HasInsertAndReplaceRange,I.Context.InsertMode.isEqualTo("replace")),title:v.localize("accept.insert","Insert")}]})),E.CommandsRegistry.registerCommandAlias("acceptSelectedSuggestionOnEnter","acceptSelectedSuggestion"),u.registerEditorCommand(new z({id:"hideSuggestWidget",precondition:I.Context.Visible,handler:e=>e.cancelSuggestWidget(),kbOpts:{weight:L,kbExpr:x.EditorContextKeys.textInputFocus,primary:9,secondary:[1033]}})),u.registerEditorCommand(new z({id:"selectNextSuggestion",precondition:f.ContextKeyExpr.and(I.Context.Visible,f.ContextKeyExpr.or(I.Context.MultipleSuggestions,I.Context.HasFocusedSuggestion.negate())),handler:e=>e.selectNextSuggestion(),kbOpts:{weight:L,kbExpr:x.EditorContextKeys.textInputFocus,primary:18,secondary:[2066],mac:{primary:18,secondary:[2066,300]}}})),u.registerEditorCommand(new z({id:"selectNextPageSuggestion",precondition:f.ContextKeyExpr.and(I.Context.Visible,f.ContextKeyExpr.or(I.Context.MultipleSuggestions,I.Context.HasFocusedSuggestion.negate())),handler:e=>e.selectNextPageSuggestion(),kbOpts:{weight:L,kbExpr:x.EditorContextKeys.textInputFocus,primary:12,secondary:[2060]}})),u.registerEditorCommand(new z({id:"selectLastSuggestion",precondition:f.ContextKeyExpr.and(I.Context.Visible,f.ContextKeyExpr.or(I.Context.MultipleSuggestions,I.Context.HasFocusedSuggestion.negate())),handler:e=>e.selectLastSuggestion()})),u.registerEditorCommand(new z({id:"selectPrevSuggestion",precondition:f.ContextKeyExpr.and(I.Context.Visible,f.ContextKeyExpr.or(I.Context.MultipleSuggestions,I.Context.HasFocusedSuggestion.negate())),handler:e=>e.selectPrevSuggestion(),kbOpts:{weight:L,kbExpr:x.EditorContextKeys.textInputFocus,primary:16,secondary:[2064],mac:{primary:16,secondary:[2064,302]}}})),u.registerEditorCommand(new z({id:"selectPrevPageSuggestion",precondition:f.ContextKeyExpr.and(I.Context.Visible,f.ContextKeyExpr.or(I.Context.MultipleSuggestions,I.Context.HasFocusedSuggestion.negate())),handler:e=>e.selectPrevPageSuggestion(),kbOpts:{weight:L,kbExpr:x.EditorContextKeys.textInputFocus,primary:11,secondary:[2059]}})),u.registerEditorCommand(new z({id:"selectFirstSuggestion",precondition:f.ContextKeyExpr.and(I.Context.Visible,f.ContextKeyExpr.or(I.Context.MultipleSuggestions,I.Context.HasFocusedSuggestion.negate())),handler:e=>e.selectFirstSuggestion()})),u.registerEditorCommand(new z({id:"focusSuggestion",precondition:f.ContextKeyExpr.and(I.Context.Visible,I.Context.HasFocusedSuggestion.negate()),handler:e=>e.focusSuggestion(),kbOpts:{weight:L,kbExpr:x.EditorContextKeys.textInputFocus,primary:2058,secondary:[2087],mac:{primary:266,secondary:[2087]}}})),u.registerEditorCommand(new z({id:"focusAndAcceptSuggestion",precondition:f.ContextKeyExpr.and(I.Context.Visible,I.Context.HasFocusedSuggestion.negate()),handler:e=>{e.focusSuggestion(),e.acceptSelectedSuggestion(!0,!1)}})),u.registerEditorCommand(new z({id:"toggleSuggestionDetails",precondition:f.ContextKeyExpr.and(I.Context.Visible,I.Context.HasFocusedSuggestion),handler:e=>e.toggleSuggestionDetails(),kbOpts:{weight:L,kbExpr:x.EditorContextKeys.textInputFocus,primary:2058,secondary:[2087],mac:{primary:266,secondary:[2087]}},menuOpts:[{menuId:I.suggestWidgetStatusbarMenu,group:"right",order:1,when:f.ContextKeyExpr.and(I.Context.DetailsVisible,I.Context.CanResolve),title:v.localize("detail.more","Show Less")},{menuId:I.suggestWidgetStatusbarMenu,group:"right",order:1,when:f.ContextKeyExpr.and(I.Context.DetailsVisible.toNegated(),I.Context.CanResolve),title:v.localize("detail.less","Show More")}]})),u.registerEditorCommand(new z({id:"toggleExplainMode",precondition:I.Context.Visible,handler:e=>e.toggleExplainMode(),kbOpts:{weight:100,primary:2138}})),u.registerEditorCommand(new z({id:"toggleSuggestionFocus",precondition:I.Context.Visible,handler:e=>e.toggleSuggestionFocus(),kbOpts:{weight:L,kbExpr:x.EditorContextKeys.textInputFocus,primary:2570,mac:{primary:778}}})),u.registerEditorCommand(new z({id:"insertBestCompletion",precondition:f.ContextKeyExpr.and(x.EditorContextKeys.textInputFocus,f.ContextKeyExpr.equals("config.editor.tabCompletion","on"),b.WordContextKey.AtEnd,I.Context.Visible.toNegated(),K.SuggestAlternatives.OtherSuggestions.toNegated(),C.SnippetController2.InSnippetMode.toNegated()),handler:(e,t)=>{e.triggerSuggestAndAcceptBest(g.isObject(t)?{fallback:"tab",...t}:{fallback:"tab"})},kbOpts:{weight:L,primary:2}})),u.registerEditorCommand(new z({id:"insertNextSuggestion",precondition:f.ContextKeyExpr.and(x.EditorContextKeys.textInputFocus,f.ContextKeyExpr.equals("config.editor.tabCompletion","on"),K.SuggestAlternatives.OtherSuggestions,I.Context.Visible.toNegated(),C.SnippetController2.InSnippetMode.toNegated()),handler:e=>e.acceptNextSuggestion(),kbOpts:{weight:L,kbExpr:x.EditorContextKeys.textInputFocus,primary:2}})),u.registerEditorCommand(new z({id:"insertPrevSuggestion",precondition:f.ContextKeyExpr.and(x.EditorContextKeys.textInputFocus,f.ContextKeyExpr.equals("config.editor.tabCompletion","on"),K.SuggestAlternatives.OtherSuggestions,I.Context.Visible.toNegated(),C.SnippetController2.InSnippetMode.toNegated()),handler:e=>e.acceptPrevSuggestion(),kbOpts:{weight:L,kbExpr:x.EditorContextKeys.textInputFocus,primary:1026}})),u.registerEditorAction(class extends u.EditorAction{constructor(){super({id:"editor.action.resetSuggestSize",label:v.localize("suggest.reset.label","Reset Suggest Widget Size"),alias:"Reset Suggest Widget Size",precondition:void 0})}run(e,t){exports.SuggestController.get(t)?.resetWidgetSize()}}),exports.TriggerSuggestAction=V;
//# sourceMappingURL=suggestController.js.map
