"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var e=require("../../../../base/common/cancellation.js"),t=require("../../../../base/common/filters.js"),o=require("../../../../base/common/iterator.js"),i=require("../../../../base/common/lifecycle.js"),r=require("../../../browser/services/codeEditorService.js"),n=require("../../../common/core/range.js"),s=require("../../../common/editorFeatures.js"),l=require("../../../common/services/languageFeatures.js"),c=require("./completionModel.js"),a=require("./suggest.js"),u=require("./suggestMemory.js"),d=require("./suggestModel.js"),m=require("./wordDistance.js"),g=require("../../../../platform/clipboard/common/clipboardService.js"),p=self&&self.__decorate||function(e,t,o,i){var r,n=arguments.length,s=n<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,o):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)s=Reflect.decorate(e,t,o,i);else for(var l=e.length-1;l>=0;l--)(r=e[l])&&(s=(n<3?r(s):n>3?r(t,o,s):r(t,o))||s);return n>3&&s&&Object.defineProperty(t,o,s),s},h=self&&self.__param||function(e,t){return function(o,i){t(o,i,e)}};class f{constructor(e,t,o,i,r,n){this.range=e,this.insertText=t,this.filterText=o,this.additionalTextEdits=i,this.command=r,this.completion=n}}let v=class extends i.RefCountedDisposable{constructor(e,t,o,i,r,n){super(r.disposable),this.model=e,this.line=t,this.word=o,this.completionModel=i,this._suggestMemoryService=n}canBeReused(e,t,o){return this.model===e&&this.line===t&&this.word.word.length>0&&this.word.startColumn===o.startColumn&&this.word.endColumn<o.endColumn&&0===this.completionModel.getIncompleteProvider().size}get items(){const i=[],{items:r}=this.completionModel,s=this._suggestMemoryService.select(this.model,{lineNumber:this.line,column:this.word.endColumn+this.completionModel.lineContext.characterCountDelta},r),l=o.Iterable.slice(r,s),c=o.Iterable.slice(r,0,s);let a=5;for(const r of o.Iterable.concat(l,c)){if(r.score===t.FuzzyScore.Default)continue;const o=new n.Range(r.editStart.lineNumber,r.editStart.column,r.editInsertEnd.lineNumber,r.editInsertEnd.column+this.completionModel.lineContext.characterCountDelta),s=r.completion.insertTextRules&&4&r.completion.insertTextRules?{snippet:r.completion.insertText}:r.completion.insertText;i.push(new f(o,s,r.filterTextLow??r.labelLow,r.completion.additionalTextEdits,r.completion.command,r)),a-- >=0&&r.resolve(e.CancellationToken.None)}return i}};v=p([h(5,u.ISuggestMemoryService)],v),exports.SuggestInlineCompletions=class extends i.Disposable{constructor(e,t,o,i){super(),this._languageFeatureService=e,this._clipboardService=t,this._suggestMemoryService=o,this._editorService=i,this._store.add(e.inlineCompletionsProvider.register("*",this))}async provideInlineCompletions(e,t,o,i){if(o.selectedSuggestionInfo)return;let r;for(const t of this._editorService.listCodeEditors())if(t.getModel()===e){r=t;break}if(!r)return;const s=r.getOption(90);if(a.QuickSuggestionsOptions.isAllOff(s))return;e.tokenization.tokenizeIfCheap(t.lineNumber);const l=e.tokenization.getLineTokens(t.lineNumber),u=l.getStandardTokenType(l.findTokenIndexAtOffset(Math.max(t.column-1-1,0)));if("inline"!==a.QuickSuggestionsOptions.valueFor(s,u))return;let g,p,h=e.getWordAtPosition(t);if(h?.word||(g=this._getTriggerCharacterInfo(e,t)),!h?.word&&!g)return;if(h||(h=e.getWordUntilPosition(t)),h.endColumn!==t.column)return;const f=e.getValueInRange(new n.Range(t.lineNumber,1,t.lineNumber,t.column));if(!g&&this._lastResult?.canBeReused(e,t.lineNumber,h)){const e=new c.LineContext(f,t.column-this._lastResult.word.endColumn);this._lastResult.completionModel.lineContext=e,this._lastResult.acquire(),p=this._lastResult}else{const o=await a.provideSuggestionItems(this._languageFeatureService.completionProvider,e,t,new a.CompletionOptions(void 0,d.SuggestModel.createSuggestFilter(r).itemKind,g?.providers),g&&{triggerKind:1,triggerCharacter:g.ch},i);let n;o.needsClipboard&&(n=await this._clipboardService.readText());const s=new c.CompletionModel(o.items,t.column,new c.LineContext(f,0),m.WordDistance.None,r.getOption(119),r.getOption(113),{boostFullMatch:!1,firstMatchCanBeWeak:!1},n);p=new v(e,t.lineNumber,h,s,o,this._suggestMemoryService)}return this._lastResult=p,p}handleItemDidShow(t,o){o.completion.resolve(e.CancellationToken.None)}freeInlineCompletions(e){e.release()}_getTriggerCharacterInfo(e,t){const o=e.getValueInRange(n.Range.fromPositions({lineNumber:t.lineNumber,column:t.column-1},t)),i=new Set;for(const t of this._languageFeatureService.completionProvider.all(e))t.triggerCharacters?.includes(o)&&i.add(t);if(0!==i.size)return{providers:i,ch:o}}},exports.SuggestInlineCompletions=p([h(0,l.ILanguageFeaturesService),h(1,g.IClipboardService),h(2,u.ISuggestMemoryService),h(3,r.ICodeEditorService)],exports.SuggestInlineCompletions),s.registerEditorFeature(exports.SuggestInlineCompletions);
//# sourceMappingURL=suggestInlineCompletions.js.map
