"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var e,t=require("../../../../base/common/async.js"),i=require("../../../../base/common/cancellation.js"),o=require("../../../../base/common/errors.js"),r=require("../../../../base/common/event.js"),s=require("../../../../base/common/lifecycle.js"),n=require("../../../../base/common/strings.js"),d=require("../../../common/core/selection.js"),a=require("../../../common/services/editorWorker.js"),g=require("./wordDistance.js"),l=require("../../../../platform/clipboard/common/clipboardService.js"),c=require("../../../../platform/configuration/common/configuration.js"),h=require("../../../../platform/contextkey/common/contextkey.js"),u=require("../../../../platform/log/common/log.js"),p=require("../../../../platform/telemetry/common/telemetry.js"),_=require("./completionModel.js"),m=require("./suggest.js"),S=require("../../../common/services/languageFeatures.js"),f=require("../../../../base/common/filters.js"),C=require("../../../../base/common/types.js"),v=require("../../inlineCompletions/browser/controller/inlineCompletionContextKeys.js"),w=require("../../snippet/browser/snippetController2.js"),b=require("../../../../platform/environment/common/environment.js"),x=self&&self.__decorate||function(e,t,i,o){var r,s=arguments.length,n=s<3?t:null===o?o=Object.getOwnPropertyDescriptor(t,i):o;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)n=Reflect.decorate(e,t,i,o);else for(var d=e.length-1;d>=0;d--)(r=e[d])&&(n=(s<3?r(n):s>3?r(t,i,n):r(t,i))||n);return s>3&&n&&Object.defineProperty(t,i,n),n},D=self&&self.__param||function(e,t){return function(i,o){t(i,o,e)}};class y{static shouldAutoTrigger(e){if(!e.hasModel())return!1;const t=e.getModel(),i=e.getPosition();t.tokenization.tokenizeIfCheap(i.lineNumber);const o=t.getWordAtPosition(i);return!!o&&((o.endColumn===i.column||o.startColumn+1===i.column)&&!!isNaN(Number(o.word)))}constructor(e,t,i){this.leadingLineContent=e.getLineContent(t.lineNumber).substr(0,t.column-1),this.leadingWord=e.getWordUntilPosition(t),this.lineNumber=t.lineNumber,this.column=t.column,this.triggerOptions=i}}exports.SuggestModel=e=class{constructor(e,i,o,n,a,g,l,c,h){this._editor=e,this._editorWorkerService=i,this._clipboardService=o,this._telemetryService=n,this._logService=a,this._contextKeyService=g,this._configurationService=l,this._languageFeaturesService=c,this._envService=h,this._toDispose=new s.DisposableStore,this._triggerCharacterListener=new s.DisposableStore,this._triggerQuickSuggest=new t.TimeoutTimer,this._triggerState=void 0,this._completionDisposables=new s.DisposableStore,this._onDidCancel=new r.Emitter,this._onDidTrigger=new r.Emitter,this._onDidSuggest=new r.Emitter,this.onDidCancel=this._onDidCancel.event,this.onDidTrigger=this._onDidTrigger.event,this.onDidSuggest=this._onDidSuggest.event,this._telemetryGate=0,this._currentSelection=this._editor.getSelection()||new d.Selection(1,1,1,1),this._toDispose.add(this._editor.onDidChangeModel((()=>{this._updateTriggerCharacters(),this.cancel()}))),this._toDispose.add(this._editor.onDidChangeModelLanguage((()=>{this._updateTriggerCharacters(),this.cancel()}))),this._toDispose.add(this._editor.onDidChangeConfiguration((()=>{this._updateTriggerCharacters()}))),this._toDispose.add(this._languageFeaturesService.completionProvider.onDidChange((()=>{this._updateTriggerCharacters(),this._updateActiveSuggestSession()})));let u=!1;this._toDispose.add(this._editor.onDidCompositionStart((()=>{u=!0}))),this._toDispose.add(this._editor.onDidCompositionEnd((()=>{u=!1,this._onCompositionEnd()}))),this._toDispose.add(this._editor.onDidChangeCursorSelection((e=>{u||this._onCursorChange(e)}))),this._toDispose.add(this._editor.onDidChangeModelContent((()=>{u||void 0===this._triggerState||this._refilterCompletionItems()}))),this._updateTriggerCharacters()}dispose(){s.dispose(this._triggerCharacterListener),s.dispose([this._onDidCancel,this._onDidSuggest,this._onDidTrigger,this._triggerQuickSuggest]),this._toDispose.dispose(),this._completionDisposables.dispose(),this.cancel()}_updateTriggerCharacters(){if(this._triggerCharacterListener.clear(),this._editor.getOption(92)||!this._editor.hasModel()||!this._editor.getOption(122))return;const e=new Map;for(const t of this._languageFeaturesService.completionProvider.all(this._editor.getModel()))for(const i of t.triggerCharacters||[]){let o=e.get(i);o||(o=new Set,e.set(i,o)),o.add(t)}const t=t=>{if(!function(e,t){if(!Boolean(t.getContextKeyValue("inlineSuggestionVisible")))return!0;const i=t.getContextKeyValue(v.InlineCompletionContextKeys.suppressSuggestions.key);return void 0!==i?!i:!e.getOption(62).suppressSuggestions}(this._editor,this._contextKeyService,this._configurationService))return;if(y.shouldAutoTrigger(this._editor))return;if(!t){const e=this._editor.getPosition();t=this._editor.getModel().getLineContent(e.lineNumber).substr(0,e.column-1)}let i="";n.isLowSurrogate(t.charCodeAt(t.length-1))?n.isHighSurrogate(t.charCodeAt(t.length-2))&&(i=t.substr(t.length-2)):i=t.charAt(t.length-1);const o=e.get(i);if(o){const e=new Map;if(this._completionModel)for(const[t,i]of this._completionModel.getItemsByProvider())o.has(t)||e.set(t,i);this.trigger({auto:!0,triggerKind:1,triggerCharacter:i,retrigger:Boolean(this._completionModel),clipboardText:this._completionModel?.clipboardText,completionOptions:{providerFilter:o,providerItemsToReuse:e}})}};this._triggerCharacterListener.add(this._editor.onDidType(t)),this._triggerCharacterListener.add(this._editor.onDidCompositionEnd((()=>t())))}get state(){return this._triggerState?this._triggerState.auto?2:1:0}cancel(e=!1){void 0!==this._triggerState&&(this._triggerQuickSuggest.cancel(),this._requestToken?.cancel(),this._requestToken=void 0,this._triggerState=void 0,this._completionModel=void 0,this._context=void 0,this._onDidCancel.fire({retrigger:e}))}clear(){this._completionDisposables.clear()}_updateActiveSuggestSession(){void 0!==this._triggerState&&(this._editor.hasModel()&&this._languageFeaturesService.completionProvider.has(this._editor.getModel())?this.trigger({auto:this._triggerState.auto,retrigger:!0}):this.cancel())}_onCursorChange(e){if(!this._editor.hasModel())return;const t=this._currentSelection;this._currentSelection=this._editor.getSelection(),!e.selection.isEmpty()||0!==e.reason&&3!==e.reason||"keyboard"!==e.source&&"deleteLeft"!==e.source?this.cancel():void 0===this._triggerState&&0===e.reason?(t.containsRange(this._currentSelection)||t.getEndPosition().isBeforeOrEqual(this._currentSelection.getPosition()))&&this._doTriggerQuickSuggest():void 0!==this._triggerState&&3===e.reason&&this._refilterCompletionItems()}_onCompositionEnd(){void 0===this._triggerState?this._doTriggerQuickSuggest():this._refilterCompletionItems()}_doTriggerQuickSuggest(){m.QuickSuggestionsOptions.isAllOff(this._editor.getOption(90))||this._editor.getOption(119).snippetsPreventQuickSuggestions&&w.SnippetController2.get(this._editor)?.isInSnippet()||(this.cancel(),this._triggerQuickSuggest.cancelAndSet((()=>{if(void 0!==this._triggerState)return;if(!y.shouldAutoTrigger(this._editor))return;if(!this._editor.hasModel()||!this._editor.hasWidgetFocus())return;const e=this._editor.getModel(),t=this._editor.getPosition(),i=this._editor.getOption(90);if(!m.QuickSuggestionsOptions.isAllOff(i)){if(!m.QuickSuggestionsOptions.isAllOn(i)){e.tokenization.tokenizeIfCheap(t.lineNumber);const o=e.tokenization.getLineTokens(t.lineNumber),r=o.getStandardTokenType(o.findTokenIndexAtOffset(Math.max(t.column-1-1,0)));if("on"!==m.QuickSuggestionsOptions.valueFor(i,r))return}(function(e,t){if(!Boolean(t.getContextKeyValue(v.InlineCompletionContextKeys.inlineSuggestionVisible.key)))return!0;const i=t.getContextKeyValue(v.InlineCompletionContextKeys.suppressSuggestions.key);return void 0!==i?!i:!e.getOption(62).suppressSuggestions})(this._editor,this._contextKeyService,this._configurationService)&&this._languageFeaturesService.completionProvider.has(e)&&this.trigger({auto:!0})}}),this._editor.getOption(91)))}_refilterCompletionItems(){C.assertType(this._editor.hasModel()),C.assertType(void 0!==this._triggerState);const e=this._editor.getModel(),t=this._editor.getPosition(),i=new y(e,t,{...this._triggerState,refilter:!0});this._onNewContext(i)}trigger(t){if(!this._editor.hasModel())return;const r=this._editor.getModel(),s=new y(r,this._editor.getPosition(),t);this.cancel(t.retrigger),this._triggerState=t,this._onDidTrigger.fire({auto:t.auto,shy:t.shy??!1,position:this._editor.getPosition()}),this._context=s;let n={triggerKind:t.triggerKind??0};t.triggerCharacter&&(n={triggerKind:1,triggerCharacter:t.triggerCharacter}),this._requestToken=new i.CancellationTokenSource;let d=1;switch(this._editor.getOption(113)){case"top":d=0;break;case"bottom":d=2}const{itemKind:a,showDeprecated:l}=e.createSuggestFilter(this._editor),c=new m.CompletionOptions(d,t.completionOptions?.kindFilter??a,t.completionOptions?.providerFilter,t.completionOptions?.providerItemsToReuse,l),h=g.WordDistance.create(this._editorWorkerService,this._editor),u=m.provideSuggestionItems(this._languageFeaturesService.completionProvider,r,this._editor.getPosition(),c,n,this._requestToken.token);Promise.all([u,h]).then((async([e,i])=>{if(this._requestToken?.dispose(),!this._editor.hasModel())return;let o=t?.clipboardText;if(!o&&e.needsClipboard&&(o=await this._clipboardService.readText()),void 0===this._triggerState)return;const r=this._editor.getModel(),s=new y(r,this._editor.getPosition(),t),n={...f.FuzzyScoreOptions.default,firstMatchCanBeWeak:!this._editor.getOption(119).matchOnWordStartOnly};if(this._completionModel=new _.CompletionModel(e.items,this._context.column,{leadingLineContent:s.leadingLineContent,characterCountDelta:s.column-this._context.column},i,this._editor.getOption(119),this._editor.getOption(113),n,o),this._completionDisposables.add(e.disposable),this._onNewContext(s),this._reportDurationsTelemetry(e.durations),!this._envService.isBuilt||this._envService.isExtensionDevelopment)for(const t of e.items)t.isInvalid&&this._logService.warn(`[suggest] did IGNORE invalid completion item from ${t.provider._debugDisplayName}`,t.completion)})).catch(o.onUnexpectedError)}_reportDurationsTelemetry(e){this._telemetryGate++%230==0&&setTimeout((()=>{this._telemetryService.publicLog2("suggest.durations.json",{data:JSON.stringify(e)}),this._logService.debug("suggest.durations.json",e)}))}static createSuggestFilter(e){const t=new Set;"none"===e.getOption(113)&&t.add(27);const i=e.getOption(119);return i.showMethods||t.add(0),i.showFunctions||t.add(1),i.showConstructors||t.add(2),i.showFields||t.add(3),i.showVariables||t.add(4),i.showClasses||t.add(5),i.showStructs||t.add(6),i.showInterfaces||t.add(7),i.showModules||t.add(8),i.showProperties||t.add(9),i.showEvents||t.add(10),i.showOperators||t.add(11),i.showUnits||t.add(12),i.showValues||t.add(13),i.showConstants||t.add(14),i.showEnums||t.add(15),i.showEnumMembers||t.add(16),i.showKeywords||t.add(17),i.showWords||t.add(18),i.showColors||t.add(19),i.showFiles||t.add(20),i.showReferences||t.add(21),i.showColors||t.add(22),i.showFolders||t.add(23),i.showTypeParameters||t.add(24),i.showSnippets||t.add(27),i.showUsers||t.add(25),i.showIssues||t.add(26),{itemKind:t,showDeprecated:i.showDeprecated}}_onNewContext(e){if(this._context)if(e.lineNumber===this._context.lineNumber)if(n.getLeadingWhitespace(e.leadingLineContent)===n.getLeadingWhitespace(this._context.leadingLineContent)){if(e.column<this._context.column)e.leadingWord.word?this.trigger({auto:this._context.triggerOptions.auto,retrigger:!0}):this.cancel();else if(this._completionModel)if(0!==e.leadingWord.word.length&&e.leadingWord.startColumn>this._context.leadingWord.startColumn){if(y.shouldAutoTrigger(this._editor)&&this._context){const e=this._completionModel.getItemsByProvider();this.trigger({auto:this._context.triggerOptions.auto,retrigger:!0,clipboardText:this._completionModel.clipboardText,completionOptions:{providerItemsToReuse:e}})}}else if(e.column>this._context.column&&this._completionModel.getIncompleteProvider().size>0&&0!==e.leadingWord.word.length){const e=new Map,t=new Set;for(const[i,o]of this._completionModel.getItemsByProvider())o.length>0&&o[0].container.incomplete?t.add(i):e.set(i,o);this.trigger({auto:this._context.triggerOptions.auto,triggerKind:2,retrigger:!0,clipboardText:this._completionModel.clipboardText,completionOptions:{providerFilter:t,providerItemsToReuse:e}})}else{const t=this._completionModel.lineContext;let i=!1;if(this._completionModel.lineContext={leadingLineContent:e.leadingLineContent,characterCountDelta:e.column-this._context.column},0===this._completionModel.items.length){const o=y.shouldAutoTrigger(this._editor);if(!this._context)return void this.cancel();if(o&&this._context.leadingWord.endColumn<e.leadingWord.startColumn)return void this.trigger({auto:this._context.triggerOptions.auto,retrigger:!0});if(this._context.triggerOptions.auto)return void this.cancel();if(this._completionModel.lineContext=t,i=this._completionModel.items.length>0,i&&0===e.leadingWord.word.length)return void this.cancel()}this._onDidSuggest.fire({completionModel:this._completionModel,triggerOptions:e.triggerOptions,isFrozen:i})}}else this.cancel();else this.cancel()}},exports.SuggestModel=e=x([D(1,a.IEditorWorkerService),D(2,l.IClipboardService),D(3,p.ITelemetryService),D(4,u.ILogService),D(5,h.IContextKeyService),D(6,c.IConfigurationService),D(7,S.ILanguageFeaturesService),D(8,b.IEnvironmentService)],exports.SuggestModel),exports.LineContext=y;
//# sourceMappingURL=suggestModel.js.map
