"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var e=require("../../../../base/browser/dom.js");require("../../../../base/browser/ui/codicons/codicon/codicon.css.js"),require("../../../../base/browser/ui/codicons/codicon/codicon-modifiers.css.js");var t=require("../../../../base/browser/ui/list/listWidget.js"),s=require("../../../../base/common/async.js"),i=require("../../../../base/common/errors.js"),o=require("../../../../base/common/event.js"),n=require("../../../../base/common/lifecycle.js"),r=require("../../../../base/common/numbers.js"),d=require("../../../../base/common/strings.js");require("./media/suggest.css.js");var h=require("../../../browser/widget/codeEditor/embeddedCodeEditorWidget.js"),l=require("./suggestWidgetStatus.js");require("../../symbolIcons/browser/symbolIcons.js");var a=require("../../../../nls.js"),g=require("../../../../platform/contextkey/common/contextkey.js"),c=require("../../../../platform/instantiation/common/instantiation.js"),u=require("../../../../platform/storage/common/storage.js"),_=require("../../../../platform/theme/common/colorUtils.js"),m=require("../../../../platform/theme/common/colors/baseColors.js");require("../../../../platform/theme/common/colors/chartsColors.js");var p=require("../../../../platform/theme/common/colors/editorColors.js");require("../../../../platform/theme/common/colors/inputColors.js");var S=require("../../../../platform/theme/common/colors/listColors.js");require("../../../../platform/theme/common/colors/menuColors.js"),require("../../../../platform/theme/common/colors/minimapColors.js"),require("../../../../platform/theme/common/colors/miscColors.js");var w=require("../../../../platform/theme/common/colors/quickpickColors.js");require("../../../../platform/theme/common/colors/searchColors.js");var f,b=require("../../../../platform/theme/common/theme.js"),D=require("../../../../platform/theme/common/themeService.js"),v=require("../../../../base/browser/ui/resizable/resizable.js"),W=require("./suggest.js"),y=require("./suggestWidgetDetails.js"),C=require("./suggestWidgetRenderer.js"),x=require("../../../../platform/theme/browser/defaultStyles.js"),z=require("../../../../base/browser/ui/aria/aria.js"),E=self&&self.__decorate||function(e,t,s,i){var o,n=arguments.length,r=n<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,s):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,s,i);else for(var d=e.length-1;d>=0;d--)(o=e[d])&&(r=(n<3?o(r):n>3?o(t,s,r):o(t,s))||r);return n>3&&r&&Object.defineProperty(t,s,r),r},F=self&&self.__param||function(e,t){return function(s,i){t(s,i,e)}};_.registerColor("editorSuggestWidget.background",p.editorWidgetBackground,a.localize("editorSuggestWidgetBackground","Background color of the suggest widget.")),_.registerColor("editorSuggestWidget.border",p.editorWidgetBorder,a.localize("editorSuggestWidgetBorder","Border color of the suggest widget."));const L=_.registerColor("editorSuggestWidget.foreground",p.editorForeground,a.localize("editorSuggestWidgetForeground","Foreground color of the suggest widget."));_.registerColor("editorSuggestWidget.selectedForeground",w.quickInputListFocusForeground,a.localize("editorSuggestWidgetSelectedForeground","Foreground color of the selected entry in the suggest widget.")),_.registerColor("editorSuggestWidget.selectedIconForeground",w.quickInputListFocusIconForeground,a.localize("editorSuggestWidgetSelectedIconForeground","Icon foreground color of the selected entry in the suggest widget."));const M=_.registerColor("editorSuggestWidget.selectedBackground",w.quickInputListFocusBackground,a.localize("editorSuggestWidgetSelectedBackground","Background color of the selected entry in the suggest widget."));_.registerColor("editorSuggestWidget.highlightForeground",S.listHighlightForeground,a.localize("editorSuggestWidgetHighlightForeground","Color of the match highlights in the suggest widget.")),_.registerColor("editorSuggestWidget.focusHighlightForeground",S.listFocusHighlightForeground,a.localize("editorSuggestWidgetFocusHighlightForeground","Color of the match highlights in the suggest widget when an item is focused.")),_.registerColor("editorSuggestWidgetStatus.foreground",_.transparent(L,.5),a.localize("editorSuggestWidgetStatusForeground","Foreground color of the suggest widget status."));class N{constructor(e,t){this._service=e,this._key=`suggestWidget.size/${t.getEditorType()}/${t instanceof h.EmbeddedCodeEditorWidget}`}restore(){const t=this._service.get(this._key,0)??"";try{const s=JSON.parse(t);if(e.Dimension.is(s))return e.Dimension.lift(s)}catch{}}store(e){this._service.store(this._key,JSON.stringify(e),0,1)}reset(){this._service.remove(this._key,0)}}exports.SuggestWidget=class{static{f=this}static{this.LOADING_MESSAGE=a.localize("suggestWidget.loading","Loading...")}static{this.NO_SUGGESTIONS_MESSAGE=a.localize("suggestWidget.noSuggestions","No suggestions.")}constructor(i,r,h,g,c){this.editor=i,this._storageService=r,this._state=0,this._isAuto=!1,this._pendingLayout=new n.MutableDisposable,this._pendingShowDetails=new n.MutableDisposable,this._ignoreFocusEvents=!1,this._forceRenderingAbove=!1,this._explainMode=!1,this._showTimeout=new s.TimeoutTimer,this._disposables=new n.DisposableStore,this._onDidSelect=new o.PauseableEmitter,this._onDidFocus=new o.PauseableEmitter,this._onDidHide=new o.Emitter,this._onDidShow=new o.Emitter,this.onDidSelect=this._onDidSelect.event,this.onDidFocus=this._onDidFocus.event,this.onDidHide=this._onDidHide.event,this.onDidShow=this._onDidShow.event,this._onDetailsKeydown=new o.Emitter,this.onDetailsKeyDown=this._onDetailsKeydown.event,this.element=new v.ResizableHTMLElement,this.element.domNode.classList.add("editor-widget","suggest-widget"),this._contentWidget=new H(this,i),this._persistedSize=new N(r,i);class u{constructor(e,t,s=!1,i=!1){this.persistedSize=e,this.currentSize=t,this.persistHeight=s,this.persistWidth=i}}let _;this._disposables.add(this.element.onDidWillResize((()=>{this._contentWidget.lockPreference(),_=new u(this._persistedSize.restore(),this.element.size)}))),this._disposables.add(this.element.onDidResize((t=>{if(this._resize(t.dimension.width,t.dimension.height),_&&(_.persistHeight=_.persistHeight||!!t.north||!!t.south,_.persistWidth=_.persistWidth||!!t.east||!!t.west),t.done){if(_){const{itemHeight:t,defaultSize:s}=this.getLayoutInfo(),i=Math.round(t/2);let{width:o,height:n}=this.element.size;(!_.persistHeight||Math.abs(_.currentSize.height-n)<=i)&&(n=_.persistedSize?.height??s.height),(!_.persistWidth||Math.abs(_.currentSize.width-o)<=i)&&(o=_.persistedSize?.width??s.width),this._persistedSize.store(new e.Dimension(o,n))}this._contentWidget.unlockPreference(),_=void 0}}))),this._messageElement=e.append(this.element.domNode,e.$(".message")),this._listElement=e.append(this.element.domNode,e.$(".tree"));const p=this._disposables.add(c.createInstance(y.SuggestDetailsWidget,this.editor));p.onDidClose(this.toggleDetails,this,this._disposables),this._details=new y.SuggestDetailsOverlay(p,this.editor);const S=()=>this.element.domNode.classList.toggle("no-icons",!this.editor.getOption(119).showIcons);S();const w=c.createInstance(C.ItemRenderer,this.editor);this._disposables.add(w),this._disposables.add(w.onDidToggleDetails((()=>this.toggleDetails()))),this._list=new t.List("SuggestWidget",this._listElement,{getHeight:e=>this.getLayoutInfo().itemHeight,getTemplateId:e=>"suggestion"},[w],{alwaysConsumeMouseWheel:!0,useShadows:!1,mouseSupport:!1,multipleSelectionSupport:!1,accessibilityProvider:{getRole:()=>"option",getWidgetAriaLabel:()=>a.localize("suggest","Suggest"),getWidgetRole:()=>"listbox",getAriaLabel:e=>{let t=e.textLabel;if("string"!=typeof e.completion.label){const{detail:s,description:i}=e.completion.label;s&&i?t=a.localize("label.full","{0} {1}, {2}",t,s,i):s?t=a.localize("label.detail","{0} {1}",t,s):i&&(t=a.localize("label.desc","{0}, {1}",t,i))}if(!e.isResolved||!this._isDetailsVisible())return t;const{documentation:s,detail:i}=e.completion,o=d.format("{0}{1}",i||"",s?"string"==typeof s?s:s.value:"");return a.localize("ariaCurrenttSuggestionReadDetails","{0}, docs: {1}",t,o)}}}),this._list.style(x.getListStyles({listInactiveFocusBackground:M,listInactiveFocusOutline:m.activeContrastBorder})),this._status=c.createInstance(l.SuggestWidgetStatus,this.element.domNode,W.suggestWidgetStatusbarMenu);const f=()=>this.element.domNode.classList.toggle("with-status-bar",this.editor.getOption(119).showStatusBar);f(),this._disposables.add(g.onDidColorThemeChange((e=>this._onThemeChange(e)))),this._onThemeChange(g.getColorTheme()),this._disposables.add(this._list.onMouseDown((e=>this._onListMouseDownOrTap(e)))),this._disposables.add(this._list.onTap((e=>this._onListMouseDownOrTap(e)))),this._disposables.add(this._list.onDidChangeSelection((e=>this._onListSelection(e)))),this._disposables.add(this._list.onDidChangeFocus((e=>this._onListFocus(e)))),this._disposables.add(this.editor.onDidChangeCursorSelection((()=>this._onCursorSelectionChanged()))),this._disposables.add(this.editor.onDidChangeConfiguration((e=>{e.hasChanged(119)&&(f(),S()),this._completionModel&&(e.hasChanged(50)||e.hasChanged(120)||e.hasChanged(121))&&this._list.splice(0,this._list.length,this._completionModel.items)}))),this._ctxSuggestWidgetVisible=W.Context.Visible.bindTo(h),this._ctxSuggestWidgetDetailsVisible=W.Context.DetailsVisible.bindTo(h),this._ctxSuggestWidgetMultipleSuggestions=W.Context.MultipleSuggestions.bindTo(h),this._ctxSuggestWidgetHasFocusedSuggestion=W.Context.HasFocusedSuggestion.bindTo(h),this._disposables.add(e.addStandardDisposableListener(this._details.widget.domNode,"keydown",(e=>{this._onDetailsKeydown.fire(e)}))),this._disposables.add(this.editor.onMouseDown((e=>this._onEditorMouseDown(e))))}dispose(){this._details.widget.dispose(),this._details.dispose(),this._list.dispose(),this._status.dispose(),this._disposables.dispose(),this._loadingTimeout?.dispose(),this._pendingLayout.dispose(),this._pendingShowDetails.dispose(),this._showTimeout.dispose(),this._contentWidget.dispose(),this.element.dispose()}_onEditorMouseDown(e){this._details.widget.domNode.contains(e.target.element)?this._details.widget.domNode.focus():this.element.domNode.contains(e.target.element)&&this.editor.focus()}_onCursorSelectionChanged(){0!==this._state&&this._contentWidget.layout()}_onListMouseDownOrTap(e){void 0!==e.element&&void 0!==e.index&&(e.browserEvent.preventDefault(),e.browserEvent.stopPropagation(),this._select(e.element,e.index))}_onListSelection(e){e.elements.length&&this._select(e.elements[0],e.indexes[0])}_select(e,t){const s=this._completionModel;s&&(this._onDidSelect.fire({item:e,index:t,model:s}),this.editor.focus())}_onThemeChange(e){this._details.widget.borderWidth=b.isHighContrast(e.type)?2:1}_onListFocus(e){if(this._ignoreFocusEvents)return;if(!e.elements.length)return this._currentSuggestionDetails&&(this._currentSuggestionDetails.cancel(),this._currentSuggestionDetails=void 0,this._focusedItem=void 0),this.editor.setAriaOptions({activeDescendant:void 0}),void this._ctxSuggestWidgetHasFocusedSuggestion.set(!1);if(!this._completionModel)return;this._ctxSuggestWidgetHasFocusedSuggestion.set(!0);const t=e.elements[0],o=e.indexes[0];t!==this._focusedItem&&(this._currentSuggestionDetails?.cancel(),this._currentSuggestionDetails=void 0,this._focusedItem=t,this._list.reveal(o),this._currentSuggestionDetails=s.createCancelablePromise((async e=>{const i=s.disposableTimeout((()=>{this._isDetailsVisible()&&this.showDetails(!0)}),250),o=e.onCancellationRequested((()=>i.dispose()));try{return await t.resolve(e)}finally{i.dispose(),o.dispose()}})),this._currentSuggestionDetails.then((()=>{o>=this._list.length||t!==this._list.element(o)||(this._ignoreFocusEvents=!0,this._list.splice(o,1,[t]),this._list.setFocus([o]),this._ignoreFocusEvents=!1,this._isDetailsVisible()?this.showDetails(!1):this.element.domNode.classList.remove("docs-side"),this.editor.setAriaOptions({activeDescendant:C.getAriaId(o)}))})).catch(i.onUnexpectedError)),this._onDidFocus.fire({item:t,index:o,model:this._completionModel})}_setState(t){if(this._state!==t)switch(this._state=t,this.element.domNode.classList.toggle("frozen",4===t),this.element.domNode.classList.remove("message"),t){case 0:e.hide(this._messageElement,this._listElement,this._status.element),this._details.hide(!0),this._status.hide(),this._contentWidget.hide(),this._ctxSuggestWidgetVisible.reset(),this._ctxSuggestWidgetMultipleSuggestions.reset(),this._ctxSuggestWidgetHasFocusedSuggestion.reset(),this._showTimeout.cancel(),this.element.domNode.classList.remove("visible"),this._list.splice(0,this._list.length),this._focusedItem=void 0,this._cappedHeight=void 0,this._explainMode=!1;break;case 1:this.element.domNode.classList.add("message"),this._messageElement.textContent=f.LOADING_MESSAGE,e.hide(this._listElement,this._status.element),e.show(this._messageElement),this._details.hide(),this._show(),this._focusedItem=void 0,z.status(f.LOADING_MESSAGE);break;case 2:this.element.domNode.classList.add("message"),this._messageElement.textContent=f.NO_SUGGESTIONS_MESSAGE,e.hide(this._listElement,this._status.element),e.show(this._messageElement),this._details.hide(),this._show(),this._focusedItem=void 0,z.status(f.NO_SUGGESTIONS_MESSAGE);break;case 3:case 4:e.hide(this._messageElement),e.show(this._listElement,this._status.element),this._show();break;case 5:e.hide(this._messageElement),e.show(this._listElement,this._status.element),this._details.show(),this._show()}}_show(){this._status.show(),this._contentWidget.show(),this._layout(this._persistedSize.restore()),this._ctxSuggestWidgetVisible.set(!0),this._showTimeout.cancelAndSet((()=>{this.element.domNode.classList.add("visible"),this._onDidShow.fire(this)}),100)}showTriggered(e,t){0===this._state&&(this._contentWidget.setPosition(this.editor.getPosition()),this._isAuto=!!e,this._isAuto||(this._loadingTimeout=s.disposableTimeout((()=>this._setState(1)),t)))}showSuggestions(t,s,i,o,n){if(this._contentWidget.setPosition(this.editor.getPosition()),this._loadingTimeout?.dispose(),this._currentSuggestionDetails?.cancel(),this._currentSuggestionDetails=void 0,this._completionModel!==t&&(this._completionModel=t),i&&2!==this._state&&0!==this._state)return void this._setState(4);const r=this._completionModel.items.length,d=0===r;if(this._ctxSuggestWidgetMultipleSuggestions.set(r>1),d)return this._setState(o?0:2),void(this._completionModel=void 0);this._focusedItem=void 0,this._onDidFocus.pause(),this._onDidSelect.pause();try{this._list.splice(0,this._list.length,this._completionModel.items),this._setState(i?4:3),this._list.reveal(s,0),this._list.setFocus(n?[]:[s])}finally{this._onDidFocus.resume(),this._onDidSelect.resume()}this._pendingLayout.value=e.runAtThisOrScheduleAtNextAnimationFrame(e.getWindow(this.element.domNode),(()=>{this._pendingLayout.clear(),this._layout(this.element.size),this._details.widget.domNode.classList.remove("focused")}))}focusSelected(){this._list.length>0&&this._list.setFocus([0])}selectNextPage(){switch(this._state){case 0:return!1;case 5:return this._details.widget.pageDown(),!0;case 1:return!this._isAuto;default:return this._list.focusNextPage(),!0}}selectNext(){switch(this._state){case 0:return!1;case 1:return!this._isAuto;default:return this._list.focusNext(1,!0),!0}}selectLast(){switch(this._state){case 0:return!1;case 5:return this._details.widget.scrollBottom(),!0;case 1:return!this._isAuto;default:return this._list.focusLast(),!0}}selectPreviousPage(){switch(this._state){case 0:return!1;case 5:return this._details.widget.pageUp(),!0;case 1:return!this._isAuto;default:return this._list.focusPreviousPage(),!0}}selectPrevious(){switch(this._state){case 0:return!1;case 1:return!this._isAuto;default:return this._list.focusPrevious(1,!0),!1}}selectFirst(){switch(this._state){case 0:return!1;case 5:return this._details.widget.scrollTop(),!0;case 1:return!this._isAuto;default:return this._list.focusFirst(),!0}}getFocusedItem(){if(0!==this._state&&2!==this._state&&1!==this._state&&this._completionModel&&this._list.getFocus().length>0)return{item:this._list.getFocusedElements()[0],index:this._list.getFocus()[0],model:this._completionModel}}toggleDetailsFocus(){5===this._state?(this._setState(3),this._details.widget.domNode.classList.remove("focused")):3===this._state&&this._isDetailsVisible()&&(this._setState(5),this._details.widget.domNode.classList.add("focused"))}toggleDetails(){this._isDetailsVisible()?(this._pendingShowDetails.clear(),this._ctxSuggestWidgetDetailsVisible.set(!1),this._setDetailsVisible(!1),this._details.hide(),this.element.domNode.classList.remove("shows-details")):!y.canExpandCompletionItem(this._list.getFocusedElements()[0])&&!this._explainMode||3!==this._state&&5!==this._state&&4!==this._state||(this._ctxSuggestWidgetDetailsVisible.set(!0),this._setDetailsVisible(!0),this.showDetails(!1))}showDetails(t){this._pendingShowDetails.value=e.runAtThisOrScheduleAtNextAnimationFrame(e.getWindow(this.element.domNode),(()=>{this._pendingShowDetails.clear(),this._details.show(),t?this._details.widget.renderLoading():this._details.widget.renderItem(this._list.getFocusedElements()[0],this._explainMode),this._details.widget.isEmpty?this._details.hide():(this._positionDetails(),this.element.domNode.classList.add("shows-details")),this.editor.focus()}))}toggleExplainMode(){this._list.getFocusedElements()[0]&&(this._explainMode=!this._explainMode,this._isDetailsVisible()?this.showDetails(!1):this.toggleDetails())}resetPersistedSize(){this._persistedSize.reset()}hideWidget(){this._pendingLayout.clear(),this._pendingShowDetails.clear(),this._loadingTimeout?.dispose(),this._setState(0),this._onDidHide.fire(this),this.element.clearSashHoverState();const e=this._persistedSize.restore(),t=Math.ceil(4.3*this.getLayoutInfo().itemHeight);e&&e.height<t&&this._persistedSize.store(e.with(void 0,t))}isFrozen(){return 4===this._state}_afterRender(e){null!==e?2!==this._state&&1!==this._state&&(this._isDetailsVisible()&&!this._details.widget.isEmpty&&this._details.show(),this._positionDetails()):this._isDetailsVisible()&&this._details.hide()}_layout(t){if(!this.editor.hasModel())return;if(!this.editor.getDomNode())return;const s=e.getClientArea(this.element.domNode.ownerDocument.body),i=this.getLayoutInfo();t||(t=i.defaultSize);let o=t.height,n=t.width;if(this._status.element.style.height=`${i.itemHeight}px`,2===this._state||1===this._state)o=i.itemHeight+i.borderHeight,n=i.defaultSize.width/2,this.element.enableSashes(!1,!1,!1,!1),this.element.minSize=this.element.maxSize=new e.Dimension(n,o),this._contentWidget.setPreference(2);else{const r=s.width-i.borderHeight-2*i.horizontalPadding;n>r&&(n=r);const d=this._completionModel?this._completionModel.stats.pLabelLen*i.typicalHalfwidthCharacterWidth:n,h=i.statusBarHeight+this._list.contentHeight+i.borderHeight,l=i.itemHeight+i.statusBarHeight,a=e.getDomNodePagePosition(this.editor.getDomNode()),g=this.editor.getScrolledVisiblePosition(this.editor.getPosition()),c=a.top+g.top+g.height,u=Math.min(s.height-c-i.verticalPadding,h),_=a.top+g.top-i.verticalPadding,m=Math.min(_,h);let p=Math.min(Math.max(m,u)+i.borderHeight,h);o===this._cappedHeight?.capped&&(o=this._cappedHeight.wanted),o<l&&(o=l),o>p&&(o=p);const S=150;o>u||this._forceRenderingAbove&&_>S?(this._contentWidget.setPreference(1),this.element.enableSashes(!0,!0,!1,!1),p=m):(this._contentWidget.setPreference(2),this.element.enableSashes(!1,!0,!0,!1),p=u),this.element.preferredSize=new e.Dimension(d,i.defaultSize.height),this.element.maxSize=new e.Dimension(r,p),this.element.minSize=new e.Dimension(220,l),this._cappedHeight=o===h?{wanted:this._cappedHeight?.wanted??t.height,capped:o}:void 0}this._resize(n,o)}_resize(e,t){const{width:s,height:i}=this.element.maxSize;e=Math.min(s,e),t=Math.min(i,t);const{statusBarHeight:o}=this.getLayoutInfo();this._list.layout(t-o,e),this._listElement.style.height=t-o+"px",this.element.layout(t,e),this._contentWidget.layout(),this._positionDetails()}_positionDetails(){this._isDetailsVisible()&&this._details.placeAtAnchor(this.element.domNode,2===this._contentWidget.getPosition()?.preference[0])}getLayoutInfo(){const t=this.editor.getOption(50),s=r.clamp(this.editor.getOption(121)||t.lineHeight,8,1e3),i=this.editor.getOption(119).showStatusBar&&2!==this._state&&1!==this._state?s:0,o=this._details.widget.borderWidth,n=2*o;return{itemHeight:s,statusBarHeight:i,borderWidth:o,borderHeight:n,typicalHalfwidthCharacterWidth:t.typicalHalfwidthCharacterWidth,verticalPadding:22,horizontalPadding:14,defaultSize:new e.Dimension(430,i+12*s+n)}}_isDetailsVisible(){return this._storageService.getBoolean("expandSuggestionDocs",0,!1)}_setDetailsVisible(e){this._storageService.store("expandSuggestionDocs",e,0,0)}forceRenderingAbove(){this._forceRenderingAbove||(this._forceRenderingAbove=!0,this._layout(this._persistedSize.restore()))}stopForceRenderingAbove(){this._forceRenderingAbove=!1}},exports.SuggestWidget=f=E([F(1,u.IStorageService),F(2,g.IContextKeyService),F(3,D.IThemeService),F(4,c.IInstantiationService)],exports.SuggestWidget);class H{constructor(e,t){this._widget=e,this._editor=t,this.allowEditorOverflow=!0,this.suppressMouseDown=!1,this._preferenceLocked=!1,this._added=!1,this._hidden=!1}dispose(){this._added&&(this._added=!1,this._editor.removeContentWidget(this))}getId(){return"editor.widget.suggestWidget"}getDomNode(){return this._widget.element.domNode}show(){this._hidden=!1,this._added||(this._added=!0,this._editor.addContentWidget(this))}hide(){this._hidden||(this._hidden=!0,this.layout())}layout(){this._editor.layoutContentWidget(this)}getPosition(){return!this._hidden&&this._position&&this._preference?{position:this._position,preference:[this._preference]}:null}beforeRender(){const{height:t,width:s}=this._widget.element.size,{borderWidth:i,horizontalPadding:o}=this._widget.getLayoutInfo();return new e.Dimension(s+2*i+o,t+2*i)}afterRender(e){this._widget._afterRender(e)}setPreference(e){this._preferenceLocked||(this._preference=e)}lockPreference(){this._preferenceLocked=!0}unlockPreference(){this._preferenceLocked=!1}setPosition(e){this._position=e}}exports.SuggestContentWidget=H,exports.editorSuggestWidgetSelectedBackground=M;
//# sourceMappingURL=suggestWidget.js.map
