"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var i=require("../../../../base/common/async.js"),e=require("../../../../base/common/codicons.js"),t=require("../../../../base/common/htmlContent.js"),o=require("../../../../base/common/lifecycle.js"),n=require("../../../../base/common/platform.js"),s=require("../../../../base/common/strings.js");require("./unicodeHighlighter.css.js");var r=require("../../../browser/editorExtensions.js"),a=require("../../../common/config/editorOptions.js"),c=require("../../../common/model/textModel.js"),h=require("../../../common/services/unicodeTextModelHighlighter.js"),l=require("../../../common/services/editorWorker.js"),g=require("../../../common/languages/language.js"),u=require("../../../common/viewModel/viewModelDecorations.js"),d=require("../../hover/browser/hoverTypes.js"),m=require("../../hover/browser/markdownHoverParticipant.js"),p=require("./bannerController.js"),b=require("../../../../nls.js"),C=require("../../../../platform/configuration/common/configuration.js"),f=require("../../../../platform/instantiation/common/instantiation.js"),_=require("../../../../platform/opener/common/opener.js"),I=require("../../../../platform/quickinput/common/quickInput.js"),H=require("../../../../platform/theme/common/iconRegistry.js"),S=require("../../../../platform/workspace/common/workspaceTrust.js"),v=self&&self.__decorate||function(i,e,t,o){var n,s=arguments.length,r=s<3?e:null===o?o=Object.getOwnPropertyDescriptor(e,t):o;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(i,e,t,o);else for(var a=i.length-1;a>=0;a--)(n=i[a])&&(r=(s<3?n(r):s>3?n(e,t,r):n(e,t))||r);return s>3&&r&&Object.defineProperty(e,t,r),r},w=self&&self.__param||function(i,e){return function(t,o){e(t,o,i)}};const A=H.registerIcon("extensions-warning-message",e.Codicon.warning,b.localize("warningIcon","Icon shown with a warning message in the extensions editor."));exports.UnicodeHighlighter=class extends o.Disposable{static{this.ID="editor.contrib.unicodeHighlighter"}constructor(i,e,t,o){super(),this._editor=i,this._editorWorkerService=e,this._workspaceTrustService=t,this._highlighter=null,this._bannerClosed=!1,this._updateState=i=>{if(i&&i.hasMore){if(this._bannerClosed)return;const e=Math.max(i.ambiguousCharacterCount,i.nonBasicAsciiCharacterCount,i.invisibleCharacterCount);let t;if(i.nonBasicAsciiCharacterCount>=e)t={message:b.localize("unicodeHighlighting.thisDocumentHasManyNonBasicAsciiUnicodeCharacters","This document contains many non-basic ASCII unicode characters"),command:new E};else if(i.ambiguousCharacterCount>=e)t={message:b.localize("unicodeHighlighting.thisDocumentHasManyAmbiguousUnicodeCharacters","This document contains many ambiguous unicode characters"),command:new B};else{if(!(i.invisibleCharacterCount>=e))throw new Error("Unreachable");t={message:b.localize("unicodeHighlighting.thisDocumentHasManyInvisibleUnicodeCharacters","This document contains many invisible unicode characters"),command:new z}}this._bannerController.show({id:"unicodeHighlightBanner",message:t.message,icon:A,actions:[{label:t.command.shortLabel,href:`command:${t.command.id}`}],onClose:()=>{this._bannerClosed=!0}})}else this._bannerController.hide()},this._bannerController=this._register(o.createInstance(p.BannerController,i)),this._register(this._editor.onDidChangeModel((()=>{this._bannerClosed=!1,this._updateHighlighter()}))),this._options=i.getOption(126),this._register(t.onDidChangeTrust((i=>{this._updateHighlighter()}))),this._register(i.onDidChangeConfiguration((e=>{e.hasChanged(126)&&(this._options=i.getOption(126),this._updateHighlighter())}))),this._updateHighlighter()}dispose(){this._highlighter&&(this._highlighter.dispose(),this._highlighter=null),super.dispose()}_updateHighlighter(){if(this._updateState(null),this._highlighter&&(this._highlighter.dispose(),this._highlighter=null),!this._editor.hasModel())return;const i=function(i,e){return{nonBasicASCII:e.nonBasicASCII===a.inUntrustedWorkspace?!i:e.nonBasicASCII,ambiguousCharacters:e.ambiguousCharacters,invisibleCharacters:e.invisibleCharacters,includeComments:e.includeComments===a.inUntrustedWorkspace?!i:e.includeComments,includeStrings:e.includeStrings===a.inUntrustedWorkspace?!i:e.includeStrings,allowedCharacters:e.allowedCharacters,allowedLocales:e.allowedLocales}}(this._workspaceTrustService.isWorkspaceTrusted(),this._options);if([i.nonBasicASCII,i.ambiguousCharacters,i.invisibleCharacters].every((i=>!1===i)))return;const e={nonBasicASCII:i.nonBasicASCII,ambiguousCharacters:i.ambiguousCharacters,invisibleCharacters:i.invisibleCharacters,includeComments:i.includeComments,includeStrings:i.includeStrings,allowedCodePoints:Object.keys(i.allowedCharacters).map((i=>i.codePointAt(0))),allowedLocales:Object.keys(i.allowedLocales).map((i=>{if("_os"===i){return(new Intl.NumberFormat).resolvedOptions().locale}return"_vscode"===i?n.language:i}))};this._editorWorkerService.canComputeUnicodeHighlights(this._editor.getModel().uri)?this._highlighter=new D(this._editor,e,this._updateState,this._editorWorkerService):this._highlighter=new y(this._editor,e,this._updateState)}getDecorationInfo(i){return this._highlighter?this._highlighter.getDecorationInfo(i):null}},exports.UnicodeHighlighter=v([w(1,l.IEditorWorkerService),w(2,S.IWorkspaceTrustManagementService),w(3,f.IInstantiationService)],exports.UnicodeHighlighter);let D=class extends o.Disposable{constructor(e,t,o,n){super(),this._editor=e,this._options=t,this._updateState=o,this._editorWorkerService=n,this._model=this._editor.getModel(),this._decorations=this._editor.createDecorationsCollection(),this._updateSoon=this._register(new i.RunOnceScheduler((()=>this._update()),250)),this._register(this._editor.onDidChangeModelContent((()=>{this._updateSoon.schedule()}))),this._updateSoon.schedule()}dispose(){this._decorations.clear(),super.dispose()}_update(){if(this._model.isDisposed())return;if(!this._model.mightContainNonBasicASCII())return void this._decorations.clear();const i=this._model.getVersionId();this._editorWorkerService.computedUnicodeHighlights(this._model.uri,this._options).then((e=>{if(this._model.isDisposed())return;if(this._model.getVersionId()!==i)return;this._updateState(e);const t=[];if(!e.hasMore)for(const i of e.ranges)t.push({range:i,options:j.instance.getDecorationFromOptions(this._options)});this._decorations.set(t)}))}getDecorationInfo(i){if(!this._decorations.has(i))return null;const e=this._editor.getModel();if(!u.isModelDecorationVisible(e,i))return null;return{reason:O(e.getValueInRange(i.range),this._options),inComment:u.isModelDecorationInComment(e,i),inString:u.isModelDecorationInString(e,i)}}};D=v([w(3,l.IEditorWorkerService)],D);class y extends o.Disposable{constructor(e,t,o){super(),this._editor=e,this._options=t,this._updateState=o,this._model=this._editor.getModel(),this._decorations=this._editor.createDecorationsCollection(),this._updateSoon=this._register(new i.RunOnceScheduler((()=>this._update()),250)),this._register(this._editor.onDidLayoutChange((()=>{this._updateSoon.schedule()}))),this._register(this._editor.onDidScrollChange((()=>{this._updateSoon.schedule()}))),this._register(this._editor.onDidChangeHiddenAreas((()=>{this._updateSoon.schedule()}))),this._register(this._editor.onDidChangeModelContent((()=>{this._updateSoon.schedule()}))),this._updateSoon.schedule()}dispose(){this._decorations.clear(),super.dispose()}_update(){if(this._model.isDisposed())return;if(!this._model.mightContainNonBasicASCII())return void this._decorations.clear();const i=this._editor.getVisibleRanges(),e=[],t={ranges:[],ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0,hasMore:!1};for(const e of i){const i=h.UnicodeTextModelHighlighter.computeUnicodeHighlights(this._model,this._options,e);for(const e of i.ranges)t.ranges.push(e);t.ambiguousCharacterCount+=t.ambiguousCharacterCount,t.invisibleCharacterCount+=t.invisibleCharacterCount,t.nonBasicAsciiCharacterCount+=t.nonBasicAsciiCharacterCount,t.hasMore=t.hasMore||i.hasMore}if(!t.hasMore)for(const i of t.ranges)e.push({range:i,options:j.instance.getDecorationFromOptions(this._options)});this._updateState(t),this._decorations.set(e)}getDecorationInfo(i){if(!this._decorations.has(i))return null;const e=this._editor.getModel(),t=e.getValueInRange(i.range);return u.isModelDecorationVisible(e,i)?{reason:O(t,this._options),inComment:u.isModelDecorationInComment(e,i),inString:u.isModelDecorationInString(e,i)}:null}}const x=b.localize("unicodeHighlight.configureUnicodeHighlightOptions","Configure Unicode Highlight Options");function M(i){return`U+${i.toString(16).padStart(4,"0")}`}function k(i){let e=`\`${M(i)}\``;return s.InvisibleCharacters.isInvisibleCharacter(i)||(e+=` "${function(i){if(96===i)return"`` ` ``";return"`"+String.fromCodePoint(i)+"`"}(i)}"`),e}function O(i,e){return h.UnicodeTextModelHighlighter.computeUnicodeHighlightReason(i,e)}exports.UnicodeHighlighterHoverParticipant=class{constructor(i,e,t){this._editor=i,this._languageService=e,this._openerService=t,this.hoverOrdinal=5}computeSync(i,e){if(!this._editor.hasModel()||1!==i.type)return[];const o=this._editor.getModel(),n=this._editor.getContribution(exports.UnicodeHighlighter.ID);if(!n)return[];const r=[],a=new Set;let c=300;for(const i of e){const e=n.getDecorationInfo(i);if(!e)continue;const h=o.getValueInRange(i.range).codePointAt(0),l=k(h);let g;switch(e.reason.kind){case 0:g=s.isBasicASCII(e.reason.confusableWith)?b.localize("unicodeHighlight.characterIsAmbiguousASCII","The character {0} could be confused with the ASCII character {1}, which is more common in source code.",l,k(e.reason.confusableWith.codePointAt(0))):b.localize("unicodeHighlight.characterIsAmbiguous","The character {0} could be confused with the character {1}, which is more common in source code.",l,k(e.reason.confusableWith.codePointAt(0)));break;case 1:g=b.localize("unicodeHighlight.characterIsInvisible","The character {0} is invisible.",l);break;case 2:g=b.localize("unicodeHighlight.characterIsNonBasicAscii","The character {0} is not a basic ASCII character.",l)}if(a.has(g))continue;a.add(g);const u={codePoint:h,reason:e.reason,inComment:e.inComment,inString:e.inString},d=b.localize("unicodeHighlight.adjustSettings","Adjust settings"),p=`command:${L.ID}?${encodeURIComponent(JSON.stringify(u))}`,C=new t.MarkdownString("",!0).appendMarkdown(g).appendText(" ").appendLink(p,d,x);r.push(new m.MarkdownHover(this,i.range,[C],!1,c++))}return r}renderHoverParts(i,e){return m.renderMarkdownHovers(i,e,this._editor,this._languageService,this._openerService)}},exports.UnicodeHighlighterHoverParticipant=v([w(1,g.ILanguageService),w(2,_.IOpenerService)],exports.UnicodeHighlighterHoverParticipant);class j{constructor(){this.map=new Map}static{this.instance=new j}getDecorationFromOptions(i){return this.getDecoration(!i.includeComments,!i.includeStrings)}getDecoration(i,e){const t=`${i}${e}`;let o=this.map.get(t);return o||(o=c.ModelDecorationOptions.createDynamic({description:"unicode-highlight",stickiness:1,className:"unicode-highlight",showIfCollapsed:!0,overviewRuler:null,minimap:null,hideInCommentTokens:i,hideInStringTokens:e}),this.map.set(t,o)),o}}class U extends r.EditorAction{constructor(){super({id:B.ID,label:b.localize("action.unicodeHighlight.disableHighlightingInComments","Disable highlighting of characters in comments"),alias:"Disable highlighting of characters in comments",precondition:void 0}),this.shortLabel=b.localize("unicodeHighlight.disableHighlightingInComments.shortLabel","Disable Highlight In Comments")}async run(i,e,t){const o=i?.get(C.IConfigurationService);o&&this.runAction(o)}async runAction(i){await i.updateValue(a.unicodeHighlightConfigKeys.includeComments,!1,2)}}class q extends r.EditorAction{constructor(){super({id:B.ID,label:b.localize("action.unicodeHighlight.disableHighlightingInStrings","Disable highlighting of characters in strings"),alias:"Disable highlighting of characters in strings",precondition:void 0}),this.shortLabel=b.localize("unicodeHighlight.disableHighlightingInStrings.shortLabel","Disable Highlight In Strings")}async run(i,e,t){const o=i?.get(C.IConfigurationService);o&&this.runAction(o)}async runAction(i){await i.updateValue(a.unicodeHighlightConfigKeys.includeStrings,!1,2)}}class B extends r.EditorAction{static{this.ID="editor.action.unicodeHighlight.disableHighlightingOfAmbiguousCharacters"}constructor(){super({id:B.ID,label:b.localize("action.unicodeHighlight.disableHighlightingOfAmbiguousCharacters","Disable highlighting of ambiguous characters"),alias:"Disable highlighting of ambiguous characters",precondition:void 0}),this.shortLabel=b.localize("unicodeHighlight.disableHighlightingOfAmbiguousCharacters.shortLabel","Disable Ambiguous Highlight")}async run(i,e,t){const o=i?.get(C.IConfigurationService);o&&this.runAction(o)}async runAction(i){await i.updateValue(a.unicodeHighlightConfigKeys.ambiguousCharacters,!1,2)}}class z extends r.EditorAction{static{this.ID="editor.action.unicodeHighlight.disableHighlightingOfInvisibleCharacters"}constructor(){super({id:z.ID,label:b.localize("action.unicodeHighlight.disableHighlightingOfInvisibleCharacters","Disable highlighting of invisible characters"),alias:"Disable highlighting of invisible characters",precondition:void 0}),this.shortLabel=b.localize("unicodeHighlight.disableHighlightingOfInvisibleCharacters.shortLabel","Disable Invisible Highlight")}async run(i,e,t){const o=i?.get(C.IConfigurationService);o&&this.runAction(o)}async runAction(i){await i.updateValue(a.unicodeHighlightConfigKeys.invisibleCharacters,!1,2)}}class E extends r.EditorAction{static{this.ID="editor.action.unicodeHighlight.disableHighlightingOfNonBasicAsciiCharacters"}constructor(){super({id:E.ID,label:b.localize("action.unicodeHighlight.disableHighlightingOfNonBasicAsciiCharacters","Disable highlighting of non basic ASCII characters"),alias:"Disable highlighting of non basic ASCII characters",precondition:void 0}),this.shortLabel=b.localize("unicodeHighlight.disableHighlightingOfNonBasicAsciiCharacters.shortLabel","Disable Non ASCII Highlight")}async run(i,e,t){const o=i?.get(C.IConfigurationService);o&&this.runAction(o)}async runAction(i){await i.updateValue(a.unicodeHighlightConfigKeys.nonBasicASCII,!1,2)}}class L extends r.EditorAction{static{this.ID="editor.action.unicodeHighlight.showExcludeOptions"}constructor(){super({id:L.ID,label:b.localize("action.unicodeHighlight.showExcludeOptions","Show Exclude Options"),alias:"Show Exclude Options",precondition:void 0})}async run(i,e,t){const{codePoint:o,reason:n,inString:r,inComment:c}=t,h=String.fromCodePoint(o),l=i.get(I.IQuickInputService),g=i.get(C.IConfigurationService);const u=[];if(0===n.kind)for(const i of n.notAmbiguousInLocales)u.push({label:b.localize("unicodeHighlight.allowCommonCharactersInLanguage",'Allow unicode characters that are more common in the language "{0}".',i),run:async()=>{P(g,[i])}});if(u.push({label:function(i){return s.InvisibleCharacters.isInvisibleCharacter(i)?b.localize("unicodeHighlight.excludeInvisibleCharFromBeingHighlighted","Exclude {0} (invisible character) from being highlighted",M(i)):b.localize("unicodeHighlight.excludeCharFromBeingHighlighted","Exclude {0} from being highlighted",`${M(i)} "${h}"`)}(o),run:()=>async function(i,e){const t=i.getValue(a.unicodeHighlightConfigKeys.allowedCharacters);let o;o="object"==typeof t&&t?t:{};for(const i of e)o[String.fromCodePoint(i)]=!0;await i.updateValue(a.unicodeHighlightConfigKeys.allowedCharacters,o,2)}(g,[o])}),c){const i=new U;u.push({label:i.label,run:async()=>i.runAction(g)})}else if(r){const i=new q;u.push({label:i.label,run:async()=>i.runAction(g)})}if(0===n.kind){const i=new B;u.push({label:i.label,run:async()=>i.runAction(g)})}else if(1===n.kind){const i=new z;u.push({label:i.label,run:async()=>i.runAction(g)})}else if(2===n.kind){const i=new E;u.push({label:i.label,run:async()=>i.runAction(g)})}else!function(i){throw new Error(`Unexpected value: ${i}`)}(n);const d=await l.pick(u,{title:x});d&&await d.run()}}async function P(i,e){const t=i.inspect(a.unicodeHighlightConfigKeys.allowedLocales).user?.value;let o;o="object"==typeof t&&t?Object.assign({},t):{};for(const i of e)o[i]=!0;await i.updateValue(a.unicodeHighlightConfigKeys.allowedLocales,o,2)}r.registerEditorAction(B),r.registerEditorAction(z),r.registerEditorAction(E),r.registerEditorAction(L),r.registerEditorContribution(exports.UnicodeHighlighter.ID,exports.UnicodeHighlighter,1),d.HoverParticipantRegistry.register(exports.UnicodeHighlighterHoverParticipant),exports.DisableHighlightingInCommentsAction=U,exports.DisableHighlightingInStringsAction=q,exports.DisableHighlightingOfAmbiguousCharactersAction=B,exports.DisableHighlightingOfInvisibleCharactersAction=z,exports.DisableHighlightingOfNonBasicAsciiCharactersAction=E,exports.ShowExcludeOptions=L,exports.warningIcon=A;
//# sourceMappingURL=unicodeHighlighter.js.map
