"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var e,t,o=require("../../../../nls.js"),i=require("../../../../base/browser/ui/aria/aria.js"),r=require("../../../../base/common/async.js"),s=require("../../../../base/common/cancellation.js"),n=require("../../../../base/common/errors.js"),h=require("../../../../base/common/lifecycle.js"),l=require("../../../browser/editorBrowser.js"),d=require("../../../browser/editorExtensions.js"),c=require("../../../browser/services/codeEditorService.js"),u=require("../../../common/core/range.js"),g=require("../../../common/editorContextKeys.js"),a=require("../../../common/model.js"),m=require("../../../common/services/languageFeatures.js"),p=require("./highlightDecorations.js"),w=require("../../../../platform/contextkey/common/contextkey.js"),f=require("../../../../base/common/network.js"),_=require("../../../../base/common/map.js"),C=require("../../../common/languageSelector.js"),D=require("../../../../base/common/resources.js"),q=require("./textualHighlightProvider.js"),v=require("../../../common/editorFeatures.js"),H=self&&self.__decorate||function(e,t,o,i){var r,s=arguments.length,n=s<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,o):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)n=Reflect.decorate(e,t,o,i);else for(var h=e.length-1;h>=0;h--)(r=e[h])&&(n=(s<3?r(n):s>3?r(t,o,n):r(t,o))||n);return s>3&&n&&Object.defineProperty(t,o,n),n},b=self&&self.__param||function(e,t){return function(o,i){t(o,i,e)}};const k=new w.RawContextKey("hasWordHighlights",!1);function R(e,t,o,i){const s=e.ordered(t);return r.first(s.map((e=>()=>Promise.resolve(e.provideDocumentHighlights(t,o,i)).then(void 0,n.onUnexpectedExternalError))),(e=>null!=e)).then((e=>{if(e){const o=new _.ResourceMap;return o.set(t.uri,e),o}return new _.ResourceMap}))}function x(e,t,o,i,s,h){const l=e.ordered(t);return r.first(l.map((e=>()=>{const i=h.filter((e=>a.shouldSynchronizeModel(e))).filter((t=>C.score(e.selector,t.uri,t.getLanguageId(),!0,void 0,void 0)>0));return Promise.resolve(e.provideMultiDocumentHighlights(t,o,i,s)).then(void 0,n.onUnexpectedExternalError)})),(e=>null!=e))}class y{constructor(e,t,o){this._model=e,this._selection=t,this._wordSeparators=o,this._wordRange=this._getCurrentWordRange(e,t),this._result=null}get result(){return this._result||(this._result=r.createCancelablePromise((e=>this._compute(this._model,this._selection,this._wordSeparators,e)))),this._result}_getCurrentWordRange(e,t){const o=e.getWordAtPosition(t.getPosition());return o?new u.Range(t.startLineNumber,o.startColumn,t.startLineNumber,o.endColumn):null}isValid(e,t,o){const i=t.startLineNumber,r=t.startColumn,s=t.endColumn,n=this._getCurrentWordRange(e,t);let h=Boolean(this._wordRange&&this._wordRange.equalsRange(n));for(let e=0,t=o.length;!h&&e<t;e++){const t=o.getRange(e);t&&t.startLineNumber===i&&t.startColumn<=r&&t.endColumn>=s&&(h=!0)}return h}cancel(){this.result.cancel()}}class T extends y{constructor(e,t,o,i){super(e,t,o),this._providers=i}_compute(e,t,o,i){return R(this._providers,e,t.getPosition(),i).then((e=>e||new _.ResourceMap))}}class M extends y{constructor(e,t,o,i,r){super(e,t,o),this._providers=i,this._otherModels=r}_compute(e,t,o,i){return x(this._providers,e,t.getPosition(),0,i,this._otherModels).then((e=>e||new _.ResourceMap))}}d.registerModelAndPositionCommand("_executeDocumentHighlights",(async(e,t,o)=>{const i=e.get(m.ILanguageFeaturesService),r=await R(i.documentHighlightProvider,t,o,s.CancellationToken.None);return r?.get(t.uri)}));let P=class{static{e=this}static{this.storedDecorationIDs=new _.ResourceMap}static{this.query=null}constructor(t,o,i,s,n){this.toUnhook=new h.DisposableStore,this.workerRequestTokenId=0,this.workerRequestCompleted=!1,this.workerRequestValue=new _.ResourceMap,this.lastCursorPositionChangeTime=0,this.renderDecorationsTimer=-1,this.runDelayer=this.toUnhook.add(new r.Delayer(50)),this.editor=t,this.providers=o,this.multiDocumentProviders=i,this.codeEditorService=n,this._hasWordHighlights=k.bindTo(s),this._ignorePositionChangeEvent=!1,this.occurrencesHighlight=this.editor.getOption(81),this.model=this.editor.getModel(),this.toUnhook.add(t.onDidChangeCursorPosition((e=>{this._ignorePositionChangeEvent||"off"!==this.occurrencesHighlight&&this.runDelayer.trigger((()=>{this._onPositionChanged(e)}))}))),this.toUnhook.add(t.onDidFocusEditorText((e=>{"off"!==this.occurrencesHighlight&&(this.workerRequest||this.runDelayer.trigger((()=>{this._run()})))}))),this.toUnhook.add(t.onDidChangeModelContent((e=>{f.matchesScheme(this.model.uri,"output")||this._stopAll()}))),this.toUnhook.add(t.onDidChangeModel((t=>{!t.newModelUrl&&t.oldModelUrl?this._stopSingular():e.query&&this._run()}))),this.toUnhook.add(t.onDidChangeConfiguration((t=>{const o=this.editor.getOption(81);if(this.occurrencesHighlight!==o)switch(this.occurrencesHighlight=o,o){case"off":this._stopAll();break;case"singleFile":this._stopAll(e.query?.modelInfo?.model);break;case"multiFile":e.query&&this._run(!0);break;default:console.warn("Unknown occurrencesHighlight setting value:",o)}}))),this.decorations=this.editor.createDecorationsCollection(),this.workerRequestTokenId=0,this.workerRequest=null,this.workerRequestCompleted=!1,this.lastCursorPositionChangeTime=0,this.renderDecorationsTimer=-1,e.query&&this._run()}hasDecorations(){return this.decorations.length>0}restore(){"off"!==this.occurrencesHighlight&&(this.runDelayer.cancel(),this._run())}_getSortedHighlights(){return this.decorations.getRanges().sort(u.Range.compareRangesUsingStarts)}moveNext(){const e=this._getSortedHighlights(),t=e.findIndex((e=>e.containsPosition(this.editor.getPosition()))),o=(t+1)%e.length,r=e[o];try{this._ignorePositionChangeEvent=!0,this.editor.setPosition(r.getStartPosition()),this.editor.revealRangeInCenterIfOutsideViewport(r);const t=this._getWord();if(t){const s=this.editor.getModel().getLineContent(r.startLineNumber);i.alert(`${s}, ${o+1} of ${e.length} for '${t.word}'`)}}finally{this._ignorePositionChangeEvent=!1}}moveBack(){const e=this._getSortedHighlights(),t=e.findIndex((e=>e.containsPosition(this.editor.getPosition()))),o=(t-1+e.length)%e.length,r=e[o];try{this._ignorePositionChangeEvent=!0,this.editor.setPosition(r.getStartPosition()),this.editor.revealRangeInCenterIfOutsideViewport(r);const t=this._getWord();if(t){const s=this.editor.getModel().getLineContent(r.startLineNumber);i.alert(`${s}, ${o+1} of ${e.length} for '${t.word}'`)}}finally{this._ignorePositionChangeEvent=!1}}_removeSingleDecorations(){if(!this.editor.hasModel())return;const t=e.storedDecorationIDs.get(this.editor.getModel().uri);t&&(this.editor.removeDecorations(t),e.storedDecorationIDs.delete(this.editor.getModel().uri),this.decorations.length>0&&(this.decorations.clear(),this._hasWordHighlights.set(!1)))}_removeAllDecorations(t){const o=this.codeEditorService.listCodeEditors(),i=[];for(const r of o){if(!r.hasModel()||D.isEqual(r.getModel().uri,t?.uri))continue;const o=e.storedDecorationIDs.get(r.getModel().uri);if(!o)continue;r.removeDecorations(o),i.push(r.getModel().uri);const s=exports.WordHighlighterContribution.get(r);s?.wordHighlighter&&(s.wordHighlighter.decorations.length>0&&(s.wordHighlighter.decorations.clear(),s.wordHighlighter.workerRequest=null,s.wordHighlighter._hasWordHighlights.set(!1)))}for(const t of i)e.storedDecorationIDs.delete(t)}_stopSingular(){this._removeSingleDecorations(),this.editor.hasTextFocus()&&(this.editor.getModel()?.uri.scheme!==f.Schemas.vscodeNotebookCell&&e.query?.modelInfo?.model.uri.scheme!==f.Schemas.vscodeNotebookCell?(e.query=null,this._run()):e.query?.modelInfo&&(e.query.modelInfo=null)),-1!==this.renderDecorationsTimer&&(clearTimeout(this.renderDecorationsTimer),this.renderDecorationsTimer=-1),null!==this.workerRequest&&(this.workerRequest.cancel(),this.workerRequest=null),this.workerRequestCompleted||(this.workerRequestTokenId++,this.workerRequestCompleted=!0)}_stopAll(e){this._removeAllDecorations(e),-1!==this.renderDecorationsTimer&&(clearTimeout(this.renderDecorationsTimer),this.renderDecorationsTimer=-1),null!==this.workerRequest&&(this.workerRequest.cancel(),this.workerRequest=null),this.workerRequestCompleted||(this.workerRequestTokenId++,this.workerRequestCompleted=!0)}_onPositionChanged(e){"off"!==this.occurrencesHighlight&&(3===e.reason||this.editor.getModel()?.uri.scheme===f.Schemas.vscodeNotebookCell)?this._run():this._stopAll()}_getWord(){const e=this.editor.getSelection(),t=e.startLineNumber,o=e.startColumn;return this.model.isDisposed()?null:this.model.getWordAtPosition({lineNumber:t,column:o})}getOtherModelsToHighlight(e){if(!e)return[];if(e.uri.scheme===f.Schemas.vscodeNotebookCell){const t=[],o=this.codeEditorService.listCodeEditors();for(const i of o){const o=i.getModel();o&&o!==e&&o.uri.scheme===f.Schemas.vscodeNotebookCell&&t.push(o)}return t}const t=[],o=this.codeEditorService.listCodeEditors();for(const i of o){if(!l.isDiffEditor(i))continue;const o=i.getModel();o&&(e===o.modified&&t.push(o.modified))}if(t.length)return t;if("singleFile"===this.occurrencesHighlight)return[];for(const i of o){const o=i.getModel();o&&o!==e&&t.push(o)}return t}_run(t){let o;if(this.editor.hasTextFocus()){const t=this.editor.getSelection();if(!t||t.startLineNumber!==t.endLineNumber)return e.query=null,void this._stopAll();const i=t.startColumn,r=t.endColumn,s=this._getWord();if(!s||s.startColumn>i||s.endColumn<r)return e.query=null,void this._stopAll();o=this.workerRequest&&this.workerRequest.isValid(this.model,t,this.decorations),e.query={modelInfo:{model:this.model,selection:t},word:s}}else if(!e.query)return void this._stopAll();if(this.lastCursorPositionChangeTime=(new Date).getTime(),o)this.workerRequestCompleted&&-1!==this.renderDecorationsTimer&&(clearTimeout(this.renderDecorationsTimer),this.renderDecorationsTimer=-1,this._beginRenderDecorations());else if(D.isEqual(this.editor.getModel().uri,e.query.modelInfo?.model.uri)){if(!t){const e=this.decorations.getRanges();for(const t of e)if(t.containsPosition(this.editor.getPosition()))return}this._stopAll(t?this.model:void 0);const o=++this.workerRequestTokenId;this.workerRequestCompleted=!1;const i=this.getOtherModelsToHighlight(this.editor.getModel());if(!e.query||!e.query.modelInfo||e.query.modelInfo.model.isDisposed())return;this.workerRequest=this.computeWithModel(e.query.modelInfo.model,e.query.modelInfo.selection,e.query.word,i),this.workerRequest?.result.then((e=>{o===this.workerRequestTokenId&&(this.workerRequestCompleted=!0,this.workerRequestValue=e||[],this._beginRenderDecorations())}),n.onUnexpectedError)}}computeWithModel(e,t,o,i){return i.length?function(e,t,o,i,r,s){return new M(t,o,r,e,s)}(this.multiDocumentProviders,e,t,0,this.editor.getOption(132),i):function(e,t,o,i,r){return new T(t,o,r,e)}(this.providers,e,t,0,this.editor.getOption(132))}_beginRenderDecorations(){const e=(new Date).getTime(),t=this.lastCursorPositionChangeTime+250;e>=t?(this.renderDecorationsTimer=-1,this.renderDecorations()):this.renderDecorationsTimer=setTimeout((()=>{this.renderDecorations()}),t-e)}renderDecorations(){this.renderDecorationsTimer=-1;const t=this.codeEditorService.listCodeEditors();for(const o of t){const t=exports.WordHighlighterContribution.get(o);if(!t)continue;const i=[],r=o.getModel()?.uri;if(r&&this.workerRequestValue.has(r)){const s=e.storedDecorationIDs.get(r),n=this.workerRequestValue.get(r);if(n)for(const e of n)e.range&&i.push({range:e.range,options:p.getHighlightDecorationOptions(e.kind)});let h=[];o.changeDecorations((e=>{h=e.deltaDecorations(s??[],i)})),e.storedDecorationIDs=e.storedDecorationIDs.set(r,h),i.length>0&&(t.wordHighlighter?.decorations.set(i),t.wordHighlighter?._hasWordHighlights.set(!0))}}}dispose(){this._stopSingular(),this.toUnhook.dispose()}};P=e=H([b(4,c.ICodeEditorService)],P),exports.WordHighlighterContribution=class extends h.Disposable{static{t=this}static{this.ID="editor.contrib.wordHighlighter"}static get(e){return e.getContribution(t.ID)}constructor(e,t,o,i){super(),this._wordHighlighter=null;const r=()=>{e.hasModel()&&!e.getModel().isTooLargeForTokenization()&&(this._wordHighlighter=new P(e,o.documentHighlightProvider,o.multiDocumentHighlightProvider,t,i))};this._register(e.onDidChangeModel((e=>{this._wordHighlighter&&(this._wordHighlighter.dispose(),this._wordHighlighter=null),r()}))),r()}get wordHighlighter(){return this._wordHighlighter}saveViewState(){return!(!this._wordHighlighter||!this._wordHighlighter.hasDecorations())}moveNext(){this._wordHighlighter?.moveNext()}moveBack(){this._wordHighlighter?.moveBack()}restoreViewState(e){this._wordHighlighter&&e&&this._wordHighlighter.restore()}dispose(){this._wordHighlighter&&(this._wordHighlighter.dispose(),this._wordHighlighter=null),super.dispose()}},exports.WordHighlighterContribution=t=H([b(1,w.IContextKeyService),b(2,m.ILanguageFeaturesService),b(3,c.ICodeEditorService)],exports.WordHighlighterContribution);class S extends d.EditorAction{constructor(e,t){super(t),this._isNext=e}run(e,t){const o=exports.WordHighlighterContribution.get(t);o&&(this._isNext?o.moveNext():o.moveBack())}}class E extends d.EditorAction{constructor(){super({id:"editor.action.wordHighlight.trigger",label:o.localize("wordHighlight.trigger.label","Trigger Symbol Highlight"),alias:"Trigger Symbol Highlight",precondition:void 0,kbOpts:{kbExpr:g.EditorContextKeys.editorTextFocus,primary:0,weight:100}})}run(e,t,o){const i=exports.WordHighlighterContribution.get(t);i&&i.restoreViewState(!0)}}d.registerEditorContribution(exports.WordHighlighterContribution.ID,exports.WordHighlighterContribution,0),d.registerEditorAction(class extends S{constructor(){super(!0,{id:"editor.action.wordHighlight.next",label:o.localize("wordHighlight.next.label","Go to Next Symbol Highlight"),alias:"Go to Next Symbol Highlight",precondition:k,kbOpts:{kbExpr:g.EditorContextKeys.editorTextFocus,primary:65,weight:100}})}}),d.registerEditorAction(class extends S{constructor(){super(!1,{id:"editor.action.wordHighlight.prev",label:o.localize("wordHighlight.previous.label","Go to Previous Symbol Highlight"),alias:"Go to Previous Symbol Highlight",precondition:k,kbOpts:{kbExpr:g.EditorContextKeys.editorTextFocus,primary:1089,weight:100}})}}),d.registerEditorAction(E),v.registerEditorFeature(q.TextualMultiDocumentHighlightFeature),exports.getOccurrencesAcrossMultipleModels=x,exports.getOccurrencesAtPosition=R;
//# sourceMappingURL=wordHighlighter.js.map
