"use strict";require("./inspectTokens.css.js");var e,t=require("../../../../base/browser/dom.js"),o=require("../../../../base/common/color.js"),n=require("../../../../base/common/lifecycle.js"),i=require("../../../browser/editorExtensions.js"),s=require("../../../common/languages.js"),r=require("../../../common/encodedTokenAttributes.js"),a=require("../../../common/languages/nullTokenize.js"),d=require("../../../common/languages/language.js"),g=require("../../common/standaloneTheme.js"),l=require("../../../common/standaloneStrings.js"),c=self&&self.__decorate||function(e,t,o,n){var i,s=arguments.length,r=s<3?t:null===n?n=Object.getOwnPropertyDescriptor(t,o):n;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,o,n);else for(var a=e.length-1;a>=0;a--)(i=e[a])&&(r=(s<3?i(r):s>3?i(t,o,r):i(t,o))||r);return s>3&&r&&Object.defineProperty(t,o,r),r},u=self&&self.__param||function(e,t){return function(o,n){t(o,n,e)}};let h=class extends n.Disposable{static{e=this}static{this.ID="editor.contrib.inspectTokens"}static get(t){return t.getContribution(e.ID)}constructor(e,t,o){super(),this._editor=e,this._languageService=o,this._widget=null,this._register(this._editor.onDidChangeModel((e=>this.stop()))),this._register(this._editor.onDidChangeModelLanguage((e=>this.stop()))),this._register(s.TokenizationRegistry.onDidChange((e=>this.stop()))),this._register(this._editor.onKeyUp((e=>9===e.keyCode&&this.stop())))}dispose(){this.stop(),super.dispose()}launch(){this._widget||this._editor.hasModel()&&(this._widget=new k(this._editor,this._languageService))}stop(){this._widget&&(this._widget.dispose(),this._widget=null)}};h=e=c([u(1,g.IStandaloneThemeService),u(2,d.ILanguageService)],h);class m extends i.EditorAction{constructor(){super({id:"editor.action.inspectTokens",label:l.InspectTokensNLS.inspectTokensAction,alias:"Developer: Inspect Tokens",precondition:void 0})}run(e,t){const o=h.get(t);o?.launch()}}class k extends n.Disposable{static{this._ID="editor.contrib.inspectTokensWidget"}constructor(e,t){super(),this.allowEditorOverflow=!0,this._editor=e,this._languageService=t,this._model=this._editor.getModel(),this._domNode=document.createElement("div"),this._domNode.className="tokens-inspect-widget",this._tokenizationSupport=function(e,t){const o=s.TokenizationRegistry.get(t);if(o)return o;const n=e.encodeLanguageId(t);return{getInitialState:()=>a.NullState,tokenize:(e,o,n)=>a.nullTokenize(t,n),tokenizeEncoded:(e,t,o)=>a.nullTokenizeEncoded(n,o)}}(this._languageService.languageIdCodec,this._model.getLanguageId()),this._compute(this._editor.getPosition()),this._register(this._editor.onDidChangeCursorPosition((e=>this._compute(this._editor.getPosition())))),this._editor.addContentWidget(this)}dispose(){this._editor.removeContentWidget(this),super.dispose()}getId(){return k._ID}_compute(e){const n=this._getTokensAtLine(e.lineNumber);let i=0;for(let t=n.tokens1.length-1;t>=0;t--){const o=n.tokens1[t];if(e.column-1>=o.offset){i=t;break}}let s=0;for(let t=n.tokens2.length>>>1;t>=0;t--)if(e.column-1>=n.tokens2[t<<1]){s=t;break}const r=this._model.getLineContent(e.lineNumber);let a="";if(i<n.tokens1.length){const e=n.tokens1[i].offset,t=i+1<n.tokens1.length?n.tokens1[i+1].offset:r.length;a=r.substring(e,t)}t.reset(this._domNode,t.$("h2.tm-token",void 0,function(e){let t="";for(let o=0,n=e.length;o<n;o++){const n=e.charCodeAt(o);switch(n){case 9:t+="→";break;case 32:t+="·";break;default:t+=String.fromCharCode(n)}}return t}(a),t.$("span.tm-token-length",void 0,`${a.length} ${1===a.length?"char":"chars"}`))),t.append(this._domNode,t.$("hr.tokens-inspect-separator",{style:"clear:both"}));const d=1+(s<<1)<n.tokens2.length?this._decodeMetadata(n.tokens2[1+(s<<1)]):null;t.append(this._domNode,t.$("table.tm-metadata-table",void 0,t.$("tbody",void 0,t.$("tr",void 0,t.$("td.tm-metadata-key",void 0,"language"),t.$("td.tm-metadata-value",void 0,`${d?d.languageId:"-?-"}`)),t.$("tr",void 0,t.$("td.tm-metadata-key",void 0,"token type"),t.$("td.tm-metadata-value",void 0,`${d?this._tokenTypeToString(d.tokenType):"-?-"}`)),t.$("tr",void 0,t.$("td.tm-metadata-key",void 0,"font style"),t.$("td.tm-metadata-value",void 0,`${d?this._fontStyleToString(d.fontStyle):"-?-"}`)),t.$("tr",void 0,t.$("td.tm-metadata-key",void 0,"foreground"),t.$("td.tm-metadata-value",void 0,`${d?o.Color.Format.CSS.formatHex(d.foreground):"-?-"}`)),t.$("tr",void 0,t.$("td.tm-metadata-key",void 0,"background"),t.$("td.tm-metadata-value",void 0,`${d?o.Color.Format.CSS.formatHex(d.background):"-?-"}`))))),t.append(this._domNode,t.$("hr.tokens-inspect-separator")),i<n.tokens1.length&&t.append(this._domNode,t.$("span.tm-token-type",void 0,n.tokens1[i].type)),this._editor.layoutContentWidget(this)}_decodeMetadata(e){const t=s.TokenizationRegistry.getColorMap(),o=r.TokenMetadata.getLanguageId(e),n=r.TokenMetadata.getTokenType(e),i=r.TokenMetadata.getFontStyle(e),a=r.TokenMetadata.getForeground(e),d=r.TokenMetadata.getBackground(e);return{languageId:this._languageService.languageIdCodec.decodeLanguageId(o),tokenType:n,fontStyle:i,foreground:t[a],background:t[d]}}_tokenTypeToString(e){switch(e){case 0:return"Other";case 1:return"Comment";case 2:return"String";case 3:return"RegEx";default:return"??"}}_fontStyleToString(e){let t="";return 1&e&&(t+="italic "),2&e&&(t+="bold "),4&e&&(t+="underline "),8&e&&(t+="strikethrough "),0===t.length&&(t="---"),t}_getTokensAtLine(e){const t=this._getStateBeforeLine(e),o=this._tokenizationSupport.tokenize(this._model.getLineContent(e),!0,t),n=this._tokenizationSupport.tokenizeEncoded(this._model.getLineContent(e),!0,t);return{startState:t,tokens1:o.tokens,tokens2:n.tokens,endState:o.endState}}_getStateBeforeLine(e){let t=this._tokenizationSupport.getInitialState();for(let o=1;o<e;o++){t=this._tokenizationSupport.tokenize(this._model.getLineContent(o),!0,t).endState}return t}getDomNode(){return this._domNode}getPosition(){return{position:this._editor.getPosition(),preference:[2,1]}}}i.registerEditorContribution(h.ID,h,4),i.registerEditorAction(m);
//# sourceMappingURL=inspectTokens.js.map
