"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var e=require("../../../base/browser/ui/aria/aria.js"),t=require("../../../base/common/lifecycle.js"),i=require("../../browser/services/codeEditorService.js"),r=require("../../browser/widget/codeEditor/codeEditorWidget.js"),o=require("../../common/editorAction.js"),n=require("./standaloneServices.js"),a=require("../common/standaloneTheme.js"),s=require("../../../platform/actions/common/actions.js"),d=require("../../../platform/commands/common/commands.js"),c=require("../../../platform/configuration/common/configuration.js"),l=require("../../../platform/contextkey/common/contextkey.js"),u=require("../../../platform/contextview/browser/contextView.js"),g=require("../../../platform/instantiation/common/instantiation.js"),m=require("../../../platform/keybinding/common/keybinding.js"),v=require("../../../platform/notification/common/notification.js"),f=require("../../../platform/theme/common/themeService.js"),p=require("../../../platform/accessibility/common/accessibility.js"),h=require("../../common/standaloneStrings.js"),S=require("../../../platform/clipboard/common/clipboardService.js"),y=require("../../../platform/progress/common/progress.js"),C=require("../../common/services/model.js"),b=require("../../common/languages/language.js"),I=require("./standaloneCodeEditorService.js"),E=require("../../common/languages/modesRegistry.js"),x=require("../../common/languages/languageConfigurationRegistry.js"),_=require("../../common/services/languageFeatures.js"),j=require("../../browser/widget/diffEditor/diffEditorWidget.js"),q=require("../../../platform/accessibilitySignal/browser/accessibilitySignalService.js"),w=require("../../../base/browser/window.js"),D=require("../../../base/browser/ui/hover/hoverDelegateFactory.js"),K=require("../../../platform/hover/browser/hover.js"),M=require("../../../base/browser/ui/hover/hoverDelegate2.js"),A=self&&self.__decorate||function(e,t,i,r){var o,n=arguments.length,a=n<3?t:null===r?r=Object.getOwnPropertyDescriptor(t,i):r;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)a=Reflect.decorate(e,t,i,r);else for(var s=e.length-1;s>=0;s--)(o=e[s])&&(a=(n<3?o(a):n>3?o(t,i,a):o(t,i))||a);return n>3&&a&&Object.defineProperty(t,i,a),a},T=self&&self.__param||function(e,t){return function(i,r){t(i,r,e)}};let H=0,L=!1;function O(e,t,i,r,o){if(i=i||"",!r){const r=i.indexOf("\n");let n=i;return-1!==r&&(n=i.substring(0,r)),k(e,i,t.createByFilepathOrFirstLine(o||null,n),o)}return k(e,i,t.createById(r),o)}function k(e,t,i,r){return e.createModel(t,i,r)}exports.StandaloneCodeEditor=class extends r.CodeEditorWidget{constructor(t,i,r,o,a,s,d,c,l,u,g,m,v){const f={...i};f.ariaLabel=f.ariaLabel||h.StandaloneCodeEditorNLS.editorViewAccessibleLabel,super(t,f,{},r,o,a,s,l,u,g,m,v),c instanceof n.StandaloneKeybindingService?this._standaloneKeybindingService=c:this._standaloneKeybindingService=null,function(t){if(!t){if(L)return;L=!0}e.setARIAContainer(t||w.mainWindow.document.body)}(f.ariaContainerElement),D.setHoverDelegateFactory(((e,t)=>r.createInstance(K.WorkbenchHoverDelegate,e,t,{}))),M.setBaseLayerHoverDelegate(d)}addCommand(e,t,i){if(!this._standaloneKeybindingService)return console.warn("Cannot add command because the editor is configured with an unrecognized KeybindingService"),null;const r="DYNAMIC_"+ ++H,o=l.ContextKeyExpr.deserialize(i);return this._standaloneKeybindingService.addDynamicKeybinding(r,e,t,o),r}createContextKey(e,t){return this._contextKeyService.createKey(e,t)}addAction(e){if("string"!=typeof e.id||"string"!=typeof e.label||"function"!=typeof e.run)throw new Error("Invalid action descriptor, `id`, `label` and `run` are required properties!");if(!this._standaloneKeybindingService)return console.warn("Cannot add keybinding because the editor is configured with an unrecognized KeybindingService"),t.Disposable.None;const i=e.id,r=e.label,n=l.ContextKeyExpr.and(l.ContextKeyExpr.equals("editorId",this.getId()),l.ContextKeyExpr.deserialize(e.precondition)),a=e.keybindings,c=l.ContextKeyExpr.and(n,l.ContextKeyExpr.deserialize(e.keybindingContext)),u=e.contextMenuGroupId||null,g=e.contextMenuOrder||0,m=(t,...i)=>Promise.resolve(e.run(this,...i)),v=new t.DisposableStore,f=this.getId()+":"+i;if(v.add(d.CommandsRegistry.registerCommand(f,m)),u){const e={command:{id:f,title:r},when:n,group:u,order:g};v.add(s.MenuRegistry.appendMenuItem(s.MenuId.EditorContext,e))}if(Array.isArray(a))for(const e of a)v.add(this._standaloneKeybindingService.addDynamicKeybinding(f,e,m,c));const p=new o.InternalEditorAction(f,r,r,void 0,n,((...t)=>Promise.resolve(e.run(this,...t))),this._contextKeyService);return this._actions.set(i,p),v.add(t.toDisposable((()=>{this._actions.delete(i)}))),v}_triggerCommand(e,t){if(this._codeEditorService instanceof I.StandaloneCodeEditorService)try{this._codeEditorService.setActiveCodeEditor(this),super._triggerCommand(e,t)}finally{this._codeEditorService.setActiveCodeEditor(null)}else super._triggerCommand(e,t)}},exports.StandaloneCodeEditor=A([T(2,g.IInstantiationService),T(3,i.ICodeEditorService),T(4,d.ICommandService),T(5,l.IContextKeyService),T(6,K.IHoverService),T(7,m.IKeybindingService),T(8,f.IThemeService),T(9,v.INotificationService),T(10,p.IAccessibilityService),T(11,x.ILanguageConfigurationService),T(12,_.ILanguageFeaturesService)],exports.StandaloneCodeEditor),exports.StandaloneEditor=class extends exports.StandaloneCodeEditor{constructor(e,t,i,r,o,a,s,d,c,l,u,g,m,v,f,p){const h={...t};n.updateConfigurationService(u,h,!1);const S=c.registerEditorContainer(e);"string"==typeof h.theme&&c.setTheme(h.theme),void 0!==h.autoDetectHighContrast&&c.setAutoDetectHighContrast(Boolean(h.autoDetectHighContrast));const y=h.model;let C;if(delete h.model,super(e,h,i,r,o,a,s,d,c,l,g,f,p),this._configurationService=u,this._standaloneThemeService=c,this._register(S),void 0===y){const e=v.getLanguageIdByMimeType(h.language)||h.language||E.PLAINTEXT_LANGUAGE_ID;C=O(m,v,h.value||"",e,void 0),this._ownsModel=!0}else C=y,this._ownsModel=!1;if(this._attachModel(C),C){const e={oldModelUrl:null,newModelUrl:C.uri};this._onDidChangeModel.fire(e)}}dispose(){super.dispose()}updateOptions(e){n.updateConfigurationService(this._configurationService,e,!1),"string"==typeof e.theme&&this._standaloneThemeService.setTheme(e.theme),void 0!==e.autoDetectHighContrast&&this._standaloneThemeService.setAutoDetectHighContrast(Boolean(e.autoDetectHighContrast)),super.updateOptions(e)}_postDetachModelCleanup(e){super._postDetachModelCleanup(e),e&&this._ownsModel&&(e.dispose(),this._ownsModel=!1)}},exports.StandaloneEditor=A([T(2,g.IInstantiationService),T(3,i.ICodeEditorService),T(4,d.ICommandService),T(5,l.IContextKeyService),T(6,K.IHoverService),T(7,m.IKeybindingService),T(8,a.IStandaloneThemeService),T(9,v.INotificationService),T(10,c.IConfigurationService),T(11,p.IAccessibilityService),T(12,C.IModelService),T(13,b.ILanguageService),T(14,x.ILanguageConfigurationService),T(15,_.ILanguageFeaturesService)],exports.StandaloneEditor),exports.StandaloneDiffEditor2=class extends j.DiffEditorWidget{constructor(e,t,i,r,o,a,s,d,c,l,u,g){const m={...t};n.updateConfigurationService(d,m,!0);const v=a.registerEditorContainer(e);"string"==typeof m.theme&&a.setTheme(m.theme),void 0!==m.autoDetectHighContrast&&a.setAutoDetectHighContrast(Boolean(m.autoDetectHighContrast)),super(e,m,{},r,i,o,g,l),this._configurationService=d,this._standaloneThemeService=a,this._register(v)}dispose(){super.dispose()}updateOptions(e){n.updateConfigurationService(this._configurationService,e,!0),"string"==typeof e.theme&&this._standaloneThemeService.setTheme(e.theme),void 0!==e.autoDetectHighContrast&&this._standaloneThemeService.setAutoDetectHighContrast(Boolean(e.autoDetectHighContrast)),super.updateOptions(e)}_createInnerEditor(e,t,i){return e.createInstance(exports.StandaloneCodeEditor,t,i)}getOriginalEditor(){return super.getOriginalEditor()}getModifiedEditor(){return super.getModifiedEditor()}addCommand(e,t,i){return this.getModifiedEditor().addCommand(e,t,i)}createContextKey(e,t){return this.getModifiedEditor().createContextKey(e,t)}addAction(e){return this.getModifiedEditor().addAction(e)}},exports.StandaloneDiffEditor2=A([T(2,g.IInstantiationService),T(3,l.IContextKeyService),T(4,i.ICodeEditorService),T(5,a.IStandaloneThemeService),T(6,v.INotificationService),T(7,c.IConfigurationService),T(8,u.IContextMenuService),T(9,y.IEditorProgressService),T(10,S.IClipboardService),T(11,q.IAccessibilitySignalService)],exports.StandaloneDiffEditor2),exports.createTextModel=O;
//# sourceMappingURL=standaloneCodeEditor.js.map
