"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var e=require("../../../base/browser/dom.js"),t=require("../../../base/browser/browser.js"),o=require("../../../base/common/color.js"),s=require("../../../base/common/event.js"),r=require("../../common/languages.js"),n=require("../../common/encodedTokenAttributes.js"),i=require("../../common/languages/supports/tokenization.js"),h=require("../common/themes.js"),a=require("../../../platform/registry/common/platform.js"),l=require("../../../platform/theme/common/colorUtils.js");require("../../../platform/theme/common/colors/baseColors.js"),require("../../../platform/theme/common/colors/chartsColors.js"),require("../../../platform/theme/common/colors/editorColors.js"),require("../../../platform/theme/common/colors/inputColors.js"),require("../../../platform/theme/common/colors/listColors.js"),require("../../../platform/theme/common/colors/menuColors.js"),require("../../../platform/theme/common/colors/minimapColors.js"),require("../../../platform/theme/common/colors/miscColors.js"),require("../../../platform/theme/common/colors/quickpickColors.js"),require("../../../platform/theme/common/colors/searchColors.js");var m=require("../../../platform/theme/common/themeService.js"),c=require("../../../base/common/lifecycle.js"),u=require("../../../platform/theme/common/theme.js"),d=require("../../../platform/theme/browser/iconsStyleSheet.js"),_=require("../../../base/browser/window.js");const C="vs",g="vs-dark",S="hc-black",T="hc-light",p=a.Registry.as(l.Extensions.ColorContribution),f=a.Registry.as(m.Extensions.ThemingContribution);class k{constructor(e,t){this.semanticHighlighting=!1,this.themeData=t;const o=t.base;e.length>0?(b(e)?this.id=e:this.id=o+" "+e,this.themeName=e):(this.id=o,this.themeName=o),this.colors=null,this.defaultColors=Object.create(null),this._tokenTheme=null}get base(){return this.themeData.base}notifyBaseUpdated(){this.themeData.inherit&&(this.colors=null,this._tokenTheme=null)}getColors(){if(!this.colors){const e=new Map;for(const t in this.themeData.colors)e.set(t,o.Color.fromHex(this.themeData.colors[t]));if(this.themeData.inherit){const t=w(this.themeData.base);for(const s in t.colors)e.has(s)||e.set(s,o.Color.fromHex(t.colors[s]))}this.colors=e}return this.colors}getColor(e,t){const o=this.getColors().get(e);return o||(!1!==t?this.getDefault(e):void 0)}getDefault(e){let t=this.defaultColors[e];return t||(t=p.resolveDefaultColor(e,this),this.defaultColors[e]=t,t)}defines(e){return this.getColors().has(e)}get type(){switch(this.base){case C:return u.ColorScheme.LIGHT;case S:return u.ColorScheme.HIGH_CONTRAST_DARK;case T:return u.ColorScheme.HIGH_CONTRAST_LIGHT;default:return u.ColorScheme.DARK}}get tokenTheme(){if(!this._tokenTheme){let e=[],t=[];if(this.themeData.inherit){const o=w(this.themeData.base);e=o.rules,o.encodedTokensColors&&(t=o.encodedTokensColors)}const o=this.themeData.colors["editor.foreground"],s=this.themeData.colors["editor.background"];if(o||s){const t={token:""};o&&(t.foreground=o),s&&(t.background=s),e.push(t)}e=e.concat(this.themeData.rules),this.themeData.encodedTokensColors&&(t=this.themeData.encodedTokensColors),this._tokenTheme=i.TokenTheme.createFromRawTokenTheme(e,t)}return this._tokenTheme}getTokenStyleMetadata(e,t,o){const s=this.tokenTheme._match([e].concat(t).join(".")).metadata,r=n.TokenMetadata.getForeground(s),i=n.TokenMetadata.getFontStyle(s);return{foreground:r,italic:Boolean(1&i),bold:Boolean(2&i),underline:Boolean(4&i),strikethrough:Boolean(8&i)}}}function b(e){return e===C||e===g||e===S||e===T}function w(e){switch(e){case C:return h.vs;case g:return h.vs_dark;case S:return h.hc_black;case T:return h.hc_light}}function E(e){const t=w(e);return new k(e,t)}class D extends c.Disposable{constructor(){super(),this._onColorThemeChange=this._register(new s.Emitter),this.onDidColorThemeChange=this._onColorThemeChange.event,this._onProductIconThemeChange=this._register(new s.Emitter),this.onDidProductIconThemeChange=this._onProductIconThemeChange.event,this._environment=Object.create(null),this._builtInProductIconTheme=new d.UnthemedProductIconTheme,this._autoDetectHighContrast=!0,this._knownThemes=new Map,this._knownThemes.set(C,E(C)),this._knownThemes.set(g,E(g)),this._knownThemes.set(S,E(S)),this._knownThemes.set(T,E(T));const e=this._register(d.getIconsStyleSheet(this));this._codiconCSS=e.getCSS(),this._themeCSS="",this._allCSS=`${this._codiconCSS}\n${this._themeCSS}`,this._globalStyleElement=null,this._styleElements=[],this._colorMapOverride=null,this.setTheme(C),this._onOSSchemeChanged(),this._register(e.onDidChange((()=>{this._codiconCSS=e.getCSS(),this._updateCSS()}))),t.addMatchMediaChangeListener(_.mainWindow,"(forced-colors: active)",(()=>{this._onOSSchemeChanged()}))}registerEditorContainer(t){return e.isInShadowDOM(t)?this._registerShadowDomContainer(t):this._registerRegularEditorContainer()}_registerRegularEditorContainer(){return this._globalStyleElement||(this._globalStyleElement=e.createStyleSheet(void 0,(e=>{e.className="monaco-colors",e.textContent=this._allCSS})),this._styleElements.push(this._globalStyleElement)),c.Disposable.None}_registerShadowDomContainer(t){const o=e.createStyleSheet(t,(e=>{e.className="monaco-colors",e.textContent=this._allCSS}));return this._styleElements.push(o),{dispose:()=>{for(let e=0;e<this._styleElements.length;e++)if(this._styleElements[e]===o)return void this._styleElements.splice(e,1)}}}defineTheme(e,t){if(!/^[a-z0-9\-]+$/i.test(e))throw new Error("Illegal theme name!");if(!b(t.base)&&!b(e))throw new Error("Illegal theme base!");this._knownThemes.set(e,new k(e,t)),b(e)&&this._knownThemes.forEach((t=>{t.base===e&&t.notifyBaseUpdated()})),this._theme.themeName===e&&this.setTheme(e)}getColorTheme(){return this._theme}setColorMapOverride(e){this._colorMapOverride=e,this._updateThemeOrColorMap()}setTheme(e){let t;t=this._knownThemes.has(e)?this._knownThemes.get(e):this._knownThemes.get(C),this._updateActualTheme(t)}_updateActualTheme(e){e&&this._theme!==e&&(this._theme=e,this._updateThemeOrColorMap())}_onOSSchemeChanged(){if(this._autoDetectHighContrast){const e=_.mainWindow.matchMedia("(forced-colors: active)").matches;if(e!==u.isHighContrast(this._theme.type)){let t;t=u.isDark(this._theme.type)?e?S:g:e?T:C,this._updateActualTheme(this._knownThemes.get(t))}}}setAutoDetectHighContrast(e){this._autoDetectHighContrast=e,this._onOSSchemeChanged()}_updateThemeOrColorMap(){const e=[],t={},o={addRule:o=>{t[o]||(e.push(o),t[o]=!0)}};f.getThemingParticipants().forEach((e=>e(this._theme,o,this._environment)));const s=[];for(const e of p.getColors()){const t=this._theme.getColor(e.id,!0);t&&s.push(`${l.asCssVariableName(e.id)}: ${t.toString()};`)}o.addRule(`.monaco-editor, .monaco-diff-editor, .monaco-component { ${s.join("\n")} }`);const n=this._colorMapOverride||this._theme.tokenTheme.getColorMap();o.addRule(i.generateTokensCSSForColorMap(n)),this._themeCSS=e.join("\n"),this._updateCSS(),r.TokenizationRegistry.setColorMap(n),this._onColorThemeChange.fire(this._theme)}_updateCSS(){this._allCSS=`${this._codiconCSS}\n${this._themeCSS}`,this._styleElements.forEach((e=>e.textContent=this._allCSS))}getFileIconTheme(){return{hasFileIcons:!1,hasFolderIcons:!1,hidesExplorerArrows:!1}}getProductIconTheme(){return this._builtInProductIconTheme}}exports.HC_BLACK_THEME_NAME=S,exports.HC_LIGHT_THEME_NAME=T,exports.StandaloneThemeService=D,exports.VS_DARK_THEME_NAME=g,exports.VS_LIGHT_THEME_NAME=C;
//# sourceMappingURL=standaloneThemeService.js.map
