"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var e,t,n=require("../../../base/common/async.js"),i=require("../../../base/common/event.js"),s=require("../../../base/common/lifecycle.js"),o=require("./actions.js"),r=require("../../commands/common/commands.js"),a=require("../../contextkey/common/contextkey.js"),c=require("../../../base/common/actions.js"),d=require("../../storage/common/storage.js"),h=require("../../../base/common/arrays.js"),u=require("../../../nls.js"),l=require("../../keybinding/common/keybinding.js"),g=self&&self.__decorate||function(e,t,n,i){var s,o=arguments.length,r=o<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,n):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,n,i);else for(var a=e.length-1;a>=0;a--)(s=e[a])&&(r=(o<3?s(r):o>3?s(t,n,r):s(t,n))||r);return o>3&&r&&Object.defineProperty(t,n,r),r},m=self&&self.__param||function(e,t){return function(n,i){t(n,i,e)}};exports.MenuService=class{constructor(e,t,n){this._commandService=e,this._keybindingService=t,this._hiddenStates=new _(n)}createMenu(e,t,n){return new p(e,this._hiddenStates,{emitEventsForSubmenuChanges:!1,eventDebounceDelay:50,...n},this._commandService,this._keybindingService,t)}getMenuActions(e,t,n){const i=new p(e,this._hiddenStates,{emitEventsForSubmenuChanges:!1,eventDebounceDelay:50,...n},this._commandService,this._keybindingService,t),s=i.getActions(n);return i.dispose(),s}resetHiddenStates(e){this._hiddenStates.reset(e)}},exports.MenuService=g([m(0,r.ICommandService),m(1,l.IKeybindingService),m(2,d.IStorageService)],exports.MenuService);let _=class{static{e=this}static{this._key="menu.hiddenCommands"}constructor(t){this._storageService=t,this._disposables=new s.DisposableStore,this._onDidChange=new i.Emitter,this.onDidChange=this._onDidChange.event,this._ignoreChangeEvent=!1,this._hiddenByDefaultCache=new Map;try{const n=t.get(e._key,0,"{}");this._data=JSON.parse(n)}catch(e){this._data=Object.create(null)}this._disposables.add(t.onDidChangeValue(0,e._key,this._disposables)((()=>{if(!this._ignoreChangeEvent)try{const n=t.get(e._key,0,"{}");this._data=JSON.parse(n)}catch(e){console.log("FAILED to read storage after UPDATE",e)}this._onDidChange.fire()})))}dispose(){this._onDidChange.dispose(),this._disposables.dispose()}_isHiddenByDefault(e,t){return this._hiddenByDefaultCache.get(`${e.id}/${t}`)??!1}setDefaultState(e,t,n){this._hiddenByDefaultCache.set(`${e.id}/${t}`,n)}isHidden(e,t){const n=this._isHiddenByDefault(e,t),i=this._data[e.id]?.includes(t)??!1;return n?!i:i}updateHidden(e,t,n){this._isHiddenByDefault(e,t)&&(n=!n);const i=this._data[e.id];if(n)if(i){i.indexOf(t)<0&&i.push(t)}else this._data[e.id]=[t];else if(i){const n=i.indexOf(t);n>=0&&h.removeFastWithoutKeepingOrder(i,n),0===i.length&&delete this._data[e.id]}this._persist()}reset(e){if(void 0===e)this._data=Object.create(null),this._persist();else{for(const{id:t}of e)this._data[t]&&delete this._data[t];this._persist()}}_persist(){try{this._ignoreChangeEvent=!0;const t=JSON.stringify(this._data);this._storageService.store(e._key,t,0,0)}finally{this._ignoreChangeEvent=!1}}};_=e=g([m(0,d.IStorageService)],_);class f{constructor(e,t){this._id=e,this._collectContextKeysForSubmenus=t,this._menuGroups=[],this._allMenuIds=new Set,this._structureContextKeys=new Set,this._preconditionContextKeys=new Set,this._toggledContextKeys=new Set,this.refresh()}get allMenuIds(){return this._allMenuIds}get structureContextKeys(){return this._structureContextKeys}get preconditionContextKeys(){return this._preconditionContextKeys}get toggledContextKeys(){return this._toggledContextKeys}refresh(){this._menuGroups.length=0,this._allMenuIds.clear(),this._structureContextKeys.clear(),this._preconditionContextKeys.clear(),this._toggledContextKeys.clear();const e=this._sort(o.MenuRegistry.getMenuItems(this._id));let t;for(const n of e){const e=n.group||"";t&&t[0]===e||(t=[e,[]],this._menuGroups.push(t)),t[1].push(n),this._collectContextKeysAndSubmenuIds(n)}this._allMenuIds.add(this._id)}_sort(e){return e}_collectContextKeysAndSubmenuIds(e){if(f._fillInKbExprKeys(e.when,this._structureContextKeys),o.isIMenuItem(e)){if(e.command.precondition&&f._fillInKbExprKeys(e.command.precondition,this._preconditionContextKeys),e.command.toggled){const t=e.command.toggled.condition||e.command.toggled;f._fillInKbExprKeys(t,this._toggledContextKeys)}}else this._collectContextKeysForSubmenus&&(o.MenuRegistry.getMenuItems(e.submenu).forEach(this._collectContextKeysAndSubmenuIds,this),this._allMenuIds.add(e.submenu))}static _fillInKbExprKeys(e,t){if(e)for(const n of e.keys())t.add(n)}}let y=t=class extends f{constructor(e,t,n,i,s,o){super(e,n),this._hiddenStates=t,this._commandService=i,this._keybindingService=s,this._contextKeyService=o,this.refresh()}createActionGroups(e){const n=[];for(const i of this._menuGroups){const[s,r]=i;let a;for(const n of r)if(this._contextKeyService.contextMatchesRules(n.when)){const i=o.isIMenuItem(n);i&&this._hiddenStates.setDefaultState(this._id,n.command.id,!!n.isHiddenByDefault);const s=b(this._id,i?n.command:n,this._hiddenStates);if(i){const t=C(this._commandService,this._keybindingService,n.command.id,n.when);(a??=[]).push(new o.MenuItemAction(n.command,n.alt,e,s,t,this._contextKeyService,this._commandService))}else{const i=new t(n.submenu,this._hiddenStates,this._collectContextKeysForSubmenus,this._commandService,this._keybindingService,this._contextKeyService).createActionGroups(e),r=c.Separator.join(...i.map((e=>e[1])));r.length>0&&(a??=[]).push(new o.SubmenuItemAction(n,s,r))}}a&&a.length>0&&n.push([s,a])}return n}_sort(e){return e.sort(t._compareMenuItems)}static _compareMenuItems(e,n){const i=e.group,s=n.group;if(i!==s){if(!i)return 1;if(!s)return-1;if("navigation"===i)return-1;if("navigation"===s)return 1;const e=i.localeCompare(s);if(0!==e)return e}const r=e.order||0,a=n.order||0;return r<a?-1:r>a?1:t._compareTitles(o.isIMenuItem(e)?e.command.title:e.title,o.isIMenuItem(n)?n.command.title:n.title)}static _compareTitles(e,t){const n="string"==typeof e?e:e.original,i="string"==typeof t?t:t.original;return n.localeCompare(i)}};y=t=g([m(3,r.ICommandService),m(4,l.IKeybindingService),m(5,a.IContextKeyService)],y);let p=class{constructor(e,t,r,a,c,d){this._disposables=new s.DisposableStore,this._menuInfo=new y(e,t,r.emitEventsForSubmenuChanges,a,c,d);const h=new n.RunOnceScheduler((()=>{this._menuInfo.refresh(),this._onDidChange.fire({menu:this,isStructuralChange:!0,isEnablementChange:!0,isToggleChange:!0})}),r.eventDebounceDelay);this._disposables.add(h),this._disposables.add(o.MenuRegistry.onDidChangeMenu((e=>{for(const t of this._menuInfo.allMenuIds)if(e.has(t)){h.schedule();break}})));const u=this._disposables.add(new s.DisposableStore);this._onDidChange=new i.DebounceEmitter({onWillAddFirstListener:()=>{u.add(d.onDidChangeContext((e=>{const t=e.affectsSome(this._menuInfo.structureContextKeys),n=e.affectsSome(this._menuInfo.preconditionContextKeys),i=e.affectsSome(this._menuInfo.toggledContextKeys);(t||n||i)&&this._onDidChange.fire({menu:this,isStructuralChange:t,isEnablementChange:n,isToggleChange:i})}))),u.add(t.onDidChange((e=>{this._onDidChange.fire({menu:this,isStructuralChange:!0,isEnablementChange:!1,isToggleChange:!1})})))},onDidRemoveLastListener:u.clear.bind(u),delay:r.eventDebounceDelay,merge:e=>{let t=!1,n=!1,i=!1;for(const s of e)if(t=t||s.isStructuralChange,n=n||s.isEnablementChange,i=i||s.isToggleChange,t&&n&&i)break;return{menu:this,isStructuralChange:t,isEnablementChange:n,isToggleChange:i}}}),this.onDidChange=this._onDidChange.event}getActions(e){return this._menuInfo.createActionGroups(e)}dispose(){this._disposables.dispose(),this._onDidChange.dispose()}};function b(e,t,n){const i=o.isISubmenuItem(t)?t.submenu.id:t.id,s="string"==typeof t.title?t.title:t.title.value,r=c.toAction({id:`hide/${e.id}/${i}`,label:u.localize("hide.label","Hide '{0}'",s),run(){n.updateHidden(e,i,!0)}}),a=c.toAction({id:`toggle/${e.id}/${i}`,label:s,get checked(){return!n.isHidden(e,i)},run(){n.updateHidden(e,i,!!this.checked)}});return{hide:r,toggle:a,get isHidden(){return!a.checked}}}function C(e,t,n,i=void 0,s=!0){return c.toAction({id:`configureKeybinding/${n}`,label:u.localize("configure keybinding","Configure Keybinding"),enabled:s,run(){const s=!!!t.lookupKeybinding(n)&&i?i.serialize():void 0;e.executeCommand("workbench.action.openGlobalKeybindings",`@command:${n}`+(s?` +when:${s}`:""))}})}p=g([m(3,r.ICommandService),m(4,l.IKeybindingService),m(5,a.IContextKeyService)],p),exports.createConfigureKeybindingAction=C;
//# sourceMappingURL=menuService.js.map
