"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var e=require("../../../base/common/arrays.js"),t=require("../../../base/common/map.js"),i=require("../../../base/common/objects.js"),o=require("../../../base/common/types.js"),r=require("../../../base/common/uri.js"),s=require("./configuration.js"),n=require("./configurationRegistry.js"),a=require("../../registry/common/platform.js");function u(e){return Object.isFrozen(e)?e:i.deepFreeze(e)}class c{static createEmptyModel(e){return new c({},[],[],void 0,e)}constructor(e,t,i,o,r){this._contents=e,this._keys=t,this._overrides=i,this.raw=o,this.logService=r,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const e=this.raw.map((e=>{if(e instanceof c)return e;const t=new d("",this.logService);return t.parseRaw(e),t.configurationModel}));this._rawConfiguration=e.reduce(((e,t)=>t===e?t:e.merge(t)),e[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return 0===this._keys.length&&0===Object.keys(this._contents).length&&0===this._overrides.length}getValue(e){return e?s.getConfigurationValue(this.contents,e):this.contents}inspect(e,t){const i=this;return{get value(){return u(i.rawConfiguration.getValue(e))},get override(){return t?u(i.rawConfiguration.getOverrideValue(e,t)):void 0},get merged(){return u(t?i.rawConfiguration.override(t).getValue(e):i.rawConfiguration.getValue(e))},get overrides(){const t=[];for(const{contents:o,identifiers:r,keys:s}of i.rawConfiguration.overrides){const n=new c(o,s,[],void 0,i.logService).getValue(e);void 0!==n&&t.push({identifiers:r,value:n})}return t.length?u(t):void 0}}}getOverrideValue(e,t){const i=this.getContentsForOverrideIdentifer(t);return i?e?s.getConfigurationValue(i,e):i:void 0}override(e){let t=this.overrideConfigurations.get(e);return t||(t=this.createOverrideConfigurationModel(e),this.overrideConfigurations.set(e,t)),t}merge(...t){const o=i.deepClone(this.contents),r=i.deepClone(this.overrides),s=[...this.keys],n=this.raw?.length?[...this.raw]:[this];for(const a of t)if(n.push(...a.raw?.length?a.raw:[a]),!a.isEmpty()){this.mergeContents(o,a.contents);for(const t of a.overrides){const[o]=r.filter((i=>e.equals(i.identifiers,t.identifiers)));o?(this.mergeContents(o.contents,t.contents),o.keys.push(...t.keys),o.keys=e.distinct(o.keys)):r.push(i.deepClone(t))}for(const e of a.keys)-1===s.indexOf(e)&&s.push(e)}return new c(o,s,r,n.every((e=>e instanceof c))?void 0:n,this.logService)}createOverrideConfigurationModel(t){const o=this.getContentsForOverrideIdentifer(t);if(!o||"object"!=typeof o||!Object.keys(o).length)return this;const r={};for(const t of e.distinct([...Object.keys(this.contents),...Object.keys(o)])){let e=this.contents[t];const s=o[t];s&&("object"==typeof e&&"object"==typeof s?(e=i.deepClone(e),this.mergeContents(e,s)):e=s),r[t]=e}return new c(r,this.keys,this.overrides,void 0,this.logService)}mergeContents(e,t){for(const r of Object.keys(t))r in e&&o.isObject(e[r])&&o.isObject(t[r])?this.mergeContents(e[r],t[r]):e[r]=i.deepClone(t[r])}getContentsForOverrideIdentifer(e){let t=null,o=null;const r=e=>{e&&(o?this.mergeContents(o,e):o=i.deepClone(e))};for(const i of this.overrides)1===i.identifiers.length&&i.identifiers[0]===e?t=i.contents:i.identifiers.includes(e)&&r(i.contents);return r(t),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(e,t){this.updateValue(e,t,!1)}removeValue(t){const i=this.keys.indexOf(t);-1!==i&&(this.keys.splice(i,1),s.removeFromValueTree(this.contents,t),n.OVERRIDE_PROPERTY_REGEX.test(t)&&this.overrides.splice(this.overrides.findIndex((i=>e.equals(i.identifiers,n.overrideIdentifiersFromKey(t)))),1))}updateValue(t,i,o){if(s.addToValueTree(this.contents,t,i,(e=>this.logService.error(e))),(o=o||-1===this.keys.indexOf(t))&&this.keys.push(t),n.OVERRIDE_PROPERTY_REGEX.test(t)){const i=n.overrideIdentifiersFromKey(t),o={identifiers:i,keys:Object.keys(this.contents[t]),contents:s.toValuesTree(this.contents[t],(e=>this.logService.error(e)))},r=this.overrides.findIndex((t=>e.equals(t.identifiers,i)));-1!==r?this.overrides[r]=o:this.overrides.push(o)}}}class d{constructor(e,t){this._name=e,this.logService=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[]}get configurationModel(){return this._configurationModel||c.createEmptyModel(this.logService)}parseRaw(e,t){this._raw=e;const{contents:i,keys:o,overrides:r,restricted:s,hasExcludedProperties:n}=this.doParseRaw(e,t);this._configurationModel=new c(i,o,r,n?[e]:void 0,this.logService),this._restrictedConfigurations=s||[]}doParseRaw(e,t){const i=a.Registry.as(n.Extensions.Configuration).getConfigurationProperties(),o=this.filter(e,i,!0,t);e=o.raw;return{contents:s.toValuesTree(e,(e=>this.logService.error(`Conflict in settings file ${this._name}: ${e}`))),keys:Object.keys(e),overrides:this.toOverrides(e,(e=>this.logService.error(`Conflict in settings file ${this._name}: ${e}`))),restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}filter(e,t,i,o){let r=!1;if(!o?.scopes&&!o?.skipRestricted&&!o?.exclude?.length)return{raw:e,restricted:[],hasExcludedProperties:r};const s={},a=[];for(const u in e)if(n.OVERRIDE_PROPERTY_REGEX.test(u)&&i){const i=this.filter(e[u],t,!1,o);s[u]=i.raw,r=r||i.hasExcludedProperties,a.push(...i.restricted)}else{const i=t[u],n=i?void 0!==i.scope?i.scope:3:void 0;i?.restricted&&a.push(u),o.exclude?.includes(u)||!o.include?.includes(u)&&(void 0!==n&&void 0!==o.scopes&&!o.scopes.includes(n)||o.skipRestricted&&i?.restricted)?r=!0:s[u]=e[u]}return{raw:s,restricted:a,hasExcludedProperties:r}}toOverrides(e,t){const i=[];for(const o of Object.keys(e))if(n.OVERRIDE_PROPERTY_REGEX.test(o)){const r={};for(const t in e[o])r[t]=e[o][t];i.push({identifiers:n.overrideIdentifiersFromKey(o),keys:Object.keys(r),contents:s.toValuesTree(r,t)})}return i}}class f{constructor(e,t,i,o,r,s,n,a,u,c,d,f,h){this.key=e,this.overrides=t,this._value=i,this.overrideIdentifiers=o,this.defaultConfiguration=r,this.policyConfiguration=s,this.applicationConfiguration=n,this.userConfiguration=a,this.localUserConfiguration=u,this.remoteUserConfiguration=c,this.workspaceConfiguration=d,this.folderConfigurationModel=f,this.memoryConfigurationModel=h}toInspectValue(e){return void 0!==e?.value||void 0!==e?.override||void 0!==e?.overrides?e:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.userConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get user(){return this.toInspectValue(this.userInspectValue)}}class h{constructor(e,i,o,r,s,n,a,u,c,d){this._defaultConfiguration=e,this._policyConfiguration=i,this._applicationConfiguration=o,this._localUserConfiguration=r,this._remoteUserConfiguration=s,this._workspaceConfiguration=n,this._folderConfigurations=a,this._memoryConfiguration=u,this._memoryConfigurationByResource=c,this.logService=d,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new t.ResourceMap,this._userConfiguration=null}getValue(e,t,i){return this.getConsolidatedConfigurationModel(e,t,i).getValue(e)}updateValue(e,t,i={}){let o;i.resource?(o=this._memoryConfigurationByResource.get(i.resource),o||(o=c.createEmptyModel(this.logService),this._memoryConfigurationByResource.set(i.resource,o))):o=this._memoryConfiguration,void 0===t?o.removeValue(e):o.setValue(e,t),i.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(e,t,i){const o=this.getConsolidatedConfigurationModel(e,t,i),r=this.getFolderConfigurationModelForResource(t.resource,i),s=t.resource&&this._memoryConfigurationByResource.get(t.resource)||this._memoryConfiguration,n=new Set;for(const t of o.overrides)for(const i of t.identifiers)void 0!==o.getOverrideValue(e,i)&&n.add(i);return new f(e,t,o.getValue(e),n.size?[...n]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,i?this._workspaceConfiguration:void 0,r||void 0,s)}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}getConsolidatedConfigurationModel(e,t,i){let o=this.getConsolidatedConfigurationModelForResource(t,i);return t.overrideIdentifier&&(o=o.override(t.overrideIdentifier)),this._policyConfiguration.isEmpty()||void 0===this._policyConfiguration.getValue(e)||(o=o.merge(this._policyConfiguration)),o}getConsolidatedConfigurationModelForResource({resource:e},t){let i=this.getWorkspaceConsolidatedConfiguration();if(t&&e){const o=t.getFolder(e);o&&(i=this.getFolderConsolidatedConfiguration(o.uri)||i);const r=this._memoryConfigurationByResource.get(e);r&&(i=i.merge(r))}return i}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(e){let t=this._foldersConsolidatedConfigurations.get(e);if(!t){const i=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(e);o?(t=i.merge(o),this._foldersConsolidatedConfigurations.set(e,t)):t=i}return t}getFolderConfigurationModelForResource(e,t){if(t&&e){const i=t.getFolder(e);if(i)return this._folderConfigurations.get(i.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce(((e,t)=>{const{contents:i,overrides:o,keys:r}=this._folderConfigurations.get(t);return e.push([t,{contents:i,overrides:o,keys:r}]),e}),[])}}static parse(e,i){const o=this.parseConfigurationModel(e.defaults,i),s=this.parseConfigurationModel(e.policy,i),n=this.parseConfigurationModel(e.application,i),a=this.parseConfigurationModel(e.user,i),u=this.parseConfigurationModel(e.workspace,i),d=e.folders.reduce(((e,t)=>(e.set(r.URI.revive(t[0]),this.parseConfigurationModel(t[1],i)),e)),new t.ResourceMap);return new h(o,s,n,a,c.createEmptyModel(i),u,d,c.createEmptyModel(i),new t.ResourceMap,i)}static parseConfigurationModel(e,t){return new c(e.contents,e.keys,e.overrides,void 0,t)}}exports.Configuration=h,exports.ConfigurationChangeEvent=class{constructor(e,t,i,o,r){this.change=e,this.previous=t,this.currentConfiguraiton=i,this.currentWorkspace=o,this.logService=r,this._marker="\n",this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=".".charCodeAt(0),this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const t of e.keys)this.affectedKeys.add(t);for(const[,t]of e.overrides)for(const e of t)this.affectedKeys.add(e);this._affectsConfigStr=this._marker;for(const e of this.affectedKeys)this._affectsConfigStr+=e+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=h.parse(this.previous.data,this.logService)),this._previousConfiguration}affectsConfiguration(e,t){const o=this._marker+e,r=this._affectsConfigStr.indexOf(o);if(r<0)return!1;const s=r+o.length;if(s>=this._affectsConfigStr.length)return!1;const n=this._affectsConfigStr.charCodeAt(s);if(n!==this._markerCode1&&n!==this._markerCode2)return!1;if(t){const o=this.previousConfiguration?this.previousConfiguration.getValue(e,t,this.previous?.workspace):void 0,r=this.currentConfiguraiton.getValue(e,t,this.currentWorkspace);return!i.equals(o,r)}return!0}},exports.ConfigurationModel=c,exports.ConfigurationModelParser=d;
//# sourceMappingURL=configurationModels.js.map
