"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var e=require("../../../base/common/async.js"),t=require("../../../base/common/errors.js"),s=require("../../../base/common/lifecycle.js"),i=require("./descriptors.js"),n=require("./graph.js"),r=require("./instantiation.js"),c=require("./serviceCollection.js"),a=require("../../../base/common/linkedList.js");class o extends Error{constructor(e){super("cyclic dependency between services"),this.message=e.findCycleSlow()??`UNABLE to detect cycle, dumping graph: \n${e.toString()}`}}class h{constructor(e=new c.ServiceCollection,t=!1,s,i=false){this._services=e,this._strict=t,this._parent=s,this._enableTracing=i,this._isDisposed=!1,this._servicesToMaybeDispose=new Set,this._children=new Set,this._activeInstantiations=new Set,this._services.set(r.IInstantiationService,this),this._globalGraph=i?s?._globalGraph??new n.Graph((e=>e)):void 0}dispose(){if(!this._isDisposed){this._isDisposed=!0,s.dispose(this._children),this._children.clear();for(const e of this._servicesToMaybeDispose)s.isDisposable(e)&&e.dispose();this._servicesToMaybeDispose.clear()}}_throwIfDisposed(){if(this._isDisposed)throw new Error("InstantiationService has been disposed")}createChild(e,t){this._throwIfDisposed();const s=this,i=new class extends h{dispose(){s._children.delete(i),super.dispose()}}(e,this._strict,this,this._enableTracing);return this._children.add(i),t?.add(i),i}invokeFunction(e,...s){this._throwIfDisposed();const i=l.traceInvocation(this._enableTracing,e);let n=!1;try{return e({get:e=>{if(n)throw t.illegalState("service accessor is only valid during the invocation of its target method");const s=this._getOrCreateServiceInstance(e,i);if(!s)throw new Error(`[invokeFunction] unknown service '${e}'`);return s}},...s)}finally{n=!0,i.stop()}}createInstance(e,...t){let s,n;return this._throwIfDisposed(),e instanceof i.SyncDescriptor?(s=l.traceCreation(this._enableTracing,e.ctor),n=this._createInstance(e.ctor,e.staticArguments.concat(t),s)):(s=l.traceCreation(this._enableTracing,e),n=this._createInstance(e,t,s)),s.stop(),n}_createInstance(e,t=[],s){const i=r._util.getServiceDependencies(e).sort(((e,t)=>e.index-t.index)),n=[];for(const t of i){const i=this._getOrCreateServiceInstance(t.id,s);i||this._throwIfStrict(`[createInstance] ${e.name} depends on UNKNOWN service ${t.id}.`,!1),n.push(i)}const c=i.length>0?i[0].index:t.length;if(t.length!==c){console.trace(`[createInstance] First service dependency of ${e.name} at position ${c+1} conflicts with ${t.length} static arguments`);const s=c-t.length;t=s>0?t.concat(new Array(s)):t.slice(0,c)}return Reflect.construct(e,t.concat(n))}_setCreatedServiceInstance(e,t){if(this._services.get(e)instanceof i.SyncDescriptor)this._services.set(e,t);else{if(!this._parent)throw new Error("illegalState - setting UNKNOWN service instance");this._parent._setCreatedServiceInstance(e,t)}}_getServiceInstanceOrDescriptor(e){const t=this._services.get(e);return!t&&this._parent?this._parent._getServiceInstanceOrDescriptor(e):t}_getOrCreateServiceInstance(e,t){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(e));const s=this._getServiceInstanceOrDescriptor(e);return s instanceof i.SyncDescriptor?this._safeCreateAndCacheServiceInstance(e,s,t.branch(e,!0)):(t.branch(e,!1),s)}_safeCreateAndCacheServiceInstance(e,t,s){if(this._activeInstantiations.has(e))throw new Error(`illegal state - RECURSIVELY instantiating service '${e}'`);this._activeInstantiations.add(e);try{return this._createAndCacheServiceInstance(e,t,s)}finally{this._activeInstantiations.delete(e)}}_createAndCacheServiceInstance(e,t,s){const c=new n.Graph((e=>e.id.toString()));let a=0;const h=[{id:e,desc:t,_trace:s}],l=new Set;for(;h.length;){const t=h.pop();if(!l.has(String(t.id))){if(l.add(String(t.id)),c.lookupOrInsertNode(t),a++>1e3)throw new o(c);for(const s of r._util.getServiceDependencies(t.desc.ctor)){const n=this._getServiceInstanceOrDescriptor(s.id);if(n||this._throwIfStrict(`[createInstance] ${e} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(s.id)),n instanceof i.SyncDescriptor){const e={id:s.id,desc:n,_trace:t._trace.branch(s.id,!0)};c.insertEdge(t,e),h.push(e)}}}}for(;;){const e=c.roots();if(0===e.length){if(!c.isEmpty())throw new o(c);break}for(const{data:t}of e){if(this._getServiceInstanceOrDescriptor(t.id)instanceof i.SyncDescriptor){const e=this._createServiceInstanceWithOwner(t.id,t.desc.ctor,t.desc.staticArguments,t.desc.supportsDelayedInstantiation,t._trace);this._setCreatedServiceInstance(t.id,e)}c.removeNode(t)}}return this._getServiceInstanceOrDescriptor(e)}_createServiceInstanceWithOwner(e,t,s=[],n,r){if(this._services.get(e)instanceof i.SyncDescriptor)return this._createServiceInstance(e,t,s,n,r,this._servicesToMaybeDispose);if(this._parent)return this._parent._createServiceInstanceWithOwner(e,t,s,n,r);throw new Error(`illegalState - creating UNKNOWN service instance ${t.name}`)}_createServiceInstance(t,i,n=[],r,c,o){if(r){const r=new h(void 0,this._strict,this,this._enableTracing);r._globalGraphImplicitDependency=String(t);const l=new Map,d=new e.GlobalIdleValue((()=>{const e=r._createInstance(i,n,c);for(const[t,s]of l){const i=e[t];if("function"==typeof i)for(const t of s)t.disposable=i.apply(e,t.listener)}return l.clear(),o.add(e),e}));return new Proxy(Object.create(null),{get(e,t){if(!d.isInitialized&&"string"==typeof t&&(t.startsWith("onDid")||t.startsWith("onWill"))){let e=l.get(t);e||(e=new a.LinkedList,l.set(t,e));return(i,n,r)=>{if(d.isInitialized)return d.value[t](i,n,r);{const t={listener:[i,n,r],disposable:void 0},c=e.push(t);return s.toDisposable((()=>{c(),t.disposable?.dispose()}))}}}if(t in e)return e[t];const i=d.value;let n=i[t];return"function"!=typeof n||(n=n.bind(i),e[t]=n),n},set:(e,t,s)=>(d.value[t]=s,!0),getPrototypeOf:e=>i.prototype})}{const e=this._createInstance(i,n,c);return o.add(e),e}}_throwIfStrict(e,t){if(t&&console.warn(e),this._strict)throw new Error(e)}}class l{static{this.all=new Set}static{this._None=new class extends l{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(e,t){return e?new l(2,t.name||(new Error).stack.split("\n").slice(3,4).join("\n")):l._None}static traceCreation(e,t){return e?new l(1,t.name):l._None}static{this._totals=0}constructor(e,t){this.type=e,this.name=t,this._start=Date.now(),this._dep=[]}branch(e,t){const s=new l(3,e.toString());return this._dep.push([e,t,s]),s}stop(){const e=Date.now()-this._start;l._totals+=e;let t=!1;const s=[`${1===this.type?"CREATE":"CALL"} ${this.name}`,`${function e(s,i){const n=[],r=new Array(s+1).join("\t");for(const[c,a,o]of i._dep)if(a&&o){t=!0,n.push(`${r}CREATES -> ${c}`);const i=e(s+1,o);i&&n.push(i)}else n.push(`${r}uses -> ${c}`);return n.join("\n")}(1,this)}`,`DONE, took ${e.toFixed(2)}ms (grand total ${l._totals.toFixed(2)}ms)`];(e>2||t)&&l.all.add(s.join("\n"))}}exports.InstantiationService=h,exports.Trace=l;
//# sourceMappingURL=instantiationService.js.map
