"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var e=require("../../../base/common/async.js"),i=require("../../../base/common/errors.js"),t=require("../../../base/common/event.js"),r=require("../../../base/common/ime.js"),s=require("../../../base/common/lifecycle.js"),n=require("../../../nls.js"),o=require("./keybindingResolver.js");const d=/^(cursor|delete|undo|redo|tab|editor\.action\.clipboard)/;class h extends s.Disposable{get onDidUpdateKeybindings(){return this._onDidUpdateKeybindings?this._onDidUpdateKeybindings.event:t.Event.None}get inChordMode(){return this._currentChords.length>0}constructor(i,r,s,n,o){super(),this._contextKeyService=i,this._commandService=r,this._telemetryService=s,this._notificationService=n,this._logService=o,this._onDidUpdateKeybindings=this._register(new t.Emitter),this._currentChords=[],this._currentChordChecker=new e.IntervalTimer,this._currentChordStatusMessage=null,this._ignoreSingleModifiers=c.EMPTY,this._currentSingleModifier=null,this._currentSingleModifierClearTimeout=new e.TimeoutTimer,this._currentlyDispatchingCommandId=null,this._logging=!1}dispose(){super.dispose()}_log(e){this._logging&&this._logService.info(`[KeybindingService]: ${e}`)}getKeybindings(){return this._getResolver().getKeybindings()}lookupKeybinding(e,i){const t=this._getResolver().lookupPrimaryKeybinding(e,i||this._contextKeyService);if(t)return t.resolvedKeybinding}dispatchEvent(e,i){return this._dispatch(e,i)}softDispatch(e,i){this._log("/ Soft dispatching keyboard event");const t=this.resolveKeyboardEvent(e);if(t.hasMultipleChords())return console.warn("keyboard event should not be mapped to multiple chords"),o.NoMatchingKb;const[r]=t.getDispatchChords();if(null===r)return this._log("\\ Keyboard event cannot be dispatched"),o.NoMatchingKb;const s=this._contextKeyService.getContext(i),n=this._currentChords.map((({keypress:e})=>e));return this._getResolver().resolve(s,n,r)}_scheduleLeaveChordMode(){const e=Date.now();this._currentChordChecker.cancelAndSet((()=>{this._documentHasFocus()?Date.now()-e>5e3&&this._leaveChordMode():this._leaveChordMode()}),500)}_expectAnotherChord(e,t){switch(this._currentChords.push({keypress:e,label:t}),this._currentChords.length){case 0:throw i.illegalState("impossible");case 1:this._currentChordStatusMessage=this._notificationService.status(n.localize("first.chord","({0}) was pressed. Waiting for second key of chord...",t));break;default:{const e=this._currentChords.map((({label:e})=>e)).join(", ");this._currentChordStatusMessage=this._notificationService.status(n.localize("next.chord","({0}) was pressed. Waiting for next key of chord...",e))}}this._scheduleLeaveChordMode(),r.IME.enabled&&r.IME.disable()}_leaveChordMode(){this._currentChordStatusMessage&&(this._currentChordStatusMessage.dispose(),this._currentChordStatusMessage=null),this._currentChordChecker.cancel(),this._currentChords=[],r.IME.enable()}_dispatch(e,i){return this._doDispatch(this.resolveKeyboardEvent(e),i,!1)}_singleModifierDispatch(e,i){const t=this.resolveKeyboardEvent(e),[r]=t.getSingleModifierDispatchChords();if(r)return this._ignoreSingleModifiers.has(r)?(this._log(`+ Ignoring single modifier ${r} due to it being pressed together with other keys.`),this._ignoreSingleModifiers=c.EMPTY,this._currentSingleModifierClearTimeout.cancel(),this._currentSingleModifier=null,!1):(this._ignoreSingleModifiers=c.EMPTY,null===this._currentSingleModifier?(this._log(`+ Storing single modifier for possible chord ${r}.`),this._currentSingleModifier=r,this._currentSingleModifierClearTimeout.cancelAndSet((()=>{this._log("+ Clearing single modifier due to 300ms elapsed."),this._currentSingleModifier=null}),300),!1):r===this._currentSingleModifier?(this._log(`/ Dispatching single modifier chord ${r} ${r}`),this._currentSingleModifierClearTimeout.cancel(),this._currentSingleModifier=null,this._doDispatch(t,i,!0)):(this._log(`+ Clearing single modifier due to modifier mismatch: ${this._currentSingleModifier} ${r}`),this._currentSingleModifierClearTimeout.cancel(),this._currentSingleModifier=null,!1));const[s]=t.getChords();return this._ignoreSingleModifiers=new c(s),null!==this._currentSingleModifier&&this._log("+ Clearing single modifier due to other key up."),this._currentSingleModifierClearTimeout.cancel(),this._currentSingleModifier=null,!1}_doDispatch(e,i,t=!1){let r=!1;if(e.hasMultipleChords())return console.warn("Unexpected keyboard event mapped to multiple chords"),!1;let s=null,o=null;if(t){const[i]=e.getSingleModifierDispatchChords();s=i,o=i?[i]:[]}else[s]=e.getDispatchChords(),o=this._currentChords.map((({keypress:e})=>e));if(null===s)return this._log("\\ Keyboard event cannot be dispatched in keydown phase."),r;const h=this._contextKeyService.getContext(i),c=e.getLabel(),l=this._getResolver().resolve(h,o,s);switch(l.kind){case 0:if(this._logService.trace("KeybindingService#dispatch",c,"[ No matching keybinding ]"),this.inChordMode){const e=this._currentChords.map((({label:e})=>e)).join(", ");this._log(`+ Leaving multi-chord mode: Nothing bound to "${e}, ${c}".`),this._notificationService.status(n.localize("missing.chord","The key combination ({0}, {1}) is not a command.",e,c),{hideAfter:1e4}),this._leaveChordMode(),r=!0}return r;case 1:return this._logService.trace("KeybindingService#dispatch",c,"[ Several keybindings match - more chords needed ]"),r=!0,this._expectAnotherChord(s,c),this._log(1===this._currentChords.length?"+ Entering multi-chord mode...":"+ Continuing multi-chord mode..."),r;case 2:if(this._logService.trace("KeybindingService#dispatch",c,`[ Will dispatch command ${l.commandId} ]`),null===l.commandId||""===l.commandId){if(this.inChordMode){const e=this._currentChords.map((({label:e})=>e)).join(", ");this._log(`+ Leaving chord mode: Nothing bound to "${e}, ${c}".`),this._notificationService.status(n.localize("missing.chord","The key combination ({0}, {1}) is not a command.",e,c),{hideAfter:1e4}),this._leaveChordMode(),r=!0}}else{this.inChordMode&&this._leaveChordMode(),l.isBubble||(r=!0),this._log(`+ Invoking command ${l.commandId}.`),this._currentlyDispatchingCommandId=l.commandId;try{void 0===l.commandArgs?this._commandService.executeCommand(l.commandId).then(void 0,(e=>this._notificationService.warn(e))):this._commandService.executeCommand(l.commandId,l.commandArgs).then(void 0,(e=>this._notificationService.warn(e)))}finally{this._currentlyDispatchingCommandId=null}d.test(l.commandId)||this._telemetryService.publicLog2("workbenchActionExecuted",{id:l.commandId,from:"keybinding",detail:e.getUserSettingsLabel()??void 0})}return r}}mightProducePrintableCharacter(e){return!e.ctrlKey&&!e.metaKey&&(e.keyCode>=31&&e.keyCode<=56||e.keyCode>=21&&e.keyCode<=30)}}class c{static{this.EMPTY=new c(null)}constructor(e){this._ctrlKey=!!e&&e.ctrlKey,this._shiftKey=!!e&&e.shiftKey,this._altKey=!!e&&e.altKey,this._metaKey=!!e&&e.metaKey}has(e){switch(e){case"ctrl":return this._ctrlKey;case"shift":return this._shiftKey;case"alt":return this._altKey;case"meta":return this._metaKey}}}exports.AbstractKeybindingService=h;
//# sourceMappingURL=abstractKeybindingService.js.map
