"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var e,t,s=require("../../../base/common/errorMessage.js"),i=require("../../../base/common/errors.js"),o=require("../../../base/common/filters.js"),r=require("../../../base/common/functional.js"),a=require("../../../base/common/lifecycle.js"),n=require("../../../base/common/map.js"),c=require("../../../base/common/tfIdf.js"),m=require("../../../nls.js"),d=require("../../commands/common/commands.js"),l=require("../../configuration/common/configuration.js"),u=require("../../dialogs/common/dialogs.js"),h=require("../../instantiation/common/instantiation.js"),f=require("../../keybinding/common/keybinding.js"),g=require("../../log/common/log.js"),p=require("./pickerQuickAccess.js"),C=require("../../storage/common/storage.js"),S=require("../../telemetry/common/telemetry.js"),I=self&&self.__decorate||function(e,t,s,i){var o,r=arguments.length,a=r<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,s):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)a=Reflect.decorate(e,t,s,i);else for(var n=e.length-1;n>=0;n--)(o=e[n])&&(a=(r<3?o(a):r>3?o(t,s,a):o(t,s))||a);return r>3&&a&&Object.defineProperty(t,s,a),a},y=self&&self.__param||function(e,t){return function(s,i){t(s,i,e)}};exports.AbstractCommandsQuickAccessProvider=class extends p.PickerQuickAccessProvider{static{e=this}static{this.PREFIX=">"}static{this.TFIDF_THRESHOLD=.5}static{this.TFIDF_MAX_RESULTS=5}static{this.WORD_FILTER=o.or(o.matchesPrefix,o.matchesWords,o.matchesContiguousSubString)}constructor(t,s,i,o,r,a){super(e.PREFIX,t),this.instantiationService=s,this.keybindingService=i,this.commandService=o,this.telemetryService=r,this.dialogService=a,this.commandsHistory=this._register(this.instantiationService.createInstance(exports.CommandsHistory)),this.options=t}async _getPicks(t,s,i,o){const a=await this.getCommandPicks(i);if(i.isCancellationRequested)return[];const n=r.createSingleCallFunction((()=>{const s=new c.TfIdfCalculator;s.updateDocuments(a.map((e=>({key:e.commandId,textChunks:[this.getTfIdfChunk(e)]}))));const o=s.calculateScores(t,i);return c.normalizeTfIdfScores(o).filter((t=>t.score>e.TFIDF_THRESHOLD)).slice(0,e.TFIDF_MAX_RESULTS)})),d=[];for(const s of a){const o=e.WORD_FILTER(t,s.label)??void 0,r=s.commandAlias?e.WORD_FILTER(t,s.commandAlias)??void 0:void 0;if(o||r)s.highlights={label:o,detail:this.options.showAlias?r:void 0},d.push(s);else if(t===s.commandId)d.push(s);else if(t.length>=3){const e=n();if(i.isCancellationRequested)return[];const t=e.find((e=>e.key===s.commandId));t&&(s.tfIdfScore=t.score,d.push(s))}}const l=new Map;for(const e of d){const t=l.get(e.label);t?(e.description=e.commandId,t.description=t.commandId):l.set(e.label,e)}d.sort(((e,t)=>{if(e.tfIdfScore&&t.tfIdfScore)return e.tfIdfScore===t.tfIdfScore?e.label.localeCompare(t.label):t.tfIdfScore-e.tfIdfScore;if(e.tfIdfScore)return 1;if(t.tfIdfScore)return-1;const s=this.commandsHistory.peek(e.commandId),i=this.commandsHistory.peek(t.commandId);if(s&&i)return s>i?-1:1;if(s)return-1;if(i)return 1;if(this.options.suggestedCommandIds){const s=this.options.suggestedCommandIds.has(e.commandId),i=this.options.suggestedCommandIds.has(t.commandId);if(s&&i)return 0;if(s)return-1;if(i)return 1}return e.label.localeCompare(t.label)}));const u=[];let h=!1,f=!0,g=!!this.options.suggestedCommandIds;for(let e=0;e<d.length;e++){const t=d[e];0===e&&this.commandsHistory.peek(t.commandId)&&(u.push({type:"separator",label:m.localize("recentlyUsed","recently used")}),h=!0),f&&void 0!==t.tfIdfScore&&(u.push({type:"separator",label:m.localize("suggested","similar commands")}),f=!1),g&&void 0===t.tfIdfScore&&!this.commandsHistory.peek(t.commandId)&&this.options.suggestedCommandIds?.has(t.commandId)&&(u.push({type:"separator",label:m.localize("commonlyUsed","commonly used")}),h=!0,g=!1),!h||void 0!==t.tfIdfScore||this.commandsHistory.peek(t.commandId)||this.options.suggestedCommandIds?.has(t.commandId)||(u.push({type:"separator",label:m.localize("morecCommands","other commands")}),h=!1),u.push(this.toCommandPick(t,o))}return this.hasAdditionalCommandPicks(t,i)?{picks:u,additionalPicks:(async()=>{const e=await this.getAdditionalCommandPicks(a,d,t,i);if(i.isCancellationRequested)return[];const s=e.map((e=>this.toCommandPick(e,o)));return f&&"separator"!==s[0]?.type&&s.unshift({type:"separator",label:m.localize("suggested","similar commands")}),s})()}:u}toCommandPick(e,t){if("separator"===e.type)return e;const o=this.keybindingService.lookupKeybinding(e.commandId),r=o?m.localize("commandPickAriaLabelWithKeybinding","{0}, {1}",e.label,o.getAriaLabel()):e.label;return{...e,ariaLabel:r,detail:this.options.showAlias&&e.commandAlias!==e.label?e.commandAlias:void 0,keybinding:o,accept:async()=>{this.commandsHistory.push(e.commandId),this.telemetryService.publicLog2("workbenchActionExecuted",{id:e.commandId,from:t?.from??"quick open"});try{e.args?.length?await this.commandService.executeCommand(e.commandId,...e.args):await this.commandService.executeCommand(e.commandId)}catch(t){i.isCancellationError(t)||this.dialogService.error(m.localize("canNotRun","Command '{0}' resulted in an error",e.label),s.toErrorMessage(t))}}}}getTfIdfChunk({label:e,commandAlias:t,commandDescription:s}){let i=e;return t&&t!==e&&(i+=` - ${t}`),s&&s.value!==e&&(i+=` - ${s.value===s.original?s.value:`${s.value} (${s.original})`}`),i}},exports.AbstractCommandsQuickAccessProvider=e=I([y(1,h.IInstantiationService),y(2,f.IKeybindingService),y(3,d.ICommandService),y(4,S.ITelemetryService),y(5,u.IDialogService)],exports.AbstractCommandsQuickAccessProvider),exports.CommandsHistory=class extends a.Disposable{static{t=this}static{this.DEFAULT_COMMANDS_HISTORY_LENGTH=50}static{this.PREF_KEY_CACHE="commandPalette.mru.cache"}static{this.PREF_KEY_COUNTER="commandPalette.mru.counter"}static{this.counter=1}static{this.hasChanges=!1}constructor(e,t,s){super(),this.storageService=e,this.configurationService=t,this.logService=s,this.configuredCommandsHistoryLength=0,this.updateConfiguration(),this.load(),this.registerListeners()}registerListeners(){this._register(this.configurationService.onDidChangeConfiguration((e=>this.updateConfiguration(e)))),this._register(this.storageService.onWillSaveState((e=>{e.reason===C.WillSaveStateReason.SHUTDOWN&&this.saveState()})))}updateConfiguration(e){e&&!e.affectsConfiguration("workbench.commandPalette.history")||(this.configuredCommandsHistoryLength=t.getConfiguredCommandHistoryLength(this.configurationService),t.cache&&t.cache.limit!==this.configuredCommandsHistoryLength&&(t.cache.limit=this.configuredCommandsHistoryLength,t.hasChanges=!0))}load(){const e=this.storageService.get(t.PREF_KEY_CACHE,0);let s;if(e)try{s=JSON.parse(e)}catch(e){this.logService.error(`[CommandsHistory] invalid data: ${e}`)}const i=t.cache=new n.LRUCache(this.configuredCommandsHistoryLength,1);if(s){let e;e=s.usesLRU?s.entries:s.entries.sort(((e,t)=>e.value-t.value)),e.forEach((e=>i.set(e.key,e.value)))}t.counter=this.storageService.getNumber(t.PREF_KEY_COUNTER,0,t.counter)}push(e){t.cache&&(t.cache.set(e,t.counter++),t.hasChanges=!0)}peek(e){return t.cache?.peek(e)}saveState(){if(!t.cache)return;if(!t.hasChanges)return;const e={usesLRU:!0,entries:[]};t.cache.forEach(((t,s)=>e.entries.push({key:s,value:t}))),this.storageService.store(t.PREF_KEY_CACHE,JSON.stringify(e),0,0),this.storageService.store(t.PREF_KEY_COUNTER,t.counter,0,0),t.hasChanges=!1}static getConfiguredCommandHistoryLength(e){const s=e.getValue(),i=s.workbench?.commandPalette?.history;return"number"==typeof i?i:t.DEFAULT_COMMANDS_HISTORY_LENGTH}},exports.CommandsHistory=t=I([y(0,C.IStorageService),y(1,l.IConfigurationService),y(2,g.ILogService)],exports.CommandsHistory);
//# sourceMappingURL=commandsQuickAccess.js.map
