"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var t=require("../../../base/browser/dom.js"),e=require("../../../base/browser/keyboardEvent.js"),i=require("../../../base/browser/ui/toggle/toggle.js"),s=require("../../../base/common/arrays.js"),n=require("../../../base/common/async.js"),o=require("../../../base/common/codicons.js"),h=require("../../../base/common/event.js"),a=require("../../../base/common/lifecycle.js"),r=require("../../../base/common/platform.js"),u=require("../../../base/common/severity.js"),l=require("../../../base/common/themables.js");require("./media/quickInput.css.js");var c=require("../../../nls.js"),d=require("../common/quickInput.js"),p=require("./quickInputUtils.js"),m=require("../../configuration/common/configuration.js"),g=require("../../hover/browser/hover.js"),v=require("../../contextkey/common/contextkey.js"),_=self&&self.__decorate||function(t,e,i,s){var n,o=arguments.length,h=o<3?e:null===s?s=Object.getOwnPropertyDescriptor(e,i):s;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)h=Reflect.decorate(t,e,i,s);else for(var a=t.length-1;a>=0;a--)(n=t[a])&&(h=(o<3?n(h):o>3?n(e,i,h):n(e,i))||h);return o>3&&h&&Object.defineProperty(e,i,h),h},b=self&&self.__param||function(t,e){return function(i,s){e(i,s,t)}};const I="inQuickInput",y=new v.RawContextKey(I,!1,c.localize("inQuickInput","Whether keyboard focus is inside the quick input control")),f=v.ContextKeyExpr.has(I),B="quickInputType",D=new v.RawContextKey(B,void 0,c.localize("quickInputType","The type of the currently visible quick input")),k="cursorAtEndOfQuickInputBox",S=new v.RawContextKey(k,!1,c.localize("cursorAtEndOfQuickInputBox","Whether the cursor in the quick input is at the end of the input box")),E=v.ContextKeyExpr.has(k),x={iconClass:l.ThemeIcon.asClassName(o.Codicon.quickInputBack),tooltip:c.localize("quickInput.back","Back"),handle:-1};class C extends a.Disposable{static{this.noPromptMessage=c.localize("inputModeEntry","Press 'Enter' to confirm your input or 'Escape' to cancel")}constructor(t){super(),this.ui=t,this._widgetUpdated=!1,this.visible=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!1,this._leftButtons=[],this._rightButtons=[],this._inlineButtons=[],this.buttonsUpdated=!1,this._toggles=[],this.togglesUpdated=!1,this.noValidationMessage=C.noPromptMessage,this._severity=u.default.Ignore,this.onDidTriggerButtonEmitter=this._register(new h.Emitter),this.onDidHideEmitter=this._register(new h.Emitter),this.onWillHideEmitter=this._register(new h.Emitter),this.onDisposeEmitter=this._register(new h.Emitter),this.visibleDisposables=this._register(new a.DisposableStore),this.onDidHide=this.onDidHideEmitter.event}get title(){return this._title}set title(t){this._title=t,this.update()}get description(){return this._description}set description(t){this._description=t,this.update()}get step(){return this._steps}set step(t){this._steps=t,this.update()}get totalSteps(){return this._totalSteps}set totalSteps(t){this._totalSteps=t,this.update()}get enabled(){return this._enabled}set enabled(t){this._enabled=t,this.update()}get contextKey(){return this._contextKey}set contextKey(t){this._contextKey=t,this.update()}get busy(){return this._busy}set busy(t){this._busy=t,this.update()}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(t){const e=this._ignoreFocusOut!==t&&!r.isIOS;this._ignoreFocusOut=t&&!r.isIOS,e&&this.update()}get titleButtons(){return this._leftButtons.length?[...this._leftButtons,this._rightButtons]:this._rightButtons}get buttons(){return[...this._leftButtons,...this._rightButtons,...this._inlineButtons]}set buttons(t){this._leftButtons=t.filter((t=>t===x)),this._rightButtons=t.filter((t=>t!==x&&t.location!==d.QuickInputButtonLocation.Inline)),this._inlineButtons=t.filter((t=>t.location===d.QuickInputButtonLocation.Inline)),this.buttonsUpdated=!0,this.update()}get toggles(){return this._toggles}set toggles(t){this._toggles=t??[],this.togglesUpdated=!0,this.update()}get validationMessage(){return this._validationMessage}set validationMessage(t){this._validationMessage=t,this.update()}get severity(){return this._severity}set severity(t){this._severity=t,this.update()}show(){this.visible||(this.visibleDisposables.add(this.ui.onDidTriggerButton((t=>{-1!==this.buttons.indexOf(t)&&this.onDidTriggerButtonEmitter.fire(t)}))),this.ui.show(this),this.visible=!0,this._lastValidationMessage=void 0,this._lastSeverity=void 0,this.buttons.length&&(this.buttonsUpdated=!0),this.toggles.length&&(this.togglesUpdated=!0),this.update())}hide(){this.visible&&this.ui.hide()}didHide(t=d.QuickInputHideReason.Other){this.visible=!1,this.visibleDisposables.clear(),this.onDidHideEmitter.fire({reason:t})}willHide(t=d.QuickInputHideReason.Other){this.onWillHideEmitter.fire({reason:t})}update(){if(!this.visible)return;const e=this.getTitle();e&&this.ui.title.textContent!==e?this.ui.title.textContent=e:e||"&nbsp;"===this.ui.title.innerHTML||(this.ui.title.innerText=" ");const s=this.getDescription();if(this.ui.description1.textContent!==s&&(this.ui.description1.textContent=s),this.ui.description2.textContent!==s&&(this.ui.description2.textContent=s),this._widgetUpdated&&(this._widgetUpdated=!1,this._widget?t.reset(this.ui.widget,this._widget):t.reset(this.ui.widget)),this.busy&&!this.busyDelay&&(this.busyDelay=new n.TimeoutTimer,this.busyDelay.setIfNotSet((()=>{this.visible&&this.ui.progressBar.infinite()}),800)),!this.busy&&this.busyDelay&&(this.ui.progressBar.stop(),this.busyDelay.cancel(),this.busyDelay=void 0),this.buttonsUpdated){this.buttonsUpdated=!1,this.ui.leftActionBar.clear();const t=this._leftButtons.map(((t,e)=>p.quickInputButtonToAction(t,`id-${e}`,(async()=>this.onDidTriggerButtonEmitter.fire(t)))));this.ui.leftActionBar.push(t,{icon:!0,label:!1}),this.ui.rightActionBar.clear();const e=this._rightButtons.map(((t,e)=>p.quickInputButtonToAction(t,`id-${e}`,(async()=>this.onDidTriggerButtonEmitter.fire(t)))));this.ui.rightActionBar.push(e,{icon:!0,label:!1}),this.ui.inlineActionBar.clear();const i=this._inlineButtons.map(((t,e)=>p.quickInputButtonToAction(t,`id-${e}`,(async()=>this.onDidTriggerButtonEmitter.fire(t)))));this.ui.inlineActionBar.push(i,{icon:!0,label:!1})}if(this.togglesUpdated){this.togglesUpdated=!1;const t=this.toggles?.filter((t=>t instanceof i.Toggle))??[];this.ui.inputBox.toggles=t}this.ui.ignoreFocusOut=this.ignoreFocusOut,this.ui.setEnabled(this.enabled),this.ui.setContextKey(this.contextKey);const o=this.validationMessage||this.noValidationMessage;this._lastValidationMessage!==o&&(this._lastValidationMessage=o,t.reset(this.ui.message),p.renderQuickInputDescription(o,this.ui.message,{callback:t=>{this.ui.linkOpenerDelegate(t)},disposables:this.visibleDisposables})),this._lastSeverity!==this.severity&&(this._lastSeverity=this.severity,this.showMessageDecoration(this.severity))}getTitle(){return this.title&&this.step?`${this.title} (${this.getSteps()})`:this.title?this.title:this.step?this.getSteps():""}getDescription(){return this.description||""}getSteps(){return this.step&&this.totalSteps?c.localize("quickInput.steps","{0}/{1}",this.step,this.totalSteps):this.step?String(this.step):""}showMessageDecoration(t){if(this.ui.inputBox.showDecoration(t),t!==u.default.Ignore){const e=this.ui.inputBox.stylesForType(t);this.ui.message.style.color=e.foreground?`${e.foreground}`:"",this.ui.message.style.backgroundColor=e.background?`${e.background}`:"",this.ui.message.style.border=e.border?`1px solid ${e.border}`:"",this.ui.message.style.marginBottom="-2px"}else this.ui.message.style.color="",this.ui.message.style.backgroundColor="",this.ui.message.style.border="",this.ui.message.style.marginBottom=""}dispose(){this.hide(),this.onDisposeEmitter.fire(),super.dispose()}}class A extends C{constructor(){super(...arguments),this._value="",this.onDidChangeValueEmitter=this._register(new h.Emitter),this.onWillAcceptEmitter=this._register(new h.Emitter),this.onDidAcceptEmitter=this._register(new h.Emitter),this.onDidCustomEmitter=this._register(new h.Emitter),this._items=[],this.itemsUpdated=!1,this._canSelectMany=!1,this._canAcceptInBackground=!1,this._matchOnDescription=!1,this._matchOnDetail=!1,this._matchOnLabel=!0,this._matchOnLabelMode="fuzzy",this._sortByLabel=!0,this._keepScrollPosition=!1,this._itemActivation=d.ItemActivation.FIRST,this._activeItems=[],this.activeItemsUpdated=!1,this.activeItemsToConfirm=[],this.onDidChangeActiveEmitter=this._register(new h.Emitter),this._selectedItems=[],this.selectedItemsUpdated=!1,this.selectedItemsToConfirm=[],this.onDidChangeSelectionEmitter=this._register(new h.Emitter),this.onDidTriggerItemButtonEmitter=this._register(new h.Emitter),this.onDidTriggerSeparatorButtonEmitter=this._register(new h.Emitter),this.valueSelectionUpdated=!0,this._ok="default",this._customButton=!1,this._focusEventBufferer=new h.EventBufferer,this.type="quickPick",this.filterValue=t=>t,this.onDidChangeValue=this.onDidChangeValueEmitter.event,this.onWillAccept=this.onWillAcceptEmitter.event,this.onDidAccept=this.onDidAcceptEmitter.event,this.onDidChangeActive=this.onDidChangeActiveEmitter.event,this.onDidChangeSelection=this.onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this.onDidTriggerItemButtonEmitter.event,this.onDidTriggerSeparatorButton=this.onDidTriggerSeparatorButtonEmitter.event}static{this.DEFAULT_ARIA_LABEL=c.localize("quickInputBox.ariaLabel","Type to narrow down results.")}get quickNavigate(){return this._quickNavigate}set quickNavigate(t){this._quickNavigate=t,this.update()}get value(){return this._value}set value(t){this.doSetValue(t)}doSetValue(t,e){if(this._value!==t){if(this._value=t,e||this.update(),this.visible){this.ui.list.filter(this.filterValue(this._value))&&this.trySelectFirst()}this.onDidChangeValueEmitter.fire(this._value)}}set ariaLabel(t){this._ariaLabel=t,this.update()}get ariaLabel(){return this._ariaLabel}get placeholder(){return this._placeholder}set placeholder(t){this._placeholder=t,this.update()}get items(){return this._items}get scrollTop(){return this.ui.list.scrollTop}set scrollTop(t){this.ui.list.scrollTop=t}set items(t){this._items=t,this.itemsUpdated=!0,this.update()}get canSelectMany(){return this._canSelectMany}set canSelectMany(t){this._canSelectMany=t,this.update()}get canAcceptInBackground(){return this._canAcceptInBackground}set canAcceptInBackground(t){this._canAcceptInBackground=t}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(t){this._matchOnDescription=t,this.update()}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(t){this._matchOnDetail=t,this.update()}get matchOnLabel(){return this._matchOnLabel}set matchOnLabel(t){this._matchOnLabel=t,this.update()}get matchOnLabelMode(){return this._matchOnLabelMode}set matchOnLabelMode(t){this._matchOnLabelMode=t,this.update()}get sortByLabel(){return this._sortByLabel}set sortByLabel(t){this._sortByLabel=t,this.update()}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(t){this._keepScrollPosition=t}get itemActivation(){return this._itemActivation}set itemActivation(t){this._itemActivation=t}get activeItems(){return this._activeItems}set activeItems(t){this._activeItems=t,this.activeItemsUpdated=!0,this.update()}get selectedItems(){return this._selectedItems}set selectedItems(t){this._selectedItems=t,this.selectedItemsUpdated=!0,this.update()}get keyMods(){return this._quickNavigate?d.NO_KEY_MODS:this.ui.keyMods}get valueSelection(){const t=this.ui.inputBox.getSelection();if(t)return[t.start,t.end]}set valueSelection(t){this._valueSelection=t,this.valueSelectionUpdated=!0,this.update()}get customButton(){return this._customButton}set customButton(t){this._customButton=t,this.update()}get customLabel(){return this._customButtonLabel}set customLabel(t){this._customButtonLabel=t,this.update()}get customHover(){return this._customButtonHover}set customHover(t){this._customButtonHover=t,this.update()}get ok(){return this._ok}set ok(t){this._ok=t,this.update()}get hideInput(){return!!this._hideInput}set hideInput(t){this._hideInput=t,this.update()}trySelectFirst(){this.canSelectMany||this.ui.list.focus(d.QuickPickFocus.First)}show(){this.visible||(this.visibleDisposables.add(this.ui.inputBox.onDidChange((t=>{this.doSetValue(t,!0)}))),this.visibleDisposables.add(this.ui.onDidAccept((()=>{this.canSelectMany?this.ui.list.getCheckedElements().length||(this._selectedItems=[],this.onDidChangeSelectionEmitter.fire(this.selectedItems)):this.activeItems[0]&&(this._selectedItems=[this.activeItems[0]],this.onDidChangeSelectionEmitter.fire(this.selectedItems)),this.handleAccept(!1)}))),this.visibleDisposables.add(this.ui.onDidCustom((()=>{this.onDidCustomEmitter.fire()}))),this.visibleDisposables.add(this._focusEventBufferer.wrapEvent(this.ui.list.onDidChangeFocus,((t,e)=>e))((t=>{this.activeItemsUpdated||this.activeItemsToConfirm!==this._activeItems&&s.equals(t,this._activeItems,((t,e)=>t===e))||(this._activeItems=t,this.onDidChangeActiveEmitter.fire(t))}))),this.visibleDisposables.add(this.ui.list.onDidChangeSelection((({items:e,event:i})=>{this.canSelectMany?e.length&&this.ui.list.setSelectedElements([]):this.selectedItemsToConfirm!==this._selectedItems&&s.equals(e,this._selectedItems,((t,e)=>t===e))||(this._selectedItems=e,this.onDidChangeSelectionEmitter.fire(e),e.length&&this.handleAccept(t.isMouseEvent(i)&&1===i.button))}))),this.visibleDisposables.add(this.ui.list.onChangedCheckedElements((t=>{this.canSelectMany&&this.visible&&(this.selectedItemsToConfirm!==this._selectedItems&&s.equals(t,this._selectedItems,((t,e)=>t===e))||(this._selectedItems=t,this.onDidChangeSelectionEmitter.fire(t)))}))),this.visibleDisposables.add(this.ui.list.onButtonTriggered((t=>this.onDidTriggerItemButtonEmitter.fire(t)))),this.visibleDisposables.add(this.ui.list.onSeparatorButtonTriggered((t=>this.onDidTriggerSeparatorButtonEmitter.fire(t)))),this.visibleDisposables.add(this.registerQuickNavigation()),this.valueSelectionUpdated=!0),super.show()}handleAccept(t){let e=!1;this.onWillAcceptEmitter.fire({veto:()=>e=!0}),e||this.onDidAcceptEmitter.fire({inBackground:t})}registerQuickNavigation(){return t.addDisposableListener(this.ui.container,t.EventType.KEY_UP,(t=>{if(this.canSelectMany||!this._quickNavigate)return;const i=new e.StandardKeyboardEvent(t),s=i.keyCode;this._quickNavigate.keybindings.some((t=>{const e=t.getChords();return!(e.length>1)&&(e[0].shiftKey&&4===s?!(i.ctrlKey||i.altKey||i.metaKey):!(!e[0].altKey||6!==s)||(!(!e[0].ctrlKey||5!==s)||!(!e[0].metaKey||57!==s)))}))&&(this.activeItems[0]&&(this._selectedItems=[this.activeItems[0]],this.onDidChangeSelectionEmitter.fire(this.selectedItems),this.handleAccept(!1)),this._quickNavigate=void 0)}))}update(){if(!this.visible)return;const t=this.keepScrollPosition?this.scrollTop:0,e=!!this.description,i={title:!!this.title||!!this.step||!!this.titleButtons.length,description:e,checkAll:this.canSelectMany&&!this._hideCheckAll,checkBox:this.canSelectMany,inputBox:!this._hideInput,progressBar:!this._hideInput||e,visibleCount:!0,count:this.canSelectMany&&!this._hideCountBadge,ok:"default"===this.ok?this.canSelectMany:this.ok,list:!0,message:!!this.validationMessage,customButton:this.customButton};this.ui.setVisibilities(i),super.update(),this.ui.inputBox.value!==this.value&&(this.ui.inputBox.value=this.value),this.valueSelectionUpdated&&(this.valueSelectionUpdated=!1,this.ui.inputBox.select(this._valueSelection&&{start:this._valueSelection[0],end:this._valueSelection[1]})),this.ui.inputBox.placeholder!==(this.placeholder||"")&&(this.ui.inputBox.placeholder=this.placeholder||"");let s=this.ariaLabel;!s&&i.inputBox&&(s=this.placeholder||A.DEFAULT_ARIA_LABEL,this.title&&(s+=` - ${this.title}`)),this.ui.list.ariaLabel!==s&&(this.ui.list.ariaLabel=s??null),this.ui.list.matchOnDescription=this.matchOnDescription,this.ui.list.matchOnDetail=this.matchOnDetail,this.ui.list.matchOnLabel=this.matchOnLabel,this.ui.list.matchOnLabelMode=this.matchOnLabelMode,this.ui.list.sortByLabel=this.sortByLabel,this.itemsUpdated&&(this.itemsUpdated=!1,this._focusEventBufferer.bufferEvents((()=>{switch(this.ui.list.setElements(this.items),this.ui.list.shouldLoop=!this.canSelectMany,this.ui.list.filter(this.filterValue(this.ui.inputBox.value)),this._itemActivation){case d.ItemActivation.NONE:this._itemActivation=d.ItemActivation.FIRST;break;case d.ItemActivation.SECOND:this.ui.list.focus(d.QuickPickFocus.Second),this._itemActivation=d.ItemActivation.FIRST;break;case d.ItemActivation.LAST:this.ui.list.focus(d.QuickPickFocus.Last),this._itemActivation=d.ItemActivation.FIRST;break;default:this.trySelectFirst()}}))),this.ui.container.classList.contains("show-checkboxes")!==!!this.canSelectMany&&(this.canSelectMany?this.ui.list.clearFocus():this.trySelectFirst()),this.activeItemsUpdated&&(this.activeItemsUpdated=!1,this.activeItemsToConfirm=this._activeItems,this.ui.list.setFocusedElements(this.activeItems),this.activeItemsToConfirm===this._activeItems&&(this.activeItemsToConfirm=null)),this.selectedItemsUpdated&&(this.selectedItemsUpdated=!1,this.selectedItemsToConfirm=this._selectedItems,this.canSelectMany?this.ui.list.setCheckedElements(this.selectedItems):this.ui.list.setSelectedElements(this.selectedItems),this.selectedItemsToConfirm===this._selectedItems&&(this.selectedItemsToConfirm=null)),this.ui.customButton.label=this.customLabel||"",this.ui.customButton.element.title=this.customHover||"",i.inputBox||(this.ui.list.domFocus(),this.canSelectMany&&this.ui.list.focus(d.QuickPickFocus.First)),this.keepScrollPosition&&(this.scrollTop=t)}focus(t){this.ui.list.focus(t),this.canSelectMany&&this.ui.list.domFocus()}accept(t){t&&!this._canAcceptInBackground||this.activeItems[0]&&(this._selectedItems=[this.activeItems[0]],this.onDidChangeSelectionEmitter.fire(this.selectedItems),this.handleAccept(t??!1))}}exports.QuickInputHoverDelegate=class extends g.WorkbenchHoverDelegate{constructor(t,e){super("element",!1,(t=>this.getOverrideOptions(t)),t,e)}getOverrideOptions(e){return{persistence:{hideOnKeyDown:!1},appearance:{showHoverHint:(t.isHTMLElement(e.content)?e.content.textContent??"":"string"==typeof e.content?e.content:e.content.value).includes("\n"),skipFadeInAnimation:!0}}}},exports.QuickInputHoverDelegate=_([b(0,m.IConfigurationService),b(1,g.IHoverService)],exports.QuickInputHoverDelegate),exports.EndOfQuickInputBoxContextKey=S,exports.InQuickInputContextKey=y,exports.InputBox=class extends C{constructor(){super(...arguments),this._value="",this.valueSelectionUpdated=!0,this._password=!1,this.onDidValueChangeEmitter=this._register(new h.Emitter),this.onDidAcceptEmitter=this._register(new h.Emitter),this.type="inputBox",this.onDidChangeValue=this.onDidValueChangeEmitter.event,this.onDidAccept=this.onDidAcceptEmitter.event}get value(){return this._value}set value(t){this._value=t||"",this.update()}get placeholder(){return this._placeholder}set placeholder(t){this._placeholder=t,this.update()}get password(){return this._password}set password(t){this._password=t,this.update()}show(){this.visible||(this.visibleDisposables.add(this.ui.inputBox.onDidChange((t=>{t!==this.value&&(this._value=t,this.onDidValueChangeEmitter.fire(t))}))),this.visibleDisposables.add(this.ui.onDidAccept((()=>this.onDidAcceptEmitter.fire()))),this.valueSelectionUpdated=!0),super.show()}update(){if(!this.visible)return;this.ui.container.classList.remove("hidden-input");const t={title:!!this.title||!!this.step||!!this.titleButtons.length,description:!!this.description||!!this.step,inputBox:!0,message:!0,progressBar:!0};this.ui.setVisibilities(t),super.update(),this.ui.inputBox.value!==this.value&&(this.ui.inputBox.value=this.value),this.valueSelectionUpdated&&(this.valueSelectionUpdated=!1,this.ui.inputBox.select(this._valueSelection&&{start:this._valueSelection[0],end:this._valueSelection[1]})),this.ui.inputBox.placeholder!==(this.placeholder||"")&&(this.ui.inputBox.placeholder=this.placeholder||""),this.ui.inputBox.password!==this.password&&(this.ui.inputBox.password=this.password)}},exports.QuickInputTypeContextKey=D,exports.QuickPick=A,exports.backButton=x,exports.endOfQuickInputBoxContext=E,exports.endOfQuickInputBoxContextKeyValue=k,exports.inQuickInputContext=f,exports.inQuickInputContextKeyValue=I,exports.quickInputTypeContextKeyValue=B;
//# sourceMappingURL=quickInput.js.map
