"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var e=require("../../../base/browser/dom.js"),t=require("../../../base/browser/ui/actionbar/actionbar.js"),i=require("../../../base/browser/ui/button/button.js"),s=require("../../../base/browser/ui/countBadge/countBadge.js"),n=require("../../../base/browser/ui/progressbar/progressbar.js"),o=require("../../../base/common/cancellation.js"),r=require("../../../base/common/event.js"),c=require("../../../base/common/lifecycle.js"),a=require("../../../base/common/severity.js"),l=require("../../../nls.js"),u=require("../common/quickInput.js"),d=require("./quickInputBox.js"),h=require("./quickInput.js"),p=require("../../layout/browser/layoutService.js"),g=require("../../../base/browser/window.js"),y=require("../../instantiation/common/instantiation.js"),b=require("./quickInputTree.js"),k=require("../../contextkey/common/contextkey.js");require("./quickInputActions.js");var m,v=self&&self.__decorate||function(e,t,i,s){var n,o=arguments.length,r=o<3?t:null===s?s=Object.getOwnPropertyDescriptor(t,i):s;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)r=Reflect.decorate(e,t,i,s);else for(var c=e.length-1;c>=0;c--)(n=e[c])&&(r=(o<3?n(r):o>3?n(t,i,r):n(t,i))||r);return o>3&&r&&Object.defineProperty(t,i,r),r},f=self&&self.__param||function(e,t){return function(i,s){t(i,s,e)}};const B=e.$;exports.QuickInputController=class extends c.Disposable{static{m=this}static{this.MAX_WIDTH=600}get currentQuickInput(){return this.controller??void 0}get container(){return this._container}constructor(t,i,s,n){super(),this.options=t,this.layoutService=i,this.instantiationService=s,this.contextKeyService=n,this.enabled=!0,this.onDidAcceptEmitter=this._register(new r.Emitter),this.onDidCustomEmitter=this._register(new r.Emitter),this.onDidTriggerButtonEmitter=this._register(new r.Emitter),this.keyMods={ctrlCmd:!1,alt:!1},this.controller=null,this.onShowEmitter=this._register(new r.Emitter),this.onShow=this.onShowEmitter.event,this.onHideEmitter=this._register(new r.Emitter),this.onHide=this.onHideEmitter.event,this.inQuickInputContext=h.InQuickInputContextKey.bindTo(this.contextKeyService),this.quickInputTypeContext=h.QuickInputTypeContextKey.bindTo(this.contextKeyService),this.endOfQuickInputBoxContext=h.EndOfQuickInputBoxContextKey.bindTo(this.contextKeyService),this.idPrefix=t.idPrefix,this._container=t.container,this.styles=t.styles,this._register(r.Event.runAndSubscribe(e.onDidRegisterWindow,(({window:e,disposables:t})=>this.registerKeyModsListeners(e,t)),{window:g.mainWindow,disposables:this._store})),this._register(e.onWillUnregisterWindow((t=>{this.ui&&e.getWindow(this.ui.container)===t&&(this.reparentUI(this.layoutService.mainContainer),this.layout(this.layoutService.mainContainerDimension,this.layoutService.mainContainerOffset.quickPickTop))})))}registerKeyModsListeners(t,i){const s=e=>{this.keyMods.ctrlCmd=e.ctrlKey||e.metaKey,this.keyMods.alt=e.altKey};for(const n of[e.EventType.KEY_DOWN,e.EventType.KEY_UP,e.EventType.MOUSE_DOWN])i.add(e.addDisposableListener(t,n,s,!0))}getUI(o){if(this.ui)return o&&e.getWindow(this._container)!==e.getWindow(this.layoutService.activeContainer)&&(this.reparentUI(this.layoutService.activeContainer),this.layout(this.layoutService.activeContainerDimension,this.layoutService.activeContainerOffset.quickPickTop)),this.ui;const r=e.append(this._container,B(".quick-input-widget.show-file-icons"));r.tabIndex=-1,r.style.display="none";const c=e.createStyleSheet(r),a=e.append(r,B(".quick-input-titlebar")),p=this._register(new t.ActionBar(a,{hoverDelegate:this.options.hoverDelegate}));p.domNode.classList.add("quick-input-left-action-bar");const g=e.append(a,B(".quick-input-title")),y=this._register(new t.ActionBar(a,{hoverDelegate:this.options.hoverDelegate}));y.domNode.classList.add("quick-input-right-action-bar");const k=e.append(r,B(".quick-input-header")),m=e.append(k,B("input.quick-input-check-all"));m.type="checkbox",m.setAttribute("aria-label",l.localize("quickInput.checkAll","Toggle all checkboxes")),this._register(e.addStandardDisposableListener(m,e.EventType.CHANGE,(e=>{const t=m.checked;j.setAllVisibleChecked(t)}))),this._register(e.addDisposableListener(m,e.EventType.CLICK,(e=>{(e.x||e.y)&&I.setFocus()})));const v=e.append(k,B(".quick-input-description")),f=e.append(k,B(".quick-input-and-message")),C=e.append(f,B(".quick-input-filter")),I=this._register(new d.QuickInputBox(C,this.styles.inputBox,this.styles.toggle));I.setAttribute("aria-describedby",`${this.idPrefix}message`);const x=e.append(C,B(".quick-input-visible-count"));x.setAttribute("aria-live","polite"),x.setAttribute("aria-atomic","true");const w=new s.CountBadge(x,{countFormat:l.localize({key:"quickInput.visibleCount",comment:["This tells the user how many items are shown in a list of items to select from. The items can be anything. Currently not visible, but read by screen readers."]},"{0} Results")},this.styles.countBadge),q=e.append(C,B(".quick-input-count"));q.setAttribute("aria-live","polite");const D=new s.CountBadge(q,{countFormat:l.localize({key:"quickInput.countSelected",comment:["This tells the user how many items are selected in a list of items to select from. The items can be anything."]},"{0} Selected")},this.styles.countBadge),L=this._register(new t.ActionBar(k,{hoverDelegate:this.options.hoverDelegate}));L.domNode.classList.add("quick-input-inline-action-bar");const S=e.append(k,B(".quick-input-action")),E=this._register(new i.Button(S,this.styles.button));E.label=l.localize("ok","OK"),this._register(E.onDidClick((e=>{this.onDidAcceptEmitter.fire()})));const A=e.append(k,B(".quick-input-action")),_=this._register(new i.Button(A,{...this.styles.button,supportIcons:!0}));_.label=l.localize("custom","Custom"),this._register(_.onDidClick((e=>{this.onDidCustomEmitter.fire()})));const O=e.append(f,B(`#${this.idPrefix}message.quick-input-message`)),T=this._register(new n.ProgressBar(r,this.styles.progressBar));T.getContainer().classList.add("quick-input-progress");const F=e.append(r,B(".quick-input-html-widget"));F.tabIndex=-1;const K=e.append(r,B(".quick-input-description")),U=this.idPrefix+"list",j=this._register(this.instantiationService.createInstance(b.QuickInputTree,r,this.options.hoverDelegate,this.options.linkOpenerDelegate,U));I.setAttribute("aria-controls",U),this._register(j.onDidChangeFocus((()=>{I.setAttribute("aria-activedescendant",j.getActiveDescendant()??"")}))),this._register(j.onChangedAllVisibleChecked((e=>{m.checked=e}))),this._register(j.onChangedVisibleCount((e=>{w.setCount(e)}))),this._register(j.onChangedCheckedCount((e=>{D.setCount(e)}))),this._register(j.onLeave((()=>{setTimeout((()=>{this.controller&&(I.setFocus(),this.controller instanceof h.QuickPick&&this.controller.canSelectMany&&j.clearFocus())}),0)})));const P=e.trackFocus(r);return this._register(P),this._register(e.addDisposableListener(r,e.EventType.FOCUS,(t=>{const i=this.getUI();if(e.isAncestor(t.relatedTarget,i.inputContainer)){const e=i.inputBox.isSelectionAtEnd();this.endOfQuickInputBoxContext.get()!==e&&this.endOfQuickInputBoxContext.set(e)}e.isAncestor(t.relatedTarget,i.container)||(this.inQuickInputContext.set(!0),this.previousFocusElement=e.isHTMLElement(t.relatedTarget)?t.relatedTarget:void 0)}),!0)),this._register(P.onDidBlur((()=>{this.getUI().ignoreFocusOut||this.options.ignoreFocusOut()||this.hide(u.QuickInputHideReason.Blur),this.inQuickInputContext.set(!1),this.endOfQuickInputBoxContext.set(!1),this.previousFocusElement=void 0}))),this._register(I.onKeyDown((e=>{const t=this.getUI().inputBox.isSelectionAtEnd();this.endOfQuickInputBoxContext.get()!==t&&this.endOfQuickInputBoxContext.set(t)}))),this._register(e.addDisposableListener(r,e.EventType.FOCUS,(e=>{I.setFocus()}))),this._register(e.addStandardDisposableListener(r,e.EventType.KEY_DOWN,(t=>{if(!e.isAncestor(t.target,F))switch(t.keyCode){case 3:e.EventHelper.stop(t,!0),this.enabled&&this.onDidAcceptEmitter.fire();break;case 9:e.EventHelper.stop(t,!0),this.hide(u.QuickInputHideReason.Gesture);break;case 2:if(!t.altKey&&!t.ctrlKey&&!t.metaKey){const i=[".quick-input-list .monaco-action-bar .always-visible",".quick-input-list-entry:hover .monaco-action-bar",".monaco-list-row.focused .monaco-action-bar"];if(r.classList.contains("show-checkboxes")?i.push("input"):i.push("input[type=text]"),this.getUI().list.displayed&&i.push(".monaco-list"),this.getUI().message&&i.push(".quick-input-message a"),this.getUI().widget){if(e.isAncestor(t.target,this.getUI().widget))break;i.push(".quick-input-html-widget")}const s=r.querySelectorAll(i.join(", "));t.shiftKey&&t.target===s[0]?(e.EventHelper.stop(t,!0),j.clearFocus()):!t.shiftKey&&e.isAncestor(t.target,s[s.length-1])&&(e.EventHelper.stop(t,!0),s[0].focus())}break;case 10:t.ctrlKey&&(e.EventHelper.stop(t,!0),this.getUI().list.toggleHover())}}))),this.ui={container:r,styleSheet:c,leftActionBar:p,titleBar:a,title:g,description1:K,description2:v,widget:F,rightActionBar:y,inlineActionBar:L,checkAll:m,inputContainer:f,filterContainer:C,inputBox:I,visibleCountContainer:x,visibleCount:w,countContainer:q,count:D,okContainer:S,ok:E,message:O,customButtonContainer:A,customButton:_,list:j,progressBar:T,onDidAccept:this.onDidAcceptEmitter.event,onDidCustom:this.onDidCustomEmitter.event,onDidTriggerButton:this.onDidTriggerButtonEmitter.event,ignoreFocusOut:!1,keyMods:this.keyMods,show:e=>this.show(e),hide:()=>this.hide(),setVisibilities:e=>this.setVisibilities(e),setEnabled:e=>this.setEnabled(e),setContextKey:e=>this.options.setContextKey(e),linkOpenerDelegate:e=>this.options.linkOpenerDelegate(e)},this.updateStyles(),this.ui}reparentUI(t){this.ui&&(this._container=t,e.append(this._container,this.ui.container))}pick(e,t={},i=o.CancellationToken.None){return new Promise(((s,n)=>{let o=e=>{o=s,t.onKeyMods?.(r.keyMods),s(e)};if(i.isCancellationRequested)return void o(void 0);const r=this.createQuickPick({useSeparators:!0});let a;const l=[r,r.onDidAccept((()=>{if(r.canSelectMany)o(r.selectedItems.slice()),r.hide();else{const e=r.activeItems[0];e&&(o(e),r.hide())}})),r.onDidChangeActive((e=>{const i=e[0];i&&t.onDidFocus&&t.onDidFocus(i)})),r.onDidChangeSelection((e=>{if(!r.canSelectMany){const t=e[0];t&&(o(t),r.hide())}})),r.onDidTriggerItemButton((e=>t.onDidTriggerItemButton&&t.onDidTriggerItemButton({...e,removeItem:()=>{const t=r.items.indexOf(e.item);if(-1!==t){const e=r.items.slice(),i=e.splice(t,1),s=r.activeItems.filter((e=>e!==i[0])),n=r.keepScrollPosition;r.keepScrollPosition=!0,r.items=e,s&&(r.activeItems=s),r.keepScrollPosition=n}}}))),r.onDidTriggerSeparatorButton((e=>t.onDidTriggerSeparatorButton?.(e))),r.onDidChangeValue((e=>{!a||e||1===r.activeItems.length&&r.activeItems[0]===a||(r.activeItems=[a])})),i.onCancellationRequested((()=>{r.hide()})),r.onDidHide((()=>{c.dispose(l),o(void 0)}))];r.title=t.title,t.value&&(r.value=t.value),r.canSelectMany=!!t.canPickMany,r.placeholder=t.placeHolder,r.ignoreFocusOut=!!t.ignoreFocusLost,r.matchOnDescription=!!t.matchOnDescription,r.matchOnDetail=!!t.matchOnDetail,r.matchOnLabel=void 0===t.matchOnLabel||t.matchOnLabel,r.quickNavigate=t.quickNavigate,r.hideInput=!!t.hideInput,r.contextKey=t.contextKey,r.busy=!0,Promise.all([e,t.activeItem]).then((([e,t])=>{a=t,r.busy=!1,r.items=e,r.canSelectMany&&(r.selectedItems=e.filter((e=>"separator"!==e.type&&e.picked))),a&&(r.activeItems=[a])})),r.show(),Promise.resolve(e).then(void 0,(e=>{n(e),r.hide()}))}))}createQuickPick(e={useSeparators:!1}){const t=this.getUI(!0);return new h.QuickPick(t)}createInputBox(){const e=this.getUI(!0);return new h.InputBox(e)}show(t){const i=this.getUI(!0);this.onShowEmitter.fire();const s=this.controller;this.controller=t,s?.didHide(),this.setEnabled(!0),i.leftActionBar.clear(),i.title.textContent="",i.description1.textContent="",i.description2.textContent="",e.reset(i.widget),i.rightActionBar.clear(),i.inlineActionBar.clear(),i.checkAll.checked=!1,i.inputBox.placeholder="",i.inputBox.password=!1,i.inputBox.showDecoration(a.default.Ignore),i.visibleCount.setCount(0),i.count.setCount(0),e.reset(i.message),i.progressBar.stop(),i.list.setElements([]),i.list.matchOnDescription=!1,i.list.matchOnDetail=!1,i.list.matchOnLabel=!0,i.list.sortByLabel=!0,i.ignoreFocusOut=!1,i.inputBox.toggles=void 0;const n=this.options.backKeybindingLabel();h.backButton.tooltip=n?l.localize("quickInput.backWithKeybinding","Back ({0})",n):l.localize("quickInput.back","Back"),i.container.style.display="",this.updateLayout(),i.inputBox.setFocus(),this.quickInputTypeContext.set(t.type)}isVisible(){return!!this.ui&&"none"!==this.ui.container.style.display}setVisibilities(e){const t=this.getUI();t.title.style.display=e.title?"":"none",t.description1.style.display=e.description&&(e.inputBox||e.checkAll)?"":"none",t.description2.style.display=!e.description||e.inputBox||e.checkAll?"none":"",t.checkAll.style.display=e.checkAll?"":"none",t.inputContainer.style.display=e.inputBox?"":"none",t.filterContainer.style.display=e.inputBox?"":"none",t.visibleCountContainer.style.display=e.visibleCount?"":"none",t.countContainer.style.display=e.count?"":"none",t.okContainer.style.display=e.ok?"":"none",t.customButtonContainer.style.display=e.customButton?"":"none",t.message.style.display=e.message?"":"none",t.progressBar.getContainer().style.display=e.progressBar?"":"none",t.list.displayed=!!e.list,t.container.classList.toggle("show-checkboxes",!!e.checkBox),t.container.classList.toggle("hidden-input",!e.inputBox&&!e.description),this.updateLayout()}setEnabled(e){if(e!==this.enabled){this.enabled=e;for(const t of this.getUI().leftActionBar.viewItems)t.action.enabled=e;for(const t of this.getUI().rightActionBar.viewItems)t.action.enabled=e;this.getUI().checkAll.disabled=!e,this.getUI().inputBox.enabled=e,this.getUI().ok.enabled=e,this.getUI().list.enabled=e}}hide(t){const i=this.controller;if(!i)return;i.willHide(t);const s=this.ui?.container,n=s&&!e.isAncestorOfActiveElement(s);if(this.controller=null,this.onHideEmitter.fire(),s&&(s.style.display="none"),!n){let e=this.previousFocusElement;for(;e&&!e.offsetParent;)e=e.parentElement??void 0;e?.offsetParent?(e.focus(),this.previousFocusElement=void 0):this.options.returnFocus()}i.didHide(t)}layout(e,t){this.dimension=e,this.titleBarOffset=t,this.updateLayout()}updateLayout(){if(this.ui&&this.isVisible()){this.ui.container.style.top=`${this.titleBarOffset}px`;const e=this.ui.container.style,t=Math.min(.62*this.dimension.width,m.MAX_WIDTH);e.width=t+"px",e.marginLeft="-"+t/2+"px",this.ui.inputBox.layout(),this.ui.list.layout(this.dimension&&.4*this.dimension.height)}}applyStyles(e){this.styles=e,this.updateStyles()}updateStyles(){if(this.ui){const{quickInputTitleBackground:e,quickInputBackground:t,quickInputForeground:i,widgetBorder:s,widgetShadow:n}=this.styles.widget;this.ui.titleBar.style.backgroundColor=e??"",this.ui.container.style.backgroundColor=t??"",this.ui.container.style.color=i??"",this.ui.container.style.border=s?`1px solid ${s}`:"",this.ui.container.style.boxShadow=n?`0 0 8px 2px ${n}`:"",this.ui.list.style(this.styles.list);const o=[];this.styles.pickerGroup.pickerGroupBorder&&o.push(`.quick-input-list .quick-input-list-entry { border-top-color:  ${this.styles.pickerGroup.pickerGroupBorder}; }`),this.styles.pickerGroup.pickerGroupForeground&&o.push(`.quick-input-list .quick-input-list-separator { color:  ${this.styles.pickerGroup.pickerGroupForeground}; }`),this.styles.pickerGroup.pickerGroupForeground&&o.push(".quick-input-list .quick-input-list-separator-as-item { color: var(--vscode-descriptionForeground); }"),(this.styles.keybindingLabel.keybindingLabelBackground||this.styles.keybindingLabel.keybindingLabelBorder||this.styles.keybindingLabel.keybindingLabelBottomBorder||this.styles.keybindingLabel.keybindingLabelShadow||this.styles.keybindingLabel.keybindingLabelForeground)&&(o.push(".quick-input-list .monaco-keybinding > .monaco-keybinding-key {"),this.styles.keybindingLabel.keybindingLabelBackground&&o.push(`background-color: ${this.styles.keybindingLabel.keybindingLabelBackground};`),this.styles.keybindingLabel.keybindingLabelBorder&&o.push(`border-color: ${this.styles.keybindingLabel.keybindingLabelBorder};`),this.styles.keybindingLabel.keybindingLabelBottomBorder&&o.push(`border-bottom-color: ${this.styles.keybindingLabel.keybindingLabelBottomBorder};`),this.styles.keybindingLabel.keybindingLabelShadow&&o.push(`box-shadow: inset 0 -1px 0 ${this.styles.keybindingLabel.keybindingLabelShadow};`),this.styles.keybindingLabel.keybindingLabelForeground&&o.push(`color: ${this.styles.keybindingLabel.keybindingLabelForeground};`),o.push("}"));const r=o.join("\n");r!==this.ui.styleSheet.textContent&&(this.ui.styleSheet.textContent=r)}}},exports.QuickInputController=m=v([f(1,p.ILayoutService),f(2,y.IInstantiationService),f(3,k.IContextKeyService)],exports.QuickInputController);
//# sourceMappingURL=quickInputController.js.map
